package com.ibm.appsure ;
/*-----------------------------------------------------------*/
/*   Source File
/*
/*   Filename:      AppSureException
/*   Creation Date: MAY 7, 2001
/*
/*
/*
/*         @Copyright  2001
/*          All Rights Reserved
/*
/*
/*-----------------------------------------------------------*/
import java.sql.* ;
/**
 * The AppSureException is thrown by the AppSure API methods.
 *
 *
 * @author  David Lentz
 * @version 1
 */

/*----------------------------------------------------
/*
/* AppSureException
/*
/*----------------------------------------------------*/
public class AppSureException extends Throwable {

    /**
      * The full description of the exception
      **/
    private String exceptionDescription = "" ;

    /**
      * Default Constructor
      **/
    public AppSureException ( String exceptionDescription ) {
        this.exceptionDescription = exceptionDescription ;
    }


    /**
      * This constructor transforms an SQL Exception into
      * an AppSure Exception
      **/
    public AppSureException ( SQLException sqlException ) {
        exceptionDescription = "Database Error\nSQL Code:"+sqlException.getErrorCode() ;
        exceptionDescription+="\nSpecific Message:\n"+sqlException.toString() ;
    }

    /**
      * This method returns the human readable error for
      * the exception.
      **/
    public String toString () {
        return( exceptionDescription ) ;
    }


}
