package com.ibm.appsure.app.gui ;
/*-----------------------------------------------------------*/
/*   Source File
/*
/*   Filename:      AppEditDlg
/*   Creation Date: MARCH 26, 2001
/*
/*
/*
/*         @Copyright  2001
/*          All Rights Reserved
/*
/*
/*-----------------------------------------------------------*/
import java.util.* ;
import java.sql.* ;
import javax.swing.* ;
import java.awt.* ;
import java.awt.event.* ;
import com.ibm.appsure.* ;
import com.ibm.appsure.common.* ;
import com.ibm.appsure.app.* ;
import com.ibm.appsure.app.system.* ;
import com.ibm.appsure.app.shared.gui.* ;
import com.ibm.appsure.app.shared.util.* ;
/**
 * This dialog allows the user to edit an application
 *
 *
 * @author  David Lentz
 * @version 1
 */

public class AppEditDlg extends JDialog implements ActionListener {

   /**
     * This is the JLabel for the AppCode
     **/
   private JLabel st_APPCODE     = new JLabel ( "AppCode" ) ;

   /**
     * This is the JLabel for the Name
     **/
   private JLabel st_NAME = new JLabel ( "Name" ) ;

   /**
     * This is the JLabel for the Run Location
     **/
   private JLabel st_RUNLOCATION = new JLabel ( "Run Location" ) ;

   /**
     * This is the Check box for the Multiple Instances
     **/
   private JCheckBox ck_MULTIPLE_INST = new JCheckBox ( "Can run Multiple Instances" ) ;

   /**
     * This is the entry field for the short description
     **/
   private JLabel st_SHORT_DESCRIPT = new JLabel ( "Short Descript." ) ;

   /**
     * This is the entry field for the average run time in minutes
     **/
   private JLabel st_AVERAGE_RUN_MIN = new JLabel ( "Average Run Time(Min)" ) ;

   /**
     * This is an instance of the main window that started us
     **/
   private MainWindow mainWindow = null ;


   /**
     * This is the about JLabel
     **/
   private JLabel st_ABOUT = new JLabel ( "About" ) ;

   /**
     * This is the about MLE
     **/
   private JTextArea mle_ABOUT = new JTextArea ( "" ) ;

   /**
     * This is the scroll pane for the MLE
     **/
   private JScrollPane scr_ABOUT = new JScrollPane ( mle_ABOUT ) ;

   /**
     * This is the Ok Button
     **/
   private DButton pb_OK = new DButton ( "Ok" ) ;

   /**
     * This is the Cancel button
     **/
   private DButton pb_CANCEL = new DButton ( "Cancel" ) ;


   /**
     * This is the JTextField for the AppCode
     **/
   private JTextField ef_APPCODE     = new JTextField ( "" ) ;

   /**
     * This is the JTextField for the Name
     **/
   private JTextField ef_NAME = new JTextField ( "" ) ;

   /**
     * This is the JTextField for the Run Location
     **/
   private JTextField ef_RUNLOCATION = new JTextField ( "" ) ;


   /**
     * This is the entry field for the short description
     **/
   private JTextField ef_SHORT_DESCRIPT = new JTextField ( "" ) ;

   /**
     * This is the entry field for the average run time in minutes
     **/
   private JTextField ef_AVERAGE_RUN_MIN = new JTextField ( "" ) ;

   /**
     * This is the Application object that is being edited
     **/
   private Application application = null ;


   /**
     * Default Constructor
     **/
   public AppEditDlg ( MainWindow parent, Application application ) {
      super ( parent, "Application Edit", false ) ;

      this.mainWindow  = parent ;
      this.application = application ;

      /*---------------------------------------------*/
      /*                                             */
      /*  Add Action Listeners and Adjust properties */
      /*                                             */
      /*---------------------------------------------*/
      mle_ABOUT.setFont ( st_ABOUT.getFont() ) ;
      pb_OK.addActionListener ( this ) ;
      pb_CANCEL.addActionListener ( this ) ;

      /*--------------*/
      /*              */              
      /*  Add the GUI */
      /*              */              
      /*--------------*/
      getContentPane().setLayout ( null ) ;
      getContentPane().add ( st_APPCODE ) ;
      getContentPane().add ( st_NAME ) ;
      getContentPane().add ( st_RUNLOCATION ) ;
      getContentPane().add ( ck_MULTIPLE_INST ) ;
      getContentPane().add ( st_SHORT_DESCRIPT ) ;
      getContentPane().add ( st_AVERAGE_RUN_MIN ) ;
      getContentPane().add ( st_ABOUT ) ;

      getContentPane().add ( ef_APPCODE ) ;
      getContentPane().add ( ef_NAME ) ;
      getContentPane().add ( ef_RUNLOCATION ) ;
      getContentPane().add ( ef_SHORT_DESCRIPT ) ;
      getContentPane().add ( ef_AVERAGE_RUN_MIN ) ;
      getContentPane().add ( scr_ABOUT ) ;
      getContentPane().add ( pb_OK ) ;
      getContentPane().add ( pb_CANCEL ) ;

      setSize ( 350, 350 ) ;
      WinUtil.centerChildInParent ( this, parent ) ;

      if ( application.getRecStatus() != application.REC_INSERT )
         refreshData() ;

      setVisible ( true ) ;
   }


   /**
     * This method will lay out and position all of our components
     **/
   public void doLayout () {
      Dimension size          = getSize() ;
      int       x             = 5 ;
      int       y             = 5 ;
      int       rowHeight     = 18 ;
      int       descriptWidth = 150 ;

      super.doLayout() ;

      st_APPCODE.setBounds ( x, y, descriptWidth, rowHeight ) ;
      ef_APPCODE.setBounds ( x+descriptWidth, y, size.width-descriptWidth-(x*3), rowHeight ) ;
      y+=rowHeight ;

      st_NAME.setBounds ( x, y, descriptWidth, rowHeight ) ;
      ef_NAME.setBounds ( x+descriptWidth, y, size.width-descriptWidth-(x*3), rowHeight ) ;
      y+=rowHeight ;


      st_RUNLOCATION.setBounds ( x, y, descriptWidth, rowHeight ) ;
      ef_RUNLOCATION.setBounds ( x+descriptWidth, y, size.width-descriptWidth-(x*3), rowHeight ) ;
      y+=rowHeight ;

      ck_MULTIPLE_INST.setBounds ( x, y, size.width-(x*3), rowHeight ) ;
      y+=rowHeight ;

      st_SHORT_DESCRIPT.setBounds ( x, y, descriptWidth, rowHeight ) ;
      ef_SHORT_DESCRIPT.setBounds ( x+descriptWidth, y, size.width-descriptWidth-(x*3), rowHeight ) ;
      y+=rowHeight ;

      st_AVERAGE_RUN_MIN.setBounds ( x, y, descriptWidth, rowHeight ) ;
      ef_AVERAGE_RUN_MIN.setBounds ( x+descriptWidth, y, size.width-descriptWidth-(x*3), rowHeight ) ;
      y+=rowHeight ;

      st_ABOUT.setBounds ( x, y, size.width-(x*3), rowHeight ) ;
      y+=rowHeight ;

      scr_ABOUT.setBounds ( x, y, size.width-(x*3), size.height-65-y ) ;
      y+=(rowHeight*6 ) ;


      pb_OK.setBounds     ( 5, size.height-60, 75, 25 ) ;
      pb_CANCEL.setBounds ( 85, size.height-60, 80, 25 ) ;

   }



   /**
     * This method will refresh the data on the screen
     **/
   private void refreshData () {
      ef_APPCODE.setText ( application.getAppCode() ) ;
      ef_NAME.setText ( application.getName() );
      ef_RUNLOCATION.setText ( application.getRunLocation() ) ;
      ck_MULTIPLE_INST.setSelected ( application.getMultipleInst() ) ;
      ef_SHORT_DESCRIPT.setText ( application.getShortDescript() ) ;
      mle_ABOUT.setText ( application.getAbout() ) ;
      ef_AVERAGE_RUN_MIN.setText ( ""+application.getAverageRunMin() ) ;
      ef_APPCODE.setEnabled ( false ) ;
   }


   /**
     * This method will set the data in our application object to the data on the screen
     **/
   private boolean saveData () {
      String  appCode        = ef_APPCODE.getText() ;
      String  name           = ef_NAME.getText() ;
      String  about          = mle_ABOUT.getText() ;
      String  runLocation    = st_RUNLOCATION.getText() ;
      String  shortDescript  = ef_SHORT_DESCRIPT.getText() ;
      boolean multipleInst   = ck_MULTIPLE_INST.isSelected() ;
      int     averageRunTime = 0 ;
      boolean saved          = false ;


      try {
         averageRunTime = new Integer ( ef_AVERAGE_RUN_MIN.getText() ).intValue() ;
      } catch ( Exception e ) {
         GUISystem.printBox ( "Info", "Please enter a valid number for the Average Run Time in Minutes" ) ;
      }

      if ( ( appCode == null ) || ( appCode.length() == 0 ) )
         GUISystem.printBox ( "Info", "Please enter the AppCode" ) ;
      else if ( ( name == null ) || ( name.length() == 0 ) )
         GUISystem.printBox ( "Info", "Please enter the Name" ) ;
      else if ( ( runLocation == null ) || ( runLocation.length() == 0 ) )
         GUISystem.printBox ( "Info", "Please enter the Run Location" ) ;
      else if ( ( about == null ) || ( about.length() == 0 ) )
         GUISystem.printBox ( "Info", "Please enter the About Application information" ) ;
      else if ( ( shortDescript == null ) || ( shortDescript.length() == 0 ) )
         GUISystem.printBox ( "Info", "Please enter the Short Description" ) ;
      else if ( averageRunTime != 0 ) {
         application.setAppCode ( appCode ) ;
         application.setName ( name ) ;
         application.setAbout ( about ) ;
         application.setRunLocation ( runLocation ) ;
         application.setShortDescript ( shortDescript ) ;
         application.setMultipleInst ( multipleInst ) ;
         application.setAverageRunMin ( averageRunTime ) ;
         try {
            saved = ( application.writeToDatabase ( AppSureTool.getConnection() ) == 0 ) ;
            mainWindow.refreshAppList() ;
         } catch ( AppSureException e ) {
            Log.log ( e ) ;
            GUISystem.printBox ( "Info", "The application was not saved" ) ;
            saved = false ;
         }
      }

      return( saved ) ;

   }


   /**
     * This method will be called when a button on our dialog was pressed
     **/
   public void actionPerformed ( ActionEvent e ) {

      if ( e.getSource() == pb_OK ) {
         if ( saveData() )
            dispose() ;
      }

      else if ( e.getSource() == pb_CANCEL )
         dispose() ;
   }
}
