package com.ibm.appsure.app.shared.gui ;       
/*-----------------------------------------------------------*/
/*   AntiAliasPanel                                          */
/*                                                           */
/*   Description:                                            */
/*      Source code for: AntiAliasPanel                      */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import javax.swing.* ;
import java.awt.* ;
/**
 * This panel turns Anti-Aliasing on or off for everything drawn on it, 
 * so this means any Swing control drawn on the panel will be drawn
 * Anti-Aliased. The Anti-Alias can be turned on or off through the
 * setAntiAlias method.
 *
 * @version 1.0, 4/4/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   AntiAliasPanel                                          */
/*                                                           */
/*-----------------------------------------------------------*/
public class AntiAliasPanel extends JPanel {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private boolean antiAlias = true ;





   /*------------------------------------------------------------*/
   /* setAntiAlias
    */
   /**
    *    This method will set anti aliasing on or
    *  off for the entire panel
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setAntiAlias ( boolean antiAlias ) {
      this.antiAlias = antiAlias ;
      revalidate() ;
   }




   /*------------------------------------------------------------*/
   /* paintComponent
    */
   /**
    *    This method will paint our component
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void paintComponent ( Graphics g ) {
      Graphics2D g2 = (Graphics2D) g ;

      if ( antiAlias )
         g2.setRenderingHint ( RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON ) ;
      else
         g2.setRenderingHint ( RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_OFF ) ;

      super.paintComponent ( g2 ) ;
   }

} /* AntiAliasPanel */
