package com.ibm.appsure.app.shared.gui ;
/*-----------------------------------------------------------*/
/*   DMultiLabel                                             */
/*                                                           */
/*   Description:                                            */
/*      Source code for: DMultiLabel                         */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 Cogent                           */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This extension of JTextArea will appear to be a JLabel with multiple lines. 
 *
 *
 * @version 1.0, 6/28/1999 
 */
import javax.swing.* ;
import java.awt.* ;



/*-----------------------------------------------------------*/
/*                                                           */
/*   DMultiLabel                                             */
/*                                                           */
/*-----------------------------------------------------------*/
public class DMultiLabel extends JTextArea {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Statics                                                 */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private static final Font defaultFont = new Font ( "SansSerif", Font.PLAIN, 12 ) ;



   /*------------------------------------------------------------*/
   /* Constructor(0)
    */
   /**
    *    This constructor will create a blank
    *  DMultiLabel
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public DMultiLabel () {    
      super() ;
      initialize() ;
   }





   /*------------------------------------------------------------*/
   /* Constructor(1)
    */
   /**
    *    This constructor will create a DMultiLabel
    *  with the initial text that is passed in
    *  
    *
    *  @param text The text to display
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public DMultiLabel ( String text ) {
      super(text) ;
      initialize() ;
   }






   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will initialize the control to look
    *  like a Multi Line  JLabel
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void initialize () {
      setLineWrap ( true ) ;
      setWrapStyleWord ( true ) ;
      setEditable ( false ) ;
      setOpaque ( false ) ;
      setFont ( defaultFont ) ;
   }



} /* DMultiLabel */
