package com.ibm.appsure.app.shared.gui ;    
/*-----------------------------------------------------------*/
/*   OutputWindow                                            */
/*                                                           */
/*   Description:                                            */
/*      Source code for: OutputWindow                        */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import com.ibm.appsure.app.shared.util.* ;
/**
 * This is a simple JFrame that holds a JTextArea and displays text. 
 *
 *
 * @version 1.0, 8/4/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   OutputWindow                                            */
/*                                                           */
/*-----------------------------------------------------------*/
public class OutputWindow extends JFrame implements ActionListener {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private JTextArea mle_OUTPUT     = null ;
   private JButton   pb_CLOSE       = null ;






   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This is the only constructor
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public OutputWindow () {
      super ( "Output" ) ;
      Container contentPane = getContentPane() ;     


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create our GUI                                          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      mle_OUTPUT = new JTextArea () ;
      pb_CLOSE   = new JButton ( "Close" ) ;    

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add listeners                                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      pb_CLOSE.addActionListener ( this ) ;        


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setSize ( 640, 480 ) ;
      WinUtil.centerWindow ( this ) ;       


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add our controls                                        */
      /*                                                           */
      /*-----------------------------------------------------------*/
      contentPane.setLayout ( new BorderLayout() ) ;
      contentPane.add ( new JScrollPane ( mle_OUTPUT ), BorderLayout.CENTER ) ;
      contentPane.add ( pb_CLOSE,   BorderLayout.SOUTH ) ;

      setVisible ( true ) ;
   }





   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will be called when an action
    *  is sent to us
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {
      dispose() ;
   }




   /*------------------------------------------------------------*/
   /* appendText
    */
   /**
    *    This method will append text to the screen
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void appendText ( String text ) {
      mle_OUTPUT.append ( text ) ;
      mle_OUTPUT.setCaretPosition ( mle_OUTPUT.getText().length()-1 ) ;
   }

} /* OutputWindow */
