package com.ibm.appsure.app.shared.gui ;
/*-----------------------------------------------------------*/
/*   PopButton                                               */
/*                                                           */
/*   Description:                                            */
/*      Source code for: PopButton                           */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 Cogent                           */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.event.* ;
import java.awt.* ;
import javax.swing.* ;
/**
 * This button will pop up when the mouse is over it. The border will disappear once the mouse moves off 
 *
 *
 * @version 1.0, 12/15/1998 
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   PopButton                                               */
/*                                                           */
/*-----------------------------------------------------------*/
public class PopButton extends JButton implements MouseListener {

   /*------------------------------------------------------------*/
   /* Constructors
    */
   /**
    *    All constructors match the constructors in the
    *  JButton
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public PopButton() {
      super() ;
      init() ;
   }
   public PopButton(Icon icon) {
      super(icon) ;
      init() ;
   }


   public PopButton(String text) {
      super(text) ;
      init() ;
   }

   public PopButton(String text, Icon icon) {
      super ( text, icon ) ;
      init() ;
   }

   private void init () {
      setBorderPainted ( false ) ;
      addMouseListener ( this ) ;
   }


   /*------------------------------------------------------------*/
   /* mouseMethods
    */
   /**
    *    These mouse methods are blank for now
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void mouseClicked(MouseEvent e) {}                                       
   public void mousePressed(MouseEvent e) {
      }
   public void mouseReleased(MouseEvent e) {
      }





   /*------------------------------------------------------------*/
   /* mouseEntered
    */
   /**
    *    This method will be called when the mouse
    *  moves over our button, we will draw our
    *  border now
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void mouseEntered(MouseEvent e) {

      setBorderPainted ( true ) ;
      //Graphics  g    = getGraphics() ;
      //Rectangle rect = getVisibleRect() ;

      //getBorder().paintBorder ( this, g, 0, 0, rect.width, rect.height ) ;
   }




   /*------------------------------------------------------------*/
   /* mouseExited
    */
   /**
    *    This method will be called once the user
    *  has moved the mouse off of the button. We
    *  will take out the border
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void mouseExited(MouseEvent e) {
      setBorderPainted ( false ) ;
   }


} /* PopButton */
