package com.ibm.appsure.app.shared.util ;
/*-----------------------------------------------------------*/
/*   ComponentPopFocus                                       */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ComponentPopFocus                   */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 Cogent                           */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This Window Listener is used so that a dialog or pop up window
 * or frame can set there focus reliably across platforms. 
 *
 *
 * @version 1.0, 8/31/1999 
 */
import java.awt.* ;
import java.awt.event.* ;


/*-----------------------------------------------------------*/
/*                                                           */
/*   ComponentPopFocus                                       */
/*                                                           */
/*-----------------------------------------------------------*/
public class ComponentPopFocus extends Object implements WindowListener {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Vars                                                    */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private Component focusComp = null ;





   /*------------------------------------------------------------*/
   /* Constructor(0)
    */
   /**
    *    This constructor creates our WindowListener
    *  object and initializes the object to set the
    *  focus to the component passed.
    *
    *  @param focusComponent The Component to give focus once a window is shown
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public ComponentPopFocus ( Component focusComponent ) {
      setFocusComponent ( focusComponent );
   }




   /*------------------------------------------------------------*/
   /* setFocusComponent
    */
   /**
    *    This metho will set what component will
    *  receive focus once the window we are listening
    *  for has been showin
    *
    *  @param focusComponent The component
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setFocusComponent ( Component focusComponent ) {
      this.focusComp = focusComponent ;
   }





   /*------------------------------------------------------------*/
   /* getFocusComponent
    */
   /**
    *    This method will return the component that
    *  will receive focus once the window we are
    *  listening to is shown
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return component
    *//*---------------------------------------------------------*/
   public Component getFocusComponent () {
      return( focusComp ) ;
   }



   public void windowClosing ( WindowEvent e ) {}
   public void windowClosed ( WindowEvent e ) {}
   public void windowIconified ( WindowEvent e ) {}
   public void windowDeiconified ( WindowEvent e ) {}
   public void windowActivated ( WindowEvent e ) {
      focusComp.requestFocus() ;
   }
   public void windowDeactivated ( WindowEvent e ) {}
   public void windowOpened ( WindowEvent e ) {
      focusComp.requestFocus() ;
   }


} /* ComponentPopFocus */
