package com.ibm.appsure.samples.sample1 ;
/*-----------------------------------------------------------*/
/*   Source File
/*
/*   Filename:      Sample1
/*   Creation Date: MARCH 26, 2001
/*
/*
/*
/*         @Copyright  2001
/*          All Rights Reserved
/*
/*
/*-----------------------------------------------------------*/
import java.util.* ;
import java.sql.* ;
import com.ibm.appsure.* ;
/**
 * A simple sample showing the AppSure API
  *
 *
 * @author  David Lentz
 * @version 1
 */


public class Sample1 {


    /**
      * Standard Main
      **/
    public static void main ( String args[] ) {
        AppSure     appsure = new AppSure () ;
        Connection  conn    = getConnection() ;


        /* First, check to see if we are supposed to run  */
        try {
            if ( appsure.startApp ( conn, "SAMPLE1" ) ) {
                System.out.println ( "Application Started. Waiting for 10 seconds now" ) ;
                Thread.currentThread().sleep ( 10000 ) ;

                System.out.println ( "Last run for SAMPLE1 returned:"+appsure.didAppRun ( "SAMPLE1" ) ) ;
                System.out.println ( "Ok, Ending Application now" ) ;
                appsure.logFailure ( 1, null, "This is a SEVERITY 1!" ) ;
                appsure.shutDown ( null, "This is my log file" ) ;
            } else
                System.out.println ( "AppSure returned FALSE on startApp" ) ;
        } catch ( AppSureException e ) {
            System.out.println ( "AppSure threw Exception" ) ;
            e.printStackTrace() ;
        } catch ( Exception e ) {
            System.out.println ( "Exception was thrown" ) ;
            e.printStackTrace() ;
        }
    }


    private static Connection getConnection () {
        String      driverName = "COM.ibm.db2.jdbc.net.DB2Driver" ;
        Connection  conn       = null ;

        try {

            Class.forName ( driverName ).newInstance() ;

            conn = DriverManager.getConnection( "jdbc:db2://defiant:5703/quest", "dlentz", "m0seley" );


        } catch ( Exception e ) {
            System.out.println ( "Could not create a connection to the database." ) ;
            e.printStackTrace() ;
        }
        return( conn ) ;

    }
}
