/*
 *                
 * @(#)Constants.java	1.0 06/24/01
 *                                        
 * @Copyright  2001 IBM          
 *                                      
 */

package com.ibm.nzna.projects.batch;

/**
 * This file holds the constants used by the batch package
 * 
 * @version 1.0, 04/24/2001 
 * @author  Steve Wang
 */

public final class Constants extends Object {   
    /**
     * debug flag
     */
    public final static boolean debug = BatchInit.getDebug();

    /**
     * Infotips mask.  
     */
    public static final int INFOTIPS_MASK = 0x01; 

    /**
     * Business Partner mask.  
     */
    public static final int IPARTNER_MASK = 0x02; 

    /**
     * Esupport mask.  
     */
    public static final int ESUPPORT_MASK = 0x04; 

    /**
     * Profile DB mask.  
     */
    public static final int PROFILE_DB_MASK = 0x08; 

    /**
     * All db mask (INFOTIPS_MASK|IPARTNER_MASK|ESUPPORT_MASK|PROFILE_DB_MASK)
     */
    public static final int ALL_DB_MASK = 0x0f; ;

    /**
     * site classification 
     */
    public static final int IBM_CONFIDENTIAL = 1;

    /**
     * site classification 
     */
    public static final int IBM_DEALER_CONFIDENTIAL = 2;

    /**
     * site classification 
     */
    public static final int UNCLASSIFIED = 3;

    /**
     * Docgen prefix 
     */
    public static final String DOCGEN_PREFIX = "TS_DOCGEN_";

    /**
     * Imageloc prefix 
     */
    public static final String IMAGELOC_PREFIX = "IMAGELOC_";

    /**
     * Web site name
     */
    //public static final String WEB_SITE_TECHTIPS = "TECHTIPS";

    /**
     * Web site name
     */
    //public static final String WEB_SITE_BPARTNER = "BPARTNER";
    
    /**
     * Web site name
     */
    public static final String WEB_SITE_ESUPPORT = "ESUPPORT";
    
    /**
     * Web site name
     */
    public static final String WEB_SITE_ESUPPORT_PROFILE = "ESUPPORT_PROFILE";
    
    /**
     * Web site name
     */
    public static final String WEB_SITE_INFOTIPS = "INFOTIPS";
    
    /**
     * Web site name
     */
    public static final String WEB_SITE_IPARTNER = "IPARTNER";
    
    /**
     * Web site type  - the siteind of the related tables 
     */
    public static final int TECHTIPS_TYPE = 1;

    /**
     * Web site type
     */
    public static final int BPARTNER_TYPE = 2;  
    
    /**
     * Web site type
     */
    public static final int ESUPPORT_TYPE = 3;
    
    /**
     * Web site type
     */
    public static final int INFOTIPS_TYPE = 4;
    
    /**
     * Web site type
     */
    public static final int IPARTNER_TYPE = 5;

    /**
     * Web site type
     */
    public static final int ESUPPORT_PROFILE_TYPE = 9; 
    
    /**
     * Web site type
     */
    public static final int ALL_SITE_TYPE = 10; 
    
    /**
     * The keys to lookup the applicaiton name
     */
    public final static String NavgenNameKey = "NavGen";
    
    /**
     * The keys to lookup the applicaiton name
     */
    public final static String DocgenNameKey = "DocGen";

    /**
     * The keys to lookup the applicaiton name
     */
    public final static String DocgenPubNowNameKey = "DocGenPubNow";

    /**
     * The keys to lookup the applicaiton name
     */
    public final static String GDBM_FILE_NAME = "db";
    
    /**
     * Some constants for log info 
     */
    public final static int DEBUG = 2001; 
    
    /**
     * Some constants for log info. Ensures Informational>debug 
     */
    public final static int INFORMATIONAL = DEBUG + 1; 
    
    
    /**
     * Some constants for log info 
     */
    public final static int WARNING     = DEBUG + 2; 
    
    /**
     * Some constants for log info 
     */
    public final static int ERROR       = DEBUG + 3; 

    /**
     * Some constants for log info 
     */
    public final static int FATAL       = DEBUG + 4; 

    /**
     * The full update timestamp - as early as we can reach
     */
    public final static String FULL_UPDATE_TIMESTAMP = "1980-01-01-00.00.00.000000";

    /**
     * file list name
     */
    public final static String HTML_FTP_LIST = ".ftp.list";

    /**
     * file list name
     */
    public final static String HTML_DELETE_LIST = ".delete.list";

    /**
     * file list name
     */
    public final static String XML_FTP_LIST = ".ftp.xmllist"; 

    /**
     * file list name
     */
    public final static String XML_DELETE_LIST = ".delete.xmllist";

    /**
     * Appsure failure types
     */
    public final static int DEF_NON_SEVER       = 0;
    public final static int SEV1                = 1;
    public final static int SEV2                = 2; 
    public final static int BATCH_EXCEPTION     = 3; 
    public final static int WRITE_GDBM          = 4; 
    public final static int LOAD_PLUGIN         = 5;
    public final static int OUTPUT_DOC          = 6;
    public final static int XMLTEMP_NOTFOUND    = 7;
    public final static int UNABLE_READ_PROP    = 8;
    public final static int UNABLE_CONNECT_QUEST= 9;
    public final static int UNABLE_START_BATCH  = 10; 
    public final static int MK_INPUT_NOTFOUND   = 11;
    public final static int CANNOT_READ_MK_INPUT= 12;
    public final static int UNABLE_PARSE_MK_INPUT=13;
    public final static int UNABLE_WRITE_QUEST  = 14; 
    public final static int UNABLE_UPDATE_TIMESTAMP=15;
    public final static int UNABLE_STOP_BATCH   = 16; 
    public final static int UNABLE_RETRIEVE_OPICM= 17;
    public final static int UNABLE_SEND_MAIL    = 18; 
}
