/*
 *                
 * @(#)DateComparator.java	1.0 04/24/01
 *                                        
 * @Copyright  2001 IBM          
 *                                      
 */

package com.ibm.nzna.projects.batch;

import java.util.*; 

/**
 * This class defines the comparation of two DocRec objects 
 * 
 * @version 1.0, 04/24/2001 
 * @author  Steve Wang
 */

public class DateComparator implements Comparator  {
    /**
     * This implements the compare of two DocRec objects. Calls compare2
     *
     * @param r1 The first object
     * @param r2 The second object
     * @return int Returns -1 if r1 less (in the front of) r2, returns 0 if
     *             r1 equals r2 and 1 if r1 bigger than r2
     */
    public int compare(Object r1, Object r2) {
        return compare2((DocRec)r1, (DocRec)r2); 
    }

    /**
     * This implements the compare of two DocRec objects
     *
     * @param r1 The first object
     * @param r2 The second object
     * @return int Returns -1 if r1 less (in the front of) r2, returns 0 if
     *             r1 equals r2 and 1 if r1 bigger than r2
     */
    public int compare2(DocRec r1, DocRec r2) {
        int n = r1.docId.compareTo(r2.docId);
        if (n==0) {
            return 0; 
        }
        if (r1.releaseDate.compareTo(r2.releaseDate)<0) {
            // Both are following none 0 ordering.
            // r1 is less than r2. r2 in the front of list
            return 1;   
        } else if (r1.releaseDate.compareTo(r2.releaseDate)==0) {
            // release date is the same, order according to the name
            if (n<0) {
                return -1; 
            } else {
                return 1; 
            }
        } else {
            return -1; 
        } 
    }
                                                            
    public boolean equals(Object obj) {
        return super.equals(obj); 
    }
}

