/*
 *                
 * @(#)RecComparator.java	1.0 04/24/01
 *                                        
 * @Copyright  2001 IBM          
 *                                      
 */

package com.ibm.nzna.projects.batch;

import java.util.*; 

/**
 * This class defines the comparation of two CategoryRec comparation
 * 
 * @version 1.0, 04/24/2001 
 * @author  Steve Wang
 */

public class RecComparator implements Comparator  {
    /**
     * This implements the compare of two CategoryRec objects. Calls compare2
     *
     * @param r1 The first object
     * @param r2 The second object
     * @return int Returns -1 if r1 less (in the front of) r2, returns 0 if
     *             r1 equals r2 and 1 if r1 bigger than r2
     */
    public int compare(Object r1, Object r2) {
        return compare2((CategoryRec)r1, (CategoryRec)r2); 
    }

    /**
     * This implements the compare of two CategoryRec objects
     *
     * @param r1 The first object
     * @param r2 The second object
     * @return int Returns -1 if r1 less (in the front of) r2, returns 0 if
     *             r1 equals r2 and 1 if r1 bigger than r2
     */
    public int compare2(CategoryRec r1, CategoryRec r2) {
        if (r1.getOrderNum() < r2.getOrderNum() && r1.getOrderNum() != 0) {
            // Both are following none 0 ordering.
            // r1 is less than r2. r1 in the front of list
            return -1;   
        } else if (r1.getOrderNum() < r2.getOrderNum() && r1.getOrderNum()==0) {
            //r1 is actually bigger than r2, r2 in front
            return 1; 
        } else if (r1.getOrderNum() == r2.getOrderNum()) {
            // Just do normal alphabetic comparing for either 
            // 0 or none 0 ordernum 
            int rc = r1.getDescript().compareTo(r2.getDescript());
            if (rc<0) {
                return -1; 
            } else if (rc==0) {
                return 0; 
            } else {
                return 1; 
            }
        } else if (r1.getOrderNum() > r2.getOrderNum() && r2.getOrderNum()!=0) {
            // r1 bigger than r2, r2 in the front of list
            return 1;
        } else if (r1.getOrderNum() > r2.getOrderNum() && r2.getOrderNum()== 0) {
            // r1 is actually less than r2, r1 is in front list
            return -1;
        } else {
            return 0; 
        }
    }
                                                            
    public boolean equals(Object obj) {
        return super.equals(obj); 
    }
}

