/*
 *                
 * @(#)BatchEvent.java	1.0 04/24/01
 *                                        
 * @Copyright  2001 IBM          
 *                                      
 */

package com.ibm.nzna.projects.batch.event;

/**
 * This class defines a batch event supper class that other batch event classes 
 * should extend  
 * 
 * @version 1.0, 04/24/2001 
 * @author  Steve Wang
 */

public class BatchEvent extends java.util.EventObject  {
    /**
     * event id 
     */
    public final static int NEW_DOCS_EVENT_ID       = 1001;

    /**
     * event id 
     */
    public final static int NEW_DOCS_EVENT_END_ID   = 1002;

    /**
     * event id 
     */
    public final static int PRODUCT_EVENT_ID        = 1003;
    
    /**
     * event id 
     */
    public final static int PRODUCT_EVENT_END_ID    = 1004;
    
    /**
     * The brandFamilyEvent id  
     */
    public static final int BRAND_FAMILY_ID         = 1007; 

    /**
     * The docCategoryEvent id  
     */
    public static final int DOC_CATEGORY_ID         = 1008; 

    /**
     * Finish query process id
     */
    public static final int FINISH_PROCESS_ID       = 1009; 

    /**
     * Market catalog event id
     */
    public static final int MK_EVENT_ID             = 1010; 


    /**
     * The brandFamilySetByModelEvent id
     */
    public static final int BRAND_FAMILY_SET_BY_TYPE = 101; 

    /**
     * The fileNameKeySetEvent id
     */
    public static final int FILE_NAME_KEY_SET = 102; 

    /**
     * The docIdKeySetEvent id
     */
    public static final int DOC_ID_KEY_SET = 103; 

    /**
     * The docIdNoDashKeySetEvent id
     */
    public static final int DOC_ID_NO_DASH_KEY_SET = 104; 

    /**
     * The brandFamilyTypeModelKeySet id
     */
    public static final int BRAND_FAMILY_TYPE_MODEL_KEY_SET = 105; 

    /**
     * The brandFamilyTypeKeySet id
     */
    public static final int BRAND_FAMILY_TYPE_KEY_SET = 106; 

    /**
     * The brandFamilyKeySet id
     */
    public static final int BRAND_FAMILY_KEY_SET = 107; 

    /**
     * The brandKeySet id
     */
    public static final int BRAND_KEY_SET = 108; 

    /**
     * The batch event id
     */
    protected int id;

    /**
     * Constructs a Batch object with the specified source object and type.
     * @param source the object where the event originated
     * @id the event type
     */
    public BatchEvent(Object source, int id) {
        super(source);
	this.id = id;
    }
    
    /**
     * Returns the event type.
     */
    public int getID() {
        return id;
    }
}

