/*
 *                
 * @(#)BrandFamilyEvent.java	1.0 04/24/01
 *                                        
 * @Copyright  2001 IBM          
 *                                      
 */

package com.ibm.nzna.projects.batch.event;

import com.ibm.nzna.projects.batch.*; 

/**
 * This defines the brandFamilyEvent. This even is fired by Navgen when 
 * a new brand-family is obtained through the machine-type-model
 * query (i.e., 9548-30U).  
 *  
 * @version 1.0, 04/24/2001 
 * @author  Steve Wang
 */

public class BrandFamilyEvent extends BatchEvent  {
    /**
     * BrandFamily 
     */
    private BrandFamily brandFamilies; 

    /**
     * Constructs a Batch object with the specified source object and type.
     *
     * @param source the object where the event originated
     * @id the event type
     * @param b brands vec
     * @param f a vector of family vec 
     */
    public BrandFamilyEvent(Object source, int id, BrandFamily bf) {
        super(source, id);
        brandFamilies = bf; 
    }
    
    /**
     * Get brandFamily
     *
     * @param none
     * @return BrandFamily The brandfamily 
     */
    public BrandFamily getBrandFamilies() {
        return brandFamilies; 
    }
}

