/*
 *                
 * @(#)FtpDbFileEvent.java	1.0 04/24/01
 *                                        
 * @Copyright  2001 IBM          
 *                                      
 */

package com.ibm.nzna.projects.batch.event;

/**
 * This defines the FtpDbFileEvent. This even is fired by Navgen when 
 * a new brand-family is obtained through the machine-type-model
 * query (i.e., 9548-30U).  
 *  
 * @version 1.0, 04/24/2001 
 * @author  Steve Wang
 */

public class FtpDbFileEvent extends BatchEvent  {
    /**
     * Destination server; 
     */
    private String dest_server;

    /**
     * Destination directory; 
     */
    private String dest_dir;

    /**
     * Constructs a Batch object with the specified source object and type.
     *
     * @param source the object where the event originated
     * @id the event type
     * @param s server
     * @param d directory
     */
    public FtpDbFileEvent(Object source, int id, String s, String d) {
        super(source, id);
        dest_server = d;
        dest_dir = d; 
    }
}
