/*
 *                
 * @(#)ProdEvent.java	1.0 04/24/01
 *                                        
 * @Copyright  2001 IBM          
 *                                      
 */

package com.ibm.nzna.projects.batch.event;

import java.util.*; 

/**
 * A light-weight class defines the ProdDocsEvent. This even is fired by Navgen in 
 * the execProdDocsQuery.
 *  
 * @version 1.0, 04/24/2001 
 * @author  Steve Wang
 */

public class ProdEvent extends BatchEvent  {
    /**
     * Product ind
     */
    private int productInd = 0; 

    /**
     * Productnum
     */
    private String productNum = "";

    /**
     * Product description
     */
    private String productDescript = ""; 

    /**
     * brand ind
     */
    public int brandInd = 0; 
    
    /**
     * family ind
     */
    public int familyInd = 0;
    
    /**
     * machine ind
     */
    public int machineInd = 0;
    
    /**
     * model ind
     */
    public int modelInd = 0;
    
    public String brand = "";

    public String family = "";

    public String machine = "";

    public String model = "";   

    public int brandOrder = 0;

    public int familyOrder = 0; 

    public int machineOrder = 0;

    public int modelOrder = 0;

    // Product date info. The vector stores PDate object
    // which has a String: actual announce data and date type ind
    public Vector datesvec =  null; 

    /**
     * Constructs a Batch object with the specified source object and type.
     *
     * @param source the object where the event originated
     * @param id the event type
     * @param pInd The product ind
     * @param pNum The product number
     * @param pDesc The product description
     */
    public ProdEvent(Object source, 
                         int id, 
                         int pInd,
                         String pNum,
                         String pDesc
                         ) {
        super(source, id);
        productInd          = pInd;
        productNum          = pNum;
        productDescript     = pDesc;
    }
    
    /**
     * Get Product ind
     */
    public int getProductInd () {
        return productInd; 
    }

    /**
     * Get Productnum
     */
    public String getProductNum () {
        return productNum; 
    }

    /**
     * Get Product description
     */
    public String getProductDescript () {
        return productDescript; 
    }
}

