
/*
 *                
 * @(#)DocgenIntf.java	1.0 04/24/01
 *                                        
 * @Copyright  2001 IBM          
 *                                      
 */

package com.ibm.nzna.projects.batch.intf;

import java.sql.*; 
import java.io.*;
import com.ibm.nzna.projects.batch.event.*; 
import com.ibm.nzna.projects.batch.exception.*; 
import com.ibm.nzna.projects.batch.*; 

/**
 * The Docgen interface which should be implemented by all
 * docgen listeners 
 * 
 * @version 1.0, 04/24/2001 
 * @author  Steve Wang
 */

public interface DocgenIntf {
    /**
     * Init function
     */
    public void init (WebSite site, Connection conn); 
    
    /**
     * Interface function to force the implementer to overwrite. 
     * NewdocsEvent handler.  
     */
    public void processDocs (DocsEvent e) throws BatchException, IOException, SQLException; 

    /**
     * Finished processing docs
     */
    public void finishDocs () throws BatchException, IOException, SQLException; 

    /**
     * Ftp new doc event handling
     */
    public void ftpNewDocs () throws BatchException, IOException;  
}

