
/*
 *                
 * @(#)BFMModelKey.java	1.0 04/24/01
 *                                        
 * @Copyright  2001 IBM          
 *                                      
 */

package com.ibm.nzna.projects.batch.plugin;

/**
 * A light-weight class defines the brand-family-machine-model key 
     
 * @version 1.0, 07/31/2001 
 * @author  Steve Wang
 */
public class BFMModelKey extends BFMachineKey {
    /**
     * model
     */
    public String model = "NULL"; 

    /**
     * constructor
     */
    public BFMModelKey(int brand_ind, int family_ind, String m, String mdl) {
        super(brand_ind, family_ind, m); 
        model     = mdl; 
    }   

    /**
     * To string method
     */
    public String toString() {
        //return super.toString()+"-" + model; 
        return brandInd+"-"+familyInd+"-"+machine+"-" + model; 
    }
    /**
     * Implement compareTo interface.  We have the following ordering: 
     *   BrandKey < BrandFmailyKey <  BFMachineKey < BFMModelKey
     * and within each key, compare the indicators
     */
    public int compareTo(Object obj) {
        if (obj instanceof BFMModelKey) {   
           int bdiff = brandInd-((BFMachineKey)obj).brandInd; 
           if (bdiff!=0) {
               return bdiff;
           } else {
               int fdiff = familyInd-((BFMachineKey)obj).familyInd;
               if (fdiff!=0) {
                   return fdiff; 
               } else {
                   int mdiff = machine.compareTo(((BFMModelKey)obj).machine); 
                   if (mdiff!=0) {
                       return mdiff;
                   } else {
                       return model.compareTo(((BFMModelKey)obj).model);
                   }
               }
           }
        } else {
            return 1; 
        }        
    }
}
