
/*
 *                
 * @(#)BFMachineKey.java	1.0 04/24/01
 *                                        
 * @Copyright  2001 IBM          
 *                                      
 */

package com.ibm.nzna.projects.batch.plugin;

/**
 * A light-weight class defines the brand-family-machine key 
     
 * @version 1.0, 07/31/2001 
 * @author  Steve Wang
 */
public class BFMachineKey extends BrandFamilyKey {
    /**
     * machine
     */
    public String machine = "NULL"; 

    /**
     * constructor
     */
    public BFMachineKey(int brand_ind, int family_ind, String m) {
        super(brand_ind, family_ind); 
        machine   = m; 
    }

    /**
     * To string method
     */
    public String toString() {
        //return super.toString()+"-" + machine; 
        return brandInd+"-"+familyInd+"-" + machine; 
    }

    /**
     * Implement compareTo interface.  We have the following ordering: 
     *   BrandKey < BrandFmailyKey <  BFMachineKey < BFMModelKey
     * and within each key, compare the indicators
     */
    public int compareTo(Object obj) {
        if (obj instanceof BFMModelKey) {
            return -1; 
        } else if (obj instanceof BFMachineKey) {
            int bdiff = brandInd-((BFMachineKey)obj).brandInd; 
            if (bdiff!=0) {
                return bdiff;
            } else {
                int fdiff = familyInd-((BFMachineKey)obj).familyInd;
                return (fdiff!=0? fdiff :
                                  machine.compareTo(((BFMachineKey)obj).machine));
            }
        } else {
            return 1;
        }
    }
}
