
/*
 *                
 * @(#)BrandFamilyKey.java	1.0 04/24/01
 *                                        
 * @Copyright  2001 IBM          
 *                                      
 */

package com.ibm.nzna.projects.batch.plugin;

/**
 * A light-weight class defines the brand-family key 
     
 * @version 1.0, 07/31/2001 
 * @author  Steve Wang
 */
public class BrandFamilyKey extends BrandKey {
    /**
     * family ind
     */
    public int familyInd = -1; 

    /**
     * constructor
     */
    public BrandFamilyKey(int brand_ind, int family_ind) {
        super(brand_ind); 
        familyInd = family_ind; 
    }

    /**
     * To string method
     */
    public String toString() {
        return brandInd+"-" + familyInd; 
    }

    /**
     * Implement compareTo interface.  We have the following ordering: 
     *   BrandKey < BrandFmailyKey <  BFMachineKey < BFMModelKey
     * and within each key, compare the indicators
     */
    public int compareTo(Object obj) {
        if (obj instanceof BFMModelKey || 
            obj instanceof BFMachineKey) {
            return -1; 
        } else if (obj instanceof BrandFamilyKey) {
            int bdiff = brandInd-((BrandFamilyKey)obj).brandInd; 
            return (bdiff!=0? bdiff :
                              familyInd-((BrandFamilyKey)obj).familyInd);
        } else {
            return 1; 
        }
    }
}
