
/*
 *                
 * @(#)BrandKey.java	1.0 04/24/01
 *                                        
 * @Copyright  2001 IBM          
 *                                      
 */

package com.ibm.nzna.projects.batch.plugin;

/**
 * A light-weight class defines the brand key 
     
 * @version 1.0, 07/31/2001 
 * @author  Steve Wang
 */
public class BrandKey extends Object implements java.lang.Comparable {
    /**
     * brand ind 
     */
    public int brandInd = -1;

    /**
     * constructor
     */
    public BrandKey(int brand_ind) {
        brandInd = brand_ind; 
    }

    /**
     * To string method
     */
    public String toString() {
        return brandInd+""; 
    }

    /**
     * Implement compareTo interface.  We have the following ordering: 
     *   BrandKey < BrandFmailyKey <  BFMachineKey < BFMModelKey
     * and within each key, compare the indicators
     */
    public int compareTo(Object obj) {
        if (obj instanceof BFMModelKey || 
            obj instanceof BFMachineKey ||
            obj instanceof BrandFamilyKey ) {
            return -1; 
        } else {
            return brandInd - ((BrandKey)obj).brandInd;
        } 
    }  
}
