
/*
 *                
 * @(#)DocTypeCatKey.java	1.0 04/24/01
 *                                        
 * @Copyright  2001 IBM          
 *                                      
 */

package com.ibm.nzna.projects.batch.plugin;

/**
 * This light-weight class defines the type-cat key for hashtable hDocId.  
     
 * @version 1.0, 07/31/2001 
 * @author  Steve Wang
 */
public class DocTypeCatKey extends Object {
    /**
     * doc type
     */
    public int doctype = 0;

    /** 
     * doc cat
     */
    public int doccat = 0; 
    
    /**
     * constructor
     */
    public DocTypeCatKey(int type, int cat) {
        doctype = type;
        doccat  = cat; 
    }

    /**
     * to String method
     */
    public String toString() {
        return doctype+"-"+doccat; 
    }

    /* 
     * Equals method overriding
     */
    public boolean equals(Object obj) {
        if (obj instanceof DocTypeCatKey) {
            DocTypeCatKey dtcKey = (DocTypeCatKey)obj; 
            if (dtcKey.doctype==this.doctype && dtcKey.doccat==this.doccat) {
                return true; 
            }
        }
        return false; 
    }
    
    /*
     * Hashcode
     */
    public int hashCode() {
        return doctype+doccat; 
    }
}
