package com.ibm.nzna.projects.common.clio ;
/*-----------------------------------------------------------*/
/*   Counter                                                 */
/*                                                           */
/*   Description:                                            */
/*      Source code for: Counter                             */
/*                                                           */
/*                                                           */
/*         @Copyright  1997 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.shared.db.* ;
import com.ibm.nzna.shared.util.* ;
import java.sql.* ;
/**
 * This class holds static methods to manipulate TIGRIS.COUNTERS.
 * All methods in this class assume that a DatabaseSystem object
 * has already been created.
 *
 *
 * @version 1.0, 4/9/1998 
 * @author  David Lentz
 */


/*-----------------------------------------------------------*/
/*                                                           */
/*   Counter                                                 */
/*                                                           */
/*-----------------------------------------------------------*/
public class Counter extends Object {
   /*------------------------------------------------------------*/
   /* getCounter
    */
   /**
    *    This method will read a counter from the
    *  TIGRIS.COUNTER table. It will then update
    *  that counter.
    *
    *  @param log The LogSystem to use for error trapping
    *  @param counter The string name of the counter to return
    *  @param None
    *
    *  @return int
    *//*---------------------------------------------------------*/
   public static int getCounter ( LogSystem log, String counter ) {
      String    rtnName = "getCounter ( "+counter+" )" ;
      SQLMethod sql     = new SQLMethod ( DatabaseSystem.CLIO, rtnName, 5 ) ;
      int       rc      = 0 ;

      try {
         Statement stmt = sql.createStatement ( ) ;
         ResultSet rs   = stmt.executeQuery ( "SELECT VALUE FROM CLIO.COUNTER WHERE counter = '"+counter+"'" ) ;

         if ( rs.next() ) {
            rc = rs.getInt(1) ;
            rc++ ;
            stmt.executeUpdate ( "UPDATE CLIO.COUNTER SET VALUE = "+rc+" WHERE COUNTER = '"+counter+"'" ) ;
         }

         rs.close() ;
      } catch ( Exception e ) {
         sql.rollBack() ;
         if ( log != null )
            log.log ( 1, e ) ;
         else
            e.printStackTrace() ;
      }

      sql.close() ;

      return ( rc ) ;
   }

} /* Counter */
