package com.ibm.nzna.projects.common.legacy ;   
   /*********************************************************
   * This class provides some legacy support of features which
   * were in the 'c' based application pagegen.
   * 
   *
   * Legal: Copyright (c) 2000 IBM. All Rights Reserved.
   * Created: 6/9/100  3:30am
   * @author 
   * @version
   *********************************************************/
public class Pagegen {
   private static final String encodePlainMapping   = "qwer-0ty5uiopQ4WER+6TYU3IOPas8df7gh%jkl2ASDFGH1JKLzxcv9bnmZXCVBNM=;";
   private static final String encodeObscureMapping = "zx&c9vbnm7KLJH3+GFDS5%A1lkjhg6fdsaMZNX4BC-Vtyru8eiwoqpQPO2WIEU.0RYT"; 
   private static final int    lengthOfMapping      = encodePlainMapping.length() ;
   /*********************************************************
   * Descrambles an encoded string which was encoded with the
   * pagegen encoder.  This is not a URL decoder.
   * 
   *
   * Author:  
   * Created: 6/9/100  3:31am
   * @param
   * @return
   *********************************************************/
   public static final String decode ( String string ) {
      /* Create the output buffer */
      StringBuffer output = new StringBuffer() ;

      /* remove beginning %% */
      string = string.substring( 2, string.length()) ;

      /* Get the character array of the string */
      char charArray[] = string.toCharArray() ;
      int  shift       = 0 ;
      int  offsetIndex = 0 ;
      for ( int x = 0 ; x < charArray.length; x++) {
         int index = encodeObscureMapping.indexOf( charArray[ x ] ) ;
         if ( index > 0) {
            offsetIndex = ( index + lengthOfMapping - shift ) % lengthOfMapping ;
            shift = ( shift + offsetIndex  * x ) % lengthOfMapping ;
            output.append( encodePlainMapping.charAt( offsetIndex ) ) ;
         }
      }
      /* The encoded string has '=;' appended to the end */
      /* We must remove this here.                       */
      output.setLength( output.length() - 2 ) ;

      return ( output.toString() ) ;
   }
   /*********************************************************
   * Encodes a string to make it unreadable using an array
   * mapping algorithm.  This is not a URL encoder.
   * 
   *
   * Author:  
   * Created: 6/9/100  3:32am
   * @param
   * @return
   *********************************************************/
   public static final String encode ( String string ) {
      /* Create the output buffer */
      StringBuffer output = new StringBuffer("%%") ;

      /* append token to string to encode */
      string = string + "=;" ;

      /* Get the character array of the string */
      char charArray[] = string.toCharArray() ;
      int  shift       = 0 ;
      int  offsetIndex = 0 ;
      for ( int x = 0 ; x < charArray.length; x++) {
         int index = encodePlainMapping.indexOf( charArray[ x ] ) ;
         if ( index > 0) {
            offsetIndex = ( index + shift ) % lengthOfMapping ;
            shift = ( shift + index * x ) % lengthOfMapping ;
            output.append( encodeObscureMapping.charAt( offsetIndex ) ) ;
         }
      }
      return ( output.toString() ) ;
   }
}

