package com.ibm.nzna.projects.common.quest ;    
/*-----------------------------------------------------------*/
/*   ConstantsRec                                            */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ConstantsRec                        */
/*                                                           */
/*                                                           */
/*         @Copyright  1997 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.shared.gui.MultiListRow ;
/**
 * This class is a record object which holds information about a specific constant in TIGRIS.CONSTANTS 
 *
 *
 * @version 1.0, 3/24/1998 
 * @author  David Lentz
 */


/*-----------------------------------------------------------*/
/*                                                           */
/*   ConstantsRec                                            */
/*                                                           */
/*-----------------------------------------------------------*/
public class ConstantsRec extends Object implements java.io.Serializable, MultiListRow {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Vars                                                    */
   /*                                                           */
   /*-----------------------------------------------------------*/
   public String constant    = "" ;
   public String strConst    = "" ;
   public int    intConst    = 0 ;
   public String application = "" ;

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Constructor                                             */
   /*                                                           */
   /*-----------------------------------------------------------*/
   public ConstantsRec () {
   }
   public ConstantsRec ( String constant, int intConst, String strConst, String application ) {
      this.constant    = constant ;
      this.intConst    = intConst ;
      this.strConst    = strConst ;
      this.application = application ;
   }

   public Object getColumnData ( int column ) {
      String retObj = null ;

      switch ( column ) {
         case 0 :
            retObj = constant ;
            break ;
         case 1 :
            retObj = ""+intConst ;
            break ;
         case 2 :
            retObj = strConst ;
            break ;
         case 3 :
            retObj = application ;
            break ;
      }

      return( retObj ) ;

   }




   /*------------------------------------------------------------*/
   /* getConstant
    */
   /**
    *    This method will return the constant name
    *  of this constant
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public String getConstant () {
      return( constant ) ;
   }




   /*------------------------------------------------------------*/
   /* getApplication
    */
   /**
    *    This method will return the application for
    *  this constant
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public String getApplication () {
      return( application ) ;
   }




   /*------------------------------------------------------------*/
   /* getIntValue
    */
   /**
    *    This method will return the int value of the
    *  constant
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return int
    *//*---------------------------------------------------------*/
   public int getIntValue () {
      return( intConst ) ;
   }




   /*------------------------------------------------------------*/
   /* getStringValue
    */
   /**
    *    This method will return the string value
    *  of the constant
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getStringValue () {
      return( strConst ) ;
   }





   /*------------------------------------------------------------*/
   /* setIntValue
    */
   /**
    *    This method will set the int value
    *  
    *  
    *
    *  @param value The Value to use as the 'int' value
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setIntValue ( int value ) {
      this.intConst = value ;
   }





   /*------------------------------------------------------------*/
   /* setStringValue
    */
   /**
    *    This method will set the string value for
    *  the constant
    *  
    *
    *  @param string The String value
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setStringValue ( String string ) {
      this.strConst = string ;
   }





   /*------------------------------------------------------------*/
   /* setApplication
    */
   /**
    *    This method will set the application
    *  that the Constant uses
    *  
    *
    *  @param application The application to set
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setApplication ( String application ) {
      this.application = application ;
   }
} /* ConstantsRec */
