package com.ibm.nzna.projects.common.quest ;   
/*-----------------------------------------------------------*/
/*   QuestRecord                                             */
/*                                                           */
/*   Description:                                            */
/*      Source code for: QuestRecord                         */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.shared.pom.* ;
/**
 * The QuestRecord should be the superclass of all java objects 
 * that are saved to the Quest database. This record includes the
 * DBUSER and CHANGEDTIME fields.
 *
 * @version 1.0, 10/23/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   QuestRecord                                             */
/*                                                           */
/*-----------------------------------------------------------*/
public class QuestRecord extends PersistentRec {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/

   /**
     *  The user who last touched this record
     **/
   private String dbUser = null ;

   /**
     *  The time that this record was last changed
     **/
   private String changedTime = null ;





   /*------------------------------------------------------------*/
   /* setDBUser
    */
   /**
    *    This method will set the person who last
    *  touched this record. This method updates the REC_STATUS to
    *  Update.
    *  
    *
    *  @param dbUser The 8 character User Id of the person
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setDBUser ( String dbUser ) {
      this.dbUser = dbUser ;
      updateRecStatus ( REC_UPDATE ) ;
   }




   /*------------------------------------------------------------*/
   /* setChangedtime
    */
   /**
    *    This method will set the last time that this
    *  record was changed/. This method updates the REC_STATUS to
    *  Update.
    *  
    *
    *  @param changedTime This MUST be a DB/2 changedTime
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setChangedtime ( String changedTime ) {
      this.changedTime = changedTime ;
      updateRecStatus ( REC_UPDATE ) ;
   }





   /*------------------------------------------------------------*/
   /* getDBUser
    */
   /**
    *    This method returns the last person who touched
    *  this document
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getDBUser () {
      return( dbUser ) ;
   }




   /*------------------------------------------------------------*/
   /* getChangedtime
    */
   /**
    *    This method will return the last time that this
    *  record was changed
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return DB/2 Timestamp
    *//*---------------------------------------------------------*/
   public String getChangedtime () {
      return( changedTime ) ;
   }
} /* QuestRecord */
