package com.ibm.nzna.projects.common.quest.brand ;     
/*-----------------------------------------------------------*/
/*   BrandGroupRec                                           */
/*                                                           */
/*   Description:                                            */
/*      Source code for: BrandGroupRec                       */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This object holds the relationship of a brand and group in TIGRIS.BRANDS 
 *
 *
 * @version 1.0, 3/20/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   BrandGroupRec                                           */
/*                                                           */
/*-----------------------------------------------------------*/
public class BrandGroupRec extends Object implements java.io.Serializable {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private int brandInd          = 0 ;
   private int groupInd          = 0 ;
   private int brandGroupInd     = 0 ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This is the default constructor
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public BrandGroupRec () {
   }




   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This constructor creates and initializes the 
    *  values in this record to the parameters passed in
    *  
    *
    *  @param brandInd The brand indicator from TIGRIS.TYPEBRAND
    *  @param groupInd The group indicator from TIGRIS.TYPEGROUP
    *  @param brandGroupInd The Brand Group Indicator from TIGRIS.BRANDS
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public BrandGroupRec ( int brandInd, int groupInd, int brandGroupInd ) {
      setBrandInd ( brandInd ) ;
      setGroupInd ( groupInd ) ;
      setBrandGroupInd ( brandGroupInd ) ;
   }




   /*------------------------------------------------------------*/
   /* setBrandInd
    */
   /**
    *    This method will set our brand indicator
    *  
    *  
    *
    *  @param brandInd The brand indicator from TIGRIS.TYPEBRAND
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setBrandInd ( int brandInd ) {
      this.brandInd = brandInd ;
   }




   /*------------------------------------------------------------*/
   /* getBrandInd
    */
   /**
    *    This method will return the brand indicator
    *  that this record represents
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return int
    *//*---------------------------------------------------------*/
   public int getBrandInd ( ) {
      return( brandInd ) ;
   }





   /*------------------------------------------------------------*/
   /* setGroupInd
    */
   /**
    *    This method will set our group indicator
    *  
    *  
    *
    *  @param groupInd The group indicator from TIGRIS.TYPEGROUP
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setGroupInd ( int groupInd ) {
      this.groupInd = groupInd ;
   }




   /*------------------------------------------------------------*/
   /* getGroupInd
    */
   /**
    *    This method will return the group indicator
    *  that this record represents
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return int
    *//*---------------------------------------------------------*/
   public int getGroupInd ( ) {
      return( groupInd ) ;
   }





   /*------------------------------------------------------------*/
   /* setBrandGroupInd
    */
   /**
    *    This method will set our brand group indicator
    *  
    *  
    *
    *  @param brandInd The brand indicator from TIGRIS.BRANDS
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setBrandGroupInd ( int brandGroupInd ) {
      this.brandGroupInd = brandGroupInd ;
   }




   /*------------------------------------------------------------*/
   /* getBrandInd
    */
   /**
    *    This method will return the brand group indicator
    *  that this record represents
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return int
    *//*---------------------------------------------------------*/
   public int getBrandGroupInd ( ) {
      return( brandGroupInd ) ;
   }




} /* BrandGroupRec */
