package com.ibm.nzna.projects.common.quest.doc ;         
/*-----------------------------------------------------------*/
/*   DocumentComment                                         */
/*                                                           */
/*   Description:                                            */
/*      Source code for: DocumentComment                     */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This object holds information about a single document's 
 * comment.
 *
 * @version 1.0, 2/21/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   DocumentComment                                         */
/*                                                           */
/*-----------------------------------------------------------*/
public class DocumentComment extends Object implements java.io.Serializable {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private int    docDraftInd       = 0 ;
   private String comment           = null ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This default constructor will initialize all
    *  values in this record
    *  
    *
    *  @param docDraftInd The Draft Documetn Indicator that this comment belongs to
    *  @param comment The comment that this record represents
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public DocumentComment ( int docDraftInd, String comment ) {
      this.docDraftInd = docDraftInd ;
      this.comment     = comment ;
   }





   /*------------------------------------------------------------*/
   /* getComment
    */
   /**
    *    This method will return the comment that
    *  this record represents
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public String getComment () {
      return( comment ) ;
   }




   /*------------------------------------------------------------*/
   /* getDocDraftInd
    */
   /**
    *    This method will return the Document
    *  Draft Inidicator that this comment belongs to
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public int getDocDraftInd () {
      return( docDraftInd ) ;
   }

} /* DocumentComment */
