package com.ibm.nzna.projects.common.quest.doc ;     
/*-----------------------------------------------------------*/
/*   DocumentGraphic                                         */
/*                                                           */
/*   Description:                                            */
/*      Source code for: DocumentGraphic                     */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This record represents a single Graphic that must be FTPed with the
 * document to all web sites.
 *
 * @version 1.0, 10/16/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   DocumentGraphic                                         */
/*                                                           */
/*-----------------------------------------------------------*/
public class DocumentGraphic extends DocumentFile {


   /**
     *  This is the primary key for the graphic
     **/
   private int graphicInd = 0 ;




   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will assume this graphic
    *  has already been read in
    *  
    *
    *  @param graphicInd The GRAPHICIND to use, it may be 0 for a new graphic
    *  @param filename The filename of the graphic
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public DocumentGraphic ( int graphicInd, String filename ) {
      super ( graphicInd, filename ) ;
      this.graphicInd = graphicInd ;
   }

   /**
     *  This method will return our graphic indicator
     **/
   public int getGraphicInd () {
      return ( graphicInd ) ;
   }


   public boolean equals ( Object object ) {
      boolean rc = false ;

      if ( object instanceof DocumentGraphic ) 
         return ( ((DocumentGraphic)object).getFilename().equals ( getFilename() ) ) ;
      return ( rc ) ;
   }
} /* DocumentGraphic */
