package com.ibm.nzna.projects.common.quest.doc ;
/*-----------------------------------------------------------*/
/*   DocumentLocale                                          */
/*                                                           */
/*   Description:                                            */
/*      Source code for: DocumentLocale                      */
/*                                                           */
/*                                                           */
/*         @Copyright  1997 David Lentz                      */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import com.ibm.nzna.shared.pom.* ;
import com.ibm.nzna.shared.db.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.quest.* ;
/**
 * This record holds information on a locale. This locale can be
 * a single geography, a list of geographies or countries or world wide. This
 * object also has usefull methods in determining if it represents the world,
 * or if a specific geography has all countries assigned to it etc..  
 *
 * @version 1.0, 7/25/1998 
 * @author  David Lentz
 */


/*-----------------------------------------------------------*/
/*                                                           */
/*   DocumentLocale                                          */
/*                                                           */
/*-----------------------------------------------------------*/
public class DocumentLocale extends LocaleRec implements java.io.Serializable {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   This is the serialization ID. If you add fields to this */
   /* record, YOU MUST UPDATE THIS NUMBER. Adding methods is    */
   /* fine as long as you know what you are doing!              */
   /*                                                           */
   /*-----------------------------------------------------------*/
   static final long serialVersionUID = 1000000 ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This constructor should only be used if you 
    *  DO NOT have an instance of TypeList
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public DocumentLocale ( boolean createGeoVec ) {
      super ( createGeoVec ) ;
   }




   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This constructor will create a DocumentLocale
    *  from the LocaleRec passed in. All properties
    *  will be initialized to match those of the localeRec passed
    *
    *  @param localeRec The LocaleRec to copy properties from
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public DocumentLocale ( LocaleRec localeRec ) {
      super ( localeRec ) ;
   }





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This is the default constructor
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public DocumentLocale () {
      super() ;
   }
} /* DocumentLocale */
