package com.ibm.nzna.projects.common.quest.doc ;              
/*-----------------------------------------------------------*/
/*   DocumentQueryText                                       */
/*                                                           */
/*   Description:                                            */
/*      Source code for: DocumentQueryText                   */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This object holds the Document Query Text for a document 
 *
 *
 * @version 1.0, 2/12/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   DocumentQueryText                                       */
/*                                                           */
/*-----------------------------------------------------------*/
public class DocumentQueryText extends com.ibm.nzna.shared.pom.PersistentRec implements java.io.Serializable {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   This is the serialization ID. If you add fields to this */
   /* record, YOU MUST UPDATE THIS NUMBER. Adding methods is    */
   /* fine as long as you know what you are doing!              */
   /*                                                           */
   /*-----------------------------------------------------------*/
   static final long serialVersionUID = 1000000 ;      

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private String queryText = null ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This default constructor initializes our
    *  variables
    *  
    *
    *  @param queryText The initial Query Text
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public DocumentQueryText ( String queryText ) throws IllegalArgumentException {
      updateRecStatus ( REC_INSERT ) ;
      setQueryText ( queryText ) ;
   }





   /*------------------------------------------------------------*/
   /* setQueryText
    */
   /**
    *    This method will set the query text of the
    *  object
    *  
    *
    *  @param queryText The Query Text to set
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setQueryText ( String queryText ) throws IllegalArgumentException {
      if ( ( queryText != null ) && ( queryText.length() < 1024 ) ) {
         this.queryText = queryText ;
         updateRecStatus ( REC_UPDATE ) ;
      } else
         throw new IllegalArgumentException ( "QUERYTEXT cannot be NULL or more than 1,024 Characters" ) ;
   }




   /*------------------------------------------------------------*/
   /* getQueryText
    */
   /**
    *    This method will return the Query Text
    *  for the document
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getQueryText () {
      return( queryText ) ;
   }





   /*------------------------------------------------------------*/
   /* toString
    */
   /**
    *    This method will return the Query Text
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String toString () {
      return( queryText ) ;
   }
} /* DocumentQueryText */
