
package com.ibm.nzna.projects.common.quest.oa;

import com.ibm.nzna.shared.pom.PersistentRec;
import com.ibm.nzna.projects.common.storedProc.sqlRunner.*;
import com.ibm.nzna.projects.common.quest.type.TypeCountryCodeRec;
import com.ibm.nzna.projects.common.quest.type.TypeLanguageRec;
import java.util.Vector;

/**
 * @version 1.2
 * @author  Mark DeBiase
**/

class ActionLinkDraftWriter {

  private static final String SCHEMA = "oadraft";

  static String getSQL(DocLink d) {
    String sql;

    switch ( d.getRecStatus() ) {
      case PersistentRec.REC_INSERT:
        sql = getInsertSQL(d, SCHEMA);
        break;

      case PersistentRec.REC_UPDATE:
        sql = getUpdateSQL(d, SCHEMA);
        break;

      case PersistentRec.REC_DELETE:
        sql = getDeleteSQL(d, SCHEMA);
        break;

      default:
        sql = "";
    }
    return sql;
  }

  static String getInsertSQL(DocLink d, String schema) {
    return ActionLinkWriter.getInsertSQL(d, schema);
  }

  static String getUpdateSQL(DocLink d, String schema) { 
    return ActionLinkWriter.getUpdateSQL(d, schema);
  }

  static String getDeleteSQL(DocLink d, String schema) {
    return ActionLinkWriter.getDeleteSQL(d, schema);
  }

  /**
   * Return SQL to delete all the DocLinks for an Action.
  **/
  static String getDeleteAllForActionSQL(int actionDraftInd) {
    return ActionLinkWriter.getDeleteAllForActionSQL(actionDraftInd, SCHEMA);
  }
}
