
package com.ibm.nzna.projects.common.quest.oa;

import com.ibm.nzna.shared.pom.PersistentRec;
import com.ibm.nzna.projects.common.storedProc.sqlRunner.*;
import com.ibm.nzna.projects.common.quest.type.TypeCountryCodeRec;
import com.ibm.nzna.projects.common.quest.type.TypeLanguageRec;
import java.util.Vector;

/**
 * @version 1.2
 * @author  Mark DeBiase
**/
class ActionTitleDraftWriter {

  private static final String SCHEMA = "oadraft";

  static String getSQL(Title t) {
    String sql;

    switch ( t.getRecStatus() ) {
      case PersistentRec.REC_INSERT:
        sql = getInsertSQL(t, SCHEMA);
        break;

      case PersistentRec.REC_UPDATE:
        sql = getUpdateSQL(t, SCHEMA);
        break;

      case PersistentRec.REC_DELETE:
        sql = getDeleteSQL(t, SCHEMA);
        break;

      default:
        sql = "";
    }
    return sql;
  }

  static String getInsertSQL(Title t, String schema) {
    return ActionTitleWriter.getInsertSQL(t, schema);
  }

  static String getUpdateSQL(Title t, String schema) { 
    return ActionTitleWriter.getUpdateSQL(t, schema);
  }

  static String getDeleteSQL(Title t, String schema) {
    return ActionTitleWriter.getDeleteSQL(t, schema);
  }

  /**
   * Return SQL to delete all the Titles for an Action.
  **/
  static String getDeleteAllForActionSQL(int actionDraftInd) {
    return ActionTitleWriter.getDeleteAllForActionSQL(actionDraftInd, SCHEMA);
  }
}
