
package com.ibm.nzna.projects.common.quest.oa;

import com.ibm.nzna.shared.pom.PersistentRec;
import com.ibm.nzna.projects.common.storedProc.sqlRunner.*;
import com.ibm.nzna.projects.common.quest.type.TypeCountryCodeRec;
import java.util.Vector;

/**
 * @version 1.2
 * @author  Mark DeBiase
**/
class AnswerConclDraftWriter {

  private static final String SCHEMA = "oadraft";

  /**
   * Returns the SQL String to write the AnswerConcl object to the database.
  **/
  static String getSQL(AnswerConcl a) {
    String sql;

    switch ( a.getRecStatus() ) {
      case PersistentRec.REC_INSERT:
        sql = getInsertSQL(a, SCHEMA);
        break;

      case PersistentRec.REC_UPDATE:
        sql = getUpdateSQL(a, SCHEMA);
        break;

      case PersistentRec.REC_DELETE:
        sql = getDeleteSQL(a, SCHEMA);
        break;

      default:
        sql = "";
    }
    return sql;
  }

  static String getInsertSQL(AnswerConcl a, String schema) {
    return AnswerConclWriter.getInsertSQL(a, schema);
  }

  static String getUpdateSQL(AnswerConcl a, String schema) {
    return AnswerConclWriter.getUpdateSQL(a, schema);
  }

  static String getDeleteSQL(AnswerConcl a, String schema) {
    return AnswerConclWriter.getDeleteSQL(a, schema);
  }

  /**
   * Return SQL to delete all the Conclusions for ALL Answers to a Question.
  **/
  static String getDeleteAllForQuestionSQL(int questionDraftInd) {
    return AnswerConclWriter.getDeleteAllForQuestionSQL(questionDraftInd,
                                                        SCHEMA);
  }

  /**
   * Return SQL to delete all the Conclusions for a single Answer.
  **/
  static String getDeleteAllForAnswerSQL(int answerInd) {
    return AnswerConclWriter.getDeleteAllForAnswerSQL(answerInd, SCHEMA);
  }

}
