
package com.ibm.nzna.projects.common.quest.oa;

import com.ibm.nzna.projects.common.storedProc.sqlRunner.*;
import com.ibm.nzna.projects.common.quest.type.TypeCountryCodeRec;
import java.util.Vector;

/**
 * @version 1.6
 * @author  Mark DeBiase
**/
class CountryWriter {

  static String getInsertSQL(String tableName, int parentInd,
                             Vector countryList, String dbUser) 
  {
    String insertSql = "";

    if (countryList != null && countryList.size() > 0) {
      StringBuffer sb = new StringBuffer(DatabaseUtil.DEFAULT_SB_SIZE);
      TypeCountryCodeRec country;

      for (int i=0; i<countryList.size(); i++) {
        country = (TypeCountryCodeRec) countryList.elementAt(i);

        // insert columns = parentInd, countryInd, dbUser, changedTime
        sb.append( "INSERT INTO ").append(tableName).append(" VALUES (" )
          .append( parentInd                       ).append(',')
          .append( country.getInd()                ).append(',')
          .append( DatabaseUtil.stringToDB(dbUser) ).append(',')
          .append( "CURRENT TIMESTAMP)")
          .append(SqlRunner.END_DELIM);
      }
      insertSql = sb.toString();
    }

    return insertSql;
  }

  static String getUpdateSQL(String tableName, String columnName, int parentInd,
                             Vector countryList, Vector originalCountryList,
                             String dbUser)
  { 

    // only update the countries if they have changed
    if ( !VectorUtil.vectorsEqual(countryList, originalCountryList) ) {
      return CountryWriter.getDeleteSQL(tableName, columnName, parentInd) +
             CountryWriter.getInsertSQL(tableName, parentInd, 
                                        countryList, dbUser);
    } else {
      return "";
    }
  }

  static String getDeleteSQL(String tableName, String columnName, int parentInd)
  {
    StringBuffer sb = new StringBuffer(DatabaseUtil.DEFAULT_SB_SIZE);

    sb.append("DELETE FROM ").append(tableName)
      .append(" WHERE ").append(columnName).append('=')
      .append( parentInd )
      .append(SqlRunner.END_DELIM);

    return sb.toString();
  }
}
