
package com.ibm.nzna.projects.common.quest.oa;

import com.ibm.nzna.shared.pom.PersistentRec;

/**
 * Represents the return Node for a Symptom subroutine.
 * There can only be one EdgeReturn object on a given edge.
 *
 * @version 1.9
 * @author  Mark DeBiase
**/

public class EdgeReturn extends EdgeObject {

  private Node node_ = null;

  /**
   * New EdgeReturn object.
   * 
   * @param Node the return Node
  **/
  public EdgeReturn(Node n) {
    node_ = n;
    updateRecStatus(REC_INSERT);
  }

  /**
   * Gets the return Node.
  **/
  public Node getNode() {
    return node_;
  }

  /**
   * Gets the return Node indicator.
  **/
  public int getNodeInd() {
    return node_.getInd();
  }

  /**
   * Returns a String representation of this object.
  **/
  public String toString() {
    return "EdgeReturn " + getInd() + ": nodeInd=" + node_.getInd();
  }
}
