
package com.ibm.nzna.projects.common.quest.oa;

/**
 * This class sets the mode to be used when reading OA objects from the
 * database.  When the mode is set to OAMode.WEB, certain optimizations
 * will be performed when reading (i.e., don't populate TypeRec object
 * descriptions).
**/
public class OAMode {

  /** the default mode (i.e., for Quest input tool) */
  public static final int DEFAULT = 0;
  /** optimize reading for web */
  public static final int WEB     = 1;

  static int currentMode = DEFAULT;

  /**
   * Set the current mode.
   * @param newMode should be either OAMode.DEFAULT (which is the default mode)
   *                or OAMode.WEB
  **/
  public static void setMode(int newMode) {
    currentMode = newMode;
  }

  /**
   * Get the current mode.
   * @return the current mode: OAMode.DEFAULT or OAMode.WEB
  **/
  public static int getMode() {
    return currentMode;
  }
}
