
package com.ibm.nzna.projects.common.quest.oa;

/**
 * Exception to be thrown when there is a pending draft.
 * <br>
 * This exception will be thrown from the getDraft() method in
 * the DraftReader classes (ActionDraftReader, QuestionDraftReader,
 * etc) when attempting to create a new draft if openDraft='Y' on
 * the active object and no open draft with stopDate=NULL exists.
 * <br>
 * This exception will also be thrown from the getDraft() method
 * in the draft object classes (ActionDraft, QuestionDraft, etc)
 * to let the input tool know that no object was returned because
 * there is a pending draft instead of some other error.
 *
 * @version 1.4
 * @author  Mark DeBiase
**/
public class PendingDraftException extends Exception { }
