package com.ibm.nzna.projects.common.quest.oa ;

import com.ibm.nzna.projects.common.quest.oa.*;
import com.ibm.nzna.projects.common.storedProc.*;
import com.ibm.nzna.projects.common.storedProc.sqlRunner.*;
import com.ibm.nzna.shared.util.*;    // LogSystem, Text
import com.ibm.nzna.shared.db.*;      // DatabaseSystem
import java.io.*;
import java.sql.*;
import java.util.*;

  /**
   * Inner class to hold information from the oa.productConcl table.
  **/
public class ProductConclInfo {

  /** Default constructor. */
  public ProductConclInfo() { }

  /** Constructor which initializes the productInd and descript fields. */
  public ProductConclInfo(int productInd, String descript) {
    this.productInd = productInd;
    this.descript   = descript;
  }

  /**
   * The productInd from the oa.productConcl table.
   * Corresponds to prodInt in tigris.products.
   */
  public int productInd;

  /**
   * The String description of the machine.
   * The type-model for machines or descript/prodnum for options.
   */
  public String descript;

  public String toString() {
    return productInd + ":" + descript;
  }
} // ProductConclInfo

