
package com.ibm.nzna.projects.common.quest.oa;

import com.ibm.nzna.shared.pom.PersistentRec;
import com.ibm.nzna.projects.common.storedProc.sqlRunner.*;
import com.ibm.nzna.projects.common.quest.type.TypeCountryCodeRec;
import com.ibm.nzna.projects.common.quest.type.TypeLanguageRec;
import java.util.Vector;

/**
 * @version 1.2
 * @author  Mark DeBiase
**/

class QuestionInfoDraftWriter {

  private static final String SCHEMA = "oadraft";

  static String getSQL(AddtlInfo a) {
    String sql;

    switch ( a.getRecStatus() ) {
      case PersistentRec.REC_INSERT:
        sql = getInsertSQL(a, SCHEMA);
        break;

      case PersistentRec.REC_UPDATE:
        sql = getUpdateSQL(a, SCHEMA);
        break;

      case PersistentRec.REC_DELETE:
        sql = getDeleteSQL(a, SCHEMA);
        break;

      default:
        sql = "";
    }
    return sql;
  }

  static String getInsertSQL(AddtlInfo a, String schema) {
    return QuestionInfoWriter.getInsertSQL(a, schema);
  }

  static String getUpdateSQL(AddtlInfo a, String schema) { 
    return QuestionInfoWriter.getUpdateSQL(a, schema);
  }

  static String getDeleteSQL(AddtlInfo a, String schema) {
    return QuestionInfoWriter.getDeleteSQL(a, schema);
  }

  /**
   * Return SQL to delete all the DocLinks for an Question.
  **/
  static String getDeleteAllForQuestionSQL(int questionDraftInd) {
    return QuestionInfoWriter.getDeleteAllForQuestionSQL(questionDraftInd,
                                                         SCHEMA);
  }
}
