
package com.ibm.nzna.projects.common.quest.oa;

import com.ibm.nzna.shared.pom.PersistentRec;
import com.ibm.nzna.projects.common.storedProc.sqlRunner.*;
import com.ibm.nzna.projects.common.quest.type.TypeCountryCodeRec;
import com.ibm.nzna.projects.common.quest.type.TypeLanguageRec;
import java.util.Vector;

/**
 * @version 1.2
 * @author  Mark DeBiase
**/
class SymptomTitleDraftWriter {

  private static final String SCHEMA = "oadraft";

  static String getSQL(SymptomTitle t) {
    String sql;

    switch ( t.getRecStatus() ) {
      case PersistentRec.REC_INSERT:
        sql = getInsertSQL(t, SCHEMA);
        break;

      case PersistentRec.REC_UPDATE:
        sql = getUpdateSQL(t, SCHEMA);
        break;

      case PersistentRec.REC_DELETE:
        sql = getDeleteSQL(t, SCHEMA);
        break;

      default:
        sql = "";
    }
    return sql;
  }

  static String getInsertSQL(SymptomTitle t, String schema) {
    return SymptomTitleWriter.getInsertSQL(t, schema);
  }

  static String getUpdateSQL(SymptomTitle t, String schema) { 
    return SymptomTitleWriter.getUpdateSQL(t, schema);
  }

  static String getDeleteSQL(SymptomTitle t, String schema) {
    return SymptomTitleWriter.getDeleteSQL(t, schema);
  }

  /**
   * Return SQL to delete all the Titles for a Symptom.
  **/
  static String getDeleteAllForSymptomSQL(int symptomInd) {
    return SymptomTitleWriter.getDeleteAllForSymptomSQL(symptomInd, SCHEMA);
  }
}
