package com.ibm.nzna.projects.common.quest.product ;      
/*-----------------------------------------------------------*/
/*   DeleteTest                                            */
/*                                                           */
/*   Description:                                            */
/*      Source code for: DeleteTest                        */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.sql.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.shared.db.* ;
import com.ibm.nzna.projects.common.quest.* ; 
import com.ibm.nzna.projects.common.quest.product.* ; 
import com.ibm.nzna.projects.common.quest.type.* ;
/**
 * This small program will edit a product in the database. The 
 * product edited is passed as the product indicator to the program
 *
 *
 * @version 1.0, 6/20/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   DeleteTest                                            */
/*                                                           */
/*-----------------------------------------------------------*/
public class DeleteTest extends Object {

   private String databaseName      = null ;
   private String server            = null ;
   private String userId            = null ;
   private String password          = null ;
   private String portNumber        = null ;
   private int    productInd        = 1 ;


   /* Main  */
   public static void main ( String args[] ) {
      new com.ibm.nzna.shared.util.LogSystem ( 1, "DeleteTest.out" ) ;
      new DeleteTest ( args ) ;
   }




   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method kicks off our test
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public DeleteTest ( String args[] ) {
      try {
         databaseName=args[0] ;
         server=args[1] ;
         portNumber=args[2] ;
         userId=args[3] ;
         password=args[4] ;
         productInd=new Integer ( args[5] ).intValue() ;
      } catch ( Exception e ) {
         System.out.println ( "Usage:\njava com.ibm.nzna.projects.common.quest.product.DeleteTest <databaseName> <serverName> <portNumber> <userId> <password> <product ind to edit>" ) ;
         System.exit(0) ;
      }


      try {
         DatabaseSystem d = new DatabaseSystem ( false, null, false ) ;

         System.out.println ( "This test will create a Product Draft for Delete, save the draft, read the draft and publish the draft" ) ;
         System.out.print ( "Connecting to Quest..." ) ;
         if ( d.createConnection ( DatabaseSystem.QUEST,
                                   databaseName,
                                   server,
                                   portNumber,
                                   userId,
                                   password ) ) {

            System.out.println ( "Connected" ) ;
            new TypeList() ;
            TypeList.getInstance().initialize ( false ) ;
            deleteProduct() ;

         } else
            System.out.println ( "Could not connect to "+databaseName+" on "+server+" on port "+portNumber ) ;
      } catch ( Exception e1 ) {
         e1.printStackTrace() ;
         System.out.println ( "Could not connect to "+databaseName+" on "+server+" on port "+portNumber ) ;

      }
      System.exit(0) ;
   }


   /**
     *  This method will create the product
     **/
   private void deleteProduct () {
      System.out.println ( "Creating ProductDraft" ) ;
      CreateProductDraft  createRec      = ProductDraft.createProductDraft ( productInd ) ;
      ProductDraft        product        = createRec.getProductDraft() ;
      int                 rc             = 0 ;

      if ( createRec.getSqlCode() == 0 ) {
         System.out.print ( "Saving Product            " ) ;
         long currentTime=System.currentTimeMillis() ;

         product.setWorkRequired ( TypeList.WORKREQ_DELETE ) ;
         rc = product.writeToDatabase() ;
         switch ( rc ) {
            case 0 :
               break ;

            default:
               System.out.println ( "Failed. RC:"+rc ) ;
         }

         System.out.print ( "Time:"+(System.currentTimeMillis()-currentTime)+"(ms)\n\nReading Draft back in     " ) ;
         
         currentTime = System.currentTimeMillis() ;
         rc = product.readFromDatabase() ;
         System.out.println ( "Time:"+(System.currentTimeMillis()-currentTime)+"(ms)\n\n" ) ;

         if ( rc == 0 ) {
            currentTime = System.currentTimeMillis() ;
            System.out.print ( "Publishing Product         " ) ;
            product.publish() ;
            System.out.println ( "Time:"+(System.currentTimeMillis()-currentTime)+"(ms)\n\n" ) ;
         } else
            System.out.println ( "Could not re-read product draft. rc:"+rc ) ;
      }
   }
} /* DeleteTest */
