package com.ibm.nzna.projects.common.quest.product ;      
/*-----------------------------------------------------------*/
/*   EditDraft                                            */
/*                                                           */
/*   Description:                                            */
/*      Source code for: EditDraft                        */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.sql.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.shared.db.* ;
import com.ibm.nzna.projects.common.quest.* ; 
import com.ibm.nzna.projects.common.quest.product.* ; 
import com.ibm.nzna.projects.common.quest.type.* ;
/**
 * This small program will edit a product in the database. The 
 * product edited is passed as the product indicator to the program
 *
 *
 * @version 1.0, 6/20/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   EditDraft                                            */
/*                                                           */
/*-----------------------------------------------------------*/
public class EditDraft extends Object {

   private String databaseName      = null ;
   private String server            = null ;
   private String userId            = null ;
   private String password          = null ;
   private String portNumber        = null ;
   private int    productInd        = 1 ;


   /* Main  */
   public static void main ( String args[] ) {
      new com.ibm.nzna.shared.util.LogSystem ( 1, "EditDraft.out" ) ;
      new EditDraft ( args ) ;
   }




   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method kicks off our test
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public EditDraft ( String args[] ) {
      try {
         databaseName=args[0] ;
         server=args[1] ;
         portNumber=args[2] ;
         userId=args[3] ;
         password=args[4] ;
         productInd=new Integer ( args[5] ).intValue() ;
      } catch ( Exception e ) {
         System.out.println ( "Usage:\njava com.ibm.nzna.projects.common.quest.product.EditDraft <databaseName> <serverName> <portNumber> <userId> <password> <product ind to edit>" ) ;
         System.exit(0) ;
      }


      try {
         DatabaseSystem d = new DatabaseSystem ( false, null, false ) ;

         System.out.print ( "Connecting to Quest..." ) ;
         if ( d.createConnection ( DatabaseSystem.QUEST,
                                   databaseName,
                                   server,
                                   portNumber,
                                   userId,
                                   password ) ) {

            System.out.println ( "Connected" ) ;
            new TypeList() ;
            TypeList.getInstance().initialize ( false ) ;
            editProduct() ;

         } else
            System.out.println ( "Could not connect to "+databaseName+" on "+server+" on port "+portNumber ) ;
      } catch ( Exception e1 ) {
         e1.printStackTrace() ;
         System.out.println ( "Could not connect to "+databaseName+" on "+server+" on port "+portNumber ) ;

      }
      System.exit(0) ;
   }


   /**
     *  This method will create the product
     **/
   private void editProduct () {
      System.out.println ( "Creating ProductDraft" ) ;
      CreateProductDraft  createRec      = ProductDraft.createProductDraft ( productInd ) ;
      ProductDraft        product        = createRec.getProductDraft() ;
      int                 rc             = 0 ;


      if ( createRec.getSqlCode() == 0 ) {
          System.out.println ( "CreateRec:\n"+createRec.toOut()+"\n\nChanging Machine to 3333" ) ;
          product.setMachine ( TypeCategory.createDraftTypeCategory ( product.getFamily().getInd(), 
                                                                    "3333", 
                                                                    TypeCategory.LEVEL_MACHINE,
                                                                    0,
                                                                    "N",
                                                                    "N" ) ) ;
         System.out.print ( "Saving Product  " ) ;
         long currentTime=System.currentTimeMillis() ;

         rc = product.writeToDatabase() ;
         switch ( rc ) {
            case 0 :
               System.out.println ( "OK!" ) ;
               break ;

            default:
               System.out.println ( "Failed. RC:"+rc ) ;
         }

         System.out.println ( "Time:"+(System.currentTimeMillis()-currentTime)+"(ms)Product Draft Ind:"+product.getProductInd()+"\n\nPublishing    " ) ;
         currentTime=System.currentTimeMillis() ;
         product.publish() ;
         System.out.println ( "Time:"+(System.currentTimeMillis()-currentTime)+"\n\n" ) ;


      }
   }


   public static void showProds () {
      SQLMethod sqlMethod = new SQLMethod ( DatabaseSystem.QUEST, "r", 5 ) ;

      LogSystem.log ( 1, "Creating SQL Method" ) ;
      try {
         Statement stmt =sqlMethod.createStatement() ;
         ResultSet rs = stmt.executeQuery ( "SELECT PRODUCTIND FROM PRODUCT.PRODUCT" ) ;

         while ( rs.next () ) {
            System.out.println ( rs.getInt(1) ) ;
         }
         rs.close() ;
      } catch ( Exception e ) {
         e.printStackTrace() ;
      }
      sqlMethod.close() ;
   }
} /* EditDraft */
