package com.ibm.nzna.projects.common.quest.product ;         
/*-----------------------------------------------------------*/
/*   ProductComment                                          */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ProductComment                      */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This object holds information about a single document's 
 * comment.
 *
 * @version 1.0, 2/21/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ProductComment                                          */
/*                                                           */
/*-----------------------------------------------------------*/
public class ProductComment extends Object implements java.io.Serializable {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   This is the serialization ID. If you add fields to this */
   /* record, YOU MUST UPDATE THIS NUMBER. Adding methods is    */
   /* fine as long as you know what you are doing!              */
   /*                                                           */
   /*-----------------------------------------------------------*/
   static final long serialVersionUID = 1000000 ;

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private int    productInd       = 0 ;
   private String comment           = null ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This default constructor will initialize all
    *  values in this record
    *  
    *
    *  @param productInd The Draft Documetn Indicator that this comment belongs to
    *  @param comment The comment that this record represents
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public ProductComment ( int productInd, String comment ) {
      this.productInd = productInd ;
      this.comment     = comment ;
   }





   /*------------------------------------------------------------*/
   /* getComment
    */
   /**
    *    This method will return the comment that
    *  this record represents
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public String getComment () {
      return( comment ) ;
   }




   /*------------------------------------------------------------*/
   /* getProductInd
    */
   /**
    *    This method will return the Document
    *  Draft Inidicator that this comment belongs to
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public int getProductInd () {
      return( productInd ) ;
   }


   /**
     *  This method will simple return what 'getComment' returns
     **/
   public String toString () {
      return ( getComment() );
   }
} /* ProductComment */
