package com.ibm.nzna.projects.common.quest.product ;   
/*-----------------------------------------------------------*/
/*   ProductReadTest                                         */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ProductReadTest                     */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.shared.db.* ;
import java.util.* ;
/**
 * This small program simply connects to the quest database 
 * and reads a product. The database information is
 * passed in from command line as is the document indicator
 *
 *
 * @version 1.0, 2/23/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ProductReadTest                                         */
/*                                                           */
/*-----------------------------------------------------------*/
public class ProductReadTest extends Object {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private String databaseName      = null ;
   private String server            = null ;
   private String userId            = null ;
   private String password          = null ;
   private String portNumber        = null ;
   private int    docInd            = 0 ;




   /*------------------------------------------------------------*/
   /* main
    */
   /**
    *    This is the execution point
    *  
    *  
    *
    *  @param databaseName The name of the database
    *  @param Server The name of the server
    *  @param port The JDBC Port number
    *  @param userId The user id to connect with
    *  @param password The password to connect with
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public static void main ( String args[] ) {
      new com.ibm.nzna.shared.util.LogSystem ( 1, "ProductReadTest.out" ) ;
      new ProductReadTest ( args ) ;
   }




   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method kicks off our test
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public ProductReadTest ( String args[] ) {
      try {
         databaseName=args[0] ;
         server=args[1] ;
         portNumber=args[2] ;
         userId=args[3] ;
         password=args[4] ;
         docInd = new Integer ( args[5] ).intValue() ;
      } catch ( Exception e ) {
         System.out.println ( "Usage:\njava com.ibm.nzna.projects.common.quest.doc.DocReader <databaseName> <serverName> <portNumber> <userId> <password> <doc indicator>" ) ;
         System.exit(0) ;
      }


      try {
         DatabaseSystem d = new DatabaseSystem ( false, null, false ) ;

         System.out.print ( "Connecting to Quest..." ) ;
         if ( d.createConnection ( DatabaseSystem.QUEST,
                                   databaseName,
                                   server,
                                   portNumber,
                                   userId,
                                   password ) ) {

            System.out.println ( "Done" ) ;

            for ( int i = docInd; i < (docInd+5); i++ ) {
               System.out.print ( "Reading Product :"+i+"  " ) ;
               Product  product     = new Product  ( i ) ;
               long     startMillis = System.currentTimeMillis() ;
               int      rc          = 0 ;

               product = Product.findFromCategory ( "IBM Aptiva", "PS/1", "2165", "55C" ) ;
               if ( product != null )
                  System.out.println ( "Found Product "+product.getProductInd()+" Through Product.find" ) ;
               product = new Product ( i ) ;
               rc= product.readFromDatabase() ;

               if ( rc == 0 ) {
                  System.out.println ( "Done" ) ; 
                  System.out.println ( product.toOut () ) ;
               } else if ( rc == 100 )
                  System.out.println ( "Could not find product" ) ;
               else
                  System.out.println ( "Error. RC:"+rc ) ;

               System.out.println ( "Total Time Taken:"+((System.currentTimeMillis()-startMillis))+"(ms)" ) ;
            }




         } else
            System.out.println ( "Could not connect to "+databaseName+" on "+server+" on port "+portNumber ) ;
      } catch ( Exception e1 ) {
         e1.printStackTrace() ;
         System.out.println ( "Could not connect to "+databaseName+" on "+server+" on port "+portNumber ) ;

      }
   }
} /* ProductReadTest */
