package com.ibm.nzna.projects.common.quest.product;
/*-----------------------------------------------------------*/
/*   Source File
/*
/*   Filename:      ProductWriter
/*   Creation Date: APRIL 17, 2001
/*
/*
/*
/*         @Copyright  2001
/*          All Rights Reserved
/*
/*
/*-----------------------------------------------------------*/
import java.sql.* ;
import com.ibm.nzna.shared.db.* ;
import com.ibm.nzna.projects.common.storedProc.sqlRunner.* ;
/**
 * This class has the static methods needed to write a Product to the
 * database. Please use the Product object's 'wroteToDatabase' method to
 * save information and not this class.
 *
 * @author  David Lentz
 * @version 1
 */

/*----------------------------------------------------
/*
/* ProductWriter
/*
/*----------------------------------------------------*/
public class ProductWriter {

    /**
      * This method will save an entire product record to the database. It
      * will return 0 if all saved ok, or and SQL Code in the event of an
      * error. However, this method will throw an SQLException if one is
      * generated.
      *
      * @param conn The DB/2 Connection used to save the information
      * @param product The Product Object to save
      **/
    protected static int saveToDatabase ( Connection conn, Product product ) throws Exception {                       
        String sql = product.toSQL () ;
        int    rc  = 0 ;                        

        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   If we have at least 1 SQL, run it                       */
        /*                                                           */
        /*-----------------------------------------------------------*/
        if ( ( sql != null ) && ( sql.length() > 0 ) ) {
            rc = SqlRunner.sqlRunnerCode ( DatabaseSystem.QUEST, sql ) ;
        }

        return( rc ) ;
    }

}
/* ProductWriter */