package com.ibm.nzna.projects.common.quest.type;
/*-----------------------------------------------------------*/
/*   Source File
/*
/*   Filename:      TypeBrandRec
/*   Creation Date: APRIL 13, 2001
/*
/*
/*
/*         @Copyright  2001
/*          All Rights Reserved
/*
/*
/*-----------------------------------------------------------*/

/**
 * This class holds information regarding a single Brand
 *
 * @author  David Lentz
 * @version 1
 */

/*----------------------------------------------------
/*
/* TypeBrandRec
/*
/*----------------------------------------------------*/
public class TypeBrandRec extends TypeCategoryRec {

    /*-----------------------------------------------------------*/
    /*                                                           */
    /*   Private Members                                         */
    /*                                                           */
    /*-----------------------------------------------------------*/

    /*-----------------------------------------------------------*/
    /*                                                           */
    /*   Public Members                                          */
    /*                                                           */
    /*-----------------------------------------------------------*/

    /**
      * This constructor should be used to create a new Brand in the
      * database
      **/
    public TypeBrandRec () {
    }

    /**
      * This constructor creates a TypeBrandRec That is already in the
      * PRODUCT.TYPECATEGORY table.
      **/
    public TypeBrandRec ( int brandInd ) throws IllegalArgumentException {
        super ( brandInd ) ;
        if ( brandInd == 0 )
            throw new IllegalArgumentException ( "Cannot create brandInd of zero" ) ;
    }

   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This is the default and only constructor
    *  
    *  
    *
    *  @param ind The Brand Indicator
    *  @param descript The description of the brand
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public TypeBrandRec ( int brandInd, String descript, int authInd ) throws IllegalArgumentException {
      super ( brandInd ) ;
      setDescript ( descript ) ;
   }
}
/* Class1 */
