package com.ibm.nzna.projects.common.quest.type ;
/*-----------------------------------------------------------*/
/*   TypeCancelRec                                           */
/*                                                           */
/*   Description:                                            */
/*      Source code for: TypeCancelRec                       */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.sql.* ;
import com.ibm.nzna.shared.db.* ;
import com.ibm.nzna.shared.util.* ;
/**
 * The TypeCancelRecRec holds specific information about a single date 
 * in the PRODUCT.TYPEDATE table
 *
 *
 * @version 1.0, 2/28/100 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   TypeCancelRec                                           */
/*                                                           */
/*-----------------------------------------------------------*/
public class TypeCancelRec extends TypeRec {





    /*------------------------------------------------------------*/
    /* Constructor
     */
    /**
     *    This is the default and only constructor
     *  
     *  
     *
     *  @param typeCancelInd The Indicator
     *  @param descript The description of the brand
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public TypeCancelRec ( int typeCancelInd, String descript ) {
        super ( typeCancelInd, descript ) ;
    }



    /**
      *  This method will save this object to the database
      **/
    public int writeToDatabase() {
       int       sqlCode   = 0 ;
       SQLMethod sqlMethod = new SQLMethod ( DatabaseSystem.QUEST, "TypeCancelRec.writeToDatabase", 5 ) ;

       try {
          Statement stmt = sqlMethod.createStatement() ;

          switch ( getRecStatus() ) {
             case REC_DELETE :
                stmt.executeUpdate ( "UPDATE PRODRAFT.PRODUCT SET TYPECANCELIND = 0 WHERE TYPECANCELIND = "+getInd() ) ;
                stmt.executeUpdate ( "DELETE FROM PRODRAFT.TYPECANCEL WHERE TYPECANCELIND = "+getInd() ) ;
                break ;

             case REC_UPDATE :
                stmt.executeUpdate ( "UPDATE PRODRAFT.TYPECANCEL SET DESCRIPTION = '"+Text.cleanDBString ( toString() )+"' "+
                                     "WHERE TYPECANCELIND = "+getInd() ) ;
                break ;

             case REC_INSERT :
                stmt.executeUpdate ( "INSERT INTO PRODRAFT.TYPECANCEL "+
                                     "VALUES ( "+getInd()+", '"+Text.cleanDBString ( toString() )+"')" ) ;
                break ;
          }



       } catch (SQLException e ) {
          sqlCode = e.getErrorCode() ;
          sqlMethod.rollBack() ;
       }

       sqlMethod.close() ;

       return ( sqlCode ) ;
    }
} /* TypeCancelRecRec */
