package com.ibm.nzna.projects.common.quest.type ;                       
/*-----------------------------------------------------------*/
/*   TypeCategoryListener                                    */
/*                                                           */
/*   Description:                                            */
/*      Source code for: TypeCategoryListener                */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This listener gets notified of status changes in the TypeCategory class 
 *
 *
 * @version 1.0, 8/1/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   TypeCategoryListener                                    */
/*                                                           */
/*-----------------------------------------------------------*/
public interface TypeCategoryListener  {


   /**
     *  This method will be called when a Category list is being
     * read
     *
     * @param categoryName The Human readable name for the category
     **/
   public abstract void typeCategoryReadStart ( String categoryName ) ;

   /**
     *  This method will be called when the reading of a category is
     * complete
     **/
   public abstract void typeCategoryReadStop () ;

   /**
     *  This method will be called when the Type Category object is saving
     * information
     **/
   public abstract void typeCategoryWriteStart() ;

   /**
     *  This method will be called when the Type Category object has completed
     * saving.
     **/
   public abstract void typeCategoryWriteStop() ;

} /* TypeCategoryListener */
