package com.ibm.nzna.projects.common.quest.type ;           
/*-----------------------------------------------------------*/
/*   TypeCategoryUtil                                        */
/*                                                           */
/*   Description:                                            */
/*      Source code for: TypeCategoryUtil                    */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
/**
 * This class holds static methods useful in manipulating TypeCategoryRec objects and lists 
 *
 *
 * @version 1.0, 8/16/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   TypeCategoryUtil                                        */
/*                                                           */
/*-----------------------------------------------------------*/
public class TypeCategoryUtil extends Object {


   /**
     *  This method will return TRUE if the at least 1 child in 
     * the vector of children passed belongs to the parent
     * passed
     *
     * @param parent The parent to use
     * @param children The children to look through
     **/
   public static boolean vectorContainsChild ( TypeCategoryRec parent, Vector children ) {
      boolean rc = false ;

      if ( ( children != null ) && ( children.size() > 0 ) ) {
         int i       = 0 ;
         int size    = children.size() ;

         while ( ( !rc ) && ( i < size ) ) {
            rc = ( TypeCategory.getParentCategory ( (TypeCategoryRec)children.elementAt(i),
                                                    parent.getCategoryLevel() ) != null ) ;
            i++ ;
         }
      }

      return ( rc ) ;
   }
} /* TypeCategoryUtil */
