package com.ibm.nzna.projects.common.quest.type ;
/*-----------------------------------------------------------*/
/*   TypeCustomerRecRec                                      */
/*                                                           */
/*   Description:                                            */
/*      Source code for: TypeCustomerRecRec                  */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.sql.* ;
import com.ibm.nzna.shared.db.* ;
import com.ibm.nzna.shared.util.* ;
/**
 * The TypeCustomerRecRec holds specific information about a single date 
 * in the PRODUCT.TYPEDATE table
 *
 *
 * @version 1.0, 2/28/100 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   TypeCustomerRec                                         */
/*                                                           */
/*-----------------------------------------------------------*/
public class TypeCustomerRec extends TypeRec {





    /*------------------------------------------------------------*/
    /* Constructor
     */
    /**
     *    This is the default and only constructor
     *  
     *  
     *
     *  @param typeCustomerInd The Indicator
     *  @param descript The description of the brand
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public TypeCustomerRec ( int typeCustomerInd, String descript ) {
        super ( typeCustomerInd, descript ) ;
    }



    /**
      *  This method will save this object to the database
      **/
    public int writeToDatabase() {
       int       sqlCode   = 0 ;
       SQLMethod sqlMethod = new SQLMethod ( DatabaseSystem.QUEST, "TypeCustomerRec.writeToDatabase", 5 ) ;

       try {
          Statement stmt = sqlMethod.createStatement() ;

          switch ( getRecStatus() ) {
             case REC_DELETE :
                stmt.executeUpdate ( "UPDATE PRODUCT.PRODUCT SET TYPECUSTOMERIND = 0 WHERE TYPECUSTOMERIND = "+getInd() ) ;
                stmt.executeUpdate ( "UPDATE PRODRAFT.PRODUCT SET TYPECUSTOMERIND = 0 WHERE TYPECUSTOMERIND = "+getInd() ) ;
                stmt.executeUpdate ( "DELETE FROM PRODUCT.TYPECUSTOMER WHERE TYPECUSTOMERIND = "+getInd() ) ;
                break ;

             case REC_UPDATE :
                stmt.executeUpdate ( "UPDATE PRODUCT.TYPECUSTOMER SET DESCRIPTION = '"+Text.cleanDBString ( toString() )+"' "+
                                     "WHERE TYPECUSTOMERIND = "+getInd() ) ;
                break ;

             case REC_INSERT :
                stmt.executeUpdate ( "INSERT INTO PRODUCT.TYPECUSTOMER "+
                                     "VALUES ( "+getInd()+", '"+Text.cleanDBString ( toString() )+"')" ) ;
                break ;
          }


       } catch (SQLException e ) {
          sqlCode = e.getErrorCode() ;
          sqlMethod.rollBack() ;
       }

       sqlMethod.close() ;

       return ( sqlCode ) ;
    }
} /* TypeCustomerRecRec */
