package com.ibm.nzna.projects.common.quest.type ;
/*-----------------------------------------------------------*/
/*   TypeDateRecRec                                          */
/*                                                           */
/*   Description:                                            */
/*      Source code for: TypeDateRecRec                      */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.sql.* ;
import com.ibm.nzna.shared.db.* ;
import com.ibm.nzna.shared.util.* ;
/**
 * The TypeDateRecRec holds specific information about a single date 
 * in the PRODUCT.TYPEDATE table
 *
 *
 * @version 1.0, 2/28/100 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   TypeDateRec                                             */
/*                                                           */
/*-----------------------------------------------------------*/
public class TypeDateRec extends TypeRec {





    /*------------------------------------------------------------*/
    /* Constructor
     */
    /**
     *    This is the default and only constructor
     *  
     *  
     *
     *  @param typeDateInd The Indicator
     *  @param descript The description of the brand
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public TypeDateRec ( int typeDateInd, String descript ) {
        super ( typeDateInd, descript ) ;
    }



    /**
      *  This method will save this object to the database
      **/
    public int writeToDatabase() {
       int       sqlCode   = 0 ;
       SQLMethod sqlMethod = new SQLMethod ( DatabaseSystem.QUEST, "TypeDateRec.writeToDatabase", 5 ) ;

       try {
          Statement stmt = sqlMethod.createStatement() ;

          switch ( getRecStatus() ) {
             case REC_DELETE :
                stmt.executeUpdate ( "DELETE FROM PRODUCT.DATES WHERE TYPEDATEIND = "+getInd() ) ;
                stmt.executeUpdate ( "DELETE FROM PRODRAFT.DATES WHERE TYPEDATEIND = "+getInd() ) ;
                stmt.executeUpdate ( "DELETE FROM PRODUCT.TYPEDATE WHERE TYPEDATEIND = "+getInd() ) ;
                break ;

             case REC_UPDATE :
                stmt.executeUpdate ( "UPDATE PRODUCT.TYPEDATE SET DESCRIPTION = '"+Text.cleanDBString ( toString() )+"' "+
                                     "WHERE TYPEDATEIND = "+getInd() ) ;
                break ;

             case REC_INSERT :
                stmt.executeUpdate ( "INSERT INTO PRODUCT.TYPEDATE "+
                                     "VALUES ( "+getInd()+", '"+Text.cleanDBString ( toString() )+"')" ) ;
                break ;
          }


       } catch (SQLException e ) {
          sqlCode = e.getErrorCode() ;
          sqlMethod.rollBack() ;
       }

       sqlMethod.close() ;

       return ( sqlCode ) ;
    }
} /* TypeDateRecRec */
