package com.ibm.nzna.projects.common.quest.type ;
/*-----------------------------------------------------------*/
/*   TypeDocCatRec                                           */
/*                                                           */
/*   Description:                                            */
/*      Source code for: TypeDocCatRec                       */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.sql.* ;
import com.ibm.nzna.shared.db.* ;
import com.ibm.nzna.shared.util.* ;
/**
 * The TypeDocCatRec holds specific information about a document category
 *
 *
 * @version 1.0, 2/28/100 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   TypeDocCatRec                                           */
/*                                                           */
/*-----------------------------------------------------------*/
public class TypeDocCatRec extends TypeRec {





    /*------------------------------------------------------------*/
    /* Constructor
     */
    /**
     *    This is the default and only constructor
     *  
     *  
     *
     *  @param ind The DocCat Indicator
     *  @param descript The description of the brand
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public TypeDocCatRec ( int docCatInd, String descript ) {
        super ( docCatInd, descript ) ;
    }


    /**
      *  This method will save this object to the database
      **/
    public int writeToDatabase() {
       int       sqlCode   = 0 ;
       SQLMethod sqlMethod = new SQLMethod ( DatabaseSystem.QUEST, "TypeDateRec.writeToDatabase", 5 ) ;

       try {
          Statement stmt = sqlMethod.createStatement() ;

          switch ( getRecStatus() ) {
             case REC_DELETE :
                stmt.executeUpdate ( "DELETE FROM TIGRIS.TYPEDOCCAT WHERE DOCCATIND = "+getInd() ) ;
                break ;

             case REC_UPDATE :
                stmt.executeUpdate ( "UPDATE TIGRIS.TYPEDOCCAT SET CHANGEDTIME = CURRENT TIMESTAMP, DESCRIPT = '"+Text.cleanDBString ( toString() )+"' "+
                                     "WHERE DOCCATIND = "+getInd() ) ;
                break ;

             case REC_INSERT :
                stmt.executeUpdate ( "INSERT INTO TIGRIS.TYPEDOCCAT "+
                                     "VALUES ( "+getInd()+", 1, '"+Text.cleanDBString ( toString() )+"', USER, CURRENT TIMESTAMP)" ) ;
                break ;
          }


       } catch (SQLException e ) {
          sqlCode = e.getErrorCode() ;
          e.printStackTrace() ;
          sqlMethod.rollBack() ;
       }

       sqlMethod.close() ;

       return ( sqlCode ) ;
    }

} /* TypeDocCatRec */
