package com.ibm.nzna.projects.common.quest.type ;
/*-----------------------------------------------------------*/
/*   TypeGroupRec                                            */
/*                                                           */
/*   Description:                                            */
/*      Source code for: TypeGroupRec                        */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * The TypeGroupRec holds specific information about a single group (family)
 *
 *
 * @version 1.0, 2/28/100 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   TypeGroupRec                                            */
/*                                                           */
/*-----------------------------------------------------------*/
public class TypeGroupRec extends TypeRec {



   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Variables                                               */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private int brandGroupInd     = 0 ;
   private int brandInd          = 0 ;



   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This is the default and only constructor
    *  
    *  
    *
    *  @param ind The Group Indicator
    *  @param descript The description of the brand
    *  @param brandGroupInd The Brand Group Indicator that this group represents
    *  @param brandInd THe brand indicator that goes with the BrandGroup Indicator
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public TypeGroupRec ( int authInd, String descript, int brandGroupInd, int brandInd ) {
      super ( authInd, descript ) ;
      this.brandInd      = brandInd ;
      this.brandGroupInd = brandGroupInd ;
   }





   /*------------------------------------------------------------*/
   /* getBrandGroupInd
    */
   /**
    *    This method will return the brand group indicator
    *  that this group rec belongs to
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return int
    *//*---------------------------------------------------------*/
   public int getBrandGroupInd () {
      return( brandGroupInd ) ;
   }





   /*------------------------------------------------------------*/
   /* getBrandInd
    */
   /**
    *    This method will return the brand indicator
    *  that is associated with the Brand Group Indicator
    *  that this record's group represents
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return int
    *//*---------------------------------------------------------*/
   public int getBrandInd () {
      return( brandInd ) ;
   }
} /* TypeGroupRec */
