package com.ibm.nzna.projects.common.quest.type ;
/*-----------------------------------------------------------*/
/*   TypeListListener                                        */
/*                                                           */
/*   Description:                                            */
/*      Source code for: TypeListListener                    */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * The TypeList refreshes lists in a thread. When you ask the TypeList
 * object to refresh a GUI list control, that is also done in a thread. This
 * Listener will be called when the list has been refreshed
 *
 *
 * @version 1.0, 3/15/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   TypeListListener                                        */
/*                                                           */
/*-----------------------------------------------------------*/
public interface TypeListListener {




   /*------------------------------------------------------------*/
   /* listRefreshed
    */
   /**
    *    Called once the previous call to 'refershList'
    *  has completed
    *  
    *
    *  @param typeList The type list that was refreshed
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public abstract void listRefreshed ( int typeList ) ;
} /* TypeListListener */
