package com.ibm.nzna.projects.common.quest.type ;                             
/*-----------------------------------------------------------*/
/*   TypeListStatusListener                                  */
/*                                                           */
/*   Description:                                            */
/*      Source code for: TypeListStatusListener              */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This listener will be notified of status events from the TypeList object 
 *
 *
 * @version 1.0, 3/24/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   TypeListStatusListener                                  */
/*                                                           */
/*-----------------------------------------------------------*/
public interface TypeListStatusListener  {





   /*------------------------------------------------------------*/
   /* statusChangeBegin
    */
   /**
    *    This method will be called when the
    *  status of the TypeList object change has begin
    *  
    *
    *  @param status The new status
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public abstract void typeListStatusChangeBegin ( String status ) ;

   /*------------------------------------------------------------*/
   /* statusChangeEnd
    */
   /**
    *    This method will be called when the
    *  status of the TypeList object change is over
    *  
    *
    *  @param status The new status
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public abstract void typeListStatusChangeEnd () ;




} /* TypeListStatusListener */
