package com.ibm.nzna.projects.common.quest.type ;
/*-----------------------------------------------------------*/
/*   TypeOfferingRecRec                                      */
/*                                                           */
/*   Description:                                            */
/*      Source code for: TypeOfferingRecRec                  */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.sql.* ;
import com.ibm.nzna.shared.db.* ;
import com.ibm.nzna.shared.util.* ;
/**
 * The TypeOfferingRecRec holds specific information about a single date 
 * in the PRODUCT.TYPEDATE table
 *
 *
 * @version 1.0, 2/28/100 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   TypeOfferingRec                                         */
/*                                                           */
/*-----------------------------------------------------------*/
public class TypeOfferingRec extends TypeRec {





    /*------------------------------------------------------------*/
    /* Constructor
     */
    /**
     *    This is the default and only constructor
     *  
     *  
     *
     *  @param typeOfferingInd The Indicator
     *  @param descript The description of the brand
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public TypeOfferingRec ( int typeOfferingInd, String descript ) {
        super ( typeOfferingInd, descript ) ;
    }



    /**
      *  This method will save this object to the database
      **/
    public int writeToDatabase() {
       int       sqlCode   = 0 ;
       SQLMethod sqlMethod = new SQLMethod ( DatabaseSystem.QUEST, "TypeOfferingRec.writeToDatabase", 5 ) ;

       try {
          Statement stmt = sqlMethod.createStatement() ;

          switch ( getRecStatus() ) {
             case REC_DELETE :
                stmt.executeUpdate ( "UPDATE PRODUCT.PRODUCT SET TYPEOFFERINGIND = 0 WHERE TYPEOFFERINGIND = "+getInd() ) ;
                stmt.executeUpdate ( "UPDATE PRODRAFT.PRODUCT SET TYPEOFFERINGIND = 0 WHERE TYPEOFFERINGIND = "+getInd() ) ;
                stmt.executeUpdate ( "DELETE FROM PRODUCT.TYPEOFFERING WHERE TYPEOFFERINGIND = "+getInd() ) ;
                break ;

             case REC_UPDATE :
                stmt.executeUpdate ( "UPDATE PRODUCT.TYPEOFFERING SET DESCRIPTION = '"+Text.cleanDBString ( toString() )+"' "+
                                     "WHERE TYPEOFFERINGIND = "+getInd() ) ;
                break ;

             case REC_INSERT :
                stmt.executeUpdate ( "INSERT INTO PRODUCT.TYPEOFFERING "+
                                     "VALUES ( "+getInd()+", '"+Text.cleanDBString ( toString() )+"')" ) ;
                break ;
          }


       } catch (SQLException e ) {
          sqlCode = e.getErrorCode() ;
          sqlMethod.rollBack() ;
       }

       sqlMethod.close() ;

       return ( sqlCode ) ;
    }
} /* TypeOfferingRecRec */
