package com.ibm.nzna.projects.common.quest.type ;
/*-----------------------------------------------------------*/
/*   TypeProductRecRec                                       */
/*                                                           */
/*   Description:                                            */
/*      Source code for: TypeProductRec                      */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.sql.* ;
import com.ibm.nzna.shared.db.* ;
import com.ibm.nzna.shared.util.* ;
/**
 * The TypeProductRecRec holds specific information about a single date 
 * in the PRODUCT.TYPEDATE table
 *
 *
 * @version 1.0, 2/28/100 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   TypeProductRec                                          */
/*                                                           */
/*-----------------------------------------------------------*/
public class TypeProductRec extends TypeRec {





    /*------------------------------------------------------------*/
    /* Constructor
     */
    /**
     *    This is the default and only constructor
     *  
     *  
     *
     *  @param typeProductInd The Indicator
     *  @param descript The description of the brand
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public TypeProductRec ( int typeProductInd, String descript ) {
        super ( typeProductInd, descript ) ;
    }



    /**
      *  This method will save this object to the database
      **/
    public int writeToDatabase() {
       int       sqlCode   = 0 ;
       SQLMethod sqlMethod = new SQLMethod ( DatabaseSystem.QUEST, "TypeProductRec.writeToDatabase", 5 ) ;

       try {
          Statement stmt = sqlMethod.createStatement() ;

          switch ( getRecStatus() ) {
             case REC_DELETE :
                stmt.executeUpdate ( "UPDATE PRODUCT.PRODUCT SET TYPEPRODUCTIND = 0 WHERE TYPEPRODUCTIND = "+getInd() ) ;
                stmt.executeUpdate ( "UPDATE PRODRAFT.PRODUCT SET TYPEPRODUCTIND = 0 WHERE TYPEPRODUCTIND = "+getInd() ) ;
                stmt.executeUpdate ( "DELETE FROM PRODUCT.TYPEPRODUCT WHERE TYPEPRODUCTIND = "+getInd() ) ;
                break ;

             case REC_UPDATE :
                stmt.executeUpdate ( "UPDATE PRODUCT.TYPEPRODUCT SET DESCRIPTION = '"+Text.cleanDBString ( toString() )+"' "+
                                     "WHERE TYPEPRODUCTIND = "+getInd() ) ;
                break ;

             case REC_INSERT :
                stmt.executeUpdate ( "INSERT INTO PRODUCT.TYPEPRODUCT "+
                                     "VALUES ( "+getInd()+", '"+Text.cleanDBString ( toString() )+"')" ) ;
                break ;
          }



       } catch (SQLException e ) {
          sqlCode = e.getErrorCode() ;
          sqlMethod.rollBack() ;
       }

       sqlMethod.close() ;

       return ( sqlCode ) ;
    }
} /* TypeProductRecRec */
