package com.ibm.nzna.projects.common.quest.type ;
/*-----------------------------------------------------------*/
/*   TypeStatusRec                                           */
/*                                                           */
/*   Description:                                            */
/*      Source code for: TypeStatusRec                       */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * The TypeStatusRec holds specific information about a single Status
 *
 *
 * @version 1.0, 2/28/100 
 * @statusor  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   TypeStatusRec                                           */
/*                                                           */
/*-----------------------------------------------------------*/
public class TypeStatusRec extends TypeRec {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private int statusType = 0 ;




   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This is the default and only constructor
    *  
    *  
    *
    *  @param ind The Status Indicator
    *  @param descript The description of the brand
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public TypeStatusRec ( int statusInd, int statusType, String descript ) {
      super ( statusInd, descript ) ;
      setStatusType ( statusType ) ;
   }




   /*------------------------------------------------------------*/
   /* setStatusType
    */
   /**
    *    This method will set what status type this
    *  is. currently the only  valid  values are 1 and 2.
    *  1 being a Document Status, and 2 being a product status
    *
    *  @param statusType The type of status
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setStatusType ( int statusType ) {
      this.statusType = statusType ;
   }




   /*------------------------------------------------------------*/
   /* getStatusType
    */
   /**
    *    this method will return the type of status
    *  that this record represents
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return int 1 = Document Status, 2 = Product Status
    *//*---------------------------------------------------------*/
   public int getStatusType () {
      return( statusType ) ;
   }


} /* TypeStatusRec */
