package com.ibm.nzna.projects.common.quest.type ;
/*-----------------------------------------------------------*/
/*   TypeTeamRec                                             */
/*                                                           */
/*   Description:                                            */
/*      Source code for: TypeTeamRec                         */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * The TypeTeamRec holds specific information about a single team in TIGRIS.USERGROUP
 *
 *
 * @version 1.0, 2/28/100 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   TypeTeamRec                                             */
/*                                                           */
/*-----------------------------------------------------------*/
public class TypeTeamRec extends TypeRec {

   static final long serialVersionUID = 1000000 ;

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private String longDescript = null ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This is the default and only constructor
    *  
    *  
    *
    *  @param ind The Team Indicator
    *  @param descript The description of the brand
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public TypeTeamRec ( int authInd, String descript, String longDescript ) {
      super ( authInd, descript ) ;
      setLongDescript ( longDescript ) ;
   }





   /*------------------------------------------------------------*/
   /* getLongDescript
    */
   /**
    *    This method will return the long description
    *  of this team
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public String getLongDescript () {
      return( longDescript ) ;
   }





   /*------------------------------------------------------------*/
   /* setLongDescript
    */
   /**
    *    This method will set the long description
    *  of this team
    *  
    *
    *  @param longDescript The new long description
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setLongDescript ( String longDescript ) {
      this.longDescript = longDescript ;
   }


   public String toString() {
      return ( longDescript ) ;
   }


   public String getShortDescript ( ) {
      return ( getDescript() ) ;
   }
} /* TypeTeamRec */
