package com.ibm.nzna.projects.common.quest.type ;
/*-----------------------------------------------------------*/
/*   TypeWarrantyRec                                         */
/*                                                           */
/*   Description:                                            */
/*      Source code for: TypeWarrantyRec                     */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.sql.* ;
import com.ibm.nzna.shared.db.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.shared.gui.* ;
/**
 * The TypeWarrantyRecRec holds specific information about a single date 
 * in the PRODUCT.TYPEDATE table
 *
 *
 * @version 1.0, 2/28/100 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   TypeWarrantyRec                                         */
/*                                                           */
/*-----------------------------------------------------------*/
public class TypeWarrantyRec extends TypeRec implements MultiListRow {



   /**
     * This is the long description
     **/
   private String longDescription = null ;


   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This is the default and only constructor
    *  
    *  
    *
    *  @param typeWarrantyInd The Indicator
    *  @param descript The description of the brand
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public TypeWarrantyRec ( int typeWarrantyInd, String descript ) {
      super ( typeWarrantyInd, descript ) ;
   }



   /**
     *  This method will save this object to the database
     **/
   public int writeToDatabase() {
      int       sqlCode   = 0 ;
      SQLMethod sqlMethod = new SQLMethod ( DatabaseSystem.QUEST, "TypeWarrantyRec.writeToDatabase", 5 ) ;

      try {
         Statement stmt = sqlMethod.createStatement() ;

         switch ( getRecStatus() ) {
            case REC_DELETE :
               stmt.executeUpdate ( "UPDATE PRODUCT.PRODUCT SET TYPEWARRANTYIND = 0 WHERE TYPEWARRANTYIND = "+getInd() ) ;
               stmt.executeUpdate ( "UPDATE PRODRAFT.PRODUCT SET TYPEWARRANTYIND = 0 WHERE TYPEWARRANTYIND = "+getInd() ) ;
               stmt.executeUpdate ( "DELETE FROM PRODUCT.TYPEWARRANTY WHERE TYPEWARRANTYIND = "+getInd() ) ;
               break ;

            case REC_UPDATE :
               stmt.executeUpdate ( "UPDATE PRODUCT.TYPEWARRANTY "+
                                    "SET DESCRIPTION  = '"+Text.cleanDBString ( toString() )+"', "+
                                    "    LONGDESCRIPT = '"+Text.cleanDBString ( longDescription )+"' "+       
                                    "WHERE TYPEWARRANTYIND = "+getInd() ) ;
               break ;

            case REC_INSERT :
               stmt.executeUpdate ( "INSERT INTO PRODUCT.TYPEWARRANTY "+
                                    "VALUES ( "+getInd()+", '"+Text.cleanDBString ( toString() )+"', '"+Text.cleanDBString (longDescription)+"')" ) ;
               break ;
         }


      } catch ( SQLException e ) {
         sqlCode = e.getErrorCode() ;
         sqlMethod.rollBack() ;
      }

      sqlMethod.close() ;

      return( sqlCode ) ;
   }


   public Object getColumnData ( int column ) {
      switch ( column ) {
         case 0 :
            return (""+getInd() );

         case 1 :
            return( toString() ) ;

         case 2 :
            return( longDescription ) ;

         default:
            return ( "" ) ;
      }
   }


   public void setLongDescription ( String longDescription )  {
      this.longDescription = longDescription ;
   }


   public String getLongDescription ( ) {
      return ( longDescription ) ;
   }
} /* TypeWarrantyRecRec */
