package com.ibm.nzna.projects.firewalker.base;

/*********************************************************
* <b><font color="maroon">Description:</b></font>
* HTTPData object contains data which is transported by a 
* MQSeries message.  The data contained within this object
# is the HTML output of a cgi or servlet call.
*
* <p><b><font color="olive">Legal:</b></font> Copyright (c) 1998 IBM. All Rights Reserved.
* <p><b><font color="teal">Created:</b></font> 5/24/1999  2:01pm
* @author Chad Meadows
* @version
*********************************************************/

import java.io.* ;
import java.util.* ;

public class HTTPData extends Object implements Serializable {
   private int contentLength = 0;
   private String contentType = null;
   private String htmlOutput = null ;
   private String[][] responseHeaders = null ;

   /*********************************************************
   * <b><font color="maroon">Description:</b></font>
   * setHtmlOutput set the value of the html
   *
   * <p><b><font color="teal">Author:</b></font> <i>Chad Meadows</i>
   * <p><b><font color="teal">Created:</b></font> 5/26/1999  1:24pm
   * @param
   * @return
   *********************************************************/
   public void setHTMLOutput ( String htmlOutput ) {
      this.htmlOutput = htmlOutput ;
   }

   /*********************************************************
   * <b><font color="maroon">Description:</b></font>
   * getHtmlOutput get the value of the html data.
   *
   * <p><b><font color="teal">Author:</b></font> <i>Chad Meadows</i>
   * <p><b><font color="teal">Created:</b></font> 5/26/1999  1:26pm
   * @param
   * @return
   *********************************************************/
   public String getHTMLOutput () {
      return  this.htmlOutput;
   }

   public void setContentType (String contentType) {
      this.contentType = contentType;
   }

   public String getContentType () {
      return  this.contentType;
   }

   public void setContentLength (int contentLength) {
      this.contentLength = contentLength;
   }

   public int getContentLength () {
      return  this.contentLength;
   }

   public void setResponseHeaders(String[][] responseHeaders)
   {
      this.responseHeaders = responseHeaders;
   }

   public String[][] getResponseHeaders()
   {
      return this.responseHeaders;
   }
}
