package com.ibm.nzna.projects.firewalker.invoker ;
import java.util.* ;
import java.io.* ;
import java.net.* ;

   /*********************************************************
   * <b><font color="maroon">Description:</b></font>
   * This class provides an access control list based on URL's
   *
   * <p><b><font color="olive">Legal:</b></font> Copyright (c) 1998 IBM. All Rights Reserved.
   * <p><b><font color="teal">Created:</b></font> 8/11/1999  1:31pm
   * @author Chad Meadows
   * @version
   *********************************************************/
public class UrlAcl {
   Vector urlAuthList = new Vector() ;
   /*********************************************************
   * <b><font color="maroon">Description:</b></font>
   * Loads an ACL from the inputStream provided.
   *
   * <p><b><font color="teal">Author:</b></font> <i>Chad Meadows</i>
   * <p><b><font color="teal">Created:</b></font> 8/11/1999  1:33pm
   * @param
   * @return
   *********************************************************/
   public void load ( InputStream in ) throws IOException , MalformedURLException {
      InputStreamReader isr               = new InputStreamReader( in ) ;
      BufferedReader    bufferedReader    = new BufferedReader ( isr ) ;
      String            inputLineString   = null ;

      /* Empty the current ACL list */
      urlAuthList = new Vector() ;

      /* Read each line of the input stream   */
      /* a line beginning with # is a comment */
      /* each line is a URL.                  */
      while ( (inputLineString = bufferedReader.readLine()) != null ) {
         /* If this is not a comment, create a URL */
         if (!(inputLineString.startsWith("#"))) {
            urlAuthList.addElement ( new URL( inputLineString )) ;
         }
      }
   }
   /*********************************************************
   * <b><font color="maroon">Description:</b></font>
   * Checks to see if this url is authorized.
   *
   * <p><b><font color="teal">Author:</b></font> <i>Chad Meadows</i>
   * <p><b><font color="teal">Created:</b></font> 8/11/1999  2:09pm
   * @param
   * @return
   *********************************************************/
   public boolean isAuthorized ( URL url ) {
      /* We default to true, if the ACL is empty all is authorized */
      boolean authorized = true ;
      Enumeration authList = urlAuthList.elements() ;
      while ( authList.hasMoreElements() ) {
         /* set authorized to false.  We have a list we must check */
         authorized = false ;
         URL authorizedURL = (URL) authList.nextElement() ;
         /* The host must be the same */
         if ( url.getHost().equalsIgnoreCase( authorizedURL.getHost() )) {
            /* Compare the path of the url                         */
            /* The url must contain the path of the authorized url */
            if ( (url.getFile().toUpperCase().indexOf( authorizedURL.getFile().toUpperCase())) != -1 ) {
               authorized = true ;
               break ;
            }
         }
      }
      return ( authorized ) ;
   }
   public boolean isAuthorized ( String url ) throws MalformedURLException {
      return ( isAuthorized(new URL (url )) ) ;
   }
}
