package com.ibm.nzna.projects.ftpsync ;  
/*-----------------------------------------------------------*/
/*   FTPCleanup                                              */
/*                                                           */
/*   Description:                                            */
/*      Source code for: FTPCleanup                          */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.shared.util.* ;
import java.io.* ;
import java.util.* ;
/**
 * This program simply reads the 'deleteFiles.ser' contents and
 * deserializes a Vector from it. Each String in the Vector 
 * is a filename in the incoming directory. Each of those files 
 * will be deleted. Each Filename also MUST contain the full path
 * to the file to be deleted.
 *
 *
 * @version 1.0, 10/9/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   FTPCleanup                                              */
/*                                                           */
/*-----------------------------------------------------------*/
public class FTPCleanup {





   /*------------------------------------------------------------*/
   /* main
    */
   /**
    *    This simply starts our small program
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public static void main ( String args[] ) {                
      Vector fileVec = null ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   First, read in our Vector                               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      try {
         fileVec = (Vector) FileUtil.readObjectFromDisk ( "deleteFiles.ser" ) ;

         if ( fileVec != null ) {
            int    i               = 0 ;
            int    size            = fileVec.size() ;
            String currentFilename = null ;

            while ( i < size ) {
               File file = null ;

               currentFilename = (String) fileVec.elementAt(i) ;
               System.out.println ( "Deleting "+currentFilename ) ;
               file = new File ( currentFilename ) ;
               file.delete() ;

               i++ ;
            } /* while */

         } /* if */


      } catch ( FileNotFoundException ef ) {
         System.err.println ( "Cannot find deleteFiles.ser File" ) ;
      } catch ( Exception e ) {
         e.printStackTrace() ;
      }

   }

} /* FTPCleanup */
