package com.ibm.nzna.projects.ftpsync ;

/**-----------------------------------------------------------*
 * The HDRFilter can be used to select files with a specific 
 * extension from a specific directory.
 *  ie. .hdr  for header files only
 *
 * @version 
 * @author  
 */

import java.io.* ;

/*-----------------------------------------------------------*/
/*                                                           */
/*   HDRFilter                                               */
/*                                                           */
/*-----------------------------------------------------------*/
public class HDRFilter implements FilenameFilter {

   final String EXTENSION = ".hdr" ;         
   /**
    * Tests if a specified file should be included in a file list.
    *
    * @param   dir   the directory in which the file was found.
    * @param   name  the name of the file.
    * @return  true  if the name should be included in the file
    *          list; false otherwise.
    */
   public boolean accept(File directory, String name ){

      if ( name.endsWith ( EXTENSION ) && directory.canRead() ) {
         return true ;
      }
      return false ;
   }

} // End of HDRFilter
