package com.ibm.nzna.projects.ftptest ;
/*-----------------------------------------------------------*/
/*   ftptest                                                 */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ftptest                             */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.shared.ftp.FTP.* ;
/**
 * This java program is a simply program to continually FTP
 * a file every 2 minutes to a server. The server name and filename
 * FTPed is defined in the constants section of this class
 *
 *
 * @version 1.0, 3/15/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ftptest                                                 */
/*                                                           */
/*-----------------------------------------------------------*/
public class ftptest extends Object implements Runnable {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Constants                                               */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private static final String FTP_SITE      = "f3.pc.ibm.com" ;
   private static final String FTP_USERID    = "quest" ;
   private static final String FTP_PASSWORD  = "hgra2l" ;
   private static       String FILE_NAME     = "c:\\ftptest.file" ;
   private static       String FTP_DIRECTORY = "/home/ftp/quest/incoming" ;

   private Ftp ftp = null ;




   /*------------------------------------------------------------*/
   /* main
    */
   /**
    *    This method kicks off our thread
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public static void main ( String args[] ) {
      new ftptest ( args ) ;
   }





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    Simply starts our thread
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public ftptest ( String args[] ) {
      if ( ( args != null ) && ( args[0] != null ) )
         FILE_NAME = args[0] ;

      new LogSystem ( 1, "ftptest.out" ) ;
      new Thread ( this ).start() ;
   }





   /*------------------------------------------------------------*/
   /* run
    */
   /**
    *    This method FTPs a fle and waits 2 minutes
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void run () {
      try {
         while ( true ) {
            if ( connectToFTP() ) {
               if ( ftpFile() )
                  LogSystem.log ( 1, getTimestamp()+": File Complete" ) ;
            }

            Thread.currentThread().sleep ( 120000 ) ; // Sleep for 2 minutes
         }
      } catch ( Exception e ) {
         LogSystem.log ( 1, getTimestamp()+": Exception happened" ) ;
         LogSystem.log ( 1, e, false ) ;
      }
   }

   public String getTimestamp () {
      return( new CDate ( CDate.DATE_STAMP ).today() ) ;
   }

   public boolean connectToFTP () {

      try {
         ftp = new Ftp() ;

         ftp.setHost ( FTP_SITE ) ;
         ftp.setPassword ( FTP_PASSWORD ) ;
         ftp.setUser ( FTP_USERID ) ;

         ftp.connect() ;

         if ( ftp.isConnected() ) {
            ftp.login() ;
               return( true ) ;
         }
         else
            LogSystem.log ( 1, getTimestamp()+": Cannot FTP to site. Ftp.connect() returned FALSE" ) ;

      } catch ( Exception e ) {
         LogSystem.log ( 1, getTimestamp()+": Exception happened, cannot FTP to site" ) ;
         LogSystem.log ( 1, e, false ) ;
         return( false ) ;
      }
      return( true ) ;
   }

   public boolean ftpFile () {
      try {
         if ( ftp != null ) {
            ftp.cd ( FTP_DIRECTORY ) ;
            ftp.put ( FILE_NAME ) ;
         }

         return ( true ) ;
      } catch ( Exception e ) {
         LogSystem.log ( 1, getTimestamp()+": Exception happened, cannot FTP file "+FILE_NAME ) ;
         LogSystem.log ( 1, e, false ) ;
      }

      return( false ) ;
   }
} /* ftptest */
