package com.ibm.nzna.projects.htmlProductImport ;
/*-----------------------------------------------------------*/
/*   HTMLTag                                                 */
/*                                                           */
/*   Description:                                            */
/*      Source code for: HTMLTag                             */
/*                                                           */
/*                                                           */
/*         @Copyright  1997 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This object represents a tag in an HTML Document tag. 
 *
 *
 * @version 1.0, 8/17/1998 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   HTMLTag                                                 */
/*                                                           */
/*-----------------------------------------------------------*/
public class HTMLTag extends Object {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Vars                                                    */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private String tag      = null ;
   private int    tagNum   = 0 ;
   private int    charPos  = 0 ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This will create a blank HTML Tag
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public HTMLTag () {
   } /* HTMLTag */




   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This will create an HTML tag with the string tag,
    *  the tagNum and charPos
    *  
    *
    *  @param tag The String representation of the tag
    *  @param charPos The position in the HTML Document of this tag
    *  @param tagNum The 0 based index of the tag in the HTML Doc.
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public HTMLTag ( String tag, int charPos, int tagNum ) {
      this.tag     = tag ;
      this.charPos = charPos ;
      this.tagNum  = tagNum ;
   } /* HTMLTag */




   /*------------------------------------------------------------*/
   /* getTag
    */
   /**
    *    This method will return the tag that this HTML Tag
    *  is representing
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String The Tag 
    *//*---------------------------------------------------------*/
   public String getTag ( ) {
      return( tag ) ;
   } /* getTag */




   /*------------------------------------------------------------*/
   /* getTagLowerCase
    */
   /**
    *    This method will return the tag in LowerCase.
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return tag The String representation of the tag in LowerCase
    *//*---------------------------------------------------------*/
   public String getTagLowerCase () {
      return( tag.toLowerCase() ) ;
   } /* getTagLowerCase */

   /*------------------------------------------------------------*/
   /* getTagUpperCase
    */
   /**
    *    This method will return the tag in UpperCase.
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return tag The String representation of the tag in UpperCase
    *//*---------------------------------------------------------*/
   public String getTagUpperCase () {
      return( tag.toUpperCase() ) ;
   } /* getTagUpperCase */





   /*------------------------------------------------------------*/
   /* setTag
    */
   /**
    *    This method will set the HTML Tag that this
    *  HTMLTag object is representing.
    *  
    *
    *  @param tag The new html tag
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setTag ( String tag ) {
      this.tag = tag ;
   }




   /*------------------------------------------------------------*/
   /* getCharPos
    */
   /**
    *    This method will get the character position
    *  in the HTML Document that this tag exists at.
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return int the charPos
    *//*---------------------------------------------------------*/
   public int getCharPos () {
      return( charPos ) ;
   } /* getCharPos */




   /*------------------------------------------------------------*/
   /* setCharPos
    */
   /**
    *    This method will set the character position
    *  that this HTMLTag sets at in the HTML page.
    *  
    *
    *  @param int charPos The new Character Position
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setCharPos ( int charPos ) {
      this.charPos = charPos ;
   } /* setCharPos */




   /*------------------------------------------------------------*/
   /* getTagNum
    */
   /**
    *    This method will get the tag number of this tag
    *  in the HTML Document.
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return int the tagNum
    *//*---------------------------------------------------------*/
   public int getTagNum () {
      return( tagNum ) ;
   } /* getTagNum */




   /*------------------------------------------------------------*/
   /* setTagNum
    */
   /**
    *    This method will set the tag number
    *  that this HTMLTag sets at in the HTML page.
    *  
    *
    *  @param int tagNum The new tag number
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setTagNum ( int tagNum ) {
      this.tagNum = tagNum ;
   } /* setTagNum */


   protected void free () {
      tag = null ;
   }

   public int length() {
      return( tag.length() ) ;
   }

} /* HTMLTag */
