/* OA Memory Interface: getDraftSymptomFromMemory, getDraftQuestionFromMemory, et al. */

package com.ibm.nzna.projects.oa.engine;
import java.io.*;
import java.sql.*;
import java.util.*;
import com.ibm.nzna.projects.common.quest.oa.*;
import com.ibm.nzna.projects.common.quest.type.*;
import com.ibm.nzna.projects.oa.engine.*;

/**
 * OAMemoryInterface class
 * @(#)OAMemoryInterface.java	1.0 05/21/2000
 * @author Mike Rychener, IBM IGS for PSG Helpcenter (stubs only, to be part of Quest Input Tool)
 **/

/* specs 
 *
 * provides object access from QIT memory similar to access from OA Draft database
 * instace of this will be passed into LogicAPI via OASubmitVars, q.v.
 *
 */

/* HISTORY
 *  08/03  mdr  created stub methods
 *          --> TO DO:
 * END HISTORY
 *
 * AGENDA
 * END AGENDA
 */

/**********************************************************************
 * Methods for accessing Quest Input Tool object memory during editing.
 * 
 * @author Mike Rychener
 * @version 1.0
 **********************************************************************/
public class OAMemoryInterface {

    /*************************************
     * new OAMemoryInterface is used to give LogicAPI, OAEngine and DBAPI access to QIT memory.
     *************************************/
    public OAMemoryInterface() {
        // = constructor

    }  // end constructor method        

    /**********************************************************************
     * Get an action from QIT Memory, if it exists.
     * @param aInd int - an action indicator
     * @param langId int - a language indicator.
     * @return Action
     **********************************************************************/
    public Action getDraftActionFromMemory(int aInd, int langId) {

        return null;

    }  // end getDraftActionFromMemory

    /**********************************************************************
     * Get a question from QIT Memory, if it exists.
     * @param qInd int - a question indicator
     * @param langId int - a language indicator.
     * @return Question
     **********************************************************************/
    public Question getDraftQuestionFromMemory(int qInd, int langId) {

        return null;

    }  // end getDraftQuestionFromMemory

    /**********************************************************************
     * Get a symptom from QIT Memory, if it exists.
     * @param symInd int - a symptom indicator
     * @param langId int - a language indicator.
     * @return Symptom
     **********************************************************************/
    public Symptom getDraftSymptomFromMemory(int symInd, int langId) {

        return null;

    }  // end getDraftSymptomFromMemory

    /**********************************************************************
     * Get edges from Memory for a current symptom, node, and response.
     * @param s Symptom - a symptom
     * @param cn int - current node
     * @param cr int - current response
     * @return Hashtable - edges
     **********************************************************************/
    public Hashtable getEdgesForMemoryNodeAndAnswer(Symptom s, int cn, int cr) {

        return null;

    }
    
    /**********************************************************************
     * Get an action indicator for an edge list from QIT Memory, if it exists.
     * @param ealist EdgeAlist
     **********************************************************************/
    public int getMemoryActionInd(EdgeAlist ealist) {

        return 0;

    }  // end getMemoryActionInd

    /**********************************************************************
     * Get answer indicator from QIT Memory, if EdgePreanswer exists.
     * @param ans EdgePreanswer
     **********************************************************************/
    public int getMemoryAnswerInd(EdgePreanswer ans) {

        return 0;

    }  // end getMemoryAnswerInd

    /**********************************************************************
     * Get a node indicator from QIT Memory, if node exists.
     * @param Node node
     **********************************************************************/
    public int getMemoryObjectInd(Node node) {

        return 0;

    }  // end getMemoryObjectInd

    /**********************************************************************
     * Get question indicator from QIT Memory, if EdgePreanswer exists.
     * @param EdgePreanswer ques
     **********************************************************************/
    public int getMemoryPreQuestionInd(EdgePreanswer ques) {

        return 0;

    }  // end getMemoryPreQuestionInd

    /**********************************************************************
     * Get question indicator from QIT Memory, if EdgeUnanswer exists.
     * @param EdgeUnanswer ques
     **********************************************************************/
    public int getMemoryUnQuestionInd(EdgeUnanswer ques) {

        return 0;

    }  // end getMemoryUnQuestionInd

}  // end class OAMemoryInterface

