/* Object returned from OA methods */

package com.ibm.nzna.projects.oa.engine;
import java.io.*;
import java.util.*;
import com.ibm.nzna.projects.common.quest.oa.*;

/*********************************************************************
 * Variables that are passed from OAEngine thru LogicAPI to the user.
 *
 *********************************************************************/

public class OAReturnVars implements Serializable,Cloneable {

    public String node_flag = "";
    public String title = "";
    public String addInfo = "";
    public Vector answerTitles = new Vector(10, 10);  // added 2 June (mdr) -- several vectors
    public Vector answerInds = new Vector(10, 10);
    public Vector actionTitles = new Vector(10, 10);
    public Vector actionInds = new Vector(10, 10);  // added 5 June (mdr) -- one more vector
    public Vector linkTitles = new Vector(10, 10);
    public Vector linkURLs = new Vector(10, 10);  // links are either external URL or tigris docind
    public int sessionInd = 0;
    public int sessionSeqNo = 0;
    public int nodeInd = 0;
    public int objectInd = 0;
    // OUT (23 Aug) public boolean qit_flag = false;

    public OAReturnVars(int sessid) {
        // dummy object creation
        this.sessionInd = sessid;
    }

    /**
     * Returns a string representation of this object suitable
     * for display on an HTML capable device.
     *
     * @return String An HTML String representation of this object.
     */
    public String toString() {

        String sret = "<p><p><b>Return Vars Object = </b>" + "<br>\n";
        sret += "  Title: " + title + "<br>\n";
        if (answerTitles != null && answerTitles.size() > 0) {
            sret += "  Answers: " + answerTitles.toString() + "<br>\n";
        }
        if (answerInds != null && answerInds.size() > 0) {
            sret += "  Answer inds: " + answerInds.toString() + "<br>\n";
        }
        if (linkTitles != null && linkTitles.size() > 0) {
            sret += "  Link titles: " + linkTitles.toString() + "<br>\n";
        }
        if (linkURLs != null && linkURLs.size() > 0) {
            sret += "  Link URLs: " + linkURLs.toString() + "<br>\n";
        }
        if (actionTitles != null && actionTitles.size() > 0) {
            sret += "  Actions: " + actionTitles.toString() + "<br>\n";
        }
        sret += "  Additional Info: " + addInfo + "<br>\n";
        sret += "  Session Indicator: " + sessionInd + "<br>\n";
        sret += "  Session Sequence #: " + sessionSeqNo + "<br>\n";
        sret += "  Node Indicator: " + nodeInd + "<br>\n";
        sret += "  Node Flag: " + node_flag + "<br>\n";
        sret += "  Object Indicator: " + objectInd + "<br>\n";
        // OUT (23 Aug) sret += "  QIT Flag: " + qit_flag + "<br>\n";

        return sret;
    }

}  // end OAReturnVars class

