package com.ibm.nzna.projects.oa.viewport.filter ;
import javax.servlet.* ;
import javax.servlet.http.* ;
import java.io.* ;
import java.net.* ;
import java.util.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.shared.servlet.* ;
import com.ibm.nzna.shared.servlet.contentmodule.* ;
import com.ibm.nzna.shared.servlet.filter.* ;
   /*********************************************************
   * Remaps the server name to the name specified.
   *
   * Legal: Copyright (c) 2000 IBM. All Rights Reserved.
   * Created: 4/14/100  5:50pm
   * @author 
   * @version
   * @see ViewPortFilterManager
   *********************************************************/
public class DocLinkFilter implements ContentFilter {
   Properties  properties         = null ;
   String      docLinkTag         = "###doclink###/" ;
   String      docClassKey        = "docclass" ;
   String      urlEsupport        = "" ;
   String      urlInfotips        = "" ;
   String      urlBusinessPartner = "" ;
   String      urlEsupportKey        = "doclink.path.esupport" ;
   String      urlInfotipsKey        = "doclink.path.infotips" ;
   String      urlBusinessPartnerKey = "doclink.path.businesspartner" ;

      /*********************************************************
   * Initialize the input class.  This is provided for classes
   * which may need some prior initialization for efficiency.
   * This would be database connections or other similar tasks.
   * 
   *
   * Author:  
   * Created: 4/19/100  12:38pm
   * @param The properties object.
   * 
   * @return
   *********************************************************/
   public void init( Properties properties ) {
      try {
         this.properties = properties ;
         String preFixTag = "<a href=" ;
         /* Set the url values */
         urlEsupport          = preFixTag + properties.getProperty( urlEsupportKey ) ;
         urlInfotips          = preFixTag + properties.getProperty( urlInfotipsKey ) ;
         urlBusinessPartner   = preFixTag + properties.getProperty( urlBusinessPartnerKey ) ;
         /* Remove extra slash at the end */
         //urlEsupport = urlEsupport.substring(0, urlEsupport.length() - 1) ;
         //urlInfotips = urlInfotips.substring(0, urlInfotips.length() - 1) ;
         //urlBusinessPartner = urlBusinessPartner.substring(0, urlBusinessPartner.length() - 1) ;
      }
      catch ( Exception e ) {
         System.err.println( e ) ;
      }
   }

   /*********************************************************
   * Applies a filter to the input string and returns a String
   * result.
   * 
   *
   * Author:  
   * Created: 4/14/100  5:52pm
   * @param
   * @return
   *********************************************************/
   public String filter ( String inputData, SessionState sessionState ) {
      String content = "" ;
      /* Get the DocClass to determine the substitution for the doclinks   */
      /* This should later be changed to the site variable when implemented*/
      HttpRequest httpRequest = sessionState.getRequest() ;
      String value = httpRequest.getParameter( docClassKey ) ;
      /* If no value is passed default to value 3 unclassified for eSupport */
      if (value == null) {
         value = "3" ;
      }
      if ( value.equals("1")) {
         content = RegularExpression.substitute( docLinkTag , urlInfotips , inputData) ;
      }
      else if ( value.equals("2")) {
         content = RegularExpression.substitute( docLinkTag , urlBusinessPartner , inputData) ;
      }
      else {
         content = RegularExpression.substitute( docLinkTag , urlEsupport , inputData) ;
      }
      return ( content ) ;
   }
}
