package com.ibm.nzna.projects.oa.web;

import java.util.*;
import java.util.zip.*;
import java.io.*;
import java.net.*;
import java.sql.*;
import javax.mail.*;
import javax.mail.internet.*;
import com.ibm.nzna.projects.common.quest.oa.*;
import com.ibm.nzna.projects.common.quest.type.*;
import com.ibm.nzna.shared.db.*;      // DatabaseSystem
import com.ibm.nzna.shared.mail.*;      //Mail 
import com.ibm.nzna.shared.util.*;    // RegularExpression, LogSystem, Text
import com.ibm.nzna.shared.servlet.template.*;      //ResourceTemplateLoader
import com.ibm.nzna.projects.common.legacy.Pagegen;  //Pagegen needed for encryption
import com.ibm.nzna.shared.servlet.*;

/* HISTORY
 *
 *  09/06  tlaw  Created based on DBAPI.java, Mail.java and Pagegen to convert the
 *                current rickUnresolved.C C++ program into Java.
 *
 * END HISTORY
 */

/*********************************************************
 * This Class was created based on DBAPI.java and Mail.java to convert the
 * current rickUnresolved C++ program(s) into Java.
 * The class directly interfaces with the database to get the customer's
 * information.  It also handles the connection creation to the
 * clio database.
 *
 * Legal: Copyright (c) 2000 IBM. All Rights Reserved.
 * Created: 09/06/2000
 * @author  Tracey Watkins
 * @version 1.0
 *********************************************************/

public class OAUnresolved {

    public static String dbName     = "";       // Database name to connect
    public static String server     = "";       //The server name on which database sits
    public static String port       = "";       // port number to connect to database
    public static String uid        = "";       //userid to connect
    public static String pw         = "";       //passwd to connect
    private static int ESUPPORT     = 3;        //Cooresponds to docClassInd 3 (Unclassified)
    private static int BPARTNER     = 2;        //Cooresponds to docClassInd 2 (Dealer Confidntial)
    private static int INFOTIPS     = 1;        //Cooresponds to docClassInd 1 (Confidential)
    private static String TMPSPATH  = "com/ibm/nzna/templates/oa/"; //Path housing the oa templates

//    private static String PRODRECIP = "elecqaus@us.ibm.com";
//    private static String TESTRECIP = "eqa@us.ibm.com";
//    private static String TSTRECPCC = "tracey@us.ibm.com,rychener@us.ibm.com";
//    private static String DEBUGRECP = "tracey@us.ibm.com,rychener@us.ibm.com";
    
    private String PRODRECIP = "";              //Production mail recipients
    private String TESTRECIP = "";              //Testing mail recipients
    private String TSTRECPCC = "";              //Testing mail cc recipients
    private String DEBUGRECP = "";              //Debugging mail recipients
    private boolean appDriver = false;          //AppDriver if true, otherwise NetDriver

    boolean Debug                   = true;
    private String custNum          = "";       //Customer number passed from WebRenderer
    private String brand            = "";       //Customer's brand passed from WR
    private String mtmdl            = "";       //Customer's machine type and model from WR
    private String history          = "";       //OA Session history
    private String sympTitle        = "";       //Symptom title passed from WebRenderer
    private int symptomInd          = 1;        //OA symptom indicator  (default is 1)
    private Vector histVec          = new Vector(); //OA Session history Vector from WR
    private int docClassInd         = 3;        //DocClassInd (default to 3--eSupport)
    private Mail mail               = null;
    private Customer customer       = null;
    private String subject          = "Subject:New Problem<###Country### ###Brand###>";
    private String  queryStr          = "";     //OA Query String to customer's personal support page
    private String  imagesPath      = "";       //Path to the images directory for the site
    private String  baseServlet     = "";       //Path and name of the site's home servlet
    private String  oaServlet       = "";       //Path and name of the site's OA serlvet (redirected)
    private String  htmlStr         = "";       //Current HTML in String format

    /**
    *   This class holds a Customer record. <p>
    *
    *   @version 1.0 09/07/2000
    *   @author Tracey Watkins
    *
    */
    class Customer
    {
        String custNum = "";      //Customer number
        String fname = "";        //Customer's first name
        String lname = "";        //Customer's last name
        String emailaddr = "";    //Customer's last name
        String country = "";      //Customer's country
        String countrycode = "";  //Customer's country code
        String geo = "";          //Customer's geography
        String profileqind = "";  //Customer's profile ind
        String machine = "";      //Customer's machine type
        String phone = "";        //Customer's phone number from the database
        String model = "";        //Customer's model
        String brand = "";        //Customer's brand
        String group = "";        //Customer's group
        String message = "";      //Customer's message from submitted form
        String company = "";      //Customer's company from submitted form  (BP only)
        boolean tech = false;       //Customer's location has on site technician from submitted form (BP only)

        /**
        *   This method returns all of the elements as a String value. <p>
        *
        *   @param None
        *
        *   @return String of customer information
        *
        */
        public String toString() {
            Boolean tmpB = new Boolean(this.tech);
            String str = "\nCustomer number = " + custNum +
                         "\nFirst name = " + fname +
                         "\nLast name = " + lname +
                         "\nEmail address = " + emailaddr +
                         "\nCountry = " + country +
                         "\nCountry code = " + this.countrycode +
                         "\nGeography = " + geo +
                         "\nProfile id = " + profileqind +
                         "\nMachine type = " + machine +
                         "\nModel = " + model +
                         "\nPhone = " + phone +
                         "\nBrand = " + brand +
                         "\nGroup = " + group +
                         "\nCompany = " + company +
                         "\nTech on site = " + tmpB.toString() +
                         "\n\nProblem = \n" + message;
            return str;
        } //method Customer.toString()
        
        
        /**
        *   This method returns all of the elements as a String value. <p>
        *
        *   @param None
        *
        *   @return String of customer information
        *
        */
        public String toString4Mail() {
            Boolean tmpB = new Boolean(this.tech);
            String str = "\nCustomer number = " + custNum +
                         "\nFirst name = " + fname +
                         "\nLast name = " + lname +
                         "\nEmail address = " + emailaddr +
                         "\nPhone = " + phone +
                         "\nCountry = " + country +
                         "\nGeography = " + geo;
            if (docClassInd == BPARTNER)
            {
                str +=   "\nCompany = " + company +
                         "\nTech On Site = " + tmpB;
            }
             str +=      "\nBrand = " + brand +
                         "\nMachine type = " + machine +
                         "\nModel = " + model +
                         "\n\nProblem = \n" + message;
            return str;
        } //method Customer.toString()
    
    } //class Customer


    /* Constructor */
    public OAUnresolved (String cid, int sympInd, String sympTitle, int docClassInd,
                         String brand, String country, String mtmdl, Vector histVec, 
                         boolean appDriver, String imagesPath, String baseServlet, 
                         String oaServlet, String queryStr) {

        try {
            custNum = cid;
            this.brand = brand;
            symptomInd = sympInd;
            this.histVec = histVec;
            this.sympTitle = sympTitle;
            this.mtmdl = mtmdl;
            this.docClassInd = docClassInd;
            this.queryStr = queryStr;
            this.appDriver = appDriver;
            this.baseServlet = baseServlet;
            this.oaServlet = oaServlet;
            this.imagesPath = imagesPath;

            //initialize the customer object with data passed from WebRenderer
            customer = new Customer();
            customer.brand = this.brand;
            customer.custNum = this.custNum;
            customer.country = country;
            if (this.mtmdl.indexOf("-") > 0) {
                customer.machine = this.mtmdl.substring(0, this.mtmdl.indexOf("-"));
                customer.model = this.mtmdl.substring(this.mtmdl.indexOf("-")+1);
            }
            else {
                customer.machine = this.mtmdl.substring(0, 3);
                customer.model = this.mtmdl.substring(4);
            }

            boolean loaded;
            String path = StandardPropertyLoader.getPath();
            String propsPath = ("/com/ibm/nzna/properties/oa/");
            LogSystem.log(10, "OAUnresolved:  " +propsPath + "WebDaemon.properties");
            Properties props = StandardPropertyLoader.load(propsPath +"WebDaemon.properties");
            if (props.isEmpty()) {
                loaded = false;
                LogSystem.log(10, "OAUnresolved:  props file empty.");
                LogSystem.log(10, "OAUnresolved:  props file=  " + props.toString());
            }
            else {
                loaded = true;
                LogSystem.log(10, "OAUnresolved:  props file not empty.");
            }
            LogSystem.log(10, "OAUnresolved:  loaded WebDaemon.properties? " + loaded);
            LogSystem.log(10, "OAUnresolved:  Getting clio db properties...");
            dbName = props.getProperty("db.clio.name");
            LogSystem.log(10, "OAUnresolved:  dbName= " + dbName);
            dbName = dbName.substring(dbName.indexOf("=")+1);
            LogSystem.log(10, "OAUnresolved:  dNname= "+ dbName);
            server = props.getProperty("db.clio.host");
            LogSystem.log(10, "OAUnresolved:  server= " + server);
            server = server.substring(server.indexOf("=")+1);
            LogSystem.log(10, "OAUnresolved:  server= "+ server);
            port = props.getProperty("db.clio.port");
            LogSystem.log(10, "OAUnresolved:  port= " + port);
            port = port.substring(port.indexOf("=")+1);
            LogSystem.log(10, "OAUnresolved:  port= "+ port);
            uid = props.getProperty("db.clio.uid");
            LogSystem.log(10, "OAUnresolved:  uid= " + uid);
            uid = uid.substring(uid.indexOf("=")+1);
            LogSystem.log(10, "OAUnresolved:  uid= "+ uid);
            pw = props.getProperty("db.clio.pwd");
            LogSystem.log(10, "OAUnresolved:  pw= " + pw);
            pw = pw.substring(pw.indexOf("=")+1);
            
            PRODRECIP = props.getProperty("PRODRECIP");
            LogSystem.log(10, "OAUnresolved:  PROD RECIPS = " + PRODRECIP);
            TESTRECIP = props.getProperty("TESTRECIP");
            LogSystem.log(10, "OAUnresolved:  TEST RECIPS = " + TESTRECIP);
            TSTRECPCC = props.getProperty("TSTRECPCC");
            LogSystem.log(10, "OAUnresolved:  TEST RECIP CC = " + TSTRECPCC);
            DEBUGRECP = props.getProperty("DEBUGRECP");
            LogSystem.log(10, "OAUnresolved:  DEBUG RECIPS = " + DEBUGRECP);
            LogSystem.log(10, "OAUnresolved:  Exiting Constructor.");
        } //try
        catch (Exception e) {
            LogSystem.log(1, "OAUnresolved:  Exception caught in constructor. ");
            LogSystem.log(1, e);
        } //catch
    } //end of constructor OAUnresolved


    /**
    * Create and send a mail message to help given the current customer object and
    * the docClassInd.
    *
    * @param Customer customer
    *
    * @return Boolean sent - Returns whether or not mail message was sent
    **/
    public boolean createCustMail(Customer cust) {

        boolean sent = false;

        try {
            InetAddress inAddr = InetAddress.getLocalHost();
            String mailHost = inAddr.getHostName();
            LogSystem.log(10, "mailHost : " + mailHost);
            Mail mail = new Mail(cust.emailaddr, mailHost);
//            mail.setRecipients(this.DEBUGRECP);
            mail.setRecipients(this.TESTRECIP);
            mail.setCC(this.TSTRECPCC);
            RegularExpression regExp = new RegularExpression();
            this.subject = regExp.substitute("###Country###", cust.country, this.subject);
            this.subject = regExp.substitute("###Brand###", " " + cust.brand, this.subject);
            mail.setSubject(this.subject);
//            if (this.docClassInd == this.BPARTNER) {
                mail.setText(cust.toString4Mail() + "\n\nSession History:\n" + this.getHistoryStr(histVec));
//            }
//            else {
//                mail.setText(cust.toStringES() + "\n\nSession History:\n" + this.getHistoryStr(histVec));
//            }
            mail.send();
            sent = true;
        }//try
        catch (Exception e) {
            sent = false;
            LogSystem.log(1, "OAUnresolved:  Exception caught in createCustMail(Customer). ");
            LogSystem.log(1, e);
        }
        return sent;
    }//createCustMail(Customer cust)


    /**
    * Create the HTML history from the additional info String passed from WebRenderer.
    *
    * @param Vector histVec
    *
    * @return String histStr
    **/
    public String parseHistory(Vector histVec) {

        LogSystem.log(10, "OAUnresolved:  parseHistory starting...");
        String histStr = "";
        String tmpStr = "";
        String typeStr = "";
        String histInfoStr="";
        ResourceTemplateLoader resTmpLdr = new ResourceTemplateLoader();
        RegularExpression regExp = new RegularExpression();

        for (int i=0; i<histVec.size(); i++){
           tmpStr = (String)histVec.elementAt(i);
           LogSystem.log(10, "OAUnresolved:  tmpStr = " + tmpStr);
           typeStr = tmpStr.substring(0,tmpStr.indexOf("="));
           LogSystem.log(10, "OAUnresolved:  typeStr = " + typeStr);
           histInfoStr = tmpStr.substring(tmpStr.indexOf("=")+1);
           LogSystem.log(10, "OAUnresolved:  histInfoStr = " + histInfoStr);
           if (typeStr.startsWith("Question") || typeStr.startsWith("Action")) {
               histStr += resTmpLdr.getTemplate(TMPSPATH + "template_boldhistory.html");
               if (typeStr.startsWith("Action")) {
                   histStr = regExp.substitute("###TYPE###", typeStr.substring(0,
                             typeStr.indexOf(" ")), histStr);
               }
               else {
                   histStr = regExp.substitute("###TYPE###",typeStr.substring(0,1), histStr);
               }
               histStr = regExp.substitute("###AITEM###", histInfoStr, histStr);
               LogSystem.log(10, "OAUnresolved:  histStr = " + histStr);
               }
               else {
                   histStr += resTmpLdr.getTemplate(TMPSPATH + "template_history.html");
                   histStr = regExp.substitute("###TYPE###", typeStr.substring(0,1), histStr);
                   histStr = regExp.substitute("###AITEM###", histInfoStr, histStr);
                   LogSystem.log(10, "OAUnresolved:  histStr = " + histStr);
               }
        }
        LogSystem.log(10, "OAUnresolved: Current parsed hitory is= \n" + histStr);
        LogSystem.log(10, "OAUnreesolved:  parseHistory complete.");

        return histStr;
    }//parseHistory(Vector)


   /**
   * Create the form using the OAUnresolved template.
   *
   * @param None
   *
   * @return String - Returns the current htmlStr.
   **/
   public String generateLinkHistoryForm() {

   LogSystem.log(10, "OAUnresolved:  Entering generateLinkHistoryForm()");
       String tmpStr = "";
       try {
               ResourceTemplateLoader resTmpLdr = new ResourceTemplateLoader();
               RegularExpression regExp = new RegularExpression();
               LogSystem.log(10, "OAUnresolved:  loading template");
               if (this.docClassInd == BPARTNER) {
                   htmlStr = resTmpLdr.getTemplate(TMPSPATH + "template_OAUnresolvedBP.html");
                   LogSystem.log(10, "OAUnresolved:  template_OAUnresolvedBP.html loaded");
               }
               else if (this.docClassInd == INFOTIPS) {
                   htmlStr = resTmpLdr.getTemplate(TMPSPATH + "template_OAUnresolvedIT.html");
//                   htmlStr = regExp.substitute("###QUERY_STRING###", this.queryStr, htmlStr);
                   LogSystem.log(10, "OAUnresolved:  template_OAUnresolvedIT.html loaded");
               }
               else {
                   htmlStr = resTmpLdr.getTemplate(TMPSPATH + "template_OAUnresolvedES.html");
//                   htmlStr = regExp.substitute("###QUERY_STRING###", this.queryStr, htmlStr);
                   LogSystem.log(10, "OAUnresolved:  template_OAUnresolvedES.html loaded");
               }
               htmlStr = regExp.substitute("###SYMPTITLE###", sympTitle, htmlStr);
               Integer tmpI = new Integer(symptomInd);
               htmlStr = regExp.substitute("###SYMPID###", tmpI.toString(), htmlStr);
               tmpStr = resTmpLdr.getTemplate(TMPSPATH + "template_header.html");
               htmlStr = regExp.substitute("###TEMPLATE_HEADER###", tmpStr, htmlStr);
               LogSystem.log(10, "OAUnresolved:  template loaded");

               //Parse History
               this.history = this.parseHistory(histVec);
               htmlStr = regExp.substitute("###HISTORY###", this.history, htmlStr);

               //OA Other conversions--oaservlet, query_string, base servlet and imagespath
               htmlStr = regExp.substitute("###oaservlet###", oaServlet, htmlStr);
               htmlStr = regExp.substitute("###baseservlet###", baseServlet, htmlStr);
               htmlStr = regExp.substitute("###QUERY_STRING###", queryStr, htmlStr);
               htmlStr = regExp.substitute("###actionValue###", oaServlet, htmlStr);
               htmlStr = regExp.substitute("###imagespath###", imagesPath, htmlStr);

       }//try
       catch (Exception e) {
           LogSystem.log(1, "OAUnresolved:  Exception caught in generateLinkHistoryForm().");
           LogSystem.log(1, e);
       }//catch
       LogSystem.log(10, "OAUnresolved:  Current htmlStr:  " + this.htmlStr);
       LogSystem.log(10, "OAUnresolved:  Exiting generateLinkHistoryForm()");
       return htmlStr;
   }//generateLinkHistoryForm()


   /**
   * Creates the UnResolved form to allow customer to submit a question or problem
   * online to the IBM HelpCenter.  This option is available for ESUPPORT and
   * BPARTNER users.
   *
   * @param None
   *
   * @return String htmlStr
   **/
   public String createURForm() {

       LogSystem.log(10, "OAunresolved:  Entering method createURForm()...");
       String tmpStr = "";
       LogSystem.log(10, "OAUnresolved:  Customer (before getCLIOCustInfo) \n" + customer.toString());
       try {
              //Get customer data from the database.
              this.customer = this.getCLIOCustInfo(this.customer);
              LogSystem.log(10, "OAUnresolved:  Customer = " + customer.toString());
       }
       catch (Exception e) {
           LogSystem.log(1, "OAUnresolved:  SQL Exception caught in createURForm:\n" + e);
           LogSystem.log(1, e);
       }

        try {
              //Load templates and prefill with current customer's data.
               ResourceTemplateLoader resTmpLdr = new ResourceTemplateLoader();
               RegularExpression regExp = new RegularExpression();
               if (this.docClassInd == this.BPARTNER) {
                   this.htmlStr = resTmpLdr.getTemplate(TMPSPATH + "template_oaunresolvedfromBP.html");
                   htmlStr = regExp.substitute("###COMPANY###", customer.company, htmlStr);
                   htmlStr = regExp.substitute("###MACHINE###", customer.machine, htmlStr);
                   htmlStr = regExp.substitute("###MODEL###", customer.model, htmlStr);
               }
               else {
                   this.htmlStr = resTmpLdr.getTemplate(TMPSPATH + "template_oaunresolvedformES.html");
                   htmlStr = regExp.substitute("###MTMDL###", customer.machine + "-" + customer.model, htmlStr);
               }
               htmlStr = regExp.substitute("###FNAME###", customer.fname, htmlStr);
               htmlStr = regExp.substitute("###LNAME###", customer.lname, htmlStr);
               htmlStr = regExp.substitute("###EADDR###", customer.emailaddr, htmlStr);
               htmlStr = regExp.substitute("###PHONE###", customer.phone, htmlStr);
               htmlStr = regExp.substitute("###COUNTRY###", customer.country, htmlStr);
               htmlStr = regExp.substitute("###BRAND###", customer.brand, htmlStr);
               htmlStr = regExp.substitute("###COMMAND###", "createStatPg", htmlStr);
               
               //OA Other conversions--oaservlet, query_string, base servlet and imagespath
               htmlStr = regExp.substitute("###oaservlet###", oaServlet, htmlStr);
               htmlStr = regExp.substitute("###baseservlet###", baseServlet, htmlStr);
               htmlStr = regExp.substitute("###QUERY_STRING###", queryStr, htmlStr);
               htmlStr = regExp.substitute("###actionValue###", oaServlet, htmlStr);
               htmlStr = regExp.substitute("###imagespath###", imagesPath, htmlStr);
        }//try
       catch (Exception e) {
           LogSystem.log(1, "OAUnresolved:  Exception caught in createURForm(). \n" + e);
           LogSystem.log(1, e);
       }//catch
       LogSystem.log(10, "OAunresolved:  Exiting method createURForm()...");
       return htmlStr;

   }//createURForm()


   /**
    * createStatPage(HttpRequest)
    *  Creates an HTML String for the status page if mail message sent is true.
    *
    * @param HttpRequest - The HttpRequest object passed from WebRenderer.
    *
    * @return String htmlStr - Returns the template_statpagetrue.html template.
    **/
    public String createStatPage(HttpRequest httpReq) {
        String htmlStr = "";
        ResourceTemplateLoader resTmpLdr = new ResourceTemplateLoader();
        RegularExpression regExp = new RegularExpression();

        // Retrieve user info & problem from the HttpRequest object.
        this.parseHttpReq(httpReq);

        //Create and send the mail message.
        boolean mailSent = this.createCustMail(this.customer);

       // build our HTML status page
       if (mailSent == true) {
           // Load successful status template
           if (this.docClassInd == BPARTNER) {
              htmlStr += resTmpLdr.getTemplate(TMPSPATH + "template_statpagetrueBP.html");
           }
           else {
              htmlStr += resTmpLdr.getTemplate(TMPSPATH + "template_statpagetrue.html");
           }
        }
        else {
           // Load unsuccessful status template
           if (this.docClassInd == BPARTNER) {
              htmlStr += resTmpLdr.getTemplate(TMPSPATH + "template_statpagefalseBP.html");
           }
           else {
              htmlStr += resTmpLdr.getTemplate(TMPSPATH + "template_statpagefalse.html");
           }
//           htmlStr = regExp.substitute("###ERROR###", tmpStr, htmlStr);
       }
       htmlStr = regExp.substitute("###QUERY_STRING###", this.queryStr, htmlStr);
       return htmlStr;
    }//createStatPage(HttpRequest)


   /**
    * getHistoryStr(Vector)
    *  Creates an String representation of the history vector.
    *
    * @param Vector histVec - The history in vector form.
    *
    * @return String histStr - Returns the history as a plain text string.
    **/
    public String getHistoryStr(Vector histVec) {
        String histStr = "";
        String tmpStr = "";

        // build our string from the vector of strings.
        for (int i=0; i<histVec.size(); i++){
           tmpStr = (String)histVec.elementAt(i);
           LogSystem.log(10, "OAUnresolved:  tmpStr = " + tmpStr);
           histStr += "\n" + tmpStr;
           LogSystem.log(10, "OAUnresolved:  histStr = " + histStr);
        } //for 0 <= i < histVec.size()

        return histStr;
    }//getHistoryStr(Vector)


    /**
    * Returns the customer information from clio for the given CLIO customer number.
    *
    * <b>Note:</b> This method requires that a connection for
    * DatabaseSystem.CLIO has already been created.
    * @see com.ibm.nzna.shared.db.DatabaseSystem.createConnection
    *
    * @param int custNum  the CLIO customer number
    *
    * @return Customer customer the filled in customer record or null if an error occurs
    **/
    public Customer getCLIOCustInfo(Customer customer) throws Exception {

        LogSystem.log(10, "OAUnresolved:  Entering method getClioCustInfo...");
        Customer cust = customer;
        LogSystem.log(10, "OAUnresolved:  Current custNum = " + cust.custNum);

        LogSystem.log(10, "OAUnresolved:  Getting COM.ibm.db2.jdbc.net.DB2Driver....");
        Class.forName( "COM.ibm.db2.jdbc.net.DB2Driver");
        LogSystem.log(10, "OAUnresolved:  Got COM.ibm.db2.jdbc.net.DB2Driver....");

        // initialize the log system
//        LogSystem logSys = new LogSystem(10, "OAUnresolved.log");
//        logSys.setProvideGUI(false);

        // initialize the database system
        LogSystem.log(10, "OAUnresolved:  Initializing the database system....");
        DatabaseSystem dbSys = new DatabaseSystem(true, LogSystem.getInstance(), this.appDriver);
        LogSystem.log(10, "OAUnresolved:  DatabaseSystem initialized. Creating the connection...");

//        boolean connectionCreated = DatabaseSystem.createConnection(DatabaseSystem.CLIO, dbName, server, port, uid,pw);
        boolean connectionCreated = dbSys.createConnection(dbSys.CLIO, dbName, server, port, uid,pw);
        LogSystem.log(10, "OAUnresolved:  connection created: " + connectionCreated);

        if (connectionCreated) {

            SQLMethod sqlm = new SQLMethod( dbSys.CLIO, "getCLIOCustInfo(String)", 1 );
            ResultSet rs = null;

            try {
                Statement stmt = sqlm.createStatement();

                rs = stmt.executeQuery(
                                       "SELECT cn.fname, cn.lname, cn.emailaddr, " +
                                       "       cc.descript country, cp.profileqind, " +
                                       "       cm.machine, cm.model, p.phonenum, "+
                                       "       cm.machine, cm.model, "+
                                       "       tb.descript brand, tg.descript group, " +
                                       "       cc.countrycode, co.company " +
                                       "FROM clio.custaddress ca, " +
                                       "     clio.typecountrycode cc, " +
                                       "     clio.custnum cn, " +
                                       "     clio.custmach cm, " +
                                       "     clio.custprofile cp, " +
                                       "     clio.brands b, " +
                                       "     clio.custphone p, " +
                                       "     clio.typebrand tb, " +
                                       "     clio.typegroup tg, " +
                                       "     clio.custcompany co " +
                                       "WHERE  ca.custNum=" + cust.custNum  +
                                       "   and cn.custNum=" + cust.custNum  +
                                       "   and cp.custnum=" + cust.custNum  +
                                       "   and cm.custnum=" + cust.custNum  +
                                       "   and p.custnum="  + cust.custNum  +
                                       "   and co.custnum="  + cust.custNum  +
                                       "   and cc.countrycode=ca.countrycode " +
                                       "   and b.brandind=cm.brandind " +
                                       "   and tb.brandid=b.brandid " +
                                       "   and tg.groupid=b.groupid " +
                                       "FOR READ ONLY"
                                       );

                if (!rs.wasNull()) {
                    ResultSetMetaData rmeta = rs.getMetaData();
                    int numCols = rmeta.getColumnCount();
                    String str = "";

                    while (rs.next()) {
                        for (int i=1; i<=numCols; i++) {
                            str = rmeta.getColumnName(i);

                            if (str.equalsIgnoreCase("fname")) {
                                cust.fname=rs.getString(i).trim();
                            } //if fname
                            if (str.equalsIgnoreCase("lname")) {
                                cust.lname=rs.getString(i).trim();
                            } //if lname
                            if (str.equalsIgnoreCase("emailaddr")) {
                                cust.emailaddr=rs.getString(i).trim();
                            } //if emailaddr
                            if (str.equalsIgnoreCase("country")) {
                                cust.country=rs.getString(i).trim();
                            } //if country
                            if (str.equalsIgnoreCase("countrycode")) {
                                cust.countrycode=rs.getString(i).trim();
                            } //if country
                            if (str.equalsIgnoreCase("profileqind")) {
                                cust.profileqind=rs.getString(i).trim();
                            } //if profileqid
                            if (str.equalsIgnoreCase("machine")) {
                                cust.machine=rs.getString(i).trim();
                            } //if machine
                            if (str.equalsIgnoreCase("model")) {
                                cust.model=rs.getString(i).trim();
                            } //if model
                            if (str.equalsIgnoreCase("phonenum")) {
                                cust.phone=rs.getString(i).trim();
                            } //if model
                            if (str.equalsIgnoreCase("brand")) {
                                if (brand.equals("")) {
                                    cust.brand=rs.getString(i).trim();
                                }
                            } //if brand
                            if (str.equalsIgnoreCase("group")) {
                                cust.group=rs.getString(i).trim();
                            } //if group
                            if (str.equalsIgnoreCase("company")) {
                                cust.company=rs.getString(i).trim();
                            } //if company
                        }  //for i=1 to numCols
                    }  //while rs.next
                }//if rs not null
//                if (!mtmdl.equals("")) {
//                    cust.machine=mtmdl.substring(0, mtmdl.indexOf("-")-);
//                    cust.model=mtmdl.substring(mtmdl.indexOf("-")+1);
//                } //if mtmdl != ""
            } //try
            catch (Exception e) {
                LogSystem.log(1, "OAUnresolved:  Exception caught in getCLIOCustInfo(Customer)");
                LogSystem.log(1, e);
            }
            finally {
                rs.close();
                sqlm.close();
            }
    } //if db connection created
    else {
        cust = customer;
    }
        return cust;
    }//getCLIOCustInfo(Customer customer)


    /**
     * Get the current html string
     *
     * @param None
     *
     * @return String
     **/
     public String getHTML() {
         return htmlStr;
     }//getHTML()

   /*------------------------------------------------------------*/
   /* parseHttpReq(HttpRequest)
    */
   /**
    *    This method parses the current HttpRequest object.
    *
    *  @param  HttpRequest - The current HttpRequest object passed from WebRenderer.
    *  @return Nothing
    *     *//*---------------------------------------------------------*/
   public void parseHttpReq (HttpRequest httpReq) {
       LogSystem.log(10, "OAUnresolved:  Parsing HttpRequest object...");
       String mailStr = "";

       Enumeration enum = httpReq.getParameterNames();
       LogSystem.log(10, "\nOAUnresolved: httpReq enumeration= ");
       while (enum.hasMoreElements()) {
           String parmName = (String)enum.nextElement();
           LogSystem.log(10, parmName + " = " + httpReq.getParameter(parmName));
           if (parmName.equalsIgnoreCase("fname")) {
               customer.fname = httpReq.getParameter("fname");
           }
           else if (parmName.equalsIgnoreCase("lname")) {
               customer.lname = httpReq.getParameter("lname");
           }
           else if (parmName.equalsIgnoreCase("eaddr")) {
               customer.emailaddr = httpReq.getParameter("eaddr");
           }
           else if (parmName.equalsIgnoreCase("phone")) {
               customer.phone = httpReq.getParameter("phone");
           }
           else if (parmName.equalsIgnoreCase("country")) {
               customer.country = httpReq.getParameter("country");
           }
           else if (parmName.equalsIgnoreCase("geo")) {
               customer.geo = httpReq.getParameter("geo");
           }
           else if (parmName.equalsIgnoreCase("brand")) {
               customer.brand = httpReq.getParameter("brand");
           }
           else if (parmName.equalsIgnoreCase("mtmdl")) {
               String tmpStr = httpReq.getParameter("mtmdl");
               customer.machine = tmpStr.substring(0,4);
               customer.model = tmpStr.substring(5);
           }
           else if (parmName.equalsIgnoreCase("problem")) {
               customer.message = httpReq.getParameter("problem");
           }
           else if (parmName.equalsIgnoreCase("type")) {
               customer.machine = httpReq.getParameter("type");
           }
           else if (parmName.equalsIgnoreCase("model")) {
               customer.model = httpReq.getParameter("model");
           }
           else if (parmName.equalsIgnoreCase("company")) {
               customer.company = httpReq.getParameter("company");
           }
           else if (parmName.equalsIgnoreCase("techOnSite")) {
               String tmpStr = httpReq.getParameter("techOnSite");
               if (!tmpStr.equals(null)) {
                   customer.tech =  true;
               }
           }
           else if (parmName.equalsIgnoreCase("name")) {
               customer.fname = httpReq.getParameter("name");
               customer.lname = customer.fname.substring(customer.fname.indexOf(" ")+1);
               customer.fname = customer.fname.substring(0, customer.fname.indexOf(" "));
           }
       }//while (enum.hasMoreElements())

       LogSystem.log(10, "OAUnresolved:  Parsing HttpRequest object completed.");
   } //parseHttpReq(HttpRequest)

}//OAUnresolved Class
