package com.ibm.nzna.projects.oa.web ;
import com.ibm.nzna.shared.mq.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.shared.servlet.* ;
import com.ibm.nzna.properties.*;
import java.util.* ;

   /*********************************************************
   * The WebDaemon receives requests from the Online Assistant
   * servlet.  The request is then processed and a HTML result
   * is returned back to the servlet to display.
   *
   * Legal: Copyright (c) 2000 IBM. All Rights Reserved.
   * Created: 5/9/100  2:44pm
   * @author 
   * @version
   *********************************************************/
public class WebDaemon extends SharedDataServer {
   String fileSeparator = System.getProperty("file.separator") ;
   WebRenderer wr       = new WebRenderer();
   public static LogSystem logSys = null;

   /*********************************************************
   * Receives a shared data object from the shared data connection.
   * Processes the result and returns a shared data object.
   * 
   *
   * Author:  
   * Created: 6/6/100  8:38pm
   * @param sharedDataObject contains data received from the shared
   * data connection.
   * @return A shared data object containing the processed result
   *********************************************************/
   public SharedDataObject processSharedDataRequest( SharedDataObject sharedDataObject ) {
      /* Get the session state object */
      SessionState sessionState  = (SessionState) sharedDataObject.object ;
      /* Show request received */
      LogSystem.log(10, "Received request:  (" + sessionState.getId() + "," + sessionState.getSequence() + ")");


      /* PROCESS REQUEST HERE */
        LogSystem.log(10, "WebRenderer object processing current request");
	wr.processRequest(sessionState);
        LogSystem.log(10, "WebRenderer object processed current request");

      /* Return data */
      Hashtable hashtable = new Hashtable() ;
      
      /* Place the html output to return in a hashtable with */
      /* the key 'data.html'.                                */
      hashtable.put( "data.html", wr.getHTML() ) ;
      
      /* Set the shared data object to return */
      sharedDataObject.object = hashtable ;
      
      /* Return the same data object we received with a new   */
      /* object reference.  We return the same object because */
      /* The web servlet will look for the id which is        */
      /* contained in this object.                            */
      return ( sharedDataObject ) ;
   }
   /*********************************************************
   * The main method for the WebDaemon.
   * 
   *
   * Author:  
   * Created: 6/6/100  8:39pm
   * @param
   * @return
   *********************************************************/
   public static void main( String argv[] ) {
      String logPath =  StandardPropertyLoader.getPath() + "/tmp/oa/";
      logSys = new LogSystem(0, logPath+"WebDaemon.log");
      logSys.setOut();
      LogSystem.setProvideGUI(false);
      LogSystem.beginLogSection("WebDaemon Started.");
      
      /* Create an instance of the server */
      WebDaemon webDaemon = new WebDaemon() ;
      /* Get the property file name */
      String propertyFile = webDaemon.getPropertyFileName() ;
      /* Load the property file */
      try {
          LogSystem.log(1, "propertyFile:  " + propertyFile);
          webDaemon.properties = StandardPropertyLoader.load(propertyFile);
      }
      catch (Exception e ) {
          LogSystem.log(1,  "WebDaemon:  unable to load="+ propertyFile);
          LogSystem.log(1, e);

          System.exit(-1) ;
      }
      
      /* Initialize the server */
      webDaemon.init( webDaemon.properties ) ;

      /* Start the channel monitor */
      webDaemon.monitorDataChannel() ;

      LogSystem.endLogSection();
   }

   /*********************************************************
   * Gets the property file name used to initialize the WebDaemon
   * 
   *
   * Author:  
   * Created: 6/6/100  8:40pm
   * @param
   * @return
   *********************************************************/
   public String getPropertyFileName() {
//      return ( path + fileSeparator + 
//               "com/ibm/nzna/properties/oa/WebDaemon.properties") ;
      return ("oa" + fileSeparator + "WebDaemon.properties") ;
   }
}

