package com.ibm.nzna.projects.qit.admin.brandmgmt ;
/*-----------------------------------------------------------*/
/*   BrandMgmt                                               */
/*                                                           */
/*   Description:                                            */
/*      Source code for: BrandMgmt                           */
/*                                                           */
/*                                                           */
/*         @Copyright  2001 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.admin.* ;
import java.util.* ;
import javax.swing.* ;
import java.awt.event.* ;
/**
 * This QuestApplet allows an authorized user to manipulate brands
 * in the Quest database.
 *
 *
 * @version 1.0, 1/26/100 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   BrandMgmt                                               */
/*                                                           */
/*-----------------------------------------------------------*/
public class BrandMgmt extends Object implements AdminConst, java.io.Serializable, QuestApplet, AppConst, Authority {


   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This constructor like all good Quest Applets
    *  does nothing
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public BrandMgmt () {
   }





   /*------------------------------------------------------------*/
   /* getName
    */
   /**
    *    This method will return the name
    *  of this Quest Applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getName () {
      return( Str.getStr ( STR_BRAND_MANAGEMENT ) ) ;
   }




   /*------------------------------------------------------------*/
   /* getDescription
    */
   /**
    *    This method will return a user readable
    *  description of this Quest Applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getDescription () {
      return( Str.getStr ( STR_BRAND_MANAGEMENT_DESCRIPT ) ) ;
   }





   /*------------------------------------------------------------*/
   /* canChat
    */
   /**
    *    This method will return TRUE, since
    *  the web browser can chat with other
    *  web browsers
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean canChat () {
      return( true ) ;
   }




   /*------------------------------------------------------------*/
   /* getAuthority
    */
   /**
    *    This method will return 0, since everyone
    *  has access to the browser
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public int getAuthority () {
      return( AUTH_BRAND_MANAGEMENT ) ;
   }




   /*------------------------------------------------------------*/
   /* stop
    */
   /**
    *    This method will be called when we need
    *  to clean up and stop our Applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void stop () {
   }




   /*------------------------------------------------------------*/
   /* start
    */
   /**
    *    This method will be called when our
    *  initialization has completed, and we
    *  can now add ourselves to a window
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void start () {         
      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add this browser to the main window                     */
      /*                                                           */
      /*-----------------------------------------------------------*/
      WindowSystem.createPanel ( new SelectBrandPanel() ) ;
   }




   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will initialize our browser
    *  bean as well as get everything else
    *  ready
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean initialize () {                                         
      return( true ) ;
   }




   /*------------------------------------------------------------*/
   /* getSmallIcon
    */
   /**
    *    This method will return the small icon
    *  representing this Quest Applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public ImageIcon getSmallIcon () {
      return( ImageSystem.getImageIcon ( this, ImageSystem.BRAND_MANAGEMENT_SMALL ) ) ;
   }





   /*------------------------------------------------------------*/
   /* getIcon
    */
   /**
    *    This method will return our normal
    *  sized icon
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return ImageIcon
    *//*---------------------------------------------------------*/
   public ImageIcon getIcon () {
      return( ImageSystem.getImageIcon ( this, ImageSystem.BRAND_MANAGEMENT ) ) ;
   }


                       
} /* BrandMgmt */
