package com.ibm.nzna.projects.qit.admin.doc ;
/*-----------------------------------------------------------*/
/*   DocPublishCheck                                         */
/*                                                           */
/*   Description:                                            */
/*      Source code for: DocPublishCheck                     */
/*                                                           */
/*                                                           */
/*         @Copyright  2001 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.io.* ;
import java.sql.* ;
import java.awt.* ;
import java.util.* ;
import java.awt.event.* ;
import javax.swing.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.db.* ;
import com.ibm.nzna.shared.sort.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
/**
  * This QuestPanel will allow the user to read in a list of
  * documents from a File and verifies that each document
  * is webable and going to the web
  *
  * @version 1.0 3/14/2001
  * @author  David Lentz
  */


/*-----------------------------------------------------------*/
/*                                                           */
/*   DocPublishCheck                                         */
/*                                                           */
/*-----------------------------------------------------------*/
public class DocPublishCheck extends JPanel implements QuestProcess, Runnable, ActionListener, AppConst, QuestPanel {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private GUI Members                                     */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private JLabel       st_FILENAME     = null ;
   private JTextField   ef_FILENAME     = null ;
   private DButton      pb_BROWSE       = null ;
   private JLabel       st_FILE_TYPE    = null ;
   private JRadioButton rb_SINGLE_LINE  = null ;
   private JRadioButton rb_CSV          = null ;
   private DButton      pb_START        = null ;
   private JScrollPane  outputScroll    = null ;
   private JTextArea    output          = null ;
   private JLabel       st_OUTPUT       = null ;
   private JLabel       st_WEB_SITE     = null ;
   private JComboBox    cb_WEB_SITE     = null ;
   private ActionButton pb_CLOSE        = null ;

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private boolean processing         = false ;
   private String  outputString       = "" ;
   private boolean continueProcessing = true ;
   private int     docClassInd        = 0 ;


   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *     This method will create our default
    *  instance and do nothing else, like all
    *  QuestApplets should
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return void - Nothing
    *//*---------------------------------------------------------*/
   public DocPublishCheck () {
   }

   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *     This method will be called when we
    *  need to initialize before we are shown
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return TRUE
    *//*---------------------------------------------------------*/
   public boolean initialize () {
      ButtonGroup bg       = new ButtonGroup () ;
      Vector      webSites = new Vector ( 3 ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Initialize our Web Sites                                */
      /*                                                           */
      /*-----------------------------------------------------------*/
      webSites.addElement ( Str.getStr ( STR_ESUPPORT ) ) ;
      webSites.addElement ( Str.getStr ( STR_BUSINESS_PARTNER ) ) ;
      webSites.addElement ( Str.getStr ( STR_INFOTIPS ) ) ;
      new QuickSort ( webSites ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   First, Initialize The GUI                               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      st_FILENAME     = new JLabel ( Str.getStr ( STR_IMPORT_FILE ) ) ;
      ef_FILENAME     = new JTextField ( "" ) ;
      pb_BROWSE       = new DButton ( Str.getStr ( STR_BROWSE ) ) ;
      st_FILE_TYPE    = new JLabel ( Str.getStr ( STR_FILE_TYPE ) ) ;
      rb_SINGLE_LINE  = new JRadioButton ( Str.getStr ( STR_DOC_CHECK_IMPORT_SINGLE_LINE ) ) ;
      rb_CSV          = new JRadioButton ( Str.getStr ( STR_DOC_CHECK_IMPORT_CSV ) ) ;
      pb_START        = new DButton ( Str.getStr ( STR_START ) ) ;
      output          = new JTextArea () ;
      outputScroll    = new JScrollPane ( output ) ;
      st_OUTPUT       = new JLabel ( Str.getStr ( STR_OUTPUT ) ) ;
      st_WEB_SITE     = new JLabel ( Str.getStr ( STR_WEBSITE  )) ;
      cb_WEB_SITE     = new JComboBox ( webSites ) ;
      pb_CLOSE        = new ActionButton ( Str.getStr ( STR_CLOSE ), ImageSystem.getImageIcon ( this, ImageSystem.CLOSE ), Str.getStr ( STR_CLOSE ) )  ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust Properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      rb_SINGLE_LINE.setOpaque ( false ) ;
      rb_CSV.setOpaque ( false ) ;
      st_FILENAME.setOpaque ( false ) ;
      st_FILE_TYPE.setOpaque ( false ) ;
      setBackground ( Color.white ) ;
      output.setFont ( pb_CLOSE.getFont() ) ;
      output.setEditable ( false ) ;
      bg.add ( rb_SINGLE_LINE ) ;
      bg.add ( rb_CSV ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add Listeners                                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      pb_BROWSE.addActionListener ( this ) ;
      pb_START.addActionListener  ( this ) ;
      pb_CLOSE.addActionListener  ( this ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add our GUI                                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( null ) ;
      add ( st_FILENAME ) ;
      add ( ef_FILENAME ) ;
      add ( pb_BROWSE ) ;
      add ( st_FILE_TYPE ) ;    
      add ( rb_SINGLE_LINE ) ;
      add ( rb_CSV ) ;
      add ( st_WEB_SITE ) ;
      add ( cb_WEB_SITE ) ;
      add ( pb_START ) ;
      add ( st_OUTPUT ) ;
      add ( outputScroll ) ;
      output.setText ( "Staring" ) ;

      return( true ) ;
   }


   /*------------------------------------------------------------*/
   /* doLayout
    */
   /**
    *     This method will lay out and position
    *  all of our controls\
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return void - Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size      = getSize() ;
      int       x         = 5 ;
      int       y         = 5 ;
      int       rowHeight = GUISystem.getRowHeight() ;

      st_FILENAME.setBounds ( x, y, 250, rowHeight ) ;
      y+=rowHeight ;

      ef_FILENAME.setBounds ( x, y, 250, rowHeight ) ;
      y+=rowHeight ;

      pb_BROWSE.setBounds ( x, y, 85, rowHeight ) ;
      y+=rowHeight*2 ;

      st_FILE_TYPE.setBounds ( x, y, 250, rowHeight ) ;
      y+=rowHeight ;

      rb_SINGLE_LINE.setBounds ( x, y, size.width, rowHeight ) ;
      y+=rowHeight ;

      rb_CSV.setBounds ( x, y, size.width, rowHeight ) ;
      y+=rowHeight*2 ;

      st_WEB_SITE.setBounds ( x, y, 250, rowHeight ) ;
      cb_WEB_SITE.setBounds ( x+250, y, 250, rowHeight ) ;
      y+=rowHeight*2 ;

      pb_START.setBounds ( (size.width/2)-40, y, 80, rowHeight+2 ) ;
      y+=rowHeight*2 ;

      st_OUTPUT.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight ;

      outputScroll.setBounds ( x, y, size.width-(x*2), size.height-y-5 ) ;
   }



   /*------------------------------------------------------------*/
   /* bookmark
    */
   /**
    *     We don't support bookmarking
    *  
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return FALSE
    *//*---------------------------------------------------------*/
   public boolean bookmark () {
      return( false ) ;
   }

   /*------------------------------------------------------------*/
   /* refresh
    */
   /**
    *     This method will do nothing
    *  
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return void - Nothing
    *//*---------------------------------------------------------*/
   public void refresh () {
   }

   /*------------------------------------------------------------*/
   /* panelDeselected
    */
   /**
    *     Do Nothing
    *  
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return void - Nothing
    *//*---------------------------------------------------------*/
   public void panelDeselected () {
   }


   /*------------------------------------------------------------*/
   /* panelSelected
    */
   /**
    *     Do Nothing
    *  
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return void - Nothing
    *//*---------------------------------------------------------*/
   public void panelSelected () {
   }



   /*------------------------------------------------------------*/
   /* pasteText
    */
   /**
    *     this method does nothing
    *  
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return FALSE
    *//*---------------------------------------------------------*/
   public boolean pasteText () {
      return( false ) ;
   }


   /*------------------------------------------------------------*/
   /* cutText
    */
   /**
    *     this method does nothing
    *  
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return FALSE
    *//*---------------------------------------------------------*/
   public boolean cutText () {
      return( false ) ;
   }


   /*------------------------------------------------------------*/
   /* copyText
    */
   /**
    *     this method does nothing
    *  
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return FALSE
    *//*---------------------------------------------------------*/
   public boolean copyText () {
      return( false ) ;
   }

   /*------------------------------------------------------------*/
   /* shutdown
    */
   /**
    *     Only allow a shutdown if we are
    *  not processing
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return void - Nothing
    *//*---------------------------------------------------------*/
   public boolean shutdown () {
      return( !processing ) ;
   }

   /*------------------------------------------------------------*/
   /* stop
    */
   /**
    *     Only allow a close if we are not processing
    *  
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return TRUE if we are not processing
    *//*---------------------------------------------------------*/
   public boolean stop () {
      return( !processing ) ;
   }

   /*------------------------------------------------------------*/
   /* getJComponent
    */
   /**
    *     This method will return an instance
    *  of this class
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return JComponent
    *//*---------------------------------------------------------*/
   public JComponent getJComponent () {
      return( this ) ;
   }

   /*------------------------------------------------------------*/
   /* start
    */
   /**
    *     This method will refresh our initial data
    *  
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return void - Nothing
    *//*---------------------------------------------------------*/
   public void start () {

      GUISystem.getParentDefWin ( this ).addActionComponent ( this, pb_CLOSE ) ;
   }


   /*------------------------------------------------------------*/
   /* getDefaultNavPanel
    */
   /**
    *     This method will do nothing
    *  
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return void - Nothing
    *//*---------------------------------------------------------*/
   public NavPanel getDefaultNavPanel () {
      return( null ) ;
   }



   /*------------------------------------------------------------*/
   /* getName
    */
   /**
    *     This method will return the name of our
    *  Quest Applet
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return void - Nothing
    *//*---------------------------------------------------------*/
   public String getName () {
      return( Str.getStr ( STR_DOCUMENT_PUB_CHECK ) ) ;
   }

   /*------------------------------------------------------------*/
   /* getIcon
    */
   /**
    *     This method will return the small icon for
    *  us to display
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return ImageIcon
    *//*---------------------------------------------------------*/
   public ImageIcon getIcon ( ) {
      return( ImageSystem.getImageIcon  ( this, ImageSystem.QUESTION_SMALL ) ) ;
   }


   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *     This method will respond to action
    *  events being fired on us
    *  
    *  
    *
    *  @param e The event
    *  @param None
    *  @param None
    *
    *  @return void - Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_BROWSE                                               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( e.getSource() == pb_BROWSE ) {
         File[] files = GUISystem.getFileOpen ( GUISystem.getParentDefWin ( this ), 
                                                Str.getStr ( STR_IMPORT_FILE ), 
                                                "",
                                                true ) ;

         if ( ( files != null ) && ( files.length > 0 ) )
            ef_FILENAME.setText ( files[0].getAbsolutePath() ) ;
      } /* pb_BROWSE  */


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_START                                                */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_START )
         new Thread ( this ).start() ;


      /*-----------*/
      /*           */                 
      /*  pb_CLOSE */
      /*           */                 
      /*-----------*/
      else if ( e.getSource() == pb_CLOSE )
         GUISystem.getParentDefWin(this).closePanel ( this, null ) ;
   }

   /*------------------------------------------------------------*/
   /* run
    */
   /**
    *     This thread will process the import
    *  file
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return void - Nothing
    *//*---------------------------------------------------------*/
   public void run () {
      String  filename = ef_FILENAME.getText() ;
      boolean rc       = false ;
      Vector  docVec   = null ;

      output.setText ( "" ) ;
      outputString = "" ;
      continueProcessing = true ;
      processing = true ;

      if ( FileUtil.exists ( filename ) ) {

         if ( ( rb_SINGLE_LINE.isSelected() ) ||
              ( rb_CSV.isSelected() ) ) {

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Always add ourselves as a new process                   */
            /*                                                           */
            /*-----------------------------------------------------------*/
            ProcessManagerSystem.addProcess ( this ) ;

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Grab the correct document classification from           */
            /* The Web SIte drop down                                    */
            /*                                                           */
            /*-----------------------------------------------------------*/
            if ( cb_WEB_SITE.getSelectedItem().equals ( Str.getStr ( STR_ESUPPORT ) ) ) {
               docClassInd = TypeList.DOCCLASS_UNCLASSIFIED ;
            }



            try {
               String inFile = FileUtil.readFile ( filename ) ;

               addOutput ( "Processing Document File:"+filename ) ;


               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   Depending on the file type, read in the doc ids         */
               /*                                                           */
               /*-----------------------------------------------------------*/
               if ( rb_SINGLE_LINE.isSelected() )
                  docVec = ReadDocsSingleLine.read ( inFile, output ) ;
               else if ( rb_CSV.isSelected() )
                  docVec = ReadDocsCSV.read ( inFile, output ) ;



               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   If we can process the file, do so now                   */
               /*                                                           */
               /*-----------------------------------------------------------*/
               if ( ( docVec != null ) && ( docVec.size() > 0 ) ) {
                  SQLMethod   sql        = new SQLMethod ( DatabaseSystem.QUEST, "DocPublishCheck", 5 ) ;

                  try {
                     Statement     statement  = sql.createStatement() ;
                     int           i          = 0 ;
                     int           size       = docVec.size() ;
                     AppDefaultWin parentWin  = GUISystem.getParentDefWin ( this ) ;

                     /*-----------------------------------------------------------*/
                     /*                                                           */
                     /*   Append our info to the output                           */
                     /*                                                           */
                     /*-----------------------------------------------------------*/
                     addOutput ( "\n\nFinished Reading File\n-----------------------------------------" ) ;
                     addOutput ( "Total Possible Document Lookups: "+size+"\n\nLooking up documents" ) ;

                     /*-----------------------------------------------------------*/
                     /*                                                           */
                     /*   Ok, now loop through and process each                   */
                     /*                                                           */
                     /*-----------------------------------------------------------*/
                     parentWin.setStatus ( STR_PLEASE_WAIT ) ;
                     parentWin.setValueMax ( size ) ;

                     while ( ( i < size ) && ( continueProcessing ) ) {
                        documentIsWebable ( (String)docVec.elementAt(i), statement ) ;
                        i++ ;
                        parentWin.setValue ( i ) ;
                     }

                     parentWin.setStatus ( null ) ;
                     parentWin.setValue ( 0 ) ;

                     if ( continueProcessing )
                        GUISystem.printBox ( STR_INFO, STR_COMPLETE ) ;

                  } catch ( Exception e ) {
                     sql.rollBack() ;
                     LogSystem.log ( 1, e, false ) ;
                     rc = false ;
                     addOutput ( "Processing stopped due to exception" ) ;
                     GUISystem.printBox ( STR_INFO, STR_ERROR_IN_LAST_ACTION ) ;
                  }

                  sql.close() ;

               } else
                  addOutput ( "No Possible Document Lookups found in file" ) ;





               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   We are done, make sure we have no errors                */
               /*                                                           */
               /*-----------------------------------------------------------*/
               rc = true ;

            } catch ( Exception e ) {
               LogSystem.log ( 1, e, false ) ;
               rc = false ;
               addOutput ( "Processing stopped due to exception" ) ;
               GUISystem.printBox ( STR_INFO, STR_ERROR_IN_LAST_ACTION ) ;
            }


            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   We are done, remove ourselves                           */
            /*                                                           */
            /*-----------------------------------------------------------*/
            ProcessManagerSystem.removeProcess ( this ) ;

            addOutput ( rc ? "Process Complete" : "Process Complete with Errors" ) ;
         } else
            GUISystem.printBox ( STR_INFO, STR_MUST_SELECT_DOCUMENT_FILE_TYPE ) ;

      } /* if  */
      else
         GUISystem.printBox ( STR_INFO, STR_CANNOT_FIND_DOCUMENT_FILE ) ;

      processing = false ;

   } /* run  */


   /*------------------------------------------------------------*/
   /* getProcessName
    */
   /**
    *     This method will return our process
    *  name which is DOC_PUB_THREAD_CHECK
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public String getProcessName () {
      return( "DOC_PUB_THREAD_CHECK" ) ;
   }

   /*------------------------------------------------------------*/
   /* stopProcess
    */
   /**
    *     This method will signal the process
    *  we are running to stop
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return void - Nothing
    *//*---------------------------------------------------------*/
   public void stopProcess () {
      continueProcessing = false ;
   }


   /*------------------------------------------------------------*/
   /* addOutput
    */
   /**
    *     This method will add a line of
    *  output to the output JTextArea
    *  
    *  
    *
    *  @param output The new line of output
    *  @param None
    *  @param None
    *
    *  @return void - Nothing
    *//*---------------------------------------------------------*/
   public void addOutput ( String newOutput ) {
      outputString+=newOutput+"\n" ;
      output.setText ( outputString ) ;
   }

   private void documentIsWebable ( String docId, Statement stmt ) throws Exception {
      ResultSet rs = stmt.executeQuery ( "SELECT WEBABLE, PUBLISH, DBUSER, CHANGEDTIME, DOCCLASSIND FROM TIGRIS.DOCUMENTS "+
                                         "WHERE LNDOCID = '"+docId+"' FOR FETCH ONLY" ) ;

      if ( rs.next() ) {
         String webable        = rs.getString(1).trim() ;
         String publish        = rs.getString(2).trim() ;
         String dbUser         = UserSystem.getNameFromUserId ( rs.getString(3).trim() ) ;
         String changedTime    = DateSystem.prettyDateFromStamp ( rs.getString(4).trim() ) ;
         int    newDocClassInd = rs.getInt(5) ;

         if ( publish.equals ( "N" ) )
            addOutput ( "Document: "+docId+" was deleted by "+dbUser+" on "+changedTime ) ;
         else if ( webable.equals ( "N" ) )
            addOutput ( "Document: "+docId+" is not Webable" ) ;
         else if ( newDocClassInd < docClassInd )
            addOutput ( "Document: "+docId+" will not appear on the web site "+cb_WEB_SITE.getSelectedItem()+
                        " because it's classification is '"+TypeList.getInstance().objectFromInd ( newDocClassInd, TypeList.TYPE_DOCCLASS )+"'" ) ;

      } else
         addOutput ( "Cannot find document:"+docId ) ;

      rs.close() ;
   }
} /* DocPublishCheck */

