package com.ibm.nzna.projects.qit.admin.doc ;
/*-----------------------------------------------------------*/
/*   ReadDocsSingleLine                                      */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ReadDocsSingleLine                  */
/*                                                           */
/*                                                           */
/*         @Copyright  2001 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import javax.swing.* ;
/**
  * This class holds a static method for
  * reading in document ids from a single line
  * 
  *
  * @version 1.0 3/14/2001
  * @author  David Lentz
  */


/*-----------------------------------------------------------*/
/*                                                           */
/*   ReadDocsSingleLine                                      */
/*                                                           */
/*-----------------------------------------------------------*/
public class ReadDocsSingleLine extends Object {

    /*------------------------------------------------------------*/
    /* read
     */
    /**
     *     This method will read all doc ids
     *  from the buffer passed in and will return
     *  a vector of Strings. Each String will be a document id
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Vector
     *//*---------------------------------------------------------*/
    public static Vector read ( String buffer, JTextArea output ) {
        Vector docVec       = new Vector ( 1, 1 ) ;
        String outputString = output.getText() ;

        if ( ( buffer != null ) && ( buffer.length() > 0 ) ) {
            StringTokenizer strtok   = new StringTokenizer ( buffer, "\n" ) ;
            String          newToken = null ;

            while ( strtok.hasMoreTokens() ) {
                newToken = strtok.nextToken() ;

                if ( ( newToken != null ) && ( newToken.length() > 0 ) ) {
                    newToken = newToken.trim() ;

                    /*-----------------------------------------------------------*/
                    /*                                                           */
                    /*   If the token is less than 12 characters, add it         */
                    /*                                                           */
                    /*-----------------------------------------------------------*/
                    if ( newToken.length() < 12 ) {
                        docVec.addElement ( newToken ) ;
                    } /* if  */

                    /*-----------------------------------------------------------*/
                    /*                                                           */
                    /*   Otherwise, notify the user of this error                */
                    /*                                                           */
                    /*-----------------------------------------------------------*/
                    else {
                        outputString+="Cannot add line from file:"+newToken ;
                        output.setText ( outputString ) ;
                    }


                } /* if  */
            } /* while  */
        } /* if  */

        return( docVec ) ;
    }

} /* ReadDocsSingleLine */

