package com.ibm.nzna.projects.qit.admin.keyword ;   
/*-----------------------------------------------------------*/
/*   KeywordList                                             */
/*                                                           */
/*   Description:                                            */
/*      Source code for: KeywordList                         */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.Vector;
/**
 * This interface defines the methods needed for a list to be viewed and
 * manipulated in the Keyword Management Quest Applet.
 *
 *
 * @version 1.0, 8/6/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   KeywordList                                             */
/*                                                           */
/*-----------------------------------------------------------*/
public interface KeywordList  {


   /**
     *  This method must return the level of authority needed
     * to edit this list
     *
     * @return int
     **/
   public abstract int getAuthority () ;


   /**
     *  This method must return the Human Readable name of this list
     *
     * @return String
     **/
   public abstract String getName () ;

   /**
     *  This method must return the contents of the list in a Vector. Each
     * item in the Vector will be simply added to a MultiList 
     *
     * @return Vector
     **/
   public abstract Vector getKeywords() ;

   /**
     *  This method must initiate an Edit. This includes any GUI pop ups,
     * database saves etc.. If this method returns TRUE it will be assumed
     * that an item was updated and the list will be refreshed.
     *
     * @param item The item to edit. 
     *
     * @return TRUE if edited, FALSE if not
     **/
   public abstract boolean edit ( Object item ) ;


   /**
     *  This method must add an item to the list. This addition includes any
     * GUI pop ups, database saves etc... If this method returns TRUE then this
     * list will be refreshed.
     *
     * @return The item added
     **/
   public abstract Object add () ;


   /**
     *  This method must delete an item from the list. This deletion includes
     * any GUI Pop ups, database saves etc.. If this method returns TRUE then this
     * list will be refreshed to show the deletion
     *
     * @return boolean TRUE if a delete ocurred.
     **/
   public abstract boolean delete ( Object item) ;


   /**
     *  This method should return an array of Strings. Each string is the column
     * title for the MultiList displayed in the Keyword Management applet
     **/
   public abstract String[] getTitles () ;



} /* KeywordList */
