package com.ibm.nzna.projects.qit.admin.keyword ;       
/*-----------------------------------------------------------*/
/*   KeywordNavPanel                                         */
/*                                                           */
/*   Description:                                            */
/*      Source code for: KeywordNavPanel                     */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import javax.swing.* ;
import javax.swing.event.* ;
import java.awt.* ;
import java.util.* ;
import java.awt.event.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;  
import com.ibm.nzna.projects.qit.admin.* ;
import com.ibm.nzna.projects.qit.admin.keyword.date.* ;
import com.ibm.nzna.projects.qit.admin.keyword.country.* ;
import com.ibm.nzna.projects.qit.admin.keyword.doccat.* ;
import com.ibm.nzna.projects.qit.admin.keyword.offering.* ;
import com.ibm.nzna.projects.qit.admin.keyword.customer.* ;
import com.ibm.nzna.projects.qit.admin.keyword.cancel.* ;
import com.ibm.nzna.projects.qit.admin.keyword.product.* ;
import com.ibm.nzna.projects.qit.admin.keyword.warranty.* ;
import com.ibm.nzna.projects.qit.admin.keyword.geo.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.sort.* ;
/**
 * This is the default navigation panel for the KeywordMaintPanel 
 *
 *
 * @version 1.0, 4/9/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   KeywordNavPanel                                         */
/*                                                           */
/*-----------------------------------------------------------*/
public class KeywordNavPanel extends JPanel implements Authority, ActionListener, AppConst, AdminConst, NavPanel {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private KeywordPanel keywordPanel = null ;
   private NavList      keywordList  = null ;




   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will initialize our local variables
    *  only
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public KeywordNavPanel ( KeywordPanel keywordPanel ) {
      this.keywordPanel = keywordPanel ;
   }




   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will initialize and create our GUI
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void initialize () {
      JScrollPane scrollPane = null ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create our GUI                                          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      keywordList = new NavList () ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add the GUI                                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( new BorderLayout () ) ;
      add ( scrollPane = new JScrollPane ( keywordList ), BorderLayout.CENTER ) ;


   }




   /*------------------------------------------------------------*/
   /* start
    */
   /**
    *    This method will be called once we are
    *  showing. We will refres our data now
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void start () {
      refreshList () ;
   }




   /*------------------------------------------------------------*/
   /* stop
    */
   /**
    *    This method will be called when we need
    *  to release our resources
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void stop () {
      removeAll() ;
   }




   /*------------------------------------------------------------*/
   /* getJComponent
    */
   /**
    *    This method will return ourselves
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public JComponent getJComponent () {
      return( this ) ;
   }





   /*------------------------------------------------------------*/
   /* getTitle
    */
   /**
    *    This method will return our title
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getTitle () {
      return( Str.getStr ( STR_KEYWORDS ) ) ;
   }


   /*------------------------------------------------------------*/
   /* refreshList
    */
   /**
    *    This method will refresh the list of
    *  keywords that can be edited
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void refreshList () {
      Vector       items = new Vector ( 1 ) ;
      HotLinkGroup group = new HotLinkGroup () ;

      if ( UserSystem.hasAuthority ( AUTH_KEYWORD_TYPE_DATE ) )
         items.addElement ( new HotLinkLabel ( Str.getStr ( STR_TYPE_DATE ), 1, new TypeDateList() ) ) ;

      if ( UserSystem.hasAuthority ( AUTH_KEYWORD_TYPE_COUNTRY ) )
         items.addElement ( new HotLinkLabel ( Str.getStr ( STR_COUNTRY ), 1, new TypeCountryList() ) ) ;

      if ( UserSystem.hasAuthority ( AUTH_KEYWORD_TYPE_DOC_CATEGORY ) )
         items.addElement ( new HotLinkLabel ( Str.getStr ( STR_TYPE_DOC_CATEGORY ), 1, new TypeDocCategoryList() ) ) ;

      if ( UserSystem.hasAuthority ( AUTH_KEYWORD_TYPE_WARRANTY ) )
         items.addElement ( new HotLinkLabel ( Str.getStr ( STR_TYPE_WARRANTY ), 1, new TypeWarrantyList() ) ) ;

      if ( UserSystem.hasAuthority ( AUTH_KEYWORD_TYPE_GEOGRAPHY ) )
         items.addElement ( new HotLinkLabel ( Str.getStr ( STR_GEOGRAPHY ), 1, new TypeGeographyList() ) ) ;

      if ( UserSystem.hasAuthority ( AUTH_KEYWORD_TYPE_CANCEL ) )
         items.addElement ( new HotLinkLabel ( Str.getStr ( STR_CANCEL ), 1, new TypeCancelList() )   ) ;

      if ( UserSystem.hasAuthority ( AUTH_KEYWORD_TYPE_PRODUCT ) )
         items.addElement ( new HotLinkLabel ( Str.getStr ( STR_TYPE_PRODUCT ), 1, new TypeProductList() )  ) ;

      if ( UserSystem.hasAuthority ( AUTH_KEYWORD_TYPE_CUSTOMER ) )
         items.addElement ( new HotLinkLabel ( Str.getStr ( STR_TYPE_CUSTOMER ), 1, new TypeCustomerList() ) ) ;

      if ( UserSystem.hasAuthority ( AUTH_KEYWORD_TYPE_OFFERING ) )
         items.addElement ( new HotLinkLabel ( Str.getStr ( STR_TYPE_OFFERING ), 1, new TypeOfferingList() )  ) ;

      new QuickSort ( items ) ;
      group.add ( items ) ;

      keywordList.add ( items ) ;
      keywordList.addActionListener ( this ) ;
      revalidate() ;
   }


   /**
     *  This method will be called when the user selects an item
     **/
   public void actionPerformed ( ActionEvent e ) {
      if ( e.getSource() instanceof HotLinkLabel ) {
         keywordPanel.setKeywordList ( (KeywordList)((HotLinkLabel)e.getSource()).getData() ) ;
      }
   }


} /* KeywordNavPanel */
