package com.ibm.nzna.projects.qit.admin.keyword.country ;
/*-----------------------------------------------------------*/
/*   EditCountryCodeDlg                                      */
/*                                                           */
/*   Description:                                            */
/*      Source code for: EditCountryCodeDlg                  */
/*                                                           */
/*                                                           */
/*         @Copyright  1997 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This dialog will allow the user to edit or create a Country Code 
 *
 *
 * @version 1.0, 4/8/1998 
 * @author  David Lentz
 */
import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import javax.swing.border.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.admin.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.qit.storedProc.sqlRunner.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.quest.* ;

/*-----------------------------------------------------------*/
/*                                                           */
/*   EditCountryCodeDlg                                      */
/*                                                           */
/*-----------------------------------------------------------*/
public class EditCountryDlg extends JDialog implements AdminConst, DataLengths, AppConst, ActionListener {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Controls                                                */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private JLabel     st_PHONECODE    = new JLabel ( Str.getStr(STR_PHONE_CODE) ) ;
   private JLabel     st_DESCRIPT     = new JLabel ( Str.getStr(STR_NAME) ) ;
   private JLabel     st_ZIPMASK      = new JLabel ( Str.getStr(STR_ZIP_MASK) ) ;
   private JLabel     st_PHONEMASK    = new JLabel ( Str.getStr(STR_PHONE_MASK) ) ;
   private JLabel     st_ZIPDIGITS    = new JLabel ( Str.getStr(STR_ZIP_DIGITS) ) ;
   private JLabel     st_TIMEDIFF     = new JLabel ( Str.getStr(STR_TIME_DIFF) ) ;
   private JCheckBox  ck_MULTIZONE    = new JCheckBox ( Str.getStr(STR_MULTI_ZONE) ) ;
   private JCheckBox  ck_USESDST      = new JCheckBox ( Str.getStr(STR_USES_DST) ) ;
   private JLabel     st_CURRENCY     = new JLabel ( Str.getStr(STR_CURRENCY) ) ;
   private JLabel     st_CURRENCYMASK = new JLabel ( Str.getStr(STR_CURRENCY_MASK) ) ;
   private JPanel     pnl_PHONE       = new JPanel (  ) ;
   private JPanel     pnl_CURRENCY    = new JPanel (  ) ;
   private JPanel     pnl_ZIPCODE     = new JPanel (  ) ;
   private JPanel     pnl_LANGUAGE    = new JPanel (  ) ;
   private JPanel     pnl_TIMEZONE    = new JPanel (  ) ;
   private JPanel     pnl_GEOGRAPHY   = new JPanel (  ) ;
   private JLabel     st_ISOCODE      = new JLabel ( Str.getStr ( STR_ISOCODE ) ) ;
   private JTextField ef_ISOCODE      = new JTextField ( new MaskDocument ( MaskDocument.MASKTYPE_UNKNOWN, 2 ), "", 2 ) ;

   private JTextField ef_PHONECODE    = new JTextField ( new MaskDocument ( MaskDocument.MASKTYPE_NUMERIC, LENGTH_PHONECODE ), "001", 20 ) ;
   private JTextField ef_PHONEMASK    = new JTextField ( new MaskDocument ( MaskDocument.MASKTYPE_UPPER,   LENGTH_PHONEMASK ), "(999)999-9999", 20 ) ;
   private JTextField ef_CURRENCY     = new JTextField ( new MaskDocument ( MaskDocument.MASKTYPE_UPPER,   LENGTH_CURRENCY ), "US DOLLAR", 20 ) ; 
   private JTextField ef_CURRENCYMASK = new JTextField ( new MaskDocument ( MaskDocument.MASKTYPE_UPPER,   LENGTH_CURRENCYMASK ), "99.99", 20 ) ;
   private JTextField ef_ZIPMASK      = new JTextField ( new MaskDocument ( MaskDocument.MASKTYPE_UPPER,   LENGTH_ZIPMASK ), "99999-9999", 20 ) ;
   private JTextField ef_ZIPDIGITS    = new JTextField ( new MaskDocument ( MaskDocument.MASKTYPE_NUMERIC, LENGTH_ZIPDIGITS ), "5", 20 ) ;
   private JTextField ef_TIMEDIFF     = new JTextField ( ) ;
   private JTextField ef_DESCRIPT     = new JTextField ( new MaskDocument ( MaskDocument.MASKTYPE_STRING,  LENGTH_DESCRIPT ), "", 20 ) ;

   private JComboBox    cb_LANG01       = new JComboBox ( TypeList.getInstance().getTypeList ( TypeList.TYPE_LANGUAGE ) ) ;
   private JComboBox    cb_LANG02       = new JComboBox ( TypeList.getInstance().getTypeList ( TypeList.TYPE_LANGUAGE ) ) ;
   private JComboBox    cb_LANG03       = new JComboBox ( TypeList.getInstance().getTypeList ( TypeList.TYPE_LANGUAGE ) ) ;
   private JList        cnr_GEOGRAPHY   = new JList ( TypeList.getInstance().getTypeList ( TypeList.TYPE_GEOGRAPHY ) ) ;
   private JScrollPane  scr_GEOGRAPHY   = new JScrollPane ( cnr_GEOGRAPHY ) ;

   private DButton    pb_OK           = new DButton ( Str.getStr(STR_OK) ) ;
   private DButton    pb_CANCEL       = new DButton ( Str.getStr(STR_CANCEL) ) ;
   private DButton    pb_HELP         = new DButton ( Str.getStr(STR_HELP)   ) ;
   private Component  errComp         = null ;


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Vars                                                    */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private TypeCountryCodeRec countryRec = null ;
   private boolean            saveStatus = false ;

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Constructor                                             */
   /*                                                           */
   /*-----------------------------------------------------------*/
   public EditCountryDlg ( Frame parent, TypeCountryCodeRec countryRec ) {
      super ( parent, Str.getStr ( STR_COUNTRY ), true ) ;
      this.countryRec = countryRec ;
      setResizable ( false ) ;
      createControls() ;
      setSize ( 470, 360 ) ;
      WinUtil.centerChildInParent ( this, parent ) ;
      refreshData () ;
      ef_DESCRIPT.requestFocus() ;
      setVisible ( true ) ;
   }


   /*-----------------------------------------------------------*/
   /*   createControls                                          */             
   /*                                                           */
   /*   Description:                                            */
   /*      Adds all of our controls                             */                                         
   /*                                                           */
   /*   Parameters:                                             */
   /*      None                                                 */
   /*                                                           */
   /*   Returns:                                                */
   /*      Nothing                                              */
   /*-----------------------------------------------------------*/
   public void createControls () {

      /* Adjust some properties  */
      pnl_PHONE.setBorder ( new TitledBorder ( Str.getStr(STR_PHONE_INFORMATION) ) ) ;
      pnl_CURRENCY.setBorder (new TitledBorder ( Str.getStr(STR_CURRENCY) ) ) ;
      pnl_ZIPCODE.setBorder ( new TitledBorder ( Str.getStr(STR_ZIP_CODE) ) ) ;
      pnl_LANGUAGE.setBorder ( new TitledBorder ( Str.getStr(STR_LANGUAGE) ) ) ;
      pnl_TIMEZONE.setBorder ( new TitledBorder ( Str.getStr(STR_TIME_ZONE) ) ) ;
      pnl_GEOGRAPHY.setBorder ( new TitledBorder ( Str.getStr(STR_GEOGRAPHY) ) ) ;
      pnl_PHONE.setLayout ( null ) ;
      pnl_CURRENCY.setLayout ( null ) ;
      pnl_ZIPCODE.setLayout ( null ) ;
      pnl_LANGUAGE.setLayout ( null ) ;
      pnl_TIMEZONE.setLayout ( null ) ;
      pnl_GEOGRAPHY.setLayout ( new BorderLayout() ) ;
      ef_TIMEDIFF.setDocument ( new MaskDocument ( MaskDocument.MASKTYPE_STRING,  "99:99:99", ef_TIMEDIFF ) ) ;
      ef_TIMEDIFF.setText ( "00:00:00" ) ;


      /* add our listeners  */
      pb_OK.addActionListener ( this ) ;
      pb_CANCEL.addActionListener ( this ) ;
      pb_HELP.addActionListener ( this ) ;

      getContentPane().setLayout ( null ) ;
      getContentPane().add ( st_DESCRIPT ) ;
      getContentPane().add ( ef_DESCRIPT ) ;
      getContentPane().add ( st_ISOCODE ) ;
      getContentPane().add ( ef_ISOCODE ) ;
      getContentPane().add ( pnl_PHONE ) ;
      getContentPane().add ( pnl_CURRENCY ) ;
      getContentPane().add ( pnl_ZIPCODE ) ;
      getContentPane().add ( pnl_TIMEZONE ) ;
      getContentPane().add ( pnl_LANGUAGE) ;
      getContentPane().add ( pnl_GEOGRAPHY ) ;
      getContentPane().add ( pb_OK ) ;
      getContentPane().add ( pb_CANCEL ) ;
      getContentPane().add ( pb_HELP ) ;

      pnl_PHONE.add ( st_PHONECODE ) ;
      pnl_PHONE.add ( ef_PHONECODE ) ;
      pnl_PHONE.add ( st_PHONEMASK ) ;
      pnl_PHONE.add ( ef_PHONEMASK ) ;

      pnl_CURRENCY.add ( st_CURRENCY ) ;
      pnl_CURRENCY.add ( ef_CURRENCY ) ;
      pnl_CURRENCY.add ( st_CURRENCYMASK ) ;
      pnl_CURRENCY.add ( ef_CURRENCYMASK ) ;

      pnl_ZIPCODE.add ( st_ZIPMASK ) ;
      pnl_ZIPCODE.add ( ef_ZIPMASK ) ;
      pnl_ZIPCODE.add ( st_ZIPDIGITS ) ;
      pnl_ZIPCODE.add ( ef_ZIPDIGITS ) ;

      pnl_TIMEZONE.add ( st_TIMEDIFF ) ;
      pnl_TIMEZONE.add ( ef_TIMEDIFF ) ;
      pnl_TIMEZONE.add ( ck_MULTIZONE ) ;
      pnl_TIMEZONE.add ( ck_USESDST ) ;

      pnl_LANGUAGE.add ( cb_LANG01 ) ;
      pnl_LANGUAGE.add ( cb_LANG02 ) ;
      pnl_LANGUAGE.add ( cb_LANG03 ) ;

      pnl_GEOGRAPHY.add ( scr_GEOGRAPHY ) ;
   }


   /*-----------------------------------------------------------*/
   /*   layoutControls                                          */
   /*                                                           */
   /*   Description:                                            */
   /*                                                           */               
   /*                                                           */
   /*   Parameters:                                             */
   /*      None                                                 */
   /*                                                           */
   /*   Returns:                                                */
   /*      None                                                 */
   /*-----------------------------------------------------------*/
   public void doLayout() {
      int       x         = 5 ;
      int       y         = 5 ;
      int       rowHeight = GUISystem.getRowHeight () ;
      Dimension size      = getSize() ;

      super.doLayout() ;

      st_DESCRIPT.setBounds ( x, y, 75, rowHeight ) ;
      ef_DESCRIPT.setBounds ( x+75, y, 150, rowHeight ) ;
      st_ISOCODE.setBounds ( x+85+150, y, 75, rowHeight ) ;
      ef_ISOCODE.setBounds ( x+85+75+150,y , 100, rowHeight ) ;
      y+=rowHeight+5 ;

      pnl_PHONE.setBounds ( x, y, 220, (rowHeight*4) ) ;
      pnl_CURRENCY.setBounds ( x+230, y, 220, (rowHeight*4) ) ;
      y+=(rowHeight*4)+10 ;

      pnl_ZIPCODE.setBounds ( x, y, 220, (rowHeight*4)+20 ) ;
      pnl_TIMEZONE.setBounds ( x+230, y, 220, (rowHeight*4)+20 ) ;
      y+=(rowHeight*4)+30 ;

      pnl_LANGUAGE.setBounds ( x+230, y, 220, (rowHeight*5) ) ;
      pnl_GEOGRAPHY.setBounds ( x, y, 220, (rowHeight*5) ) ;
      y+=(rowHeight*4)-5 ;

      pb_OK.setBounds ( x, size.height-55, 70, 25 ) ;
      pb_CANCEL.setBounds ( x+75, size.height-55, 80, 25 ) ;
      pb_HELP.setBounds ( x+75+85, size.height-55, 70, 25 ) ;

      y = 15 ;
      st_PHONECODE.setBounds ( x+2, y, 90, rowHeight ) ;
      ef_PHONECODE.setBounds ( x+92, y, 100, rowHeight ) ;
      y+=rowHeight+2 ;

      st_PHONEMASK.setBounds ( x+2, y, 90, rowHeight ) ;
      ef_PHONEMASK.setBounds ( x+92, y, 100, rowHeight ) ;

      y=15 ;
      st_CURRENCY.setBounds ( x+2, y, 90, rowHeight ) ;
      ef_CURRENCY.setBounds ( x+92, y ,100, rowHeight ) ;
      y+=rowHeight+2 ;

      st_CURRENCYMASK.setBounds ( x, y, 90, rowHeight ) ;
      ef_CURRENCYMASK.setBounds ( x+90, y, 100, rowHeight ) ;

      y=15 ;
      st_ZIPMASK.setBounds ( x, y, 90, rowHeight ) ;
      ef_ZIPMASK.setBounds ( x+90, y, 100, rowHeight ) ;
      y+=rowHeight+2 ;

      st_ZIPDIGITS.setBounds ( x+2, y, 90, rowHeight ) ;
      ef_ZIPDIGITS.setBounds ( x+92, y, 100, rowHeight ) ;

      y=15 ;
      cb_LANG01.setBounds ( x, y, 190, rowHeight ) ;
      y+=rowHeight+4 ;
      cb_LANG02.setBounds ( x, y, 190, rowHeight ) ;
      y+=rowHeight+4 ;
      cb_LANG03.setBounds ( x, y, 190, rowHeight ) ;

      y=15 ;
      st_TIMEDIFF.setBounds ( x+2, y, 90, rowHeight ) ;
      ef_TIMEDIFF.setBounds ( x+92, y, 100, rowHeight ) ;
      y+=rowHeight+2 ;
      ck_MULTIZONE.setBounds ( x+2, y, 190, rowHeight ) ;
      y+=rowHeight+2 ;
      ck_USESDST.setBounds ( x+2, y, 190, rowHeight ) ;

      y=15 ;
      scr_GEOGRAPHY.setBounds ( x, y, 210, (rowHeight*3)-10 ) ;

   }

   /*-----------------------------------------------------------*/
   /*   refreshData                                             */
   /*                                                           */
   /*   Description:                                            */
   /*      This method will refresh the data on the window      */                                                            
   /*                                                           */
   /*   Parameters:                                             */
   /*      None                                                 */
   /*                                                           */
   /*   Returns:                                                */
   /*      None                                                 */
   /*-----------------------------------------------------------*/
   private void refreshData () {
      if ( countryRec != null ) {
         TypeLanguageRec lang1   = (TypeLanguageRec)TypeList.getInstance().objectFromInd ( countryRec.lang01, TypeList.TYPE_LANGUAGE ) ;
         TypeLanguageRec lang2   = (TypeLanguageRec)TypeList.getInstance().objectFromInd ( countryRec.lang02, TypeList.TYPE_LANGUAGE ) ;
         TypeLanguageRec lang3   = (TypeLanguageRec)TypeList.getInstance().objectFromInd ( countryRec.lang03, TypeList.TYPE_LANGUAGE ) ;
         TypeLanguageRec english = (TypeLanguageRec)TypeList.getInstance().objectFromInd ( TypeList.LANGUAGE_ENGLISH, TypeList.TYPE_LANGUAGE ) ;

         ef_ISOCODE.setText ( countryRec.isoCode ) ;
         ef_DESCRIPT.setText     ( countryRec.toString() ) ;
         ef_PHONECODE.setText    ( ""+countryRec.phoneCountryCode ) ;
         ef_ZIPMASK.setText      ( countryRec.zipMask ) ;
         ef_PHONEMASK.setText    ( countryRec.phoneMask ) ;

         if ( countryRec.getRecStatus () == countryRec.REC_INSERT )
            ef_TIMEDIFF.setText ( "00:00:00" ) ;
         else
            ef_TIMEDIFF.setText     ( countryRec.timeDiff ) ;

         ef_CURRENCY.setText     ( countryRec.currency ) ;
         ef_CURRENCYMASK.setText ( countryRec.currencyMask ) ;
         ef_ZIPDIGITS.setText    ( ""+countryRec.zipDigits ) ;
         cnr_GEOGRAPHY.setSelectedValue ( TypeList.getInstance().objectFromInd ( countryRec.geoInd, TypeList.TYPE_GEOGRAPHY ), true ) ;


         ck_MULTIZONE.setSelected ( countryRec.multiZone ) ;
         ck_USESDST.setSelected ( countryRec.usesDST ) ;

         if ( lang1 != null )
            cb_LANG01.setSelectedItem( lang1 ) ;
         else
            cb_LANG01.setSelectedItem ( english ) ;

         if ( lang2 != null )
            cb_LANG02.setSelectedItem( lang2 ) ;
         else
            cb_LANG02.setSelectedItem ( english ) ;

         if ( lang3 != null )
            cb_LANG03.setSelectedItem( lang3 ) ;
         else
            cb_LANG03.setSelectedItem ( english ) ;


      }
   }

   /*-----------------------------------------------------------*/
   /*   actionPerformed                                         */
   /*                                                           */
   /*   Description:                                            */
   /*      Responds to buttons being pressed                    */                                              
   /*                                                           */
   /*   Parameters:                                             */
   /*      e The action event                                   */
   /*                                                           */
   /*   Returns:                                                */
   /*      None                                                 */
   /*-----------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {
      if ( e.getSource() instanceof DButton ) {
         DButton button = (DButton) e.getSource() ;

         if ( pb_OK == button ) {
            if ( saveData() )
               dispose() ;
         }

         else if ( pb_CANCEL == button ) {
            countryRec.updateRecStatus ( countryRec.REC_NOCHANGE ) ;
            dispose() ;
         }
      }
   }


   /*-----------------------------------------------------------*/
   /*   saveData                                                */
   /*                                                           */
   /*   Description:                                            */
   /*      This method will save the data on our window         */                                                         
   /*                                                           */
   /*   Parameters:                                             */
   /*      None                                                 */
   /*                                                           */
   /*   Returns:                                                */
   /*      None                                                 */
   /*-----------------------------------------------------------*/
   private boolean saveData () {
      boolean    rc = false ;
      String     isoCode      = ef_ISOCODE.getText() ;
      String     descript     = ef_DESCRIPT.getText() ;
      String     phoneCode    = ef_PHONECODE.getText() ;
      String     phoneMask    = ef_PHONEMASK.getText() ;
      String     zipMask      = ef_ZIPMASK.getText () ;
      String     currency     = ef_CURRENCY.getText () ;
      String     currencyMask = ef_CURRENCYMASK.getText () ;
      String     timeDiff     = ef_TIMEDIFF.getText () ;
      String     errStr       = null ;
      short      zipDigits    = (short) new Integer ( ef_ZIPDIGITS.getText() ).intValue() ;
      short      lang01       = (short) ((TypeLanguageRec)cb_LANG01.getSelectedItem()).getInd() ;
      short      lang02       = (short) ((TypeLanguageRec)cb_LANG02.getSelectedItem()).getInd() ;
      short      lang03       = (short) ((TypeLanguageRec)cb_LANG03.getSelectedItem()).getInd() ;
      TypeGeoRec geoRec       = (TypeGeoRec) cnr_GEOGRAPHY.getSelectedValue() ;
      boolean    usesDST      = ck_USESDST.isSelected() ;
      boolean    multiZone    = ck_MULTIZONE.isSelected() ;
      String     usesDSTStr   = usesDST ? "Y" : "N" ;
      String     multiZoneStr = multiZone ? "Y" : "N" ;

      if ( ( descript != null ) && ( descript.length() > 0 ) )
         countryRec.setDescript (  descript ) ;
      else {
         errStr = Str.getStr(STR_MUST_ENTER_COUNTRY_NAME) ;
         errComp = ef_DESCRIPT ;
      }

      if ( ( phoneCode != null ) && ( phoneCode.length() > 0 ) )
         countryRec.phoneCountryCode = (short) new Integer ( phoneCode ).intValue() ;
      else {
         errStr = Str.getStr(STR_MUST_ENTER_PHONE_CODE) ;
         errComp = ef_PHONECODE ;
      }

      if ( ( isoCode != null ) && ( isoCode.length() > 0 ) )
         countryRec.isoCode = isoCode ;
      else {
         errStr = Str.getStr ( STR_MUST_ENTER_ISO_CODE ) ;
         errComp = ef_ISOCODE ;
      }

      if ( ( phoneMask != null ) && ( phoneMask.length() > 0 ) )
         countryRec.phoneMask = phoneMask ;
      else {
         errStr = Str.getStr(STR_MUST_ENTER_PHONE_MASK) ;
         errComp = ef_PHONEMASK ; 
      }                          

      if ( ( zipMask != null ) && ( zipMask.length() > 0 ) )
         countryRec.zipMask = zipMask ;
      else {
         errStr = Str.getStr(STR_MUST_ENTER_ZIP_MASK) ;
         errComp = ef_ZIPMASK ; 
      }                          

      if ( ( currency != null ) && ( currency.length() > 0 ) )
         countryRec.currency = currency ;
      else {
         errStr = Str.getStr(STR_MUST_ENTER_CURRENCY) ;
         errComp = ef_CURRENCY ; 
      }                          

      if ( ( currencyMask != null ) && ( currencyMask.length() > 0 ) )
         countryRec.currencyMask = currencyMask ;
      else {
         errStr = Str.getStr(STR_MUST_ENTER_CURRENCY_MASK) ;
         errComp = ef_CURRENCYMASK ;
      }


      if ( ( timeDiff != null ) && ( timeDiff.length() > 0 ) )
         countryRec.timeDiff = timeDiff ;
      else {
         errStr  = Str.getStr(STR_MUST_ENTER_TIME_DIFF) ;
         errComp = ef_TIMEDIFF ;
      }

      if ( geoRec != null ) {
         countryRec.geoInd = (short) geoRec.getInd() ;
      } else {
         errStr  = Str.getStr ( STR_MUST_ENTER_GEOGRAPHY ) ;
         errComp = cnr_GEOGRAPHY ;
      }

      if ( errStr == null ) {
         countryRec.zipDigits = zipDigits ;
         countryRec.lang01    = lang01 ;
         countryRec.lang02    = lang02 ;
         countryRec.lang03    = lang03 ;
         countryRec.usesDST   = usesDST ;
         countryRec.multiZone = multiZone ;                             

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   If this is a new country code, save it                  */
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( countryRec.getRecStatus() == QITRec.REC_INSERT ) {

            QITSqlRunner.sqlRunner ( "INSERT INTO TIGRIS.TYPECOUNTRYCODE "+
                                     "( COUNTRYCODEIND, PHONECOUNTRYCODE, DESCRIPT,     ZIPMASK,   "+
                                     "  PHONEMASK,      ZIPDIGITS,        TIMEDIFF,     MULTIZONE, "+
                                     "  USESDST,        CURRENCY,         CURRENCYMASK, LANG01,    "+
                                     "  LANG02,         LANG03,           DBUSER,       CHANGEDTIME, ISOCODE )"+
                                     "VALUES ("+
                                     ""+countryRec.getInd()+", "+
                                     "'"+countryRec.phoneCountryCode+"', "+
                                     "'"+Text.cleanDBString ( countryRec.toString() )+"', "+
                                     "'"+Text.cleanDBString ( countryRec.zipMask )+"', " +
                                     "'"+Text.cleanDBString ( countryRec.phoneMask )+"', "+
                                     ""+countryRec.zipDigits+", "+
                                     "'"+Text.cleanDBString ( countryRec.timeDiff )+"', "+
                                     "'"+Text.cleanDBString ( multiZoneStr )+"', " +
                                     "'"+Text.cleanDBString ( usesDSTStr )+"', " +
                                     "'"+Text.cleanDBString ( countryRec.currency )+"', "+
                                     "'"+Text.cleanDBString ( countryRec.currencyMask )+"', "+
                                     ""+countryRec.lang01+", "+
                                     ""+countryRec.lang02+", "+
                                     ""+countryRec.lang03+", "+
                                     "'"+Text.cleanDBString ( UserSystem.getUserId() )+"', "+
                                     "CURRENT TIMESTAMP, "+
                                     "'"+Text.cleanDBString ( countryRec.isoCode )+"')"+QITSqlRunner.END_DELIM+
                                     ""+
                                     "INSERT INTO TIGRIS.GEOCOUNTRY "+
                                     "(GEOIND, COUNTRYCODEIND, DBUSER, CHANGEDTIME) "+
                                     "VALUES ("+
                                     ""+countryRec.geoInd+", "+
                                     ""+countryRec.getInd()+", "+
                                     "'"+UserSystem.getUserId()+"', "+
                                     "CURRENT TIMESTAMP )"+QITSqlRunner.END_DELIM ) ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   If this is an update, save it                           */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( countryRec.getRecStatus() == QITRec.REC_UPDATE ) {

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   First, we must delete everything in GEOCOUNTRY          */
            /* because they might have switched geographies, then save   */
            /* the geography and update TIGRIS.TYPECOUNTRYCODE           */
            /*                                                           */
            /*-----------------------------------------------------------*/
            QITSqlRunner.sqlRunner ( "DELETE FROM TIGRIS.GEOCOUNTRY WHERE COUNTRYCODEIND = "+countryRec.getInd()+QITSqlRunner.END_DELIM+
                                     ""+
                                     "INSERT INTO TIGRIS.GEOCOUNTRY "+
                                     "(GEOIND, COUNTRYCODEIND, DBUSER, CHANGEDTIME) "+
                                     "VALUES ("+
                                     ""+countryRec.geoInd+", "+
                                     ""+countryRec.getInd()+", "+
                                     "'"+UserSystem.getUserId()+"', "+
                                     "CURRENT TIMESTAMP )"+QITSqlRunner.END_DELIM+
                                     ""+
                                     "UPDATE TIGRIS.TYPECOUNTRYCODE "+
                                     "SET PHONECOUNTRYCODE = '"+countryRec.phoneCountryCode+"', "+
                                     "    DESCRIPT         = '"+Text.cleanDBString ( countryRec.toString() )+"', "+
                                     "    ZIPMASK          = '"+Text.cleanDBString ( countryRec.zipMask )+"', "+
                                     "    PHONEMASK        = '"+Text.cleanDBString ( countryRec.phoneMask )+"', "+
                                     "    ZIPDIGITS        = "+countryRec.zipDigits+", "+
                                     "    TIMEDIFF         = '"+Text.cleanDBString ( countryRec.timeDiff )+"', "+
                                     "    MULTIZONE        = '"+Text.cleanDBString ( multiZoneStr )+"', "+
                                     "    USESDST          = '"+Text.cleanDBString ( usesDSTStr )+"', "+
                                     "    CURRENCY         = '"+Text.cleanDBString ( countryRec.currency )+"', "+
                                     "    CURRENCYMASK     = '"+Text.cleanDBString ( countryRec.currencyMask )+"', "+
                                     "    LANG01           = "+countryRec.lang01+", "+
                                     "    LANG02           = "+countryRec.lang02+", "+
                                     "    LANG03           = "+countryRec.lang03+", "+
                                     "    ISOCODE          = '"+Text.cleanDBString ( countryRec.isoCode )+"', "+
                                     "    DBUSER           = '"+Text.cleanDBString ( UserSystem.getUserId() )+"', "+
                                     "    CHANGEDTIME      = CURRENT TIMESTAMP "+
                                     "WHERE COUNTRYCODEIND = "+countryRec.getInd() ) ;

         }


         countryRec.updateRecStatus ( QITRec.REC_NOCHANGE ) ;
         rc = true ;
         saveStatus = rc ;

      } else {
         GUISystem.printBox ( Str.getStr(STR_ERROR), errStr ) ;
         if ( errComp != null )
            errComp.requestFocus() ;
      }


      return( rc ) ;
   }


   public boolean getSaved () {
      return( saveStatus ) ;
   }
} /* EditCountryCodeDlg */
