package com.ibm.nzna.projects.qit.admin.keyword.country ;
/*-----------------------------------------------------------*/
/*   TypeCountryList                                         */
/*                                                           */
/*   Description:                                            */
/*      Source code for: TypeCountryList                     */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import com.ibm.nzna.projects.qit.admin.keyword.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.qit.admin.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.quest.* ;
import com.ibm.nzna.shared.util.* ;
/**
 * This object represents the TIGRIS.TYPECOUNTRYCODE table for the Keyword Management Applet 
 *
 *
 * @version 1.0, 8/6/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   TypeCountryList                                         */
/*                                                           */
/*-----------------------------------------------------------*/
public class TypeCountryList extends Object implements AppConst, KeywordList, Authority, AdminConst {



   /**
     *  This method will return our name
     **/
   public String getName () {
      return( Str.getStr ( STR_TYPE_COUNTRY ) ) ;
   }


   /**
     *  This method will add an item to our date list
     **/
   public Object add () {
      boolean            rc         = false ;
      TypeCountryCodeRec countryRec = new TypeCountryCodeRec ( Counter.getCounter ( LogSystem.getInstance(), "CCIND" ), "" ) ;   
      EditCountryDlg     countryDlg = null ;
      
      countryRec.updateRecStatus ( TypeCountryCodeRec.REC_INSERT ) ;
      countryDlg = new EditCountryDlg ( MainWindow.getInstance(), countryRec ) ;

      if ( !countryDlg.getSaved() ) {
         countryRec = null ;
      } else
         TypeList.getInstance().addToList ( countryRec, TypeList.TYPE_COUNTRYCODE ) ;


      return( countryRec ) ;
   }


   /**
     *  This method will remove an item from our list
     **/
   public boolean delete ( Object item ) {
      boolean rc = false ;

      if ( ( item != null ) && ( item instanceof TypeCountryCodeRec ) ) {
         TypeCountryCodeRec countryRec = (TypeCountryCodeRec) item ;

         if ( GUISystem.printBox ( STR_QUESTION, STR_ARE_YOU_SURE_DELETE_COUNTRY ) ) {
            int saveRC = 0 ;

            countryRec.updateRecStatus ( TypeCountryCodeRec.REC_DELETE ) ;
            saveRC = countryRec.writeToDatabase() ;

            if ( saveRC != 0 ) {
               LogSystem.log ( 1, "Cannot delete country "+countryRec.toString()+" ("+countryRec.getInd()+"). SQLCode:"+saveRC ) ;
               GUISystem.printBox ( STR_INFO, STR_ERROR_IN_LAST_ACTION ) ;
            } else {
               rc = true ;
               TypeList.getInstance().removeFromList ( countryRec, TypeList.TYPE_COUNTRYCODE ) ;
            }

         }

      }
      return( rc ) ;
   }


   /**
     *  This method will edit the item passed in
     *
     * @param item This is a TypeCountryCodeRec object to edit
     **/
   public boolean edit ( Object item ) {
      boolean rc = false ;

      if ( ( item != null ) && ( item instanceof TypeCountryCodeRec ) ) {
         TypeCountryCodeRec countryRec  = (TypeCountryCodeRec) item ;
         EditCountryDlg     countryDlg  = new EditCountryDlg ( MainWindow.getInstance(), countryRec ) ;

         rc = countryDlg.getSaved() ;
      }

      return( rc ) ;
   }


   /**
     *  This method will return the authorization level needed
     * to edit this list
     **/
   public int getAuthority () {
      return( AUTH_KEYWORD_TYPE_COUNTRY ) ;
   }


   /**
     *  This method will return a list of TypeCountryCodeRec objects
     *
     * @return Vector
     **/
   public Vector getKeywords () {
      Vector list = TypeList.getInstance().getTypeList ( TypeList.TYPE_COUNTRYCODE ) ;
      return( list ) ;
   }


   /**
     *  This method will return our single column's title
     *
     * @return String[]
     **/
   public String[] getTitles () {
      String[] titles = { Str.getStr ( STR_DESCRIPTION ), "Country Ind", "Zip Mask", "Phone Mask", "Zip Digits"} ;

      return( titles  );
   }


   /**
     *  The toString method must return the name as well
     **/
   public String toString () {
      return( getName() ) ;
   }


} /* TypeCountryList */


