package com.ibm.nzna.projects.qit.admin.keyword.doccat ;    
/*-----------------------------------------------------------*/
/*   TypeDocCategoryList                                     */
/*                                                           */
/*   Description:                                            */
/*      Source code for: TypeDocCategoryList                 */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import java.sql.* ;
import java.awt.* ;
import com.ibm.nzna.projects.qit.admin.keyword.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.qit.admin.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.quest.doc.* ;
import com.ibm.nzna.projects.common.quest.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.shared.db.* ;
/**
 * This object represents the PRODUCT.TYPEDOCCAT table for the Keyword Management Applet 
 *
 *
 * @version 1.0, 8/6/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   TypeDocCategoryList                                     */
/*                                                           */
/*-----------------------------------------------------------*/
public class TypeDocCategoryList extends Object implements AppConst, KeywordList, Authority, AdminConst {



   /**
     *  This method will return our name
     **/
   public String getName () {
      return( Str.getStr ( STR_TYPE_DOC_CATEGORY ) ) ;
   }


   /**
     *  This method will add an item to our date list
     **/
   public Object add () {
      TypeDocCatRec catRec      = null ;
      String        newDescript = new SingleEntryDlg ( MainWindow.getInstance(),
                                                       Str.getStr ( STR_TYPE_DOC_CATEGORY ),
                                                       Str.getStr ( STR_PLEASE_ENTER_DOC_CATEGORY ),
                                                       "",
                                                       "" ).getResult() ;

      if ( ( newDescript != null ) && ( newDescript.length() > 0 ) ) {

         /*----------------------------------------------------*/
         /*                                                    */
         /*  Make sure this name isn't already in the database */
         /*                                                    */
         /*----------------------------------------------------*/
         if ( TypeList.getInstance().objectFromString ( newDescript, TypeList.TYPE_DOCCAT ) == null ) {
            int newInd = Counter.getCounter ( LogSystem.getInstance(), "DOCCATIND" ) ;

            if ( newInd > 0 ) {
               int            saveRC  = 0 ;
               
               catRec  = new TypeDocCatRec ( newInd, newDescript ) ;
               catRec.updateRecStatus ( TypeDocCatRec.REC_INSERT ) ;
               saveRC = catRec.writeToDatabase() ;

               if ( saveRC != 0 ) {
                  LogSystem.log ( 1, "Could not create new TypeDocCategory of "+newDescript+". SQLCode:"+saveRC ) ;
                  GUISystem.printBox ( STR_INFO, STR_ERROR_IN_LAST_ACTION ) ;
                  catRec = null ;
               } else {
                  TypeList.getInstance().addToList ( catRec, TypeList.TYPE_DOCCAT ) ;
               }
            }
         } else
            GUISystem.printBox ( STR_INFO, STR_THAT_ITEM_ALREADY_EXISTS_IN_KEYWORD_LIST ) ;
      }

      return( catRec ) ;
   }


   /**
     *  This method will remove an item from our list
     **/
   public boolean delete ( Object item ) {
      boolean rc = false ;

      if ( ( item != null ) && ( item instanceof TypeDocCatRec ) ) {
         TypeDocCatRec docCatRec = (TypeDocCatRec) item ;

         if ( docCatRec.getInd() == 0 )
            GUISystem.printBox ( STR_INFO, STR_CANNOT_DELETE_DEFAULT ) ;
         else {
            Frame     tempFrame = new Frame() ;
            StatusWin statusWin = new StatusWin ( tempFrame ) ;

            if ( GUISystem.printBox ( STR_QUESTION, STR_ARE_YOU_SURE_DELETE_DOC_CATEGORY_LIST ) ) {
               try {
                  int saveRC = 0 ;

                  /*-----------------------------------------------------------*/
                  /*                                                           */
                  /*   First, we have to delete all Document Associations      */                                         
                  /*                                                           */
                  /*-----------------------------------------------------------*/
                  statusWin.setText ( Str.getStr ( STR_DELETING_DOCUMENT_CATEGORY_ASSOCIATIONS ) );
                  DocumentSQL.removeAllDocumentCategory ( docCatRec.toString() ) ;

                  /*-----------------------------------------------------------*/
                  /*                                                           */
                  /*   Now, Delete the entry from TIGRIS.TYPEDOCCAT            */                                   
                  /*                                                           */
                  /*-----------------------------------------------------------*/
                  statusWin.setText ( Str.getStr ( STR_DELETING ) ) ;
                  docCatRec.updateRecStatus ( docCatRec.REC_DELETE ) ;
                  saveRC = docCatRec.writeToDatabase() ;

                  if ( saveRC != 0 ) {
                     LogSystem.log ( 1, "Cannot delete Offering "+docCatRec.toString()+". SQLCode:"+saveRC ) ;
                     GUISystem.printBox ( STR_INFO, STR_ERROR_IN_LAST_ACTION ) ;
                  } else {
                     rc = true ;
                     TypeList.getInstance().removeFromList ( docCatRec, TypeList.TYPE_DOCCAT ) ;
                  }
               } catch ( SQLException e ) {
                  LogSystem.log ( 1, e, false ) ;
                  rc = false ;
               }
            }

            statusWin.dispose() ;
            tempFrame.dispose() ;
         }

      }
      return( rc ) ;
   }


   /**
     *  This method will edit the item passed in
     *
     * @param item This is a TypeDocCatRec object to edit
     **/
   public boolean edit ( Object item ) {
      boolean rc = false ;

      if ( ( item != null ) && ( item instanceof TypeDocCatRec ) ) {
         TypeDocCatRec docCatRec     = (TypeDocCatRec) item ;
         String          current         = docCatRec.toString() ;
         String          newDescript     = new SingleEntryDlg ( MainWindow.getInstance(),
                                                                Str.getStr ( STR_TYPE_DATE ),
                                                                Str.getStr ( STR_PLEASE_ENTER_DOC_CATEGORY ),
                                                                docCatRec.toString(),
                                                                "" ).getResult() ;

         if ( ( newDescript != null ) && ( newDescript.length() > 0 ) ) {
            int saveRC = 0 ;

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   First, try to update the name in the TYPECATEGORY table */                                              
            /*                                                           */
            /*-----------------------------------------------------------*/
            if ( editAllDocCat ( docCatRec.toString(), newDescript ) ) {

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   Now, update the name in the TIGRIS.TYPEDOCCAT table     */                                          
               /*                                                           */
               /*-----------------------------------------------------------*/
               docCatRec.updateRecStatus ( docCatRec.REC_NOCHANGE ) ;
               docCatRec.setDescript ( newDescript ) ;
               saveRC = docCatRec.writeToDatabase() ;
            } else
               saveRC=-1 ;

            if ( saveRC != 0 ) {
               LogSystem.log ( 1, "Could not change TypeDocCat to description "+newDescript+". SQLCode:"+saveRC ) ;
               docCatRec.setDescript ( current ) ;
               GUISystem.printBox ( STR_INFO, STR_ERROR_IN_LAST_ACTION ) ;
            } else {
               rc = true ;
            }
         }
      }

      return( rc ) ;
   }


   /**
     *  This method will return the authorization level needed
     * to edit this list
     **/
   public int getAuthority () {
      return( AUTH_KEYWORD_TYPE_DOC_CATEGORY ) ;
   }


   /**
     *  This method will return a list of TypeDocCatRec objects
     *
     * @return Vector
     **/
   public Vector getKeywords () {
      Vector list = TypeList.getInstance().getTypeList ( TypeList.TYPE_DOCCAT ) ;
      return( list ) ;
   }


   /**
     *  This method will return our single column's title
     *
     * @return String[]
     **/
   public String[] getTitles () {
      String[] titles = { Str.getStr ( STR_DESCRIPTION ), "Doc Category Ind"} ;

      return( titles  );
   }


   /**
     *  The toString method must return the name as well
     **/
   public String toString () {
      return( getName() ) ;
   }


   /**
     *  This method will change the name of the Product.TypeCategory items
     * to the name of the new Document Category
     **/
   private boolean editAllDocCat ( String oldName, String newName ) {
      SQLMethod sqlMethod = new SQLMethod ( DatabaseSystem.QUEST, "TypeCatCategoryList.editAllDocCat ( "+oldName+", "+newName+" )",5) ;
      boolean   rc        =  false ;

      try {
         Statement stmt = sqlMethod.createStatement() ;

         newName = Text.cleanDBString ( newName ) ;
         oldName = Text.cleanDBString ( oldName ) ;
         stmt.executeUpdate ( "UPDATE PRODUCT.TYPECATEGORY "+
                              "SET DESCRIPTION = '"+newName+"' "+
                              "WHERE DESCRIPTION = '"+oldName+"' AND "+
                              "      CATEGORYLEVEL = '"+TypeCategory.LEVEL_DOC_CATEGORY+"'" ) ;

         rc = true ;
      } catch ( Exception e ) {
         LogSystem.log ( 1, e, false ) ;
         sqlMethod.rollBack() ;
      }

      sqlMethod.close() ;

      return( rc ) ;
   }

} /* TypeDocCategoryList */


