package com.ibm.nzna.projects.qit.admin.keyword.geo ;
/*-----------------------------------------------------------*/
/*   TypeGeographyList                                       */
/*                                                           */
/*   Description:                                            */
/*      Source code for: TypeGeographyList                   */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import com.ibm.nzna.projects.qit.admin.keyword.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.qit.admin.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.quest.* ;
import com.ibm.nzna.shared.util.* ;
/**
 * This object represents the PRODUCT.TYPEGEOGRAPHY   table for the Keyword Management Applet 
 *
 *
 * @version 1.0, 8/6/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   TypeGeographyList                                        */
/*                                                           */
/*-----------------------------------------------------------*/
public class TypeGeographyList extends Object implements AppConst, KeywordList, Authority, AdminConst {



   /**
     *  This method will return our name
     **/
   public String getName () {
      return( Str.getStr ( STR_TYPE_GEOGRAPHY ) ) ;
   }


   /**
     *  This method will add an item to our date list
     **/
   public Object add () {
      GUISystem.printBox ( "Info", "There are no more Geographies" ) ;
      return( null ) ;
   }


   /**
     *  This method will remove an item from our list
     **/
   public boolean delete ( Object item ) {
      GUISystem.printBox ( "Info", "You cannot delete a geography" ) ;
      return( false ) ;
   }


   /**
     *  This method will edit the item passed in
     *
     * @param item This is a TypeGeoRec object to edit
     **/
   public boolean edit ( Object item ) {
      boolean rc = false ;

      if ( ( item != null ) && ( item instanceof TypeGeoRec ) ) {
         TypeGeoRec geographyRec     = (TypeGeoRec) item ;
         String          current         = geographyRec.toString() ;
         String          newDescript     = new SingleEntryDlg ( MainWindow.getInstance(),
                                                                Str.getStr ( STR_TYPE_DATE ),
                                                                Str.getStr ( STR_PLEASE_ENTER_GEOGRAPHY ),
                                                                geographyRec.toString(),
                                                                "" ).getResult() ;

         if ( ( newDescript != null ) && ( newDescript.length() > 0 ) ) {
            int saveRC = 0 ;

            geographyRec.updateRecStatus ( geographyRec.REC_NOCHANGE ) ;
            geographyRec.setDescript ( newDescript ) ;
            saveRC = geographyRec.writeToDatabase() ;

            if ( saveRC != 0 ) {
               LogSystem.log ( 1, "Could not change TypeGeography to description "+newDescript+". SQLCode:"+saveRC ) ;
               geographyRec.setDescript ( current ) ;
               GUISystem.printBox ( STR_INFO, STR_ERROR_IN_LAST_ACTION ) ;
            } else
               rc = true ;
         }
      }

      return( rc ) ;
   }


   /**
     *  This method will return the authorization level needed
     * to edit this list
     **/
   public int getAuthority () {
      return( AUTH_KEYWORD_TYPE_GEOGRAPHY ) ;
   }


   /**
     *  This method will return a list of TypeGeoRec objects
     *
     * @return Vector
     **/
   public Vector getKeywords () {
      Vector list = TypeList.getInstance().getTypeList ( TypeList.TYPE_GEOGRAPHY ) ;

      list.removeElement ( TypeList.getInstance().objectFromInd ( TypeList.GEO_WORLD_WIDE, TypeList.TYPE_GEOGRAPHY ) ) ;
      return( list ) ;
   }


   /**
     *  This method will return our single column's title
     *
     * @return String[]
     **/
   public String[] getTitles () {
      String[] titles = { Str.getStr ( STR_DESCRIPTION ), "Geography Ind"} ;

      return( titles  );
   }


   /**
     *  The toString method must return the name as well
     **/
   public String toString () {
      return( getName() ) ;
   }


} /* TypeGeographyList */


