package com.ibm.nzna.projects.qit.admin.pers ;    
/*-----------------------------------------------------------*/
/*   Pers                                                    */
/*                                                           */
/*   Description:                                            */
/*      Source code for: Pers                                */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.doc.docmaint.* ;
import javax.swing.* ;
import java.awt.event.* ;
/**
 * This QuestApplet allows an adminstrator to create, edit and delete users from Quest
 *
 *
 * @version 1.0, 1/26/100 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   Pers                                                    */
/*                                                           */
/*-----------------------------------------------------------*/
public class Pers extends Object implements ActionListener, java.io.Serializable, QuestApplet, AppConst, Authority {



   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private static boolean        addedCreatePers    = false ;
   private        JMenuItem      createPersMenuItem = null ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This constructor like all good Quest Applets
    *  does nothing
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public Pers () {
      if ( !addedCreatePers ) {

         addedCreatePers = true ;

         if ( UserSystem.hasAuthority ( AUTH_ADMIN ) ) {
            createPersMenuItem = new JMenuItem ( Str.getStr ( STR_PERSONEL ) ) ;
            createPersMenuItem.addActionListener ( this ) ;
            MainWindow.getInstance().getAppDefaultMenuBar().addCreateMenuItem ( createPersMenuItem ) ;
         }
      }
   }





   /*------------------------------------------------------------*/
   /* getName
    */
   /**
    *    This method will return the name
    *  of this Quest Applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getName () {
      return( Str.getStr ( STR_PERSONEL ) ) ;
   }




   /*------------------------------------------------------------*/
   /* getDescription
    */
   /**
    *    This method will return a user readable
    *  description of this Quest Applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getDescription () {
      return( Str.getStr ( STR_PERSONEL ) ) ;
   }





   /*------------------------------------------------------------*/
   /* canChat
    */
   /**
    *    This method will return TRUE, since
    *  the web browser can chat with other
    *  web browsers
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean canChat () {
      return( true ) ;
   }




   /*------------------------------------------------------------*/
   /* getAuthority
    */
   /**
    *    This method will return 0, since everyone
    *  has access to the browser
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public int getAuthority () {
      return( AUTH_PERS ) ;
   }




   /*------------------------------------------------------------*/
   /* stop
    */
   /**
    *    This method will be called when we need
    *  to clean up and stop our Applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void stop () {
   }




   /*------------------------------------------------------------*/
   /* start
    */
   /**
    *    This method will be called when our
    *  initialization has completed, and we
    *  can now add ourselves to a window
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void start () {         

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add this panel   to the main window                     */
      /*                                                           */
      /*-----------------------------------------------------------*/
      WindowSystem.createPanel ( new PersPanel() ) ;
   }




   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will initialize our browser
    *  bean as well as get everything else
    *  ready
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean initialize () {                                         

      return( true ) ;
   }




   /*------------------------------------------------------------*/
   /* getSmallIcon
    */
   /**
    *    This method will return the small icon
    *  representing this Quest Applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public ImageIcon getSmallIcon () {
      return( ImageSystem.getImageIcon ( this, ImageSystem.SMALL_PERSONEL ) ) ;
   }





   /*------------------------------------------------------------*/
   /* getIcon
    */
   /**
    *    This method will return our normal
    *  sized icon
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return ImageIcon
    *//*---------------------------------------------------------*/
   public ImageIcon getIcon () {
      return( ImageSystem.getImageIcon ( this, ImageSystem.PERSONEL ) ) ;
   }





   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will respond to action events
    *  sent to us
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {
      if ( e.getSource() == createPersMenuItem ) {
         start() ;
      }
   }



} /* Pers */
