package com.ibm.nzna.projects.qit.admin.property ;     
/*-----------------------------------------------------------*/
/*   PropertyPanel                                           */
/*                                                           */
/*   Description:                                            */
/*      Source code for: PropertyPanel                       */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import java.awt.event.* ;
import java.util.* ;
import java.sql.* ;
import javax.swing.* ;
import javax.swing.event.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.qit.print.* ;
import com.ibm.nzna.projects.common.quest.* ;
import com.ibm.nzna.shared.db.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.util.* ;
/**
 * This panel allows a user to alter the TIGRIS.CONSTANTS values. 
 *
 *
 * @version 1.0, 9/11/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   PropertyPanel                                           */
/*                                                           */
/*-----------------------------------------------------------*/
public class PropertyPanel extends JPanel implements PrintPanel, PreviewPanel, ActionListener, ListSelectionListener, AppConst, QuestPanel {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Static Members                                          */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private static String[] propertyTitles = { Str.getStr ( STR_PROPERTY ),
      Str.getStr ( STR_INT_VALUE ),
      Str.getStr ( STR_STRING_VALUE ),
      Str.getStr ( STR_APPLICATION )
   } ;


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private GUI Members                                     */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private MultiList        propertyList      = null ;
   private JTitle           st_PROPERTY       = null ;
   private JLabel           stt_PROPERTY      = null ;
   private JLabel           st_PROPERTY_NAME  = null ;
   private JLabel           st_INT_VALUE      = null ;
   private JTextField       ef_INT_VALUE      = null ;
   private JLabel           st_STRING_VALUE   = null ;
   private JTextField       ef_STRING_VALUE   = null ;
   private JLabel           st_APPLICATION    = null ;
   private JTextField       ef_APPLICATION    = null ;
   private JScrollPane      scr_DESCRIPTION   = null ;
   private JTextArea        mle_DESCRIPTION   = null ;
   private NavPanelWrapper  navPanel          = null ;
   private ActionButton     pb_CLOSE          = null ;
   private ActionButton     pb_NEW            = null ;
   private DButton          pb_SAVE           = null ;      


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private ConstantsRec constantRec     = null ;






   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will simply create an instance of
    *  this panel
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public PropertyPanel () {
   }





   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will initialize the panel
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean initialize () {     

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create our GUI                                          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      propertyList     = new MultiList ( GUISystem.getFontUtil() ) ;
      mle_DESCRIPTION  = new JTextArea () ;
      scr_DESCRIPTION  = new JScrollPane ( mle_DESCRIPTION ) ;
      navPanel         = new NavPanelWrapper ( Str.getStr ( STR_DESCRIPTION ), scr_DESCRIPTION ) ;
      pb_CLOSE         = new ActionButton ( Str.getStr ( STR_CLOSE ), ImageSystem.getImageIcon ( this, ImageSystem.CLOSE ), Str.getStr ( STR_CLOSE ) ) ;
      pb_NEW           = new ActionButton ( Str.getStr ( STR_NEW ), ImageSystem.getImageIcon ( this, ImageSystem.NEW ), Str.getStr ( STR_NEW ) ) ;
      st_PROPERTY      = new JTitle ( Str.getStr ( STR_PROPERTIES ) ) ;        
      stt_PROPERTY     = new JLabel ( Str.getStr ( STR_PROPERTY ) ) ;
      st_PROPERTY_NAME = new JLabel ( "" ) ;
      st_INT_VALUE     = new JLabel ( Str.getStr ( STR_INT_VALUE ) ) ;
      st_STRING_VALUE  = new JLabel ( Str.getStr ( STR_STRING_VALUE ) ) ;
      ef_INT_VALUE     = new JTextField ( new MaskDocument ( MaskDocument.MASKTYPE_NUMERIC, 5 ), "", 0 ) ;
      ef_STRING_VALUE  = new JTextField ( new MaskDocument ( MaskDocument.MASKTYPE_UNKNOWN, 50 ), "", 0 ) ;
      st_APPLICATION   = new JLabel ( Str.getStr ( STR_APPLICATION ) ) ;
      ef_APPLICATION   = new JTextField ( new MaskDocument ( MaskDocument.MASKTYPE_UNKNOWN, 50 ), "", 0 ) ;
      pb_SAVE          = new DButton ( Str.getStr ( STR_SAVE ) ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      propertyList.setBorder ( null ) ;
      propertyList.setColumnHeadings ( propertyTitles ) ;
      propertyList.setColumnWidth ( 0, 200 ) ;
      propertyList.setColumnWidth ( 1, 75 ) ;
      propertyList.setColumnWidth ( 2, 250 ) ;
      propertyList.setColumnWidth ( 3, 250 ) ;
      mle_DESCRIPTION.setFont ( FontSystem.defaultFont ) ;
      mle_DESCRIPTION.setWrapStyleWord ( true ) ;
      mle_DESCRIPTION.setLineWrap ( true ) ;
      st_PROPERTY_NAME.setForeground ( Color.blue ) ;    


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add listeners                                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      propertyList.addListSelectionListener ( this ) ;
      pb_CLOSE.addActionListener ( this ) ;
      pb_SAVE.addActionListener ( this ) ;
      ef_INT_VALUE.addActionListener ( this ) ;
      ef_STRING_VALUE.addActionListener ( this ) ;
      ef_APPLICATION.addActionListener ( this ) ;
      pb_NEW.addActionListener ( this ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add the controls                                        */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( null ) ;
      add ( st_PROPERTY ) ;
      add ( propertyList ) ;
      add ( stt_PROPERTY ) ;
      add ( st_PROPERTY_NAME ) ;
      add ( st_INT_VALUE ) ;
      add ( ef_INT_VALUE ) ;
      add ( st_STRING_VALUE ) ;
      add ( ef_STRING_VALUE ) ;
      add ( st_APPLICATION ) ;
      add ( ef_APPLICATION ) ;
      add ( pb_SAVE ) ;



      return( true ) ;
   }





   /*------------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will layout and position our
    *  controls
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      int       x         = 5 ;
      int       y         = 5 ;
      int       rowHeight = GUISystem.getRowHeight() ;
      Dimension size      = getSize() ;

      super.doLayout () ;

      st_PROPERTY.setBounds ( x, y, size.width-(x*2), rowHeight*2 ) ;
      y+=(rowHeight*2) ;

      propertyList.setBounds ( x, y, size.width-(x*2), size.height-(rowHeight*12) ) ;
      y=size.height-(rowHeight*9) ;

      stt_PROPERTY.setBounds ( x, y, 200, rowHeight ) ;
      st_PROPERTY_NAME.setBounds ( x+200, y, 200, rowHeight ) ;
      y+=rowHeight ;

      st_INT_VALUE.setBounds ( x,     y, 200, rowHeight ) ;
      ef_INT_VALUE.setBounds ( x+200, y, 200, rowHeight ) ;
      y+=rowHeight+2 ;

      st_STRING_VALUE.setBounds ( x, y, 200, rowHeight ) ;
      ef_STRING_VALUE.setBounds ( x+200, y, 200, rowHeight ) ;
      y+=rowHeight+2 ;

      st_APPLICATION.setBounds ( x, y, 200, rowHeight ) ;
      ef_APPLICATION.setBounds ( x+200, y, 200, rowHeight ) ;
      y+=rowHeight+5 ;

      pb_SAVE.setBounds ( x, y, 100, 25 ) ;

   }




   /*------------------------------------------------------------*/
   /* start
    */
   /**
    *    This method will refresh our data and
    *  our action components
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void start () {
      AppDefaultWin parentWin = GUISystem.getParentDefWin ( this ) ;

      parentWin.addActionComponent ( this, pb_CLOSE ) ;
      parentWin.addActionComponent ( this, pb_NEW ) ;
      refresh() ;
   }



   /*------------------------------------------------------------*/
   /* getJComponent
    */
   /**
    *    This method will return an instance of this
    *  panel
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public JComponent getJComponent () {
      return( this ) ;
   }




   /*------------------------------------------------------------*/
   /* getDefaultNavPanel
    */
   /**
    *    This method returns the Default Nav panel which
    *  is simply a JTextArea
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public NavPanel getDefaultNavPanel () {
      return( navPanel ) ;
   }




   /*------------------------------------------------------------*/
   /* copy
    */
   /**
    *    This method does nothing
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean copyText () {
      return( false ) ;
   }


   /*------------------------------------------------------------*/
   /* paste
    */
   /**
    *    This method does nothing
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean pasteText () {
      return( false ) ;
   }


   /*------------------------------------------------------------*/
   /* cutText
    */
   /**
    *    This method does nothing
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean cutText () {
      return( false ) ;
   }





   /*------------------------------------------------------------*/
   /* panelSelected
    */
   /**
    *    This method does nothing
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void panelSelected () {
   }




   /*------------------------------------------------------------*/
   /* panelDeselected
    */
   /**
    *    This method does nothing
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void panelDeselected () {
   }





   /*------------------------------------------------------------*/
   /* stop
    */
   /**
    *    This method will be called when we need
    *  to stop.
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean stop () {
      return( true ) ;
   }





   /*------------------------------------------------------------*/
   /* shutdown
    */
   /**
    *    This method will be called asking us if it
    *  is ok to shutdown
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return True
    *//*---------------------------------------------------------*/
   public boolean shutdown () {
      return( true ) ;
   }





   /*------------------------------------------------------------*/
   /* bookmark
    */
   /**
    *    This method returns FALSE
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean bookmark () {
      return( false ) ;
   }




   /*------------------------------------------------------------*/
   /* getName
    */
   /**
    *    This method will return our name
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getName () {
      return( Str.getStr ( STR_PROPERTIES ) ) ;
   }





   /*------------------------------------------------------------*/
   /* getIcon
    */
   /**
    *    This method will return our icon, a small
    *  court house looking thing
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public ImageIcon getIcon () {
      return( ImageSystem.getImageIcon ( this, ImageSystem.SMALL_PROPERTY_APP ) ) ;
   }




   /*------------------------------------------------------------*/
   /* refresh
    */
   /**
    *    This method will refresh our list
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void refresh () {
      Constants constants    = new Constants() ;
      Vector    constantList = null ;

      GUISystem.getParentDefWin ( this ).setStatus ( Str.getStr ( STR_PLEASE_WAIT ) ) ;
      constants.refreshConstants ( LogSystem.getInstance() ) ;
      constantList = constants.getConstantVector() ;

      propertyList.removeAll() ;
      propertyList.add ( constantList ) ;
      GUISystem.getParentDefWin ( this ).setStatus ( null ) ;
   }





   /*------------------------------------------------------------*/
   /* getDescription
    */
   /**
    *    This method will return the description of
    *  a property from the name of the property
    *  
    *
    *  @param property The name of the property
    *  @param None
    *  @param None
    *
    *  @return String
    *//*---------------------------------------------------------*/
   private String getDescription ( String property ) { 

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   IT_FILEURL                                              */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( property.equals ( "IT_FILEURL" ) )
         return( "This value is prepended to file names that are attached"+
                 "to documents to form a complete URL. For example, if the "+
                 "filename is '/pub/pccbbs/mobiles/mytext.txt' then when the "+
                 "file is attached, the location of the file will be "+
                 "IT_FILEURL/pub/pccbbs/mobiles/mytext.txt" ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   IT_PRODFTP                                              */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( property.equals ( "IT_PRODFTP" ) ) {
         return( "This is the production FTP site to place file attachments "+
                 "that have been published with the Quest Input Tool. This should "+
                 "contain only the host name or I/P Address of the FTP server" ) ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   IT_IMAGELOCTEMP                                         */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( property.equals ( "IT_IMAGELOCTEMP" ) ) {
         return( "This is the location on the TEMPORARY FTP server that draft documents "+
                 "store their Images. The images will only reside in that directory "+
                 "for as long as the document draft is alive." ) ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   IT_IMAGEHOST                                            */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( property.equals ( "IT_IMAGEHOST" ) ) {
         return( "This is the location of the production machine to FTP published "+
                 "graphics in a document to. For example, if a document has 2 graphics and "+
                 "the user publishes the document, those 2 graphics are FTPed to this "+
                 "host. This should be the host name or I/P Address of the FTP site" ) ;
      }


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   IT_FILEHOSTTEMP                                         */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( property.equals ( "IT_FILEHOSTTEMP" ) ) {
         return( "This is the host name of the FTP server to store files for "+
                 "document drafts. If the user creates a new draft with a file attachment "+
                 "and then saves the draft, this FTP site is used to put the file attachments" ) ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   IT_FILELOC                                              */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( property.equals ( "IT_FILELOC" ) ) {
         return( "This is the location on the FTP Server to store files that have been "+
                 "published. If a document has 2 file attachments and the user publishses" +
                 "that document, the file attachments are placed in this location, on the IT_PRODFTP server" ) ;
      }


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   IT_IMAGELOC                                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( property.equals ( "IT_IMAGELOC" ) ) {
         return( "This is the location to put published images on the IT_IMAGEHOST FTP server. "+
                 "If a document has 3 graphics with it and the user publishes the document, all "+
                 "graphics are put in this directory" ) ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   IT_IMAGEHOSTTEMP                                        */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( property.equals ( "IT_IMAGEHOSTTEMP" ) ) {
         return( "This is the FTP site that image files are placed "+
                 "temporarily until a document draft is published. For "+
                 "example, if a document draft has 3 images then when "+
                 "the user saves it, the images are put on this FTP site. "+
                 "This value should be either a host name or preferable an I/P Address" ) ;
      }


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   FILEHOST                                                */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( property.equals ( "IT_FILEHOST" ) ) {
         return( "This is the host name for the FTP site that stores the production "+
                 "file attachments. For example if a document draft has 3 file attachments "+
                 "and the user publishes the document, all file attachments are placed "+
                 "on this FTP site. This should either be the host name or preferably the I/P Address" ) ;
      }


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   IT_FILELOCTEMP                                          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( property.equals ( "IT_FILELOCTEMP" ) ) {
         return( "This is the location on the IT_FILEHOSTTEMP server to "+
                 "place temporary files for document drafts. For example, "+
                 "if a document draft has 3 file attachments and the user "+
                 "saves it, the file attachments are placed in this directory" ) ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   IT_VER                                                  */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( property.equals ( "IT_VER" ) ) {
         return( "DANGER DANGER DANGER DANGER DANGER DANGER. This property "+
                 "tells the Quest Input tool what version it should be at. If this "+
                 "number is different then what is running on the clients, then the "+
                 "quest input tool will auto-update itself" ) ;
      }


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   IT_OA_FTP_IMG_DRAFT                                     */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( property.equals ( "IT_OA_FTP_IMG_DRFT" ) ) {
         return( "This is the FTP site for images to be placed while an Avalon "+
                 "object is in draft mode. For example, if an Action has 3 graphics and "+
                 "the user saves it, the graphics will be placed on this FTP server. "+
                 "This should be either the host name or I/P Address" ) ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   IT_OA_FTP_IMG_LOC_DRFT                                  */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( property.equals ( "IT_OA_FTP_IMG_LOC_DRFT" ) ) {
         return( "This is the the location on the IT_OA_FTP_IMG_DRFT "+
                 "server that temporary graphics are placed while a draft "+
                 "object in Avalon is alive. For example, if an Action has 3 graphics and "+
                 "the user saves it, the graphics will be placed on this FTP server. " ) ;
      }


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   IT_OA_FTPIMG_LOC_PUB                                    */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( property.equals ( "IT_OA_FTP_IMG_LOC_PUB" ) ) {
         return( "This is the location on the IT_OA_FTP_IMG_PUB "+
                 "server that graphics are published to. For example, "+
                 "if an Action has 3 graphics and the user publishes it, "+
                 "the graphics are put in this directory on the FTP server" ) ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   IT_OA_IMG_PUB                                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( property.equals ( "IT_OA_FTP_IMG_PUB" ) ) {
         return( "This is the host name of the FTP site where published "+
                 "graphics are stored. For example, if the user has an Action Draft "+
                 "and that Action has 3 graphics and they publish the Action, the "+
                 "graphics are placed on this FTP site. This should be either the "+
                 "host name or I/P Address of the FTP site" ) ;
      }


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   IT_HELP_URL                                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( property.equals ( "IT_HELP_URL" ) ) {
         return( "This is the base URL of all Help files. For example, if the "+
                 "help files are placed on the root of bigdawg, then this url would be "+
                 "http://bigdawg.raleigh.ibm.com" ) ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   IT_CLIOSERVER                                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( property.equals ( "IT_CLIOSERVER" ) ) {
         return( "This is the server that is housing the CLIO database. This should "+
                 "be the full host name or I/P Address" ) ;
      }


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   IT_DEBUG_EMAIL                                          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( property.equals ( "IT_DEBUG_EMAIL" ) ) {
         return( "This is the eMail Address that the Quest Client will eMail if the "+
                 "user chooses to send the QUEST.DEBUG file" ) ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   IT_DEBUG_SMTP                                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( property.equals ( "IT_DEBUG_SMTP" ) ) {
         return( "This is the host name or IP Address of the SMTP server that "+
                 "the Quest client uses to send a Quest.Debug file" ) ;
      }


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   IT_CLIOPORTNUM                                          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( property.equals ( "IT_CLIOPORTNUM" ) ) {
         return( "This is the port number that db2jstrt is listening on the "+
                 "IT_CLIOSERVER server for the CLIO database" ) ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   IT_CLIODBNAME                                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( property.equals ( "IT_CLIODBNAME" ) ) {
         return( "This is the name of the database on the IT_CLIOSERVER "+
                 "that Quest will attempt to connect to" ) ;
      }

      return( "No Description yet" ) ;
   }




   /*------------------------------------------------------------*/
   /* valueChanged
    */
   /**
    *    This method will be called when the user
    *  selects an item in our propertyList
    *  
    *
    *  @param e The event
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void valueChanged ( ListSelectionEvent e ) {

      constantRec = (ConstantsRec) propertyList.getSelectedItem() ;

      mle_DESCRIPTION.setText ( getDescription ( constantRec.getConstant() ) ) ;

      ef_INT_VALUE.setText    ( ""+constantRec.getIntValue() ) ;
      ef_STRING_VALUE.setText ( ""+constantRec.getStringValue() ) ;
      ef_APPLICATION.setText  ( ""+constantRec.getApplication() ) ;
   }





   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will be called when an action
    *  event is fired on us
    *  
    *
    *  @param e The event
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   PB_CLOSE                                                */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( e.getSource() == pb_CLOSE )
         GUISystem.getParentDefWin ( this ).closePanel ( this, null ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   PB_SAVE                                                 */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( ( e.getSource() == pb_SAVE ) || ( e.getSource() == ef_APPLICATION ) )
         save() ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_NEW                                                  */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_NEW )
         newConstant() ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   ef_INT_VALUE                                            */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == ef_INT_VALUE )
         ef_STRING_VALUE.requestFocus() ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   ef_STRING_VALUE                                         */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == ef_STRING_VALUE )
         ef_APPLICATION.requestFocus() ;
   }





   /*------------------------------------------------------------*/
   /* save
    */
   /**
    *    This method saves the information on the 
    *  screen
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void save () {
      SQLMethod sqlMethod = new SQLMethod ( DatabaseSystem.QUEST, "PropertyPanel.save", 5 ) ;

      constantRec.setIntValue    ( new Integer ( ef_INT_VALUE.getText() ).intValue() ) ;
      constantRec.setStringValue ( ef_STRING_VALUE.getText() ) ;
      constantRec.setApplication ( ef_APPLICATION.getText() ) ;

      try {
         Statement stmt = sqlMethod.createStatement() ;

         if ( stmt != null ) {
            stmt.executeUpdate ( "UPDATE TIGRIS.CONSTANTS "+
                                 "SET INTCONST    = "+constantRec.getIntValue()+", "+
                                 "    STRCONST    = '"+constantRec.getStringValue()+"', "+
                                 "    APPLICATION = '"+constantRec.getApplication()+"' "+
                                 "WHERE CONSTANT = '"+constantRec.getConstant()+"'" ) ;
         }

         GUISystem.printBox ( STR_INFO, STR_SAVED ) ;
         propertyList.repaint() ;

      } catch ( Exception e ) {
         sqlMethod.rollBack() ;
         LogSystem.log ( 1, e, false ) ;
         GUISystem.printBox ( STR_ERROR, STR_ERROR_IN_LAST_ACTION ) ;
      }

      sqlMethod.close() ;
   }





   /*------------------------------------------------------------*/
   /* newConstant
    */
   /**
    *    This method will create a new constant
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void newConstant() {
      String constantName = new SingleEntryDlg ( GUISystem.getParentDefWin ( this ), 
                                                 "New Constant", 
                                                 "Please enter the name of the new constant", "", "" ).getResult() ;

      if ( ( constantName != null ) && ( constantName.length() > 0 ) ) {
         SQLMethod sqlMethod = new SQLMethod ( DatabaseSystem.QUEST, "newConstant", 5 ) ;

         try {
            Statement stmt = sqlMethod.createStatement() ;

            stmt.executeUpdate ( "INSERT INTO TIGRIS.CONSTANTS VALUES ( '"+constantName+"', 0, ' ', ' ', user, current timestamp)") ;

            constantRec = new ConstantsRec ( constantName, 0, " ", " " ) ;
            propertyList.add ( constantRec ) ;
            propertyList.setSelectedItem ( constantRec, true ) ;

         } catch ( Exception e ) {
            sqlMethod.rollBack() ;
            LogSystem.log ( 1, e, false ) ;
            GUISystem.printBox ( STR_INFO, STR_ERROR_IN_LAST_ACTION ) ;
         }

         sqlMethod.close() ;
      }
   }
    /**
    *  This method will give the Print support to the panel
    **/
   public Object getPrintObject() {
      return( new Print ( propertyList, GUISystem.getParentDefWin ( this ), Str.getStr ( STR_DOCUMENTS ) ) ) ;
   }
    /**
    *  This method will give the Preview support to the panel
    **/
   public Object getPreviewObject() {
      return( new Preview ( propertyList, GUISystem.getParentDefWin ( this ), Str.getStr ( STR_DOCUMENTS ) ) ) ;
   }

} /* PropertyPanel */
