package com.ibm.nzna.projects.qit.admin.stats ;    
/*-----------------------------------------------------------*/
/*   StatsNavPanel                                           */
/*                                                           */
/*   Description:                                            */
/*      Source code for:                                     */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import java.util.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.util.* ;
/**
 * This is the navigation panel that appears with this StatsPanel 
 *
 *
 * @version 1.0, 7/10/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   StatsNavPanel                                           */
/*                                                           */
/*-----------------------------------------------------------*/
public class StatsNavPanel extends JPanel implements ActionListener, Runnable, AppConst, NavPanel {



   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Controls                                                */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private UserEntryPanel ef_USERID        = null ;
   private JLabel         st_HELP          = null ;
   private HotLinkLabel   pb_DOCS_CHANGE   = null ;
   private HotLinkLabel   pb_DOCS_NOCHANGE = null ;
   private HotLinkLabel   pb_PRODUCTS      = null ;
   private NavListGroup   exportPanel      = null ;
   private JLabel         st_USERID        = null ;      
   private JLabel         st_EXPORT_TYPE   = null ;
   private JComboBox      cb_EXPORT_TYPE   = null ;
   private DateEntryField ef_DATE          = null ;
   private JLabel         st_DATE          = null ;
   private JLabel         st_TODATE        = null ;
   private DateEntryField ef_TODATE        = null ;

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private Vector actionListeners    = null ;
   private int    lastSelectedExport = 0 ;





   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will initialize our control
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void initialize () {          
      Vector       typeVec = new Vector ( 1, 1 ) ;
      HotLinkGroup group   = new HotLinkGroup() ;

      typeVec.addElement ( Str.getStr ( STR_COMMA_SEPARATED ) ) ;
      typeVec.addElement ( Str.getStr ( STR_HTML ) ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create our controls                                     */
      /*                                                           */
      /*-----------------------------------------------------------*/
      st_DATE          = new JLabel ( "From Date" ) ;
      ef_DATE          = new DateEntryField() ;
      st_TODATE        = new JLabel ( "To Date" ) ;
      ef_TODATE        = new DateEntryField() ;
      ef_USERID        = new UserEntryPanel ( ) ;
      st_USERID        = new JLabel ( "User Id" ) ;
      st_HELP          = new JLabel ( Str.getStr ( STR_STATS_NAV_HELP ) ) ;        
      exportPanel      = new NavListGroup ( Str.getStr ( STR_EXPORT ) ) ;
      pb_DOCS_CHANGE   = new HotLinkLabel ( Str.getStr ( STR_CHANGED_DOCS ) ) ;
      pb_DOCS_NOCHANGE = new HotLinkLabel ( Str.getStr ( STR_NOCHANGED_DOCS ) ) ;
      pb_PRODUCTS      = new HotLinkLabel ( Str.getStr ( STR_PRODUCTS ) ) ;
      st_EXPORT_TYPE   = new JLabel ( Str.getStr ( STR_EXPORT_TYPE ) ) ;
      cb_EXPORT_TYPE   = new JComboBox ( typeVec ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setBackground ( Color.white ) ;
      ef_USERID.setBackground ( Color.white ) ;
      st_HELP.setOpaque ( false ) ;  
      st_USERID.setOpaque ( false ) ;
      exportPanel.setOpaque ( false ) ;
      ef_DATE.setBackground ( Color.white ) ;
      setBackground ( Color.white ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add listeners                                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      exportPanel.addActionListener ( this ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add our GUI                                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      group.add ( pb_DOCS_CHANGE ) ;
      group.add ( pb_DOCS_NOCHANGE ) ;
      group.add ( pb_PRODUCTS ) ;
      exportPanel.add ( pb_DOCS_CHANGE ) ;
      exportPanel.add ( pb_DOCS_NOCHANGE ) ;
      exportPanel.add ( pb_PRODUCTS ) ;
      add ( st_USERID ) ;
      add ( ef_USERID ) ;
      add ( st_EXPORT_TYPE ) ;
      add ( cb_EXPORT_TYPE ) ;
      add ( st_DATE ) ;
      add ( ef_DATE ) ;
      add ( st_TODATE ) ;
      add ( ef_TODATE ) ;
      add ( st_HELP ) ;
      add ( exportPanel ) ;


      ef_TODATE.setText ( new CDate ( CDate.DATE_DATE ).today() ) ;
   }






   /*------------------------------------------------------------*/
   /* start
    */
   /**
    *    This method will start the control. This means that
    *  the control has been initialized and is now showing
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void start () {       

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Expand the Stats                                        */
      /*                                                           */
      /*-----------------------------------------------------------*/
      exportPanel.expand() ;

   }





   /*------------------------------------------------------------*/
   /* stop
    */
   /**
    *    This method means that someone has closed
    *  the control
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void stop () {
   }




   /*------------------------------------------------------------*/
   /* getTitle
    */
   /**
    *    This method will return our title
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getTitle () {
      return( Str.getStr ( STR_TITLE ) ) ;
   }




   /*------------------------------------------------------------*/
   /* getJComponent
    */
   /**
    *    This method will return an instance of this
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return JComponent
    *//*---------------------------------------------------------*/
   public JComponent getJComponent () {
      return( this ) ;
   }





   /*------------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will lay out and position all of
    *  our controls
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size      = getSize () ;
      int       rowHeight = GUISystem.getRowHeight () ;
      int       x         = 5 ;
      int       y         = 15 ;

      st_USERID.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight ;

      ef_USERID.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight ;

      st_EXPORT_TYPE.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight ;

      cb_EXPORT_TYPE.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=(rowHeight) ;

      st_DATE.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight ;
      ef_DATE.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight ;

      st_TODATE.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight ;

      ef_TODATE.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight*2 ;

      exportPanel.setBounds ( x, y, size.width-(x*2), size.height-y-160 ) ;
      y+=rowHeight*2 ;

      st_HELP.setBounds ( x, y, size.width-(x*2), size.height-y ) ;
   }





   /*------------------------------------------------------------*/
   /* addActionListener
    */
   /**
    *    This method will add an action listener to 
    *  this nav panel
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void addActionListener ( ActionListener listener ) {
      if ( actionListeners == null )
         actionListeners = new Vector ( 1 ) ;

      actionListeners.addElement ( listener ) ;
   }




   /*------------------------------------------------------------*/
   /* removeActionListener
    */
   /**
    *    This method will remove an action listener
    *  from this nav panel
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void removeActionListener ( ActionListener listener ) {
      if ( actionListeners != null )
         actionListeners.removeElement ( listener ) ;

      if ( actionListeners.size() == 0 )
         actionListeners = null ;
   }





   /*------------------------------------------------------------*/
   /* notifyListeners
    */
   /**
    *    This method will go through the actionListeners Vector and notify everyone 
    *  of an Action Event
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void notifyListeners () {
      if ( actionListeners != null ) {
         int         i           = 0 ;
         int         size        = actionListeners.size() ;
         ActionEvent actionEvent = new ActionEvent ( this, 0, null ) ;

         while ( i < size ) {
            ((ActionListener)actionListeners.elementAt(i)).actionPerformed ( actionEvent ) ;
            i++ ;
         }
      }
   }





   /*------------------------------------------------------------*/
   /* run
    */
   /**
    *    This thread will kick off the notifyListeners
    *  method. Which in turn notifies all of our listeners
    *  of an action event
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void run () {
      notifyListeners () ;
   }





   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will be called when an action
    *  event we are waiting for has been fired
    *  
    *
    *  @param e The ActionEvent
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {                           

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   First, note what export was selected                    */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( e.getSource() == pb_DOCS_CHANGE )
         lastSelectedExport = StatsPanel.EXPORT_DOCUMENT_CHANGES ;
      else if ( e.getSource() == pb_DOCS_NOCHANGE )
         lastSelectedExport = StatsPanel.EXPORT_DOCUMENT_NOCHANGES ;
      else if ( e.getSource() == pb_PRODUCTS )
         lastSelectedExport = StatsPanel.EXPORT_PRODUCTS ;


      new Thread ( this ).start() ;
   }





   /*------------------------------------------------------------*/
   /* getSelectedExport
    */
   /**
    *    This method will return the last selected
    *  export from the user
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return int An Export identifier as defined in StatsPanel.java
    *//*---------------------------------------------------------*/
   protected int getSelectedExport () {
      return( lastSelectedExport ) ;
   }




   /*------------------------------------------------------------*/
   /* getUserId
    */
   /**
    *    This method will return the User Id that 
    *  is entered into the User Id Field
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String The User Id, NULL if no User was entered
    *//*---------------------------------------------------------*/
   protected String getUserId () {
      UserRec userRec = ef_USERID.getUserRecNoLookup() ;

      if ( userRec != null )
         return( userRec.getUserId() ) ;

      return( null ) ;

   }





   /*------------------------------------------------------------*/
   /* getExportType
    */
   /**
    *    This method will return the String representation
    *  of the Export Type
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   protected String getExportType ( ) {
      return ( (String)cb_EXPORT_TYPE.getSelectedItem() ) ;
   }


   /**
     * this method will return the date that is entered
     **/
   protected String getDate () {
      return ( ef_DATE.getText() ) ;
   }

   protected String getToDate () {
      return ( ef_TODATE.getText() ) ;
   }

} /* StatsNavPanel */
