package com.ibm.nzna.projects.qit.admin.teammaint ;    
/*-----------------------------------------------------------*/
/*   TeamMaint                                               */
/*                                                           */
/*   Description:                                            */
/*      Source code for: TeamMaint                           */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.doc.docmaint.* ;
import javax.swing.* ;
import java.awt.event.* ;
/**
 * This QuestApplet allows an author to create and maintain Teams of users
 * in the Quest database. The user must have AUTH_TEAM_MAINT to use this application
 *
 *
 * @version 1.0, 1/26/100 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   TeamMaint                                               */
/*                                                           */
/*-----------------------------------------------------------*/
public class TeamMaint extends Object implements ActionListener, java.io.Serializable, QuestApplet, AppConst, Authority {



   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private        TeamMaintPanel teamMaintPanel          = null ;
   private static boolean        addedCreateTeamMaint    = false ;
   private        JMenuItem      createTeamMaintMenuItem = null ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This constructor like all good Quest Applets
    *  does nothing
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public TeamMaint () {
      if ( !addedCreateTeamMaint ) {

         addedCreateTeamMaint = true ;

         if ( UserSystem.hasAuthority ( AUTH_TEAM_MAINT ) ) {
            createTeamMaintMenuItem = new JMenuItem ( Str.getStr ( STR_TEAM ) ) ;
            createTeamMaintMenuItem.addActionListener ( this ) ;
            MainWindow.getInstance().getAppDefaultMenuBar().addCreateMenuItem ( createTeamMaintMenuItem ) ;
         }
      }
   }





   /*------------------------------------------------------------*/
   /* getName
    */
   /**
    *    This method will return the name
    *  of this Quest Applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getName () {
      return( Str.getStr ( STR_TEAMS ) ) ;
   }




   /*------------------------------------------------------------*/
   /* getDescription
    */
   /**
    *    This method will return a user readable
    *  description of this Quest Applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getDescription () {
      return( Str.getStr ( STR_TEAMS ) ) ;
   }





   /*------------------------------------------------------------*/
   /* canChat
    */
   /**
    *    This method will return TRUE, since
    *  the web browser can chat with other
    *  web browsers
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean canChat () {
      return( true ) ;
   }




   /*------------------------------------------------------------*/
   /* getAuthority
    */
   /**
    *    This method will return 0, since everyone
    *  has access to the browser
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public int getAuthority () {
      return( AUTH_TEAM_MAINT ) ;
   }




   /*------------------------------------------------------------*/
   /* stop
    */
   /**
    *    This method will be called when we need
    *  to clean up and stop our Applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void stop () {
   }




   /*------------------------------------------------------------*/
   /* start
    */
   /**
    *    This method will be called when our
    *  initialization has completed, and we
    *  can now add ourselves to a window
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void start () {         

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add this panel   to the main window                     */
      /*                                                           */
      /*-----------------------------------------------------------*/
      WindowSystem.createPanel ( teamMaintPanel ) ;
   }




   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will initialize our browser
    *  bean as well as get everything else
    *  ready
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean initialize () {                                         

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   First, create our panel that holds the browser          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      teamMaintPanel = new TeamMaintPanel () ;                          
      return( true ) ;
   }




   /*------------------------------------------------------------*/
   /* getSmallIcon
    */
   /**
    *    This method will return the small icon
    *  representing this Quest Applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public ImageIcon getSmallIcon () {
      return( ImageSystem.getImageIcon ( this, ImageSystem.SMALL_TEAMS ) ) ;
   }





   /*------------------------------------------------------------*/
   /* getIcon
    */
   /**
    *    This method will return our normal
    *  sized icon
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return ImageIcon
    *//*---------------------------------------------------------*/
   public ImageIcon getIcon () {
      return( ImageSystem.getImageIcon ( this, ImageSystem.TEAMS ) ) ;
   }





   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will respond to action events
    *  sent to us
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {
      if ( e.getSource() == createTeamMaintMenuItem ) {
         initialize() ;
         start() ;
      }
   }



} /* TeamMaint */
