package com.ibm.nzna.projects.qit.admin.teammaint ;    
/*-----------------------------------------------------------*/
/*   TeamNavPanel                                            */
/*                                                           */
/*   Description:                                            */
/*      Source code for: TeamNavPanel                        */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.shared.gui.* ;
import javax.swing.* ;
import java.awt.* ;
import java.awt.event.* ;
import java.util.* ;
/**
 * This navigation panel is used in the TeamMaintPanel. It holds 
 *
 *
 * @version 1.0, 4/9/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   TeamNavPanel                                            */
/*                                                           */
/*-----------------------------------------------------------*/
public class TeamNavPanel extends JPanel implements NavPanel, AppConst, ActionListener {



   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private GUI Members                                     */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private NavList        navList        = null ;
   private TeamMaintPanel teamMaintPanel = null ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will only assign our local vars
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public TeamNavPanel ( TeamMaintPanel teamMaintPanel ) {
      this.teamMaintPanel = teamMaintPanel ;
   }


   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will create our Nav Panel
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void initialize () {
      JScrollPane scrollPane = null ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create our GUI                                          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      navList = new NavList () ;        

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add listeners                                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      navList.addActionListener ( this ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add our GUI                                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( new BorderLayout () ) ;
      add ( scrollPane = new JScrollPane ( navList ), BorderLayout.CENTER ) ;
      scrollPane.getVerticalScrollBar().setUnitIncrement ( GUISystem.getRowHeight() ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add all teams to the navList                            */
      /*                                                           */
      /*-----------------------------------------------------------*/
      refreshList() ;


   }


   /*------------------------------------------------------------*/
   /* start
    */
   /**
    *    This method will be called once we are showing
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void start () {
   }




   /*------------------------------------------------------------*/
   /* stop
    */
   /**
    *    This method will be called when we are
    *  removed and need to clean up resources
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void stop () {
      removeAll() ;
   }




   /*------------------------------------------------------------*/
   /* getTitle
    */
   /**
    *    This method will return our title
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getTitle () {
      return( Str.getStr ( STR_TEAMS ) ) ;
   }




   /*------------------------------------------------------------*/
   /* getJComponent
    */
   /**
    *    This method will return our JComponent
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public JComponent getJComponent () {
      return( this ) ;
   }





   /*------------------------------------------------------------*/
   /* refreshList
    */
   /**
    *    This method will remove all teams from
    *  our list and add them all back
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   protected void refreshList () {
      Vector teamVec = TypeList.getInstance().getTypeList ( TypeList.TYPE_TEAM ) ;

      navList.removeAll() ;
      new com.ibm.nzna.shared.sort.QuickSort ( teamVec ) ;

      if ( teamVec != null ) {
         HotLinkLabel hotLinkLabel = null ;
         HotLinkGroup group        = new HotLinkGroup() ;
         int          i            = 0 ;
         int          size         = teamVec.size() ;

         while ( i < size ) {
            if ( ((TypeTeamRec)teamVec.elementAt(i)).valid() ) {
               navList.add ( hotLinkLabel = new HotLinkLabel ( ((TypeTeamRec)teamVec.elementAt(i)).getShortDescript(),
                                                               0,
                                                               teamVec.elementAt(i) ) ) ;
               group.add ( hotLinkLabel ) ;
            }
            i++ ;
         }
      }

   }





   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will be called when one of the
    *  buttons in the navList are hit
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {
      if ( e.getSource() instanceof HotLinkLabel ) {
         HotLinkLabel label    = (HotLinkLabel) e.getSource() ;
         TypeTeamRec  teamRec  = (TypeTeamRec) label.getData() ;

         teamMaintPanel.setTeamRec ( teamRec ) ;
      }
   }

} /* TeamNavPanel */
