package com.ibm.nzna.projects.qit.app ;
/*-----------------------------------------------------------*/
/*   Authority                                               */
/*                                                           */
/*   Description:                                            */
/*      Source code for: Authority                           */
/*                                                           */
/*                                                           */
/*         @Copyright  1997 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This class holds all of the hard coded static Authorities
 *
 *
 * @version 1.0, 4/20/1998 
 * @author  David Lentz
 */
public interface Authority {

    /**
      * Default authority saying that no authority is required
      */
    public static final short AUTH_NOAUTHREQ             = 0 ;

    /**
      * This is the 'Development and Services' Super User authority
      */
    public static final short AUTH_SUPERUSER             = 1 ;

    /**
      * This is the Admnistration Authority
      */
    public static final short AUTH_ADMIN                 = 2 ;

    /**
      * This is the authority to see the Product Maintenance Applet
      * on the workspace.
      */
    public static final short AUTH_PRODMAINT             = 3 ;   

    /**
      * This is the authority to see the Document Maintenance 
      * applet on the workspace.
      */
    public static final short AUTH_DOCMAINT              = 4 ;   

    /**
      * This is the Author Authority for Docuemnts
      */
    public static final short AUTH_AUTHOR                = 5 ;

    /**
      * This is the Authority to muck with the Aptiva Brand
      */
    public static final short AUTH_APTIVA                = 6 ;
    
    /**
      * This is the Authority to muck with the Cross Brand Brand
      */
    public static final short AUTH_CROSS_BRAND           = 7 ;

    /**
      * This is the Authority to muck with the Thinkpad Brand
      */
    public static final short AUTH_THINKPAD              = 8 ;

    /**
      * This is the Authority to muck with the Options Brand
      */
    public static final short AUTH_OPTIONS               = 9 ;

    /**
      * This is the Authority to muck with the Ambra Brand
      */
    public static final short AUTH_AMBRA                 = 10 ;

    /**
      * This is the Authority to muck with the Intellistation Brand
      */
    public static final short AUTH_INTELLISTATION        = 11 ;

    /**
      * This is the Authority to muck with the Monitors Brand
      */
    public static final short AUTH_MONITORS              = 12 ;

    /**
      * This is the Authority to muck with the PC Brand
      */
    public static final short AUTH_PC                    = 13 ;

    /**
      * This is the Authority to muck with the PC Server Brand
      */
    public static final short AUTH_PC_SERVER             = 14 ;

    /**
      * This is the Authority to muck with the Power PC Brand
      */
    public static final short AUTH_POWER_PC              = 15 ;

    /**
      * This is the Authority to create Custom Views that go 
      * across an entire team
      */
    public static final short AUTH_CUSTOMQUERYGROUP      = 17 ;

    /**
      * This is the authority for the Web Customer Management piece
      */
    public static final short AUTH_CLIOEDITOR            = 18 ;

    /**
      * This is the authority so that Proactive eMail icon will
      * show on the workspace
      */
    public static final short AUTH_PROACTIVEEMAILADMIN   = 19 ;

    /**
      * This is the Requestor authority for documents
      */
    public static final short AUTH_REQUESTOR             = 20 ;

    /**
      * This is the authority so that people will see the 
      * FTP Explorer icon on their workspace
      */
    public static final short AUTH_FTPEXPLORER           = 21 ;

    /**
      * This is the authority saying that the user may delete
      * information from f3 or ftp
      */
    public static final short AUTH_FTPEXPLORER_DELETE    = 22 ;

    /**
      * This is the authority saying that the user may create
      * information on f3 or ftp
      */
    public static final short AUTH_FTPEXPLORER_INSERT    = 23 ;

    /**
      * This is the authority saying that the user may update
      * information on f3 or ftp
      */
    public static final short AUTH_FTPEXPLORER_UPDATE    = 24 ;


    /**
      * Avalon authorities. Will document if project ever
      * comes back alive.
      */
    public static final short AUTH_AVALON                = 26 ;
    public static final short AUTH_AVALON_APTIVA         = 27 ;
    public static final short AUTH_AVALON_CROSS_BRAND    = 28 ;
    public static final short AUTH_AVALON_THINKPAD       = 29 ;
    public static final short AUTH_AVALON_OPTIONS        = 30 ;
    public static final short AUTH_AVALON_AMBRA          = 31 ;
    public static final short AUTH_AVALON_INTELLISTATION = 32 ;
    public static final short AUTH_AVALON_MONITORS       = 33 ;
    public static final short AUTH_AVALON_IBM_PC         = 34 ;
    public static final short AUTH_AVALON_IBM_PC_SERVER  = 35 ;
    public static final short AUTH_AVALON_POWER_PC       = 36 ;   
    public static final short AUTH_AVALON_NETWORK_PC     = 37 ;


    /**
      * This authority will add the Team Maintenance icon 
      * to the workspace.
      */
    public static final short AUTH_TEAM_MAINT            = 38 ;  

    /**
      * This authority allows a user to unlock documents
      */
    public static final short AUTH_UNLOCK_DOCUMENTS     = 39 ;

    /**
      * This authority allows a user to unlock products
      */
    public static final short AUTH_UNLOCK_PRODUCTS      = 40 ;

    /**
      *  This authority allows a user to get into the Brand Management applet
      **/
    public static final short AUTH_BRAND_MANAGEMENT      = 41 ;


    /* Below here are the new ones  */
    /**-------------------------------------------------------------------------------------
    /**-------------------------------------------------------------------------------------
    /**-------------------------------------------------------------------------------------
    /**-------------------------------------------------------------------------------------
    /**-------------------------------------------------------------------------------------
    /**-------------------------------------------------------------------------------------
    /**-------------------------------------------------------------------------------------
    /**-------------------------------------------------------------------------------------
    /**-------------------------------------------------------------------------------------
    /**-------------------------------------------------------------------------------------
    /**-------------------------------------------------------------------------------------
    /**-------------------------------------------------------------------------------------
    /**-------------------------------------------------------------------------------------
    /**-------------------------------------------------------------------------------------
    /**-------------------------------------------------------------------------------------
    /**-------------------------------------------------------------------------------------
    /**-------------------------------------------------------------------------------------
    /**-------------------------------------------------------------------------------------
    /**
      *  This authority allows the user to edit the TypeDate list
      **/
    public static final short AUTH_KEYWORD_TYPE_DATE  = 42 ;

    /**
      *  This authority allows the user to get into the Keyword Management Applet
      **/
    public static final short AUTH_KEYWORD_MANAGEMENT = 43 ;

    /**
      *  This authority allows the user to get into the Keyword Management Applet
      **/
    public static final short AUTH_KEYWORD_TYPE_COUNTRY = 44 ;

    /**
      *  This authority allows the user to edit Document Categories in the Keyword Management Applet
      **/
    public static final short AUTH_KEYWORD_TYPE_DOC_CATEGORY = 45 ;

    /**
      *  This authority allows the user to edit Offerings in the Keyword Management Applet
      **/
    public static final short AUTH_KEYWORD_TYPE_OFFERING = 46 ;

    /**
      *  This authority allows the user to edit Customers in the Keyword Management Applet
      **/
    public static final short AUTH_KEYWORD_TYPE_CUSTOMER = 47 ;

    /**
      *  This authority allows the user to edit Cancel Types in the Keyword Management Applet
      **/
    public static final short AUTH_KEYWORD_TYPE_CANCEL = 48 ;

    /**
      *  This authority allows the user to edit Product Types in the Keyword Management Applet
      **/
    public static final short AUTH_KEYWORD_TYPE_PRODUCT = 49 ;

    /**
      *  This authority allows the user to edit Warranty Types in the Keyword Management Applet
      **/
    public static final short AUTH_KEYWORD_TYPE_WARRANTY = 50 ;

    /**
      *  This authority allows the user to edit users in Quest, giving them the Personel App
      **/
    public static final short AUTH_PERS = 51 ;

    /**
      *  This authority allows the user to add/edit/delete/move families in Brand Management
      **/
    public static final short AUTH_FAMILY_KEYWORD = 52 ;

    /**
      *  This authority allows the user to edit geography items in Keyword Mgmt
      **/
    public static final short AUTH_KEYWORD_TYPE_GEOGRAPHY = 53 ;


    /**
      *  This authority allows the user to add/edit/delete/move machines in BRand Managament
      **/
    public static final short AUTH_MACHINE_KEYWORD = 54 ;


    /**
      *  This authority allows the user to use the Document Check applet
      **/
    public static final short AUTH_DOCUMENT_CHECK = 55 ;

    /**
      *  This is the authority that allows the user to run statistics
      **/
    public static final short AUTH_STATISTICS = 56 ;
}
