package com.ibm.nzna.projects.qit.app ;              
/*-----------------------------------------------------------*/
/*   DebugSenderInfoStep                                     */
/*                                                           */
/*   Description:                                            */
/*      Source code for: DebugSenderInfoStep                 */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import javax.swing.* ;
import com.ibm.nzna.shared.gui.wizard.* ;      
import com.ibm.nzna.shared.gui.* ;      
import com.ibm.nzna.shared.util.* ;      
/**
 * This step asks the user for their PR# and Description of the problem 
 *
 *
 * @version 1.0, 1/24/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   DebugSenderInfoStep                                     */
/*                                                           */
/*-----------------------------------------------------------*/
public class DebugSenderInfoStep extends WizardStep implements AppConst {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private JLabel       st_PR        = new JLabel ( Str.getStr ( STR_PR_NUM ) ) ;
   private JTextField   ef_PR        = new JTextField ( new MaskDocument ( MaskDocument.MASKTYPE_NUMERIC, 15 ), "", 0 ) ;
   private JLabel       st_DESCRIPT  = new JLabel ( Str.getStr ( STR_DESCRIPTION ) ) ;
   private JTextArea    mle_DESCRIPT = new JTextArea () ;
   private JScrollPane  scr_DESCRIPT = new JScrollPane ( mle_DESCRIPT ) ;


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Local Private Vars                                      */         
   /*                                                           */
   /*-----------------------------------------------------------*/
   private String pr       = null ;
   private String descript = null ;
   





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This default construtor initializes and adds
    *  our GUI Components
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public DebugSenderInfoStep () {          

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      mle_DESCRIPT.setFont ( FontSystem.defaultFont ) ;
      mle_DESCRIPT.setLineWrap ( true ) ;
      mle_DESCRIPT.setWrapStyleWord ( true ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add our GUI                                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( null ) ;
      add ( st_PR ) ;
      add ( ef_PR ) ;
      add ( st_DESCRIPT ) ;
      add ( scr_DESCRIPT ) ;

   }





   /*------------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will lay out and position all of
    *  our controls
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size      = getSize() ;
      int       rowHeight = GUISystem.getRowHeight () ;
      int       y         = 5 ;
      int       txtWidth  = st_PR.getPreferredSize().width ;

      super.doLayout () ;

      st_PR.setBounds ( 0, y, txtWidth, rowHeight ) ;
      ef_PR.setBounds ( txtWidth, y, (size.width/2)-5, rowHeight ) ;
      y+=rowHeight*2 ;

      st_DESCRIPT.setBounds ( 0, y, size.width, rowHeight ) ;
      y+=rowHeight ;

      scr_DESCRIPT.setBounds ( 0,y, size.width-5, size.height-y-rowHeight ) ;
   }


   /*------------------------------------------------------------*/
   /* getTitle
    */
   /**
    *    returns the title of this panel to show above
    *  it in the wizard
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getTitle () {
      return( Str.getStr ( STR_DEBUG_WIZARD_INFORMATION ) ) ;
   }




   /*------------------------------------------------------------*/
   /* refreshInfo
    */
   /**
    *    This method will refresh our information
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void refreshInfo () {
      ef_PR.requestFocus () ;
   }




   /*------------------------------------------------------------*/
   /* saveInfo
    */
   /**
    *    This method will attempt to save the information. If
    *  the PR is not there or the description is too short
    *  then this method returns FALSE
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean saveInfo () {
      pr       = ef_PR.getText() ;
      descript = mle_DESCRIPT.getText() ;

      if ( pr == null ) 
         GUISystem.printBox ( WinUtil.getParentJDialog ( this ), "Error", "You must supply a valid PR Number. You can call 1-800-IBM-HELP to acquire one" ) ;
      else if ( descript == null ) 
         GUISystem.printBox ( WinUtil.getParentJDialog ( this ), "Error", "Please be more descriptive in your problem description" ) ;
      else 
         return( true ) ;

      return( false ) ;
   }




   /*------------------------------------------------------------*/
   /* getPR
    */
   /**
    *    This method will return the PR number
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String the PR Number
    *//*---------------------------------------------------------*/
   public String getPR () {
      return( pr ) ;
   }




   /*------------------------------------------------------------*/
   /* getDescription
    */
   /**
    *    This method will return the descriptive
    *  text
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getDescription () {
      return( descript ) ;
   }
} /* DebugSenderInfoStep */
