package com.ibm.nzna.projects.qit.app ;                    
/*-----------------------------------------------------------*/
/*   DebugSenderProcessStep                                  */
/*                                                           */
/*   Description:                                            */
/*      Source code for: DebugSenderProcessStep              */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import javax.swing.* ;
import com.ibm.nzna.shared.gui.wizard.* ;      
import com.ibm.nzna.shared.gui.* ;               
import com.ibm.nzna.shared.util.* ;               
import com.ibm.nzna.shared.mail.* ;
import com.ibm.nzna.projects.common.quest.* ;
/**
 * This step has no input, it simply outputs the progress of sending the mail 
 *
 *
 * @version 1.0, 1/24/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   DebugSenderProcessStep                                  */
/*                                                           */
/*-----------------------------------------------------------*/
public class DebugSenderProcessStep extends WizardStep implements AppConst {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private GUI Members                                     */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private JLabel              st_STATUS = new JLabel ( Str.getStr ( STR_DEBUG_WIZARD_PROCESS ) ) ;
   private DebugSenderInfoStep infoStep  = null ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will create and add our Gui
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public DebugSenderProcessStep ( DebugSenderInfoStep infoStep ) {
      this.infoStep = infoStep ;

      setLayout ( new BorderLayout () ) ;
      add ( st_STATUS, BorderLayout.CENTER ) ;
   }


   public void refreshInfo () {
      String fromUser = Text.replaceAllStrInStr ( UserSystem.getUserName(), " ", "_" ) ;
      String comments = infoStep.getDescription() ;
      String subject  = "Quest Input QUEST.DEBUG file.  "+DateSystem.getDate ( CDate.DATE_DATE )+"   PR#:"+infoStep.getPR() ;
      String body     = null ;
      String toUser   = Constants.getStrConst ( "IT_DEBUG_EMAIL" ) ;
      String smtp     = Constants.getStrConst ( "IT_DEBUG_SMTP" ) ;

      try {
         Mail mail = new Mail ( fromUser, smtp ) ;

         body="Quest Debug Info\n\n\nUser Comments:\n---------------------------------------\n"+comments+"\n\n\nQuest.Debug file:\n------------------------------------------\n"+FileUtil.readFile ( "quest.debug" ) ;

         mail.setRecipients ( toUser ) ;
         mail.setSubject ( subject ) ;
         mail.setText ( body ) ;

         mail.send() ;

         st_STATUS.setText ( Str.getStr ( STR_DEBUG_WIZARD_PROCESS_END ) ) ;
      } catch ( Exception e ) {
         LogSystem.log ( 1, e ,false ) ;
         GUISystem.printBox ( STR_INFO, STR_DEBUG_NOT_SENT ) ;
         st_STATUS.setText ( "Please press 'Back' to try again" ) ;
      }

   }

} /* DebugSenderProcessStep */
