package com.ibm.nzna.projects.qit.app ;    
/*-----------------------------------------------------------*/
/*   FontSystem                                              */
/*                                                           */
/*   Description:                                            */
/*      Source code for: FontSystem                          */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
/**
 * This FontSystem holds the user defined fonts 
 *
 *
 * @version 1.0, 1/14/100 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   FontSystem                                              */
/*                                                           */
/*-----------------------------------------------------------*/
public class FontSystem extends Object implements PropertyListener {



   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Static Members                                          */
   /*                                                           */
   /*-----------------------------------------------------------*/
   public static Font defaultFont             = null ;
   public static Font largeTitleFont          = null ;
   public static Font smallTitleFont          = null ;
   public static Font buttonFont              = null ;
   public static Font listFont                = null ;
   public static Font textFont                = null ;
   public static Font smallFont               = null ;
   public static Font panelTitleFont          = null ;
   public static Font formTitleFont           = null ;
   public static Font formValueFont           = null ;
   public static Font formDescriptFont        = null ;



   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will initialize all of the
    *  user defined fonts
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public FontSystem () {    

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Set the fonts                                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      try {
         defaultFont      = (Font)javax.swing.UIManager.getDefaults().get ( "Label.font" ) ;
         formDescriptFont = (Font)javax.swing.UIManager.getDefaults().get ( "Label.font" ) ;
         formValueFont    = (Font)javax.swing.UIManager.getDefaults().get ( "Label.font" ) ;
         textFont         = (Font)javax.swing.UIManager.getDefaults().get ( "Label.font" ) ;
         buttonFont       = (Font)javax.swing.UIManager.getDefaults().get ( "Button.font" ) ;
         listFont         = (Font)javax.swing.UIManager.getDefaults().get ( "List.font" ) ;

         largeTitleFont = new Font ( defaultFont.getFontName(),
                                     defaultFont.getStyle(),
                                     defaultFont.getSize()+12 ) ;

         panelTitleFont = new Font ( defaultFont.getFontName(),
                                     defaultFont.getStyle(),
                                     defaultFont.getSize()+8 ) ;
         
         formTitleFont  = new Font ( defaultFont.getFontName(),
                                     defaultFont.getStyle(),
                                     defaultFont.getSize()+8 ) ;
         
         smallTitleFont = new Font ( defaultFont.getFontName(),
                                     defaultFont.getStyle(),
                                     defaultFont.getSize()-2 ) ;
         smallFont = smallTitleFont ;


         //PropertySystem.addPropertyListener ( PropertySystem.PROPERTY_DEFAULTFONT, this ) ;
         //PropertySystem.addPropertyListener ( PropertySystem.PROPERTY_LARGETITLEFONT, this ) ;
         //PropertySystem.addPropertyListener ( PropertySystem.PROPERTY_SMALLTITLEFONT, this ) ;
         //PropertySystem.addPropertyListener ( PropertySystem.PROPERTY_TEXTFONT, this ) ;
         //PropertySystem.addPropertyListener ( PropertySystem.PROPERTY_BUTTONFONT, this ) ;
         //PropertySystem.addPropertyListener ( PropertySystem.PROPERTY_LISTFONT, this ) ;
         //PropertySystem.addPropertyListener ( PropertySystem.PROPERTY_SMALLFONT, this ) ;
         //PropertySystem.addPropertyListener ( PropertySystem.PROPERTY_PANELTITLEFONT, this ) ;

      } catch ( Exception e ) {
         e.printStackTrace() ;
         defaultFont = largeTitleFont = smallTitleFont = textFont = buttonFont = listFont = new Font ( "SansSerif", Font.PLAIN, 10 ) ;
      }


   }





   /*------------------------------------------------------------*/
   /* propertyChanged
    */
   /**
    *    This method will be called when a property
    *  we are listening for has been changed.
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void propertyChanged ( int property, Object value ) {

      //switch ( property ) {
      //   case PropertySystem.PROPERTY_DEFAULTFONT :
      //      defaultFont    = (Font) value ;
      //      break ;

      //   case PropertySystem.PROPERTY_LARGETITLEFONT :
      //      largeTitleFont = (Font) value ;
      //      break ;

      //   case PropertySystem.PROPERTY_SMALLTITLEFONT :
      //      smallTitleFont = (Font) value ;
      //      break ;

      //   case PropertySystem.PROPERTY_TEXTFONT :
      //      textFont       = (Font) value ;
      //      break ;

      //   case PropertySystem.PROPERTY_BUTTONFONT :
      //      buttonFont     = (Font) value ;
      //      break ;

      //   case PropertySystem.PROPERTY_LISTFONT :
      //      listFont       = (Font) value ;
      //      break ;

      //   case PropertySystem.PROPERTY_SMALLFONT :
      //      smallFont      = (Font) value ;
      //      break ;

      //   case PropertySystem.PROPERTY_PANELTITLEFONT :
      //      panelTitleFont = (Font) value ;
      //      break ;

      //}

   }

} /* FontSystem */
