package com.ibm.nzna.projects.qit.app ;                                                  
/*-----------------------------------------------------------*/
/*   InitializeQuestAppletThread                             */
/*                                                           */
/*   Description:                                            */
/*      Source code for: InitializeQuestAppletThread         */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.shared.util.* ;
/**
 * This thread will initialize a QuestApplet. It will call the initialize and start methods 
 * of a QuestApplet, as well as instantiating a new instance of it 
 *
 *
 * @version 1.0, 1/26/100 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   InitializeQuestAppletThread                             */
/*                                                           */
/*-----------------------------------------------------------*/
public class InitializeQuestAppletThread extends Object implements AppConst, Runnable {



   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private AppletRec appletRec = null ;



   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will create and kick off
    *  the thread that will initialize our QuestApplet
    *  
    *
    *  @param appletRec The AppletRec to start
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public InitializeQuestAppletThread ( AppletRec appletRec ) {
      this.appletRec = appletRec ;
      new Thread ( this ).start() ;
   }





   /*------------------------------------------------------------*/
   /* run
    */
   /**
    *    This method will run the thread
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void run () {

      try {
         if ( appletRec != null ) {
            QuestApplet applet = appletRec.createQuestApplet() ;


            if ( applet.initialize() ) {
               applet.start() ;
               AppletSystem.addRunningApplet ( applet ) ;
            }
         }
      } catch ( Exception e ) {
         LogSystem.log ( 1, e, false ) ;
      }
   }
} /* InitializeQuestAppletThread */
