package com.ibm.nzna.projects.qit.app ;                 
/*-----------------------------------------------------------*/
/*   PropertyListener                                        */
/*                                                           */
/*   Description:                                            */
/*      Source code for: PropertyListener                    */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This listener can be added to the PropertySystem to be notified when a 
 * property changes. To avoid a memory leak and over processing, REMEMBER TO
 * REMOVE YOURSELF FROM THE PROPERTYSYSTEM!!! Remember that the PropertySystem
 * is alive throughout the application life, so if you add yourself to the
 * property system, you must also remove yourself! See PropertySystem.removePropertyListener
 *
 *
 * @version 1.0, 1/22/100 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   PropertyListener                                        */
/*                                                           */
/*-----------------------------------------------------------*/
public interface PropertyListener {





    /*------------------------------------------------------------*/
    /* propertyChanged
     */
    /**
     *    This method will be called when a property
     *  has been changed
     *  
     *
     *  @param property The property name
     *  @param value The new value for the Object
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public abstract void propertyChanged ( int property, Object value ) ;



} /* PropertyListener */
