package com.ibm.nzna.projects.qit.app ;     
/*-----------------------------------------------------------*/
/*   QuestApplet                                             */
/*                                                           */
/*   Description:                                            */
/*      Source code for: QuestApplet                         */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import javax.swing.ImageIcon ;
/**
 *  The QuestApplet Interface must be implemented by the main
 * applet class of a Quest Applet. The interface is used primarily as a
 * communication mechanism between the Quest application and applets that are running.
 *
 *
 * @version 1.0, 1/26/100 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   QuestApplet                                             */
/*                                                           */
/*-----------------------------------------------------------*/
public interface QuestApplet {







    /*------------------------------------------------------------*/
    /* getIcon
     */
    /**
     *    Returns the icon representing this QuestApplet on the workspace.
     *  
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return ImageIcon
     *//*---------------------------------------------------------*/
    public abstract ImageIcon getIcon () ;




    /*------------------------------------------------------------*/
    /* getSmallIcon
     */
    /**
     *    This method should return the small
     *  representation of the icon for this applet
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public abstract ImageIcon getSmallIcon () ;





    /*------------------------------------------------------------*/
    /* getName
     */
    /**
     *    This method should return the name
     *  of this QuestApplet
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public abstract String getName () ;





    /*------------------------------------------------------------*/
    /* getDescription
     */
    /**
     *    This method should return a description
     *  of this QuestApplet.
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public abstract String getDescription() ;





    /*------------------------------------------------------------*/
    /* initialize
     */
    /**
     *    This method should do any preparation
     *  work for the QuestApplet prior to start
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return TRUE if initializing should continue, FALSE if there was an error and to signify not to continue 
     *//*---------------------------------------------------------*/
    public abstract boolean initialize () ;




    /*------------------------------------------------------------*/
    /* start
     */
    /**
     *    This method should start all services
     *  of the QuestApplet. This start method
     *  should always create and display the main QuestPanel for the QuestApplet.
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public abstract void start() ;


    /*------------------------------------------------------------*/
    /* getAuthority
     */
    /**
     *    This method should return the authority
     *  indicator (See AppConst) that the user
     *  needs to run the QuestApplet
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public abstract int getAuthority () ;




    /*------------------------------------------------------------*/
    /* canChat
     */
    /**
     *    This method should return TRUE if
     *  this QuestApplet can support a Chat
     *  session of type other than CHAT_TEXT
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public abstract boolean canChat() ;


} /* QuestApplet */
