package com.ibm.nzna.projects.qit.app ;                                               
/*-----------------------------------------------------------*/
/*   QuestAppletNotFoundException                            */
/*                                                           */
/*   Description:                                            */
/*      Source code for: QuestAppletNotFoundException        */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This exception is thrown when a Quest Applet is called to run, but cannot be found 
 *
 *
 * @version 1.0, 8/28/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   QuestAppletNotFoundException                            */
/*                                                           */
/*-----------------------------------------------------------*/
public class QuestAppletNotFoundException extends Exception {      


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private String questApplet = "" ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will call the super (String) and
    *  also sets the questApplet property
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public QuestAppletNotFoundException ( String exception, String questApplet ) {
      super ( exception ) ;
      this.questApplet = questApplet ;
   }




   /*------------------------------------------------------------*/
   /* toString
    */
   /**
    *    This method will return a human-readable
    *  string of this exception
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String toString () {
      return( "Cannot load QuestApplet: "+questApplet ) ;
   }


} /* QuestAppletNotFoundException */
