package com.ibm.nzna.projects.qit.app ;
/*-----------------------------------------------------------*/
/*   SearchListener                                          */
/*                                                           */
/*   Description:                                            */
/*      Source code for: SearchListener                      */
/*                                                           */
/*                                                           */
/*         @Copyright  1997 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This is a generic listener for threads that perform searches to use. The 
 * only method is the searchComplete method which will be called when the thread
 * is done searching. The thread type is defined in Const.java For example:
 * SEARCH_PRODUCT, SEARCH_DOCUMENT, SEARCH_CUSTOMER etc...
 *
 * The data parameter is used for a generic data piece to be passed back.
 *
 * @version 1.0, 7/14/1998 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   SearchListener                                          */
/*                                                           */
/*-----------------------------------------------------------*/
public interface SearchListener {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Methods                                                 */
   /*                                                           */
   /*-----------------------------------------------------------*/
   public abstract void searchComplete ( int searchType, SearchRec data ) ;

} /* SearchListener */
