package com.ibm.nzna.projects.qit.app ;
/*-----------------------------------------------------------*/
/*   SearchRec                                               */
/*                                                           */
/*   Description:                                            */
/*      Source code for: SearchRec                           */
/*                                                           */
/*                                                           */
/*         @Copyright  1997 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.Vector ;
import javax.swing.tree.DefaultMutableTreeNode ;
/**
 * This record holds generic information needed to perform a simple search 
 *
 *
 * @version 1.0, 9/21/1998 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   SearchRec                                               */
/*                                                           */
/*-----------------------------------------------------------*/
public class SearchRec extends DefaultMutableTreeNode {   

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Search Types                                            */
   /*                                                           */
   /*-----------------------------------------------------------*/
   public static final int SEARCH_PRODUCT             = 0 ;
   public static final int SEARCH_DOCUMENT            = 1 ;
   public static final int SEARCH_DOCTEMPLATE         = 2 ;
   public static final int SEARCH_NOTIFICATION        = 3 ;
   public static final int SEARCH_CUSTOMER            = 4 ;
   public static final int SEARCH_EMAIL               = 5 ;
   public static final int SEARCH_MACHINE             = 6 ;


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Vars                                                    */
   /*                                                           */
   /*-----------------------------------------------------------*/
   public int                      intSearchArg   = 0 ;
   public int                      intSearchArg1  = 0 ;
   public int                      intSearchArg2  = 0 ;
   public String                   strSearchArg   = "" ;
   public String                   strSearchArg2  = "" ;
   public String                   strSearchArg3  = "" ;
   public transient SearchListener listener       = null ;
   public Vector                   resultVec      = null ;



   /*------------------------------------------------------------*/
   /* newSearch
    */
   /**
    *    This method will clear out and free all of
    *  the data associated to an older search
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void newSearch () {
      if ( resultVec != null ) {
         resultVec.removeAllElements() ;
         resultVec  = null ;
      }
      listener = null ;
      strSearchArg = null ;
      intSearchArg = 0 ;
   }

} /* SearchRec */

