package com.ibm.nzna.projects.qit.app.appProp ;
/*-----------------------------------------------------------*/
/*   AppletsPage                                             */
/*                                                           */
/*   Description:                                            */
/*      Source code for: AppletsPage                         */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.help.* ;     
import com.ibm.nzna.projects.qit.gui.* ;     
import com.ibm.nzna.shared.gui.wizard.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.shared.gui.* ;
import java.io.File ;
import java.awt.* ;
import java.util.* ;
import java.awt.event.* ;
import javax.swing.* ;
/**
 * This page belongs in the ApplicationPropertyDlg's notebook. It holds 
 * all QuestApplets that are available to the user and allows the user
 * to add and remove QuestApplets.
 *
 * @version 1.0, 1/26/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   AppletsPage                                             */
/*                                                           */
/*-----------------------------------------------------------*/
public class AppletsPage extends WizardStep implements ActionListener, PropertyListener, AppConst {

    /*-----------------------------------------------------------*/
    /*                                                           */
    /*   Container Titles                                        */
    /*                                                           */
    /*-----------------------------------------------------------*/
    private static String[] cnrTitle = null ;

    /*-----------------------------------------------------------*/
    /*                                                           */
    /*   GUI Components                                          */
    /*                                                           */
    /*-----------------------------------------------------------*/
    private JLabel      st_HELP          = null ;
    private MultiList   cnr_APPLETS      = null ;
    private DButton     pb_ADD           = null ;
    private DButton     pb_REMOVE        = null ;
    private DButton     pb_HELP          = null ;
    private ButtonPanel buttonPanel      = null ;      

    /*-----------------------------------------------------------*/
    /*                                                           */
    /*   Private Members                                         */
    /*                                                           */
    /*-----------------------------------------------------------*/
    private Vector   addAppletVec       = new Vector ( 1, 1 ) ;
    private Vector   removeAppletVec    = new Vector ( 1, 1 ) ;



    /*------------------------------------------------------------*/
    /* Constructor
     */
    /**
     *    This method will create and initialize
     *  the page and all GUI Components
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public AppletsPage() {     

        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   Create the GUI                                          */
        /*                                                           */
        /*-----------------------------------------------------------*/
        st_HELP     = new JLabel () ;
        pb_ADD      = new DButton ( "" ) ;
        pb_REMOVE   = new DButton ( "" ) ;
        pb_HELP     = new DButton ( "" ) ;
        cnr_APPLETS = new MultiList ( GUISystem.getFontUtil() ) ;        
        buttonPanel = new ButtonPanel () ;

        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   Adjust properties                                       */
        /*                                                           */
        /*-----------------------------------------------------------*/
        st_HELP.setVerticalAlignment ( SwingConstants.TOP ) ;
        GUISystem.setPreferredButton ( pb_ADD ) ;
        GUISystem.setPreferredButton ( pb_REMOVE ) ;
        GUISystem.setPreferredButton ( pb_HELP ) ;
        cnr_APPLETS.setOddLinesColor ( new Color ( 240, 240, 240 ) ) ;
        setText() ;    

        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   Add listeners                                           */
        /*                                                           */
        /*-----------------------------------------------------------*/
        PropertySystem.addPropertyListener ( PropertySystem.PROPERTY_LANGUAGE, this ) ;
        pb_HELP.addActionListener   ( this ) ;
        pb_ADD.addActionListener    ( this ) ;
        pb_REMOVE.addActionListener ( this ) ;               

        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   Add the GUI to our panel                                */
        /*                                                           */
        /*-----------------------------------------------------------*/
        setLayout ( null ) ;
        add ( st_HELP ) ;
        add ( cnr_APPLETS ) ;
        add ( buttonPanel ) ;
        buttonPanel.add ( pb_ADD ) ;
        buttonPanel.add ( pb_REMOVE ) ;
        buttonPanel.add ( pb_HELP ) ;       

        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   Refresh our data                                        */
        /*                                                           */
        /*-----------------------------------------------------------*/
        refreshData() ;
    }





    /*------------------------------------------------------------*/
    /* doLayout
     */
    /**
     *    This method will lay out and position
     *  all of our GUI Controls
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void doLayout () {
        Dimension size = getSize() ;

        st_HELP.setBounds ( 5, 5, size.width-5, 125 ) ;
        cnr_APPLETS.setBounds ( 10, 150, size.width-20, 200 ) ;
        buttonPanel.setBounds ( 10, size.height-50, size.width-20, 25 ) ;
    }





    /*------------------------------------------------------------*/
    /* actionPerformed
     */
    /**
     *    This method will be called when an action
     *  event is fired
     *  
     *
     *  @param e The event
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void actionPerformed ( ActionEvent e ) {
        Object source = e.getSource() ;

        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   Help                                                    */
        /*                                                           */
        /*-----------------------------------------------------------*/
        if ( source == pb_HELP )
            HelpSystem.showHelp ( "app"+File.separator+"quest_applet.html" ) ;

        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   Add                                                     */
        /*                                                           */
        /*-----------------------------------------------------------*/
        else if ( source == pb_ADD )
            add() ;

        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   remove                                                  */
        /*                                                           */
        /*-----------------------------------------------------------*/
        else if ( source == pb_REMOVE )
            remove() ;
    }





    /*------------------------------------------------------------*/
    /* propertyChanged
     */
    /**
     *    This method will be called when a property
     *  we are listening for has been changed
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void propertyChanged ( int property, Object value ) {
        if ( property == PropertySystem.PROPERTY_LANGUAGE )
            setText() ;
    }





    /*------------------------------------------------------------*/
    /* setText
     */
    /**
     *    This method will set the text on all
     *  of our components
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    private void setText ( ) {
        pb_ADD.setText    ( Str.getStr ( STR_ADD ) ) ;
        pb_REMOVE.setText ( Str.getStr ( STR_REMOVE ) ) ;
        pb_HELP.setText   ( Str.getStr ( STR_HELP ) ) ;
        st_HELP.setText   ( Str.getStr ( STR_APPLETS_PAGE_HELP ) ) ;

        cnrTitle = new String[3] ;
        cnrTitle[0] = "" ;
        cnrTitle[1] = Str.getStr ( STR_NAME ) ;
        cnrTitle[2] = Str.getStr ( STR_DESCRIPTION ) ;
        cnr_APPLETS.setColumnHeadings ( cnrTitle ) ;
        cnr_APPLETS.setColumnWidth ( 0, 22 ) ;
        cnr_APPLETS.setColumnWidth ( 2, 455 ) ;
        cnr_APPLETS.setBackground ( Color.white ) ;
        cnr_APPLETS.setOddLinesColor ( GUISystem.oddLinesColor ) ;
    }





    /*------------------------------------------------------------*/
    /* refreshData
     */
    /**
     *    This method will refesh out list
     *  of Quest Applets
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    private void refreshData () {
        Vector appletVec = AppletSystem.getAppletList() ;

        if ( appletVec != null ) {
            cnr_APPLETS.removeAll() ;
            cnr_APPLETS.add ( appletVec ) ;
        }
    }






    /*------------------------------------------------------------*/
    /* add
     */
    /**
     *    This method will add an applet to the
     *  Quest application
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    private void add () {
        String className = new SingleEntryDlg ( WinUtil.getParentDialog ( this ), 
                                                Str.getStr ( STR_CLASS_NAME ), 
                                                Str.getStr ( STR_PLEASE_ENTER_CLASS_NAME ), 
                                                "com.ibm.nzna.projects.qit." ).getResult() ;

        if ( ( className != null ) && ( className.length() > 0 ) ) {

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Try and load this class                                 */
            /*                                                           */
            /*-----------------------------------------------------------*/
            try {
                QuestApplet applet = (QuestApplet)Class.forName(className).newInstance() ;
                AppletRec   appletRec = new AppletRec ( className ) ;

                cnr_APPLETS.add ( appletRec ) ;
                addAppletVec.addElement ( appletRec ) ;

                if ( StoreUtil.vectorContains ( removeAppletVec, appletRec ) )
                    removeAppletVec.removeElement ( appletRec ) ;

            } catch ( ClassNotFoundException e ) {
                GUISystem.printBox ( WinUtil.getParentJDialog ( this ),
                                     Str.getStr ( STR_INFO ), 
                                     Str.getStr ( STR_CANNOT_FIND_CLASS_NAME_FOR_APPLET ) ) ;
            } catch ( IllegalAccessException e1 ) {
                LogSystem.log ( 1, e1 ) ;
            } catch ( InstantiationException e2 ) {
                LogSystem.log ( 1, e2 ) ;
            }
        }
    }




    /*------------------------------------------------------------*/
    /* remove
     */
    /**
     *    This method will remove a QuestApplet
     *  from the list of available applets
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    private void remove () {
        AppletRec appletRec = (AppletRec)cnr_APPLETS.getSelectedItem() ;

        if ( appletRec != null ) {
            cnr_APPLETS.remove ( appletRec ) ;
            removeAppletVec.addElement ( appletRec ) ;
            if ( StoreUtil.vectorContains ( addAppletVec, appletRec ) )
                addAppletVec.removeElement ( appletRec ) ;
        }
    }





    /*------------------------------------------------------------*/
    /* saveInfo
     */
    /**
     *    This method will make the final save
     *  for all operations that have been
     *  made on this panel
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public boolean saveInfo () {
        if ( addAppletVec.size() > 0 ) {
            int i       = 0 ;
            int length  = addAppletVec.size() ;

            while ( i < length ) {
                AppletSystem.addApplet ( (AppletRec)addAppletVec.elementAt(i) ) ;
                i++ ;
            }
        }

        if ( removeAppletVec.size() > 0 ) {
            int i       = 0 ;
            int length  = removeAppletVec.size() ;

            while ( i < length ) {
                AppletSystem.removeApplet ( (AppletRec)removeAppletVec.elementAt(i) ) ;
                i++ ;
            }
        }

        return ( true ) ;

    }





    /*------------------------------------------------------------*/
    /* free
     */
    /**
     *    This method will release resources
     *  
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    protected void free () {
        PropertySystem.removePropertyListener ( PropertySystem.PROPERTY_LANGUAGE, this ) ;
    }





   /*------------------------------------------------------------*/
   /* getTitle
    */
   /**
    *    This method will return the title that is shown
    *  in a wizard
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String
    *//*---------------------------------------------------------*/
    public String getTitle () {
       return ( Str.getStr ( STR_APPLETS_PAGE_HELP ) ) ;
    }
} /* AppletsPage */
