package com.ibm.nzna.projects.qit.app.appProp ;
/*-----------------------------------------------------------*/
/*   GeneralPage                                             */
/*                                                           */
/*   Description:                                            */
/*      Source code for: GeneralPage                         */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.help.* ;     
import com.ibm.nzna.projects.qit.gui.* ;     
import com.ibm.nzna.projects.qit.app.util.QuestUtil ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.gui.wizard.* ;
import java.io.File ;
import java.awt.* ;
import java.util.* ;
import java.awt.event.* ;
import javax.swing.* ;
/**
 * This page belongs in the ApplicationPropertyDlg's notebook. It holds 
 * all 'General' options that are available to the user
 *
 * @version 1.0, 1/26/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   GeneralPage                                             */
/*                                                           */
/*-----------------------------------------------------------*/
public class GeneralPage extends WizardStep implements ActionListener, PropertyListener, AppConst {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Container Titles                                        */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private static String[] cnrTitle = null ;

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   GUI Components                                          */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private JLabel      st_HELP                      = null ;
   private DButton     pb_HELP                      = null ;
   private ButtonPanel buttonPanel                  = null ;      
   private JCheckBox   ck_USE_DEFAULT_BOOKMARK_NAME = null ;
   private JLabel      st_TEMP_DIR                  = null ;
   private JTextField  ef_TEMP_DIR                  = null ;
   private JCheckBox   ck_CLEAR_TEMP_DIR            = null ;
   private DButton     pb_CLEAR_NOW                 = null ;
   private JLabel      st_DAYS_TO_KEEP              = null ;
   private JTextField  ef_DAYS_TO_KEEP              = null ;
   private JCheckBox   ck_SHOW_WHATS_NEW            = null ;
   private JCheckBox   ck_START_FAVORITE_APPLET     = null ;
   private JTextField  ef_BROWSER                   = null ;
   private DButton     pb_BROWSER_BROWSE            = null ;
   private JLabel      st_BROWSER                   = null ;


   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will create and initialize
    *  the page and all GUI Components
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public GeneralPage() {

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create the GUI                                          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      st_HELP                      = new JLabel () ;
      pb_HELP                      = new DButton ( "" ) ;
      ck_USE_DEFAULT_BOOKMARK_NAME = new JCheckBox ( "" ) ;
      buttonPanel                  = new ButtonPanel () ;
      st_TEMP_DIR                  = new JLabel ( Str.getStr ( STR_TEMP_DIR ) ) ;
      ef_TEMP_DIR                  = new JTextField ( "" ) ;
      ck_CLEAR_TEMP_DIR            = new JCheckBox ( "" ) ;
      pb_CLEAR_NOW                 = new DButton ( "" ) ;
      st_DAYS_TO_KEEP              = new JLabel ( "" ) ;
      st_BROWSER                   = new JLabel ( "External Browser used for Printing" ) ;
      ef_DAYS_TO_KEEP              = new JTextField ( new MaskDocument ( MaskDocument.MASKTYPE_NUMERIC ), "", 0 ) ;
      ck_SHOW_WHATS_NEW            = new JCheckBox ( Str.getStr ( STR_SHOW_WHATS_NEW ) ) ;
      ck_START_FAVORITE_APPLET     = new JCheckBox ( Str.getStr ( STR_START_FAVORITE_APPLET ) ) ;
      ef_BROWSER                   = new JTextField ( "" ) ;
      pb_BROWSER_BROWSE            = new DButton ( Str.getStr ( STR_BROWSE ) ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      st_HELP.setVerticalAlignment ( SwingConstants.TOP ) ;
      setText() ;    

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add listeners                                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      PropertySystem.addPropertyListener ( PropertySystem.PROPERTY_LANGUAGE, this ) ;
      pb_HELP.addActionListener      ( this ) ;
      pb_CLEAR_NOW.addActionListener ( this ) ;
      pb_BROWSER_BROWSE.addActionListener    ( this ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add the GUI to our panel                                */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( null ) ;
      add ( st_HELP ) ;  
      add ( st_TEMP_DIR ) ;
      add ( ef_TEMP_DIR ) ;
      add ( ck_CLEAR_TEMP_DIR ) ;
      add ( pb_CLEAR_NOW ) ;
      add ( st_DAYS_TO_KEEP ) ;
      add ( ef_DAYS_TO_KEEP ) ;
      add ( ck_USE_DEFAULT_BOOKMARK_NAME ) ;
      add ( ck_START_FAVORITE_APPLET ) ;
      add ( ck_SHOW_WHATS_NEW ) ;
      add ( st_BROWSER ) ;
      add ( ef_BROWSER ) ;
      add ( pb_BROWSER_BROWSE ) ;
      add ( buttonPanel ) ;
      buttonPanel.add ( pb_HELP ) ;       

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Refresh our data                                        */
      /*                                                           */
      /*-----------------------------------------------------------*/
      refreshData() ;
   }





   /*------------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will lay out and position
    *  all of our GUI Controls
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size      = getSize() ;
      int       y         = 5 ;
      int       rowHeight = GUISystem.getRowHeight() ;


      st_TEMP_DIR.setBounds ( 5, y, size.width-10, rowHeight ) ;
      y+=rowHeight ;

      ef_TEMP_DIR.setBounds ( 10, y, size.width-20, rowHeight ) ;
      y+=rowHeight ;

      ck_CLEAR_TEMP_DIR.setBounds ( 10, y, size.width-110, rowHeight ) ;
      pb_CLEAR_NOW.setBounds ( size.width-98, y, 78, rowHeight ) ;
      y+=(rowHeight*3) ;

      st_DAYS_TO_KEEP.setBounds ( 5, y, size.width-10, rowHeight ) ;
      y+=rowHeight ;

      ef_DAYS_TO_KEEP.setBounds ( 10, y, 100, rowHeight ) ;
      y+=rowHeight*3 ;

      ck_USE_DEFAULT_BOOKMARK_NAME.setBounds ( 5, y, size.width-10, rowHeight ) ;
      y+=rowHeight ;

      ck_START_FAVORITE_APPLET.setBounds ( 5, y, size.width-10, rowHeight ) ;
      y+=rowHeight ;

      ck_SHOW_WHATS_NEW.setBounds ( 5, y, size.width-10, rowHeight ) ;
      y+=rowHeight*2 ;


      st_BROWSER.setBounds ( 5, y, size.width-110, rowHeight ) ;
      y+=rowHeight ;

      ef_BROWSER.setBounds ( 5, y, size.width-110, rowHeight ) ;
      pb_BROWSER_BROWSE.setBounds ( size.width-100, y, 100, rowHeight ) ;




      buttonPanel.setBounds ( 10, size.height-50, size.width-20, 25 ) ;
   }





   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will be called when an action
    *  event is fired
    *  
    *
    *  @param e The event
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {
      Object source = e.getSource() ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Help                                                    */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( source == pb_HELP )
         HelpSystem.showHelp ( "app"+File.separator+"general_prefs.html" ) ;

      else if ( source == pb_CLEAR_NOW ) {
         QuestUtil.clearTempDir() ;
         pb_CLEAR_NOW.setEnabled ( false ) ;
      }


      /*------------*/
      /*            */
      /*  pb_BROWSE */
      /*            */
      /*------------*/
      else if ( source == pb_BROWSER_BROWSE ) {
         File[] file = GUISystem.getFileOpen ( WinUtil.getParentFrame ( this ),
                                               Str.getStr ( STR_FIND ),
                                               "",
                                               "*.EXE",
                                               true ) ;
         if ( file != null ) {
            ef_BROWSER.setText ( file[1].getAbsolutePath()+File.separator+file[0].getName() ) ;
         }

      }

   }





   /*------------------------------------------------------------*/
   /* propertyChanged
    */
   /**
    *    This method will be called when a property
    *  we are listening for has been changed
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void propertyChanged ( int property, Object value ) {
      if ( property == PropertySystem.PROPERTY_LANGUAGE )
         setText() ;
   }





   /*------------------------------------------------------------*/
   /* setText
    */
   /**
    *    This method will set the text on all
    *  of our components
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void setText ( ) {
      pb_HELP.setText                      ( Str.getStr ( STR_HELP ) ) ;
      st_HELP.setText                      ( Str.getStr ( STR_GENERAL_PAGE_HELP ) ) ;
      st_TEMP_DIR.setText                  ( Str.getStr ( STR_TEMP_DIR ) ) ;
      ck_USE_DEFAULT_BOOKMARK_NAME.setText ( Str.getStr ( STR_USE_DEFAULT_BOOKMARK_NAME ) ) ;
      ck_CLEAR_TEMP_DIR.setText            ( Str.getStr ( STR_CLEAR_TEMP_DIR_ON_START ) ) ;
      pb_CLEAR_NOW.setText                 ( Str.getStr ( STR_CLEAR_NOW ) ) ;
      st_DAYS_TO_KEEP.setText              ( Str.getStr ( STR_NUM_OF_DAYS_TO_KEEP_LOGS ) ) ;

      ck_USE_DEFAULT_BOOKMARK_NAME.setToolTipText ( Str.getStr ( STR_USE_DEFAULT_BOOKMARK_NAME_TOOLTIP ) ) ;
      st_TEMP_DIR.setToolTipText ( Str.getStr ( STR_TEMP_DIR_TOOLTIP ) ) ;
      ef_TEMP_DIR.setToolTipText ( Str.getStr ( STR_TEMP_DIR_TOOLTIP ) ) ;
      ck_CLEAR_TEMP_DIR.setToolTipText ( Str.getStr ( STR_CLEAR_TEMP_DIR_ON_START ) ) ;

   }





   /*------------------------------------------------------------*/
   /* refreshData
    */
   /**
    *    This method will refesh out list
    *  of Quest Applets
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void refreshData () {
      ef_TEMP_DIR.setText ( PropertySystem.getString ( PropertySystem.PROPERTY_TEMP_DIR ) ) ;
      ck_CLEAR_TEMP_DIR.setSelected ( PropertySystem.getBool ( PropertySystem.PROPERTY_CLEAR_TEMP_DIR_ON_START ) ) ;
      ef_DAYS_TO_KEEP.setText ( ""+PropertySystem.getInt ( PropertySystem.PROPERTY_LOGS_KEEP ) ) ;
      ck_SHOW_WHATS_NEW.setSelected ( PropertySystem.getBool ( PropertySystem.PROPERTY_SHOW_WHATS_NEW ) ) ;
      ck_START_FAVORITE_APPLET.setSelected ( PropertySystem.getBool ( PropertySystem.PROPERTY_ASK_FIRST_APPLET_RUN ) ) ;
      ef_BROWSER.setText ( PropertySystem.getString ( PropertySystem.PROPERTY_EXTERNAL_BROWSER ) ) ;
   }




   /*------------------------------------------------------------*/
   /* saveInfo
    */
   /**
    *    This method will make the final save
    *  for all operations that have been
    *  made on this panel
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean saveInfo () {
      boolean rc          = false ;
      String  tempDir     = ef_TEMP_DIR.getText() ;
      File    tempDirFile = new File ( tempDir ) ;
      int     logsKeep    = PropertySystem.getInt ( PropertySystem.PROPERTY_LOGS_KEEP ) ;
      int     newLogsKeep = new Integer ( ef_DAYS_TO_KEEP.getText() ).intValue() ;

      PropertySystem.putBool ( PropertySystem.PROPERTY_USE_DEFAULT_BOOKMARK_NAME, 
                               new Boolean ( ck_USE_DEFAULT_BOOKMARK_NAME.isSelected() ) ) ;

      PropertySystem.putBool ( PropertySystem.PROPERTY_SHOW_WHATS_NEW, 
                               new Boolean ( ck_SHOW_WHATS_NEW.isSelected() ) ) ;

      PropertySystem.putBool ( PropertySystem.PROPERTY_ASK_FIRST_APPLET_RUN, 
                               new Boolean ( ck_START_FAVORITE_APPLET.isSelected() ) ) ;                                              

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   If they turned First Applet Run off, set other props to */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( !ck_START_FAVORITE_APPLET.isSelected() ) {
         PropertySystem.putInt    ( PropertySystem.PROPERTY_FIRST_APPLET_RUN_COUNT, 0 ) ;
         PropertySystem.putString ( PropertySystem.PROPERTY_FIRST_APPLET_RUN, "" ) ;
         PropertySystem.putString ( PropertySystem.PROPERTY_STARTUP_APPLET, "" ) ;
      }




      if ( !tempDirFile.exists() ) {
         if ( GUISystem.printBox ( STR_QUESTION, STR_DIRECTORY_DOES_NOT_EXIST_CREATE ) ) {
            tempDirFile.mkdirs() ;
            rc=true ;
         }
      } else
         rc = true ;                                        

      PropertySystem.putInt  ( PropertySystem.PROPERTY_LOGS_KEEP, newLogsKeep ) ;

      if ( newLogsKeep < logsKeep ) {
         if ( GUISystem.printBox ( STR_QUESTION, STR_NEW_DAYS_KEEP_LOWER ) ) {
            QuestUtil.cleanOldLogFiles() ;
            GUISystem.printBox ( STR_INFO, STR_COMPLETE ) ;
         }
      }


      if ( rc ) {
         String pathExe = ef_BROWSER.getText() ;
         File   file    = new File ( pathExe ) ;

         if ( file.exists() )
            PropertySystem.putString ( PropertySystem.PROPERTY_EXTERNAL_BROWSER, ef_BROWSER.getText() ) ;
         else {
            GUISystem.printBox ( "Error", "The 'External Browser' you have entered cannot be found. Please supply a valid path including the .exe (iexplore.exe, netscape.exe)" ) ;
            rc = false ;
         }
      }


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Ask the user if they wish to clear their logs now       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( rc ) {

         PropertySystem.put ( PropertySystem.PROPERTY_TEMP_DIR, tempDir ) ;

         PropertySystem.putBool ( PropertySystem.PROPERTY_CLEAR_TEMP_DIR_ON_START, ck_CLEAR_TEMP_DIR.isSelected() ) ;
      }


      return( rc ) ;
   }





   /*------------------------------------------------------------*/
   /* free
    */
   /**
    *    This method will release resources
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   protected void free () {
      PropertySystem.removePropertyListener ( PropertySystem.PROPERTY_LANGUAGE, this ) ;
   }


} /* GeneralPage */
