package com.ibm.nzna.projects.qit.app.appProp ;     
/*-----------------------------------------------------------*/
/*   TaskBarPage                                             */
/*                                                           */
/*   Description:                                            */
/*      Source code for: TaskBarPage                         */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;     
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.gui.wizard.* ;
import javax.swing.* ;
import javax.swing.border.* ;
import java.awt.* ;
import java.awt.event.* ;
import java.util.* ;
/**
 * This page is visible in the Application Property Notebook. It holds 
 * all user changable properties for the task bar
 *
 *
 * @version 1.0, 1/23/100 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   TaskBarPage                                             */
/*                                                           */
/*-----------------------------------------------------------*/
public class TaskBarPage extends WizardStep implements AppConst, PropertyListener, ActionListener {


    /*-----------------------------------------------------------*/
    /*                                                           */
    /*   GUI Controls                                            */
    /*                                                           */
    /*-----------------------------------------------------------*/
    private JRadioButton rb_SHOWICONTEXT        = null ;
    private JRadioButton rb_SHOWICON            = null ;
    private JRadioButton rb_SHOWTEXT            = null ;
    private JRadioButton rb_SMALLBUTTONS        = null ;
    private JRadioButton rb_DEFAULTBUTTONS      = null ;
    private JComboBox    cb_TEXTORIENT          = null ;
    private JPanel       pnl_OUTPUT             = null ;
    private JLabel       st_TEXTORIENT          = null ;
    private DButton      pb_REFRESH            = null ;
    private DButton      pb_BACK               = null ;
    private DButton      pb_FORWARD            = null ;
    private JCheckBox    ck_SHOWTOOLTIPS       = null ;





    /*------------------------------------------------------------*/
    /* Constructor
     */
    /**
     *    This method will create the page, including
     *  attaching all GUI components
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public TaskBarPage () {     
        ButtonGroup group1 = new ButtonGroup () ;
        ButtonGroup group2 = new ButtonGroup () ;
        Insets      insets = new Insets ( 1,2,1,2 ) ;

        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   Create the GUI                                          */
        /*                                                           */
        /*-----------------------------------------------------------*/
        rb_SHOWICONTEXT     = new JRadioButton () ;
        rb_SHOWICON         = new JRadioButton () ;
        rb_SHOWTEXT         = new JRadioButton () ;
        rb_SMALLBUTTONS     = new JRadioButton () ;
        rb_DEFAULTBUTTONS   = new JRadioButton () ;
        pnl_OUTPUT          = new JPanel () ;
        st_TEXTORIENT       = new JLabel () ;     
        cb_TEXTORIENT       = new JComboBox () ;
        pb_BACK             = new DButton ( Str.getStr ( STR_BACK ), ImageSystem.getImageIcon ( this, ImageSystem.BACK ) ) ;
        pb_FORWARD          = new DButton ( Str.getStr ( STR_FORWARD ), ImageSystem.getImageIcon ( this, ImageSystem.FORWARD ) ) ;
        pb_REFRESH          = new DButton ( Str.getStr ( STR_REFRESH ), ImageSystem.getImageIcon ( this, ImageSystem.REFRESH ) ) ;
        ck_SHOWTOOLTIPS     = new JCheckBox () ;

        group1.add ( rb_SHOWICONTEXT ) ;
        group1.add ( rb_SHOWICON ) ;
        group1.add ( rb_SHOWTEXT ) ;
        group2.add ( rb_SMALLBUTTONS ) ;
        group2.add ( rb_DEFAULTBUTTONS ) ;

        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   Set Properties                                          */
        /*                                                           */
        /*-----------------------------------------------------------*/
        pnl_OUTPUT.setBorder ( GUISystem.loweredBorder ) ;  
        pnl_OUTPUT.setBorder ( new TitledBorder ( "" ) ) ;
        pb_REFRESH.setBorderRollover ( true ) ;                        
        pb_REFRESH.setMargin ( insets ) ;
        pb_REFRESH.setFocusPainted ( false ) ;
        pb_BACK.setBorderRollover ( true ) ;                        
        pb_BACK.setMargin ( insets ) ;
        pb_BACK.setFocusPainted ( false ) ;
        pb_FORWARD.setBorderRollover ( true ) ;                        
        pb_FORWARD.setMargin ( insets ) ;
        pb_FORWARD.setFocusPainted ( false ) ;
        pb_BACK.setToolTipText ( Str.getStr ( STR_TOOLTIPS ) ) ;
        pb_FORWARD.setToolTipText ( Str.getStr ( STR_TOOLTIPS ) ) ;
        pb_REFRESH.setToolTipText ( Str.getStr ( STR_TOOLTIPS ) ) ;

        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   Add the GUI                                             */
        /*                                                           */
        /*-----------------------------------------------------------*/
        setLayout ( null ) ;
        add ( rb_SHOWICONTEXT ) ;
        add ( rb_SHOWICON ) ;
        add ( rb_SHOWTEXT ) ;
        add ( pnl_OUTPUT ) ;
        add ( st_TEXTORIENT ) ;                           
        add ( cb_TEXTORIENT ) ;    
        add ( rb_SMALLBUTTONS ) ;
        add ( rb_DEFAULTBUTTONS ) ;
        add ( ck_SHOWTOOLTIPS ) ;
        pnl_OUTPUT.setLayout ( new FlowLayout() ) ;
        pnl_OUTPUT.add ( pb_BACK ) ;
        pnl_OUTPUT.add ( pb_FORWARD ) ;
        pnl_OUTPUT.add ( pb_REFRESH ) ;       

        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   Set the text to the correct language                    */
        /*                                                           */
        /*-----------------------------------------------------------*/
        setText() ;

        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   Refresh our data                                        */
        /*                                                           */
        /*-----------------------------------------------------------*/
        refreshData() ;

        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   Add listeners                                           */
        /*                                                           */
        /*-----------------------------------------------------------*/
        PropertySystem.addPropertyListener ( PropertySystem.PROPERTY_LANGUAGE, this ) ;
        ck_SHOWTOOLTIPS.addActionListener   ( this ) ;
        rb_SHOWICONTEXT.addActionListener   ( this ) ;
        rb_SHOWICON.addActionListener       ( this ) ;
        rb_SHOWTEXT.addActionListener       ( this ) ;
        rb_SMALLBUTTONS.addActionListener   ( this ) ;
        rb_DEFAULTBUTTONS.addActionListener ( this ) ;
        cb_TEXTORIENT.addActionListener     ( this ) ;


        rb_SMALLBUTTONS.setEnabled ( false ) ;
        rb_DEFAULTBUTTONS.setEnabled ( false ) ;
    }





    /*------------------------------------------------------------*/
    /* setText
     */
    /**
     *    This method will set all of the text
     *  in all of our controls
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    private void setText () {
        Vector textOrientVec = new Vector ( 5, 1 ) ;                                           


        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   Create all text strings for orientation and add them    */
        /*                                                           */
        /*-----------------------------------------------------------*/
        textOrientVec.addElement ( Str.getStr ( STR_LEFT ) ) ;
        textOrientVec.addElement ( Str.getStr ( STR_RIGHT ) ) ;
        textOrientVec.addElement ( Str.getStr ( STR_BOTTOM ) ) ;
        textOrientVec.addElement ( Str.getStr ( STR_TOP ) ) ;

        remove ( cb_TEXTORIENT ) ;
        cb_TEXTORIENT = new JComboBox ( textOrientVec ) ;
        add ( cb_TEXTORIENT ) ;                


        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   Handle all other controls                               */
        /*                                                           */
        /*-----------------------------------------------------------*/
        st_TEXTORIENT.setText     ( Str.getStr ( STR_TEXTORIENT ) ) ;
        rb_SHOWICONTEXT.setText   ( Str.getStr ( STR_SHOW_ICON_TEXT ) ) ;
        rb_SHOWICON.setText       ( Str.getStr ( STR_SHOW_ICON ) ) ;
        rb_SHOWTEXT.setText       ( Str.getStr ( STR_SHOW_TEXT ) ) ;
        rb_SMALLBUTTONS.setText   ( Str.getStr ( STR_SMALL_BUTTONS ) ) ;
        rb_DEFAULTBUTTONS.setText ( Str.getStr ( STR_DEFAULT_BUTTONS ) ) ;
        ck_SHOWTOOLTIPS.setText   ( Str.getStr ( STR_SHOW_TOOL_TIPS ) ) ;
        ((TitledBorder)pnl_OUTPUT.getBorder()).setTitle ( Str.getStr ( STR_PREVIEW ) ) ;

        pb_BACK.setText ( Str.getStr ( STR_BACK ) ) ;
        pb_FORWARD.setText ( Str.getStr ( STR_FORWARD ) ) ;
        pb_REFRESH.setText ( Str.getStr ( STR_REFRESH ) ) ;
        refreshData() ;
    }





    /*------------------------------------------------------------*/
    /* doLayout
     */
    /**
     *    This method will lay out and position
     *  all of our controls
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void doLayout () {
        Dimension size      = getSize( );
        int       rowHeight = GUISystem.getRowHeight() ;
        int       halfWidth = size.width/2 ;
        int       y         = 5 ;
        int       x         = 5 ;

        super.doLayout() ;
        st_TEXTORIENT.setBounds ( x, y, halfWidth, rowHeight ) ;
        y+=rowHeight ;

        cb_TEXTORIENT.setBounds ( x, y, halfWidth, rowHeight ) ;
        y+=rowHeight*2 ;

        rb_SHOWICONTEXT.setBounds ( x, y, halfWidth, rowHeight ) ;
        y+=rowHeight ;

        rb_SHOWICON.setBounds ( x, y, halfWidth, rowHeight ) ;
        y+=rowHeight ;

        rb_SHOWTEXT.setBounds ( x, y, halfWidth, rowHeight ) ;
        y+=rowHeight*2 ;


        rb_SMALLBUTTONS.setBounds ( x, y, halfWidth, rowHeight ) ;
        y+=rowHeight ;

        rb_DEFAULTBUTTONS.setBounds ( x, y, halfWidth, rowHeight ) ;
        y+=rowHeight*2 ;

        ck_SHOWTOOLTIPS.setBounds ( x, y, halfWidth, rowHeight ) ;
        y+=rowHeight*2 ;

        pnl_OUTPUT.setBounds ( x, y, size.width-(x*2), rowHeight*5 ) ;

    }



    /*------------------------------------------------------------*/
    /* propertyChanged
     */
    /**
     *    This method will be called when properties
     *  we are waiting for have been changed
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void propertyChanged ( int property, Object value ) {
        if ( property == PropertySystem.PROPERTY_LANGUAGE )
            setText() ;
    }





    /*------------------------------------------------------------*/
    /* refreshData
     */
    /**
     *    This method will set all of our
     *  controls to the current Properties
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    private void refreshData () {

        try {
            String orient = PropertySystem.getString ( PropertySystem.PROPERTY_TOOLBAR_TEXT_ORIENT ) ;
            String show   = PropertySystem.getString ( PropertySystem.PROPERTY_TOOLBAR_SHOW_ICON_TEXT ) ;
            String size   = PropertySystem.getString ( PropertySystem.PROPERTY_TOOLBAR_BUTTON_SIZE ) ;

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Select the correct text orientation                     */
            /*                                                           */
            /*-----------------------------------------------------------*/
            if ( orient.equals ( "LEFT" ) )
                cb_TEXTORIENT.setSelectedIndex ( 0 ) ;
            else if ( orient.equals ( "RIGHT" ) )
                cb_TEXTORIENT.setSelectedIndex ( 1 ) ;
            else if ( orient.equals ( "BOTTOM" ) )
                cb_TEXTORIENT.setSelectedIndex ( 2 ) ;
            else if ( orient.equals ( "TOP" ) )
                cb_TEXTORIENT.setSelectedIndex ( 3 ) ;

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Set the 3 'Show' radio buttons                          */
            /*                                                           */
            /*-----------------------------------------------------------*/
            if ( show.equals ( "ICONTEXT" ) ) {
                rb_SHOWICONTEXT.setSelected ( true ) ;
                actionPerformed ( new ActionEvent ( rb_SHOWICONTEXT, 0, null ) ) ;
            } else if ( show.equals ( "ICON" )  ) {
                rb_SHOWICON.setSelected ( true ) ;
                actionPerformed ( new ActionEvent ( rb_SHOWICON, 0, null ) ) ;
            } else if ( show.equals ( "TEXT" )  ) {
                rb_SHOWTEXT.setSelected ( true ) ;
                actionPerformed ( new ActionEvent ( rb_SHOWTEXT, 0, null ) ) ;
            }


            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Set the 2 size radio buttons                            */
            /*                                                           */
            /*-----------------------------------------------------------*/
            if ( size.equals ( "DEFAULT" ) )
                rb_DEFAULTBUTTONS.setSelected ( true ) ;
            else if ( size.equals ( "SMALL" ) )
                rb_SMALLBUTTONS.setSelected ( true ) ;

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Set the tool tip                                        */
            /*                                                           */
            /*-----------------------------------------------------------*/
            ck_SHOWTOOLTIPS.setSelected ( PropertySystem.getBool ( PropertySystem.PROPERTY_TOOLBAR_HELP ) ) ;

            actionPerformed ( new ActionEvent ( cb_TEXTORIENT,   0, null ) ) ;
            actionPerformed ( new ActionEvent ( ck_SHOWTOOLTIPS, 0, null ) ) ;
        } catch ( Exception e ) {
            e.printStackTrace() ;
        }
    }





    /*------------------------------------------------------------*/
    /* actionPerformed
     */
    /**
     *    This method will be called when an
     *  action event we are listening for has
     *  been fired
     *
     *  @param e The event
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void actionPerformed ( ActionEvent e ) {


        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   Tool Tips                                               */
        /*                                                           */
        /*-----------------------------------------------------------*/
        if ( e.getSource() == ck_SHOWTOOLTIPS ) {
            pb_BACK.setToolTipText    ( ck_SHOWTOOLTIPS.isSelected() ? Str.getStr ( STR_TOOLTIPS ) : "" ) ;
            pb_FORWARD.setToolTipText ( ck_SHOWTOOLTIPS.isSelected() ? Str.getStr ( STR_TOOLTIPS ) : "" ) ;
            pb_REFRESH.setToolTipText ( ck_SHOWTOOLTIPS.isSelected() ? Str.getStr ( STR_TOOLTIPS ) : "" ) ;
        }


        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   Show                                                    */
        /*                                                           */
        /*-----------------------------------------------------------*/
        else if ( e.getSource() == rb_SHOWICONTEXT ) {
            pb_BACK.setText ( Str.getStr ( STR_BACK ) ) ;
            pb_BACK.setIcon ( ImageSystem.getImageIcon ( this, ImageSystem.BACK ) ) ;
            pb_FORWARD.setText ( Str.getStr ( STR_FORWARD ) ) ;
            pb_FORWARD.setIcon ( ImageSystem.getImageIcon ( this, ImageSystem.FORWARD ) ) ;
            pb_REFRESH.setText ( Str.getStr ( STR_REFRESH ) ) ;
            pb_REFRESH.setIcon ( ImageSystem.getImageIcon ( this, ImageSystem.REFRESH ) ) ;
        } else if ( e.getSource() == rb_SHOWICON ) {
            pb_BACK.setText ( "" ) ;
            pb_BACK.setIcon ( ImageSystem.getImageIcon ( this, ImageSystem.BACK ) ) ;
            pb_FORWARD.setText ( "" ) ;
            pb_FORWARD.setIcon ( ImageSystem.getImageIcon ( this, ImageSystem.FORWARD ) ) ;
            pb_REFRESH.setText ( "" ) ;
            pb_REFRESH.setIcon ( ImageSystem.getImageIcon ( this, ImageSystem.REFRESH ) ) ;

        } else if ( e.getSource() == rb_SHOWTEXT ) {
            pb_BACK.setText ( Str.getStr ( STR_BACK ) ) ;
            pb_BACK.setIcon ( null ) ;
            pb_FORWARD.setText ( Str.getStr ( STR_FORWARD ) ) ;
            pb_FORWARD.setIcon ( null ) ;
            pb_REFRESH.setText ( Str.getStr ( STR_REFRESH ) ) ;
            pb_REFRESH.setIcon ( null ) ;
        }


        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   Text orientation                                        */
        /*                                                           */
        /*-----------------------------------------------------------*/
        else if ( e.getSource() == cb_TEXTORIENT ) {
            String orient = (String)cb_TEXTORIENT.getSelectedItem() ;


            setTextOrient ( orient, pb_BACK ) ;
            setTextOrient ( orient, pb_FORWARD ) ;
            setTextOrient ( orient, pb_REFRESH ) ;
            pnl_OUTPUT.invalidate() ;
            pnl_OUTPUT.revalidate() ;
        }

    }




    /*------------------------------------------------------------*/
    /* setTextOrient
     */
    /**
     *    This method will set the text orientation
     *  of one of our preview buttons
     *  
     *
     *  @param orient The new orientation
     *  @param button The DButton to show
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    private void setTextOrient ( String orient, DButton button ) {
        if ( orient.equals ( Str.getStr ( STR_LEFT ) ) ) {
            button.setHorizontalTextPosition ( SwingConstants.LEFT ) ;
            button.setVerticalAlignment ( SwingConstants.CENTER ) ;
        } else if ( orient.equals ( Str.getStr ( STR_RIGHT ) ) ) {
            button.setHorizontalTextPosition ( SwingConstants.RIGHT ) ;
            button.setVerticalAlignment ( SwingConstants.CENTER ) ;
        } else if ( orient.equals ( Str.getStr ( STR_BOTTOM ) ) ) {
            button.setVerticalTextPosition ( SwingConstants.BOTTOM ) ;
            button.setVerticalAlignment ( SwingConstants.TOP ) ;
            button.setHorizontalTextPosition ( SwingConstants.CENTER ) ;
        } else if ( orient.equals ( Str.getStr ( STR_TOP ) ) ) {
            button.setVerticalTextPosition ( SwingConstants.TOP ) ;
            button.setVerticalAlignment ( SwingConstants.BOTTOM ) ;
            button.setHorizontalTextPosition ( SwingConstants.CENTER ) ;
        }

    }






    /*------------------------------------------------------------*/
    /* saveInfo
     */
    /**
     *    This method will save all of our
     *  properties
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public boolean saveInfo () {

        try {
            String orient        = (String)cb_TEXTORIENT.getSelectedItem() ;       
            String currentOrient = PropertySystem.getString ( PropertySystem.PROPERTY_TOOLBAR_TEXT_ORIENT ) ;
            String currentShow   = PropertySystem.getString ( PropertySystem.PROPERTY_TOOLBAR_SHOW_ICON_TEXT ) ;

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Save Text Orient                                        */
            /*                                                           */
            /*-----------------------------------------------------------*/
            if ( ( orient.equals ( Str.getStr ( STR_TOP ) ) ) && ( !currentOrient.equals ( "TOP" ) ) )
                PropertySystem.putString ( PropertySystem.PROPERTY_TOOLBAR_TEXT_ORIENT, "TOP" ) ;
            else if ( ( orient.equals ( Str.getStr ( STR_BOTTOM ) ) ) && ( !currentOrient.equals ( "BOTTOM" ) ) )
                PropertySystem.putString ( PropertySystem.PROPERTY_TOOLBAR_TEXT_ORIENT, "BOTTOM" ) ;
            else if ( ( orient.equals ( Str.getStr ( STR_RIGHT ) ) ) && ( !currentOrient.equals ( "RIGHT" ) ) )
                PropertySystem.putString ( PropertySystem.PROPERTY_TOOLBAR_TEXT_ORIENT, "RIGHT" ) ;
            else if ( ( orient.equals ( Str.getStr ( STR_LEFT ) ) ) && ( !currentOrient.equals ( "LEFT" ) ) )
                PropertySystem.putString ( PropertySystem.PROPERTY_TOOLBAR_TEXT_ORIENT, "LEFT" ) ;

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Show                                                    */
            /*                                                           */
            /*-----------------------------------------------------------*/
            if ( ( rb_SHOWICONTEXT.isSelected() ) && ( !currentShow.equals ( "ICONTEXT" ) ) )
                PropertySystem.putString ( PropertySystem.PROPERTY_TOOLBAR_SHOW_ICON_TEXT, "ICONTEXT" ) ;
            else if ( ( rb_SHOWICON.isSelected() ) && ( !currentShow.equals ( "ICON" ) ) )
                PropertySystem.putString ( PropertySystem.PROPERTY_TOOLBAR_SHOW_ICON_TEXT, "ICON" ) ;
            else if ( ( rb_SHOWTEXT.isSelected() ) && ( !currentShow.equals ( "TEXT" ) ) )
                PropertySystem.putString ( PropertySystem.PROPERTY_TOOLBAR_SHOW_ICON_TEXT, "TEXT" ) ;

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Tool Tips                                               */
            /*                                                           */
            /*-----------------------------------------------------------*/
            if ( PropertySystem.getBool ( PropertySystem.PROPERTY_TOOLBAR_HELP ) != ck_SHOWTOOLTIPS.isSelected() )
                PropertySystem.putBool ( PropertySystem.PROPERTY_TOOLBAR_HELP, ck_SHOWTOOLTIPS.isSelected() ) ;

        } catch ( Exception e ) {
        }

        return ( true ) ;
    }





    /*------------------------------------------------------------*/
    /* free
     */
    /**
     *    This method will be called to release
     *  resources
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    protected void free () {
        PropertySystem.removePropertyListener ( PropertySystem.PROPERTY_LANGUAGE, this ) ;
    }

} /* TaskBarPage */
