package com.ibm.nzna.projects.qit.app.userProp ;
/*-----------------------------------------------------------*/
/*   BrandFamilyPage                                         */
/*                                                           */
/*   Description:                                            */
/*      Source code for: BrandFamilyPage                     */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import javax.swing.* ;
import javax.swing.event.* ;
import java.awt.* ;
import java.awt.event.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.quest.brand.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.gui.wizard.* ;

/**
 * This page holds the default brand and family that the user has selected.
 *
 *
 * @version 1.0, 3/12/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   BrandFamilyPage                                         */
/*                                                           */
/*-----------------------------------------------------------*/
public class BrandFamilyPage extends WizardStep implements AppConst, ActionListener, ListSelectionListener, TypeListListener {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   GUI Variables                                           */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private JLabel      st_HELP            = null ;
   private JLabel      st_BRAND           = null ;
   private JLabel      st_FAMILY          = null ;
   private JList       lb_BRAND           = null ;
   private JList       lb_FAMILY          = null ;
   private JScrollPane scr_BRAND          = null ;
   private JScrollPane scr_FAMILY         = null ;
   private JCheckBox   ck_NO_BRAND        = null ;
   private JCheckBox   ck_NO_FAMILY       = null ;



   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will simply create our panel
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public BrandFamilyPage () {
      initialize() ;
   }




   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will initialize our GUI and add's
    *  the GUI to our panel
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void initialize () {                

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create the GUI Components                               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      st_HELP            = new JLabel ( Str.getStr ( STR_DEFAULT_BRAND_FAMILY_HELP ) )  ;
      st_BRAND           = new JLabel ( Str.getStr ( STR_BRAND ) )  ;
      st_FAMILY          = new JLabel ( Str.getStr ( STR_FAMILY ) ) ;
      lb_BRAND           = new JList () ;
      lb_FAMILY          = new JList () ;
      scr_BRAND          = new JScrollPane ( lb_BRAND ) ;
      scr_FAMILY         = new JScrollPane ( lb_FAMILY ) ;
      ck_NO_BRAND        = new JCheckBox ( Str.getStr ( STR_NONE ) ) ;
      ck_NO_FAMILY       = new JCheckBox ( Str.getStr ( STR_NONE ) ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add listeners                                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      lb_BRAND.addListSelectionListener ( this ) ;
      ck_NO_BRAND.addActionListener ( this ) ;
      ck_NO_FAMILY.addActionListener ( this ) ;        

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      st_HELP.setVerticalAlignment ( SwingConstants.TOP ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add the GUI                                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( null ) ;
      add ( st_HELP ) ;
      add ( st_BRAND ) ;
      add ( st_FAMILY ) ;
      add ( scr_BRAND ) ;
      add ( scr_FAMILY ) ;
      add ( ck_NO_BRAND ) ;
      add ( ck_NO_FAMILY ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Refresh our data                                        */
      /*                                                           */
      /*-----------------------------------------------------------*/
      refreshData() ;

   }





   /*------------------------------------------------------------*/
   /* refreshData
    */
   /**
    *    This method will refresh all of the fields
    *  on the screen
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void refreshData () {
       lb_BRAND.setListData ( Brands.getBrands() ) ;
       listRefreshed(0) ;
   }




   /*------------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will lay out and position all of our
    *  controls
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size      = getSize() ;
      int       y         = 5 ;
      int       x         = 25 ;
      int       rowHeight = GUISystem.getRowHeight() ;

      super.doLayout() ;

      st_HELP.setBounds ( x, y, size.width-x, 100 ) ;
      y+=100 ;

      st_BRAND.setBounds ( x, y, 150, rowHeight ) ;
      st_FAMILY.setBounds ( x+200, y, 150 ,rowHeight ) ;
      y+=rowHeight ;

      scr_BRAND.setBounds ( x, y, 150, size.height-y-rowHeight-5 ) ;
      scr_FAMILY.setBounds ( x+200, y, 150, size.height-y-rowHeight-5 ) ;

      ck_NO_BRAND.setBounds ( x, size.height-rowHeight-5, 150, rowHeight ) ;
      ck_NO_FAMILY.setBounds ( x+200, size.height-rowHeight-5, 150, rowHeight ) ;
   }



   /*------------------------------------------------------------*/
   /* valueChanged
    */
   /**
    *    This method will respond to list events
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void valueChanged ( ListSelectionEvent e ) {
      TypeCategoryRec brandRec = (TypeCategoryRec) lb_BRAND.getSelectedValue() ;

      if ( brandRec != null ) {
         lb_FAMILY.removeAll() ;
         lb_FAMILY.setListData ( Brands.getFamilies ( brandRec.getInd() ) ) ;
      }

   }





   /*------------------------------------------------------------*/
   /* listRefreshed
    */
   /**
    *    This method will be called when one 
    *  of the type lists that we have asked to populate
    *  is done and is now refreshed
    *
    *  @param typeList The type list that was refreshed
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void listRefreshed ( int typeList ) {
      try {
         int               brandInd  = PropertySystem.getInt ( PropertySystem.PROPERTY_DEFAULT_BRAND ) ;
         int               groupInd  = PropertySystem.getInt ( PropertySystem.PROPERTY_DEFAULT_GROUP ) ;
         TypeCategoryRec   brandRec  = Brands.getBrand ( brandInd ) ;
         TypeFamilyRec     familyRec = Brands.getFamily ( groupInd ) ;

         if ( brandRec != null ) {
            lb_BRAND.setSelectedValue ( brandRec, true ) ;
            lb_FAMILY.removeAll() ;
            lb_FAMILY.setListData ( Brands.getFamilies ( brandRec ) ) ;
            
            if ( familyRec != null ) 
               lb_FAMILY.setSelectedValue ( familyRec, true ) ;
         }


         ck_NO_BRAND.setSelected ( brandInd == -1 ) ;
         ck_NO_FAMILY.setSelected ( groupInd == -1 ) ;

         enableLists() ;

      } catch ( Exception e ) {
          LogSystem.log ( 1, e, false ) ;
      }
   }




   /*------------------------------------------------------------*/
   /* enableLists
    */
   /**
    *    This method will either enable or disable the
    *  lists according to the check box located 
    *  beneath each
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void enableLists () {
      lb_BRAND.setEnabled ( !ck_NO_BRAND.isSelected() ) ;
      lb_FAMILY.setEnabled ( !ck_NO_FAMILY.isSelected() ) ;
   }





   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will be called when the user
    *  clicks on one of our check boxes
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {
      enableLists() ;
   }

   /*------------------------------------------------------------*/
   /* saveProperties
    */
   /**
    *    This method will save our properties
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean saveInfo () {
      boolean rc = true ;

      try {
         TypeCategoryRec brandRec = (TypeCategoryRec ) lb_BRAND.getSelectedValue () ;
         TypeGroupRec familyRec = (TypeGroupRec ) lb_FAMILY.getSelectedValue () ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   ck_NO_BRAND                                             */  
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( !ck_NO_BRAND.isSelected() ) {
            if ( brandRec == null ) {
               PropertySystem.putInt ( PropertySystem.PROPERTY_DEFAULT_BRAND, -1 ) ;
            } else
               PropertySystem.putInt ( PropertySystem.PROPERTY_DEFAULT_BRAND, brandRec.getInd() ) ;
         } else
            PropertySystem.putInt ( PropertySystem.PROPERTY_DEFAULT_BRAND, -1 ) ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   ck_NO_FAMILY                                            */   
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( !ck_NO_FAMILY.isSelected() ) {
            if ( familyRec == null ) {
               PropertySystem.putInt ( PropertySystem.PROPERTY_DEFAULT_GROUP, -1 ) ;
            } else
               PropertySystem.putInt ( PropertySystem.PROPERTY_DEFAULT_GROUP, familyRec.getInd() ) ;
         } else
            PropertySystem.putInt ( PropertySystem.PROPERTY_DEFAULT_GROUP, -1 ) ;

      } catch ( Exception e ) {
          LogSystem.log ( 1, e, false ) ;
      }


      return( rc ) ;
   }


   
   
   
      /*------------------------------------------------------------*/
      /* getTitle
       */
      /**
       *    This method will return our title that is shown
       *  if we are in a wizard
       *  
       *
       *  @param None
       *  @param None
       *  @param None
       *
       *  @return Nothing
       *//*---------------------------------------------------------*/
   public String getTitle () {
      return ( Str.getStr ( STR_DEFAULT_BRAND_FAMILY_HELP_TITLE ) ) ;
   }
} /* BrandFamilyPage */
