package com.ibm.nzna.projects.qit.app.userProp ;
/*-----------------------------------------------------------*/
/*   FavoriteCountryPage                                     */
/*                                                           */
/*   Description:                                            */
/*      Source code for: FavoriteCountryPage                 */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import javax.swing.* ;
import javax.swing.event.* ;
import java.awt.* ;
import java.util.* ;
import java.awt.event.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.quest.brand.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.shared.sort.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.gui.wizard.* ;

/**
 * This page holds the favorite Country selection.
 *
 *
 * @version 1.0, 3/12/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   FavoriteCountryPage                                     */
/*                                                           */
/*-----------------------------------------------------------*/
public class FavoriteCountryPage extends WizardStep implements AppConst, ActionListener {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   GUI Variables                                           */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private JLabel      st_HELP              = null ;
   private JLabel      st_AVAIL_COUNTRY     = null ;
   private JLabel      st_FAVORITE_COUNTRY  = null ;
   private JList       lb_AVAIL_COUNTRY     = null ;
   private JList       lb_FAVORITE_COUNTRY  = null ;
   private JScrollPane scr_AVAIL_COUNTRY    = null ;
   private JScrollPane scr_FAVORITE_COUNTRY = null ;
   private JCheckBox   ck_ALWAYS_USE_AUTO   = null ;
   private DButton     pb_ADD               = null ;
   private DButton     pb_REMOVE            = null ;      

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private DefaultListModel listModel        = null ;



   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will simply create our panel
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public FavoriteCountryPage () {
      initialize() ;
   }




   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will initialize our GUI and add's
    *  the GUI to our panel
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void initialize () {                

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create the GUI Components                               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      st_HELP                 = new JLabel ( Str.getStr ( STR_FAVORITE_COUNTRY_HELP ) )  ;
      st_AVAIL_COUNTRY        = new JLabel ( Str.getStr ( STR_AVAIL_COUNTRY ) )  ;
      st_FAVORITE_COUNTRY     = new JLabel ( Str.getStr ( STR_FAVORITE_COUNTRY ) ) ;
      lb_AVAIL_COUNTRY        = new JList () ;
      lb_FAVORITE_COUNTRY     = new JList () ;
      scr_AVAIL_COUNTRY       = new JScrollPane ( lb_AVAIL_COUNTRY ) ;
      scr_FAVORITE_COUNTRY    = new JScrollPane ( lb_FAVORITE_COUNTRY ) ;
      ck_ALWAYS_USE_AUTO      = new JCheckBox ( Str.getStr ( STR_ALWAYS_USE_FAV_COUNTRY_AUTO ) ) ;
      pb_ADD                  = new DButton ( ">>" ) ;
      pb_REMOVE               = new DButton ( "<<" ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add listeners                                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      ck_ALWAYS_USE_AUTO.addActionListener ( this ) ;
      pb_ADD.addActionListener             ( this ) ;
      pb_REMOVE.addActionListener          ( this ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      st_HELP.setVerticalAlignment ( SwingConstants.TOP ) ;
      listModel = new DefaultListModel () ;
      lb_FAVORITE_COUNTRY.setModel ( listModel ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add the GUI                                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( null ) ;
      add ( st_HELP ) ;
      add ( st_AVAIL_COUNTRY ) ;
      add ( st_FAVORITE_COUNTRY ) ;
      add ( scr_AVAIL_COUNTRY ) ;
      add ( pb_ADD ) ;
      add ( pb_REMOVE ) ;
      add ( scr_FAVORITE_COUNTRY ) ;
      add ( ck_ALWAYS_USE_AUTO ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Refresh our data                                        */
      /*                                                           */
      /*-----------------------------------------------------------*/
      refreshData() ;

   }





   /*------------------------------------------------------------*/
   /* refreshData
    */
   /**
    *    This method will refresh all of the fields
    *  on the screen
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void refreshData () {
      Vector favoriteVec = (Vector) PropertySystem.get ( PropertySystem.PROPERTY_COUNTRY_FAVORITES ) ;
      Vector availCountryVec = UserSystem.getLoggedUserCountries() ;

      new QuickSort ( availCountryVec ) ;
      lb_AVAIL_COUNTRY.setListData ( availCountryVec ) ; //TypeList.getInstance().getTypeList ( TypeList.TYPE_COUNTRYCODE ) ) ;

      if ( ( favoriteVec != null ) && ( favoriteVec.size() > 0 ) ) {
         int i    = 0 ;
         int size = favoriteVec.size() ;

         while ( i < size )
            listModel.add ( 0, favoriteVec.elementAt(i++ ) ) ;
      }

      ck_ALWAYS_USE_AUTO.setSelected ( PropertySystem.getBool ( PropertySystem.PROPERTY_COUNTRY_FAVORITES_AUTO ) ) ;

      enableLists() ;
   }




   /*------------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will lay out and position all of our
    *  controls
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size      = getSize() ;
      int       y         = 5 ;
      int       x         = 25 ;
      int       rowHeight = GUISystem.getRowHeight() ;

      super.doLayout() ;

      st_HELP.setBounds ( x, y, size.width-x, 100 ) ;
      y+=100 ;

      st_AVAIL_COUNTRY.setBounds ( x, y, 150, rowHeight ) ;
      st_FAVORITE_COUNTRY.setBounds ( x+200, y, 150 ,rowHeight ) ;
      y+=rowHeight ;

      scr_AVAIL_COUNTRY.setBounds ( x, y, 150, size.height-y-rowHeight-5 ) ;
      scr_FAVORITE_COUNTRY.setBounds ( x+200, y, 150, size.height-y-rowHeight-5 ) ;
      pb_ADD.setBounds ( x+160, y, 25, rowHeight-5 ) ;
      pb_REMOVE.setBounds ( x+160, y+rowHeight+5, 25, rowHeight-5 ) ;

      ck_ALWAYS_USE_AUTO.setBounds ( x, size.height-rowHeight-5, size.width-(x*2), rowHeight ) ;
   }




   /*------------------------------------------------------------*/
   /* enableLists
    */
   /**
    *    This method will either enable or disable the
    *  lists according to the check box located 
    *  beneath each
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void enableLists () {
      lb_AVAIL_COUNTRY.setEnabled    ( !ck_ALWAYS_USE_AUTO.isSelected() ) ;
      lb_FAVORITE_COUNTRY.setEnabled ( !ck_ALWAYS_USE_AUTO.isSelected() ) ;
      pb_ADD.setEnabled              ( !ck_ALWAYS_USE_AUTO.isSelected() ) ;
      pb_REMOVE.setEnabled           ( !ck_ALWAYS_USE_AUTO.isSelected() ) ;
   }





   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will be called when the user
    *  clicks on one of our check boxes
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {         

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   ck_ALWAYS_USE_AUTO                                      */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( e.getSource() == ck_ALWAYS_USE_AUTO )
         enableLists() ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_ADD                                                  */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_ADD )
         add() ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_REMOVE                                               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_REMOVE )
         remove() ;


   }

   /*------------------------------------------------------------*/
   /* saveProperties
    */
   /**
    *    This method will save our properties
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean saveInfo () {
      boolean rc        = false ;
      Vector  favorites = new Vector ( 10 ) ;
      boolean useAuto   = ck_ALWAYS_USE_AUTO.isSelected() ;

      if ( ( listModel.size() > 0 ) && ( !useAuto ) ) {
         int i    = 0 ;
         int size = listModel.size() ;

         while ( i < size ) {
            favorites.addElement ( listModel.elementAt(i) ) ;
            i++ ;
         }

         PropertySystem.putBool ( PropertySystem.PROPERTY_COUNTRY_FAVORITES_AUTO, useAuto ) ;
         PropertySystem.put ( PropertySystem.PROPERTY_COUNTRY_FAVORITES, favorites ) ;
         rc = true ;

      } else if ( !useAuto )
         GUISystem.printBox ( STR_INFO, STR_MUST_SELECT_FAVORITE_COUNTRY ) ;
      else
         rc = true ;



      return( rc ) ;
   }





   /*------------------------------------------------------------*/
   /* add
    */
   /**
    *    This method will add all selected countries
    *  from the available country list to the favorite
    *  country list
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void add () {
      Object[] selected = lb_AVAIL_COUNTRY.getSelectedValues() ;

      if ( ( selected != null ) && ( selected.length > 0 ) ) {
         for ( int i = 0 ; i < selected.length; i++ )
            if ( !listModel.contains ( selected[i] ) )
               listModel.add ( 0, selected[i] ) ;
      }
   }




   /*------------------------------------------------------------*/
   /* remove
    */
   /**
    *    This method will remove all selected items
    *  from the favorite country list
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void remove () {
      Object[] selected = lb_FAVORITE_COUNTRY.getSelectedValues() ;

      if ( ( selected != null ) && ( selected.length > 0 ) ) {
         for ( int i = 0 ; i < selected.length; i++ )
            listModel.removeElement ( selected[i] ) ;
      }
   }





   /*------------------------------------------------------------*/
   /* getTitle
    */
   /**
    *    THis method will return the title that will
    *  show in a wizard
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getTitle () {
      return( Str.getStr ( STR_FAVORITE_COUNTRY_HELP_TITLE ) ) ;
   }
} /* FavoriteCountryPage */
