package com.ibm.nzna.projects.qit.app.userProp ;
/*-----------------------------------------------------------*/
/*   UserPage                                                */
/*                                                           */
/*   Description:                                            */
/*      Source code for: UserPage                            */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import javax.swing.* ;
import java.awt.* ;
import java.awt.event.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.qit.type.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.shared.gui.* ;
/**
 * This page holds static information about the user, allowing them to change their password. 
 *
 *
 * @version 1.0, 3/12/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   UserPage                                                */
/*                                                           */
/*-----------------------------------------------------------*/
public class UserPage extends JPanel implements AppConst, ActionListener {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   GUI Variables                                           */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private JLabel   st_NAME            = null ;
   private JLabel   stt_NAME           = null ;
   private JLabel   st_MANAGER         = null ;
   private JLabel   stt_MANAGER        = null ;
   private JLabel   st_PHONE           = null ;
   private JLabel   stt_PHONE          = null ;
   private JLabel   st_IPADDRESS       = null ;
   private JLabel   stt_IPADDRESS      = null ;
   private JLabel   st_TEAMS           = null ;
   private JLabel   stt_TEAMS          = null ;
   private DButton  pb_CHANGEPW        = null ;



   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will simply create our panel
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public UserPage () {
      initialize() ;
   }




   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will initialize our GUI and add's
    *  the GUI to our panel
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void initialize () {                

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create the GUI Components                               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      st_NAME            = new JLabel ( Str.getStr ( STR_NAME ) )  ;
      stt_NAME           = new JLabel () ;
      st_MANAGER         = new JLabel ( Str.getStr ( STR_MANAGER ) )  ;
      stt_MANAGER        = new JLabel () ;
      st_PHONE           = new JLabel ( Str.getStr ( STR_PHONE ) ) ;
      stt_PHONE          = new JLabel () ;
      st_IPADDRESS       = new JLabel ( Str.getStr ( STR_CURRENT_IP_ADDRESS ) ) ;
      stt_IPADDRESS      = new JLabel () ;
      st_TEAMS           = new JLabel ( Str.getStr ( STR_TEAMS ) ) ;
      stt_TEAMS          = new JLabel () ;
      pb_CHANGEPW        = new DButton ( Str.getStr ( STR_CHANGE_PASSWORD ) ) ;        


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      stt_NAME.setForeground ( Color.blue ) ;
      stt_MANAGER.setForeground ( Color.blue ) ;
      stt_PHONE.setForeground ( Color.blue ) ;
      stt_IPADDRESS.setForeground ( Color.blue ) ;    
      stt_TEAMS.setForeground ( Color.blue ) ;    

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add listeners                                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      pb_CHANGEPW.addActionListener ( this ) ;  
      GUISystem.setPreferredButton ( pb_CHANGEPW ) ;
      stt_TEAMS.setVerticalAlignment ( SwingConstants.TOP ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add the GUI                                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( null ) ;
      add ( st_NAME ) ;
      add ( stt_NAME ) ;
      add ( st_MANAGER ) ;
      add ( stt_MANAGER ) ;
      add ( st_PHONE ) ;
      add ( stt_PHONE ) ;
      add ( st_IPADDRESS ) ;
      add ( stt_IPADDRESS ) ;
      add ( st_TEAMS ) ;
      add ( stt_TEAMS ) ;
      add ( pb_CHANGEPW ) ;       


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Refresh our data                                        */
      /*                                                           */
      /*-----------------------------------------------------------*/
      refreshData() ;

   }





   /*------------------------------------------------------------*/
   /* refreshData
    */
   /**
    *    This method will refresh all of the fields
    *  on the screen
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void refreshData () {
      LoggedUserRec userRec  = UserSystem.getLoggedUserRec() ;
      int[]         teams    = userRec.getTeams() ;
      String        strTeams = "<html><body><font size=2 color=blue>" ;
      QITTypeList   typeList = (QITTypeList)QITTypeList.getInstance() ;

      stt_NAME.setText      ( userRec.getName () ) ;
      stt_MANAGER.setText   ( UserSystem.getNameFromUserId ( userRec.getManagerUserId() ) ) ;
      stt_PHONE.setText     ( userRec.getPhone() ) ;
      stt_IPADDRESS.setText ( userRec.getIPAddress() ) ;

      for ( int i = 0; i < teams.length; i++ ) {
         strTeams+=""+typeList.stringFromInd ( teams[i], QITTypeList.TYPE_TEAM ) ;
         if ( i != teams.length-1 )
            strTeams+="," ;
      }
      strTeams+="</font></body></html>" ;

      stt_TEAMS.setText ( strTeams ) ;
   }




   /*------------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will lay out and position all of our
    *  controls
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size      = getSize() ;
      int       y         = 5 ;
      int       x         = 5 ;
      int       rowHeight = GUISystem.getRowHeight() ;

      super.doLayout() ;

      st_NAME.setBounds ( x, y, 130, rowHeight ) ;
      stt_NAME.setBounds ( x+130, y, 150, rowHeight ) ;
      y+=rowHeight ;

      st_MANAGER.setBounds ( x, y, 130, rowHeight ) ;
      stt_MANAGER.setBounds ( x+130, y, 150, rowHeight ) ;
      y+=rowHeight ;

      st_PHONE.setBounds ( x, y, 130, rowHeight ) ;
      stt_PHONE.setBounds ( x+130, y, 150, rowHeight ) ;
      y+=rowHeight ;

      st_IPADDRESS.setBounds ( x, y, 130, rowHeight ) ;
      stt_IPADDRESS.setBounds ( x+130, y, 150, rowHeight ) ;
      y+=rowHeight ;

      st_TEAMS.setBounds ( x, y, 130, rowHeight ) ;
      stt_TEAMS.setBounds ( x+130, y, 150, size.height-y-30 ) ;
      y+=rowHeight ;

      pb_CHANGEPW.setLocation ( x, size.height-30 ) ;
      pb_CHANGEPW.setSize ( pb_CHANGEPW.getMinimumSize() ) ;
   }



   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will respond to button events
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {
      if ( e.getSource() == pb_CHANGEPW )
         new PasswordChangeDlg ( GUISystem.getParentDefWin(this) ) ;
   }




} /* UserPage */
