package com.ibm.nzna.projects.qit.avalon ;
/*-----------------------------------------------------------*/
/*   Avalon                                                  */
/*                                                           */
/*   Description:                                            */
/*      Source code for: Avalon                              */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.qit.app.util.* ;
import com.ibm.nzna.projects.qit.avalon.oanav.* ;
import com.ibm.nzna.projects.qit.avalon.base.* ;
import com.ibm.nzna.projects.qit.avalon.gui.* ;
import com.ibm.nzna.projects.qit.avalon.editors.* ;
import javax.swing.* ;
import java.awt.event.* ;
import java.awt.* ;
import java.io.* ;
import java.util.* ;
/**
 * This Quest Applet is the Online Assistant Authoring Tool. 
 *
 *
 * @version 1.0, 3/30/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   Avalon                                                  */
/*                                                           */
/*-----------------------------------------------------------*/
public class Avalon extends Object implements Runnable, ActionListener, java.io.Serializable, OASort, QuestApplet, AvalonConst, AppConst {



   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private OANavPanel         oaNavPanel       = null ;            
   private static Avalon      instance         = null ;
   private static boolean     createdMenuItems = false ;
   private        JMenuItem   createQuestion   = null ;
   private        JMenuItem   createAction     = null ;
   private        JMenuItem   createLink       = null ;
   private        JMenuItem   createSymptom    = null ;
   private        JMenuItem   createLinkGroup  = null ;
   private        Object      lastEventSource  = null ;







   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    Default constructor does nothing
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public Avalon () {

      if ( instance == null )
         instance = this ;

      if ( !createdMenuItems ) {
         AppDefaultMenuBar menuBar = MainWindow.getInstance().getAppDefaultMenuBar() ; 

         createdMenuItems = true ;

         if ( UserSystem.hasAuthority ( AUTH_AVALON ) ) {
            createQuestion  = new JMenuItem ( Str.getStr ( STR_QUESTION ) ) ;
            createAction    = new JMenuItem ( Str.getStr ( STR_ACTION ) ) ;
            createSymptom   = new JMenuItem ( Str.getStr ( STR_SYMPTOM ) ) ;
            createLink      = new JMenuItem ( Str.getStr ( STR_LINK ) ) ;
            createLinkGroup = new JMenuItem ( Str.getStr ( STR_LINK_GROUP ) ) ;

            menuBar.addCreateMenuItem ( createAction ) ;
            menuBar.addCreateMenuItem ( createLink ) ;
            menuBar.addCreateMenuItem ( createLinkGroup ) ;
            menuBar.addCreateMenuItem ( createQuestion ) ;
            menuBar.addCreateMenuItem ( createSymptom ) ;


            createQuestion.addActionListener ( this ) ;
            createAction.addActionListener ( this ) ;
            createSymptom.addActionListener ( this ) ;
            createLink.addActionListener ( this ) ;
            createLinkGroup.addActionListener ( this ) ;
         }
      }
   }


   /*------------------------------------------------------------*/
   /* getIcon
    */
   /**
    *    This method will return the icon that represents
    *  this applet. This icon is displayed on the 
    *  workspace page
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return ImageIcon
    *//*---------------------------------------------------------*/
   public ImageIcon getIcon () {
      return( ImageSystem.getImageIcon ( MainWindow.getInstance(), ImageSystem.OA_LARGE ) ) ;
   }





   /*------------------------------------------------------------*/
   /* getSmallIcon
    */
   /**
    *    This method will return the small icon used
    *  to represent this Applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public ImageIcon getSmallIcon () {
      return( ImageSystem.getImageIcon ( MainWindow.getInstance(), ImageSystem.OA_SMALL ) ) ;
   }





   /*------------------------------------------------------------*/
   /* getDescription
    */
   /**
    *    This method will return the long description
    *  of this Quest Applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getDescription () {
      return( Str.getStr ( STR_AVALON_DESCRIPTION ) ) ;
   }




   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will initialize our Quest Applet.
    *  We will return FALSE if we cannot initialize. Otherwise
    *  we will return TRUE
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean initialize () {
      boolean setDefault = false ;                         
      String  homeDir    = PropertySystem.getString ( PropertySystem.PROPERTY_HOMEDIR ) ;
      String  skinDir    = homeDir+File.separator+"skins"+File.separator+PropertySystem.getString ( PropertySystem.PROPERTY_SKINNAME ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Initialize our Applet's properties, if any one of the   */
      /* properties does not exist, an exception will be thrown    */
      /* and we will set our default properties in the catch       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( PropertySystem.get ( PROPERTY_FLOWNODE_COLOR ) == null )
         setDefault = true ;

      if ( PropertySystem.get ( PROPERTY_VISIO_TEXT_LENGTH ) == null )
         setDefault = true ;

      if ( PropertySystem.get ( PROPERTY_GRID_COLOR ) == null )
         setDefault = true ;

      if ( PropertySystem.get ( PROPERTY_FLOWNODE_FOCUS_COLOR ) == null )
         setDefault = true ;

      if ( PropertySystem.get ( PROPERTY_FLOWNODE_ACTION_COLOR ) == null )
         setDefault = true ;

      if ( PropertySystem.get ( PROPERTY_FLOW_FILTER ) == null )
         setDefault = true ;

      if ( PropertySystem.get ( PROPERTY_EDGE_RETURN_COLOR ) == null )
         setDefault = true ;

      if ( PropertySystem.get ( PROPERTY_EDGE_FOCUS_COLOR ) == null )
         setDefault = true ;

      if ( PropertySystem.get ( PROPERTY_EDGE_COLOR ) == null )
         setDefault = true ;

      if ( PropertySystem.get ( PROPERTY_SEARCH_HISTORY ) == null )
         setDefault = true ;

      if ( PropertySystem.get ( PROPERTY_FLOW_BACKGROUND_COLOR ) == null )
         setDefault = true ;

      if ( PropertySystem.getInt ( PROPERTY_OANAV_SORT ) == 0 )
         setDefault = true ;

      if ( PropertySystem.get ( PROPERTY_FLOWNODE_TEXT_COLOR ) == null )
         setDefault = true ;

      if ( PropertySystem.get ( PROPERTY_FLOWNODE_FOCUS_TEXT_COLOR ) == null )
         setDefault = true ;

      if ( setDefault ) {
         FlowEditorFilter editorFilter = new FlowEditorFilter() ;

         System.out.println ( "Resetting Avalon Defaults" ) ;
         editorFilter.setCountryFilterList ( UserSystem.getUserCountries() ) ;
         editorFilter.setSite ( editorFilter.SITE_INFOTIPS ) ;

         PropertySystem.put    ( PROPERTY_VALIDATOR_PRODUCT, "" ) ;
         PropertySystem.putInt ( PROPERTY_VALIDATOR_COUNTRY, 124 ) ;
         PropertySystem.put    ( PROPERTY_VALIDATOR_SITE, "Info Tips" ) ;    
         PropertySystem.put    ( PROPERTY_FLOWNODE_COLOR, new Color ( 230, 230, 230 ) ) ;
         PropertySystem.put    ( PROPERTY_FLOWNODE_FOCUS_COLOR, new Color ( 0, 0, 170 ) ) ;
         PropertySystem.putInt ( PROPERTY_VISIO_TEXT_LENGTH, 50 ) ;
         PropertySystem.put    ( PROPERTY_GRID_COLOR, new Color ( 240, 240, 240 ) ) ;
         PropertySystem.put    ( PROPERTY_FLOWNODE_ACTION_COLOR, new Color ( 200, 0, 0 ) ) ;
         PropertySystem.put    ( PROPERTY_FLOW_FILTER, editorFilter ) ;
         PropertySystem.putInt ( PROPERTY_OANAV_SORT, OASort.SORT_TITLE_ASC ) ;
         PropertySystem.put    ( PROPERTY_FLOWNODE_TEXT_COLOR, Color.black ) ;
         PropertySystem.put    ( PROPERTY_FLOWNODE_FOCUS_TEXT_COLOR, Color.white ) ;
         PropertySystem.put    ( PROPERTY_EDGE_COLOR, Color.black ) ;
         PropertySystem.put    ( PROPERTY_EDGE_FOCUS_COLOR, new Color ( 0, 0, 170 ) ) ;
         PropertySystem.put    ( PROPERTY_EDGE_RETURN_COLOR, new Color ( 0, 0, 255 ) ) ;
         PropertySystem.put    ( PROPERTY_FLOW_BACKGROUND_COLOR, new Color ( 255, 255, 255 ) ) ;
         PropertySystem.put    ( PROPERTY_SEARCH_HISTORY, new Vector ( 1 ) ) ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Make Continous Flow on by default                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      PropertySystem.putBool ( PROPERTY_CONTINUOUS_DRAW, true ) ;



      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Copy over Images for the Preview in OANav               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      QuestUtil.copyFileToTempDir ( skinDir+File.separator+"ibm_confidential.gif" ) ;
      QuestUtil.copyFileToTempDir ( skinDir+File.separator+"ibm_dealer_confidential.gif" ) ;
      QuestUtil.copyFileToTempDir ( skinDir+File.separator+"unclassified.gif" ) ;

      return( true ) ;
   }





   /*------------------------------------------------------------*/
   /* start
    */
   /**
    *    This method will start the Quest Applet.
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void start () {
      Avalon instance = getInstance() ;

      if ( instance.oaNavPanel == null )
         WindowSystem.createPanel ( instance.oaNavPanel = new OANavPanel() ) ;
      else
         WindowSystem.showPanel ( instance.oaNavPanel ) ;
   }





   /*------------------------------------------------------------*/
   /* getAuthority
    */
   /**
    *    This method will return the authority that
    *  is needed to run this applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public int getAuthority () {
      return( AUTH_AVALON ) ;
   }




   /*------------------------------------------------------------*/
   /* getName
    */
   /**
    *    This method will return the name of this
    *  Quest Applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public String getName () {
      return( Str.getStr ( STR_AVALON ) ) ;
   }





   /*------------------------------------------------------------*/
   /* canChat
    */
   /**
    *    This method will return FALSE
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean canChat () {
      return( false ) ;
   }





   /*------------------------------------------------------------*/
   /* getOANavPanel
    */
   /**
    *    This method will return the OANavPanel
    *  That the application is using
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public static OANavPanel getOANavPanel () {
      return( getInstance().oaNavPanel ) ;
   }

   /*------------------------------------------------------------*/
   /* setOANavPanel
    */
   /**
    *    This method will set the OANavPanel
    *  That the application is using
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public static void setOANavPanel ( OANavPanel newoaNavPanel) {
      getInstance().oaNavPanel = newoaNavPanel ;
   }






   /*------------------------------------------------------------*/
   /* getInstance
    */
   /**
    *    Returns the one tracked instance of the Avalon
    *  application
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private static Avalon getInstance() {
      return( instance ) ;
   }




   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will be called when an action
    *  event is fired on us
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {
      lastEventSource = e.getSource()  ;
      new Thread ( this ).start() ;
   }

   public void run () {
      QuestPanel questPanel = oaNavPanel ;

      if ( questPanel == null )
         questPanel = com.ibm.nzna.projects.qit.workspace.WorkspacePanel.getInstance() ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Question                                                */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( lastEventSource == createQuestion )
         OANavPanel.newObject (  AVALON_QUESTION , questPanel ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Action                                                  */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( lastEventSource == createAction )
         OANavPanel.newObject (  AVALON_ACTION , questPanel ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Symptom                                                 */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( lastEventSource == createSymptom )
         OANavPanel.newObject (  AVALON_SYMPTOM , questPanel ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Link                                                    */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( lastEventSource == createLink )
         OANavPanel.newObject (  AVALON_LINK , questPanel ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   LinkGroup                                               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( lastEventSource == createLinkGroup )
         OANavPanel.newObject (  AVALON_LINK_GROUP , questPanel ) ;



   }
} /* Avalon */
