package com.ibm.nzna.projects.qit.avalon.base ;                          
/*-----------------------------------------------------------*/
/*   ActionSoftValidator                                     */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ActionSoftValidator                 */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.projects.common.quest.oa.* ;
/**
 * This class holds the methods needed to do a 'soft' validation of a action. 
 *
 *
 * @version 1.0, 5/17/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ActionSoftValidator                                     */
/*                                                           */
/*-----------------------------------------------------------*/
public class ActionSoftValidator extends SoftValidator {




   /*------------------------------------------------------------*/
   /* validateAction
    */
   /**
    *    This method will validate a action and
    *  will return the string that needs to be displayed
    *  to the user in a Browser control
    *
    *  @param action The action to validate
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public static String validateAction ( Action action ) {
      StringBuffer buffer = new StringBuffer ( "<html><head><font face=\"Helvetica\">" ) ;

      validateAuthority ( buffer,
                          action.getBrand(),
                          action.getCountryList() ) ;

      validateTitles ( buffer, 
                       action.getTitles(), 
                       action.getDocClass().getInd() ) ;

      validateAddtlInfos ( buffer,
                           action.getAdditionalInfo(),
                           action.getDocClass().getInd() ) ;

      buffer.append ( "</font></head></html>" ) ;
      return ( buffer.toString() ) ;
   }
} /* ActionSoftValidator */
