package com.ibm.nzna.projects.qit.avalon.base ;                       
/*-----------------------------------------------------------*/
/*   EdgeReturnDisplayRec                                    */
/*                                                           */
/*   Description:                                            */
/*      Source code for: EdgeReturnDisplayRec                */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.avalon.editors.* ;
import com.ibm.nzna.projects.common.quest.oa.* ;
/**
 * This records represents an EdgeReturn object. Currently  
 * it is used only in the VisioPanel.
 *
 *
 * @version 1.0, 10/22/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   EdgeReturnDisplayRec                                    */
/*                                                           */
/*-----------------------------------------------------------*/
public class EdgeReturnDisplayRec extends Object implements DisplayRec, java.io.Serializable, AvalonConst, AppConst {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private EdgeReturn edgeReturn = null ;
   private Node       headNode   = null ;
   private Node       tailNode   = null ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will construct an EdgeReturnDisplayRec
    *  from the edge passed in. This method will thrown an IllegalArgumentException
    *  if a non-EdgeReturn Edge is passed in
    *  
    *
    *  @param objectNodes This is the list of all available objectNodes in a flow. This
    *                     is needed to get the tail and head ObjectNodes.
    *  @param Edge The Edge object
    *  @param EdgeGroup The EdgeGroup that the Edge belongs in
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public EdgeReturnDisplayRec ( Edge edge, EdgeGroup edgeGroup ) {
      if ( edge.getReturnNode() != null ) {
         headNode = edgeGroup.getTailNode() ; //Yes, the tail node! This is the symptom the EdgeReturn is pointing to
         tailNode = edge.getReturnNode().getNode() ;
      } else
         throw new IllegalArgumentException ( "Edge passed in does not have EdgeReturn set" ) ;
   }




   public void addChild ( DisplayRec displayRec ) {}
   public void removeChild ( DisplayRec displayRec ) {}
   public void setSort ( int sort ) {}
   public boolean containsChildren() {
      return( false ) ;
   }
   public Vector getChildren() {
      return( null ) ;
   }
   public Object getData () {
      return( edgeReturn ) ;
   }




   /*------------------------------------------------------------*/
   /* getHeadObjectNode
    */
   /**
    *    This method will return the head object
    *  node for this edge return. The head ObjectNode
    *  will be the sub routine symptom
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public Node getHeadNode () {
      return( headNode ) ;
   }




   /*------------------------------------------------------------*/
   /* getTailObjectNode
    */
   /**
    *    This method will return the tail object node. This
    *  will be where the Subroutine symptom returns
    *  to
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public Node getTailNode () {
      return( tailNode ) ;
   }
} /* EdgeReturnDisplayRec */
