package com.ibm.nzna.projects.qit.avalon.base ;       
/*-----------------------------------------------------------*/
/*   LinkGroupPreviewRec                                     */
/*                                                           */
/*   Description:                                            */
/*      Source code for: LinkGroupPreviewRec                 */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.qit.app.* ;
/**
 * This record holds all of the information used to display a Preview of a Link. Nothing more 
 *
 *
 * @version 1.0, 4/24/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   LinkGroupPreviewRec                                     */
/*                                                           */
/*-----------------------------------------------------------*/
public class LinkGroupPreviewRec extends Object implements AppConst {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Preview Template                                        */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private static String previewTemplate= "<html><body bgcolor=\"#FFFFFF\">"+
                                          "<p><font size=\"5\" face=\"Arial, Helvetica, sans-serif\">TITLE</font></p>"+
                                          "<p><font color=\"#800080\" size=\"2\" face=\"Arial, Helvetica, sans-serif\">STR_CREATE_DATE</font><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">:CREATEDATE<br>"+
                                          "  <font color=\"#800080\">STR_INTERNAL_NUM</font>:INTERNAL_NUM<br>"+
                                          "  <font color=\"#800080\">STR_LAST_TOUCHED_ON</font>:LAST_TOUCHED_ON<br>"+
                                          "  <font color=\"#800080\">STR_LAST_TOUCHED_BY</font>:LAST_TOUCHED_BY</font><br>"+
                                          "</p>"+
                                          "</body>"+
                                          "</html>" ;


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Members                                                 */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private String  title       = null ;
   private String  createDate  = null ;
   private String  changedTime = null ;
   private String  dbUser      = null ;
   private String  linkInd     = "" ;




   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This is the only constructor currently for the
    *  LinkGroupPreviewRec.
    *  
    *
    *  @param LinkDisplayRec The LinkDisplayRec to copy information from
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public LinkGroupPreviewRec ( LinkGroupDisplayRec displayRec ) {
      title       = (String) displayRec.getColumnData ( 3 ) ;
      createDate  = (String) displayRec.getColumnData ( 7 ) ;
      changedTime = (String) displayRec.getColumnData ( 4 ) ;
      dbUser      = (String) displayRec.getColumnData ( 5 ) ;
      linkInd     = (String) displayRec.getColumnData ( 2 ) ;
   }

   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This is the only constructor currently for the
    *  LinkGroupPreviewRec.
    *  
    *
    *  @param LinkDisplayRec The LinkDisplayRec to copy information from
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public LinkGroupPreviewRec ( LinkGroupDraftDisplayRec displayRec ) {
      title       = (String) displayRec.getColumnData ( 3 ) ;
      createDate  = (String) displayRec.getColumnData ( 7 ) ;
      changedTime = (String) displayRec.getColumnData ( 4 ) ;
      dbUser      = (String) displayRec.getColumnData ( 5 ) ;
      linkInd     = (String) displayRec.getColumnData ( 2 ) ;
   }





   /*------------------------------------------------------------*/
   /* getPreviewHTMLSource
    */
   /**
    *    This method will return the source code for
    *  the HTML needed to display this record
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getPreviewHTMLSource () {
      String retStr = Text.replaceInStr ( previewTemplate, "TITLE", title ) ;

      retStr = Text.replaceInStr ( retStr, "STR_INTERNAL_NUM",    Str.getStr ( STR_INTERNAL_NUM ) ) ;
      retStr = Text.replaceInStr ( retStr, "STR_CREATE_DATE",     Str.getStr ( STR_CREATION_DATE ) ) ;
      retStr = Text.replaceInStr ( retStr, "STR_LAST_TOUCHED_ON", Str.getStr ( STR_LAST_TOUCHED_ON ) ) ;
      retStr = Text.replaceInStr ( retStr, "STR_LAST_TOUCHED_BY", Str.getStr ( STR_LAST_TOUCHED_BY ) ) ;
      retStr = Text.replaceInStr ( retStr, "CREATEDATE",         createDate ) ;
      retStr = Text.replaceInStr ( retStr, "LAST_TOUCHED_BY",     dbUser ) ;
      retStr = Text.replaceInStr ( retStr, "LAST_TOUCHED_ON",     changedTime ) ;
      retStr = Text.replaceInStr ( retStr, "INTERNAL_NUM",        linkInd ) ;

      return( retStr ) ;
   }
} /* LinkGroupPreviewRec */
