package com.ibm.nzna.projects.qit.avalon.base ;                          
/*-----------------------------------------------------------*/
/*   LinkSoftValidator                                       */
/*                                                           */
/*   Description:                                            */
/*      Source code for: LinkSoftValidator                   */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import com.ibm.nzna.projects.common.quest.oa.* ;
import com.ibm.nzna.projects.qit.app.* ;
/**
 * This class holds the methods needed to do a 'soft' validation of a question. 
 *
 *
 * @version 1.0, 5/17/2000 
 * @author  David Lentz
 */




/*-----------------------------------------------------------*/
/*                                                           */
/*   LinkSoftValidator                                       */
/*                                                           */
/*-----------------------------------------------------------*/
public class LinkSoftValidator extends SoftValidator {




   /*------------------------------------------------------------*/
   /* validateLink
    */
   /**
    *    This method will validate a question and
    *  will return the string that needs to be displayed
    *  to the user in a Browser control
    *
    *  @param link The link to validate
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public static String validateLink ( LinkDraft link ) {
      StringBuffer buffer = new StringBuffer ( "<html><head><font face=\"Helvetica\">" ) ;

      validateAuthority ( buffer,
                          null,
                          null ) ;


      if ( link instanceof ExternalLinkDraft )
         validateLink      ( buffer,
                             ((ExternalLinkDraft)link).isUrlValid() ) ;

      buffer.append ( "</font></head></html>" ) ;
      return( buffer.toString() ) ;
   }





   /*------------------------------------------------------------*/
   /* validateLink
    */
   /**
    *    This method will validate the validity of a link
    *  
    *
    *  @param buffer The string buffer to append information to
    *  @param answers A vector containing the answers
    *  @param docClassInd The document classification
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private static void validateLink ( StringBuffer buffer, boolean valid ) {
      if ( !valid ) {

         buffer.append ( "<table width=\"100\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" bgcolor=\"#990000\"><tr><td><b><font size=2 face = \"Helvetica\" color=\"#FFFFFF\">&nbsp;&nbsp;" ) ;
         buffer.append ( Str.getStr ( STR_ERROR ) ) ;
         buffer.append ( "</font></b></td></tr></table><font face=\"Helvetica, Arial\" size=2>" ) ;
         buffer.append ( Str.getStr ( STR_LINK_IS_NOT_VALID ) ) ;
         buffer.append ( "<br><br>" ) ;
      }

   }
} /* LinkSoftValidator */
