package com.ibm.nzna.projects.qit.avalon.base ;                          
/*-----------------------------------------------------------*/
/*   QuestionSoftValidator                                   */
/*                                                           */
/*   Description:                                            */
/*      Source code for: QuestionSoftValidator               */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import com.ibm.nzna.projects.common.quest.oa.* ;
import com.ibm.nzna.projects.qit.app.* ;
/**
 * This class holds the methods needed to do a 'soft' validation of a question. 
 *
 *
 * @version 1.0, 5/17/2000 
 * @author  David Lentz
 */




/*-----------------------------------------------------------*/
/*                                                           */
/*   QuestionSoftValidator                                   */
/*                                                           */
/*-----------------------------------------------------------*/
public class QuestionSoftValidator extends SoftValidator {




   /*------------------------------------------------------------*/
   /* validateQuestion
    */
   /**
    *    This method will validate a question and
    *  will return the string that needs to be displayed
    *  to the user in a Browser control
    *
    *  @param question The question to validate
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public static String validateQuestion ( Question question ) {
      StringBuffer buffer = new StringBuffer ( "<html><head><font face=\"Helvetica\">" ) ;

      validateAuthority ( buffer,
                          question.getBrand(),
                          question.getCountryList() ) ;


      validateTitles ( buffer, 
                       question.getTitles(), 
                       question.getDocClass().getInd() ) ;

      validateAddtlInfos ( buffer,
                           question.getAdditionalInfo(),
                           question.getDocClass().getInd() ) ;

      validateAnswers ( buffer,
                        question.getAnswers(),
                        question.getDocClass().getInd() ) ;

      buffer.append ( "</font></head></html>" ) ;
      return( buffer.toString() ) ;
   }





   /*------------------------------------------------------------*/
   /* validateAnswers
    */
   /**
    *    This method will validate the answers on
    *  a question.
    *  
    *
    *  @param buffer The string buffer to append information to
    *  @param answers A vector containing the answers
    *  @param docClassInd The document classification
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private static void validateAnswers ( StringBuffer buffer, Vector answers, int docClassInd ) {
      if ( ( answers == null ) || ( answers.size() == 0 ) ) {
         buffer.append ( "<table width=\"100\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" bgcolor=\"#990000\"><tr><td><b><font size=2 face = \"Helvetica\" color=\"#FFFFFF\">&nbsp;&nbsp;" ) ;
         buffer.append ( Str.getStr ( STR_ERROR ) ) ;
         buffer.append ( "</font></b></td></tr></table><font face=\"Helvetica, Arial\" size=2>" ) ;
         buffer.append ( Str.getStr ( STR_QUESTION_HAS_NO_ANSWERS ) ) ;
         buffer.append ( "<br><br>" ) ;
      }

   }
} /* QuestionSoftValidator */
