package com.ibm.nzna.projects.qit.avalon.editors ;            
/*-----------------------------------------------------------*/
/*   AddInfoEditPanel                                        */
/*                                                           */
/*   Description:                                            */
/*      Source code for: AddInfoEditPanel                    */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import javax.swing.* ;
import javax.swing.event.* ;
import java.awt.* ;
import java.awt.event.* ;
import java.util.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.app.util.* ;
import com.ibm.nzna.projects.qit.gui.* ;     
import com.ibm.nzna.projects.qit.dbgui.* ;     
import com.ibm.nzna.projects.qit.avalon.base.* ;
import com.ibm.nzna.projects.qit.avalon.gui.* ;
import com.ibm.nzna.shared.gui.* ;     
import com.ibm.nzna.shared.util.* ;     
import com.ibm.nzna.shared.pom.* ;     
import com.ibm.nzna.projects.common.quest.oa.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
/**
 * This panel allows a user to edit a vector of additional information. 
 *
 *
 * @version 1.0, 4/26/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   AddInfoEditPanel                                        */
/*                                                           */
/*-----------------------------------------------------------*/
public class AddInfoEditPanel extends EditPanel implements Runnable, ListSelectionListener, AppConst, AvalonConst, ActionListener {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private GUI Members                                     */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private Dimension          prefSize           = new Dimension ( 400, 570 ) ;
   private ExtWordProcButton  pb_ADDINFO         = null ;
   private JList              lb_ADDINFO         = null ;
   private DocClassPanel      docClassPanel      = null ;
   private Browser            br_ADDINFO         = null ;
   private JScrollPane        scr_ADDINFO        = null ;
   private JTitle             st_ADDINFO         = null ;
   private JTitle             st_ADDINFO_TEXT    = null ;
   private HotLinkLabel       pb_ADD_ADDINFO     = null ;
   private HotLinkLabel       pb_REMOVE_ADDINFO  = null ;
   private HotLinkLabel       pb_ADDINFO_UP      = null ;
   private HotLinkLabel       pb_ADDINFO_DOWN    = null ;
   private ButtonPanel        buttonPanel        = null ;
   private DefaultListModel   listModel          = null ;
   private ConditionList      conditionList      = null ;
   private ButtonPanel        titleButtonPanel   = null ;
   private CountrySelectPanel countrySelectPanel = null ;
   private JCheckBox          ck_REDIRECT        = null ;


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private Vector    addInfoVec        = null ;
   private AddtlInfo currentAddInfo  = null ;




   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will create a title panel
    *  initialized to the vector passed in
    *  
    *
    *  @param addInfoVec The vector of Title objects
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public AddInfoEditPanel ( AppDefaultWin parent, Vector addInfoVec ) {

      this.addInfoVec = addInfoVec ;                                      

      initialize ( ) ;
   }





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This constructor will create a blank edit
    *  panel
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public AddInfoEditPanel ( ) {
      initialize ( ) ;
   }


   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will initialize our panel. It will
    *  add all of the GUI and refresh the data
    *  
    *
    *  @param parent Our parent window
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void initialize ( ) {                

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create the GUI Components                               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      pb_ADDINFO         = new ExtWordProcButton ( ExtWordProcButton.HOTLINKLABEL ) ;
      br_ADDINFO         = new Browser() ;
      docClassPanel      = new DocClassPanel () ;
      st_ADDINFO         = new JTitle ( Str.getStr ( STR_ADDITIONAL_INFORMATION_ITEMS ) ) ;
      st_ADDINFO_TEXT    = new JTitle ( Str.getStr ( STR_ADDINFO_TEXT ) ) ;
      pb_ADD_ADDINFO     = new HotLinkLabel ( Str.getStr ( STR_ADD_ADDINFO ) ) ;
      pb_REMOVE_ADDINFO  = new HotLinkLabel ( Str.getStr ( STR_REMOVE_ADDINFO ) ) ;
      buttonPanel        = new ButtonPanel () ;
      lb_ADDINFO         = new JList() ;
      pb_ADDINFO_UP      = new HotLinkLabel ( Str.getStr ( STR_UP ) ) ;
      pb_ADDINFO_DOWN    = new HotLinkLabel ( Str.getStr ( STR_DOWN ) ) ;
      scr_ADDINFO        = new JScrollPane ( lb_ADDINFO ) ;
      listModel          = new DefaultListModel() ;
      conditionList      = new ConditionList () ;
      titleButtonPanel   = new ButtonPanel () ;
      countrySelectPanel = new CountrySelectPanel () ;
      ck_REDIRECT        = new JCheckBox ( Str.getStr ( STR_REDIRECT_FIRST_LINK ) ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      pb_ADDINFO.setAutoLaunch ( false ) ;
      setBackground ( Color.white ) ;
      st_ADDINFO_TEXT.setFont    ( FontSystem.smallTitleFont ) ;
      st_ADDINFO.setFont         ( FontSystem.smallTitleFont ) ;
      pb_ADDINFO.setOpaque ( false ) ;
      lb_ADDINFO.setSelectionBackground ( new Color ( 209, 210, 253 ) ) ;
      lb_ADDINFO.setSelectionForeground ( Color.black ) ;
      GUISystem.setPreferredButton ( pb_ADD_ADDINFO ) ;
      GUISystem.setPreferredButton ( pb_REMOVE_ADDINFO ) ;
      scr_ADDINFO.setBorder      ( GUISystem.blackBorder ) ;
      buttonPanel.setBorder     ( GUISystem.grayBorder ) ;
      buttonPanel.setBackground ( new Color ( 230, 230, 230 ) ) ;
      buttonPanel.setArrowImage ( ImageSystem.getImageIcon ( this, ImageSystem.BUTTONPANEL_LEFT ),
                                  ImageSystem.getImageIcon ( this, ImageSystem.BUTTONPANEL_RIGHT ) ) ;             
      titleButtonPanel.setBorder     ( GUISystem.grayBorder ) ;
      titleButtonPanel.setBackground ( new Color ( 230, 230, 230 ) ) ;
      titleButtonPanel.setArrowImage ( ImageSystem.getImageIcon ( this, ImageSystem.BUTTONPANEL_LEFT ),
                                       ImageSystem.getImageIcon ( this, ImageSystem.BUTTONPANEL_RIGHT ) ) ;             
      br_ADDINFO.showZoom ( false ) ;
      lb_ADDINFO.setModel ( listModel ) ;
      pb_ADDINFO_UP.setOpaque ( false ) ;
      pb_ADDINFO_DOWN.setOpaque ( false ) ;
      ck_REDIRECT.setOpaque ( false ) ;
      ck_REDIRECT.setVisible ( false ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add action listeners                                    */
      /*                                                           */
      /*-----------------------------------------------------------*/
      pb_ADD_ADDINFO.addActionListener     ( this ) ;
      pb_REMOVE_ADDINFO.addActionListener  ( this ) ;
      lb_ADDINFO.addListSelectionListener  ( this ) ;
      pb_ADDINFO_UP.addActionListener      ( this ) ;
      pb_ADDINFO_DOWN.addActionListener    ( this ) ;
      pb_ADDINFO.addActionListener         ( this ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add the GUI                                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( null ) ;
      add ( st_ADDINFO ) ;
      add ( scr_ADDINFO ) ;
      titleButtonPanel.add ( pb_ADDINFO_UP ) ;
      titleButtonPanel.add ( new ToolBarSeparator ( new Dimension ( 1, GUISystem.getRowHeight() ) ) ) ;
      titleButtonPanel.add ( pb_ADDINFO_DOWN ) ;
      add ( titleButtonPanel ) ;
      add ( st_ADDINFO_TEXT ) ;
      add ( br_ADDINFO ) ;
      add ( ck_REDIRECT ) ;
      add ( docClassPanel ) ;
      add ( pb_ADDINFO ) ;
      add ( buttonPanel ) ;
      add ( conditionList ) ;
      add ( countrySelectPanel ) ;

      buttonPanel.add ( pb_ADD_ADDINFO ) ;
      buttonPanel.add ( new ToolBarSeparator ( new Dimension ( 1, GUISystem.getRowHeight() ) ) ) ;
      buttonPanel.add ( pb_REMOVE_ADDINFO ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Refresh the data                                        */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( addInfoVec != null )
         refreshData ( ) ;

   } /* initialize  */





   /*------------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will lay out and position all of
    *  our GUI
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size      = getSize() ;
      int       x         = 15 ;
      int       rowHeight = GUISystem.getRowHeight() ;
      int       y         = 5 ;
      int       halfWidth = size.width/2 ;

      buttonPanel.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight+5 ;

      st_ADDINFO.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight ;

      scr_ADDINFO.setBounds ( x, y, size.width-(x*2), rowHeight*5 ) ;
      y+=(rowHeight*5)+5 ;

      titleButtonPanel.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight+10 ;

      if ( ck_REDIRECT.isVisible() ) {
         ck_REDIRECT.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
         y+=rowHeight+10 ;
      }

      docClassPanel.setBounds ( x, y, 250, rowHeight*2 ) ;
      y+=(rowHeight*2)+5 ;

      conditionList.setBounds ( x, y, halfWidth-x-5, rowHeight*7 ) ;
      countrySelectPanel.setBounds ( halfWidth, y, halfWidth-x-5, rowHeight*7 ) ;
      y+=(rowHeight*7)+2 ;

      st_ADDINFO_TEXT.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight ;

      pb_ADDINFO.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight ;

      br_ADDINFO.setBounds ( x, y, size.width-(x*2), size.height-y-15 ) ;

   }





   /*------------------------------------------------------------*/
   /* refreshData
    */
   /**
    *    This method will refresh all of the data on our
    *  panel
    *  
    *
    *  @param title The Title to refresh with
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void refreshData ( ) {

      if ( currentAddInfo != null ) {

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Add the conditions                                      */
         /*                                                           */
         /*-----------------------------------------------------------*/
         conditionList.setConditions ( currentAddInfo.getConditions() ) ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Set our additional information data                     */
         /*                                                           */
         /*-----------------------------------------------------------*/
         pb_ADDINFO.setBody ( currentAddInfo.getAddtlInfo() );
         br_ADDINFO.setPageContent ( AvalonUtil.prepareAddInfoForView ( currentAddInfo.getAddtlInfo() ) ) ;        

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Set the countries and class                             */
         /*                                                           */
         /*-----------------------------------------------------------*/
         countrySelectPanel.setCountryList ( currentAddInfo.getCountryList() ) ;
         docClassPanel.setDocClass ( currentAddInfo.getDocClass() ) ;  

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Redirection                                             */
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( ck_REDIRECT.isVisible() )
            ck_REDIRECT.setSelected ( currentAddInfo.getRedirectFlag() ) ;



      } else {
         br_ADDINFO.setPageContent ( "<html><body>...</body></html>" ) ;
         conditionList.clear() ;
      }


   }


   /*------------------------------------------------------------*/
   /* addAddtlInfo
    */
   /**
    *    This method will pop up the external word processor.
    *  Once the user re-imports the body the process will be complete.
    *
    *  @param None
    *  @param None
    *
    *//*---------------------------------------------------------*/
   private void addAddtlInfo (  ) {
      AddtlInfo addtlInfo = new AddtlInfo () ;

      try {
         currentAddInfo = null ;
         addtlInfo.setLanguage ( (TypeLanguageRec) TypeList.getInstance().objectFromInd ( PropertySystem.getInt ( PropertySystem.PROPERTY_LANGUAGE ),
                                                                                          TypeList.TYPE_LANGUAGE ) ) ;
         addtlInfo.setCountryList ( UserSystem.getUserCountries ( UserSystem.getUserId() ) ) ;
         addtlInfo.setDocClass ( (TypeDocClassRec) TypeList.getInstance().objectFromInd ( TypeList.DOCCLASS_IBM_CONFIDENTIAL, TypeList.TYPE_DOCCLASS ) ) ;

         addtlInfo.setAddtlInfo ( "<html><body>Erase Me</body></html>" ) ;
         addInfoVec.addElement ( addtlInfo ) ;
         listModel.add ( listModel.getSize(), addtlInfo ) ;
         lb_ADDINFO.setSelectedValue ( addtlInfo, true ) ;
         currentAddInfo = addtlInfo ;

         pb_ADDINFO.launch() ;
         pb_ADD_ADDINFO.setEnabled    ( !pb_ADDINFO.getLaunched() ) ;
         pb_REMOVE_ADDINFO.setEnabled ( !pb_ADDINFO.getLaunched() ) ;
         pb_ADDINFO.setEnabled        ( !pb_ADDINFO.getLaunched() ) ;
         lb_ADDINFO.setEnabled        ( !pb_ADDINFO.getLaunched() ) ;

      } catch ( Exception e ) {
         LogSystem.log ( 1, e ) ;
      }

   } /* addAddtlInfo  */





   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will be called when an action
    *  is performed and we need to know about it
    *  
    *
    *  @param e The ActionEvent
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {   

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_ADD_ADDINFO                                          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( e.getSource() == pb_ADD_ADDINFO ) {
         addAddtlInfo() ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_REMOVE_ADDINFO                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( e.getSource() == pb_REMOVE_ADDINFO ) {
         //AddtlInfo curAddtlInfo = (AddtlInfo) lb_ADDINFO.getSelectedValue() ;

         if ( currentAddInfo != null ) {
            currentAddInfo.updateRecStatus ( QITRec.REC_DELETE ) ;
            currentAddInfo=null ;
            refreshAddtlInfos() ;
            refreshData() ;
         }
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_ADDINFO_UP                                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_ADDINFO_UP ) {
         if ( currentAddInfo != null )
            moveAddInfoUp ( ) ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_ADDINFO_DOWN                                         */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_ADDINFO_DOWN ) {
         if ( currentAddInfo != null )
            moveAddInfoDown ( ) ;
      }


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_ADDINFO                                              */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_ADDINFO ) {
         int id = e.getID() ;                                           

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   ID of 0 means that they want to launch the word proc    */
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( id == 0 ) {
            if ( currentAddInfo != null ) {

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   If we haven't launched yet, launch now                  */
               /*                                                           */
               /*-----------------------------------------------------------*/
               pb_ADDINFO.launch() ;

            } /* if currentAddInfo  */
            else
               GUISystem.printBox ( this, STR_INFO, STR_MUST_SELECT_ITEM ) ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   AN ID of 1 means they want to reimport the body         */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( id == 1 ) {
            String body = pb_ADDINFO.getBody() ;

            if ( currentAddInfo != null ) {
               AddtlInfoImporter.importAddtlInfo ( body, currentAddInfo ) ;
               setCurrentAddtlInfo ( currentAddInfo ) ;
            }
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   If the ext word proc was launched, disable our stuff    */
         /*                                                           */
         /*-----------------------------------------------------------*/
         pb_ADD_ADDINFO.setEnabled    ( !pb_ADDINFO.getLaunched() ) ;
         pb_REMOVE_ADDINFO.setEnabled ( !pb_ADDINFO.getLaunched() ) ;
         pb_ADDINFO.setEnabled        ( !pb_ADDINFO.getLaunched() ) ;
         lb_ADDINFO.setEnabled        ( !pb_ADDINFO.getLaunched() ) ;
      } /* else PB_ADDINFO  */

   }/* actionPerformed  */




   /*------------------------------------------------------------*/
   /* refreshAddtlInfos
    */
   /**
    *    This method will refresh all of our addInfoVec
    *  in the title drop down
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void refreshAddtlInfos () {
      Vector validAddtlInfos = QuestUtil.getValidData ( addInfoVec ) ;                                     

      listModel.removeAllElements() ;
      if ( validAddtlInfos != null ) {
         int i    = 0 ;
         int size = validAddtlInfos.size() ;

         while ( i < size ) {
            listModel.add ( listModel.getSize(), validAddtlInfos.elementAt(i) ) ;
            i++ ;
         }
      }
   }



   /*------------------------------------------------------------*/
   /* setAddtlInfos
    */
   /**
    *    This method will set the vector of addInfoVec that
    *  we are using
    *  
    *
    *  @param addInfoVec A vector of addInfoVec
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setAddtlInfos ( Vector addInfoVec ) {
      this.addInfoVec = addInfoVec ;
      refreshAddtlInfos() ;
   }




   /*------------------------------------------------------------*/
   /* valueChanged
    */
   /**
    *    this method will be called when the user has
    *  selected another title
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void valueChanged ( ListSelectionEvent e ) {
      if ( !e.getValueIsAdjusting() ) {
         AddtlInfo addtlInfo = (AddtlInfo) lb_ADDINFO.getSelectedValue() ;

         saveData() ;

         if ( addtlInfo != null )
            setCurrentAddtlInfo ( addtlInfo ) ;
      }
   }



   /*------------------------------------------------------------*/
   /* run
    */
   /**
    *    This thread currently only refreshes our data
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void run () {
      refreshData ( ) ;
   }





   /*------------------------------------------------------------*/
   /* saveData
    */
   /**
    *    This method will save all of the information
    *  on our display
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean saveData () {
      if ( currentAddInfo != null ) {
         conditionList.saveConditions() ;
         currentAddInfo.setDocClass ( docClassPanel.getDocClass() ) ;
         currentAddInfo.setCountryList ( countrySelectPanel.getCountryList() ) ;
         if ( ck_REDIRECT.isVisible() )
            currentAddInfo.setRedirectFlag ( ck_REDIRECT.isSelected() ) ;
      }
      return( true ) ;
   }




   /*------------------------------------------------------------*/
   /* getAddInfoVec
    */
   /**
    *    This method will return the vector of all of our
    *  AddtlInfo recs
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Vector
    *//*---------------------------------------------------------*/
   protected Vector getAddInfoVec () {
      return( addInfoVec ) ;
   }


   /*------------------------------------------------------------*/
   /* setCurrentAddtlInfo
    */
   /**
    *    This method will set the current additional
    *  information
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setCurrentAddtlInfo ( AddtlInfo addtlInfo ) {
      if ( addtlInfo != null ) {
         this.currentAddInfo = addtlInfo ;
         refreshData() ;
      }
   }





   /*------------------------------------------------------------*/
   /* getPreferredSize()
    */
   /**
    *    This method will return the preferred 
    *  size of this panel
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Dimension
    *//*---------------------------------------------------------*/
   public Dimension getPreferredSize() {
      return( prefSize ) ;
   }




   /*------------------------------------------------------------*/
   /* getMinimumSize
    */
   /**
    *    This method will return our minimum size. Actually
    *  this method returns whatever getPreferredSize
    *  returns
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Dimension
    *//*---------------------------------------------------------*/
   public Dimension getMinimumSize () {
      return( getPreferredSize() ) ;
   }



   /*------------------------------------------------------------*/
   /* moveAddInfoUp
    */
   /**
    *    This method will move a title in the
    *  title list up a level in the sort order
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void moveAddInfoUp ( ) {
      moveAddInfoInList ( false ) ;
   }




   /*------------------------------------------------------------*/
   /* moveAddInfoDown
    */
   /**
    *    This method will move a title down
    *  in the list
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void moveAddInfoDown ( ) {
      moveAddInfoInList ( true ) ;
   }




   /*------------------------------------------------------------*/
   /* moveAddInfoFromList
    */
   /**
    *    This method will simply move the title
    *  in the container. This will not have an effect
    *  of the title object yet
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return int The position it was at before it was moved
    *//*---------------------------------------------------------*/
   public void moveAddInfoInList ( boolean down ) {
      int    rc     = addInfoVec.indexOf ( currentAddInfo ) ;                         

      if ( down )
         rc++ ;
      else
         rc-- ;

      if ( ( rc >= 0 ) && ( rc < addInfoVec.size() ) ) {
         int    i            = 0 ;
         int    length       = 0 ;
         Vector validDataVec = null ;

         addInfoVec.removeElement ( currentAddInfo ) ;
         addInfoVec.insertElementAt ( currentAddInfo, rc ) ;

         listModel.removeAllElements() ;

         validDataVec = QuestUtil.getValidData ( addInfoVec ) ;
         length = validDataVec.size() ;
         while ( i < length ) {
            listModel.add ( listModel.getSize(), validDataVec.elementAt(i) ) ;
            i++ ;
         } /* while */
         lb_ADDINFO.setSelectedValue ( currentAddInfo, true ) ;
      }

   }


   /*------------------------------------------------------------*/
   /* getCountrySelectPanel
    */
   /**
    *    This method will return an instance of this
    *  panel's CountrySelectPanel
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   protected CountrySelectPanel getCountrySelectPanel () {
      return( countrySelectPanel ) ;
   }


   /*------------------------------------------------------------*/
   /* removeCountryFromPanel
    */
   /**
    *    This method will remove the TypeCountryCodeRec
    *  passed from all answers in this panel
    *  
    *
    *  @param countryRec The TypeCountryCodeRec to remove
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   protected void removeCountryFromPanel ( TypeCountryCodeRec countryRec ) {


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Remove the country from all of our addInfoVec           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( ( addInfoVec != null ) && ( addInfoVec.size() > 0 ) ) {
         int    i              = 0 ;
         int    size           = addInfoVec.size() ;
         Vector addInfoCountries = null ;

         while ( i < size ) {
            addInfoCountries = ((AddtlInfo)addInfoVec.elementAt(i)).getCountryList() ;
            addInfoCountries.removeElement ( countryRec ) ;
            ((AddtlInfo)addInfoVec.elementAt(i)).setCountryList ( addInfoCountries ) ;
            i++ ;
         } /* while  */
      } /* if  */


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Now, refresh our display                                */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( currentAddInfo != null )
         countrySelectPanel.setCountryList ( currentAddInfo.getCountryList() ) ;
   }





   /*------------------------------------------------------------*/
   /* showRedirect
    */
   /**
    *    This method will show or hide the redirect
    *  flag. Questions cannot have redirects, but Actions can.
    *  
    *
    *  @param show TRUE = allow the user to specify this
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   protected void showRedirect ( boolean show ) {
      ck_REDIRECT.setVisible ( show ) ;
   }
} /* AddInfoEditPanel */
