package com.ibm.nzna.projects.qit.avalon.editors ;            
/*-----------------------------------------------------------*/
/*   AnswerEditPanel                                         */
/*                                                           */
/*   Description:                                            */
/*      Source code for: AnswerEditPanel                     */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import javax.swing.* ;
import javax.swing.event.* ;
import java.awt.* ;
import java.awt.event.* ;
import java.util.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.app.util.* ;
import com.ibm.nzna.projects.qit.gui.* ;     
import com.ibm.nzna.projects.qit.dbgui.* ;     
import com.ibm.nzna.projects.qit.avalon.base.* ;
import com.ibm.nzna.projects.qit.avalon.gui.* ;
import com.ibm.nzna.shared.gui.* ;     
import com.ibm.nzna.shared.util.* ;     
import com.ibm.nzna.shared.pom.* ;     
import com.ibm.nzna.shared.spell.* ;     
import com.ibm.nzna.projects.common.quest.oa.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
/**
 * This panel allows a user to edit a vector of answers. 
 *
 *
 * @version 1.0, 4/26/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   AnswerEditPanel                                         */
/*                                                           */
/*-----------------------------------------------------------*/
public class AnswerEditPanel extends EditPanel implements SpellPanelListener, Runnable, ConclusionDlgListener, ListSelectionListener, AppConst, AvalonConst, ActionListener, TitleEditDlgListener {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private GUI Members                                     */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private JList               lb_ANSWERS              = null ;
   private JScrollPane         scr_ANSWERS             = null ;
   private JTitle              st_ANSWERS              = null ;
   private JTitle              st_DOC_CLASS            = null ;
   private JComboBox           cb_DOC_CLASS            = null ;
   private HotLinkLabel        pb_SET_TITLE            = null ;
   private HotLinkLabel        pb_ADD_ANSWER           = null ;
   private HotLinkLabel        pb_REMOVE_ANSWER        = null ;
   private ButtonPanel         buttonPanel             = null ;
   private JPanel              conclPanel              = null ;
   private JTitle              st_CONCLUSIONS          = null ;
   private JList               lb_CONCLUSIONS          = null ;
   private ConditionList       conclusionConditionList = null ;
   private ConditionList       conditionList           = null ;
   private HotLinkLabel        pb_ADD_CONCL            = null ;
   private HotLinkLabel        pb_REMOVE_CONCL         = null ;
   private JScrollPane         scr_CONCLUSIONS         = null ;
   private ButtonPanel         conclButtonPanel        = null ;
   private CountrySelectPanel  countrySelectPanel      = null ;
   private DocClassPanel       conclDocClassPanel      = null ;
   private DefaultListModel    answerListModel         = null ;
   private DefaultListModel    conclusionListModel     = null ;
   private SpellPanel          spellPanel              = null ;
   private JTabbedPane         tabbedPane              = null ;



   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private Dimension          prefSize         = new Dimension ( 100, 640 ) ;
   private QuestionUsagePanel usagePanel       = null ;
   private Vector             answers          = null ;
   private Answer             currentAnswer    = null ;
   private AnswerConcl        currentConcl     = null ;
   private boolean            conclCond        = false ;
   private Vector             conclusions      = null ;     //  Vector holding the AnswerConclDisplayRecs
   private TitleEditDlg       titleEditDlg     = null ;
   private ConclusionDlg      conclDlg         = null ;
   private QuestionDraft      question         = null ;
   private AppDefaultWin      parentWin        = null ;
   private Answer             spellCheckAnswer = null ;
   private int                spellIndex       = 0 ;
   private int                tabIndex         = 0 ;
   private int                brandInd         = 0 ;




   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will create a title panel
    *  initialized to the vector passed in
    *  
    *
    *  @param titles The vector of Title objects
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public AnswerEditPanel ( int tabIndex, QuestionDraft question, Vector answers, QuestionUsagePanel usagePanel, int brandInd ) {
      setBrandInd ( brandInd ) ;
      this.tabIndex   = tabIndex ;
      this.usagePanel = usagePanel ;
      initialize ( ) ;
      setAnswers ( answers ) ;
      setOAObject ( question ) ;
   }





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This constructor will create a blank edit
    *  window
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public AnswerEditPanel ( int tabIndex, QuestionUsagePanel usagePanel, int brandInd  ){
      setBrandInd ( brandInd ) ;
      this.tabIndex   = tabIndex ;
      this.usagePanel = usagePanel ;
      initialize ( ) ;
   }




   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will initialize our panel. It will
    *  add all of the GUI and refresh the data
    *  
    *
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void initialize ( ) {                

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create the GUI Components                               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      st_ANSWERS                = new JTitle ( Str.getStr ( STR_ANSWERS ) ) ;
      st_DOC_CLASS              = new JTitle ( Str.getStr ( STR_DOC_CLASS ) ) ;
      cb_DOC_CLASS              = new JComboBox ( TypeList.getInstance().getTypeList ( TypeList.TYPE_DOCCLASS ) ) ;
      pb_SET_TITLE              = new HotLinkLabel ( Str.getStr ( STR_SET_TITLE ) ) ;
      pb_ADD_ANSWER             = new HotLinkLabel ( Str.getStr ( STR_ADD_ANSWER ) ) ;
      pb_REMOVE_ANSWER          = new HotLinkLabel ( Str.getStr ( STR_REMOVE_ANSWER ) ) ;
      buttonPanel               = new ButtonPanel () ;
      lb_ANSWERS                = new JList() ;
      scr_ANSWERS               = new JScrollPane ( lb_ANSWERS ) ;
      conclPanel                = new JPanel () ;
      st_CONCLUSIONS            = new JTitle ( Str.getStr ( STR_CONCLUSIONS ) ) ;
      lb_CONCLUSIONS            = new JList () ;
      scr_CONCLUSIONS           = new JScrollPane ( lb_CONCLUSIONS ) ;
      pb_ADD_CONCL              = new HotLinkLabel ( Str.getStr ( STR_ADD ) ) ;
      pb_REMOVE_CONCL           = new HotLinkLabel ( Str.getStr ( STR_REMOVE ) ) ;
      conclButtonPanel          = new ButtonPanel () ;
      conditionList             = new ConditionList() ;
      conclusionConditionList   = new ConditionList () ;
      countrySelectPanel        = new CountrySelectPanel () ;
      conclDocClassPanel        = new DocClassPanel () ;
      answerListModel           = new DefaultListModel () ;
      conclusionListModel       = new DefaultListModel () ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setBackground ( Color.white ) ;
      conclPanel.setBorder ( GUISystem.blackBorder ) ;
      conclPanel.setBackground ( Color.white ) ;
      st_CONCLUSIONS.setOpaque ( false ) ;
      scr_CONCLUSIONS.setBorder ( GUISystem.blackBorder ) ;
      GUISystem.setPreferredButton ( pb_ADD_CONCL ) ;
      GUISystem.setPreferredButton ( pb_REMOVE_CONCL ) ;
      lb_CONCLUSIONS.setSelectionBackground ( new Color ( 209, 210, 253 ) ) ;
      lb_ANSWERS.setSelectionBackground ( new Color ( 209, 210, 253 ) ) ;
      lb_ANSWERS.setSelectionForeground ( Color.black ) ;


      st_ANSWERS.setFont     ( FontSystem.smallTitleFont ) ;
      st_DOC_CLASS.setFont   ( FontSystem.smallTitleFont ) ;
      st_CONCLUSIONS.setFont   ( FontSystem.smallTitleFont ) ;
      GUISystem.setPreferredButton ( pb_ADD_ANSWER ) ;
      GUISystem.setPreferredButton ( pb_REMOVE_ANSWER ) ;
      scr_ANSWERS.setBorder ( GUISystem.blackBorder ) ;
      buttonPanel.setBorder     ( GUISystem.grayBorder ) ;
      buttonPanel.setBackground ( new Color ( 230, 230, 230 ) ) ;
      buttonPanel.setArrowImage ( ImageSystem.getImageIcon ( this, ImageSystem.BUTTONPANEL_LEFT ),
                                  ImageSystem.getImageIcon ( this, ImageSystem.BUTTONPANEL_RIGHT ) ) ;             
      conclButtonPanel.setBorder     ( GUISystem.grayBorder ) ;
      conclButtonPanel.setBackground ( new Color ( 230, 230, 230 ) ) ;
      conclButtonPanel.setArrowImage ( ImageSystem.getImageIcon ( this, ImageSystem.BUTTONPANEL_LEFT ),
                                       ImageSystem.getImageIcon ( this, ImageSystem.BUTTONPANEL_RIGHT ) ) ;             
      lb_ANSWERS.setModel ( answerListModel ) ;
      lb_CONCLUSIONS.setModel ( conclusionListModel ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add action listeners                                    */
      /*                                                           */
      /*-----------------------------------------------------------*/
      pb_SET_TITLE.addActionListener          ( this ) ;
      pb_ADD_ANSWER.addActionListener         ( this ) ;
      pb_REMOVE_ANSWER.addActionListener      ( this ) ;
      pb_ADD_CONCL.addActionListener          ( this ) ;
      pb_REMOVE_CONCL.addActionListener       ( this ) ;
      lb_ANSWERS.addListSelectionListener     ( this ) ;
      lb_CONCLUSIONS.addListSelectionListener ( this ) ;
      cb_DOC_CLASS.addActionListener          ( this ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add the GUI                                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( null ) ;
      add ( st_ANSWERS ) ;
      add ( scr_ANSWERS ) ;
      add ( st_DOC_CLASS ) ;
      add ( cb_DOC_CLASS ) ;
      add ( conditionList ) ;
      add ( countrySelectPanel ) ;
      add ( buttonPanel ) ;
      add ( conclPanel ) ;

      conclPanel.setLayout ( null ) ;
      conclPanel.add ( st_CONCLUSIONS ) ;
      conclPanel.add ( scr_CONCLUSIONS ) ;
      conclPanel.add ( conclDocClassPanel ) ;
      conclPanel.add ( conclButtonPanel ) ;
      conclPanel.add ( conclusionConditionList ) ;

      buttonPanel.add ( pb_SET_TITLE ) ;
      buttonPanel.add ( new ToolBarSeparator ( new Dimension ( 1, GUISystem.getRowHeight() ) ) ) ;
      buttonPanel.add ( pb_ADD_ANSWER ) ;
      buttonPanel.add ( new ToolBarSeparator ( new Dimension ( 1, GUISystem.getRowHeight() ) ) ) ;
      buttonPanel.add ( pb_REMOVE_ANSWER ) ;
      buttonPanel.add ( new ToolBarSeparator ( new Dimension ( 1, GUISystem.getRowHeight() ) ) ) ;
      conclButtonPanel.add ( pb_ADD_CONCL ) ;
      conclButtonPanel.add ( new ToolBarSeparator ( new Dimension ( 1, GUISystem.getRowHeight() ) ) ) ;
      conclButtonPanel.add ( pb_REMOVE_CONCL ) ;

      parentWin = GUISystem.getParentDefWin ( this ) ;

   } /* initialize  */



   /*------------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will lay out and position all of
    *  our GUI
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size      = getSize() ;
      int       x         = 15 ;
      int       rowHeight = GUISystem.getRowHeight() ;
      int       y         = 5 ;
      int       halfWidth = size.width/2 ;

      buttonPanel.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight+5 ;

      st_ANSWERS.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight ;

      scr_ANSWERS.setBounds ( x, y, size.width-(x*2), rowHeight*5 ) ;
      y+=(rowHeight*5)+2  ;

      st_DOC_CLASS.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight ;

      cb_DOC_CLASS.setBounds ( x, y, 250, rowHeight ) ;
      y+=rowHeight ;

      conditionList.setBounds ( x, y, halfWidth-x-5, rowHeight*7 ) ;
      countrySelectPanel.setBounds ( halfWidth, y, halfWidth-5, rowHeight*7 ) ;
      y+=rowHeight*7+5 ;

      conclPanel.setBounds ( x, y, size.width-(x*2), (rowHeight*9)+30 ) ;
      y+=(rowHeight*7)+35 ;

      x=5 ;
      y=5 ;
      halfWidth = conclPanel.getSize().width/2 ;
      st_CONCLUSIONS.setBounds ( x, y, halfWidth, rowHeight ) ;
      conclusionConditionList.setBounds ( x+halfWidth, y, halfWidth-10, (rowHeight*8)+5) ;
      y+=rowHeight ;

      scr_CONCLUSIONS.setBounds ( x, y, halfWidth-5, rowHeight*5 ) ;
      y+=(rowHeight*5)+2 ;

      conclButtonPanel.setBounds ( x, y, halfWidth-5, rowHeight ) ;
      y+=rowHeight+2 ;

      conclDocClassPanel.setBounds ( x, y, halfWidth-5, rowHeight*2 ) ;
      y+=rowHeight*2 ;


   }


   public Dimension getPreferredSize () {
      return( prefSize ) ;
   }

   public Dimension getMinimumSize() {
      return( prefSize ) ;
   }




   /*------------------------------------------------------------*/
   /* refreshData
    */
   /**
    *    This method will refresh the data on
    *  our screen to the answer passed
    *  
    *
    *  @param answer The answer to refresh data with
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void refreshData ( Answer answer ) {                                 


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Populate the data                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( answer != null ) {
         Vector titles = answer.getTitles() ;                                        

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Refresh the Conditions, Conclusions and Doc Class       */
         /*                                                           */
         /*-----------------------------------------------------------*/
         conditionList.setConditions ( answer.getConditions() ) ;
         countrySelectPanel.setCountryList ( answer.getCountryList( ) ) ;
         cb_DOC_CLASS.setSelectedItem ( answer.getDocClass() ) ;
         conclusionListModel.removeAllElements() ;                                

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   If we have conclusions, populate them now               */
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( conclusions != null ) {
            int    i         = 0 ;
            int    size      = conclusions.size() ;

            /* Loop through adding each conclusion if it is valid */
            while ( i < size ) {
               if ( ((AnswerConcl)((AnswerConclDisplayRec)conclusions.elementAt(i)).getData()).valid() )
                  conclusionListModel.addElement ( conclusions.elementAt(i) ) ;
               i++ ;
            }

         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Ok, now set the help text for the list                  */
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( titles != null ) {
            int i           = 0 ;
            int size        = titles.size() ;
            String helpText = "<html><body><font size =2><u><b>Titles:</b></u><br>" ;


            while ( i < size ) {
               if ( i == size-1 )
                  helpText+="<i>" ;
               helpText+="&nbsp;&nbsp;"+titles.elementAt(i).toString() ;
               if ( i == size-1 )
                  helpText+="</i>" ;
               else
                  helpText+="<br>" ;
               i++ ;
            }

            lb_ANSWERS.setToolTipText ( helpText ) ;
         }

      } else {

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Clear all of the fields                                 */
         /*                                                           */
         /*-----------------------------------------------------------*/
         conclusionListModel.removeAllElements() ;
         refreshConclusion( null ) ;  // This will remove all Conditions on the Conclusion
         countrySelectPanel.setCountryList ( null ); // This will remove all countries
         conditionList.setConditions ( null ) ; //This will remove all conditions on the answer
         currentConcl = null ; 
      }

   }






   /*------------------------------------------------------------*/
   /* run
    */
   /**
    *    This method will simply refresh our data
    *  with what is currently in the 'currentAnswer'
    *  field
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void run () {
      refreshData ( currentAnswer ) ;
   }





   /*------------------------------------------------------------*/
   /* valueChanged
    */
   /**
    *    This method will be called when a value
    *  is selected in one of the lists
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void valueChanged ( ListSelectionEvent e  ) {

      if ( !e.getValueIsAdjusting() ) {


         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   lb_ANSWERS                                              */
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( e.getSource() == lb_ANSWERS ) {
            setCurrentAnswer ( (Answer)lb_ANSWERS.getSelectedValue() ) ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   lb_CONCLUSIONS                                          */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( e.getSource() == lb_CONCLUSIONS ) {
            if ( lb_CONCLUSIONS.getSelectedValue() != null )
               setCurrentConclusion ( (AnswerConcl) ((AnswerConclDisplayRec)lb_CONCLUSIONS.getSelectedValue()).getData() ) ;
         }
      }
   }



   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will be called when an action
    *  event is fired
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {   

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_SET_TITLE                                            */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( e.getSource() == pb_SET_TITLE ) {
         if ( titleEditDlg == null ) {
            Answer answer = (Answer) lb_ANSWERS.getSelectedValue() ;

            if ( answer != null ) {
               Vector titles = answer.getTitles() ;

               titleEditDlg = new TitleEditDlg ( GUISystem.getParentDefWin ( this ), titles, brandInd ) ;
               titleEditDlg.setTitleEditDlgListener ( this ) ;
               titleEditDlg.setJoinCountrySelectPanel ( countrySelectPanel.getJoinCountrySelectPanel() ) ;
            } else
               GUISystem.printBox ( GUISystem.getParentDefWin ( this ), STR_INFO, STR_MUST_SELECT_ITEM ) ;
         } else
            GUISystem.printBox ( GUISystem.getParentDefWin ( this ), 
                                 STR_INFO, 
                                 STR_TITLE_EDIT_DLG_OPEN ) ;

      }


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_ADD_ANSWER                                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_ADD_ANSWER )
         addAnswer() ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_REMOVE_ANSWER                                        */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_REMOVE_ANSWER )
         removeAnswer() ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_ADD_CONCL                                            */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_ADD_CONCL ) {
         if ( currentAnswer != null ) {
            conclDlg = new ConclusionDlg ( GUISystem.getParentDefWin ( this ) ) ;
            conclDlg.setConclusionDlgListener ( this ) ;
         } else
            GUISystem.printBox ( GUISystem.getParentDefWin ( this ), STR_INFO, STR_MUST_SELECT_ITEM ) ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_REMOVE_CONCL                                         */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_REMOVE_CONCL ) {
         if ( currentConcl != null ) {
            currentConcl.setDocClass ( (TypeDocClassRec)TypeList.getInstance().objectFromInd ( TypeList.DOCCLASS_IBM_CONFIDENTIAL, TypeList.TYPE_DOCCLASS ) ) ;
            currentConcl.updateRecStatus ( PersistentRec.REC_DELETE ) ;
            refreshConclusions() ;
            currentConcl = null ;
         }
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   cb_DOC_CLASS                                            */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == cb_DOC_CLASS ) {
         if ( currentAnswer != null )
            currentAnswer.setDocClass ( (TypeDocClassRec) cb_DOC_CLASS.getSelectedItem() ) ;
      }


   }




   /*------------------------------------------------------------*/
   /* refreshAnswers
    */
   /**
    *    This method will refresh the list of answers
    *  in the answer list box with all of the valid
    *  answers
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void refreshAnswers () {
      Vector validAnswers = QuestUtil.getValidData ( answers ) ;                                     

      answerListModel.removeAllElements() ;
      if ( validAnswers != null ) {
         int i    = 0 ;
         int size = validAnswers.size() ;

         while ( i < size ) {
            answerListModel.addElement ( validAnswers.elementAt(i) ) ;
            i++ ;
         }
      }

      new Thread ( this ).start() ;
   }


   /*------------------------------------------------------------*/
   /* refreshConclusions
    */
   /**
    *    This method will refresh the list of conclusions
    *  in the conclusion list box with all of the valid
    *  conclusions
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void refreshConclusions () {
      Vector validConc = QuestUtil.getValidData ( currentAnswer.getConclusions() ) ;                                     

      conclusionListModel.removeAllElements() ;
      if ( validConc != null ) {
         int    i            = 0 ;
         Vector convConclVec = AnswerConclDisplayRec.convert ( validConc ) ;
         int    size         = convConclVec.size() ;

         while ( i < size ) {
            conclusionListModel.addElement ( convConclVec.elementAt(i) ) ;
            i++ ;
         }
      }

      refreshConclusion ( null ) ;
      revalidate() ;
   }





   /*------------------------------------------------------------*/
   /* addAnswer
    */
   /**
    *    This method will create a new answer and
    *  will add that answer to the list
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void addAnswer () {

      try {
         Answer newAnswer       = new Answer() ;
         String defaultTitle = null ;                              

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   First, we must create the default title for the answer  */
         /*                                                           */
         /*-----------------------------------------------------------*/
         defaultTitle = new SingleEntryDlg ( GUISystem.getParentDefWin ( this ),
                                             Str.getStr ( STR_DEFAULT_TITLE ),
                                             Str.getStr ( STR_DEFAULT_TITLE ),
                                             "", 
                                             new MaskDocument ( MaskDocument.MASKTYPE_UNKNOWN, LENGTH_OA_TITLE ) ).getResult() ;                       

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Only continue if we have a title                        */
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( defaultTitle != null ) {
            Title  title  = new Title ( defaultTitle ) ;
            Vector titles = new Vector ( 1 ) ;                         

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Set the values in the Title object                      */
            /*                                                           */
            /*-----------------------------------------------------------*/
            title.setLanguage ( (TypeLanguageRec) TypeList.getInstance().objectFromInd ( PropertySystem.getInt ( PropertySystem.PROPERTY_LANGUAGE ),
                                                                                         TypeList.TYPE_LANGUAGE ) ) ;
            title.setDocClass ( (TypeDocClassRec) TypeList.getInstance().objectFromInd ( TypeList.DOCCLASS_UNCLASSIFIED,
                                                                                         TypeList.TYPE_DOCCLASS ) ) ;
            title.setCountryList ( UserSystem.getUserCountries ( UserSystem.getUserId() ) ) ;                   

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Set up the newAnswer values                             */
            /*                                                           */
            /*-----------------------------------------------------------*/
            newAnswer.setCountryList ( UserSystem.getUserCountries ( UserSystem.getUserId() ) ) ;                   
            newAnswer.setDocClass ( (TypeDocClassRec) TypeList.getInstance().objectFromInd ( TypeList.DOCCLASS_IBM_CONFIDENTIAL,
                                                                                             TypeList.TYPE_DOCCLASS ) ) ;


            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Add the title                                           */
            /*                                                           */
            /*-----------------------------------------------------------*/
            titles.addElement ( title ) ;
            newAnswer.setTitles ( titles ) ;                                     
            answers.addElement ( newAnswer ) ;

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Now, we must force our question to assign keys          */
            /*                                                           */
            /*-----------------------------------------------------------*/
            parentWin.setStatus ( STR_PLEASE_WAIT ) ;
            question.assignDatabaseKeys() ;
            parentWin.setStatus ( null ) ;
            answerListModel.addElement ( newAnswer ) ;                                      

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Select the value. This will kick an event to us         */
            /* notifying us of the list selection. Our event handler     */
            /* automatically saves the current data and refreshes!       */
            /*                                                           */
            /*-----------------------------------------------------------*/
            lb_ANSWERS.setSelectedValue ( newAnswer, true ) ;

         }
      } catch ( Exception e ) {
         LogSystem.log ( 1, e ) ;
      }
   } /* addAnswer  */





   /*------------------------------------------------------------*/
   /* setCurrentAnswer
    */
   /**
    *    This method will set the current answer
    *  that we are editing
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void setCurrentAnswer ( Answer answer ) {                                                         

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Save the data for the current answer                    */
      /*                                                           */
      /*-----------------------------------------------------------*/
      saveData() ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Close the dialogs if we have them                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( titleEditDlg != null )
         titleEditDlg.dispose() ;

      if ( conclDlg != null )
         conclDlg.dispose() ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Now, refresh our data                                   */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( answer != null ) {
         Vector titles = answer.getTitles() ;

         currentAnswer = answer ;                                       

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   If there are new conclusions, create a Vector of        */
         /* AnswerConclDisplayRec objects to hold each conclusion     */
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( answer.getConclusions() != null )
            conclusions   = AnswerConclDisplayRec.convert ( answer.getConclusions() ) ;
         else
            conclusions   = null ;                         

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   set the current conclusion to null                      */
         /*                                                           */
         /*-----------------------------------------------------------*/
         currentConcl  = null ;           


         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Refresh our GUI data                                    */
         /*                                                           */
         /*-----------------------------------------------------------*/
         new Thread ( this ).start() ;

      }
   }




   /*------------------------------------------------------------*/
   /* setCurrentConclusion
    */
   /**
    *    This method will set the conclusion that
    *  is the current conclusion
    *  
    *
    *  @param conclusion The current conclusion
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void setCurrentConclusion ( AnswerConcl conclusion ) {
      if ( conclusion != null ) {
         this.currentConcl = conclusion ;
         refreshConclusion ( currentConcl ) ;

         if ( conclDlg != null )
            conclDlg.dispose() ;

      }
   }





   /*------------------------------------------------------------*/
   /* refreshConclusion
    */
   /**
    *    This method will refresh the data on the screen with the conclusion
    *  that is passed
    *  
    *
    *  @param concl The conclusion to use to refresh with
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void refreshConclusion ( AnswerConcl concl ) {
      if ( concl != null ) {
         conclusionConditionList.setConditions ( concl.getConditions() ) ;
         conclDocClassPanel.setDocClass ( concl.getDocClass() ) ;
      } else {
         conclusionConditionList.clear() ;
      }
   } /* refreshConclusion  */




   /*------------------------------------------------------------*/
   /* conclusionDlgClosed
    */
   /**
    *    This method will be called when the user
    *  is finished with a ConclusionDlg
    *  
    *
    *  @param answerConcl The AnswerConclusion that we are working with
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void conclusionDlgClosed ( AnswerConcl answerConcl, AnswerConclDisplayRec displayRec ) {
      if ( answerConcl != null ) {
         Vector answerConcVec = currentAnswer.getConclusions() ;

         if ( conclusions == null )
            conclusions = new Vector ( 1, 1 ) ;

         conclusions.addElement ( displayRec ) ;
         conclusionListModel.addElement ( displayRec ) ;
         lb_CONCLUSIONS.setSelectedValue ( displayRec, true ) ;

         if ( answerConcVec == null )
            answerConcVec = new Vector ( 1 ) ;

         answerConcVec.addElement ( answerConcl ) ;
         currentAnswer.setConclusions ( answerConcVec ) ;
      }
   }




   /*------------------------------------------------------------*/
   /* titleEditDlgClosed
    */
   /**
    *    This method will be called when the user
    *  has edited the titles of an answer, we will
    *  save that data here
    *
    *  @param titles The titles
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void titleEditDlgClosed ( Vector titles ) {
      if ( titles != null ) {
         int i    = 0 ;
         int size = titles.size() ;

         while ( i < size ) {
            ((Title)titles.elementAt(i)).setToStringType ( Title.TEXT ) ;
            i++ ;
         }
         currentAnswer.setTitles ( titles ) ;
         saveData() ;
         revalidate() ;
      }
      titleEditDlg = null ;
   }





   /*------------------------------------------------------------*/
   /* setOAObject
    */
   /**
    *    This method will set the OA Object
    *  that these answers represent
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setOAObject ( QuestionDraft question ) {
      this.question = question ;
   }




   /*------------------------------------------------------------*/
   /* setAnswers
    */
   /**
    *    This method will set the set of answers that
    *  we are allowing edit of
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setAnswers ( Vector answers ) {
      this.answers = answers ;
      refreshAnswers() ;
   }



   /*------------------------------------------------------------*/
   /* saveData
    */
   /**
    *    Currently all data is saved when anything
    *  is changed automatically, currently we just
    *  return TRUE
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean saveData () {
      if ( currentAnswer != null ) {
         saveConclusions() ;
         conditionList.getConditions() ;
         currentAnswer.setCountryList ( countrySelectPanel.getCountryList() ) ;
      }

      if ( question != null )
         question.setAnswers ( answers ) ;

      return( true ) ;
   }




   /*------------------------------------------------------------*/
   /* removeAnswer
    */
   /**
    *    This method will be called when the user
    *  wants to remove the selected answer
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void removeAnswer () {
      if ( currentAnswer != null ) {

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Check the usage first, and then continue if there       */
         /* is no usage                                               */
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( ( !usagePanel.isAnswerUsed ( currentAnswer.getInd() ) ) &&
              ( !usagePanel.isAnswerUsed ( currentAnswer.getActiveAnswerInd() ) ) ) {
            currentAnswer.updateRecStatus ( currentAnswer.REC_DELETE ) ;
            currentAnswer = null ;
            refreshAnswers() ;
         } else
            GUISystem.printBox ( STR_INFO, STR_ANSWER_USED_CHECK_USAGE ) ;
      }
   }




   /*------------------------------------------------------------*/
   /* saveConclusionData
    */
   /**
    *    This method will save all of the information
    *  that the current conclusion has
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void saveConclusionData () {
      if ( currentConcl != null ) {
         conclusionConditionList.getConditions() ;
         currentConcl.setDocClass ( conclDocClassPanel.getDocClass() ) ;
      }
   }




   /*------------------------------------------------------------*/
   /* saveConclusions
    */
   /**
    *    This method will save all of the current conclusions
    *  in the conclusions vector to the answer
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void saveConclusions () {
      if ( currentAnswer != null ) {

         saveConclusionData() ;

         currentAnswer.setConclusions ( QuestUtil.getDataFromDisplay ( conclusions ) ) ;
      }
   }

   /*------------------------------------------------------------*/
   /* getCountrySelectPanel
    */
   /**
    *    This method will return an instance of this
    *  panel's CountrySelectPanel
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   protected CountrySelectPanel getCountrySelectPanel () {
      return( countrySelectPanel ) ;
   }




   /*------------------------------------------------------------*/
   /* removeCountryFromPanel
    */
   /**
    *    This method will remove the TypeCountryCodeRec
    *  passed from all answers in this panel
    *  
    *
    *  @param countryRec The TypeCountryCodeRec to remove
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   protected void removeCountryFromPanel ( TypeCountryCodeRec countryRec ) {


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Remove the country from all of our answers              */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( ( answers != null ) && ( answers.size() > 0 ) ) {
         int    i               = 0 ;
         int    size            = answers.size() ;
         Vector answerCountries = null ;

         while ( i < size ) {
            answerCountries = ((Answer)answers.elementAt(i)).getCountryList() ;
            answerCountries.removeElement ( countryRec ) ;
            ((Answer)answers.elementAt(i)).setCountryList ( answerCountries ) ;
            i++ ;
         } /* while  */
      } /* if  */


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Now, refresh our display                                */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( currentAnswer != null )
         countrySelectPanel.setCountryList ( currentAnswer.getCountryList() ) ;



   }






   /*------------------------------------------------------------*/
   /* spellCheck
    */
   /**
    *    This method will spell check all answers on this
    *  panel
    *  
    *
    *  @param tabbedPane This can be null. If it is not null, and there
    *                    are misspelled words, this method will turn the
    *                    tabbed pane's page to this panel.
    *  @param None
    *  @param None
    *
    *  @return TRUE if there are no misspelled words
    *//*---------------------------------------------------------*/
   protected boolean spellCheck ( JTabbedPane tabbedPane, SpellPanel spellPanel ) {
      boolean         mispelled    = false ;

      if ( answers.size() > 0 ) {

         this.tabbedPane = tabbedPane ;
         this.spellPanel = spellPanel ;

         /*-------------------------------------------------------------*/
         /*                                                             */
         /*   Add ourselves as a listener so we get notified of status  */
         /*                                                             */
         /*-------------------------------------------------------------*/
         spellPanel.addSpellPanelListener ( this ) ;

         spellIndex = 0 ;
         spellCheck ( (Answer)answers.elementAt(spellIndex) ) ;
      } else
         fireSpellCheckEvent ( false ) ;

      return( mispelled ) ;
   }





   /*------------------------------------------------------------*/
   /* spellCheck
    */
   /**
    *    This method will spell check an entire Answer
    *  
    *  
    *
    *  @param answer The answer object to spell check
    *  @param spellToolkit The already created JSpellToolkit
    *  @param None
    *
    *  @return TRUE if no misspelled words
    *//*---------------------------------------------------------*/
   private boolean spellCheck ( Answer answer ) {
      boolean         rc           = false ;

      spellCheckAnswer = answer ;
      spellPanel.spellCheck ( spellCheckAnswer.toString() ) ;
      return( rc ) ;
   }





   /*------------------------------------------------------------*/
   /* spellCheckComplete
    */
   /**
    *    This method will be called once the SpellPanel
    *  is done checking a answer.
    *  
    *
    *  @param errorsFound TRUE if any errors were encountered
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void spellCheckComplete ( boolean errorsFound ) {             

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Update the spell Index                                  */
      /*                                                           */
      /*-----------------------------------------------------------*/
      spellIndex++ ;                                               

      /*--------------------------------------------------------------*/
      /*                                                              */
      /*   If we have no more answers to check, notify the listeners  */
      /*                                                              */
      /*--------------------------------------------------------------*/
      if ( spellIndex >= (answers.size() ) ) {
         spellPanel.removeSpellPanelListener ( this ) ;
         fireSpellCheckEvent ( errorsFound ) ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Otherwise, start spell checking the next answer         */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else {
         System.out.println (" AnswerEditPanel CompletE, asdasd!" ) ;
         spellCheck ( (Answer)answers.elementAt ( spellIndex ) ) ;
      }
   }





   /*------------------------------------------------------------*/
   /* spellCheckWord
    */
   /**
    *    This method will be called when the SpellPanel
    *  has encountered an error
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void spellCheckWord ( String word, int startPos, int endPos ) {

      tabbedPane.setSelectedIndex ( tabIndex ) ;

      saveData() ;
      currentAnswer = spellCheckAnswer ;
      refreshData ( currentAnswer ) ;
      lb_ANSWERS.setSelectedValue ( currentAnswer, true ) ;
      revalidate() ;
   }




   /*------------------------------------------------------------*/
   /* replaceWord
    */
   /**
    *    This method will replace the word that is passed
    *  in (oldWord) with the newWord passed in. This means
    *  that the user has corrected the type-o
    *
    *  @param oldWord What the word used to be
    *  @param newWord What the new word is
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void replaceWord ( String oldWord, String newWord, int startIndex ) {
      String newAnswer = spellCheckAnswer.toString() ;
      Vector titles    = spellCheckAnswer.getTitles() ;
      Title  title     = (Title)titles.elementAt(titles.size()-1) ;

      newAnswer = newAnswer.substring ( 0, startIndex )+newWord+newAnswer.substring ( startIndex+oldWord.length() ) ;

      title.setTitle ( newAnswer ) ;
      titles.removeElement ( title ) ;
      titles.addElement ( title ) ;
      spellCheckAnswer.setTitles ( titles ) ;

      refreshData ( spellCheckAnswer ) ;

      revalidate() ;
   }






   /*------------------------------------------------------------*/
   /* setBrandInd
    */
   /**
    *    This method will set the brand that is
    *  the brand of the parent object of the answers
    *  being edited
    *
    *  @param brandInd The brand indicator as defined in TIGRIS.TYPEBRAND
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setBrandInd ( int brandInd ) {
      this.brandInd = brandInd ;
   }

} /* AnswerEditPanel */
