package com.ibm.nzna.projects.qit.avalon.editors ;              
/*-----------------------------------------------------------*/
/*   SymptomNodePanel                                        */
/*                                                           */
/*   Description:                                            */
/*      Source code for: SymptomNodePanel                    */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import com.ibm.nzna.projects.common.quest.oa.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.app.util.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.qit.avalon.cache.* ;
import com.ibm.nzna.projects.qit.avalon.base.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.util.* ;
/**
 * This panel shows on the 'NodeEdit' panel. It allows the user 
 * to see things about the symptom 
 *
 * @version 1.0, 5/15/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   SymptomNodePanel                                       */
/*                                                           */
/*-----------------------------------------------------------*/
public class SymptomNodePanel extends JPanel implements EditPanelListener, ActionListener, NodePanel, AppConst {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private GUI Members                                     */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private JLabel       st_SYMPTOM     = null ;
   private JLabel       st_TITLE       = null ;
   private JLabel       st_SYMPTOMIND  = null ;
   //private JLabel       st_EDGES       = null ;
   //private JList        lb_EDGES       = null ;
   //private JScrollPane  scr_EDGES      = null ;
   //private ButtonPanel  buttonPanel    = null ;
   //private HotLinkLabel pb_ADD         = null ;
   //private HotLinkLabel pb_REMOVE      = null ;
   //private HotLinkLabel pb_EDIT        = null ;

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private int           symptomInd    = 0 ;
   private boolean       showingDraft  = false ;
   private ObjectNode    objectNode    = null ;
   private Vector        edges         = null ;
   private Symptom       symptom       = null ;
   private FlowEditPanel flowPanel     = null ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will construct our panel with
    *  no Question
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public SymptomNodePanel () {
      initialize() ;
   }





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This constructor will create our panel initialized
    *  to the Node passed
    *  
    *
    *  @param node The Node representing the Question to show information for
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public SymptomNodePanel ( FlowEditPanel flowPanel, FlowNode node, Symptom symptom ) {
      initialize() ;
      this.flowPanel = flowPanel ;
      setSymptom ( symptom ) ;
      if ( node instanceof ObjectNode )
         setNode ( (ObjectNode)node ) ;
   }





   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will initialize our GUI
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void initialize () {     

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create our GUI                                          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      st_SYMPTOM      = new JLabel ( Str.getStr ( STR_SYMPTOM ) ) ;
      st_SYMPTOMIND   = new JLabel ( "" ) ;
      st_TITLE        = new JLabel ( "" ) ;
      //st_EDGES        = new JLabel ( Str.getStr ( STR_EDGES ) ) ;
      //lb_EDGES        = new JList () ;
      //scr_EDGES       = new JScrollPane ( lb_EDGES ) ;
      //buttonPanel     = new ButtonPanel () ;
      //pb_ADD          = new HotLinkLabel ( Str.getStr ( STR_ADD ) ) ;
      //pb_REMOVE       = new HotLinkLabel ( Str.getStr ( STR_REMOVE ) ) ;
      //pb_EDIT         = new HotLinkLabel ( Str.getStr ( STR_EDIT ) ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setOpaque                 ( false ) ;
      st_SYMPTOM.setOpaque      ( false ) ;
      st_TITLE.setOpaque        ( false ) ;
      st_SYMPTOM.setFont        ( FontSystem.largeTitleFont ) ;
      //st_EDGES.setFont          ( FontSystem.smallTitleFont ) ;
      //scr_EDGES.setBorder       ( GUISystem.blackBorder ) ;
      //buttonPanel.setBorder     ( GUISystem.grayBorder ) ;
      //buttonPanel.setBackground ( new Color ( 240, 240, 240 ) ) ;                 

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add listeners                                           */    
      /*                                                           */
      /*-----------------------------------------------------------*/
      //pb_ADD.addActionListener ( this ) ;
      //pb_REMOVE.addActionListener ( this ) ;
      //pb_EDIT.addActionListener ( this ) ;
      

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add the GUI                                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( null ) ;
      //buttonPanel.add ( pb_ADD ) ;
      //buttonPanel.add ( new ToolBarSeparator ( new Dimension ( 1, GUISystem.getRowHeight() ) ) ) ;
      //buttonPanel.add ( pb_EDIT ) ;
      //buttonPanel.add ( new ToolBarSeparator ( new Dimension ( 1, GUISystem.getRowHeight() ) ) ) ;
      //buttonPanel.add ( pb_REMOVE ) ;
      add ( st_SYMPTOM ) ;
      add ( st_TITLE ) ;
      add ( st_SYMPTOMIND ) ;
      //add ( st_EDGES ) ;
      //add ( scr_EDGES ) ;
      //add ( buttonPanel ) ;

      //pb_ADD.setEnabled ( false ) ;
      //pb_EDIT.setEnabled ( false ) ;
      //pb_REMOVE.setEnabled ( false ) ;
   }





   /*------------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will lay out and position all of 
    *  our controls
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size      = getSize() ;
      int       rowHeight = GUISystem.getRowHeight() ;
      int       x         = 5 ; 
      int       y         = 0 ; 

      st_SYMPTOM.setBounds ( x, y, size.width-(x*2), rowHeight+8 ) ;
      y+=rowHeight+10 ;

      st_TITLE.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight ;

      st_SYMPTOMIND.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight+5 ;

      //st_EDGES.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      //y+=rowHeight+5 ;

      //scr_EDGES.setBounds ( x,y , size.width-(x*2), rowHeight*5 );
      //y+=rowHeight*5+5 ;

      //buttonPanel.setBounds ( x, y, size.width-(x*2), rowHeight ) ;

   }





   /*------------------------------------------------------------*/
   /* setNode
    */
   /**
    *    This method will set the node that we are
    *  currently editing
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setNode ( FlowNode node ) {                       
      if ( node instanceof ObjectNode )
         this.objectNode = (ObjectNode)node ;
   }




   /*------------------------------------------------------------*/
   /* refresh
    */
   /**
    *    This method will refresh all of our data
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void refresh () {
      st_TITLE.setText ( getDefaultTitle () ) ;
      if ( objectNode.isDraft() )
         st_SYMPTOMIND.setText ( ""+objectNode.getNode().getDraftObjectInd() ) ;
      else
         st_SYMPTOMIND.setText ( ""+objectNode.getNode().getActiveObjectInd() ) ;

      //setEdges ( AvalonUtil.getEdgesFromNode ( symptom.getEdgeGroups(), objectNode.getNode() ) ) ;

   }


   /*------------------------------------------------------------*/
   /* setEdges
    */
   /**
    *    This method will set the edges that this
    *  panel is displaying
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   //protected void setEdges ( Vector edges ) {
   //   this.edges = QuestUtil.getValidData ( edges ) ;

   //   lb_EDGES.setListData ( this.edges ) ;
   //}



   /*------------------------------------------------------------*/
   /* getDefaultTitle
    */
   /**
    *    This method will get the default title of the
    *  object we are representing
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String
    *//*---------------------------------------------------------*/
   private String getDefaultTitle () {
      if ( objectNode != null )
         return( objectNode.getTitle() ) ;
      return( "Unknown" ) ;
   } /* getDefaultTitle */

   public void spellCheckComplete ( EditPanel editPanel, boolean errorsFound ) {
   }





   /*------------------------------------------------------------*/
   /* setSymptom
    */
   /**
    *    This method will set the symptom that we are
    *  using
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setSymptom ( Symptom symptom ) {
      this.symptom = symptom ;
   }





   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will be called when an
    *  active event is fired on us
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {
//      /*-----------------------------------------------------------*/
//      /*                                                           */
//      /*   pb_ADD_EDGE                                             */
//      /*                                                           */
//      /*-----------------------------------------------------------*/
//      if ( e.getSource() == pb_ADD ) {
//         Vector          edgeGroups = symptom.getEdgeGroups() ;
//         EdgeGroup       edgeGroup  = null ;
//         EdgeReturnDlg   edgeDlg    = new EdgeReturnDlg ( GUISystem.getParentDefWin ( this ),
//                                                          symptom,
//                                                          objectNode,
//                                                          flowPanel.getObjectNodes() ) ;

//         /*-----------------------------------------------------------*/
//         /*                                                           */
//         /*   Wait for the user to respond                            */
//         /*                                                           */
//         /*-----------------------------------------------------------*/
//         if ( edgeDlg.getResult() ) {
//            Edge   edgeRec = edgeDlg.getEdge() ;
//            Vector edgeVec = null ;

//            /*-----------------------------------------------------------*/
//            /*                                                           */
//            /*   Get the edge group that binds the head and tail node    */
//            /* and create one if need be                                 */
//            /*                                                           */
//            /*-----------------------------------------------------------*/
//            edgeGroup = AvalonUtil.getEdgeGroup ( edgeGroups, 
//                                                  objectNode.getNode(), 
//                                                  edgeDlg.getTailNode().getNode() ) ;

//            /*----------------------------------------------------------------------*/
//            /*                                                                      */
//            /*   If we do not have that group, create a new EdgeGroup to hold it    */
//            /*                                                                      */
//            /*----------------------------------------------------------------------*/
//            if ( edgeGroup == null ) {

//               /*-----------------------------------------------------------*/
//               /*                                                           */
//               /*   If there is no edgeGroupVec, create a new one           */
//               /*                                                           */
//               /*-----------------------------------------------------------*/
//               if ( edgeGroups == null )
//                  edgeGroups = new Vector ( 1 ) ;

//               edgeGroup = new EdgeGroup ( objectNode.getNode(), edgeDlg.getTailNode().getNode() ) ;
//               edgeGroups.addElement ( edgeGroup ) ;
//            }

//            /*-----------------------------------------------------------*/
//            /*                                                           */
//            /*   Add this new edge to the list of edges                  */
//            /*                                                           */
//            /*-----------------------------------------------------------*/
//            edgeVec = edgeGroup.getEdges() ;
//            if ( edgeVec == null )
//               edgeVec = new Vector ( 1 ) ;
//            edgeVec.addElement ( edgeRec ) ;
//            edges.addElement   ( edgeRec ) ;
//            edgeGroup.setEdges ( edgeVec ) ;
//            edgeGroup.updateRecStatus ( edgeGroup.REC_UPDATE ) ;
//            setEdges ( edges ) ;

//            /*-----------------------------------------------------------*/
//            /*                                                           */
//            /*    Now, set the symptoms in the edge group                */
//            /*                                                           */
//            /*-----------------------------------------------------------*/
//            symptom.setEdgeGroups ( edgeGroups ) ;
//            flowPanel.getVisioPanel().addEdgeGroup ( edgeGroup ) ;
//            flowPanel.refreshCounters() ;
//            flowPanel.repaint() ;
//         }
//      }
//      /*-----------------------------------------------------------*/
//      /*                                                           */
//      /*   pb_REMOVE_EDGE                                          */
//      /*                                                           */
//      /*-----------------------------------------------------------*/
//      else if ( e.getSource() == pb_REMOVE ) {
//         Edge      edgeRec       = (Edge)lb_EDGES.getSelectedValue() ;
//         EdgeGroup edgeGroup     = null ;
//         Vector    allEdgeGroups = symptom.getEdgeGroups() ; 
//         int       i             = 0 ;
//         boolean   found         = false;

//         if ( allEdgeGroups != null ) {
//            int size    = allEdgeGroups.size() ;

//            while ( ( i < size ) && ( !found ) ) {
//               if ( ((EdgeGroup)allEdgeGroups.elementAt(i)).getEdges().contains ( edgeRec ) ) {
//                  edgeGroup = (EdgeGroup)allEdgeGroups.elementAt(i) ;
//                  
//                  /*-----------------------------------------------------------*/
//                  /*                                                           */
//                  /*   Mark the edge as delete now                             */                  
//                  /*                                                           */
//                  /*-----------------------------------------------------------*/
//                  edgeRec.updateRecStatus ( edgeRec.REC_DELETE ) ;
//                  
//                  
//                  /*-------------------------------------------------------------------*/
//                  /*                                                                   */
//                  /*   If the edge group has no more valid items, mark it as delete    */
//                  /*                                                                   */
//                  /*-------------------------------------------------------------------*/
//                  if ( !QuestUtil.containsValid ( edgeGroup.getEdges() ) )
//                     edgeGroup.updateRecStatus ( edgeGroup.REC_DELETE ) ;
//                  found=true ;
//               }
//               i++ ;
//            }
//         }
//      } /* pb_REMOVE  */

//      /*-----------------------------------------------------------*/
//      /*                                                           */
//      /*   pb_EDIT_EDGE                                            */
//      /*                                                           */
//      /*-----------------------------------------------------------*/
//      else if ( e.getSource() == pb_EDIT ) {
//         Edge edge = (Edge) lb_EDGES.getSelectedValue() ;

//         if ( edge != null ) {
//            EdgeEditPanel edgePanel = new EdgeEditPanel ( edge ) ;

//            edgePanel.addEditPanelListener ( this ) ;
//            flowPanel.setDataPanel ( edgePanel, true ) ;
//            setControlsEnabled ( false ) ;
//         }
//      }
   } /* actionPerf  */

   /*------------------------------------------------------------*/
   /* setControlsEnabled
    */
   /**
    *    This method will either enable or disable
    *  all of our controls
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void setControlsEnabled ( boolean enabled ) {
//      pb_ADD.setEnabled ( enabled ) ;
//      pb_REMOVE.setEnabled ( enabled ) ;
//      pb_EDIT.setEnabled ( enabled ) ;
//      scr_EDGES.setEnabled ( enabled ) ;
//      lb_EDGES.setEnabled ( enabled ) ;
   }

   /*------------------------------------------------------------*/
   /* editPanelChanged
    */
   /**
    *    This method will be called when one of our
    *  edit panels has been changed
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void editPanelChanged ( EditPanel editPanel ) {
      flowPanel.setDefaultDataPanel() ;
      setControlsEnabled ( true ) ;
   } /* editPanelChanged  */

} /* SymptomNodePanel */
