package com.ibm.nzna.projects.qit.avalon.editors ;            
/*-----------------------------------------------------------*/
/*   SymptomTitleEditPanel                                   */
/*                                                           */
/*   Description:                                            */
/*      Source code for: SymptomTitleEditPanel               */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import javax.swing.* ;
import javax.swing.event.* ;
import java.awt.* ;
import java.awt.event.* ;
import java.util.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.app.util.* ;
import com.ibm.nzna.projects.qit.gui.* ;     
import com.ibm.nzna.projects.qit.dbgui.* ;     
import com.ibm.nzna.projects.qit.avalon.base.* ;
import com.ibm.nzna.projects.qit.avalon.gui.* ;
import com.ibm.nzna.shared.gui.* ;     
import com.ibm.nzna.shared.spell.* ;     
import com.ibm.nzna.shared.util.* ;     
import com.ibm.nzna.shared.pom.* ;     
import com.ibm.nzna.projects.common.quest.oa.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
/**
 * This panel allows a user to edit a vector of titles. 
 *
 *
 * @version 1.0, 4/26/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   SymptomTitleEditPanel                                   */
/*                                                           */
/*-----------------------------------------------------------*/
public class SymptomTitleEditPanel extends EditPanel implements SpellPanelListener, Runnable, ListSelectionListener, AppConst, AvalonConst, ActionListener, KeyListener {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private GUI Members                                     */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private Dimension          prefSize           = new Dimension ( 400, 700 ) ;
   private JList              lb_TITLES          = null ;
   private JTextField         ef_TITLE           = null ;
   private JScrollPane        scr_TITLES         = null ;
   private JTitle             st_TITLES          = null ;
   private JTitle             st_DOC_CLASS       = null ;
   private JComboBox          cb_DOC_CLASS       = null ;
   private JTitle             st_TITLE_TEXT      = null ;
   private HotLinkLabel       pb_ADD_TITLE       = null ;
   private HotLinkLabel       pb_REMOVE_TITLE    = null ;
   private HotLinkLabel       pb_SET_DEFAULT     = null ;
   private HotLinkLabel       pb_TITLE_UP        = null ;
   private HotLinkLabel       pb_TITLE_DOWN      = null ;
   private HotLinkLabel       pb_ADD_KEYWORDS    = null ;
   private HotLinkLabel       pb_REMOVE_KEYWORDS = null ;
   private ButtonPanel        buttonPanel        = null ;
   private ButtonPanel        titleButtonPanel   = null ;
   private JTextArea          mle_KEYWORDS       = null ;
   private JTitle             st_KEYWORDS        = null ;
   private JScrollPane        scr_KEYWORDS       = null ;
   private CountrySelectPanel countryPanel       = null ;


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private DefaultListModel   listModel         = null ;
   private Vector             titles            = null ;
   private SymptomTitle       defaultTitle      = null ;
   private SymptomTitle       currentTitle      = null ;
   private SymptomTitle       spellCheckTitle   = null ;
   private int                spellIndex        = 0 ;
   private JTabbedPane        tabbedPane        = null ; // This is not one of our components. We are placed as a tab in this JTabbedPane
   private SpellPanel         spellPanel        = null ;
   private int                brandInd          = 0 ;




   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will create a title panel
    *  initialized to the vector passed in
    *  
    *
    *  @param titles The vector of Title objects
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public SymptomTitleEditPanel ( int brandInd, Vector titles ) {

      this.brandInd = brandInd ;
      this.titles = titles ;                                      

      initialize ( ) ;
   }

   public SymptomTitleEditPanel ( int brandInd ) {
      this.brandInd = brandInd ;
      initialize (  ) ;
   }




   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will initialize our panel. It will
    *  add all of the GUI and refresh the data
    *  
    *
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void initialize ( ) {                

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create the GUI Components                               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      ef_TITLE           = new JTextField ( new MaskDocument ( MaskDocument.MASKTYPE_UNKNOWN, LENGTH_OA_TITLE ), "", 0 ) ;
      st_TITLES          = new JTitle ( Str.getStr ( STR_TITLES ) ) ;
      st_TITLE_TEXT      = new JTitle ( Str.getStr ( STR_TITLE_TEXT ) ) ;
      pb_ADD_TITLE       = new HotLinkLabel ( Str.getStr ( STR_ADD_TITLE ) ) ;
      pb_REMOVE_TITLE    = new HotLinkLabel ( Str.getStr ( STR_REMOVE_TITLE ) ) ;
      pb_SET_DEFAULT     = new HotLinkLabel ( Str.getStr ( STR_SET_DEFAULT ) ) ;
      pb_ADD_KEYWORDS    = new HotLinkLabel ( Str.getStr ( STR_ADD_KEYWORDS ) ) ;
      pb_REMOVE_KEYWORDS = new HotLinkLabel ( Str.getStr ( STR_REMOVE_KEYWORDS ) ) ;
      buttonPanel        = new ButtonPanel () ;
      lb_TITLES          = new JList() ;
      pb_TITLE_UP        = new HotLinkLabel ( Str.getStr ( STR_UP ) ) ;
      pb_TITLE_DOWN      = new HotLinkLabel ( Str.getStr ( STR_DOWN ) ) ;
      scr_TITLES         = new JScrollPane ( lb_TITLES ) ;
      st_DOC_CLASS       = new JTitle ( Str.getStr ( STR_DOC_CLASS ) ) ;
      cb_DOC_CLASS       = new JComboBox ( TypeList.getInstance().getTypeList ( TypeList.TYPE_DOCCLASS ) ) ;
      titleButtonPanel   = new ButtonPanel () ;
      st_KEYWORDS        = new JTitle ( Str.getStr ( STR_KEYWORDS ) ) ;
      mle_KEYWORDS       = new JTextArea ( new MaskDocument ( MaskDocument.MASKTYPE_UNKNOWN, 1024 ) ) ;
      scr_KEYWORDS       = new JScrollPane ( mle_KEYWORDS ) ;
      countryPanel       = new CountrySelectPanel () ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setBackground ( Color.white ) ;
      lb_TITLES.setModel ( listModel = new DefaultListModel() ) ;
      st_TITLE_TEXT.setFont  ( FontSystem.smallTitleFont ) ;
      st_DOC_CLASS.setFont   ( FontSystem.smallTitleFont ) ;
      st_TITLES.setFont      ( FontSystem.smallTitleFont ) ;
      GUISystem.setPreferredButton ( pb_SET_DEFAULT ) ;
      GUISystem.setPreferredButton ( pb_ADD_TITLE ) ;
      GUISystem.setPreferredButton ( pb_REMOVE_TITLE ) ;
      scr_TITLES.setBorder ( GUISystem.blackBorder ) ;
      buttonPanel.setBorder     ( GUISystem.grayBorder ) ;
      st_KEYWORDS.setFont ( FontSystem.smallTitleFont ) ;
      buttonPanel.setBackground ( new Color ( 230, 230, 230 ) ) ;
      buttonPanel.setArrowImage ( ImageSystem.getImageIcon ( this, ImageSystem.BUTTONPANEL_LEFT ),
                                  ImageSystem.getImageIcon ( this, ImageSystem.BUTTONPANEL_RIGHT ) ) ;             
      titleButtonPanel.setBorder     ( GUISystem.grayBorder ) ;
      titleButtonPanel.setBackground ( new Color ( 230, 230, 230 ) ) ;
      titleButtonPanel.setArrowImage ( ImageSystem.getImageIcon ( this, ImageSystem.BUTTONPANEL_LEFT ),
                                       ImageSystem.getImageIcon ( this, ImageSystem.BUTTONPANEL_RIGHT ) ) ;             
      lb_TITLES.setSelectionBackground ( new Color ( 170, 170, 255 ) ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add action listeners                                    */
      /*                                                           */
      /*-----------------------------------------------------------*/
      pb_ADD_TITLE.addActionListener       ( this ) ;
      pb_REMOVE_TITLE.addActionListener    ( this ) ;
      pb_SET_DEFAULT.addActionListener     ( this ) ;
      lb_TITLES.addListSelectionListener   ( this ) ;
      ef_TITLE.addKeyListener              ( this ) ;
      pb_TITLE_UP.addActionListener        ( this ) ;
      pb_TITLE_DOWN.addActionListener      ( this ) ;
      pb_ADD_KEYWORDS.addActionListener    ( this ) ;
      pb_REMOVE_KEYWORDS.addActionListener ( this ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add the GUI                                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( null ) ;
      add ( st_TITLES ) ;
      add ( scr_TITLES ) ;
      titleButtonPanel.add ( pb_TITLE_UP ) ;
      titleButtonPanel.add ( new ToolBarSeparator ( new Dimension ( 1, GUISystem.getRowHeight() ) ) ) ;
      titleButtonPanel.add ( pb_TITLE_DOWN ) ;
      add ( titleButtonPanel ) ;
      add ( st_TITLE_TEXT ) ;
      add ( ef_TITLE ) ;
      add ( st_DOC_CLASS ) ;
      add ( cb_DOC_CLASS ) ;
      add ( buttonPanel ) ;
      add ( st_KEYWORDS ) ;
      add ( scr_KEYWORDS ) ;
      add ( countryPanel ) ;

      /* Only allow BPMs to set the default title  */
      if ( UserSystem.getLoggedUserRec().isBPM() ) {
         buttonPanel.add ( pb_SET_DEFAULT ) ;
         buttonPanel.add ( new ToolBarSeparator ( new Dimension ( 1, GUISystem.getRowHeight() ) ) ) ;
      }

      buttonPanel.add ( pb_ADD_TITLE ) ;
      buttonPanel.add ( new ToolBarSeparator ( new Dimension ( 1, GUISystem.getRowHeight() ) ) ) ;
      buttonPanel.add ( pb_REMOVE_TITLE ) ;
      buttonPanel.add ( new ToolBarSeparator ( new Dimension ( 1, GUISystem.getRowHeight() ) ) ) ;
      buttonPanel.add ( pb_ADD_KEYWORDS ) ;
      buttonPanel.add ( new ToolBarSeparator ( new Dimension ( 1, GUISystem.getRowHeight() ) ) ) ;
      buttonPanel.add ( pb_REMOVE_KEYWORDS ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Refresh the data                                        */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( titles != null ) {

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Set the default title in the large title                */
         /*                                                           */
         /*-----------------------------------------------------------*/
         getDefaultTitle() ;
         refreshData ( null ) ;
         refreshTitles() ;
      }

   } /* initialize  */





   /*------------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will lay out and position all of
    *  our GUI
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size      = getSize() ;
      int       x         = 15 ;
      int       rowHeight = GUISystem.getRowHeight() ;
      int       y         = 5 ;

      buttonPanel.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight+5 ;

      st_TITLES.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight ;

      scr_TITLES.setBounds ( x, y, size.width-(x*2), rowHeight*5 ) ;
      y+=(rowHeight*5)+5 ;

      titleButtonPanel.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight+10 ;

      st_TITLE_TEXT.setBounds ( x, y, size.width-(x*2)-170, rowHeight ) ;
      st_DOC_CLASS.setBounds ( size.width-(x*2)-150, y, 150, rowHeight ) ;
      y+=rowHeight ;

      ef_TITLE.setBounds ( x, y, size.width-(x*2)-170, rowHeight ) ;
      cb_DOC_CLASS.setBounds ( size.width-(x*2)-150, y, 150, rowHeight ) ;
      y+=rowHeight ;

      st_KEYWORDS.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight ;

      scr_KEYWORDS.setBounds ( x, y, size.width-(x*2), rowHeight*5 ) ;
      y+=(rowHeight*5) ;

      countryPanel.setBounds ( x, y, size.width-(x*2), rowHeight*7 ) ;

   }





   /*------------------------------------------------------------*/
   /* refreshData
    */
   /**
    *    This method will refresh all of the data on our
    *  panel
    *  
    *
    *  @param title The Title to refresh with
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void refreshData ( SymptomTitle title ) {

      ef_TITLE.setText ( "" ) ;
      mle_KEYWORDS.setText ( "" ) ;

      if ( title != null ) {

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Set our title data                                      */
         /*                                                           */
         /*-----------------------------------------------------------*/
         ef_TITLE.setText ( title.getTitle() ) ;         
         cb_DOC_CLASS.setSelectedItem ( title.getDocClass() ) ;
         mle_KEYWORDS.setText ( title.getKeywords() ) ;
         countryPanel.setCountryList ( title.getCountryList() ) ;

      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   If this is the default title, we must disable           */
      /* the document classification and title entry field         */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( currentTitle == getDefaultTitle() ) {
         cb_DOC_CLASS.setVisible ( false ) ;
         st_DOC_CLASS.setVisible ( false ) ;
         ef_TITLE.setEnabled ( UserSystem.getLoggedUserRec().isBPM ( brandInd ) ) ;
         pb_TITLE_UP.setEnabled ( false ) ;
         pb_TITLE_DOWN.setEnabled ( false ) ;
         countryPanel.setEnabled ( false ) ;
      } else {
         ef_TITLE.setEnabled ( true ) ;
         countryPanel.setEnabled ( true ) ;
         cb_DOC_CLASS.setVisible ( true ) ;
         st_DOC_CLASS.setVisible ( true ) ;
         pb_TITLE_UP.setEnabled ( true ) ;
         pb_TITLE_DOWN.setEnabled ( true ) ;
      }

   }



   /*------------------------------------------------------------*/
   /* getDefaultTitle
    */
   /**
    *    This method will return the default title
    *  for the symptom
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   protected SymptomTitle getDefaultTitle () {
      if ( titles != null )
         defaultTitle = (SymptomTitle) titles.elementAt(titles.size()-1 ) ;
      else
         defaultTitle = null ;
      return( defaultTitle ) ;
   }




   /*------------------------------------------------------------*/
   /* addTitle
    */
   /**
    *    This method will pop up a window asking
    *  the user for a title. It will then add the title
    *  to the list and return the title object.
    *
    *  @param parent The parent window for the user pop up
    *  @param None
    *  @param None
    *
    *  @return SymptomTitle
    *//*---------------------------------------------------------*/
   private SymptomTitle addTitle ( AppDefaultWin parent ) {
      SymptomTitle  title        = null ;
      String newTitle = new SingleEntryDlg ( parent, 
                                             ( titles == null ) ? Str.getStr ( STR_DEFAULT_TITLE ) : Str.getStr ( STR_TITLE ),
                                             ( titles == null ) ? Str.getStr ( STR_ENTER_DEFAULT_TITLE ) : Str.getStr ( STR_TITLE ),
                                             "",
                                             new MaskDocument ( MaskDocument.MASKTYPE_UNKNOWN, LENGTH_OA_TITLE ) ).getResult() ;                           

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   If the user supplied a title, add it                    */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( ( newTitle != null ) && ( newTitle.length() > 0 ) ) {
         try {

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Create our title object                                 */
            /*                                                           */
            /*-----------------------------------------------------------*/
            title = new SymptomTitle ( newTitle ) ;            

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Assign it's variables                                   */
            /*                                                           */
            /*-----------------------------------------------------------*/
            title.setDocClass ( (TypeDocClassRec) TypeList.getInstance().objectFromInd ( TypeList.DOCCLASS_IBM_CONFIDENTIAL,
                                                                                         TypeList.TYPE_DOCCLASS ) ) ;
            title.setLanguage ( (TypeLanguageRec) TypeList.getInstance().objectFromInd ( PropertySystem.getInt ( PropertySystem.PROPERTY_LANGUAGE ),
                                                                                         TypeList.TYPE_LANGUAGE ) ) ;
            title.setCountryList ( UserSystem.getUserCountries ( UserSystem.getUserId() ) ) ;                 

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Add this title to our list                              */
            /*                                                           */
            /*-----------------------------------------------------------*/
            if ( titles == null )
               titles = new Vector ( 1, 1 ) ;
            titles.insertElementAt ( title, 0 ) ;                         

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Refresh our data to this new title                      */
            /*                                                           */
            /*-----------------------------------------------------------*/
            refreshTitles() ;
            lb_TITLES.setSelectedValue ( title, true ) ;
            refreshData ( title ) ;

         } catch ( Exception e ) {
            LogSystem.log ( 1, e ) ;
         }
      }
      return( title ) ;
   }





   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will be called when an action
    *  is performed and we need to know about it
    *  
    *
    *  @param e The ActionEvent
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {   

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_ADD_TITLE                                            */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( e.getSource() == pb_ADD_TITLE )
         refreshData ( addTitle ( GUISystem.getParentDefWin ( this ) ) ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_REMOVE_TITLE                                         */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_REMOVE_TITLE ) {

         if ( currentTitle != null ) {
            currentTitle.updateRecStatus ( QITRec.REC_DELETE ) ;
            currentTitle = null ;
            refreshTitles() ;
         }
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_SET_DEFAULT                                          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_SET_DEFAULT )
         setDefault() ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_TITLE_UP                                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_TITLE_UP ) {
         if ( currentTitle != null )
            moveTitleUp () ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_TITLE_DOWN                                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_TITLE_DOWN ) {
         if ( currentTitle != null )
            moveTitleDown() ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_ADD_KEYWORDS                                         */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_ADD_KEYWORDS ) {
         SymptomKeywordDlg dlg = new SymptomKeywordDlg ( GUISystem.getParentDefWin ( this ) ) ;

         saveData() ;

         if ( dlg.getResults() != dlg.CANCEL ) {

            switch ( dlg.getResults() ) {
               case dlg.UPDATE_ALL :
                  addKeywords ( dlg.getKeywords(), titles ) ;
                  break ;

               case dlg.UPDATE_SELECTED :
                  Object[] selectedObjects = lb_TITLES.getSelectedValues() ;
                  Vector   vec             = new Vector ( 10 )  ;

                  if ( selectedObjects != null ) {
                     for ( int i = 0; i < selectedObjects.length; i++ )
                        vec.addElement ( selectedObjects[i] ) ;

                     addKeywords ( dlg.getKeywords(), vec ) ;
                  }
                  break ;
            }
         }
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_REMOVE_KEYWORDS                                      */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_REMOVE_KEYWORDS ) {
         SymptomKeywordDlg dlg = new SymptomKeywordDlg ( GUISystem.getParentDefWin ( this ), mle_KEYWORDS.getSelectedText() ) ;

         saveData() ;

         if ( dlg.getResults() != dlg.CANCEL ) {
            switch ( dlg.getResults() ) {
               case dlg.UPDATE_ALL :
                  removeKeywords ( dlg.getKeywords(), titles ) ;
                  break ;

               case dlg.UPDATE_SELECTED :
                  Object[] selectedObjects = lb_TITLES.getSelectedValues() ;
                  Vector   vec             = new Vector ( 10 )  ;

                  if ( selectedObjects != null ) {
                     for ( int i = 0; i < selectedObjects.length; i++ )
                        vec.addElement ( selectedObjects[i] ) ;

                     removeKeywords ( dlg.getKeywords(), vec ) ;
                  }
                  break ;

            }
         }
      }


   } /* actionPerformed  */




   /*------------------------------------------------------------*/
   /* refreshTitles
    */
   /**
    *    This method will refresh all of our titles
    *  in the title drop down
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void refreshTitles () {
      Vector validTitles = QuestUtil.getValidData ( titles ) ;                                     

      listModel.removeAllElements() ;
      if ( validTitles != null ) {

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   First, make sure all of them have their normal output   */
         /*                                                           */
         /*-----------------------------------------------------------*/
         for ( int i =0 ;i < validTitles.size(); i++ )
            ((SymptomTitle)validTitles.elementAt(i)).setToStringType ( SymptomTitle.TEXT ) ;


         getDefaultTitle() ;

         if ( defaultTitle != null )
            defaultTitle.setToStringType ( SymptomTitle.HTML ) ;

         if ( validTitles != null ) {
            int i    = 0 ;
            int size = validTitles.size() ;

            while ( i < size ) {
               listModel.add ( listModel.getSize(), validTitles.elementAt(i)   ) ;
               i++ ;
            }
         }
      }

      ef_TITLE.setText ( "" ) ;
      revalidate() ;
   }




   /*------------------------------------------------------------*/
   /* setDefault
    */
   /**
    *    This method will ask the user to set the default
    *  title
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void setDefault ( ) {
      if ( currentTitle != getDefaultTitle() ) {
         titles.removeElement ( currentTitle ) ;
         titles.addElement ( currentTitle );
         defaultTitle = currentTitle ;
         refreshTitles() ;
      }

   }




   /*------------------------------------------------------------*/
   /* setTitles
    */
   /**
    *    This method will set the vector of titles that
    *  we are using
    *  
    *
    *  @param titles A vector of titles
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setTitles ( Vector titles ) {
      if ( ( titles != null ) && ( titles.size() > 0 ) ) {
         this.titles = titles ;
         getDefaultTitle() ;
         refreshTitles() ;
      }
   }




   /*------------------------------------------------------------*/
   /* valueChanged
    */
   /**
    *    this method will be called when the user has
    *  selected another title
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void valueChanged ( ListSelectionEvent e ) {
      if ( !e.getValueIsAdjusting() ) {
         if ( currentTitle != null ) {
            saveData() ;
         }
         currentTitle = (SymptomTitle)lb_TITLES.getSelectedValue() ;
         new Thread ( this ).start() ;
      }
   }




   /*------------------------------------------------------------*/
   /* keyTyped
    */
   /**
    *    We have subclassed this method so that
    *  we will automagically update the title in both
    *  the entry field and in theSymptomTitle object
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void keyTyped ( KeyEvent e ) {
      saveTitle() ;
   }
   public void keyPressed ( KeyEvent e ) {
      saveTitle() ;
   }
   public void keyReleased ( KeyEvent e ) {
      saveTitle() ;
   }




   /*------------------------------------------------------------*/
   /* saveTitle
    */
   /**
    *    This method will update the title in the
    * SymptomTitle object with what is entered on the command
    *  line
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void saveTitle () {
      if ( currentTitle != null ) {
         if ( currentTitle == defaultTitle )
            fireChangedEvent () ;

         currentTitle.setTitle ( ef_TITLE.getText() ) ;
         lb_TITLES.repaint() ;
      }
   }



   /*------------------------------------------------------------*/
   /* saveData
    */
   /**
    *    This method will save the data on the
    *  screen to the title
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   protected boolean saveData () {

      if ( currentTitle != null ) {

         currentTitle.setDocClass ( (TypeDocClassRec) cb_DOC_CLASS.getSelectedItem() ) ;
         currentTitle.setKeywords ( mle_KEYWORDS.getText() ) ;
         currentTitle.setCountryList ( countryPanel.getCountryList() ) ;

      }

      return( true ) ;
   }





   /*------------------------------------------------------------*/
   /* run
    */
   /**
    *    This thread currently only refreshes our data
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void run () {
      fireChangedEvent() ;
      refreshData ( currentTitle ) ;
   }


   /*------------------------------------------------------------*/
   /* getPreferredSize()
    */
   /**
    *    This method will return the preferred 
    *  size of this panel
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Dimension
    *//*---------------------------------------------------------*/
   public Dimension getPreferredSize() {
      return( prefSize ) ;
   }




   /*------------------------------------------------------------*/
   /* getMinimumSize
    */
   /**
    *    This method will return our minimum size. Actually
    *  this method returns whatever getPreferredSize
    *  returns
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Dimension
    *//*---------------------------------------------------------*/
   public Dimension getMinimumSize () {
      return( getPreferredSize() ) ;
   }




   /*------------------------------------------------------------*/
   /* getTitleVec
    */
   /**
    *    This method will return the tile
    *  vector that is being displayed
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   protected Vector getTitleVec () {
      return( titles ) ;
   }




   /*------------------------------------------------------------*/
   /* moveTitleUp
    */
   /**
    *    This method will move a title in the
    *  title list up a level in the sort order
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void moveTitleUp ( ) {
      moveTitleInList ( false ) ;
   }




   /*------------------------------------------------------------*/
   /* moveTitleDown
    */
   /**
    *    This method will move a title down
    *  in the list
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void moveTitleDown ( ) {
      moveTitleInList ( true ) ;
   }




   /*------------------------------------------------------------*/
   /* moveTitleFromList
    */
   /**
    *    This method will simply move the title
    *  in the container. This will not have an effect
    *  of the title object yet
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return int The position it was at before it was moved
    *//*---------------------------------------------------------*/
   public void moveTitleInList ( boolean down ) {
      int    rc     = titles.indexOf ( currentTitle ) ;                         

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Take the default title out for now                      */
      /*                                                           */
      /*-----------------------------------------------------------*/
      //titles.removeElement ( defaultTitle ) ;

      if ( down )
         rc++ ;
      else
         rc-- ;

      if ( ( rc >= 0 ) && ( rc < (titles.size()-1) ) ) {
         int i      = 0 ;
         int length = titles.size() ;

         titles.removeElement ( currentTitle ) ;
         titles.insertElementAt ( currentTitle, rc ) ;

         listModel.removeElement ( currentTitle ) ;
         listModel.add ( rc, currentTitle ) ;

         lb_TITLES.setSelectedValue ( currentTitle, true ) ;
      }


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Now, put the default back in                            */
      /*                                                           */
      /*-----------------------------------------------------------*/
      //titles.addElement ( defaultTitle ) ;
      //listModel.add ( listModel.getSize(), defaultTitle ) ;

   }









   /*------------------------------------------------------------*/
   /* spellCheck
    */
   /**
    *    This method will spell check all titles on this
    *  panel
    *  
    *
    *  @param tabbedPane This can be null. If it is not null, and there
    *                    are misspelled words, this method will turn the
    *                    tabbed pane's page to this panel.
    *  @param None
    *  @param None
    *
    *  @return TRUE if there are no misspelled words
    *//*---------------------------------------------------------*/
   protected boolean spellCheck ( JTabbedPane tabbedPane, SpellPanel spellPanel ) {
      boolean         mispelled    = false ;

      if ( titles.size() > 0 ) {

         this.tabbedPane = tabbedPane ;
         this.spellPanel = spellPanel ;

         /*-------------------------------------------------------------*/
         /*                                                             */
         /*   Add ourselves as a listener so we get notified of status  */
         /*                                                             */
         /*-------------------------------------------------------------*/
         spellPanel.addSpellPanelListener ( this ) ;

         spellIndex = 0 ;
         spellCheck ( (SymptomTitle)titles.elementAt(spellIndex) ) ;
      } else
         fireSpellCheckEvent ( false ) ;


      return( mispelled ) ;
   }





   /*------------------------------------------------------------*/
   /* spellCheck
    */
   /**
    *    This method will spell check an entire Title
    *  
    *  
    *
    *  @param title The title object to spell check
    *  @param spellToolkit The already created JSpellToolkit
    *  @param None
    *
    *  @return TRUE if no misspelled words
    *//*---------------------------------------------------------*/
   private boolean spellCheck ( SymptomTitle title ) {
      boolean         rc           = false ;

      spellCheckTitle = title ;
      spellPanel.spellCheck ( spellCheckTitle.getTitle() ) ;
      return( rc ) ;
   }





   /*------------------------------------------------------------*/
   /* spellCheckComplete
    */
   /**
    *    This method will be called once the SpellPanel
    *  is done checking a title.
    *  
    *
    *  @param errorsFound TRUE if any errors were encountered
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void spellCheckComplete ( boolean errorsFound ) {             

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Update the spell Index                                  */
      /*                                                           */
      /*-----------------------------------------------------------*/
      spellIndex++ ;                                               

      /*------------------------------------------------------------*/
      /*                                                            */
      /*   If we have no more titles to check, notify the listeners */
      /*                                                            */
      /*------------------------------------------------------------*/
      if ( spellIndex >= (titles.size()-1) ) { // subtract 1 from .size() so we don't check the default
         spellPanel.removeSpellPanelListener ( this ) ;
         fireSpellCheckEvent ( errorsFound ) ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Otherwise, start spell checking the next title          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else {
         spellCheck ( (SymptomTitle)titles.elementAt ( spellIndex ) ) ;
      }
   }





   /*------------------------------------------------------------*/
   /* spellCheckWord
    */
   /**
    *    This method will be called when the SpellPanel
    *  has encountered an error
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void spellCheckWord ( String word, int startPos, int endPos ) {

      tabbedPane.setSelectedComponent ( WinUtil.getParentJScrollPane ( this ) ) ;

      saveData() ;
      currentTitle = spellCheckTitle ;
      refreshData ( currentTitle ) ;
      lb_TITLES.setSelectedValue ( currentTitle, true ) ;
      ef_TITLE.setSelectionStart ( startPos ) ;
      ef_TITLE.setSelectionEnd   ( endPos ) ;
      revalidate() ;
   }




   /*------------------------------------------------------------*/
   /* replaceWord
    */
   /**
    *    This method will replace the word that is passed
    *  in (oldWord) with the newWord passed in. This means
    *  that the user has corrected the type-o
    *
    *  @param oldWord What the word used to be
    *  @param newWord What the new word is
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void replaceWord ( String oldWord, String newWord, int startIndex ) {
      int startPos = ef_TITLE.getSelectionStart() ;
      String newTitle = spellCheckTitle.getTitle() ;

      newTitle = newTitle.substring ( 0, startIndex )+newWord+newTitle.substring ( startIndex+oldWord.length() ) ;

      spellCheckTitle.setTitle ( newTitle ) ;

      refreshData ( spellCheckTitle ) ;

      revalidate() ;
   }




   /*------------------------------------------------------------*/
   /* setBrandInd
    */
   /**
    *    This method will set what brand the symptom
    *  we are editing titles for is. This has direct
    *  effect on the 'setDefaultTitle' button as the user
    *  must be a BPM of this brand to be able to set the
    *  default title
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setBrandInd ( int brandInd ) {
      this.brandInd = brandInd ;
      pb_SET_DEFAULT.setEnabled ( UserSystem.getLoggedUserRec().isBPM ( brandInd ) ) ;
   }




   /*------------------------------------------------------------*/
   /* addKeywords
    */
   /**
    *    This method will add the keywords passed in
    *  to all of the titles in the vector passed, and will
    *  add the keywords to the MLE_KEYWORD control
    *
    *  @param keywords The keywords to add
    *  @param titleVec The Vector holding the titles to add keywords to
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void addKeywords ( String keywords, Vector titleVec ) {
      int             i               = 0 ;
      int             size            = titleVec.size() ;
      String          currentKeywords = null ; 
      Vector          keywordVec      = new Vector() ;
      StringTokenizer strtok          = new StringTokenizer ( keywords, " " ) ;
      int             k               = 0 ;
      int             keywordVecSize  = 0 ;
      boolean         update          = false ;

      while ( strtok.hasMoreTokens() )
         keywordVec.addElement ( strtok.nextToken().trim() ) ;

      keywordVecSize = keywordVec.size() ;                        

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Update all of the selected values                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      while ( i < size ) {

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Only allow BPMs of this brand to update the default     */
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( titleVec.elementAt(i) == defaultTitle ) {
            update = UserSystem.getLoggedUserRec().isBPM ( brandInd ) ;
         } else
            update = true ;          

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   If update, continue                                     */
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( update ) {
            currentKeywords = ((SymptomTitle)titleVec.elementAt(i)).getKeywords().trim() ;

            k=0;
            while ( k < keywordVecSize ) {
               if ( currentKeywords.indexOf ( keywordVec.elementAt(k).toString() ) == -1 )
                  currentKeywords+=" "+keywordVec.elementAt(k) ;
               k++ ;
            } /* while  */

            ((SymptomTitle)titleVec.elementAt(i)).setKeywords ( currentKeywords ) ;

            i++ ;
         } /* update  */

      } /* while  */

      refreshData ( currentTitle ) ;
   }

   /*------------------------------------------------------------*/
   /* removeKeywords
    */
   /**
    *    This method will remove the keywords passed in
    *  to all of the titles in the vector passed, and will
    *  remove the keywords from the MLE_KEYWORD control
    *
    *  @param keywords The keywords to remove
    *  @param titleVec The Vector holding the titles to remove keywords from
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void removeKeywords ( String keywords, Vector titleVec ) {
      int             i               = 0 ;
      int             size            = titleVec.size() ;
      String          currentKeywords = null ; 
      Vector          keywordVec      = new Vector() ;
      StringTokenizer strtok          = new StringTokenizer ( keywords, " " ) ;
      int             k               = 0 ;
      int             keywordVecSize  = 0 ;
      boolean         update          = false ;

      while ( strtok.hasMoreTokens() )
         keywordVec.addElement ( strtok.nextToken().trim() ) ;

      keywordVecSize = keywordVec.size() ;                        

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Update all of the selected values                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      while ( i < size ) {

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Only allow BPMs of this brand to update the default     */
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( titleVec.elementAt(i) == defaultTitle ) {
            update = UserSystem.getLoggedUserRec().isBPM ( brandInd ) ;
         } else
            update = true ;          

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   If update, continue                                     */
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( update ) {
            currentKeywords = ((SymptomTitle)titleVec.elementAt(i)).getKeywords().trim() ;

            k=0;
            while ( k < keywordVecSize ) {
               if ( currentKeywords.indexOf ( keywordVec.elementAt(k).toString() ) >= 0 )
                  currentKeywords = Text.replaceAllStrInStr ( currentKeywords, keywordVec.elementAt(k).toString(), "" ) ;
               k++ ;
            } /* while  */

            ((SymptomTitle)titleVec.elementAt(i)).setKeywords ( currentKeywords.trim() ) ;

            i++ ;
         } /* update  */

      } /* while  */

      refreshData ( currentTitle ) ;
   }





   /*------------------------------------------------------------*/
   /* getCountrySelectPanel
    */
   /**
    *    This method will return the instance of
    *  CountrySelectPanel that we are using
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return CountrySelectPanel
    *//*---------------------------------------------------------*/
   protected CountrySelectPanel getCountrySelectPanel () {
      return( countryPanel ) ;
   }



   /*------------------------------------------------------------*/
   /* removeCountryFromPanel
    */
   /**
    *    This method will not only remove the country
    *  passed in from the panel, but it will also remove
    *  the country from all titles in this panel
    *
    *  @param countryRec The TypeCountryCodeRec to remove
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   protected void removeCountryFromPanel ( TypeCountryCodeRec countryRec ) {                                

      saveData() ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Remove the country from all of our titles               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( ( titles != null ) && ( titles.size() > 0 ) ) {
         int    i              = 0 ;
         int    size           = titles.size() ;
         Vector titleCountries = null ;

         while ( i < size ) {
            titleCountries = ((SymptomTitle)titles.elementAt(i)).getCountryList() ;
            titleCountries.removeElement ( countryRec ) ;
            ((SymptomTitle)titles.elementAt(i)).setCountryList ( titleCountries ) ;
            i++ ;
         } /* while  */
      } /* if  */

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Now, refresh our display                                */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( currentTitle != null )
         countryPanel.setCountryList ( currentTitle.getCountryList() ) ;

   } /* removeCountryFromPanel  */

} /* SymptomTitleEditPanel */
