package com.ibm.nzna.projects.qit.avalon.gui ;                                   
/*-----------------------------------------------------------*/
/*   NewAvalonObjectAddtlInfoStep                            */
/*                                                           */
/*   Description:                                            */
/*      Source code for: NewAvalonObjectAddtlInfoStep        */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import javax.swing.* ;
import java.awt.* ;
import java.awt.event.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.qit.avalon.base.* ;
import com.ibm.nzna.projects.common.quest.oa.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.shared.gui.* ;        
import com.ibm.nzna.shared.gui.wizard.* ;
/**
 * This step of the NewAvalonObjectWizard asks the user for a default 
 * additional information
 *
 *
 * @version 1.0, 4/27/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   NewAvalonObjectAddtlInfoStep                            */
/*                                                           */
/*-----------------------------------------------------------*/
public class NewAvalonObjectAddtlInfoStep extends WizardStep implements ActionListener, AvalonConst, AppConst {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private JLabel            st_HELP_TEXT      = null ;
   private ExtWordProcButton pb_LAUNCH         = null ;
   private Browser           preview           = null ;



   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will create and initialize our step
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public NewAvalonObjectAddtlInfoStep () {     
      try {
         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Create our GUI                                          */
         /*                                                           */
         /*-----------------------------------------------------------*/
         st_HELP_TEXT = new JLabel ( Str.getStr ( STR_NEW_AVALON_OBJECT_ADDTL_INFO_HELP ) ) ;
         preview      = new Browser () ;
         pb_LAUNCH    = new ExtWordProcButton ( ExtWordProcButton.DBUTTON ) ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Adjust Properties                                       */
         /*                                                           */
         /*-----------------------------------------------------------*/
         st_HELP_TEXT.setVerticalAlignment ( SwingConstants.TOP ) ;
         preview.setBorder ( GUISystem.loweredBorder ) ;    
         pb_LAUNCH.setBody ( "<html><body> </body></html>" ) ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Add listeners                                           */
         /*                                                           */
         /*-----------------------------------------------------------*/
         pb_LAUNCH.addActionListener ( this ) ;


         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Add our controls                                        */
         /*                                                           */
         /*-----------------------------------------------------------*/
         setLayout ( null ) ;
         add ( st_HELP_TEXT ) ;
         add ( pb_LAUNCH ) ;
         add ( preview ) ;

         preview.setPageContent ( pb_LAUNCH.getBody() ) ;

      } catch ( Exception e ) {
      }
   }




   /*------------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will lay out and position our
    *  controls
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size           = getSize() ;
      int       y              = 0 ;
      Dimension launchPrefSize = pb_LAUNCH.getPreferredSize() ;
      int       rowHeight      = GUISystem.getRowHeight() ;

      st_HELP_TEXT.setBounds ( 0, 0, size.width, rowHeight*4 ) ;
      y+=rowHeight*4 ;

      pb_LAUNCH.setBounds ( 0, y, launchPrefSize.width, launchPrefSize.height ) ;
      y+=rowHeight+5 ;

      preview.setBounds ( 0, y, size.width, size.height-y-5 ) ;
   }




   /*------------------------------------------------------------*/
   /* refreshInfo
    */
   /**
    *    This method will refresh our data
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void refreshInfo () {
      pb_LAUNCH.requestFocus() ;
   }




   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will be called when objects
    *  fire an action against us
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {
      if ( e.getSource() == pb_LAUNCH ) {
         if ( !pb_LAUNCH.getLaunched() )
            preview.setPageContent ( pb_LAUNCH.getBody() ) ;
      }
   }



   /*------------------------------------------------------------*/
   /* getAddtlInfo
    */
   /**
    *    This method will return a string representation
    *  of the HTML that the user has entered as
    *  the additional information
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public String getAddtlInfo () {
      if ( pb_LAUNCH.getHasChanged() )
         return( pb_LAUNCH.getBody() ) ;

      return ( "" ) ;

   }


   /*------------------------------------------------------------*/
   /* saveInfo
    */
   /**
    *    This method will save our info. We will
    *  return NULL if we have no additional information
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean saveInfo () {
      if ( pb_LAUNCH.getLaunched() ) {
         GUISystem.printBox ( GUISystem.getParentDefWin ( this ), STR_INFO, STR_MUST_REIMPORT_BODY ) ;
         return ( false ) ;
      }
      
      return( true ) ;
   }





   /*------------------------------------------------------------*/
   /* getTitle
    */
   /**
    *    This method will return out title
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public String getTitle () {
      return ( Str.getStr ( STR_ADDTL_INFO_WIZARD_TITLE ) ) ;
   }
} /* NewAvalonObjectAddtlInfoStep */
