package com.ibm.nzna.projects.qit.avalon.gui ;            
/*-----------------------------------------------------------*/
/*   NewAvalonObjectDlg                                      */
/*                                                           */
/*   Description:                                            */
/*      Source code for: NewAvalonObjectDlg                  */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.qit.avalon.base.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.util.* ;
import javax.swing.* ;
import java.awt.* ;
import java.awt.event.* ;     
/**
 * This dialog will prompt the user to select a object type. Currently 
 *
 *
 * @version 1.0, 4/14/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   NewAvalonObjectDlg                                      */
/*                                                           */
/*-----------------------------------------------------------*/
public class NewAvalonObjectDlg extends JDialog implements ActionListener, AvalonConst, AppConst {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private GUI Members                                     */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private NavList      buttonList     = null ;
   private DButton      pb_QUESTION    = null ;
   private DButton      pb_ACTION      = null ;
   private DButton      pb_SYMPTOM     = null ;
   private DButton      pb_LINK        = null ;
   private DButton      pb_LINKGROUP   = null ;
   private DButton      pb_CANCEL      = null ;
   private JTitle       st_TITLE       = null ;
   private ButtonPanel  buttonPanel    = null ;      


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private int    rc     = 0;



   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This is the only constructor and it will return
    *  immediatly after being called. Please call 'getResult'
    *  to show the window and wait for user input
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public NewAvalonObjectDlg ( AppDefaultWin parent ) {
      super ( parent, Str.getStr ( STR_NEW ), true ) ;          

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create our controls                                     */
      /*                                                           */
      /*-----------------------------------------------------------*/
      buttonList        = new NavList () ;
      buttonPanel       = new ButtonPanel () ;
      pb_QUESTION       = new DButton ( Str.getStr ( STR_QUESTION ),   ImageSystem.getImageIcon ( this, ImageSystem.QUESTION_LARGE ) ) ;
      pb_ACTION         = new DButton ( Str.getStr ( STR_ACTION ),     ImageSystem.getImageIcon ( this, ImageSystem.ACTION_LARGE ) ) ;
      pb_SYMPTOM        = new DButton ( Str.getStr ( STR_SYMPTOM ),    ImageSystem.getImageIcon ( this, ImageSystem.SYMPTOM_LARGE ) ) ;
      pb_LINK           = new DButton ( Str.getStr ( STR_LINK ),       ImageSystem.getImageIcon ( this, ImageSystem.LINK_LARGE ) ) ;
      pb_LINKGROUP      = new DButton ( Str.getStr ( STR_LINK_GROUP ), ImageSystem.getImageIcon ( this, ImageSystem.LINK_GROUP_LARGE ) ) ;
      st_TITLE          = new JTitle  ( Str.getStr ( STR_NEW_AVALON_OBJECT ) ) ;
      pb_CANCEL         = new DButton ( Str.getStr ( STR_CANCEL ) ) ;        


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      GUISystem.setPreferredButton ( pb_CANCEL ) ;
      st_TITLE.setFont ( FontSystem.smallTitleFont ) ;       
      buttonList.setBorder ( GUISystem.loweredBorder ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add Action Listeners                                    */           
      /*                                                           */
      /*-----------------------------------------------------------*/
      pb_QUESTION.addActionListener  ( this ) ;
      pb_ACTION.addActionListener    ( this ) ;
      pb_SYMPTOM.addActionListener   ( this ) ;
      pb_LINK.addActionListener      ( this ) ;
      pb_LINKGROUP.addActionListener ( this ) ;
      pb_CANCEL.addActionListener    ( this ) ;

      

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add our controls                                        */
      /*                                                           */
      /*-----------------------------------------------------------*/
      buttonPanel.add ( pb_CANCEL ) ;
      buttonList.add ( st_TITLE ) ;
      buttonList.add ( pb_SYMPTOM ) ;
      buttonList.add ( pb_QUESTION ) ;
      buttonList.add ( pb_ACTION ) ;
      buttonList.add ( pb_LINK ) ;   
      buttonList.add ( pb_LINKGROUP ) ;
       
      getContentPane().setLayout ( null ) ;
      getContentPane().add ( buttonList ) ;
      getContentPane().add ( buttonPanel ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Set our window properties                               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setSize ( 300, 300 ) ;
      WinUtil.centerChildInParent ( this, parent ) ;


   } /* Constructor */





   /*------------------------------------------------------------*/
   /* getResult
    */
   /**
    *    This method will return one of the NEW_XXX
    *  values defined in this class. A NEW_NONE
    *  will be returned if the user cancels the dialog
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return int
    *//*---------------------------------------------------------*/
   public int getResult () {
      setVisible ( true ) ;

      return( rc ) ;
   }





   /*------------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will lay out and position our
    *  controls
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size = getSize() ;

      super.doLayout() ;
      buttonList.setBounds ( 15, 5, size.width-35, size.height-65 ) ;
      buttonPanel.setBounds ( 10, size.height-55, size.width-20, 25 ) ;
   }




   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will be called when an action
    *  event is fired on us
    *  
    *
    *  @param e The event
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   PB_SYMPTOM                                              */ 
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( e.getSource() == pb_SYMPTOM ) 
         rc = AVALON_SYMPTOM ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   PB_QUESTION                                             */  
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_QUESTION ) 
         rc = AVALON_QUESTION ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   PB_ACTION                                               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_ACTION )
         rc = AVALON_ACTION ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   PB_LINK                                                 */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_LINK ) 
         rc = AVALON_LINK ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   PB_LINKGROUP                                            */   
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_LINKGROUP )
         rc = AVALON_LINK_GROUP ;

      else
         rc = 0 ;

      dispose() ;

   } /* actionPerformed */


} /* NewAvalonObjectDlg */
