package com.ibm.nzna.projects.qit.avalon.gui ;                                   
/*-----------------------------------------------------------*/
/*   SelectOASearchHistoryRec                                */
/*                                                           */
/*   Description:                                            */
/*      Source code for: SelectOASearchHistoryRec            */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.projects.qit.avalon.gui.selectview.* ;
/**
 * This record contains all information on a previous search in the SelectOADlg 
 *
 *
 * @version 1.0, 10/26/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   SelectOASearchHistoryRec                                */
/*                                                           */
/*-----------------------------------------------------------*/
public class SelectOASearchHistoryRec extends Object implements java.io.Serializable {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private String       search       = null ;
   private String       searchOn     = null ;
   private int          brandInd     = 0 ;
   private SelectOAView selectOAView = null ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public SelectOASearchHistoryRec ( String search, int brandInd, String searchOn, SelectOAView selectOAView ) {
      System.out.println ( "Creating new Search HIstory with search:"+search ) ;
      this.search       = search ;
      this.brandInd     = brandInd ;
      this.searchOn     = searchOn ;
      this.selectOAView = selectOAView ;
   }




   /*------------------------------------------------------------*/
   /* getSearch
    */
   /**
    *    This method will return the search. This is the text
    * that the user entered in the search
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public String getSearch ( ) {
      return( search ) ;
   }




   /*------------------------------------------------------------*/
   /* getSearchOn
    */
   /**
    *    This method will return what field the user
    *  searched on (Title, Indicator etc..)
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public String getSearchOn () {
      return( searchOn ) ;
   }




   /*------------------------------------------------------------*/
   /* getBrandInd
    */
   /**
    *    This method will return the brand indicator
    *  that was searched on
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return int
    *//*---------------------------------------------------------*/
   public int getBrandInd () {
      return( brandInd ) ;
   }




   /*------------------------------------------------------------*/
   /* getSelectOAView
    */
   /**
    *    This method will return the SelectOAView that
    *  was searched on
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return SelectOAView
    *//*---------------------------------------------------------*/
   public SelectOAView getSelectOAView () {
      return( selectOAView ) ;
   }




   /*------------------------------------------------------------*/
   /* toString
    */
   /**
    *    This method returns what the user entered
    *  in to search on
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String toString () {
      return( search ) ;
   }




   /*------------------------------------------------------------*/
   /* equals
    */
   /**
    *    This method will determine if this object
    *  is equal to another object passed in. If the object
    *  passed in is a SelectOASearchHistoryRec then it will
    *  compare all properties (Brand, Search etc..). If a
    *  String is passed, only the 'toString()' method is called
    *  for the compare
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return TRUE if the items match
    *//*---------------------------------------------------------*/
   public boolean equals ( Object object ) {
      boolean rc = false ;

      if ( object instanceof String ) 
         rc = ((String)object).equals ( toString() ) ;

      else if ( object instanceof SelectOASearchHistoryRec ) {
         SelectOASearchHistoryRec compare = (SelectOASearchHistoryRec) object ;

         rc = ( ( compare.search.equals ( search ) ) && 
                ( compare.searchOn.equals ( searchOn ) ) &&
                ( compare.selectOAView == selectOAView ) &&
                ( compare.brandInd == brandInd ) ) ;
      }

      return ( rc ) ;
   }

} /* SelectOASearchHistoryRec */
