package com.ibm.nzna.projects.qit.avalon.gui.selectview ;    
/*-----------------------------------------------------------*/
/*   SelectOAView                                            */
/*                                                           */
/*   Description:                                            */
/*      Source code for: SelectOAView                        */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
/**
 * This interface defines the methods needed for a view to be in the SelectOADlg 
 *
 *
 * @version 1.0, 4/19/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   SelectOAView                                            */
/*                                                           */
/*-----------------------------------------------------------*/
public interface SelectOAView  {




   /*------------------------------------------------------------*/
   /* getSearchArg
    */
   /**
    *    This method should return the different
    *  arguments that this view is able to search on
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Vector of Strings
    *//*---------------------------------------------------------*/
   public abstract Vector getSearchArg () ;




   /*------------------------------------------------------------*/
   /* getSearchArgDisplay
    */
   /**
    *    This method should return one of the
    *  predefined values in SelectOADlg that tell
    *  what controls should be displayed. Currently these
    *  values are:
    *  SelectOADlg.ENTRYFIELD
    *  SelectOADlg.COMBO_BOX
    *  SelectOADlg.USER_ENTRYFIELD
    *
    *  @param searchArg The Search argument to return with
    *  @param None
    *  @param None
    *
    *  @return int
    *//*---------------------------------------------------------*/
   public abstract int getSearchArgDisplay ( String searchArg ) ;





   /*------------------------------------------------------------*/
   /* getData
    */
   /**
    *    This method should return the data from
    *  the view specified.
    *  
    *
    *  @param searchArg The Search Argument that is needed
    *  @param qualifier The qualifier to use in the search
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public abstract Vector getData ( String searchArg, String qualifier, String data, int brandInd ) ;




   /*------------------------------------------------------------*/
   /* getColumnHeadings
    */
   /**
    *    This method should return the column headings
    *  needed to display the view in a MultiList
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String[]
    *//*---------------------------------------------------------*/
   public abstract String[] getColumnHeadings () ;
} /* SelectOAView */
