package com.ibm.nzna.projects.qit.avalon.oanav ;
/*-----------------------------------------------------------*/
/*   OANavPanel                                              */
/*                                                           */
/*   Description:                                            */
/*      Source code for: OANavPanel                          */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import javax.swing.event.* ;
import javax.swing.tree.* ;
import java.util.* ;
import com.ibm.nzna.projects.qit.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.bookmark.* ;
import com.ibm.nzna.projects.qit.customview.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.qit.print.* ;
import com.ibm.nzna.projects.qit.exporter.* ;
import com.ibm.nzna.projects.qit.avalon.* ;
import com.ibm.nzna.projects.qit.avalon.gui.* ;
import com.ibm.nzna.projects.qit.avalon.sql.* ;
import com.ibm.nzna.projects.qit.avalon.base.* ;
import com.ibm.nzna.projects.qit.avalon.editors.* ;
import com.ibm.nzna.projects.qit.avalon.cache.* ;
import com.ibm.nzna.projects.qit.avalon.oanav.views.* ;
import com.ibm.nzna.projects.qit.avalon.oanav.searchreplace.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.quest.oa.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.pom.* ;
import com.ibm.nzna.shared.util.* ;
/**
 * This is the Online Assistant Navigator. It allows a user 
 * traverse through the Online Assistant Objects in their
 * Draft, Active, Archived and Orphaned forms.
 *
 * @version 1.0, 3/30/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   OANavPanel                                              */
/*                                                           */
/*-----------------------------------------------------------*/
public class OANavPanel extends JPanel implements OASort, PrintPanel, QuestPanel, SelectOAListener, TreeExpansionListener, TreeSelectionListener, ActionListener, AvalonConst, AppConst, CustomViewDlgListener {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private DefaultTreeModel       treeModel              = null ;
   private OANavNavPanel          defaultNavPanel        = null ;
   private JScrollPane            scr_DATA               = null ;
   private Browser                previewBrowser         = null ;
   private JTitle                 st_TITLE               = null ;
   private DTree                  cnr_DATA               = null ;
   private JSplitPane             splitPane              = null ;
   private String                 currentView            = null ;  // The view currently showing
   private CustomView             currentCustomView      = null ;  // The current custom view being shown
   private DetailTreeCellRenderer treeRenderer           = null ;  // The tree renderer for the view
   private TypeBrandRec           currentBrandRec        = null ;  // The brand for the view being displayed
   private JToolBar               toolBar                = null ;  // Our personal tool bar
   private ToolBarButton          pb_FIND                = null ;  // Kicks off the SelectOADlg
   private ToolBarButton          pb_PREVIEW             = null ;  // Shows/Hides Preview
   private ToolBarButton          pb_CUSTOM              = null ;  // Allows editing/create of custom views
   private ToolBarButton          pb_EXPORT              = null ;  // Allows exporting the view being seen
   private ToolBarButton          pb_WIZARD              = null ;  // Allows the user to change 1 field in an object
   private ActionButton           pb_CLOSE               = null ;  // Closes this panel
   private ActionButton           pb_NEW                 = null ;  // Creates a new Object
   private ActionButton           pb_EDIT                = null ;  // Edits the selected Object
   private ActionButton           pb_DELETE              = null ;  // Deletes the selected Object
   private ActionButton           pb_VALIDATE            = null ;  // Validates a Draft or Active Symptom
   private ActionButton           pb_COMPLETE            = null ;  // Complete
   private JMenu                  MNU_SORT               = null ;
   private JMenuItem              MNU_ASCENDING          = null ;
   private JRadioButtonMenuItem   MNU_DESCENDING         = null ;
   private JRadioButtonMenuItem   MNU_DBUSER             = null ;
   private JRadioButtonMenuItem   MNU_CHANGEDTIME        = null ;
   private JRadioButtonMenuItem   MNU_TITLE              = null ;
   private JRadioButtonMenuItem   MNU_DOCCLASS           = null ;
   private JRadioButtonMenuItem   MNU_INDICATOR          = null ;
   private JLabel                 st_KEY                 = null ;


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private AppDefaultWin parentWin = null ;
   private int           sort      = 0 ;
   private String        lastSQL   = null ;


   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will initialize this panel
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return TRUE if initialized, FALSE if not
    *//*---------------------------------------------------------*/
   public boolean initialize () {                                 
      ButtonGroup sortGroup = new ButtonGroup () ;
      ButtonGroup ascGroup  = new ButtonGroup () ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create and initialize our Default NavPanel              */
      /*                                                           */
      /*-----------------------------------------------------------*/
      defaultNavPanel = new OANavNavPanel ( this ) ;     

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create our GUI                                          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      st_TITLE       = new JTitle ( "" ) ;
      cnr_DATA       = new DTree () ;        
      pb_CLOSE       = new ActionButton  ( Str.getStr ( STR_CLOSE ),        ImageSystem.getImageIcon ( this, ImageSystem.CLOSE ),        Str.getStr ( STR_CLOSE_THIS_PANEL ) ) ;
      pb_NEW         = new ActionButton  ( Str.getStr ( STR_NEW ),          ImageSystem.getImageIcon ( this, ImageSystem.NEW ),          Str.getStr ( STR_NEW ) ) ;
      pb_EDIT        = new ActionButton  ( Str.getStr ( STR_EDIT ),         ImageSystem.getImageIcon ( this, ImageSystem.EDIT ),         Str.getStr ( STR_EDIT ) )  ;
      pb_DELETE      = new ActionButton  ( Str.getStr ( STR_DELETE ),       ImageSystem.getImageIcon ( this, ImageSystem.DELETE ),       Str.getStr ( STR_DELETE ) ) ;           
      pb_VALIDATE    = new ActionButton  ( Str.getStr ( STR_VALIDATE ),     ImageSystem.getImageIcon ( this, ImageSystem.SAVE ),         Str.getStr ( STR_VALIDATE ) ) ;           
      pb_COMPLETE    = new ActionButton  ( Str.getStr ( STR_COMPLETE ),     ImageSystem.getImageIcon ( this, ImageSystem.SAVE ),         Str.getStr ( STR_COMPLETE ) ) ;           
      pb_FIND        = new ToolBarButton ( Str.getStr ( STR_FIND ),         ImageSystem.getImageIcon ( this, ImageSystem.SEARCH ),       Str.getStr ( STR_FIND ) ) ;
      pb_PREVIEW     = new ToolBarButton ( Str.getStr ( STR_PREVIEW_ON ),   ImageSystem.getImageIcon ( this, ImageSystem.PREVIEW ),      Str.getStr ( STR_TURN_PREVIEW_ON ) ) ;
      pb_CUSTOM      = new ToolBarButton ( Str.getStr ( STR_CUSTOM ),       ImageSystem.getImageIcon ( this, ImageSystem.CUSTOM_QUERY ), Str.getStr ( STR_CUSTOM ) ) ;
      pb_EXPORT      = new ToolBarButton ( Str.getStr ( STR_EXPORT ),       ImageSystem.getImageIcon ( this, ImageSystem.EXPORT ),       Str.getStr ( STR_EXPORT ) ) ;
      pb_WIZARD      = new ToolBarButton ( Str.getStr ( STR_WIZARD ),       ImageSystem.getImageIcon ( this, ImageSystem.WIZARD ),       Str.getStr ( STR_FIELD_CHANGER ) ) ;
      toolBar        = new JToolBar() ;      
      st_KEY         = new JLabel ( "") ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create our menu                                         */
      /*                                                           */
      /*-----------------------------------------------------------*/
      MNU_SORT        = new JMenu ( Str.getStr ( STR_SORT ) ) ;
      MNU_DESCENDING  = new JRadioButtonMenuItem ( Str.getStr ( STR_DESCENDING ) ) ;
      MNU_ASCENDING   = new JRadioButtonMenuItem ( Str.getStr ( STR_ASCENDING ) ) ;
      MNU_DOCCLASS    = new JRadioButtonMenuItem ( Str.getStr ( STR_DOC_CLASS ) ) ;
      MNU_TITLE       = new JRadioButtonMenuItem ( Str.getStr ( STR_TITLE ) ) ;
      MNU_DBUSER      = new JRadioButtonMenuItem ( Str.getStr ( STR_LAST_TOUCHED_BY  ) ) ;
      MNU_CHANGEDTIME = new JRadioButtonMenuItem ( Str.getStr ( STR_LAST_TOUCHED_ON ) ) ;
      MNU_INDICATOR   = new JRadioButtonMenuItem ( Str.getStr ( STR_INDICATOR ) ) ;



      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add Action Listeners                                    */
      /*                                                           */
      /*-----------------------------------------------------------*/
      pb_CLOSE.addActionListener        ( this ) ;
      pb_NEW.addActionListener          ( this ) ;
      pb_VALIDATE.addActionListener     ( this ) ;
      pb_COMPLETE.addActionListener     ( this ) ;
      pb_EDIT.addActionListener         ( this ) ;
      pb_DELETE.addActionListener       ( this ) ;
      cnr_DATA.addActionListener        ( this ) ;
      cnr_DATA.addTreeExpansionListener ( this ) ;
      cnr_DATA.addTreeSelectionListener ( this ) ;
      pb_FIND.addActionListener         ( this ) ;
      pb_CUSTOM.addActionListener       ( this ) ;
      pb_EXPORT.addActionListener       ( this ) ;
      pb_WIZARD.addActionListener       ( this ) ;
      pb_PREVIEW.addActionListener      ( this ) ;
      MNU_DESCENDING.addActionListener  ( this ) ;
      MNU_ASCENDING.addActionListener   ( this ) ;
      MNU_DOCCLASS.addActionListener    ( this ) ;
      MNU_TITLE.addActionListener       ( this ) ;
      MNU_DBUSER.addActionListener      ( this ) ;
      MNU_CHANGEDTIME.addActionListener ( this ) ;
      MNU_INDICATOR.addActionListener   ( this ) ;              

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add our Sort Menu Group                                 */
      /*                                                           */
      /*-----------------------------------------------------------*/
      sortGroup.add ( MNU_DOCCLASS ) ;
      sortGroup.add ( MNU_TITLE ) ;
      sortGroup.add ( MNU_DBUSER ) ;
      sortGroup.add ( MNU_CHANGEDTIME ) ;
      sortGroup.add ( MNU_INDICATOR ) ;
      ascGroup.add  ( MNU_ASCENDING ) ;
      ascGroup.add  ( MNU_DESCENDING ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setBackground ( Color.white ) ;  
      cnr_DATA.setCellRenderer ( treeRenderer = new DetailTreeCellRenderer ( GUISystem.getFontUtil(), 6 ) ) ;
      cnr_DATA.setModel ( new DefaultTreeModel ( new StringTreeNode ( Str.getStr ( STR_SELECT_A_VIEW ) ) ) ) ;
      cnr_DATA.setBorder ( null ) ;
      treeRenderer.setPreferredWidth ( 800 ) ;
      treeRenderer.setColumnWidth ( 0, 15 ) ;
      treeRenderer.setColumnWidth ( 1, 15 ) ;
      treeRenderer.setColumnWidth ( 2, 75 ) ;
      treeRenderer.setColumnWidth ( 3, WIDTH_JTREE_TITLE ) ;
      treeRenderer.setColumnWidth ( 4, 175 ) ;
      treeRenderer.setColumnWidth ( 5, 140 ) ;
      treeRenderer.setWordWrap ( true ) ;
      cnr_DATA.setRowHeight ( 0 ) ;
      toolBar.setBorder ( null ) ;
      toolBar.setOpaque ( false ) ;   
      st_KEY.setOpaque ( false ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add our GUI                                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( new BorderLayout() ) ;
      add ( st_TITLE, BorderLayout.NORTH ) ;
      add ( scr_DATA = new JScrollPane ( cnr_DATA ), BorderLayout.CENTER ) ;      
      add ( st_KEY, BorderLayout.SOUTH ) ;
      scr_DATA.getViewport().putClientProperty ("EnableWindowBlit", Boolean.TRUE);
      scr_DATA.setBorder ( null ) ;

      if ( !PropertySystem.getBool ( PropertySystem.PROPERTY_SHOWSKIN ) )
         setBorder ( GUISystem.loweredBorder ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add our toolbar                                         */
      /*                                                           */
      /*-----------------------------------------------------------*/
      toolBar.add ( new ToolBarSeparator() ) ;
      toolBar.add ( pb_FIND ) ;
      toolBar.add ( pb_WIZARD ) ;
      toolBar.add ( pb_PREVIEW ) ;
      toolBar.add ( pb_EXPORT ) ;
      toolBar.add ( new ToolBarSeparator() ) ;
      toolBar.add ( pb_CUSTOM ) ;   


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add our menu                                            */
      /*                                                           */
      /*-----------------------------------------------------------*/
      MNU_SORT.add ( MNU_ASCENDING  ) ;
      MNU_SORT.add ( MNU_DESCENDING ) ;
      MNU_SORT.addSeparator() ;
      MNU_SORT.add ( MNU_CHANGEDTIME ) ;
      MNU_SORT.add ( MNU_DBUSER ) ;
      MNU_SORT.add ( MNU_TITLE ) ;
      MNU_SORT.add ( MNU_INDICATOR ) ;
      MNU_SORT.add ( MNU_DOCCLASS ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Ok, select the correct menu items                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      switch ( getSort() ) {
         
         case SORT_CHANGEDTIME_ASC :
            MNU_ASCENDING.setSelected ( true ) ;
            MNU_CHANGEDTIME.setSelected ( true ) ;
            break ;

         case SORT_CHANGEDTIME_DESC :
            MNU_DESCENDING.setSelected ( true ) ;
            MNU_CHANGEDTIME.setSelected ( true ) ;
            break ;

         case SORT_DBUSER_ASC :
            MNU_ASCENDING.setSelected ( true ) ;
            MNU_DBUSER.setSelected ( true ) ;
            break ;

         case SORT_DBUSER_DESC :
            MNU_DESCENDING.setSelected ( true ) ;
            MNU_DBUSER.setSelected ( true ) ;
            break ;


         case SORT_TITLE_ASC :
            MNU_ASCENDING.setSelected ( true ) ;
            MNU_TITLE.setSelected ( true ) ;
            break ;

         case SORT_TITLE_DESC :
            MNU_DESCENDING.setSelected ( true ) ;
            MNU_TITLE.setSelected ( true ) ;
            break ;

         case SORT_DOCCLASS :
            MNU_DESCENDING.setSelected ( true ) ;
            MNU_DOCCLASS.setSelected ( true ) ;
            break ;

         case SORT_INDICATOR_ASC :
            MNU_ASCENDING.setSelected ( true ) ;
            MNU_INDICATOR.setSelected ( true ) ;
            break ;

         case SORT_INDICATOR_DESC :
            MNU_DESCENDING.setSelected ( true ) ;
            MNU_INDICATOR.setSelected ( true ) ;
            break ;

      }

      return( true ) ;
   }





   /*------------------------------------------------------------*/
   /* start
    */
   /**
    *    This method will be called once we are
    *  up and showing. We will use this time to
    *  refresh our data
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void start () {                       
      parentWin = GUISystem.getParentDefWin ( this ) ;             

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add our action buttons                                  */
      /*                                                           */
      /*-----------------------------------------------------------*/
      parentWin.addActionComponent ( this, pb_CLOSE ) ;
      parentWin.addActionComponent ( this, pb_NEW ) ;
      parentWin.addActionComponent ( this, pb_EDIT ) ;
      parentWin.addActionComponent ( this, pb_DELETE ) ;
      parentWin.addActionComponent ( this, pb_COMPLETE ) ;
      parentWin.addActionComponent ( this, pb_VALIDATE ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add our toolbar and menu                                */
      /*                                                           */
      /*-----------------------------------------------------------*/
      addToolBarButtons() ;
      addMenu() ;           


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Set the current sort                                    */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setSort ( PropertySystem.getInt ( PROPERTY_OANAV_SORT ) ) ;                        

   }




   /*------------------------------------------------------------*/
   /* stop
    */
   /**
    *    This method will be called when we have
    *  been closed and are no longer showing
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean stop () {
      removeAll() ;
      panelDeselected() ;
      Avalon.setOANavPanel ( null ) ;
      return( true );
   }




   /*------------------------------------------------------------*/
   /* getIcon
    */
   /**
    *    This method will return the icon that represents
    *  this QuestPanel
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public ImageIcon getIcon () {
      return( ImageSystem.getImageIcon ( this, ImageSystem.OA_SMALL ) ) ;
   }




   /*------------------------------------------------------------*/
   /* getName
    */
   /**
    *    This method will return this Quest Panel's
    *  name
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getName () {
      return( Str.getStr ( STR_OA_NAV ) ) ;
   }



   /*------------------------------------------------------------*/
   /* panelSelected
    */
   /**
    *    This method will be called when the
    *  user has selected our panel from a
    *  tabbed pane. If we are in MDI mode, this method is never called
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void panelSelected () {
      addToolBarButtons() ;
      addMenu() ;
   }



   /*------------------------------------------------------------*/
   /* panelDeselected
    */
   /**
    *    This method will be called when the user
    *  clicks off of our panel onto another. This method
    *  will never be called in the MDI mode
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void panelDeselected () {
      GUISystem.getParentDefWin ( this ).removeToolbarButton ( toolBar ) ;
      GUISystem.getParentDefWin ( this ).getAppDefaultMenuBar().removeMenu ( MNU_SORT ) ;
   }





   /*------------------------------------------------------------*/
   /* addToolBarButtons
    */
   /**
    *    This method will add all of our specific
    *  toolbar buttons
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void addToolBarButtons () {
      AppDefaultWin     parentWin = GUISystem.getParentDefWin ( this ) ;
      AppDefaultMenuBar menuBar   = parentWin.getAppDefaultMenuBar() ;

      parentWin.addToolbarButton ( toolBar, 2 ) ;
      menuBar.removeMenu ( MNU_SORT ) ;
   }






   /*------------------------------------------------------------*/
   /* addMenu
    */
   /**
    *    This method will add our menu to the Edit
    *  menu item in the toolbar
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void addMenu () {
      GUISystem.getParentDefWin ( this ).getAppDefaultMenuBar().addMenu ( MNU_SORT ) ;
   }




   /*------------------------------------------------------------*/
   /* refresh
    */
   /**
    *    This method will be called when the user
    *  wishes to refresh this panel
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void refresh () {                                 

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   If this is a pre-built view, set the model              */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( ( currentBrandRec != null ) && 
           ( currentView != null ) ) {
         int rowCount = cnr_DATA.getRowCount() ;
         int rowIndex = 1 ;                              

         parentWin.setStatus ( STR_SORTING ) ;
         parentWin.setValueMax ( rowCount ) ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Walk each row, asking if it is expanded                 */
         /*                                                           */
         /*-----------------------------------------------------------*/
         while ( rowIndex < rowCount ) {
            if ( cnr_DATA.isExpanded ( rowIndex ) ) {

               try {
                  TreePath               pathRoot  = cnr_DATA.getPathForRow ( rowIndex ) ;
                  TreePath               path      = cnr_DATA.getPathForRow ( rowIndex+1 ) ;
                  DefaultMutableTreeNode node      = (DefaultMutableTreeNode)pathRoot.getLastPathComponent() ;                                             

                  new RefreshTreeViewThread ( GUISystem.getParentDefWin ( this ), 
                                              treeModel, 
                                              pathRoot, 
                                              currentView,
                                              this ) ;

               } catch ( Exception e ) {
                  LogSystem.log ( 1, e, false ) ;
               }

            }

            rowIndex++ ;
            parentWin.setValue ( rowIndex ) ;
         }

         parentWin.setValue ( 0 ) ;
         parentWin.setStatus ( null ) ;

      }
   }





   /*------------------------------------------------------------*/
   /* cutText
    */
   /**
    *    This method will be called when the user
    *  wants to cut the selected rows to the
    *  clipboard
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean cutText () {
      return( false ) ;
   }



   /*------------------------------------------------------------*/
   /* pasteText
    */
   /**
    *    This method will be called when the user
    *  wants to paste. We do not support this.
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean pasteText () {
      return( false ) ;
   }



   /*------------------------------------------------------------*/
   /* copyText
    */
   /**
    *    This method will be called when the user
    *  wants to copy the selected rows to the
    *  clipboard
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean copyText () {
      return( false ) ;
   }





   /*------------------------------------------------------------*/
   /* getJComponent
    */
   /**
    *    This method will return this panel
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public JComponent getJComponent () {
      return( this ) ;
   }




   /*------------------------------------------------------------*/
   /* shutdown
    */
   /**
    *    This method will return TRUE
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean shutdown () {
      return( true ) ;
   }





   /*------------------------------------------------------------*/
   /* getDefaultNavPanel
    */
   /**
    *    This method will return the default
    *  navigation panel for the OA Nav
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public NavPanel getDefaultNavPanel () {
      return( defaultNavPanel ) ;
   }






   /*------------------------------------------------------------*/
   /* setView
    */
   /**
    *    This method will set our view if it is not
    *  already set to the value specified
    *  
    *
    *  @param view The view as defined in OAViews
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   protected void setView ( String view ) {
      if ( !view.equals ( currentView ) ) {
         currentView = view ;
         treeRenderer.setPreferredWidth ( 800 ) ;
         treeRenderer.setColumnWidth ( 0, 15 ) ;
         treeRenderer.setColumnWidth ( 1, 15 ) ;
         treeRenderer.setColumnWidth ( 2, 75 ) ;
         treeRenderer.setColumnWidth ( 3, WIDTH_JTREE_TITLE ) ;
         treeRenderer.setColumnWidth ( 4, 175 ) ;
         treeRenderer.setColumnWidth ( 5, 140 ) ;
         refreshMemoryView() ;

      }
   }


   /*------------------------------------------------------------*/
   /* setCustomView
    */
   /**
    *    This method will set our custom view if it is not
    *  already set to the value specified
    *  
    *
    *  @param view The custom view description
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   protected void setCustomView ( String view ) {
      CustomView customView = CustomViewSystem.getView ( view ) ;

      if ( customView != null ) {
         int[] colWidths = customView.getColumnWidths() ;

         cnr_DATA.setCellRenderer ( treeRenderer = new DetailTreeCellRenderer ( GUISystem.getFontUtil(), customView.getColumnCount() ) ) ;
         cnr_DATA.setModel ( treeModel = new DefaultTreeModel ( new StringTreeNode ( Str.getStr ( STR_SELECT_A_VIEW ) ) ) ) ;

         for ( int i = 0; i < customView.getColumnCount(); i++ )
            treeRenderer.setColumnWidth ( i, colWidths[i] ) ;

         currentView = null ;
         currentCustomView = customView ;
         new RefreshTreeViewThread ( GUISystem.getParentDefWin ( this ) , treeModel, customView, this ) ; 
      }
   }




   /*------------------------------------------------------------*/
   /* setBrand
    */
   /**
    *    This method will set what brand all of the
    *  views are currently being refreshed with
    *  
    *
    *  @param brandRec The TypeBrandRec
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   protected void setBrand ( TypeBrandRec brandRec ) {
      if ( currentBrandRec != brandRec ) {
         this.currentBrandRec = brandRec ;
         refreshMemoryView() ;
      }
   }





   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will be called when an action
    *  event is fired against us
    *  
    *
    *  @param e The event
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   PB_CLOSE                                                */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( e.getSource() == pb_CLOSE )
         GUISystem.getParentDefWin ( this ).closePanel ( this, null ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   PB_NEW                                                  */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_NEW )
         newObject ( new NewAvalonObjectDlg ( GUISystem.getParentDefWin ( this ) ).getResult(), this ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   PB_FIND                                                 */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_FIND )
         new SelectOADlg().getInstance().addSelectOAListener ( this ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   PB_CUSTOM                                               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_CUSTOM ) {
         new CustomViewDlg ( GUISystem.getParentDefWin ( this ), this ).getResult() ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_VALIDATE                                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_VALIDATE )
         validateSymptom() ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_DELETE                                               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_DELETE ) {
         delete() ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_EXPORT                                               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_EXPORT ) {
         Vector viewDataVec = getViewData() ;

         if ( viewDataVec.size() > 0 )
            new Export ( GUISystem.getParentDefWin ( this ), viewDataVec ) ;
         else
            GUISystem.printBox ( GUISystem.getParentDefWin ( this ),
                                 STR_INFO,
                                 STR_MUST_NAVIGATE_TO_DATA ) ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_COMPLETE                                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_COMPLETE )
         complete() ;



      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   PB_PREVIEW                                              */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_PREVIEW )
         togglePreview() ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_EDIT                                                 */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( ( e.getSource() == pb_EDIT ) ||
                ( e.getSource() == cnr_DATA ) ) {
         if ( cnr_DATA.getSelectionPath().getLastPathComponent() != null )
            OAEdit.edit ( (MutableTreeWrapper) cnr_DATA.getSelectionPath().getLastPathComponent(), this ) ;
      }



      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_WIZARD                                               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_WIZARD )
         searchAndReplace() ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   MNU_ASCENDING                                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == MNU_ASCENDING ) {
         switch ( sort ) {
            case SORT_CHANGEDTIME_DESC :
               setSort ( SORT_CHANGEDTIME_ASC ) ;
               break ;
            case SORT_INDICATOR_DESC :
               setSort ( SORT_INDICATOR_ASC ) ;
               break ;
            case SORT_DBUSER_DESC :
               setSort ( SORT_DBUSER_ASC ) ;
               break ;
            case SORT_TITLE_DESC :
               setSort ( SORT_TITLE_ASC ) ;
               break ;
         }
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   MNU_DESCENDING                                          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == MNU_DESCENDING ) {
         switch ( sort ) {
            case SORT_CHANGEDTIME_ASC :
               setSort ( SORT_CHANGEDTIME_DESC ) ;
               break ;
            case SORT_INDICATOR_ASC :
               setSort ( SORT_INDICATOR_DESC ) ;
               break ;
            case SORT_DBUSER_ASC :
               setSort ( SORT_DBUSER_DESC ) ;
               break ;
            case SORT_TITLE_ASC :
               setSort ( SORT_TITLE_DESC ) ;
               break ;
         }
      }



      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   MNU_INDICATOR                                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == MNU_INDICATOR ) {
         if ( MNU_ASCENDING.isSelected() )
            setSort ( SORT_INDICATOR_ASC ) ;
         else
            setSort ( SORT_INDICATOR_DESC ) ;
      }


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   MNU_TITLE                                               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == MNU_TITLE ) {
         if ( MNU_ASCENDING.isSelected() )
            setSort ( SORT_TITLE_ASC ) ;
         else
            setSort ( SORT_TITLE_DESC ) ;
      }


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   MNU_CHANGEDTIME                                         */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == MNU_CHANGEDTIME ) {
         if ( MNU_ASCENDING.isSelected() )
            setSort ( SORT_CHANGEDTIME_ASC ) ;
         else
            setSort ( SORT_CHANGEDTIME_DESC ) ;
      }



      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   MNU_DBUSER                                              */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == MNU_DBUSER ) {
         if ( MNU_ASCENDING.isSelected() )
            setSort ( SORT_DBUSER_ASC ) ;
         else
            setSort ( SORT_DBUSER_DESC ) ;
      }



      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   MNU_DOCCLASS                                            */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == MNU_DOCCLASS )
         setSort ( SORT_DOCCLASS ) ;

   }





   /*------------------------------------------------------------*/
   /* valueChanged
    */
   /**
    *    This method will be called when an item in
    *  our JTree has changed it's selection state
    *  
    *
    *  @param e The event
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void valueChanged ( TreeSelectionEvent e ) {     
      refreshPreview() ;
   }




   /*------------------------------------------------------------*/
   /* treeExpanded
    */
   /**
    *    This method will be called when a branch
    *  in our tree has been expanded
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void treeExpanded ( TreeExpansionEvent e ) {
      Object expandedObject = e.getPath().getLastPathComponent() ;

      if ( ( expandedObject != null ) && ( expandedObject instanceof ViewTreeNode ) ) {
         System.out.println ( "Tree Expanded!" ) ;

         new RefreshTreeViewThread ( GUISystem.getParentDefWin ( this ), treeModel, e.getPath(), currentView, this ) ;
      }
   }





   /*------------------------------------------------------------*/
   /* treeCollapsed
    */
   /**
    *    This method will be called when a tree
    *  has been collapsed
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void treeCollapsed ( TreeExpansionEvent e ) {
   }



   /*------------------------------------------------------------*/
   /* newObject
    */
   /**
    *    This method will create a new Object in the
    *  OnlineAssistant database
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public static void newObject ( int newObjectType, QuestPanel navPanel ) {

      switch ( newObjectType ) {
         case AVALON_SYMPTOM :
            WindowSystem.createPanel ( new SymptomEditorPanel ( navPanel ) ) ;
            break ;

         case AVALON_LINK_GROUP :
            WindowSystem.createPanel ( new LinkGroupEditorPanel ( navPanel ) ) ;
            break ;

         case AVALON_ACTION :
            WindowSystem.createPanel ( new ActionEditorPanel ( navPanel ) ) ;
            break ;

         case AVALON_LINK :
            WindowSystem.createPanel ( new LinkEditorPanel ( navPanel ) ) ;
            break ;

         case AVALON_QUESTION :
            WindowSystem.createPanel ( new QuestionEditorPanel ( navPanel ) ) ;
            break ;

      } /* switch */

   } /* newObject */





   /*------------------------------------------------------------*/
   /* selectOAComplete
    */
   /**
    *    This method will be called when the user
    *  has selected items from the SelectOADlg.
    *  
    *
    *  @param vec The vector of items
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void selectOAComplete ( Vector vector ) {
      if ( ( vector != null ) && ( vector.size() > 0 ) ) {
         StringTreeNode   root  = null ;
         DefaultTreeModel model = new DefaultTreeModel ( root = new StringTreeNode ( Str.getStr ( STR_RESULTS ) ) ) ;
         int              i     = 0 ;
         int              size  = vector.size() ;

         while ( i < size ) {
            root.add ( new MutableTreeWrapper ( vector.elementAt(i) ) ) ;
            i++ ;
         }

         cnr_DATA.setModel ( model ) ;
      }
   }





   /*------------------------------------------------------------*/
   /* togglePreview
    */
   /**
    *    This method will toggle the preview on and off
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void togglePreview () {                                               

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   If the splitPane is null, we are not showing the preview*/
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( splitPane == null ) {
         Dimension size  = getSize() ;                        


         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Create the Split Pane and Browser                       */
         /*                                                           */
         /*-----------------------------------------------------------*/
         splitPane      = new JSplitPane ( JSplitPane.VERTICAL_SPLIT ) ;
         previewBrowser = new Browser() ;

         remove ( scr_DATA ) ;

         splitPane.add ( scr_DATA,       splitPane.TOP ) ;
         splitPane.add ( previewBrowser, splitPane.BOTTOM ) ;

         add ( splitPane, BorderLayout.CENTER ) ;

         previewBrowser.setPageContent ( "<html><body><center><font face=\"Helvetica, Arial\" size=2>"+Str.getStr ( STR_NO_PREVIEW_INFO )+"</font></center></body></html>" ) ;
         pb_PREVIEW.setText ( Str.getStr ( STR_PREVIEW_OFF ) ) ;
         pb_PREVIEW.setToolTipText ( Str.getStr ( STR_TURN_PREVIEW_OFF ) ) ;
         splitPane.setDividerLocation ( size.height-(size.height/4) ) ;
         refreshPreview() ;
      }


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Otherwise, we are showing the preview                   */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else {
         splitPane.remove ( scr_DATA ) ;
         splitPane.remove ( previewBrowser ) ;
         remove ( splitPane ) ;
         add ( scr_DATA, BorderLayout.CENTER ) ;
         splitPane = null ;
         previewBrowser = null ;

         pb_PREVIEW.setText ( Str.getStr ( STR_PREVIEW_ON ) ) ;
         pb_PREVIEW.setToolTipText ( Str.getStr ( STR_TURN_PREVIEW_ON ) ) ;
      }

      GUISystem.getParentDefWin ( this ).revalidate() ;

   }





   /*------------------------------------------------------------*/
   /* refreshPreview
    */
   /**
    *    This method will refresh the preview if
    *  the preview is on and an item is selected
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void refreshPreview () {
      try {
         Object selectedObject = cnr_DATA.getSelectionPath().getLastPathComponent() ;                                         

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   If we are not showing the preview, do nothing           */
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( ( previewBrowser != null ) && ( Qit.getEnabled() ) ) {

            GUISystem.getParentDefWin ( this ).setStatus ( STR_READING_PREVIEW ) ;
            Qit.setEnabled ( false ) ;

            try {
               if ( selectedObject instanceof MutableTreeWrapper ) {

                  selectedObject = ((MutableTreeWrapper)selectedObject).getDataObject() ;     

                  /*-----------------------------------------------------------*/
                  /*                                                           */
                  /*   LinkDisplayRec                                          */
                  /*                                                           */
                  /*-----------------------------------------------------------*/
                  if ( selectedObject instanceof LinkDisplayRec ) {
                     previewBrowser.setPageContent ( new LinkPreviewRec ( (LinkDisplayRec)selectedObject ).getPreviewHTMLSource() ) ;
                  } else if ( selectedObject instanceof LinkDraftDisplayRec ) {
                     previewBrowser.setPageContent ( new LinkPreviewRec ( (LinkDraftDisplayRec)selectedObject ).getPreviewHTMLSource() ) ;
                  }

                  /*-----------------------------------------------------------*/
                  /*                                                           */
                  /*   QuestionDisplayRec                                      */
                  /*                                                           */
                  /*-----------------------------------------------------------*/
                  else if ( selectedObject instanceof QuestionDisplayRec ) {
                     previewBrowser.setPageContent ( new QuestionPreviewRec ( (QuestionDisplayRec)selectedObject ).getPreviewHTMLSource() ) ;
                  } else if ( selectedObject instanceof QuestionDraftDisplayRec ) {
                     previewBrowser.setPageContent ( new QuestionPreviewRec ( (QuestionDraftDisplayRec)selectedObject ).getPreviewHTMLSource() ) ;
                  }

                  /*-----------------------------------------------------------*/
                  /*                                                           */
                  /*   LinkGroupDisplayRec                                     */
                  /*                                                           */
                  /*-----------------------------------------------------------*/
                  else if ( selectedObject instanceof LinkGroupDisplayRec ) {
                     previewBrowser.setPageContent ( new LinkGroupPreviewRec ( (LinkGroupDisplayRec)selectedObject ).getPreviewHTMLSource() ) ;
                  } else if ( selectedObject instanceof LinkGroupDraftDisplayRec ) {
                     previewBrowser.setPageContent ( new LinkGroupPreviewRec ( (LinkGroupDraftDisplayRec)selectedObject ).getPreviewHTMLSource() ) ;
                  }

                  /*-----------------------------------------------------------*/
                  /*                                                           */
                  /*   ActionDisplayRec                                        */
                  /*                                                           */
                  /*-----------------------------------------------------------*/
                  else if ( selectedObject instanceof ActionDisplayRec ) {
                     previewBrowser.setPageContent ( new ActionPreviewRec ( (ActionDisplayRec)selectedObject ).getPreviewHTMLSource() ) ;
                  } else if ( selectedObject instanceof ActionDraftDisplayRec ) {
                     previewBrowser.setPageContent ( new ActionPreviewRec ( (ActionDraftDisplayRec)selectedObject ).getPreviewHTMLSource() ) ;
                  }

                  /*-----------------------------------------------------------*/
                  /*                                                           */
                  /*   SymptomDisplayRec                                       */
                  /*                                                           */
                  /*-----------------------------------------------------------*/
                  else if ( selectedObject instanceof SymptomDisplayRec ) {
                     previewBrowser.setPageContent ( new SymptomPreviewRec ( (SymptomDisplayRec)selectedObject ).getPreviewHTMLSource() ) ;
                  } else if ( selectedObject instanceof SymptomDraftDisplayRec ) {
                     previewBrowser.setPageContent ( new SymptomPreviewRec ( (SymptomDraftDisplayRec)selectedObject ).getPreviewHTMLSource() ) ;
                  }

               } /* if */
            } catch ( Exception ex ) {
               LogSystem.log ( 1, ex ) ;
            }

            Qit.setEnabled ( true ) ;
            GUISystem.getParentDefWin ( this ).setStatus ( null ) ;
         }
      } catch ( Exception ex2 ) {
         // Print nothing
      }
   }





   /*------------------------------------------------------------*/
   /* getNewCustomView
    */
   /**
    *    This method simply returns a blank OACustomView
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return CustomView
    *//*---------------------------------------------------------*/
   public CustomView getNewCustomView () {
      OACustomView customView = new OACustomView() ;

      customView.updateRecStatus ( QITRec.REC_INSERT ) ;

      return( customView ) ;
   }



   /*------------------------------------------------------------*/
   /* bookmark
    */
   /**
    *    This method will be called if the user
    *  has hit the 'Bookmark' button. 
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return FALSE if Bookmarking is supported, TRUE if bookmarked
    *//*---------------------------------------------------------*/
   public boolean bookmark  () {
      try {
         MutableTreeWrapper selectedObject = (MutableTreeWrapper) cnr_DATA.getSelectionPath().getLastPathComponent() ;                                         

         if ( selectedObject != null ) {
            TreePath[] treePath    = cnr_DATA.getSelectionPaths() ;
            Vector     bookmarkVec = new Vector ( treePath.length ) ;

            for ( int i = 0; i < treePath.length; i++ ) {
               Bookmark           bookmark = new Bookmark() ;
               MutableTreeWrapper treeNode = (MutableTreeWrapper) treePath[i].getLastPathComponent() ;
               Object             object   = treeNode.getDataObject() ;

               /*-------------------------------------------------------------------*/
               /*                                                                   */
               /*   Depending on what the user has selected, assign the bookmark    */
               /*                                                                   */
               /*-------------------------------------------------------------------*/
               if ( object instanceof QuestionDisplayRec ) {
                  bookmark.setDescript ( ((QuestionDisplayRec)object).getColumnData ( 3 ).toString() ) ;
                  bookmark.setObject   ( new Integer ( ((QuestionDisplayRec)object).getQuestionInd() ),
                                         BOOKMARK_QUESTION ) ;
               }

               else if ( object instanceof ActionDisplayRec ) {
                  bookmark.setDescript ( ((ActionDisplayRec)object).getColumnData ( 3 ).toString() ) ;
                  bookmark.setObject   ( new Integer ( ((ActionDisplayRec)object).getActionInd() ),
                                         BOOKMARK_ACTION ) ;
               }

               else if ( object instanceof SymptomDisplayRec ) {
                  bookmark.setDescript ( ((SymptomDisplayRec)object).getColumnData ( 3 ).toString() ) ;
                  bookmark.setObject   ( new Integer ( ((SymptomDisplayRec)object).getSymptomInd() ),
                                         BOOKMARK_SYMPTOM ) ;
               }

               else if ( object instanceof LinkDisplayRec ) {
                  bookmark.setDescript ( ((LinkDisplayRec)object).getColumnData ( 3 ).toString() ) ;
                  bookmark.setObject   ( new Integer ( ((LinkDisplayRec)object).getLinkInd() ),
                                         BOOKMARK_LINK ) ;
               }

               else if ( object instanceof LinkGroupDisplayRec ) {
                  bookmark.setDescript ( ((LinkGroupDisplayRec)object).getColumnData ( 3 ).toString() ) ;
                  bookmark.setObject   ( new Integer ( ((LinkGroupDisplayRec)object).getLinkGroupInd() ),
                                         BOOKMARK_LINK ) ;
               }

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   DO NOT ALLOW DRAFT BOOKMARKS                            */
               /*                                                           */
               /*-----------------------------------------------------------*/
               else if ( ( object instanceof QuestionDraftDisplayRec ) ||
                         ( object instanceof ActionDraftDisplayRec ) ||
                         ( object instanceof LinkDraftDisplayRec ) ||
                         ( object instanceof SymptomDraftDisplayRec ) ||
                         ( object instanceof LinkGroupDraftDisplayRec ) ) {
                  GUISystem.printBox ( this, STR_INFO, STR_CANNOT_BOOKMARK_DRAFTS ) ;
                  bookmark = null ;
               }

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   Otherwise, just don't allow                             */
               /*                                                           */
               /*-----------------------------------------------------------*/
               else {
                  GUISystem.printBox ( this, STR_INFO, STR_CANNOT_BOOKMARK_THAT ) ;
                  bookmark = null ;
               }


               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   Now, create the bookmark                                */               
               /*                                                           */
               /*-----------------------------------------------------------*/
               if ( bookmark != null )
                  bookmarkVec.addElement ( bookmark ) ;


            } /* for  */

            BookmarkSystem.guiAddBookmarks ( bookmarkVec ) ;

         } else
            GUISystem.printBox ( this, STR_INFO, STR_MUST_SELECT_ITEM ) ;

      } catch ( Exception e ) {
         LogSystem.log ( 1, e, false ) ;
         GUISystem.printBox ( this, STR_INFO, STR_MUST_SELECT_ITEM ) ;
      }
      return( true ) ;
   }





   /*------------------------------------------------------------*/
   /* getSelectedObjects
    */
   /**
    *    This method will return all selected objects in
    *  a vector
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Vector - A Vector containing ***DisplayRec Objects (QuestionDisplayRec, ActionDisplayRec etc..)
    *//*---------------------------------------------------------*/
   private Vector getSelectedObjects () {
      Vector returnVec     = new Vector ( 1, 1 ) ;
      int[]  selectionRows = cnr_DATA.getSelectionRows () ;

      if ( selectionRows != null ) {
         for ( int i = 0; i < selectionRows.length; i++ ) {
            MutableTreeWrapper selectedObject = (MutableTreeWrapper) cnr_DATA.getPathForRow(selectionRows[i]).getLastPathComponent() ;

            returnVec.addElement ( selectedObject.getDataObject() ) ;
         }
      }

      return( returnVec ) ;
   }


   /*------------------------------------------------------------*/
   /* getViewData
    */
   /**
    *    This method will bring out the actual data
    *  items in the view.
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private Vector getViewData () {
      DefaultTreeModel treeModel = (DefaultTreeModel)cnr_DATA.getModel() ;
      Vector           dataVec   = new Vector ( 1, 10 ) ;

      if ( treeModel != null ) {
         Object root        = treeModel.getRoot() ;
         int    parentCount = treeModel.getChildCount ( root ) ;

         if ( parentCount > 0 )
            addNodesFromParent ( dataVec, treeModel, root ) ;
      }

      return( dataVec ) ;
   }





   /*------------------------------------------------------------*/
   /* addNodesFromParent
    */
   /**
    *    This method will add all nodes from the 
    *  parent passed in recursivly.
    *  
    *
    *  @param dataVec The Vector to add data to
    *  @param treeModel The TreeModel holding the data
    *  @param parent The parent object to look for children under
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void addNodesFromParent ( Vector dataVec, DefaultTreeModel treeModel, Object parent ) {
      int childCount = treeModel.getChildCount ( parent ) ;
      int i          = 0 ;

      while ( i < childCount ) {
         Object childObject = treeModel.getChild ( parent, i ) ;

         if ( treeModel.getChildCount ( childObject ) > 0 )
            addNodesFromParent ( dataVec, treeModel, treeModel.getChild ( parent, i ) ) ;
         else {

            if ( !(childObject instanceof StringTreeNode) )
               dataVec.addElement ( childObject ) ;
         }
         i++ ;
      }
   }





   /*------------------------------------------------------------*/
   /* getPrintObject
    */
   /**
    *    This method will return the print object that
    *  should print
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return The Tree to print
    *//*---------------------------------------------------------*/
   public Object getPrintObject () {
      return( cnr_DATA ) ;
   }





   /*------------------------------------------------------------*/
   /* searchAndReplace
    */
   /**
    *    This method will start the process of
    *  the search and replace
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void searchAndReplace () {
      Vector     viewData        = getSelectedObjects() ;
      Vector     objectChangeVec = new Vector ( 1 ) ;

      if ( ( viewData != null ) && ( viewData.size() > 0 ) ) {
         StatusWin        statusWin        = new StatusWin ( parentWin ) ;
         int              i                = 0 ;
         int              size             = viewData.size() ;
         Object           oaObject         = null ;
         SearchReplaceRec searchReplaceRec = new SearchReplaceRec () ;
         int              newType          = 0 ;

         statusWin.setMaxValue ( size ) ;

         while ( i < size ) {
            oaObject = viewData.elementAt(i) ;

            statusWin.setText ( Str.getStr ( STR_PLEASE_WAIT ) ) ;          

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Set the object type                                     */
            /*                                                           */
            /*-----------------------------------------------------------*/
            if ( ( oaObject instanceof QuestionDraftDisplayRec ) ||
                 ( oaObject instanceof QuestionDisplayRec ) )
               newType = SearchReplaceRec.TYPE_QUESTION ;

            else if ( ( oaObject instanceof ActionDraftDisplayRec ) ||
                      ( oaObject instanceof ActionDisplayRec ) )
               newType = SearchReplaceRec.TYPE_ACTION ;

            else if ( ( oaObject instanceof SymptomDraftDisplayRec ) ||
                      ( oaObject instanceof SymptomDisplayRec ) )
               newType = SearchReplaceRec.TYPE_SYMPTOM ;

            else if ( oaObject instanceof LinkDraftDisplayRec ) {
               if ( ((LinkDraftDisplayRec)oaObject).getLinkType() == 0 )
                  newType = SearchReplaceRec.TYPE_QUEST_LINK ;
               else
                  newType = SearchReplaceRec.TYPE_DOC_LINK ;
            }

            else if ( oaObject instanceof LinkDisplayRec ) {
               if ( ((LinkDisplayRec)oaObject).getLinkType() == 0 )
                  newType = SearchReplaceRec.TYPE_QUEST_LINK ;
               else
                  newType = SearchReplaceRec.TYPE_DOC_LINK ;
            }

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   If this object type is different than the other recs,   */
            /* throw an error message up                                 */
            /*                                                           */
            /*-----------------------------------------------------------*/
            if ( ( searchReplaceRec != null ) && ( searchReplaceRec.getObjectType() > 0 ) ) {
               if ( newType != searchReplaceRec.getObjectType() ) {
                  GUISystem.printBox ( parentWin, STR_INFO, STR_CANNOT_SEARCH_REPLACE_DIFFERENT_OBJECT_TYPES ) ;
                  searchReplaceRec = null ;
                  i = size ;
               }
            }

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Otherwise, set the new type                             */
            /*                                                           */
            /*-----------------------------------------------------------*/
            else
               searchReplaceRec.setObjectType ( newType ) ;                                   


            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   If we haven't encountered an error, continue            */
            /*                                                           */
            /*-----------------------------------------------------------*/
            if ( searchReplaceRec != null ) {

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   If this is a draft, just add it's indicator             */
               /*                                                           */
               /*-----------------------------------------------------------*/
               if ( oaObject instanceof QuestionDraftDisplayRec ) {
                  objectChangeVec.addElement ( new Integer ( ((QuestionDraftDisplayRec)oaObject).getQuestionInd() ) ) ;
               } else if ( oaObject instanceof ActionDraftDisplayRec ) {
                  objectChangeVec.addElement ( new Integer ( ((ActionDraftDisplayRec)oaObject).getActionInd() ) ) ;
               } else if ( oaObject instanceof SymptomDraftDisplayRec ) {
                  objectChangeVec.addElement ( new Integer ( ((SymptomDraftDisplayRec)oaObject).getSymptomInd() ) ) ;
               } else if ( oaObject instanceof LinkDraftDisplayRec ) {
                  objectChangeVec.addElement ( new Integer ( ((LinkDraftDisplayRec)oaObject).getLinkInd() ) ) ;
               }

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   Otherwise we have to create a new  draft                */
               /*                                                           */
               /*-----------------------------------------------------------*/
               else if ( oaObject instanceof QuestionDisplayRec ) {

                  statusWin.setText ( Str.getStr ( STR_CREATING_DRAFT ) ) ;

                  QuestionDraft questionDraft = OASQL.getQuestionDraft ( GUISystem.getParentDefWin ( this ), 
                                                                         ((QuestionDisplayRec)oaObject).getQuestionInd(), 
                                                                         TypeList.WORKREQ_EDIT ) ;
                  if ( questionDraft != null ) {
                     objectChangeVec.addElement ( new Integer ( questionDraft.getInd() ) ) ;
                     questionDraft.writeToDatabase() ;
                  }
               }

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   If a action, create a action draft                      */
               /*                                                           */
               /*-----------------------------------------------------------*/
               else if ( oaObject instanceof ActionDisplayRec ) {
                  ActionDraft actionDraft = OASQL.getActionDraft ( GUISystem.getParentDefWin ( this ), 
                                                                   ((ActionDisplayRec)oaObject).getActionInd(), 
                                                                   TypeList.WORKREQ_EDIT ) ;
                  if ( actionDraft != null ) {
                     objectChangeVec.addElement ( new Integer ( actionDraft.getInd() ) ) ;
                     actionDraft.writeToDatabase() ;
                  }
               }

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   If a symptom, create a symptom draft                    */
               /*                                                           */
               /*-----------------------------------------------------------*/
               else if ( oaObject instanceof SymptomDisplayRec ) {
                  SymptomDraft symptomDraft = OASQL.getSymptomDraft ( GUISystem.getParentDefWin ( this ), 
                                                                      ((SymptomDisplayRec)oaObject).getSymptomInd(), 
                                                                      TypeList.WORKREQ_EDIT ) ;
                  if ( symptomDraft != null ) {
                     objectChangeVec.addElement ( new Integer ( symptomDraft.getInd() ) ) ;
                     symptomDraft.writeToDatabase() ;
                  }
               }


               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   If a Quest Link, create a draft                         */
               /*                                                           */
               /*-----------------------------------------------------------*/
               else if ( oaObject instanceof LinkDisplayRec ) {
                  if ( ((LinkDisplayRec)oaObject).getLinkType() == 0 ) {
                     LinkDraft questLink = OASQL.getQuestLinkDraft ( GUISystem.getParentDefWin ( this ), 
                                                                     ((LinkDisplayRec)oaObject).getLinkInd(), 
                                                                     TypeList.WORKREQ_EDIT ) ;

                     if ( questLink != null ) {
                        objectChangeVec.addElement ( new Integer ( questLink.getInd() ) ) ;
                        ((PersistentRec)questLink).writeToDatabase() ;
                     }
                  } else {
                     LinkDraft docLink = OASQL.getQuestLinkDraft ( GUISystem.getParentDefWin ( this ), 
                                                                   ((LinkDisplayRec)oaObject).getLinkInd(), 
                                                                   TypeList.WORKREQ_EDIT ) ;

                     if ( docLink != null ) {
                        objectChangeVec.addElement ( new Integer ( docLink.getInd() ) ) ;
                        ((PersistentRec)docLink).writeToDatabase() ;
                     }
                  }

               } /* link  */

            } /* if  */

            statusWin.setValue ( i ) ;
            i++ ;
         }


         /*--------------------------------------------------------------*/
         /*                                                              */
         /*   Ok, now that we have the data that will change, change it  */
         /*                                                              */
         /*--------------------------------------------------------------*/
         searchReplaceRec.setObjectChangeVec ( objectChangeVec ) ;

         statusWin.dispose() ;                                  

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Now, kick off the Search and Replace Wizard             */
         /*                                                           */
         /*-----------------------------------------------------------*/
         new SearchReplaceWizard ( parentWin, searchReplaceRec ) ;


      } /* if user has selected data  */
      else
         GUISystem.printBox ( parentWin, STR_INFO, STR_MUST_SELECT_ITEM ) ;


   } /* searchAndReplace  */






   /*------------------------------------------------------------*/
   /* validateSymptom
    */
   /**
    *    This method will start the Symptom Validator
    *  if there is a valid symptom selected
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void validateSymptom () {
      TreePath           treePath       = cnr_DATA.getSelectionPath() ;

      if ( treePath != null ) {
         MutableTreeWrapper selectedObject = (MutableTreeWrapper) treePath.getLastPathComponent() ;                                         

         if ( selectedObject != null ) {
            if ( selectedObject.getDataObject() instanceof SymptomDisplayRec )
               WindowSystem.createPanel ( new SymptomValidatorWrapper ( ((SymptomDisplayRec)selectedObject.getDataObject()).getSymptomInd(),
                                                                        false,
                                                                        this ) ) ;

            else if ( selectedObject.getDataObject() instanceof SymptomDraftDisplayRec )
               WindowSystem.createPanel ( new SymptomValidatorWrapper ( ((SymptomDraftDisplayRec)selectedObject.getDataObject()).getSymptomInd(),
                                                                        true,
                                                                        this ) ) ;

            /* Load in the symptom here, you can get the indicator from the displayRecs! */
         } else
            GUISystem.printBox ( STR_INFO, STR_MUST_SELECT_SYMPTOM ) ;
      } else
         GUISystem.printBox ( STR_INFO, STR_MUST_SELECT_ITEM ) ;
   }





   /*------------------------------------------------------------*/
   /* setSort
    */
   /**
    *    This method will set the current sort that
    *  we are using
    *  
    *
    *  @param sort The new sort. This must be one of the values defined in OASort
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setSort ( int sort ) {
      this.sort = sort ;
      PropertySystem.putInt ( PROPERTY_OANAV_SORT, sort ) ;                         

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Refresh the view with the new sort                      */
      /*                                                           */
      /*-----------------------------------------------------------*/
      refreshViewWithSort() ;

   }





   /*------------------------------------------------------------*/
   /* getSort
    */
   /**
    *    This method will return the sort that we
    *  should be sorting on
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return int The type of sort as defined in OASort
    *//*---------------------------------------------------------*/
   public int getSort () {
      return( PropertySystem.getInt ( PROPERTY_OANAV_SORT ) ) ;
   }






   /*------------------------------------------------------------*/
   /* refreshViewWithSort
    */
   /**
    *    This method will refresh all exanded data
    *  with the current sort
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void refreshViewWithSort() {
      int rowCount = cnr_DATA.getRowCount() ;
      int rowIndex = 1 ;                              

      parentWin.setStatus ( STR_SORTING ) ;
      parentWin.setValueMax ( rowCount ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Walk each row, asking if it is expanded                 */
      /*                                                           */
      /*-----------------------------------------------------------*/
      while ( rowIndex < rowCount ) {
         if ( cnr_DATA.isExpanded ( rowIndex ) ) {

            try {
               TreePath               pathRoot  = cnr_DATA.getPathForRow ( rowIndex ) ;
               TreePath               path      = cnr_DATA.getPathForRow ( rowIndex+1 ) ;
               DefaultMutableTreeNode node      = (DefaultMutableTreeNode)pathRoot.getLastPathComponent() ;                                             

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   Ok, if the Object on this row is a MutableTreeWrapper,  */
               /* then we can sort this view                                */
               /*                                                           */
               /*-----------------------------------------------------------*/
               if ( path.getLastPathComponent() instanceof MutableTreeNode ) {
                  int      childCount = node.getChildCount() ;
                  Vector   newDataVec = new Vector ( childCount ) ;

                  for ( int i = 0; i < childCount; i++ )
                     newDataVec.addElement ( ((MutableTreeWrapper)node.getChildAt(i)).getDataObject() ) ;

                  new RefreshTreeViewThread().populateTree ( treeModel, node, newDataVec ) ;
               }
            } catch ( Exception e ) {
               LogSystem.log ( 1, e, false ) ;
            }

         }

         rowIndex++ ;
         parentWin.setValue ( rowIndex ) ;
      }

      parentWin.setValue ( 0 ) ;
      parentWin.setStatus ( null ) ;
   }





   /*------------------------------------------------------------*/
   /* delete
    */
   /**
    *    This method will delete all selected Objects. Please
    *  note that this 'Delete' will do the following:<br><br>
    *
    *  For Drafts, the 'RECYCLED' flag is set to 'Y'<br>
    *  For Active Objects, a Request is created for 'Delete'.<br>
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void delete() {
      Vector  viewData = getSelectedObjects() ;
      boolean refresh  = false ;

      if ( ( viewData != null ) && ( viewData.size() > 0 ) ) {
         int     i             = 0 ;
         int     size          = viewData.size() ;
         Object  currentObject = null ;

         while ( i < size ) {
            currentObject = viewData.elementAt(i) ;                            

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   If this is a draft, recycle the draft                   */
            /*                                                           */
            /*-----------------------------------------------------------*/
            if ( currentObject instanceof QuestionDraftDisplayRec ) {
               parentWin.setStatus ( STR_PLACING_IN_RECYCLING_BIN ) ;
               OASQL.recycleObject ( AVALON_QUESTION_DRAFT, ((QuestionDraftDisplayRec)currentObject).getQuestionInd() ) ;
               refresh = true ;
            }

            else if ( currentObject instanceof ActionDraftDisplayRec ) {
               parentWin.setStatus ( STR_PLACING_IN_RECYCLING_BIN ) ;
               OASQL.recycleObject ( AVALON_ACTION_DRAFT, ((ActionDraftDisplayRec)currentObject).getActionInd() ) ;
               refresh = true ;
            }

            else if ( currentObject instanceof SymptomDraftDisplayRec ) {
               parentWin.setStatus ( STR_PLACING_IN_RECYCLING_BIN ) ;
               OASQL.recycleObject ( AVALON_SYMPTOM_DRAFT, ((SymptomDraftDisplayRec)currentObject).getSymptomInd() ) ;
               refresh = true ;
            }

            else if ( currentObject instanceof LinkDraftDisplayRec ) {
               parentWin.setStatus ( STR_PLACING_IN_RECYCLING_BIN ) ;
               OASQL.recycleObject ( AVALON_LINK_DRAFT, ((LinkDraftDisplayRec)currentObject).getLinkInd() ) ;
               refresh = true ;
            }

            else if ( currentObject instanceof LinkGroupDraftDisplayRec ) {
               parentWin.setStatus ( STR_PLACING_IN_RECYCLING_BIN ) ;
               OASQL.recycleObject ( AVALON_LINK_GROUP_DRAFT, ((LinkGroupDraftDisplayRec)currentObject).getLinkGroupInd() ) ;
               refresh = true ;
            }


            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Otherwise, we must create a draft for delete            */
            /*                                                           */
            /*-----------------------------------------------------------*/
            else {
               parentWin.setStatus ( STR_CREATING_DRAFT_FOR_DELETE ) ;
               parentWin.setStatusLock ( true ) ;

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   Question                                                */
               /*                                                           */
               /*-----------------------------------------------------------*/
               if ( currentObject instanceof QuestionDisplayRec ) {
                  QuestionDraft questionDraft = OASQL.getQuestionDraft ( parentWin,
                                                                         ((QuestionDisplayRec)currentObject).getQuestionInd(),
                                                                         TypeList.WORKREQ_DELETE ) ;

                  questionDraft.setDbUser ( UserSystem.getUserId() ) ;
                  questionDraft.writeToDatabase() ;
                  if ( GUISystem.printBox ( Str.getStr ( STR_QUESTION ), 
                                            Str.getStr ( STR_OBJECT_DRAFT_CREATED_FOR_DELETE ) ) )
                     WindowSystem.createPanel ( new QuestionEditorPanel ( this, questionDraft.getInd() ) ) ;
               }

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   Action                                                  */
               /*                                                           */
               /*-----------------------------------------------------------*/
               else if ( currentObject instanceof ActionDisplayRec ) {
                  ActionDraft actionDraft = OASQL.getActionDraft ( parentWin,
                                                                   ((ActionDisplayRec)currentObject).getActionInd(),
                                                                   TypeList.WORKREQ_DELETE ) ;

                  actionDraft.setDbUser ( UserSystem.getUserId() ) ;
                  actionDraft.writeToDatabase() ;

                  if ( GUISystem.printBox ( Str.getStr ( STR_QUESTION ), 
                                            Str.getStr ( STR_OBJECT_DRAFT_CREATED_FOR_DELETE ) ) )
                     WindowSystem.createPanel ( new ActionEditorPanel ( this, actionDraft.getInd() ) ) ;
               }

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   Symptom                                                 */
               /*                                                           */
               /*-----------------------------------------------------------*/
               else if ( currentObject instanceof SymptomDisplayRec ) {
                  SymptomDraft symptomDraft = OASQL.getSymptomDraft ( parentWin,
                                                                      ((SymptomDisplayRec)currentObject).getSymptomInd(),
                                                                      TypeList.WORKREQ_DELETE ) ;

                  symptomDraft.setDbUser ( UserSystem.getUserId() ) ;
                  symptomDraft.writeToDatabase() ;
                  if ( GUISystem.printBox ( Str.getStr ( STR_QUESTION ), 
                                            Str.getStr ( STR_OBJECT_DRAFT_CREATED_FOR_DELETE ) ) )
                     WindowSystem.createPanel ( new SymptomEditorPanel ( this, symptomDraft.getInd() ) ) ;
               }



               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   Link                                                    */
               /*                                                           */
               /*-----------------------------------------------------------*/
               else if ( currentObject instanceof LinkDisplayRec ) {
                  if ( ((LinkDisplayRec)currentObject).getLinkType() == 0 ) {
                     QuestLinkDraft linkDraft = (QuestLinkDraft)OASQL.getQuestLinkDraft ( parentWin,
                                                                                          ((LinkDisplayRec)currentObject).getLinkInd(),
                                                                                          TypeList.WORKREQ_DELETE ) ;

                     linkDraft.setDbUser ( UserSystem.getUserId() ) ;
                     linkDraft.writeToDatabase() ;

                     if ( GUISystem.printBox ( Str.getStr ( STR_QUESTION ), 
                                               Str.getStr ( STR_OBJECT_DRAFT_CREATED_FOR_DELETE ) ) )
                        WindowSystem.createPanel ( new LinkEditorPanel ( this, 
                                                                         linkDraft.getInd(),
                                                                         QUEST_LINK ) ) ;

                  } else if ( ((LinkDisplayRec)currentObject).getLinkType() == 1 ) {
                     ExternalLinkDraft linkDraft = (ExternalLinkDraft)OASQL.getExternalLinkDraft ( parentWin,
                                                                                                   ((LinkDisplayRec)currentObject).getLinkInd(),
                                                                                                   TypeList.WORKREQ_DELETE ) ;

                     linkDraft.setDbUser ( UserSystem.getUserId() ) ;
                     linkDraft.writeToDatabase() ;

                     if ( GUISystem.printBox ( Str.getStr ( STR_QUESTION ), 
                                               Str.getStr ( STR_OBJECT_DRAFT_CREATED_FOR_DELETE ) ) )
                        WindowSystem.createPanel ( new LinkEditorPanel ( this, 
                                                                         linkDraft.getInd(), 
                                                                         EXTERNAL_LINK ) ) ;
                  }

               }

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   LinkGroup                                               */
               /*                                                           */
               /*-----------------------------------------------------------*/
               else if ( currentObject instanceof LinkGroupDisplayRec ) {
                  LinkGroupDraft linkGroupDraft = OASQL.getLinkGroupDraft ( parentWin,
                                                                            ((LinkGroupDisplayRec)currentObject).getLinkGroupInd(),
                                                                            TypeList.WORKREQ_DELETE ) ;

                  linkGroupDraft.setDbUser ( UserSystem.getUserId() ) ;
                  linkGroupDraft.writeToDatabase() ;
                  if ( GUISystem.printBox ( Str.getStr ( STR_QUESTION ), 
                                            Str.getStr ( STR_OBJECT_DRAFT_CREATED_FOR_DELETE ) ) )
                     WindowSystem.createPanel ( new LinkGroupEditorPanel ( this, linkGroupDraft.getInd() ) ) ;

               }





               parentWin.setStatusLock ( false ) ;
            }

            i++ ;
         }

      } else
         GUISystem.printBox ( STR_INFO, STR_MUST_SELECT_ITEM ) ;

      parentWin.setStatus ( null ) ;

      if ( refresh )
         refresh() ;

   }






   /*------------------------------------------------------------*/
   /* refreshMemoryView
    */
   /**
    *    This method will only refresh our in-memory
    *  view of what view and brand is selected
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void refreshMemoryView () {
      treeModel = OAViews.getJTreeModel ( currentView, currentBrandRec ) ;
      st_KEY.setText ( "<html><body><font face=\"Helvetica, Arial\" size=2>"+
                       "<b>"+Str.getStr ( STR_KEY )+":</b><br>"+
                       OAViews.getViewKey ( currentView )+"</body></html>" ) ;

      if ( treeModel != null ) {
         cnr_DATA.setModel ( treeModel ) ;
         st_TITLE.setText ( OAViews.getViewName ( currentView ) ) ;
      }
   }





   /*------------------------------------------------------------*/
   /* closeTree
    */
   /**
    *    This method will close the tree items defined
    *  in the treePath param
    *  
    *
    *  @param treePath The path to close
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   protected void closeTree ( TreePath treePath ) {
      cnr_DATA.collapsePath ( treePath ) ;
   }




   /*------------------------------------------------------------*/
   /* complete
    */
   /**
    *    This method will 'complete' all of the selected
    *  drafts. If there is no selected draft a message
    *  will be displayed to the user
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void complete () {
      Vector selected = getSelectedObjects() ;                           

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   If they selected something, continue                    */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( ( selected != null ) && ( selected.size() > 0 ) ) {
         int    i          = 0 ;
         int    size       = selected.size() ;
         Object displayRec = null ;                     

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Loop through editing each item                          */
         /*                                                           */
         /*-----------------------------------------------------------*/
         while ( ( i < size ) && ( i < 5 ) ) {
            displayRec = selected.elementAt(i) ;      

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Draft Questions                                         */
            /*                                                           */
            /*-----------------------------------------------------------*/
            if ( displayRec instanceof QuestionDraftDisplayRec ) {
               QuestionDraft draft = AvalonCache.readQuestionDraft ( ((QuestionDraftDisplayRec)displayRec).getQuestionInd() ) ;

               if ( ( draft != null ) && ( validateQuestion ( draft ) ) ) {
                  if ( draft.getTypeWorkRequired ().getInd() == TypeList.WORKREQ_DELETE ) {

                     draft.setArchived ( true ) ;
                     if ( draft.writeToDatabase() == 0 )
                        OAObjectArchiver.archiveObject ( draft, null ) ;
                  } else
                     WindowSystem.createPanel ( new QuestionEditorPanel ( this, 
                                                                          draft,
                                                                          true ) ) ;
               }
            }

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Draft Actions                                           */
            /*                                                           */
            /*-----------------------------------------------------------*/
            else if ( displayRec instanceof ActionDraftDisplayRec ) {
               ActionDraft draft = AvalonCache.readActionDraft ( ((ActionDraftDisplayRec)displayRec).getActionInd() ) ;

               if ( ( draft != null ) && ( validateAction ( draft ) ) ) {
                  if ( draft.getTypeWorkRequired ().getInd() == TypeList.WORKREQ_DELETE ) {

                     draft.setArchived ( true ) ;
                     if ( draft.writeToDatabase() == 0 )
                        OAObjectArchiver.archiveObject ( draft, null ) ;
                  } else
                     WindowSystem.createPanel ( new ActionEditorPanel ( this, 
                                                                        draft,
                                                                        true ) ) ;
               }
            }

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Draft Symptoms                                          */
            /*                                                           */
            /*-----------------------------------------------------------*/
            else if ( displayRec instanceof SymptomDraftDisplayRec ) {
               SymptomDraft draft = AvalonCache.readSymptomDraft ( ((SymptomDraftDisplayRec)displayRec).getSymptomInd() ) ;

               if ( draft != null ) {
                  if ( draft.getTypeWorkRequired ().getInd() == TypeList.WORKREQ_DELETE ) {

                     draft.setArchived ( true ) ;
                     if ( draft.writeToDatabase() == 0 )
                        OAObjectArchiver.archiveObject ( draft, null ) ;
                  } else
                     WindowSystem.createPanel ( new SymptomEditorPanel ( this, 
                                                                         draft,
                                                                         true ) ) ;
               }
            }


            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Links                                                   */
            /*                                                           */
            /*-----------------------------------------------------------*/
            else if ( displayRec instanceof LinkDraftDisplayRec ) {

               if ( ((LinkDraftDisplayRec)displayRec).getLinkType() == QUEST_LINK ) {
                  QuestLinkDraft draft = (QuestLinkDraft) AvalonCache.readLinkDraft ( ((LinkDraftDisplayRec)displayRec).getLinkInd(), QUEST_LINK ) ;

                  if ( ( draft != null ) && ( validateLink ( draft ) ) ) {
                     if ( draft.getTypeWorkRequired ().getInd() == TypeList.WORKREQ_DELETE ) {

                        draft.setArchived ( true ) ;
                        if ( draft.writeToDatabase() == 0 )
                           OAObjectArchiver.archiveObject ( draft, null ) ;
                     } else
                        WindowSystem.createPanel ( new LinkEditorPanel ( this, draft, true ) ) ;
                  }
               }

               else {
                  ExternalLinkDraft draft = (ExternalLinkDraft) AvalonCache.readLinkDraft ( ((LinkDraftDisplayRec)displayRec).getLinkInd(), EXTERNAL_LINK ) ;

                  if ( ( draft != null ) && ( validateLink ( draft ) ) ) {
                     if ( draft.getTypeWorkRequired ().getInd() == TypeList.WORKREQ_DELETE ) {

                        draft.setArchived ( true ) ;
                        if ( draft.writeToDatabase() == 0 )
                           OAObjectArchiver.archiveObject ( draft, null ) ;
                     } else
                        WindowSystem.createPanel ( new LinkEditorPanel ( this, draft, true ) ) ;
                  }
               }
            }

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Draft LinkGroups                                        */
            /*                                                           */
            /*-----------------------------------------------------------*/
            else if ( displayRec instanceof LinkGroupDraftDisplayRec ) {
               LinkGroupDraft draft = AvalonCache.readLinkGroupDraft ( ((LinkGroupDraftDisplayRec)displayRec).getLinkGroupInd() ) ;

               if ( draft != null ) {
                  if ( draft.getTypeWorkRequired ().getInd() == TypeList.WORKREQ_DELETE ) {

                     draft.setArchived ( true ) ;
                     if ( draft.writeToDatabase() == 0 )
                        OAObjectArchiver.archiveObject ( draft, null ) ;
                  } else
                     WindowSystem.createPanel ( new LinkGroupEditorPanel ( this, 
                                                                           draft,
                                                                           true ) ) ;
               }
            }

            else
               GUISystem.printBox ( Str.getStr ( STR_INFO ),
                                    Str.getStr ( STR_CANNOT_COMPLETE_OBJECT )+" "+displayRec.toString() ) ;


            i++ ;
         } /* while  */


      } else
         GUISystem.printBox ( STR_INFO, STR_MUST_SELECT_ITEM ) ;
   }



   /*------------------------------------------------------------*/
   /* validateLink
    */
   /**
    *    This method will validate the link being
    *  edited. It will return TRUE if the validation was
    *  without error
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return boolean
    *//*---------------------------------------------------------*/
   private boolean validateLink ( LinkDraft link ) {
      return( !(new SoftValidateDlg ( GUISystem.getParentDefWin ( this ), 
                                      LinkSoftValidator.validateLink ( link ) ).getHadErrors()) ) ;
   }


   /*------------------------------------------------------------*/
   /* validateAction
    */
   /**
    *    This method will validate the symptom being
    *  edited. It will return TRUE if the validation was
    *  without error
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return boolean
    *//*---------------------------------------------------------*/
   private boolean validateAction ( ActionDraft action ) {
      return( !(new SoftValidateDlg ( GUISystem.getParentDefWin ( this ), 
                                      ActionSoftValidator.validateAction ( action ) ).getHadErrors()) ) ;
   }



   /*------------------------------------------------------------*/
   /* validateQuestion
    */
   /**
    *    This method will validate the symptom being
    *  edited. It will return TRUE if the validation was
    *  without error
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return boolean
    *//*---------------------------------------------------------*/
   private boolean validateQuestion ( QuestionDraft question ) {
      return( !(new SoftValidateDlg ( GUISystem.getParentDefWin ( this ), 
                                      QuestionSoftValidator.validateQuestion ( question ) ).getHadErrors()) ) ;
   }



} /* OANavPanel */
