package com.ibm.nzna.projects.qit.avalon.oanav.searchreplace ;                    
/*-----------------------------------------------------------*/
/*   SearchReplaceFieldStep                                  */
/*                                                           */
/*   Description:                                            */
/*      Source code for: SearchReplaceFieldStep              */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import javax.swing.* ;
import java.awt.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.gui.wizard.* ;
import com.ibm.nzna.shared.util.* ;         
/**
 * This step asks the user what field they want to edit 
 *
 *
 * @version 1.0, 6/7/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   SearchReplaceFieldStep                                  */
/*                                                           */
/*-----------------------------------------------------------*/
public class SearchReplaceFieldStep extends WizardStep implements AppConst {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   GUI Controls                                            */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private JLabel      st_HELP        = new JLabel () ;
   private JList       lb_FIELDS      = new JList() ;
   private JScrollPane scr_FIELDS     = new JScrollPane ( lb_FIELDS ) ;      


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private SearchReplaceRec searchReplaceRec = null ;




   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will create and initialize our panel
    *  
    *  
    *
    *  @param searchReplaceRec The SearchReplaceRec to alter
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public SearchReplaceFieldStep ( SearchReplaceRec searchReplaceRec ) {
      this.searchReplaceRec = searchReplaceRec ;     

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust the GUI                                          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( null ) ;
      add ( st_HELP ) ;
      add ( scr_FIELDS ) ;
      st_HELP.setVerticalAlignment ( SwingConstants.TOP ) ;    
      GUISystem.setPropertiesOnPanel ( this ) ;       

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Refresh our data                                        */
      /*                                                           */
      /*-----------------------------------------------------------*/
      st_HELP.setText ( Str.getStr ( STR_SEARCH_REPLACE_WIZARD_FIELD_HELP ) ) ;
      lb_FIELDS.setListData ( searchReplaceRec.getFieldDescripts() ) ;

   }




   /*------------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will lay out and position our controls
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size = getSize() ;

      st_HELP.setBounds ( 0, 0, size.width, 150 ) ;
      scr_FIELDS.setBounds ( 30, 155, size.width-60, size.height-165 ) ;
   }





   /*------------------------------------------------------------*/
   /* saveInfo
    */
   /**
    *    This method will attempt to save the information
    *  on our step. If the information could not be
    *  saved, then we return FALSE
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return boolean
    *//*---------------------------------------------------------*/
   public boolean saveInfo () {
      String field = (String) lb_FIELDS.getSelectedValue() ;

      if ( field != null )
         searchReplaceRec.setField ( field ) ;

      return( field != null ) ;
   }

} /* SearchReplaceFieldStep */
