package com.ibm.nzna.projects.qit.avalon.oanav.searchreplace ;                    
/*-----------------------------------------------------------*/
/*   SearchReplaceTextStep                                   */
/*                                                           */
/*   Description:                                            */
/*      Source code for: SearchReplaceTextStep               */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import javax.swing.* ;
import java.awt.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.gui.wizard.* ;
import com.ibm.nzna.shared.util.* ;         
/**
 * This step asks the user what field they want to edit 
 *
 *
 * @version 1.0, 6/7/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   SearchReplaceTextStep                                   */
/*                                                           */
/*-----------------------------------------------------------*/
public class SearchReplaceTextStep extends WizardStep implements AppConst {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   GUI Controls                                            */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private JLabel      st_HELP        = new JLabel ( Str.getStr ( STR_SEARCH_REPLACE_WIZARD_TEXT_HELP ) ) ;
   private JLabel      st_SEARCH      = new JLabel ( Str.getStr ( STR_SEARCH ) ) ;
   private JLabel      st_REPLACE     = new JLabel ( Str.getStr ( STR_REPLACE ) ) ;
   private JTextField  ef_SEARCH      = new JTextField ( "" ) ;
   private JTextField  ef_REPLACE     = new JTextField ( "" ) ;


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private SearchReplaceRec searchReplaceRec = null ;




   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will create and initialize our panel
    *  
    *  
    *
    *  @param searchReplaceRec The SearchReplaceRec to alter
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public SearchReplaceTextStep ( SearchReplaceRec searchReplaceRec ) {
      this.searchReplaceRec = searchReplaceRec ;     

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust the GUI                                          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( null ) ;
      add ( st_HELP ) ;
      add ( st_SEARCH ) ;
      add ( st_REPLACE ) ;
      add ( ef_SEARCH ) ;
      add ( ef_REPLACE ) ;
      st_HELP.setVerticalAlignment ( SwingConstants.TOP ) ;    
      GUISystem.setPropertiesOnPanel ( this ) ;       

   }




   /*------------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will lay out and position our controls
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size      = getSize() ;
      int       y         = 0 ;
      int       x         = 15 ;
      int       rowHeight = GUISystem.getRowHeight() ;

      st_HELP.setBounds ( 0, 0, size.width, 150 ) ;
      y+=150 ;

      st_SEARCH.setBounds ( x, y, 75, rowHeight ) ;
      ef_SEARCH.setBounds ( x+75, y, size.width-(x+80), rowHeight ) ;
      y+=rowHeight*2 ;

      st_REPLACE.setBounds ( x, y, 75, rowHeight ) ;
      ef_REPLACE.setBounds ( x+75, y, size.width-(x+80), rowHeight ) ;

   }





   /*------------------------------------------------------------*/
   /* saveInfo
    */
   /**
    *    This method will attempt to save the information
    *  on our step. If the information could not be
    *  saved, then we return FALSE
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return boolean
    *//*---------------------------------------------------------*/
   public boolean saveInfo () {
      String searchText  = ef_SEARCH.getText() ;
      String replaceText = ef_REPLACE.getText() ;

      if ( ( searchText != null ) &&
           ( searchText.length() > 0 ) && 
           ( replaceText != null ) &&
           ( replaceText.length() > 0 ) ) {

         searchReplaceRec.setFromString ( searchText ) ;
         searchReplaceRec.setToString ( replaceText ) ;
         return( true ) ;
      }

      return( false ) ;
   }

} /* SearchReplaceTextStep */
