package com.ibm.nzna.projects.qit.avalon.oanav.views ;          
/*-----------------------------------------------------------*/
/*   OANavView                                               */
/*                                                           */
/*   Description:                                            */
/*      Source code for: OANavView                           */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.projects.common.quest.type.* ;
import javax.swing.tree.* ;
/**
 * This interface must be implemented for a view to show up in the 
 * Online Assistant Navigator
 *
 * @version 1.0, 4/18/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   OANavView                                               */
/*                                                           */
/*-----------------------------------------------------------*/
public interface OANavView {





   /*------------------------------------------------------------*/
   /* setBrand
    */
   /**
    *    This method will set the brand that the
    *  view needs to be based on
    *  
    *
    *  @param brandRec The TypeBrandRec to set the view on
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public abstract void setBrand ( TypeBrandRec brandRec ) ;





   /*------------------------------------------------------------*/
   /* getName
    */
   /**
    *    This method should return the name of
    *  a view. The name must be user readable
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public abstract String getName () ;





   /*------------------------------------------------------------*/
   /* getJTreeModel
    */
   /**
    *    This method must return the complete DefaultTreeModel
    *  needed to display the view
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return DefaultTreeModel
    *//*---------------------------------------------------------*/
   public abstract DefaultTreeModel getJTreeModel () ;





   /*------------------------------------------------------------*/
   /* getShortName
    */
   /**
    *    This method should return a short name of the
    *  actual 'name' from getName
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public abstract String getShortName () ;





   /*------------------------------------------------------------*/
   /* getKey
    */
   /**
    *    This method should return the key, or the
    *  names of the columns returned in a view
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public abstract String getKey () ;
} /* OANavView */
