package com.ibm.nzna.projects.qit.avalon.oanav.views ;         
/*-----------------------------------------------------------*/
/*   ViewArchivedLink                                        */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ViewArchivedLink                    */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import javax.swing.tree.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.shared.gui.* ;
/**
 * This view will list Links by their type. Their 
 * type is 'Document(0)' and 'URL(1)
 *
 * @version 1.0, 4/18/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ViewArchivedLink                                        */
/*                                                           */
/*-----------------------------------------------------------*/
public class ViewArchivedLink extends Object implements OANavView, AppConst {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private  DefaultMutableTreeNode root     = null ;



   /*------------------------------------------------------------*/
   /* getName
    */
   /**
    *    This method will return the user readable
    *  description of this view
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getName () {
      return( Str.getStr ( STR_ARCHIVED )+" "+Str.getStr ( STR_DOC_LINKS ) ) ;
   }

   /*------------------------------------------------------------*/
   /* getKey
    */
   /**
    *    This method will return the key, or the names
    *  of the columns returned, from this view
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getKey () {
      return( Str.getStr ( STR_DOC_CLASS )+", "+
              Str.getStr ( STR_INDICATOR )+", "+
              Str.getStr ( STR_TITLE )+" "+
              Str.getStr ( STR_LAST_TOUCHED_ON )+", "+
              Str.getStr ( STR_LAST_TOUCHED_BY ) ) ;
   }



   /*------------------------------------------------------------*/
   /* getShortName
    */
   /**
    *    This method will return the user readable
    *  description of this view
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getShortName () {
      return( Str.getStr ( STR_DOC_LINKS ) ) ;
   }




   /*------------------------------------------------------------*/
   /* setBrand
    */
   /**
    *    This method will set the brand that this
    *  view will be based on
    *  
    *
    *  @param brandRec The BrandRec to base the view on
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setBrand ( TypeBrandRec brandRec ) {
   }





   /*------------------------------------------------------------*/
   /* getJTreeModel
    */
   /**
    *    This method will return the complete DefaultTreeModel
    *  needed to show this view
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return DefaultTreeModel
    *//*---------------------------------------------------------*/
   public DefaultTreeModel getJTreeModel () {
      DefaultTreeModel model  = null ;
      ViewTreeNode     node   = null ;

      model = new DefaultTreeModel ( root = new DefaultMutableTreeNode("") ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Link Type, Quest Document Link                          */                     
      /*                                                           */
      /*-----------------------------------------------------------*/
      node = new ViewTreeNode ( Str.getStr ( STR_DOC_LINKS ), null ) ;

      node.setSQL ( "SELECT A.LINKIND, B.LNDOCID,     A.DBUSER,  A.CHANGEDTIME, "+
                    "       A.URLVALID, A.DOCIND,     C.TITLE,   A.LINKTYPE "+
                    "FROM OA.LINK          A, "+
                    "     TIGRIS.DOCUMENTS B,  "+
                    "     OA.LINKTITLE     C "+
                    "WHERE A.LINKTYPE  = 0 AND "+
                    "      A.DOCIND    = B.DOCIND AND "+
                    "      C.LINKIND   = A.LINKIND AND "+
                    "      A.ARCHIVED  = 'Y' "+
                    "FOR FETCH ONLY" ) ;

      node.add ( new StringTreeNode ( Str.getStr ( STR_PLEASE_WAIT ) ) ) ;
      
      
      
      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Link Type, URL Hot Link                                 */              
      /*                                                           */
      /*-----------------------------------------------------------*/
      model.insertNodeInto ( node, root, 0 ) ;

      node = new ViewTreeNode ( Str.getStr ( STR_URL ), null ) ;
      node.setSQL ( "SELECT A.LINKIND, A.URL,         A.DBUSER,  A.CHANGEDTIME, "+
                    "       A.URLVALID, A.DOCIND,     B.TITLE, A.LINKTYPE "+
                    "FROM   OA.LINK      A, "+
                    "       OA.LINKTITLE B "+
                    "WHERE  LINKTYPE   = 1 AND "+
                    "       B.LINKIND  = A.LINKIND AND "+
                    "       A.ARCHIVED  = 'Y' "+
                    "FOR FETCH ONLY" ) ;

      node.add ( new StringTreeNode ( Str.getStr ( STR_PLEASE_WAIT ) ) ) ;
      model.insertNodeInto ( node, root, 1 ) ;

      return( model ) ;
   }

} /* ViewArchivedLink */
