package com.ibm.nzna.projects.qit.avalon.oanav.views ;         
/*-----------------------------------------------------------*/
/*   ViewDraftLinkType                                       */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ViewDraftLinkType                   */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import javax.swing.tree.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.shared.gui.* ;
/**
 * This view will list draft Links by their type. Their 
 * type is 'Document(0)' and 'URL(1)
 *
 * @version 1.0, 4/18/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ViewDraftLinkType                                       */
/*                                                           */
/*-----------------------------------------------------------*/
public class ViewDraftLinkType extends Object implements OANavView, AppConst {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private  DefaultMutableTreeNode root     = null ;




   /*------------------------------------------------------------*/
   /* getName
    */
   /**
    *    This method will return the user readable
    *  description of this view
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getName () {
      return( Str.getStr ( STR_DRAFT )+" "+Str.getStr ( STR_LINKS )+" "+Str.getStr ( STR_BY_TYPE ) ) ;
   }

   /*------------------------------------------------------------*/
   /* getKey
    */
   /**
    *    This method will return the key, or the names
    *  of the columns returned, from this view
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getKey () {
      return( Str.getStr ( STR_DOC_CLASS )+", "+
              Str.getStr ( STR_INDICATOR )+", "+
              Str.getStr ( STR_TITLE )+" "+
              Str.getStr ( STR_LAST_TOUCHED_ON )+", "+
              Str.getStr ( STR_LAST_TOUCHED_BY ) ) ;
   }


   /*------------------------------------------------------------*/
   /* getShortName
    */
   /**
    *    This method will return the user readable
    *  description of this view
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getShortName () {
      return( Str.getStr ( STR_BY_TYPE ) ) ;
   }




   /*------------------------------------------------------------*/
   /* setBrand
    */
   /**
    *    This method will set the brand that this
    *  view will be based on
    *  
    *
    *  @param brandRec The BrandRec to base the view on
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setBrand ( TypeBrandRec brandRec ) {
   }





   /*------------------------------------------------------------*/
   /* getJTreeModel
    */
   /**
    *    This method will return the complete DefaultTreeModel
    *  needed to show this view
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return DefaultTreeModel
    *//*---------------------------------------------------------*/
   public DefaultTreeModel getJTreeModel () {
      DefaultTreeModel model  = null ;
      ViewTreeNode     node   = null ;

      model = new DefaultTreeModel ( root = new DefaultMutableTreeNode("") ) ;                     


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Link Type, Quest Document Link                          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      node = new ViewTreeNode ( Str.getStr ( STR_DOC_LINKS ), null ) ;

      node.setSQL ( "SELECT A.LINKIND, B.LNDOCID,     A.DBUSER,  A.CHANGEDTIME, "+
                    "       'Y',       A.DOCIND,     C.TITLE,   A.LINKTYPE, A.STARTDATE, A.STOPDATE, A.ACTIVELINKIND "+
                    "FROM OADRAFT.LINK          A, "+
                    "     TIGRIS.DOCUMENTS B,  "+
                    "     OADRAFT.LINKTITLE     C "+
                    "WHERE A.LINKTYPE  = 0 AND "+
                    "      A.DOCIND    = B.DOCIND AND "+
                    "      A.STOPDATE  IS NULL AND "+
                    "      C.LINKIND   = A.LINKIND AND "+
                    "      A.RECYCLED  = 'N' AND "+
                    "      A.ARCHIVED  = 'N' "+
                    "FOR FETCH ONLY" ) ;

      node.add ( new StringTreeNode ( Str.getStr ( STR_PLEASE_WAIT ) ) ) ;              



      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Link Type, URL Hot Link                                 */
      /*                                                           */
      /*-----------------------------------------------------------*/
      model.insertNodeInto ( node, root, 0 ) ;

      node = new ViewTreeNode ( Str.getStr ( STR_URL ), null ) ;
      node.setSQL ( "SELECT A.LINKIND, A.URL,         A.DBUSER,  A.CHANGEDTIME, "+
                    "       A.URLVALID, A.DOCIND,     B.TITLE, A.LINKTYPE, A.STARTDATE, A.STOPDATE, A.ACTIVELINKIND  "+
                    "FROM   OADRAFT.LINK      A, "+
                    "       OADRAFT.LINKTITLE B "+
                    "WHERE  LINKTYPE   = 1 AND "+
                    "       A.STOPDATE  IS NULL AND "+
                    "       B.LINKIND   = A.LINKIND AND "+
                    "       A.ARCHIVED  = 'N' AND "+
                    "       A.RECYCLED  = 'N'  "+
                    "FOR FETCH ONLY" ) ;

      node.add ( new StringTreeNode ( Str.getStr ( STR_PLEASE_WAIT ) ) ) ;
      model.insertNodeInto ( node, root, 1 ) ;

      return( model ) ;
   }

} /* ViewDraftLinkType */
