package com.ibm.nzna.projects.qit.avalon.oanav.views ;         
/*-----------------------------------------------------------*/
/*   ViewOpenDraftAction                                     */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ViewOpenDraftAction                 */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import javax.swing.tree.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.quest.status.* ;
import com.ibm.nzna.shared.gui.* ;
/**
 * This view will list Actions that are open drafts
 *
 * @version 1.0, 4/18/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ViewOpenDraftAction                                     */
/*                                                           */
/*-----------------------------------------------------------*/
public class ViewOpenDraftAction extends Object implements OANavView, AppConst {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private  TypeBrandRec           brandRec = null ;
   private  boolean                draft    = false ;
   private  DefaultMutableTreeNode root     = null ;





   /*------------------------------------------------------------*/
   /* setDraftMode
    */
   /**
    *    This method will do nothing
    *  
    *  
    *
    *  @param draft TRUE = Read from OA_DRAFT tables, FALSE = Read From OA tables.
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setDraftMode ( boolean draft ) {
   }

   /*------------------------------------------------------------*/
   /* getKey
    */
   /**
    *    This method will return the key, or the names
    *  of the columns returned, from this view
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getKey () {
      return( Str.getStr ( STR_DOC_CLASS )+", "+
              Str.getStr ( STR_INDICATOR )+", "+
              Str.getStr ( STR_TITLE )+" "+
              Str.getStr ( STR_LAST_TOUCHED_ON )+", "+
              Str.getStr ( STR_LAST_TOUCHED_BY ) ) ;
   }



   /*------------------------------------------------------------*/
   /* getName
    */
   /**
    *    This method will return the user readable
    *  description of this view
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getName () {
      return( Str.getStr ( STR_OPEN_ACTIONS ) ) ;
   }


   /*------------------------------------------------------------*/
   /* getShortName
    */
   /**
    *    This method will return the user readable
    *  description of this view
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getShortName () {
      return( Str.getStr ( STR_OPEN_ACTIONS ) ) ;
   }




   /*------------------------------------------------------------*/
   /* setBrand
    */
   /**
    *    This method will do nothing
    *  
    *
    *  @param brandRec The BrandRec to base the view on
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setBrand ( TypeBrandRec brandRec ) {
   }





   /*------------------------------------------------------------*/
   /* getJTreeModel
    */
   /**
    *    This method will return the complete DefaultTreeModel
    *  needed to show this view
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return DefaultTreeModel
    *//*---------------------------------------------------------*/
   public DefaultTreeModel getJTreeModel () {
      DefaultTreeModel model  = null ;
      ViewTreeNode     node   = new ViewTreeNode() ;


      model = new DefaultTreeModel ( root = new DefaultMutableTreeNode() ) ;
      node.setName ( Str.getStr ( STR_OPEN_ACTIONS ) ) ;
      model.insertNodeInto ( node, root, 0 ) ;

      node.setSQL  ( "SELECT A.ACTIONIND,   B.DOCCLASSIND, B.TITLE, "+
                     "       A.CHANGEDTIME, A.DBUSER,      A.STARTDATE, A.STOPDATE, B.SORTORDER "+     
                     "FROM   OADRAFT.ACTION        A, "+
                     "       OADRAFT.ACTIONTITLE   B  "+
                     "WHERE  A.STOPDATE       IS NULL AND "+
                     "       B.ACTIONIND      = A.ACTIONIND   AND "+
                     "       A.RECYCLED       = 'N' AND "+
                     "       ORDER BY A.ACTIONIND, B.SORTORDER DESC "+
                     "FOR FETCH ONLY" ) ;

      /* Insert the 'Please Wait' node */
      model.insertNodeInto ( new StringTreeNode ( Str.getStr ( STR_PLEASE_WAIT ) ), node, 0 ) ;

      return( model ) ;
   }





} /* ViewOpenDraftAction */
