package com.ibm.nzna.projects.qit.avalon.oanav.views ;         
/*-----------------------------------------------------------*/
/*   ViewOpenDraftQuestion                                   */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ViewOpenDraftQuestion               */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import javax.swing.tree.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.shared.gui.* ;
/**
 * This view will list Actions by their geography, 
 *
 * @version 1.0, 4/18/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ViewOpenDraftQuestion                                   */
/*                                                           */
/*-----------------------------------------------------------*/
public class ViewOpenDraftQuestion extends Object implements OANavView, AppConst {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private  TypeBrandRec           brandRec = null ;
   private  DefaultMutableTreeNode root     = null ;





   /*------------------------------------------------------------*/
   /* setDraftMode
    */
   /**
    *    This method will does nothing
    *  
    *  
    *
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setDraftMode ( boolean draft ) {
   }


   /*------------------------------------------------------------*/
   /* getKey
    */
   /**
    *    This method will return the key, or the names
    *  of the columns returned, from this view
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getKey () {
      return( Str.getStr ( STR_DOC_CLASS )+", "+
              Str.getStr ( STR_INDICATOR )+", "+
              Str.getStr ( STR_TITLE )+" "+
              Str.getStr ( STR_LAST_TOUCHED_ON )+", "+
              Str.getStr ( STR_LAST_TOUCHED_BY ) ) ;
   }


   /*------------------------------------------------------------*/
   /* getName
    */
   /**
    *    This method will return the user readable
    *  description of this view
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getName () {
      return( Str.getStr ( STR_OPEN_QUESTIONS ) ) ;
   }




   /*------------------------------------------------------------*/
   /* getShortName
    */
   /**
    *    This method will return the user readable
    *  description of this view
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getShortName () {
      return( Str.getStr ( STR_OPEN_QUESTIONS ) ) ;
   }




   /*------------------------------------------------------------*/
   /* setBrand
    */
   /**
    *    This method will do nothing
    *  
    *
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setBrand ( TypeBrandRec brandRec ) {
   }





   /*------------------------------------------------------------*/
   /* getJTreeModel
    */
   /**
    *    This method will return the complete DefaultTreeModel
    *  needed to show this view
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return DefaultTreeModel
    *//*---------------------------------------------------------*/
   public DefaultTreeModel getJTreeModel () {
      DefaultTreeModel model  = null ;
      ViewTreeNode     node   = null ;


      model = new DefaultTreeModel ( root = new DefaultMutableTreeNode() ) ;
      node  = new ViewTreeNode ( Str.getStr ( STR_QUESTIONS ), null ) ;

      model.insertNodeInto ( node, root, 0 ) ;

      node.setSQL  ( "SELECT A.QUESTIONIND, A.STARTTIME, B.DOCCLASSIND, B.TITLE, "+
                     "       A.DBUSER,     A.CHANGEDTIME, A.STARTDATE, A.STOPDATE, B.SORTORDER "+
                     "FROM   OADRAFT.QUESTION        A, "+
                     "       OADRAFT.QUESTIONTITLE   B  "+
                     "WHERE  A.ARCHIVED       = 'N' AND "+
                     "       A.RECYCLED       = 'N' AND "+
                     "       B.QUESTIONIND    = A.QUESTIONIND AND "+
                     "       A.STOPDATE       IS NULL AND "+
                     "       ORDER BY A.QUESTIONIND, B.SORTORDER DESC "+
                     "FOR FETCH ONLY" ) ;

      /* Insert the 'Please Wait' node */
      model.insertNodeInto ( new StringTreeNode ( Str.getStr ( STR_PLEASE_WAIT ) ), node, 0 ) ;



      return( model ) ;
   }





} /* ViewOpenDraftQuestion */
