package com.ibm.nzna.projects.qit.avalon.oanav.views ;         
/*-----------------------------------------------------------*/
/*   ViewOrphanedLinkGroup                                   */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ViewOrphanedLinkGroup               */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import javax.swing.tree.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.shared.gui.* ;
/**
 * This view will list OrphanedLinkGroups.
 *
 * @version 1.0, 4/18/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ViewOrphanedLinkGroup                                   */
/*                                                           */
/*-----------------------------------------------------------*/
public class ViewOrphanedLinkGroup extends Object implements OANavView, AppConst {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private  DefaultMutableTreeNode root     = null ;

   /*------------------------------------------------------------*/
   /* getName
    */
   /**
    *    This method will return the user readable
    *  description of this view
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getName () {
      return( Str.getStr ( STR_ORPHANED )+" "+Str.getStr ( STR_LINK_GROUPS ) ) ;
   }

   /*------------------------------------------------------------*/
   /* getKey
    */
   /**
    *    This method will return the key, or the names
    *  of the columns returned, from this view
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getKey () {
      return( Str.getStr ( STR_INDICATOR )+", "+
              Str.getStr ( STR_TITLE )+" "+
              Str.getStr ( STR_LAST_TOUCHED_ON )+", "+
              Str.getStr ( STR_LAST_TOUCHED_BY ) ) ;
   }


   /*------------------------------------------------------------*/
   /* getShortName
    */
   /**
    *    This method will return the user readable
    *  description of this view
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getShortName () {
      return( Str.getStr ( STR_LINK_GROUPS ) ) ;
   }




   /*------------------------------------------------------------*/
   /* setBrand
    */
   /**
    *    This method will set the brand that this
    *  view will be based on
    *  
    *
    *  @param brandRec The BrandRec to base the view on
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setBrand ( TypeBrandRec brandRec ) {
   }





   /*------------------------------------------------------------*/
   /* getJTreeModel
    */
   /**
    *    This method will return the complete DefaultTreeModel
    *  needed to show this view
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return DefaultTreeModel
    *//*---------------------------------------------------------*/
   public DefaultTreeModel getJTreeModel () {
      DefaultTreeModel model     = null ;
      ViewTreeNode     node      = null ;

      model = new DefaultTreeModel ( root = new DefaultMutableTreeNode("") ) ;                     

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Link Type, Quest Document Link                          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      node = new ViewTreeNode ( Str.getStr ( STR_LINK_GROUPS ), null ) ;

      try {
         node.setSQL ( "SELECT DISTINCT ( A.LINKGROUPIND ), B.TITLE, A.DBUSER, A.CHANGEDTIME  "+
                       "FROM OA.LINKGROUP      A, "+
                       "     OA.LINKGROUPTITLE B   "+
                       "WHERE A.LINKGROUPIND = B.LINKGROUPIND AND "+
                       "      A.LINKGROUPIND NOT IN (SELECT LINKGROUPIND FROM OA.ACTIONLINK WHERE LINKGROUPIND IS NOT NULL) AND "+
                       "      A.LINKGROUPIND NOT IN (SELECT LINKGROUPIND FROM OA.QUESTIONLINK WHERE LINKGROUPIND IS NOT NULL) AND "+
                       "      B.LANGUAGEIND  = "+PropertySystem.getInt ( PropertySystem.getInt ( PropertySystem.PROPERTY_LANGUAGE ) )+" "+
                       "FOR FETCH ONLY" ) ;
      } catch ( Exception e ) {

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Default to english                                      */
         /*                                                           */
         /*-----------------------------------------------------------*/
         node.setSQL ( "SELECT DISTINCT ( A.LINKGROUPIND ), B.TITLE, A.DBUSER, A.CHANGEDTIME "+
                       "FROM OA.LINKGROUP      A, "+
                       "     OA.LINKGROUPTITLE B   "+
                       "WHERE A.LINKGROUPIND = B.LINKGROUPIND AND "+
                       "      A.LINKGROUPIND NOT IN (SELECT LINKGROUPIND FROM OA.ACTIONLINK WHERE LINKGROUPIND IS NOT NULL) AND "+
                       "      A.LINKGROUPIND NOT IN (SELECT LINKGROUPIND FROM OA.QUESTIONLINK WHERE LINKGROUPIND IS NOT NULL) AND "+
                       "      B.LANGUAGEIND  = 1 "+
                       "FOR FETCH ONLY" ) ;
      }

      node.add ( new StringTreeNode ( Str.getStr ( STR_PLEASE_WAIT ) ) ) ;
      model.insertNodeInto ( node, root, 0 ) ;


      return( model ) ;
   }

} /* ViewOrphanedLinkGroup */
