package com.ibm.nzna.projects.qit.avalon.oanav.views ;         
/*-----------------------------------------------------------*/
/*   ViewOrphanedQuestion                                    */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ViewOrphanedQuestion                */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import javax.swing.tree.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.quest.status.* ;
import com.ibm.nzna.shared.gui.* ;
/**
 * This view will list Questions by their geography, 
 *
 * @version 1.0, 4/18/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ViewOrphanedQuestion                                    */
/*                                                           */
/*-----------------------------------------------------------*/
public class ViewOrphanedQuestion extends Object implements OANavView, AppConst {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private  TypeBrandRec           brandRec = null ;
   private  DefaultMutableTreeNode root     = null ;


   /*------------------------------------------------------------*/
   /* getName
    */
   /**
    *    This method will return the user readable
    *  description of this view
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getName () {
      return( Str.getStr ( STR_ORPHANED )+" "+Str.getStr ( STR_QUESTIONS ) ) ;
   }

   /*------------------------------------------------------------*/
   /* getKey
    */
   /**
    *    This method will return the key, or the names
    *  of the columns returned, from this view
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getKey () {
      return( Str.getStr ( STR_DOC_CLASS )+", "+
              Str.getStr ( STR_INDICATOR )+", "+
              Str.getStr ( STR_TITLE )+" "+
              Str.getStr ( STR_LAST_TOUCHED_ON )+", "+
              Str.getStr ( STR_LAST_TOUCHED_BY ) ) ;
   }


   /*------------------------------------------------------------*/
   /* getShortName
    */
   /**
    *    This method will return the user readable
    *  description of this view
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getShortName () {
      return( Str.getStr ( STR_QUESTIONS ) ) ;
   }



   /*------------------------------------------------------------*/
   /* setBrand
    */
   /**
    *    This method will set the brand that this
    *  view will be based on
    *  
    *
    *  @param brandRec The BrandRec to base the view on
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setBrand ( TypeBrandRec brandRec ) {
      this.brandRec = brandRec ;
   }





   /*------------------------------------------------------------*/
   /* getJTreeModel
    */
   /**
    *    This method will return the complete DefaultTreeModel
    *  needed to show this view
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return DefaultTreeModel
    *//*---------------------------------------------------------*/
   public DefaultTreeModel getJTreeModel () {
      DefaultTreeModel model  = null ;
      ViewTreeNode     node   = null ;


      model = new DefaultTreeModel ( root = new DefaultMutableTreeNode() ) ;
      node = new ViewTreeNode() ;
      node.setName ( Str.getStr ( STR_QUESTIONS ) ) ;
      model.insertNodeInto ( node, root, 0 ) ;

      node.setSQL  ( "SELECT A.QUESTIONIND, B.DOCCLASSIND, B.TITLE, "+
                     "       A.DBUSER,      A.CHANGEDTIME, B.SORTORDER "+
                     "FROM   OA.QUESTION        A, "+
                     "       OA.QUESTIONTITLE   B  "+
                     "WHERE  A.QUESTIONIND NOT IN (SELECT QUESTIONIND FROM OA.NODE WHERE QUESTIONIND IS NOT NULL) AND "+
                     "       B.QUESTIONIND    = A.QUESTIONIND "+
                     "       ORDER BY A.QUESTIONIND, B.SORTORDER DESC "+
                     "FOR FETCH ONLY" ) ;

      /* Insert the 'Please Wait' node */
      model.insertNodeInto ( new StringTreeNode ( Str.getStr ( STR_PLEASE_WAIT ) ), node, 0 ) ;


      return( model ) ;
   }





} /* ViewOrphanedQuestion */
