package com.ibm.nzna.projects.qit.batchrunner ;   
/*-----------------------------------------------------------*/
/*   BatchRunner                                             */
/*                                                           */
/*   Description:                                            */
/*      Source code for: BatchRunner                         */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import javax.swing.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
/**
 * This quest applet is primarily meant to be used to run NZNA Standard Batches. 
 *
 *
 * @version 1.0, 4/4/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   BatchRunner                                             */
/*                                                           */
/*-----------------------------------------------------------*/
public class BatchRunner extends Object implements AppConst, QuestApplet, Authority {




   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This constructor does nothing
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public BatchRunner () {
   }






   /*------------------------------------------------------------*/
   /* getIcon
    */
   /**
    *    This method will return the icon associated
    *  with this Applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public ImageIcon getIcon () {
      return( ImageSystem.getImageIcon ( MainWindow.getInstance(), ImageSystem.SAVE ) ) ;
   }


   /*------------------------------------------------------------*/
   /* getSmallIcon
    */
   /**
    *    This method will return the icon associated
    *  with this Applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public ImageIcon getSmallIcon () {
      return( ImageSystem.getImageIcon ( MainWindow.getInstance(), ImageSystem.SAVE ) ) ;
   }




   /*------------------------------------------------------------*/
   /* getName
    */
   /**
    *    This method will return the name of thsi 
    *  quest applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public String getName () {
      return( Str.getStr ( STR_BATCH_RUNNER ) ) ;
   }




   /*------------------------------------------------------------*/
   /* getDescription
    */
   /**
    *    This method will return the long description
    *  of this Applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public String getDescription () {
      return( Str.getStr ( STR_BATCH_RUNNER_HELP ) ) ;
   }





   /*------------------------------------------------------------*/
   /* start
    */
   /**
    *    This method will be called when we have
    *  been initialized and we need to start our
    *  applet
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void start () {
      WindowSystem.createPanel ( new BatchRunnerPanel () ) ;
   }




   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will be called when we need
    *  to initialize ourselved.
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return TRUE if initialize went ok
    *//*---------------------------------------------------------*/
   public boolean initialize () {
      return( true ) ;
   }




   /*------------------------------------------------------------*/
   /* stop
    */
   /**
    *    This method will be called when we are
    *  needed to stop and release our resources
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void stop () {
   }





   /*------------------------------------------------------------*/
   /* getAuthority
    */
   /**
    *    This method will return the authority
    *  needed to run this applet. The authority
    *  needed is super user
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public int getAuthority () {
      return( AUTH_SUPERUSER ) ;
   }





   /*------------------------------------------------------------*/
   /* canChat
    */
   /**
    *    This methodw will return false
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean canChat () {
      return( false ) ;
   }





} /* BatchRunner */
