package com.ibm.nzna.projects.qit.bookmark ;           
/*-----------------------------------------------------------*/
/*   BookmarkListener                                        */
/*                                                           */
/*   Description:                                            */
/*      Source code for: BookmarkListener                    */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This listener will be notified of events from the BookmarkSystem. 
 *
 *
 * @version 1.0, 4/30/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   BookmarkListener                                        */
/*                                                           */
/*-----------------------------------------------------------*/
public interface BookmarkListener {





   /*------------------------------------------------------------*/
   /* bookmarkAdded
    */
   /**
    *    This method will be called when a bookmark
    *  is added
    *  
    *
    *  @param bookmark The Bookmark that was added
    *
    *//*---------------------------------------------------------*/
   public abstract void bookmarkAdded ( Bookmark bookmark ) ;




   /*------------------------------------------------------------*/
   /* bookmarkRemoved
    */
   /**
    *    This method will be called when a bookmark
    *  is removed
    *  
    *
    *  @param bookmark The bookmark that was removed
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public abstract void bookmarkRemoved ( Bookmark bookmark ) ;
} /* BookmarkListener */
