package com.ibm.nzna.projects.qit.bookmark ;
/*-----------------------------------------------------------*/
/*   BookmarkTreeComponent                                   */
/*                                                           */
/*   Description:                                            */
/*      Source code for: BookmarkTreeComponent               */
/*                                                           */
/*                                                           */
/*         @Copyright  1998 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import javax.swing.* ;
import java.awt.* ;      
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.projects.qit.app.* ;
/**
 * This Renderer which do the actual drawing work for items in
 * a JTree. This renderer will automagically draw the correct
 * image next to each bookmark also.
 *
 *
 * @version 1.0, 1/4/1999 
 * @author  David Lentz
 */


/*-----------------------------------------------------------*/
/*                                                           */
/*   BookmarkTreeComponent                                   */
/*                                                           */
/*-----------------------------------------------------------*/
public class BookmarkTreeComponent extends DefaultTreeComponent implements AppConst {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Members                                                 */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private static final Color blue = new Color ( 0, 0, 150 ) ;


   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will create a blank BookmarkTreeComponent
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public BookmarkTreeComponent () {
      super() ;
      prefSize = new Dimension ( 640, 18 ) ;
   }


   /*------------------------------------------------------------*/
   /* paint
    */
   /**
    *    This method will paint our component
    *  
    *  
    *
    *  @param g The Graphics context
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void paint ( Graphics g ) {

      if ( data instanceof StringTreeNode ) {
         Dimension size      = getSize() ;
         Bookmark  bookmark  = (Bookmark)((StringTreeNode)data).getData() ;
         ImageIcon imageIcon = null ;

         if ( bookmark != null ) {
            if ( ( expanded ) && ( bookmark.isFolder() ) )
               imageIcon = ImageSystem.getImageIcon ( this, ImageSystem.OPEN_FOLDER ) ;
            else if ( bookmark.isFolder() )
               imageIcon = ImageSystem.getImageIcon ( this, ImageSystem.CLOSE_FOLDER ) ;
            else
               imageIcon = bookmark.getIcon() ;

            if ( selected )
               g.setColor ( blue ) ;
            else
               g.setColor ( Color.white ) ;

            g.fillRect ( 0, 0, size.width, size.height ) ;

            if ( selected )
               g.setColor ( Color.white ) ;
            else
               g.setColor ( Color.black ) ;

            g.drawImage ( imageIcon.getImage(), 0, 0, this ) ;
            if ( bookmark.getDescript() != null )
               g.drawString ( bookmark.getDescript(), 25, 12 ) ;
         } else
            g.drawString ( data.toString(), 25, 12 ) ;

      } 


   }


} /* BookmarkTreeComponent */
