package com.ibm.nzna.projects.qit.chat ;
/*-----------------------------------------------------------*/
/*   ChatUser                                                */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ChatUser                            */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This record holds information about on-line quest chatters 
 *
 *
 * @version 1.0, 9/1/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ChatUser                                                */
/*                                                           */
/*-----------------------------------------------------------*/
public class ChatUser extends Object {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private String name     = null ;
   private String ipAddr   = null ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will create a blank record
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public ChatUser () {
   }





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will create and initialize the ChatUser
    *  record to the values passed in
    *  
    *
    *  @param name The name of the chatter
    *  @param ipAddr The IP Address of the person
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public ChatUser ( String name, String ipAddr ) {
      setName ( name ) ;
      setIPAddr ( ipAddr ) ;
   }




   /*------------------------------------------------------------*/
   /* setName
    */
   /**
    *    This method will set the person's name
    *  
    *  
    *
    *  @param name The person's name
    *  @param 
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setName ( String name ) {
      this.name = name ;
   }




   /*------------------------------------------------------------*/
   /* setIPAddr
    */
   /**
    *    This method will set the ip address of the
    *  person
    *  
    *
    *  @param ipAddr Must be a valid I/P Address
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setIPAddr ( String ipAddr ) {
      this.ipAddr = ipAddr ;
   }





   /*------------------------------------------------------------*/
   /* getName
    */
   /**
    *    This method will return the person's name
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public String getName () {
      return( name ) ;
   }




   /*------------------------------------------------------------*/
   /* getIPAddr
    */
   /**
    *    This method will return this person;s
    *  I/P Address
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public String getIPAddr () {
      return( ipAddr ) ;
   }





   /*------------------------------------------------------------*/
   /* toString
    */
   /**
    *    This method just returns the name of the person
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String toString () {
      return ( name ) ;
   }
} /* ChatUser */
