package com.ibm.nzna.projects.qit.chat ;      
/*-----------------------------------------------------------*/
/*   GetChatUserDlg                                          */
/*                                                           */
/*   Description:                                            */
/*      Source code for: GetChatUserDlg                      */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import javax.swing.* ;
import com.ibm.nzna.projects.qit.app.* ; 
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.util.* ;
/**
 * This dialog allows the user to select an on-line chat person 
 *
 *
 * @version 1.0, 1/18/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   GetChatUserDlg                                          */
/*                                                           */
/*-----------------------------------------------------------*/
public class GetChatUserDlg extends JDialog implements AppConst {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private GUI Members                                     */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private JScrollPane     scrollPane  = null ;
   private JList           users       = null ;
   private JLabel          st_STATUS   = null ;
   private JLabel          st_IMAGE    = null ;
   private DButton         pb_OK       = null ;
   private DButton         pb_CANCEL   = null ;
   private ButtonPanel     buttonPanel = null ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This constructor puts up our dialog and
    *  does not return until the user acts on it. You
    *  can retrieve the results selected by calling 'getChatUser'
    *
    *  @param parent The Parent Frame
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public GetChatUserDlg ( Frame parent ) {
      super ( parent, Str.getStr ( STR_CHAT ), true ) ;

      initialize() ;

      setVisible ( true ) ;
   }





   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will initialize our window
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void initialize () {
      Container contentPane = getContentPane() ;          

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create the controls                                     */
      /*                                                           */
      /*-----------------------------------------------------------*/
      users       = new JList () ;
      scrollPane  = new JScrollPane ( users ) ;
      buttonPanel = new ButtonPanel () ;
      pb_OK       = new DButton ( Str.getStr ( STR_OK ) ) ;
      pb_CANCEL   = new DButton ( Str.getStr ( STR_CANCEL ) ) ;
      st_IMAGE    = new JLabel ( ImageSystem.getImageIcon ( this, ImageSystem.LARGE_CHAT ) ) ;
      st_STATUS   = new JLabel ( Str.getStr ( STR_PLEASE_WAIT ) ) ;       

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add our controls                                        */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( null ) ;
      buttonPanel.add ( pb_OK ) ;
      buttonPanel.add ( pb_CANCEL ) ;
      contentPane.add ( st_IMAGE ) ;
      contentPane.add ( st_STATUS ) ;
      contentPane.add ( scrollPane ) ;
      contentPane.add ( buttonPanel ) ;        



      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      GUISystem.setPropertiesOnPanel ( contentPane ) ;


      setSize ( 300, 450 ) ;
      WinUtil.centerChildInParent ( this, getParent() ) ;

   }


   
   
   
      /*------------------------------------------------------------*/
      /* doLayout
       */
      /**
       *    This method will lay out and position our controls
       *  
       *  
       *
       *  @param None
       *  @param None
       *  @param None
       *
       *  @return Nothing
       *//*---------------------------------------------------------*/

} /* GetChatUserDlg */
