package com.ibm.nzna.projects.qit.customer ;
/*-----------------------------------------------------------*/
/*   Customer                                                */
/*                                                           */
/*   Description:                                            */
/*      Source code for: Customer                            */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.common.quest.* ;
import com.ibm.nzna.shared.db.* ;
import com.ibm.nzna.projects.qit.customer.custmaint.* ;
import java.awt.* ;
import javax.swing.* ;
/**
 * This is the QuestApplet for CLIO Customer Maintenance. 
 *
 *
 * @version 1.0, 10/30/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   Customer                                                */
/*                                                           */
/*-----------------------------------------------------------*/
public class Customer extends Object implements QuestApplet, AppConst, Authority {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   CustMaintPanel Definition                               */                
   /*                                                           */
   /*-----------------------------------------------------------*/
   private static CustMaintPanel custMaintPanel    = null ;
   



   /*------------------------------------------------------------*/
   /* getIcon
    */
   /**
    *    This method will return our normal icon
    *  that is displayed on the workspace
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public ImageIcon getIcon () {
      return( ImageSystem.getImageIcon ( MainWindow.getInstance(), ImageSystem.CLIO ) ) ;
   }




   /*------------------------------------------------------------*/
   /* getSmallIcon
    */
   /**
    *    This method will return the small icon
    *  for the Customer Applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public ImageIcon getSmallIcon () {
      return( ImageSystem.getImageIcon ( MainWindow.getInstance(), ImageSystem.SMALL_CLIO ) ) ;
   }




   /*------------------------------------------------------------*/
   /* getName
    */
   /**
    *    This method will return the short name of
    *  this Quest Applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public String getName () {
      return( Str.getStr ( STR_WEB_CUSTOMER_MGMT ) ) ;
   }





   /*------------------------------------------------------------*/
   /* getDescription
    */
   /**
    *    This method will return our long description
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getDescription () {
      return( Str.getStr ( STR_WEB_CUSTOMER_MANAGEMENT ) ) ;
   }





   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will initialize all of our properties
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean initialize () {
      return ( true ) ;
   }




   /*------------------------------------------------------------*/
   /* start
    */
   /**
    *    This method will be called when the user
    *  wants the QuestApplet to start and show something.
    *  We will attempt to connect to CLIO here, if we are
    *  able to connect to CLIO, then the ClioMaintPanel is
    *  shown
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void start () {
      custMaintPanel = new CustMaintPanel () ;
      
      if ( DatabaseSystem.createConnection ( DatabaseSystem.CLIO,
                                             Constants.getStrConst ( "IT_CLIODBNAME" ),
                                             Constants.getStrConst ( "IT_CLIOSERVER" ),
                                             Constants.getStrConst ( "IT_CLIOPORTNUM" ),
                                             "esupport",
                                             "ESUPP0RT" ) )
         WindowSystem.createPanel ( custMaintPanel ) ;
      else
         GUISystem.printBox ( STR_INFO, STR_CANNOT_CONNECT_CLIO_NO_CUST_MGMT ) ;

   }





   /*------------------------------------------------------------*/
   /* getAuthority
    */
   /**
    *    This method will return the authority needed
    *  to run this Quest Applet.
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public int getAuthority () {
      return( AUTH_CLIOEDITOR ) ;
   }




   /*------------------------------------------------------------*/
   /* canChat
    */
   /**
    *    This method will return FALSE
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean canChat () {
      return( false ) ;
   }


} /* Customer */
