package com.ibm.nzna.projects.qit.customer ;
/*-----------------------------------------------------------*/
/*   CustomerAddressRec                                      */
/*                                                           */
/*   Description:                                            */
/*      Source code for: CustomerAddressRec                  */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This object holds specific information about a Customer's Address 
 *
 *
 * @version 1.0, 8/6/1999 
 * @author  David Lentz
 */
import java.sql.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.common.clio.* ;
import com.ibm.nzna.shared.db.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.shared.pom.* ;
import com.ibm.nzna.shared.gui.* ;

/*-----------------------------------------------------------*/
/*                                                           */
/*   CustomerAddressRec                                      */
/*                                                           */
/*-----------------------------------------------------------*/
public class CustomerAddressRec extends PersistentRec implements MultiListRow, AppConst {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   vars                                                    */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private String address1    = "" ;
   private String address2    = "" ;
   private String address3    = "" ;
   private String city        = "" ;
   private String state       = "" ;
   private String zipcode     = "" ;
   private String countryCode = "USA" ;
   private int    recNum      = 0 ;
   private String addressType = "" ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    The default constructor does nothing
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public CustomerAddressRec () {
   }





   /*------------------------------------------------------------*/
   /* setAddress1
    */
   /**
    *    This method will set the address1 property
    *  of the address
    *  
    *
    *  @param address1 The new address1 to use
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setAddress1 ( String address1 ) {
      this.address1 = address1 ;
   }




   /*------------------------------------------------------------*/
   /* setAddress2
    */
   /**
    *    This method will set the address2 property
    *  of the address
    *  
    *
    *  @param address2 The new address2 to use
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setAddress2 ( String address2 ) {
      this.address2 = address2 ;
   }






   /*------------------------------------------------------------*/
   /* setAddress3
    */
   /**
    *    This method will set the address3 property
    *  of the address
    *  
    *
    *  @param address3 The new address3 to use
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setAddress3 ( String address3 ) {
      this.address3 = address3 ;
   }





   /*------------------------------------------------------------*/
   /* setCity
    */
   /**
    *    This method will set the city property
    *  of the address
    *  
    *
    *  @param city The new city to use
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setCity ( String city ) {
      this.city = city ;
   }




   /*------------------------------------------------------------*/
   /* setZipcode
    */
   /**
    *    This method will set the zipcode property
    *  of the address
    *  
    *
    *  @param zipcode The new zipcode to use
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setZipcode ( String zipcode ) {
      this.zipcode = zipcode ;
   }


   /*------------------------------------------------------------*/
   /* setState
    */
   /**
    *    This method will set the state property
    *  of the address
    *  
    *
    *  @param state The new state to use
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setState ( String state ) {
      this.state = state ;
   }


   /*------------------------------------------------------------*/
   /* getAddress1
    */
   /**
    *    This method will get the address1 property
    *  of the address
    *  
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public String getAddress1 ( ) {
      return( address1 ) ;
   }




   /*------------------------------------------------------------*/
   /* getAddress2
    */
   /**
    *    This method will get the address2 property
    *  of the address
    *  
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public String getAddress2 ( ) {
      return( address2 ) ;
   }






   /*------------------------------------------------------------*/
   /* getAddress3
    */
   /**
    *    This method will get the address3 property
    *  of the address
    *  
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public String getAddress3 () {
      return( address3 ) ;
   }





   /*------------------------------------------------------------*/
   /* getCity
    */
   /**
    *    This method will get the city property
    *  of the address
    *  
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public String getCity ( ) {
      return( city ) ;
   }




   /*------------------------------------------------------------*/
   /* getZipcode
    */
   /**
    *    This method will get the zipcode property
    *  of the address
    *  
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public String getZipcode ( ) {
      return( zipcode ) ;
   }


   /*------------------------------------------------------------*/
   /* getState
    */
   /**
    *    This method will get the state property
    *  of the address
    *  
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public String getState ( ) {
      return( state ) ;
   }


   /*------------------------------------------------------------*/
   /* generateRecNum
    */
   /**
    *    This method will generate a record number
    *  only if the current rec num is 0
    *  
    *
    *  @param custNum This is needed to get the max rec num from CLIO.CUSTMACH
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean generateRecNum ( int custNum ) {
      String    rtnName  = "generateRecNum" ;
      SQLMethod sql      = new SQLMethod ( DatabaseSystem.CLIO, "generateRecNum", 5 ) ;
      boolean   rc       = false;

      recNum = 0 ;

      try {
         Statement stmt = sql.createStatement() ;
         ResultSet rs   = stmt.executeQuery ( "SELECT RECNUM FROM CLIO.CUSTADDRESS WHERE CUSTNUM = "+custNum+" ORDER BY RECNUM" ) ;

         while ( rs.next() )
            recNum = rs.getInt(1) ;

         recNum++ ;

         rs.close() ;
      } catch ( Exception e ) {
         sql.rollBack() ;
         LogSystem.log ( 1, e, true ) ;
      }

      sql.close() ;

      return( rc ) ;
   }




   /*------------------------------------------------------------*/
   /* setRecNum
    */
   /**
    *    This method will set this address' rec
    *  num
    *  
    *
    *  @param recNum The new Country Code
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setRecNum ( int recNum ) {
      this.recNum = recNum ;
   }




   /*------------------------------------------------------------*/
   /* getRecNum
    */
   /**
    *    This method will get the address'
    *  rec num
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public int getRecNum () {
      return( recNum ) ;
   }


   /*------------------------------------------------------------*/
   /* setCountryCode
    */
   /**
    *    This method will set this address' country
    *  code
    *  
    *
    *  @param countryCode The new Country Code
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setCountryCode ( String countryCode ) {
      this.countryCode = countryCode ;
   }




   /*------------------------------------------------------------*/
   /* getCountryCode
    */
   /**
    *    This method will get the address'
    *  country code
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getCountryCode () {
      return( countryCode ) ;
   }





   /*------------------------------------------------------------*/
   /* setAddressType
    */
   /**
    *    This method will set the type of address
    *  that this represents
    *  
    *
    *  @param addressType The new type
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setAddressType ( String addressType ) {
      this.addressType = addressType ;
   }




   /*------------------------------------------------------------*/
   /* getAddressType
    */
   /**
    *    This method will return the type of address
    *  this represents
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String The type of address
    *//*---------------------------------------------------------*/
   public String getAddressType () {
      return( addressType ) ;
   }

   /*------------------------------------------------------------*/
   /* getColumnData
    */
   /**
    *    This method will return the data that should
    *  be displayed inside of a MultiList control
    *  
    *
    *  @param column The column number
    *
    *  @return The data to put in the column passed
    *//*---------------------------------------------------------*/
   public Object getColumnData ( int column ) {
      Object retObj = null ;

      switch ( column ) {
         case 0 :
            retObj = addressType ;
            break ;

         case 1 :
            retObj = address1 ;
            break ;

         case 2 :
            retObj = city ;
            break ;

         case 3 :
            retObj = state ;
            break ;

         case 4 :
            retObj = zipcode ;
            break ;

         case 5 :
            retObj = countryCode ;
            break ;

      }
      return( retObj ) ;
   }

} /* CustomerAddressRec */
