package com.ibm.nzna.projects.qit.customer ;
/*-----------------------------------------------------------*/
/*   CustomerPhoneRec                                        */
/*                                                           */
/*   Description:                                            */
/*      Source code for: CustomerPhoneRec                    */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This record holds information about a customers specifc Phone Number and Type 
 *
 *
 * @version 1.0, 8/6/1999 
 * @author  David Lentz
 */
import java.sql.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.shared.pom.* ;
import com.ibm.nzna.shared.db.* ;
import com.ibm.nzna.shared.gui.* ;


/*-----------------------------------------------------------*/
/*                                                           */
/*   CustomerPhoneRec                                        */
/*                                                           */
/*-----------------------------------------------------------*/
public class CustomerPhoneRec extends PersistentRec implements MultiListRow, AppConst {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Vars                                                    */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private String phoneNumber       = "" ;
   private String phone             = "" ;
   private String phoneCountryCode  = " " ;
   private String extension         = " " ;
   private int    recNum            = 0;
   private String areaCode          = " " ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    Default constructor does nothing
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public CustomerPhoneRec () {
   }





   /*------------------------------------------------------------*/
   /* setPhone
    */
   /**
    *    This method will set the Phone
    *  property
    *  
    *
    *  @param phone The new Phone
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setPhone ( String phone ) {
      this.phone = phone ;
   }

   /*------------------------------------------------------------*/
   /* setPhoneNumber
    */
   /**
    *    This method will set the PhoneNumber
    *  property
    *  
    *
    *  @param phoneNumber The new PhoneNumber
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setPhoneNumber ( String phoneNumber ) {
      this.phoneNumber = phoneNumber ;
   }



   /*------------------------------------------------------------*/
   /* getPhone
    */
   /**
    *    This method will get the Phone
    *  property
    *  
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public String getPhone ( ) {
      return( phone ) ;
   }

   /*------------------------------------------------------------*/
   /* getPhoneNumber
    */
   /**
    *    This method will get the PhoneNumber
    *  property
    *  
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public String getPhoneNumber () {
      return( phoneNumber ) ;
   }

   /*------------------------------------------------------------*/
   /* generateRecNum
    */
   /**
    *    This method will generate a record number
    *  only if the current rec num is 0
    *  
    *
    *  @param custNum This is needed to get the max rec num from CLIO.CUSTMACH
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean generateRecNum ( int custNum ) {
      String    rtnName  = "generateRecNum" ;
      SQLMethod sql      = new SQLMethod ( DatabaseSystem.CLIO, "generateRecNum", 5 ) ;
      boolean   rc       = false;

      recNum = 0 ;

      try {
         Statement stmt = sql.createStatement() ;
         ResultSet rs   = stmt.executeQuery ( "SELECT RECNUM FROM CLIO.CUSTPHONE WHERE CUSTNUM = "+custNum+" ORDER BY RECNUM" ) ;

         while ( rs.next() )
            recNum = rs.getInt(1) ;

         recNum++ ;

         rs.close() ;
      } catch ( Exception e ) {
         sql.rollBack() ;
         LogSystem.log ( 1, e, true ) ;
      }

      sql.close() ;

      return( rc ) ;
   }




   /*------------------------------------------------------------*/
   /* setRecNum
    */
   /**
    *    This method will set this phone' rec
    *  num
    *  
    *
    *  @param recNum The new Country Code
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setRecNum ( int recNum ) {
      this.recNum = recNum ;
   }




   /*------------------------------------------------------------*/
   /* getRecNum
    */
   /**
    *    This method will get the phone'
    *  rec num
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public int getRecNum () {
      return( recNum ) ;
   }


   /*------------------------------------------------------------*/
   /* setExtension
    */
   /**
    *    This method will set this phone' extension
    *  
    *
    *  @param extension The new Country Code
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setExtension ( String extension ) {
      this.extension = extension ;
   }




   /*------------------------------------------------------------*/
   /* getExtension
    */
   /**
    *    This method will get the phone'
    *  extension
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getExtension () {
      return( extension ) ;
   }


   /*------------------------------------------------------------*/
   /* setPhoneCountryCode
    */
   /**
    *    This method will set this phone' country
    *  code
    *  
    *
    *  @param phoneCountryCode The new Country Code
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setPhoneCountryCode ( String phoneCountryCode ) {
      this.phoneCountryCode = phoneCountryCode ;
   }




   /*------------------------------------------------------------*/
   /* getPhoneCountryCode
    */
   /**
    *    This method will get the phone' Country Code
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getPhoneCountryCode () {
      return( phoneCountryCode ) ;
   }





   /*------------------------------------------------------------*/
   /* getAreaCode
    */
   /**
    *    This method will return this Phone's
    *  area code
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getAreaCode () {
      return( areaCode )  ;
   }





   /*------------------------------------------------------------*/
   /* setAreaCode
    */
   /**
    *    This method will set this phone's
    *  area code
    *  
    *
    *  @param areaCode The Area Code to set to
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setAreaCode ( String areaCode ) {
      this.areaCode = areaCode ;
   }

   /*------------------------------------------------------------*/
   /* getColumnData
    */
   /**
    *    This method will return the data that should
    *  be displayed inside of a MultiList control
    *  
    *
    *  @param column The column number
    *
    *  @return The data to put in the column passed
    *//*---------------------------------------------------------*/
   public Object getColumnData ( int column ) {
      Object retObj = null ;

      switch ( column ) {
         case 0 :
            retObj = phone ;
            break ;

         case 1 :
            retObj = phoneNumber ;
            break ;

         case 2 :
            retObj = extension ;
            break ;

         case 3 :
            retObj = areaCode ;
            break ;

         case 4 :
            retObj = phoneCountryCode ;
            break ;

      }
      return( retObj ) ;
   }

} /* CustomerPhoneRec */
