package com.ibm.nzna.projects.qit.customer.custmaint ;          
/*-----------------------------------------------------------*/
/*   CustMaintNavPanel                                       */
/*                                                           */
/*   Description:                                            */
/*      Source code for: CustMaintNavPanel                   */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.shared.gui.* ;    
/**
 * This nav panel allows the user to navigate through CustMaintPanel 
 *
 *
 * @version 1.0, 1/13/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   CustMaintNavPanel                                       */
/*                                                           */
/*-----------------------------------------------------------*/
public class CustMaintNavPanel extends JPanel implements ActionListener, AppConst, NavPanel {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private GUI Members                                     */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private JScrollPane  scrollPane        = null ;
   private HotLinkLabel view_Name         = null ;
   private HotLinkLabel view_EMail        = null ;
   private HotLinkLabel view_MachineModel = null ;
   private HotLinkLabel view_Machine      = null ;
   private HotLinkLabel view_CustNum      = null ;
   private HotLinkLabel view_User         = null ;
   private NavList      viewList          = null ;

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */      
   /*                                                           */
   /*-----------------------------------------------------------*/
   private CustMaintPanel custMaintPanel = null ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will simply assign local
    *  variables. The heart of initializing is in the initialize
    *  method
    *
    *  @param CustMaintPanel The Customer Maintenance panel that this nav panel is tied to
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public CustMaintNavPanel ( CustMaintPanel custMaintPanel ) {
      this.custMaintPanel = custMaintPanel ; 
   }

   /*------------------------------------------------------------*/
   /* getJComponent
    */
   /**
    *    This method returns an instance of this
    *  panel
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public JComponent getJComponent () {
      return( this ) ;
   }





   /*------------------------------------------------------------*/
   /* getTitle
    */
   /**
    *    This method will return the String title of ours
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public String getTitle () {
      return( Str.getStr ( STR_VIEWS ) ) ;
   }





   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will initialize our component
    *  before it is shown
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void initialize () {
      HotLinkGroup hotGroup = new HotLinkGroup () ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create our GUI                                          */     
      /*                                                           */
      /*-----------------------------------------------------------*/
      view_Name         = new HotLinkLabel ( Str.getStr ( STR_CUST_BY_NAME ) ) ;
      view_EMail        = new HotLinkLabel ( Str.getStr ( STR_CUST_BY_EMAIL_ADDR ) ) ;
      view_MachineModel = new HotLinkLabel ( Str.getStr ( STR_CUST_BY_MACHINE_MODEL ) ) ;
      view_Machine      = new HotLinkLabel ( Str.getStr ( STR_CUST_BY_MACHINE ) ) ;
      view_CustNum      = new HotLinkLabel ( Str.getStr ( STR_CUST_BY_CUSTNUM ) ) ;
      view_User         = new HotLinkLabel ( Str.getStr ( STR_CUST_BY_USERID ) ) ;
      viewList          = new NavList ( ) ;
      scrollPane        = new JScrollPane ( viewList ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add our controls                                        */       
      /*                                                           */
      /*-----------------------------------------------------------*/
      viewList.add ( view_User ) ;
      viewList.add ( view_Name ) ;
      viewList.add ( view_EMail ) ;
      viewList.add ( view_MachineModel ) ;
      viewList.add ( view_Machine ) ;
      viewList.add ( view_CustNum ) ;
      setLayout ( new BorderLayout () ) ;
      add ( scrollPane, BorderLayout.CENTER ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add listeners                                           */    
      /*                                                           */
      /*-----------------------------------------------------------*/
      viewList.addActionListener ( this ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */        
      /*                                                           */
      /*-----------------------------------------------------------*/
      hotGroup.add ( view_User ) ;
      hotGroup.add ( view_Name ) ;
      hotGroup.add ( view_EMail ) ;
      hotGroup.add ( view_MachineModel ) ;
      hotGroup.add ( view_Machine ) ;
      hotGroup.add ( view_CustNum ) ;
      
   }





   /*------------------------------------------------------------*/
   /* start
    */
   /**
    *    This method will be called once we are
    *  showing. 
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void start () {
   }

   public void stop () {
      removeAll() ;
   }





   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will be called when the user
    *  has selected a view to refresh
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {
      custMaintPanel.refreshView ( ((HotLinkLabel)e.getSource()).getText ()) ;
   }

} /* CustMaintNavPanel */
