package com.ibm.nzna.projects.qit.customview ;                 
/*-----------------------------------------------------------*/
/*   CustomViewListener                                      */
/*                                                           */
/*   Description:                                            */
/*      Source code for: CustomViewListener                  */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This listener will be notified when changes are made to the CustomViews in Quest 
 *
 *
 * @version 1.0, 5/3/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   CustomViewListener                                      */
/*                                                           */
/*-----------------------------------------------------------*/
public interface CustomViewListener {





   /*------------------------------------------------------------*/
   /* customViewAdded
    */
   /**
    *    This method will be called when a new
    *  custom view is added to the system
    *  
    *
    *  @param customView The customview that was added
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public abstract void customViewAdded ( CustomView customView ) ;





   /*------------------------------------------------------------*/
   /* customViewRemoved
    */
   /**
    *    This method will be called when a custom
    *  view has been removed from the system
    *  
    *
    *  @param customView The CustomView that was removed
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public abstract void customViewRemoved ( CustomView customView ) ;




   /*------------------------------------------------------------*/
   /* customViewUpdated
    */
   /**
    *    This method will be called when a custom
    *  view has been updated in the system
    *  
    *
    *  @param customView The customView that was edited
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public abstract void customViewUpdated ( CustomView customView ) ;

} /* CustomViewListener */
