package com.ibm.nzna.projects.qit.dbgui ;                          
/*-----------------------------------------------------------*/
/*   CountrySelectListener                                   */
/*                                                           */
/*   Description:                                            */
/*      Source code for: CountrySelectListener               */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.projects.common.quest.type.* ;
/**
 * The CountrySelectListener is notified of any changes 
 * made to the CountrySelectPanel. These notifications include
 * the adding and removing of countries.
 *
 *
 * @version 1.0, 9/29/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   CountrySelectListener                                   */
/*                                                           */
/*-----------------------------------------------------------*/
public interface CountrySelectListener {





   /*------------------------------------------------------------*/
   /* countryRemoved
    */
   /**
    *    This method will be called when a country
    *  has been requested to be removed.
    *  
    *
    *  @param countryRec The TypeCountryCodeRec that is being removed
    *  @param None
    *  @param None
    *
    *  @return TRUE if the remove is Ok, FALSE if the remove is not Ok. Returning
    *          FALSE will not allow the remove and the country will stay
    *//*---------------------------------------------------------*/
   public abstract boolean countryRemoved ( TypeCountryCodeRec countryRec ) ;





   /*------------------------------------------------------------*/
   /* countryAdded
    */
   /**
    *    This method will be called when the user
    *  has selected to add a country. 
    *  
    *
    *  @param countryRec The country to add
    *  @param None
    *  @param None
    *
    *  @return TRUE if the add should be allowed, FALSE if the add should not be allowed
    *//*---------------------------------------------------------*/
   public abstract boolean countryAdded ( TypeCountryCodeRec countryRec ) ;





   /*------------------------------------------------------------*/
   /* countryRemoveDone
    */
   /**
    *    This method will be called once all processing
    *  for removing all countries is done
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public abstract void countryRemoveDone () ;

} /* CountrySelectListener */
