package com.ibm.nzna.projects.qit.dbgui ;     
/*-----------------------------------------------------------*/
/*   DocClassPanel                                           */
/*                                                           */
/*   Description:                                            */
/*      Source code for: DocClassPanel                       */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import java.util.* ;
import javax.swing.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
/**
 * This panel shows all document class information, including the doc class title and drop down 
 *
 *
 * @version 1.0, 5/24/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   DocClassPanel                                           */
/*                                                           */
/*-----------------------------------------------------------*/
public class DocClassPanel extends JPanel implements AppConst {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private GUI Members                                     */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private JTitle       st_DOC_CLASS         = new JTitle ( Str.getStr ( STR_DOC_CLASS ) ) ;
   private JComboBox    cb_DOC_CLASS         = new JComboBox ( TypeList.getInstance().getTypeList ( TypeList.TYPE_DOCCLASS ) ) ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will create the initial control.
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public DocClassPanel () {       

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */        
      /*                                                           */
      /*-----------------------------------------------------------*/
      st_DOC_CLASS.setFont ( FontSystem.smallTitleFont ) ;
      
      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add the controls                                        */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( new BorderLayout() ) ;
      add ( st_DOC_CLASS, BorderLayout.NORTH ) ;
      add ( cb_DOC_CLASS, BorderLayout.CENTER ) ;

      setDocClass ( TypeList.DOCCLASS_IBM_CONFIDENTIAL ) ;
   }




   /*------------------------------------------------------------*/
   /* setDocClass
    */
   /**
    *    This method will set what doc class is selected
    *  
    *  
    *
    *  @param docClassInd The indicator of the doc class to set
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setDocClass ( int docClassInd ) {
      setDocClass ( (TypeDocClassRec) TypeList.getInstance().objectFromInd ( docClassInd, TypeList.TYPE_DOCCLASS ) ) ;
   }




   /*------------------------------------------------------------*/
   /* setDocClass
    */
   /**
    *    This method will set what doc class is selected
    *  
    *  
    *
    *  @param docClass The TypeDocClassRec to set
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setDocClass ( TypeDocClassRec docClass ) {
      cb_DOC_CLASS.setSelectedItem ( docClass ) ;
   }




   /*------------------------------------------------------------*/
   /* getDocClass
    */
   /**
    *    This method will return the TypeDocClassRec
    *  that is currently selected
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return TypeDocClassRec
    *//*---------------------------------------------------------*/
   public TypeDocClassRec getDocClass () {
      return( (TypeDocClassRec)cb_DOC_CLASS.getSelectedItem() ) ;
   }





   /*------------------------------------------------------------*/
   /* setEnabled
    */
   /**
    *    This method will either enabel or disable our
    *  contrls
    *  
    *
    *  @param enabled
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setEnabled ( boolean enabled ) {
      super.setEnabled ( enabled ) ;
      cb_DOC_CLASS.setEnabled ( enabled ) ;
   }
} /* DocClassPanel */
