package com.ibm.nzna.projects.qit.dbgui ;              
/*-----------------------------------------------------------*/
/*   LocaleDlgListener                                       */
/*                                                           */
/*   Description:                                            */
/*      Source code for: LocaleDlgListener                   */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.projects.common.quest.type.* ;
/**
 * This listener is notified when a Country or Geography is
 * selected in the LocaleDlg.
 *
 *
 * @version 1.0, 6/13/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   LocaleDlgListener                                       */
/*                                                           */
/*-----------------------------------------------------------*/
public interface LocaleDlgListener {


   /**
     *  This method will be called when the user hits the 'Add Selected Countries'
     * button. This means that the user has chosen the countries that are passed
     * in the array.
     *
     * @param An array of TypeCountryCodeRec objects
     **/
   public abstract void localeDlgAddCountries ( Object[] countries ) ;


   /**
     *  This method will be called when the user hits the 'Add Entire Geography'
     * button. This means that the user has chosen to add all of the countries
     * under the geography.
     *
     * @param geoRec The Geography that the user wants to add
     **/
   public abstract void localeDlgAddGeo ( TypeGeoRec geoRec ) ;
} /* LocaleDlgListener */
