package com.ibm.nzna.projects.qit.doc ;    
/*-----------------------------------------------------------*/
/*   Doc                                                     */
/*                                                           */
/*   Description:                                            */
/*      Source code for: Doc                                 */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.doc.docmaint.* ;
import com.ibm.nzna.projects.qit.doc.docedit.* ;
import java.util.* ;
import javax.swing.* ;
import java.awt.event.* ;
/**
 * This QuestApplet allows an author to create and maintain documents
 * in the Quest database.
 *
 *
 * @version 1.0, 1/26/100 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   Doc                                                     */
/*                                                           */
/*-----------------------------------------------------------*/
public class Doc extends Object implements ActionListener, java.io.Serializable, DocConst, QuestApplet, AppConst, Authority {



   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private        DocMaintPanel docMaintPanel       = null ;
   private static boolean       addedCreateDocument = false ;
   private        JMenuItem     createDocMenuItem   = null ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This constructor like all good Quest Applets
    *  does nothing
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public Doc () {
      if ( !addedCreateDocument ) {

         addedCreateDocument = true ;

         if ( UserSystem.hasAuthority ( AUTH_DOCMAINT ) ) {
            createDocMenuItem = new JMenuItem ( Str.getStr ( STR_DOCUMENT ) ) ;
            createDocMenuItem.addActionListener ( this ) ;
            MainWindow.getInstance().getAppDefaultMenuBar().addCreateMenuItem ( createDocMenuItem ) ;
         }
      }
   }





   /*------------------------------------------------------------*/
   /* getName
    */
   /**
    *    This method will return the name
    *  of this Quest Applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getName () {
      return( Str.getStr ( STR_DOCUMENT ) ) ;
   }




   /*------------------------------------------------------------*/
   /* getDescription
    */
   /**
    *    This method will return a user readable
    *  description of this Quest Applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getDescription () {
      return( Str.getStr ( STR_DOCUMENT_DESCRIPT ) ) ;
   }





   /*------------------------------------------------------------*/
   /* canChat
    */
   /**
    *    This method will return TRUE, since
    *  the web browser can chat with other
    *  web browsers
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean canChat () {
      return( true ) ;
   }




   /*------------------------------------------------------------*/
   /* getAuthority
    */
   /**
    *    This method will return 0, since everyone
    *  has access to the browser
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public int getAuthority () {
      return( AUTH_DOCMAINT ) ;
   }




   /*------------------------------------------------------------*/
   /* stop
    */
   /**
    *    This method will be called when we need
    *  to clean up and stop our Applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void stop () {
   }




   /*------------------------------------------------------------*/
   /* start
    */
   /**
    *    This method will be called when our
    *  initialization has completed, and we
    *  can now add ourselves to a window
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void start () {

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create our Systems                                      */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( DocTemplateSystem.getInstance() == null )
         new DocTemplateSystem() ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Set our default properties                              */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( PropertySystem.getInt ( PROPERTY_MAX_DOCUMENT_RETURN ) == 0 ) {
         PropertySystem.putInt ( PROPERTY_MAX_DOCUMENT_RETURN, 150 ) ;
         PropertySystem.putBool ( PROPERTY_SHOW_MY_BRANDS_ONLY, false ) ;
         PropertySystem.putBool ( PROPERTY_DOCMAINT_PREVIEW, false ) ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Set up the default layout for the DocEditor             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( PropertySystem.get ( PROPERTY_EDITOR_LAYOUT ) == null ) {
         Vector layout = new Vector () ;

         layout.addElement ( DocEditPanel.FORM_TITLE ) ;
         layout.addElement ( DocEditPanel.FORM_TYPE_CLASS ) ;
         layout.addElement ( DocEditPanel.FORM_DRAFT_INFO ) ;
         layout.addElement ( DocEditPanel.FORM_COMMENT ) ;
         layout.addElement ( DocEditPanel.FORM_COMMENT_HISTORY ) ;
         layout.addElement ( DocEditPanel.FORM_PUBLISHING_OPTIONS ) ;
         layout.addElement ( DocEditPanel.FORM_CATEGORY ) ;
         layout.addElement ( DocEditPanel.FORM_DOCUMENT_LOCATION ) ;
         layout.addElement ( DocEditPanel.FORM_DOCUMENT_PRODUCTS ) ;
         layout.addElement ( DocEditPanel.FORM_DOWNLOADABLE_FILE_INFO ) ;
         layout.addElement ( DocEditPanel.FORM_FILE_ATTACHMENTS ) ;
         layout.addElement ( DocEditPanel.FORM_PROACTIVE_EMAIL ) ;
         layout.addElement ( DocEditPanel.FORM_THIS_DOCUMENT_LINKS_TO ) ;
         layout.addElement ( DocEditPanel.FORM_DOCUMENTS_LINK_TO_THIS ) ;
         layout.addElement ( DocEditPanel.FORM_SEARCH_ENGINE_QUERY_INDEX ) ;
         layout.addElement ( DocEditPanel.FORM_QUEST_DOCUMENT_INFO ) ;

         PropertySystem.put ( PROPERTY_EDITOR_LAYOUT, layout ) ;
      }


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add this browser to the main window                     */
      /*                                                           */
      /*-----------------------------------------------------------*/
      WindowSystem.createPanel ( docMaintPanel ) ;
   }




   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will initialize our browser
    *  bean as well as get everything else
    *  ready
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean initialize () {

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   First, create our panel that holds the browser          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      docMaintPanel = new DocMaintPanel () ;                          
      return( true ) ;
   }




   /*------------------------------------------------------------*/
   /* getSmallIcon
    */
   /**
    *    This method will return the small icon
    *  representing this Quest Applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public ImageIcon getSmallIcon () {
      return( ImageSystem.getImageIcon ( this, ImageSystem.DOCUMENT_SMALL ) ) ;
   }





   /*------------------------------------------------------------*/
   /* getIcon
    */
   /**
    *    This method will return our normal
    *  sized icon
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return ImageIcon
    *//*---------------------------------------------------------*/
   public ImageIcon getIcon () {
      return( ImageSystem.getImageIcon ( this, ImageSystem.DOCUMENT_LARGE ) ) ;
   }





   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will respond to action events
    *  sent to us
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {
      if ( e.getSource() == createDocMenuItem ) {
         DocMaintPanel.createNewDoc ( MainWindow.getInstance(), null ) ;
      }
   }



} /* Doc */
