package com.ibm.nzna.projects.qit.doc ;    
/*-----------------------------------------------------------*/
/*   DocHistory                                              */
/*                                                           */
/*   Description:                                            */
/*      Source code for: Doc                                 */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.doc.history.* ;
import javax.swing.* ;
/**
 * This QuestApplet allows an author to view history on a document  
 *
 *
 * @version 1.0, 1/26/100 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   Doc                                                     */
/*                                                           */
/*-----------------------------------------------------------*/
public class DocHistory extends Object implements DocConst, QuestApplet, AppConst {



    /*-----------------------------------------------------------*/
    /*                                                           */
    /*   Private members                                         */
    /*                                                           */
    /*-----------------------------------------------------------*/
    private DocHistPanel docHistoryPanel = null ;





    /*------------------------------------------------------------*/
    /* Constructor
     */
    /**
     *    This constructor like all good Quest Applets
     *  does nothing
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public DocHistory () {
    }





    /*------------------------------------------------------------*/
    /* getName
     */
    /**
     *    This method will return the name
     *  of this Quest Applet
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public String getName () {
        return( Str.getStr ( STR_DOCUMENT_HISTORY ) ) ;
    }




    /*------------------------------------------------------------*/
    /* getDescription
     */
    /**
     *    This method will return a user readable
     *  description of this Quest Applet
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public String getDescription () {
        return( Str.getStr ( STR_DOCUMENT_HISTORY_DESCRIPTION ) ) ;
    }





    /*------------------------------------------------------------*/
    /* canChat
     */
    /**
     *    This method will return TRUE, since
     *  the web browser can chat with other
     *  web browsers
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public boolean canChat () {
        return( false ) ;
    }




    /*------------------------------------------------------------*/
    /* getAuthority
     */
    /**
     *    This method will return 0, since everyone
     *  has access to the browser
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public int getAuthority () {
        return( 0 ) ;
    }




    /*------------------------------------------------------------*/
    /* stop
     */
    /**
     *    This method will be called when we need
     *  to clean up and stop our Applet
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void stop () {
    }




    /*------------------------------------------------------------*/
    /* start
     */
    /**
     *    This method will be called when our
     *  initialization has completed, and we
     *  can now add ourselves to a window
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void start () {

        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   Add this browser to the main window                     */
        /*                                                           */
        /*-----------------------------------------------------------*/
        WindowSystem.createPanel ( docHistoryPanel ) ;
    }




    /*------------------------------------------------------------*/
    /* initialize
     */
    /**
     *    This method will initialize our browser
     *  bean as well as get everything else
     *  ready
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public boolean initialize () {                                         

        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   First, create our panel that holds the browser          */
        /*                                                           */
        /*-----------------------------------------------------------*/
        docHistoryPanel = new DocHistPanel ( null ) ;                          
        return( true ) ;
    }




    /*------------------------------------------------------------*/
    /* getSmallIcon
     */
    /**
     *    This method will return the small icon
     *  representing this Quest Applet
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public ImageIcon getSmallIcon () {
        return( ImageSystem.getImageIcon ( this, ImageSystem.DOCUMENT_HISTORY_SMALL ) ) ;
    }





    /*------------------------------------------------------------*/
    /* getIcon
     */
    /**
     *    This method will return our normal
     *  sized icon
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return ImageIcon
     *//*---------------------------------------------------------*/
    public ImageIcon getIcon () {
        return( ImageSystem.getImageIcon ( this, ImageSystem.DOCUMENT_HISTORY_LARGE ) ) ;
    }





} /* Doc */
