package com.ibm.nzna.projects.qit.doc ;      
/*-----------------------------------------------------------*/
/*   DocPropertyRec                                          */
/*                                                           */
/*   Description:                                            */
/*      Source code for: DocPropertyRec                      */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.projects.qit.app.* ; 
/**
 * This object holds information about a single document property 
 *
 *
 * @version 1.0, 3/19/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   DocPropertyRec                                          */
/*                                                           */
/*-----------------------------------------------------------*/
public class DocPropertyRec extends QITRec {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Members                                                 */
   /*                                                           */
   /*-----------------------------------------------------------*/
   public String  descript = null ;
   public int     docInd   = 0 ;
   public int     recNum   = 0 ;
   public String  value    = null ;
   public int     propInd  = 0 ;




   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    Default Constructor
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public DocPropertyRec () {
   }





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will initialize the DocPropertyRec
    *  to the values passed in
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public DocPropertyRec ( String value , int propInd) {
      this.value = value ;
      this.propInd   = propInd ;
      setDescript ( value ) ;
      setInd ( propInd ) ;
   }




   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will create the Doc Property Rec
    *  with the DocPropertyRec passed in.
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public DocPropertyRec ( DocPropertyRec propRec ) {
      this.docInd  = propRec.docInd ;
      this.recNum  = propRec.recNum ;
      this.value   = propRec.value ;
      this.propInd = propRec.propInd ;
   }





   /*------------------------------------------------------------*/
   /* equals
    */
   /**
    *    This method will compare the object passed
    *  to this object
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return TRUE = Objects are equal
    *//*---------------------------------------------------------*/
   public boolean equals ( Object object ) {
      if ( object instanceof DocPropertyRec ) {
         DocPropertyRec propRec = (DocPropertyRec) object ;

         /* DO NOT ADD MORE CHECKS IN. THAT WILL
            BREAK THE DocRec.setProperty() method */
         return( propInd == propRec.propInd ) ;
      }

      return( false ) ;
   }





   /*------------------------------------------------------------*/
   /* setInd
    */
   /**
    *    This method will set this Property's indicator
    *  
    *  
    *
    *  @param ind The indicator
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setInd ( int ind ) {
      this.propInd = ind ;
   }





   /*------------------------------------------------------------*/
   /* setDescript
    */
   /**
    *    This method will set the textual description
    *  
    *  
    *
    *  @param descript The string
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setDescript ( String descript ) {
      this.descript = descript ;
   }




   /*------------------------------------------------------------*/
   /* toString
    */
   /**
    *    This method will return the textutal description
    *  of this object
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public String toString () {
      return( descript ) ;
   }
}
