package com.ibm.nzna.projects.qit.doc.docedit ;         
/*-----------------------------------------------------------*/
/*   DocSavingPanel                                          */
/*                                                           */
/*   Description:                                            */
/*      Source code for: DocSavingPanel                      */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import javax.swing.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.shared.gui.* ;
/**
 * This is the small progress window that shows up on the screen while saving a document 
 *
 *
 * @version 1.0, 3/22/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   DocSavingPanel                                          */
/*                                                           */
/*-----------------------------------------------------------*/
public class DocSavingPanel extends JPanel implements AppConst {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private ImageIcon backgroundImage = null ;
   private JLabel    title           = new JLabel () ;
   private JTextArea output          = new JTextArea() ;




   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This constructor initializes and shows 
    *  our window
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public DocSavingPanel ( ) {

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Intialize our size and position                         */
      /*                                                           */
      /*-----------------------------------------------------------*/
      backgroundImage = ImageSystem.getImageIcon ( this, ImageSystem.SAVEDOC_BACKGROUND ) ;        

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      title.setOpaque ( false ) ;
      output.setOpaque ( false ) ;
      output.setWrapStyleWord ( true ) ;
      output.setLineWrap ( true ) ;
      output.setFont ( FontSystem.smallTitleFont ) ;
      title.setFont ( FontSystem.smallTitleFont ) ;
      title.setForeground ( Color.white ) ;
      output.setForeground ( new Color ( 0, 0, 150 ) ) ;
      output.setEditable ( false ) ;

      title.setText ( Str.getStr ( STR_SAVING_DOC ) ) ;
      setLayout ( new BorderLayout(5,5) ) ;
      setBorder ( new javax.swing.border.EmptyBorder ( 0, 5, 5, 5 ) ) ;


      add ( title, BorderLayout.NORTH ) ;
      add ( output, BorderLayout.CENTER ) ;

   }



   public void paintComponent ( Graphics g ) {
      g.drawImage ( backgroundImage.getImage(), 0, 0, this ) ;
      super.paintChildren ( g ) ;
   }


   public void setStatus ( String text ) {
      output.setText ( text ) ;
   }

   public void setStatus ( int id ) {
      setStatus ( Str.getStr ( id ) ) ;
   }
} /* DocSavingPanel */
