package com.ibm.nzna.projects.qit.doc.docedit ;              
/*-----------------------------------------------------------*/
/*   DocumentLinkPanel                                       */
/*                                                           */
/*   Description:                                            */
/*      Source code for: DocumentLinkPanel                   */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import javax.swing.* ;
import java.awt.* ;
import java.util.* ;
import java.awt.event.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.common.quest.doc.* ;
import com.ibm.nzna.shared.gui.* ;
/**
 * This panel simply shows a list of DocumentLink objects and allows the user to select/edit one 
 *
 *
 * @version 1.0, 8/19/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   DocumentLinkPanel                                       */
/*                                                           */
/*-----------------------------------------------------------*/
public class DocumentLinkPanel extends DPanel implements ActionListener, AppConst {

   /**
     *  This is the List panel which holds all of the documents
     **/
   private ListPanel listPanel = new ListPanel () ;


   /**
     *  Default Constructor
     **/
   public DocumentLinkPanel () {

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      listPanel.setBackground ( Color.white ) ;
      setBackground ( Color.white ) ;
      setLayout ( new BorderLayout() );
      add ( listPanel ) ;

   }


   /**
     *  This method will set the contents that are dispalyed
     **/
   public void setDocumentLinks ( Vector links ) {
      Dimension prefSize  = new Dimension ( 470, 18 ) ;
      int       rowHeight = GUISystem.getRowHeight() ;

      listPanel.removeAll() ;
      listPanel.add ( new JLabel ( Str.getStr ( STR_NONE ) ) ) ;

      if ( ( links != null ) && ( links.size() > 0 ) ) {
         listPanel.removeAll() ;

         for ( int i = 0; i < links.size(); i++ ) {
            DocumentLink docLink   = (DocumentLink)links.elementAt(i) ;
            HotLinkLabel linkLabel = null ;

            if ( docLink.getReferringLink() )
               linkLabel = new HotLinkLabel ( "("+docLink.getDocInd()+") "+docLink.getTitle(), docLink.getDocInd() ) ;
            else
               linkLabel = new HotLinkLabel ( "("+docLink.getLinkedDocInd()+") "+docLink.getTitle(), docLink.getLinkedDocInd() ) ;

            linkLabel.setBackground ( Color.white ) ;
            linkLabel.showSelection ( false ) ;
            linkLabel.addActionListener ( this ) ;
            listPanel.add ( linkLabel ) ;
            //prefSize.height+=rowHeight ;
         }
      }

      prefSize.height = listPanel.getPreferredSize().height ;
      setPreferredSize ( prefSize ) ;
      revalidate() ;
   }

   /**
     *
     **/
   public void actionPerformed ( ActionEvent e ) {

      if ( e.getSource() instanceof HotLinkLabel ) {
         int           docId     = ((HotLinkLabel)e.getSource()).getId() ;
         AppDefaultWin parentWin = GUISystem.getParentDefWin ( this ) ;

         parentWin.setStatus ( Str.getStr ( STR_READING )+" "+Str.getStr ( STR_DOCUMENT ) ) ;
         EditDocument.editDocument ( new DocumentRow ( ""+docId, false ) ) ;
         parentWin.setStatus ( null ) ;

      }
   }

} /* DocumentLinkPanel */
