package com.ibm.nzna.projects.qit.doc.docedit ;                    
/*-----------------------------------------------------------*/
/*   FileAttachmentPanel                                     */
/*                                                           */
/*   Description:                                            */
/*      Source code for: FileAttachmentPanel                 */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.io.* ;
import java.util.* ;
import javax.swing.* ;
import javax.swing.event.* ;
import java.awt.* ;
import java.awt.event.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.qit.app.util.* ;
import com.ibm.nzna.projects.qit.doc.* ;
import com.ibm.nzna.projects.qit.doc.gui.* ;
import com.ibm.nzna.projects.common.quest.doc.* ;
import com.ibm.nzna.projects.common.quest.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.shared.ftp.FTP.* ;
import com.ibm.nzna.shared.ftp.* ;
/**
 * This panel holds all the controls needed to manipulate File Attachments 
 *
 *
 * @version 1.0, 8/18/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   FileAttachmentPanel                                     */
/*                                                           */
/*-----------------------------------------------------------*/
public class FileAttachmentPanel extends DPanel implements DocumentPropertyListener, ListSelectionListener, Authority, AppConst, DocConst, ActionListener {

   /**
     *  THis is the default list model for the list of files
     **/
   private DefaultListModel listModel = new DefaultListModel() ;

   /**
     *  This is the list panel which holds all of the buttons
     **/
   private ListPanel buttonPanel    = new ListPanel () ;

   /**
     *  This is the JList which holds the list of attachments
     **/
   private DList lb_FILES = new DList () ;

   /**
     *  This is the Scroll pane which holds the list
     **/
   private JScrollPane scr_FILES = new JScrollPane ( lb_FILES ) ;

   /**
     *  This is the version static text
     **/
   private JLabel st_VERSION = new JLabel () ;

   /**
     *  This is the Location static text
     **/
   private JLabel st_LOCATION = new JLabel () ;

   /**
     *  This is the Version value label
     **/
   private ValueLabel vl_VERSION = new ValueLabel ( Str.getStr ( STR_VERSION ), st_VERSION ) ;

   /**
     *  This is the Location value label
     **/
   private ValueLabel vl_LOCATION = new ValueLabel ( Str.getStr ( STR_LOCATION ), st_LOCATION ) ;


   /**
     *  This 'add' button
     **/
   private DButton pb_ADD = new DButton ( Str.getStr ( STR_ADD ) ) ;

   /**
     *  Thie 'Edit' button
     **/
   private DButton pb_EDIT = new DButton ( Str.getStr ( STR_EDIT ) ) ;

   /**
     *  The 'Remove' button
     **/
   private DButton pb_REMOVE = new DButton ( Str.getStr ( STR_REMOVE ) ) ;

   /**
     *  The 'Download' button
     **/
   private DButton pb_DOWNLOAD = new DButton ( Str.getStr ( STR_DOWNLOAD ) ) ;

   /**
     *  The 'Verify' button
     **/
   private DButton pb_VERIFY = new DButton ( Str.getStr ( STR_VERIFY ) ) ;

   /**
     *  The 'Deassociate' button
     **/
   private DButton pb_DEASSOC = new DButton ( Str.getStr ( STR_DEASSOC ) ) ;

   /**
     *  This is the Up button
     **/
   private DButton pb_UP = new DButton ( Str.getStr ( STR_UP ) ) ;

   /**
     *  THis is the down button
     **/
   private DButton pb_DOWN = new DButton ( Str.getStr ( STR_DOWN ) ) ;

   /**
     *  This is the filler button that doesn't do anything but take up space
     **/
   private DButton fillerButton = new DButton ( "" ) ;


   /**
     *  THis is the document that we are editing
     **/
   private Document document = null ;







   /**
     *  Default Constructor
     **/
   public FileAttachmentPanel () {

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setBackground ( Color.white ) ;
      pb_EDIT.setEnabled ( false ) ;
      pb_REMOVE.setEnabled ( false ) ;
      pb_DOWNLOAD.setEnabled ( false ) ;
      pb_VERIFY.setEnabled ( false ) ;
      pb_DEASSOC.setEnabled ( false ) ;
      pb_UP.setEnabled ( false ) ;
      pb_DOWN.setEnabled ( false ) ;
      fillerButton.setEnabled ( false ) ;
      lb_FILES.setCellRenderer ( new DocumentFileRenderer() ) ;
      lb_FILES.setModel ( listModel ) ;
      st_VERSION.setFont ( (Font)javax.swing.UIManager.getDefaults().get ( "Form.valueFont" ) ) ;
      st_VERSION.setForeground ( (Color)javax.swing.UIManager.getDefaults().get ( "Form.valueForeground" ) ) ;
      st_LOCATION.setFont ( (Font)javax.swing.UIManager.getDefaults().get ( "Form.valueFont" ) ) ;
      st_LOCATION.setForeground ( (Color)javax.swing.UIManager.getDefaults().get ( "Form.valueForeground" ) ) ;           
      pb_EDIT.setEnabled ( false ) ;
      pb_REMOVE.setEnabled ( false ) ;
      pb_DOWNLOAD.setEnabled ( false ) ;
      pb_VERIFY.setEnabled ( false ) ;
      pb_DEASSOC.setEnabled ( ( false ) ) ;
      pb_UP.setEnabled ( false ) ;
      pb_DOWN.setEnabled ( false ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add action listeners                                    */
      /*                                                           */
      /*-----------------------------------------------------------*/
      pb_ADD.addActionListener ( this )  ;
      pb_EDIT.addActionListener ( this )  ;
      pb_REMOVE.addActionListener ( this )  ;
      pb_DOWNLOAD.addActionListener ( this )  ;
      pb_VERIFY.addActionListener ( this )  ;
      pb_DEASSOC.addActionListener ( this )  ;
      pb_UP.addActionListener ( this )  ;
      pb_DOWN.addActionListener ( this )  ;
      lb_FILES.addListSelectionListener ( this );
      lb_FILES.addActionListener ( this ) ;



      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add the GUI                                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setPreferredSize ( new Dimension ( 500, 240 ) ) ;
      setLayout ( new BorderLayout() ) ;
      buttonPanel.add ( pb_ADD ) ;
      buttonPanel.add ( pb_EDIT ) ;
      buttonPanel.add ( pb_REMOVE ) ;
      buttonPanel.add ( pb_DOWNLOAD ) ;
      buttonPanel.add ( pb_VERIFY ) ;
      buttonPanel.add ( pb_DEASSOC ) ;
      buttonPanel.add ( fillerButton ) ;
      buttonPanel.add ( pb_UP ) ;
      buttonPanel.add ( pb_DOWN ) ;
      add ( vl_VERSION ) ;
      add ( vl_LOCATION  ) ;
      add ( buttonPanel ) ;
      add ( scr_FILES ) ;

      buttonPanel.setPreferredSize ( new Dimension ( 75, 200 ) ) ;
   }

   /**
     *  This method will lay out and position all of our controls
     **/
   public void doLayout () {
      Dimension size      = getSize() ;
      int       x         = 0 ;
      int       y         = 0 ;
      int       rowHeight = GUISystem.getRowHeight () ;

      super.doLayout() ;

      scr_FILES.setBounds ( x, y, size.width-100, size.height-40 ) ;
      buttonPanel.setBounds ( size.width-100, y, 100, size.height-40 ) ;
      y=size.height-40 ;

      vl_VERSION.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight ;
      vl_LOCATION.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
   }



   /**
     *  This method will be called when the user hits a button
     **/
   public void actionPerformed ( ActionEvent e ) {

      if ( isEnabled () ) {
         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Edit                                                    */
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( ( e.getSource() == pb_EDIT ) ||
              ( e.getSource() == lb_FILES ) ) {
            new FileAttachmentDlg ( GUISystem.getParentDefWin ( this ),
                                    (DocumentFile)lb_FILES.getSelectedValue() ) ;
            revalidate() ;
            refreshData() ;
            document.setFileAttachments ( WinUtil.getListData ( lb_FILES ) ) ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Add                                                     */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( e.getSource() == pb_ADD )
            addFile() ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Remove                                                  */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( e.getSource() == pb_REMOVE ) {
            Object[] selection = lb_FILES.getSelectedValues() ;

            if ( ( selection != null ) && ( selection.length > 0 ) ) {
               for ( int i = 0; i < selection.length; i++ )
                  ((DocumentFile)selection[i]).updateRecStatus ( DocumentFile.REC_DELETE ) ;
               refreshList() ;
            } /* if  */
         } /* else  */


         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Up                                                      */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( e.getSource() == pb_UP ) {
            WinUtil.moveItemUp ( lb_FILES ) ;
            reorderFiles() ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   pb_DOWN                                                 */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( e.getSource() == pb_DOWN ) {
            WinUtil.moveItemDown ( lb_FILES ) ;
            reorderFiles() ;
         }


         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Verify                                                  */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( e.getSource() == pb_VERIFY )
            verifyFile ( lb_FILES.getSelectedValues() ) ;


         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Download                                                */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( e.getSource() == pb_DOWNLOAD ) {
            DocumentFile file = (DocumentFile)lb_FILES.getSelectedValue() ;

            if ( file != null )
               downloadFiles ( file ) ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Deassociate                                             */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( e.getSource() == pb_DEASSOC ) {
            if ( GUISystem.printBox ( STR_QUESTION, STR_FILE_DEASSOC_WARNING ) ) {
               Object[] selection = lb_FILES.getSelectedValues() ;

               if ( ( selection != null ) && ( selection.length > 0 ) ) {
                  for ( int i = 0; i < selection.length; i++ )
                     ((DocumentFile)selection[i]).updateRecStatus ( DocumentFile.REC_DEASSOCIATE ) ;
                  refreshList() ;
               } /* if  */

            }
         }
      }


   } /* actionPerformed  */

   /**
     *  This method gets called when the list is altered
     **/
   public void valueChanged ( ListSelectionEvent e ) {
      if ( isEnabled() ) {
         DocumentFile file        = (DocumentFile) lb_FILES.getSelectedValue() ; 
         boolean      hasSelected = ( file != null ) ;

         pb_EDIT.setEnabled ( hasSelected ) ;
         pb_REMOVE.setEnabled ( hasSelected ) ;
         pb_DOWNLOAD.setEnabled ( hasSelected ) ;
         pb_VERIFY.setEnabled ( hasSelected ) ;
         pb_DEASSOC.setEnabled ( ( hasSelected ) && ( UserSystem.hasAuthority ( AUTH_AUTHOR ) ) ) ;
         pb_UP.setEnabled ( hasSelected ) ;
         pb_DOWN.setEnabled ( hasSelected ) ;

      }

      refreshData() ;
   }


   /**
     *  This method will refresh our data
     **/
   private void refreshData () {
      DocumentFile file        = (DocumentFile) lb_FILES.getSelectedValue() ; 

      if ( file != null ) {
         st_VERSION.setText ( file.getVersion() ) ;
         st_LOCATION.setText ( file.getLocation() ) ;
      } else {
         st_VERSION.setText ( "" ) ;
         st_LOCATION.setText ( "" ) ;
      }

   }


   /**
     *  This method will set the document that we are displaying
     **/
   public void setDocument ( Document document ) {

      if ( this.document != null )
         this.document.removeDocumentPropertyListener ( this ) ;
      document.addDocumentPropertyListener ( this ) ;
      this.document = document ;

      refreshList() ;
   }

   /**
     *  This method will refresh the list of files
     **/
   private void refreshList () {
      Vector files = QuestUtil.getValidData ( document.getFileAttachments() ) ;                                          

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   For backwards compatibility, if the first file has      */
      /* an orderNum of 0, reset all files to start at 1           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( ( files != null ) && 
           ( files.size() > 0 ) &&
           ( files.elementAt(0) != null ) && 
           ( ((DocumentFile)files.elementAt(0)).getOrderNum() == 0 ) ) {
         for ( int i = 0; i < files.size(); i++ )
            ((DocumentFile)files.elementAt(i)).setOrderNum ( i+1 ) ;
      }

      if ( files != null )
         WinUtil.setListData ( files, listModel ) ;

      valueChanged ( null ) ;
   }


   /**
     *  This method will do the following:<br><br>
     *
     * 1. Ask the user for the file to add<br>
     * 2. Create a new DocumentFile object for the file<br>
     * 3. Create and show the FileAttachmentDlg<br>
     * 4. If all is good, add the file to the list<br>
     **/
   private void addFile () {
      File[]  openFile  = GUISystem.getFileOpen ( GUISystem.getParentDefWin ( this ), 
                                                  Str.getStr ( STR_FILE_ATTACHMENT ), 
                                                  PropertySystem.getString ( PropertySystem.PROPERTY_IMPORT_DIRECTORY ) ) ;

      if ( openFile != null ) {
         try {
            File           newFile        = new File ( openFile[0].toString() ) ;
            String         filename       = Text.stripPath ( openFile[0].toString().toLowerCase() ) ;                                       
            DocumentFile   documentFile   = null ;                                               

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Only process if the file exists on the local file system*/
            /*                                                           */
            /*-----------------------------------------------------------*/
            if ( ( newFile.exists() ) && ( newFile.length() > 0 ) ) {
               Vector tempSelect = new Vector () ;                                            

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   Rename the file to lowercase                            */
               /*                                                           */
               /*-----------------------------------------------------------*/
               newFile.renameTo ( new File ( openFile[0].toString().toLowerCase() ) ) ;

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   Only process if this filename differs from the others   */
               /*                                                           */
               /*-----------------------------------------------------------*/
               if ( !fileAlreadyExists ( filename ) ) {

                  /*-----------------------------------------------------------*/
                  /*                                                           */
                  /*   Assign the first set of properties, then show the dlg   */
                  /*                                                           */
                  /*-----------------------------------------------------------*/
                  document.generateKeys() ;
                  documentFile = new DocumentFile ( document.getDocInd(), filename ) ;
                  documentFile.setSize            ( newFile.length() ) ;
                  documentFile.setLocalFilename   ( openFile[0].toString().toLowerCase() ) ;
                  documentFile.updateRecStatus    ( DocumentFile.REC_NOCHANGE ) ;
                  documentFile.updateRecStatus    ( DocumentFile.REC_INSERT ) ;
                  new FileAttachmentDlg ( GUISystem.getParentDefWin ( this ),
                                          documentFile ) ;                                            

                  /*-----------------------------------------------------------*/
                  /*                                                           */
                  /*   If we have a description, then the user filled in all   */
                  /* data and the file is ready to go                          */
                  /*                                                           */
                  /*-----------------------------------------------------------*/
                  if ( documentFile.getDescription() != null ) {
                     document.addFileAttachment ( documentFile ) ;
                     tempSelect.addElement ( documentFile ) ;
                     refreshList() ;
                     WinUtil.selectItems ( lb_FILES, tempSelect ) ;
                  } /* if  */

               } else
                  GUISystem.printBox ( STR_INFO, STR_FILE_ALREADY_EXISTS_IN_DOCUMENT ) ;

            } else
               GUISystem.printBox ( STR_INFO, STR_FILE_INVALID_SIZE_ZERO ) ;


         } catch ( Exception e ) {
            LogSystem.log ( 1, e, false ) ;
            GUISystem.printBox ( STR_ERROR, STR_ERROR_IN_LAST_ACTION ) ;
         }
      }
   } /* addFile  */


   /**
     *  This method will return TRUE if the filename passed exists in the
     * document list of file attachments
     *
     * @param filename The name of the file
     *
     * @return TRUE if exists, in either deleted form or active form
     **/
   private boolean fileAlreadyExists ( String filename ) {
      boolean rc        = false ;
      Vector  files     = document.getFileAttachments() ;

      if ( ( files != null ) && ( files.size() > 0 ) ) {
         int i    = 0 ;
         int size = files.size() ;

         while ( ( !rc ) && ( i < size ) ) {
            if ( ( ((DocumentFile)files.elementAt(i)).getFilename().equals ( filename ) ) &&
                 ( ((DocumentFile)files.elementAt(i)).valid() ) )
               rc = true ;
            i++ ;
         }
      }

      return( rc ) ;
   }



   /**
     *  This method will verify that a file exists on the FTP Server. This is done by:<br><br>
     *
     * 1. Logging into the FTP server<br>
     * 2. Checking that the  file exists in the directory<br>
     * 3. Checking the file size<br><br><br>
     *
     * If the file has a rec status of REC_INSERT, then the file is checked on the
     * local file system.
     *
     * @param files The array of selected files in the lb_FILES
     *
     **/
   private void verifyFile ( Object[] files ) {
      if ( ( files != null ) && ( files.length > 0 ) ) {
         Ftp       ftp        = null ;
         StatusWin statusWin  = new StatusWin ( GUISystem.getParentDefWin ( this )) ;
         String    errorMsg   = "The following errors were found:<br><br>" ;
         boolean   foundError = false ;                    
         String    ftpBaseDir = "/home/ftp/pub/pccbbs" ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Loop through all of the files                           */
         /*                                                           */
         /*-----------------------------------------------------------*/
         statusWin.setVisible ( true ) ;
         statusWin.setMaxValue ( files.length ) ;
         for ( int i = 0; i < files.length; i++ ) {
            DocumentFile documentFile = (DocumentFile)files[i] ;                  

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Check the local file system                             */
            /*                                                           */
            /*-----------------------------------------------------------*/
            System.out.println ( "RecStatus:"+documentFile.getRecStatus() ) ;
            if ( documentFile.getRecStatus() == DocumentFile.REC_INSERT ) {
               File file = null ;

               statusWin.setText ( Str.getStr ( STR_CHECKING_LOCAL_FILE ) ) ;
               file  = new File ( documentFile.getFilename() ) ;

               if ( file.exists() ) {
                  if ( file.length() != documentFile.getSize() ) {
                     foundError = true ;
                     errorMsg+="Local File "+file.toString()+" has byte size of "+file.length()+" while document file attachment has size of "+documentFile.getSize()+" bytes<br><br>" ;
                  }
               } else {
                  foundError = true ;
                  errorMsg+="Local File "+documentFile.getLocalFilename()+" could not be found" ;
               }
            } /* if local  */


            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Check the Remote File                                   */
            /*                                                           */
            /*-----------------------------------------------------------*/
            else {

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   First, if we have not logged into the site, do so now   */
               /*                                                           */
               /*-----------------------------------------------------------*/
               if ( ftp == null ) {
                  statusWin.setText ( "Logging into remote FTP" ) ;
                  ftp = QuestUtil.connectToProductionFileFTP() ;
               }

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   If the FTP Site is good, continue checking              */
               /*                                                           */
               /*-----------------------------------------------------------*/
               if ( ftp != null ) {

                  /*-----------------------------------------------------------*/
                  /*                                                           */
                  /*   Change to the directory of the file                     */
                  /*                                                           */
                  /*-----------------------------------------------------------*/
                  statusWin.setText ( "Checking remote file: "+document.getFilename() ) ;
                  try {
                     ftp.cd ( ftpBaseDir+"/"+documentFile.getLocation() ) ;
                  } catch ( Exception e ) {
                     LogSystem.log ( 1, e, false ) ;
                     errorMsg+= "Cannot change to FTP Directory "+ftpBaseDir+"/"+documentFile.getLocation()+". File "+documentFile.getFilename()+" cannot be verified<br><br>" ;
                     foundError = true ;
                  }

                  try {
                     String[] remoteFiles = ftp.list ( documentFile.getFilename() ) ;

                     if ( ( remoteFiles != null ) && ( remoteFiles.length > 0 ) ) {
                        long size = ftp.size ( documentFile.getFilename() ) ;

                        if ( size != documentFile.getSize() ) {
                           errorMsg+="The size of "+documentFile.getFilename()+" on the FTP site is "+size+" bytes while the size of the file attachment is "+documentFile.getSize()+" bytes" ;
                           foundError = true ;
                        }
                     }

                  } catch ( Exception e ) {
                     LogSystem.log ( 1, e, false ) ;
                     errorMsg+= "Cannot find file "+documentFile.getFilename()+" on ftp site.<br><br>" ;
                     foundError = true ;
                  }


               }

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   If we still haven't logged in then there must have      */
               /* been a problem. We will exit now                          */
               /*                                                           */
               /*-----------------------------------------------------------*/
               else {
                  i=files.length+1 ;
                  errorMsg = "Cannot log into FTP Site for verfication. Please try again later. No Files Verified" ;
                  foundError = true ;
               }
            } /* else, remoteFile  */

         } /* for  */

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Log out of the FTP server if we are in                  */                             
         /*                                                           */
         /*-----------------------------------------------------------*/
         try {
            if ( ftp != null )
               ftp.disconnect() ;
         } catch ( Exception e ) {
         }


         /*-----------------------------------------------------------------------------------*/
         /*                                                                                   */
         /*   Ok, if we found an error, report it. If we didn't find an error, report that to */
         /*                                                                                   */
         /*-----------------------------------------------------------------------------------*/
         statusWin.dispose() ;
         if ( foundError )
            GUISystem.printBox ( Str.getStr ( STR_INFO ), errorMsg ) ;
         else
            GUISystem.printBox ( STR_INFO, STR_ALL_FILES_VERIFIED ) ;

      } /* if any files are selected  */
      else
         GUISystem.printBox ( "Info", "Please select at least 1 file to verify" ) ;
   }



   /**
     *  This method will download the file selected to the user's local directory
     *
     * @param documentFile The DocumentFile to download
     **/
   private void downloadFiles ( DocumentFile documentFile ) {
      AppDefaultWin parentWin = GUISystem.getParentDefWin ( this ) ;
      File[]        openFile  = GUISystem.getFileOpen ( GUISystem.getParentDefWin ( this ), 
                                                        Str.getStr ( STR_SAVE ), 
                                                        PropertySystem.getString ( PropertySystem.PROPERTY_DETACH_DIRECTORY ),
                                                        documentFile.getFilename(),
                                                        false ) ;

      if ( ( openFile != null ) && ( openFile.length > 0 ) ) {
         String localFilename   = openFile[0].toString() ;
         Ftp    ftp             = null ;
         String remoteDirectory = Constants.getStrConst ( "IT_FILELOCTEMP" ) ;

         parentWin.setStatus ( "Logging into Draft FTP Site" ) ;
         ftp = QuestUtil.connectToTempFileFTP () ;

         if ( ftp != null ) {
            try {
               ftp.cd ( remoteDirectory ) ;
               parentWin.setStatus ( Str.getStr ( STR_DOWNLOADING )+" "+documentFile.getFilename() ) ;
               ftp.get ( documentFile.getFilename(), localFilename ) ;
               ftp.disconnect() ;
               GUISystem.printBox ( STR_INFO, STR_DOWNLOAD_COMPLETE ) ;

            } catch ( Exception e ) {
               LogSystem.log ( 1, e, false ) ;
               GUISystem.printBox ( STR_INFO, STR_FTP_SITE_RESPONDED_WITH_ERROR ) ;
            }

         } else
            GUISystem.printBox ( STR_INFO, STR_COULD_NOT_CONNECT_TO_FTP_SITE ) ;
      }

      parentWin.setStatus ( null ) ;
   }



   /**
     *  This method will download the file selected to the user's local directory from
     * the production FTP Box
     *
     * @param documentFile The DocumentFile to download
     * @param localFile The Local Filenaem to get
     **/
   private void downloadFileFromProduction ( DocumentFile documentFile, String localFilename ) {
      AppDefaultWin parentWin = GUISystem.getParentDefWin ( this ) ;
      Ftp           ftp       = null ;

      parentWin.setStatus ( "Logging into Production FTP Site" ) ;
      try {
         ftp = new Ftp() ;
         ftp.setHost ( "ftp.pc.ibm.com" ) ;
         ftp.setUser ( "anonymous" ) ;
         ftp.setPassword ( UserSystem.getUserId()+"@qit.comd" ) ;
         ftp.connect() ;
         ftp.login() ;
      } catch ( Exception e ) {
         LogSystem.log ( 1, e, false ) ;
         GUISystem.printBox ( "Error", "Cannot log into production FTP Server. Make sure your machine is socksified" ) ;
      }

      if ( ftp != null ) {
         try {
            ftp.cd ( "/home/ftp/pub/pccbbs/"+documentFile.getLocation() ) ;
            parentWin.setStatus ( Str.getStr ( STR_DOWNLOADING )+" "+documentFile.getFilename() ) ;
            ftp.get ( documentFile.getFilename(), localFilename ) ;
            ftp.disconnect() ;
            GUISystem.printBox ( STR_INFO, STR_DOWNLOAD_COMPLETE ) ;

         } catch ( Exception e ) {

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   If the file was not found on the temp. directory,       */
            /* then try the production directory                         */
            /*                                                           */
            /*-----------------------------------------------------------*/
            if ( e.toString().indexOf ( "No such file" ) >= 0 ) {
               downloadFileFromProduction ( documentFile, localFilename ) ;
            }

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Otherwise, log the error and do nothing                 */
            /*                                                           */
            /*-----------------------------------------------------------*/
            LogSystem.log ( 1, e, false ) ;
            GUISystem.printBox ( STR_INFO, STR_FTP_SITE_RESPONDED_WITH_ERROR ) ;
         }

      } else
         GUISystem.printBox ( STR_INFO, STR_COULD_NOT_CONNECT_TO_FTP_SITE ) ;

      parentWin.setStatus ( null ) ;
   }



   /**
     *  This method will reorder the file attachments by their position in
     * the list.
     **/
   private void reorderFiles () {
      int i    = 0 ;
      int size = listModel.size() ;

      while ( i < size ) {
         ((DocumentFile)listModel.elementAt(i)).setOrderNum ( i+1 ) ;
         i++ ;
      }
   }/* reorder Files  */



   public void setEnabled ( boolean enable ) {
      super.setEnabled ( enable ) ;

      valueChanged ( null ) ;

   }

   public void documentChanged ( Document document, int property ) {
      if ( property == document.FILE_ATTACHMENTS )
         setDocument ( document ) ;
   }

} /* FileAttachmentPanel */
