package com.ibm.nzna.projects.qit.doc.docmaint ;
/*-----------------------------------------------------------*/
/*   FilterTreeComponent                                     */
/*                                                           */
/*   Description:                                            */
/*      Source code for: FilterTreeComponent                 */
/*                                                           */
/*                                                           */
/*         @Copyright  1998 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import javax.swing.* ;
import java.awt.* ;      
/**
 * This Renderer which do the actual drawing work for items in
 * the Document Maint. Filter
 *
 *
 * @version 1.0, 1/4/1999 
 * @author  David Lentz
 */


/*-----------------------------------------------------------*/
/*                                                           */
/*   FilterTreeComponent                                     */
/*                                                           */
/*-----------------------------------------------------------*/
public class FilterTreeComponent extends DefaultTreeComponent  {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Members                                                 */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private static final Color blue = new Color ( 0, 0, 150 ) ;
   

   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will create a blank FilterTreeComponent
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public FilterTreeComponent () {
      super() ;
      prefSize = new Dimension ( 120, 18 ) ;
   }


   /*------------------------------------------------------------*/
   /* paint
    */
   /**
    *    This method will paint our component
    *  
    *  
    *
    *  @param g The Graphics context
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void paint ( Graphics g ) {
      String dataString = data.toString() ;

      if ( dataString != null ) {

         /* Ok, if we are selected, draw the selection now */
         if ( selected ) {
            Dimension size = getSize() ;

            g.setColor ( blue ) ;
            g.fillRect ( 0, 0, size.width, size.height ) ;
            g.setColor ( Color.white ) ;
         } else
            g.setColor ( Color.black ) ;

         /* Now, draw our text */
         g.drawString ( dataString, 3, 12 ) ;

      }
   }


} /* FilterTreeComponent */
