package com.ibm.nzna.projects.qit.doc.docmaint ;
/*-----------------------------------------------------------*/
/*   FilterTreeRenderer                                      */
/*                                                           */
/*   Description:                                            */
/*      Source code for: FilterTreeRenderer                  */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * The FilterTreeRenderer is the heart of the Filter Tree list. It's
 * job is to return a FilterTreeComponent that will draw an item
 * in the JTree control of the Document Maint.
 *
 *
 * @version 1.0, 1/4/1999 
 * @author  David Lentz
 */
import javax.swing.tree.* ;
import javax.swing.JTree ;
import java.awt.Component ;

/*-----------------------------------------------------------*/
/*                                                           */
/*   FilterTreeRenderer                                      */
/*                                                           */
/*-----------------------------------------------------------*/
public class FilterTreeRenderer extends Object implements TreeCellRenderer {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Vars                                                    */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private FilterTreeComponent filterComp = null ;

   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This will create the FilterTreeRenderer
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public FilterTreeRenderer () {
      filterComp = new FilterTreeComponent () ;
   }




   /*------------------------------------------------------------*/
   /* getTreeCellRendererComponent
    */
   /**
    *    This method will return our ccRendererComponent
    *  instead of the normal JLabel Component
    *  
    *
    *  @param The normal getTreeCellRenderer params
    *
    *  @return Component
    *//*---------------------------------------------------------*/
   public Component getTreeCellRendererComponent ( JTree jTree, Object value, boolean selected, boolean expanded, boolean leaf, int row, boolean hasFocus ) {
      filterComp.refreshData ( value, selected, expanded, leaf, row, hasFocus ) ;
      return( (Component) filterComp ) ;
   } /* getTreeCellRendererComponent */





   /*------------------------------------------------------------*/
   /* setPreferredWidth
    */
   /**
    *    This method will set the preferred width of
    *  all items in the list
    *  
    *
    *  @param width The preferred width
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setPreferredWidth ( int width ) {
      filterComp.setPreferredWidth ( width ) ;
   }


} /* FilterTreeRenderer */
