package com.ibm.nzna.projects.qit.doc.docmaint.property ;                    
/*-----------------------------------------------------------*/
/*   PropertyDlg                                             */
/*                                                           */
/*   Description:                                            */
/*      Source code for: PropertyDlg                         */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.projects.qit.doc.* ;
import com.ibm.nzna.projects.qit.app.* ;
/**
 * This dialog holds simple properties for the DocMaintPanel 
 *
 *
 * @version 1.0, 11/24/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   PropertyDlg                                             */
/*                                                           */
/*-----------------------------------------------------------*/
public class PropertyDlg extends JDialog implements ActionListener, AppConst, DocConst {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   GUI Properties                                          */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private DButton      pb_OK       = null ;
   private DButton      pb_CANCEL   = null ;
   private JTabbedPane  tabbedPane  = null ;
   private ButtonPanel  buttonPanel = null ;            

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Pages in the notebook                                   */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private ViewPropertyPage viewPage      = null ;



   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public PropertyDlg ( Frame parent ) {
      super ( parent, Str.getStr ( STR_PROPERTIES ), true ) ;

      createGUI() ;

      setSize ( 300, 400 ) ;
      WinUtil.centerWindow ( this ) ;
      setVisible ( true ) ;
   }





   /*------------------------------------------------------------*/
   /* createGUI
    */
   /**
    *    This method will create and add our 
    *  GUI components
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void createGUI () {   
      Container contentPane = getContentPane() ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create the GUI                                          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      pb_OK       = new DButton ( Str.getStr ( STR_OK ) ) ;
      pb_CANCEL   = new DButton ( Str.getStr ( STR_CANCEL ) ) ;
      tabbedPane  = new JTabbedPane () ;
      buttonPanel = new ButtonPanel() ;   

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add our tabs                                            */
      /*                                                           */
      /*-----------------------------------------------------------*/
      tabbedPane.addTab ( Str.getStr ( STR_VIEWS ), viewPage = new ViewPropertyPage () ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add listeners                                           */    
      /*                                                           */
      /*-----------------------------------------------------------*/
      pb_OK.addActionListener ( this ) ;
      pb_CANCEL.addActionListener ( this ) ;
      



      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add the GUI                                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      buttonPanel.add ( pb_OK ) ;
      buttonPanel.add ( pb_CANCEL ) ;
      contentPane.setLayout ( null ) ;
      contentPane.add ( tabbedPane ) ;
      contentPane.add ( buttonPanel ) ;
      GUISystem.setPropertiesOnPanel ( contentPane ) ;

   }





   /*------------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will lay out and position all
    *  of our controls
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size      = null ;
      int       rowHeight = GUISystem.getRowHeight () ;

      super.doLayout () ;
      size = getSize() ;

      tabbedPane.setBounds ( 5, 5, size.width-20, size.height-65 ) ;
      buttonPanel.setBounds ( 0, size.height-55, size.width, 25 ) ;
   }






   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will be called when an action
    *  event is fired on us
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Ok                                                      */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( e.getSource() == pb_OK ) {
         if ( ( viewPage.saveData() ) )
            dispose() ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Cancel                                                  */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_CANCEL ) 
         dispose() ;
   }


} /* PropertyDlg */
