package com.ibm.nzna.projects.qit.doc.docview ;         
/*-----------------------------------------------------------*/
/*   DocViewListener                                         */
/*                                                           */
/*   Description:                                            */
/*      Source code for: DocViewListener                     */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This listener gets notified of when a view starts refreshing and stops refreshing 
 *
 *
 * @version 1.0, 11/29/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   DocViewListener                                         */
/*                                                           */
/*-----------------------------------------------------------*/
public interface DocViewListener {




   /*------------------------------------------------------------*/
   /* docViewStarted
    */
   /**
    *    This method will be called when a view
    *  is started to refresh
    *  
    *
    *  @param docView The DocViewRec that is being refreshed
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public abstract void docViewStarted ( DocViewRec docView ) ;





   /*------------------------------------------------------------*/
   /* DocViewStopped
    */
   /**
    *    This method will be called when a view
    *  has completed refreshing. You can grab
    *  the results from the view using the 'DocViewRec.getResults()' method
    *
    *  @param docView The DocViewRec that has stopped
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public abstract void docViewStopped ( DocViewRec docView ) ;
} /* DocViewListener */
