package com.ibm.nzna.projects.qit.doc.fieldchanger ;
/*-----------------------------------------------------------*/
/*   CommentStep                                             */
/*                                                           */
/*   Description:                                            */
/*      Source code for: CommentStep                         */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.doc.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.shared.gui.wizard.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.shared.gui.* ;
import javax.swing.* ;
import java.util.* ;   
import java.awt.* ;
import java.awt.event.* ;
/**
 * This step will ask the user to comment on the changes being made
 *
 *
 * @version 1.0, 1/21/100 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   CommentStep                                             */
/*                                                           */
/*-----------------------------------------------------------*/
public class CommentStep extends WizardStep implements DataLengths, AppConst {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private JLabel      st_HELP        = null ;
   private JTextArea   commentField   = null ;
   private JScrollPane commentScroll  = null ;
   private String      comments       = null ;


   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will create our step
    *  
    *
    *  @param message The Message to display to the user
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public CommentStep (  ) {

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create our controls                                     */
      /*                                                           */
      /*-----------------------------------------------------------*/
      st_HELP        = new JLabel ( ) ;
      commentField   = new JTextArea ( new MaskDocument ( MaskDocument.MASKTYPE_UNKNOWN, LENGTH_COMMENT ) ) ;
      commentScroll  = new JScrollPane ( commentField ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      st_HELP.setVerticalAlignment ( SwingConstants.TOP ) ;
      commentField.setFont ( FontSystem.defaultFont ) ;
      commentScroll.setBorder ( GUISystem.loweredBorder ) ;
      setText() ;                           

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add our controls to the panel                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( null ) ;
      add ( st_HELP ) ;
      add ( commentScroll ) ;                                       

   }




   /*------------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will position and size all
    *  of our controls
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size      = getSize() ;
      int       rowHeight = GUISystem.getRowHeight() ;
      int       x         = 5 ;
      int       y         = 5 ;
      Dimension prefSize  = null ;

      super.doLayout() ;

      st_HELP.setBounds ( x, y, size.width-10, 100 ) ;
      prefSize = st_HELP.getPreferredSize() ;
      st_HELP.setBounds ( x, y, size.width-10, prefSize.height ) ;
      y+=prefSize.height+5 ;

      commentScroll.setBounds ( x, y, size.width-10, size.height-y-10 ) ;
   }





   /*------------------------------------------------------------*/
   /* saveInfo
    */
   /**
    *    This method will save the information
    *  and return TRUE if a language was
    *  selected.
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean saveInfo () {
      boolean rc = false ;

      comments = commentField.getText() ;
      rc = ( ( comments != null ) && ( comments.length() > 0 ) ) ;

      return( rc ) ;
   }

   public void close () {}


   public String getTitle () {
      return( Str.getStr ( STR_ENTER_COMMENTS_FOR_MASS_CHANGE_TITLE ) ) ;
   }


   /*------------------------------------------------------------*/
   /* setText
    */
   /**
    *    This method will set the text of the panel
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void setText () {
      st_HELP.setText ( Str.getStr ( STR_ENTER_COMMENTS_FOR_MASS_CHANGE ) ) ;
   }





   /*------------------------------------------------------------*/
   /* getComments
    */
   /**
    *    This method will return the comments
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getComments () {
      return( comments ) ;
   }

} /* CommentStep */
