package com.ibm.nzna.projects.qit.doc.fieldchanger ;                    
/*-----------------------------------------------------------*/
/*   DocBodyFieldChanger                                     */
/*                                                           */
/*   Description:                                            */
/*      Source code for: DocBodyFieldChanger                 */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.quest.doc.* ;
import com.ibm.nzna.projects.common.storedProc.sqlRunner.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.popup.* ;
import com.ibm.nzna.projects.qit.storedProc.sqlRunner.* ;
import com.ibm.nzna.projects.qit.doc.* ;
/**
 * This field changer will change the Document Metrics of 
 * a list of documents
 *
 * @version 1.0, 11/22/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   DocBodyFieldChanger                                     */
/*                                                           */
/*-----------------------------------------------------------*/
public class DocBodyFieldChanger extends Object implements DocConst, FieldChanger, AppConst {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private boolean continueProcess = true ;





   /*------------------------------------------------------------*/
   /* beginProcess
    */
   /**
    *    This method will begin processing the document
    *  list passed
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean beginProcess ( Vector docList, Object data, boolean updateOnly, DocFieldChangerPanel changerPanel ) {
      boolean        rc        = false ;
      int            i         = 0 ;
      int            size      = docList.size() ;
      StringBuffer   sqlBuffer = new StringBuffer() ;
      DocumentDraft         draft    = null ;
      BodyReplaceRec bodyRec   = (BodyReplaceRec)data ;                                 

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Form what big buffer to send to SQL Runner              */
      /*                                                           */
      /*-----------------------------------------------------------*/
      while ( ( continueProcess ) && ( i < size ) ) {

         draft = FieldChangerUtil.getDraftFromRow ( (DocumentRow)docList.elementAt(i) ) ;

         if ( draft != null ) {

            changerPanel.setStatus ( Str.getStr ( STR_READING )+" "+draft.getTitle() ) ;
            if ( ( draft.readFromDatabase() == 0 ) && ( draft.getDocumentBody() != null ) ) {
               String body = draft.getDocumentBody().toString() ;

               body = Text.replaceAllStrInStr ( body, bodyRec.originalStr, bodyRec.newStr ) ;

               draft.setDocumentBody ( new DocumentBody ( body ) );
               draft.updateRecStatus ( draft.REC_UPDATE ) ;

               try {
                  changerPanel.setStatus ( Str.getStr ( STR_SAVING )+" "+draft.getTitle() ) ;
                  continueProcess = (draft.writeToDatabase()==0) ;
               } catch ( Exception e ) {
                  GUISystem.printBox ( STR_ERROR, STR_ERROR_IN_LAST_ACTION ) ;
                  LogSystem.log ( 1, e, false ) ;
               }

               if ( continueProcess ) {
                  sqlBuffer.append ( "UPDATE QUEST.DOCUMENTS SET " ) ;
                  sqlBuffer.append ( "DBUSER = '"+UserSystem.getUserId()+"', " ) ;
                  sqlBuffer.append ( "CHANGEDTIME = CURRENT TIMESTAMP, " ) ;
                  sqlBuffer.append ( "COMMENT = '"+Text.cleanDBString ( draft.getOriginalComments()+"\n"+draft.getComments() )+"' " ) ;
                  sqlBuffer.append ( "WHERE DOCIND = "+draft.getDocInd() ) ;
                  sqlBuffer.append ( SqlRunner.END_DELIM ) ;
               }
            }
            ((DocumentRow)docList.elementAt(i)).freeDocument() ;
         }
         i++ ;
      } /* while  */

      changerPanel.setStatus ( Str.getStr ( STR_SAVING ) );           

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Now, send the buffer                                    */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( continueProcess )
         rc = QITSqlRunner.sqlRunner ( sqlBuffer.toString() ) ;

      return( rc ) ;
   } /* beginProcess  */


   /*------------------------------------------------------------*/
   /* stopProcess
    */
   /**
    *    This method will stop the processing at the next
    *  available point
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void stopProcess () {
      continueProcess = false ;
   }

} /* DocBodyFieldChanger */
