package com.ibm.nzna.projects.qit.doc.fieldchanger ;                    
/*-----------------------------------------------------------*/
/*   DocCategoryFieldChanger                                 */
/*                                                           */
/*   Description:                                            */
/*      Source code for: DocCategoryFieldChanger             */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.quest.doc.* ;
import com.ibm.nzna.projects.common.storedProc.sqlRunner.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.storedProc.sqlRunner.* ;
import com.ibm.nzna.projects.qit.doc.* ;
/**
 * This field changer will change the document type of 
 * a list of documents
 *
 * @version 1.0, 11/22/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   DocCategoryFieldChanger                                 */
/*                                                           */
/*-----------------------------------------------------------*/
public class DocCategoryFieldChanger extends Object implements DocConst, FieldChanger, AppConst {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private boolean continueProcess = true ;





   /*------------------------------------------------------------*/
   /* beginProcess
    */
   /**
    *    This method will begin processing the document
    *  list passed
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean beginProcess ( Vector docList, Object data, boolean updateOnly, DocFieldChangerPanel changerPanel ) {
      boolean      rc        = false ;
      int          i         = 0 ;
      int          size      = docList.size() ;
      StringBuffer sqlBuffer = new StringBuffer() ;
      DocumentDraft       draft    = null ;
      Vector       catVec    = (Vector)data ;
      int          catIndex  = 0 ;
      int          catSize   = catVec.size() ;                                 

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Form what big buffer to send to SQL Runner              */
      /*                                                           */
      /*-----------------------------------------------------------*/
      while ( ( continueProcess ) && ( i < size ) ) {

         draft = FieldChangerUtil.getDraftFromRow ( (DocumentRow)docList.elementAt(i) ) ;

         if ( draft != null ) {                                   

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   If this is an update and replace, delete all the        */
            /* categories first                                          */
            /*                                                           */
            /*-----------------------------------------------------------*/
            if ( !updateOnly ) {
               sqlBuffer.append ( "DELETE FROM QUEST.DOCCATEGORY WHERE DOCIND = "+draft.getDocInd() ) ;
               sqlBuffer.append ( SqlRunner.END_DELIM ) ;
            }

            catIndex=0 ;                                          

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   First, to prevent an SQLCode -803 from being thrown     */
            /* delete all of the categories that the user wants to add   */
            /* and then insert them                                      */
            /*                                                           */
            /*-----------------------------------------------------------*/
            while ( ( continueProcess ) && ( catIndex < catSize ) ) {

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   Delete                                                  */
               /*                                                           */
               /*-----------------------------------------------------------*/
               sqlBuffer.append ( "DELETE FROM QUEST.CATEGORY WHERE TYPECATIND = " ) ;
               sqlBuffer.append ( ((TypeDocCatRec)catVec.elementAt(catIndex)).getInd()+" AND " ) ;
               sqlBuffer.append ( "DOCIND = "+draft.getDocInd() ) ;
               sqlBuffer.append ( SqlRunner.END_DELIM ) ;

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   Insert                                                  */
               /*                                                           */
               /*-----------------------------------------------------------*/
               sqlBuffer.append ( "INSERT INTO QUEST.CATEGORY ( DOCIND, TYPECATIND ) VALUES (" ) ;
               sqlBuffer.append ( ""+draft.getDocInd()+", " ) ;
               sqlBuffer.append ( ((TypeDocCatRec)catVec.elementAt(catIndex)).getInd()+" ) " ) ;
               sqlBuffer.append ( SqlRunner.END_DELIM ) ;          

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   Update the comments                                     */
               /*                                                           */
               /*-----------------------------------------------------------*/
               sqlBuffer.append ( "UPDATE QUEST.DOCUMENTS " ) ;
               sqlBuffer.append ( "SET DBUSER = '"+UserSystem.getUserId()+"', " ) ;
               sqlBuffer.append ( "CHANGEDTIME = CURRENT TIMESTAMP, " ) ;
               sqlBuffer.append ( "COMMENT = '"+Text.cleanDBString ( draft.getOriginalComments()+"\n"+draft.getComments() )+"' " ) ;
               sqlBuffer.append ( "WHERE DOCIND = "+draft.getDocInd() ) ;
               sqlBuffer.append ( SqlRunner.END_DELIM ) ;

               catIndex++ ;
            }

            ((DocumentRow)docList.elementAt(i)).freeDocument() ;
         }

         i++ ;
      } /* while  */

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Now, send the buffer                                    */           
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( continueProcess )
         rc = QITSqlRunner.sqlRunner ( sqlBuffer.toString() ) ;

      return( rc ) ;
   } /* beginProcess  */


   /*------------------------------------------------------------*/
   /* stopProcess
    */
   /**
    *    This method will stop the processing at the next
    *  available point
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void stopProcess () {
      continueProcess = false ;
   }

} /* DocCategoryFieldChanger */
