package com.ibm.nzna.projects.qit.doc.fieldchanger ;                    
/*-----------------------------------------------------------*/
/*   DocStatusFieldChanger                                   */
/*                                                           */
/*   Description:                                            */
/*      Source code for: DocStatusFieldChanger               */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.quest.doc.* ;
import com.ibm.nzna.projects.common.storedProc.sqlRunner.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.storedProc.sqlRunner.* ;
import com.ibm.nzna.projects.qit.doc.* ;
/**
 * This field changer will change the document type of 
 * a list of documents
 *
 * @version 1.0, 11/22/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   DocStatusFieldChanger                                   */
/*                                                           */
/*-----------------------------------------------------------*/
public class DocStatusFieldChanger extends Object implements DocConst, FieldChanger, AppConst {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private boolean continueProcess = true ;





   /*------------------------------------------------------------*/
   /* beginProcess
    */
   /**
    *    This method will begin processing the document
    *  list passed
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean beginProcess ( Vector docList, Object data, boolean updateOnly, DocFieldChangerPanel changerPanel ) {
      boolean      rc             = false ;
      int          i              = 0 ;
      int          size           = docList.size() ;
      StringBuffer sqlBuffer      = new StringBuffer() ;
      DocumentDraft       draft         = null ;
      int          countryCodeInd = PropertySystem.getInt ( PropertySystem.PROPERTY_COUNTRY ) ;                                 

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Form what big buffer to send to SQL Runner              */
      /*                                                           */
      /*-----------------------------------------------------------*/
      while ( ( continueProcess ) && ( i < size ) ) {

         draft = FieldChangerUtil.getDraftFromRow ( (DocumentRow)docList.elementAt(i) ) ;

         if ( draft != null ) {

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Delete                                                  */
            /*                                                           */
            /*-----------------------------------------------------------*/
            sqlBuffer.append ( "DELETE FROM QUEST.DOCSTATUS WHERE RECNUM <> 1 AND DOCIND = "+draft.getDocInd() ) ;
            sqlBuffer.append ( SqlRunner.END_DELIM ) ;

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Insert                                                  */
            /*                                                           */
            /*-----------------------------------------------------------*/
            sqlBuffer.append ( "INSERT INTO QUEST.DOCSTATUS ( DOCIND, RECNUM, STATUSIND, COUNTRYCODEIND, STATUSDATE, REFERENCE, DBUSER, CHANGEDTIME ) " ) ;
            sqlBuffer.append ( "VALUES ( "+draft.getDocInd()+", 2, " ) ;
            sqlBuffer.append ( ((StatusRec)data).getStatusInd()+", " ) ;
            sqlBuffer.append ( ""+countryCodeInd+", " ) ;
            sqlBuffer.append ( "'"+((StatusRec)data).getDate()+"', " ) ;
            sqlBuffer.append ( "NULL, " ) ;
            sqlBuffer.append ( " '"+UserSystem.getUserId()+"', " ) ;
            sqlBuffer.append ( " CURRENT TIMESTAMP ) " ) ;
            sqlBuffer.append ( SqlRunner.END_DELIM ) ;          

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Update the comments                                     */
            /*                                                           */
            /*-----------------------------------------------------------*/
            sqlBuffer.append ( "UPDATE QUEST.DOCUMENTS " ) ;
            sqlBuffer.append ( "SET DBUSER = '"+UserSystem.getUserId()+"', " ) ;
            sqlBuffer.append ( "CHANGEDTIME = CURRENT TIMESTAMP, " ) ;
            sqlBuffer.append ( "COMMENT = '"+Text.cleanDBString ( draft.getOriginalComments()+"\n"+draft.getComments() )+"' " ) ;
            sqlBuffer.append ( "WHERE DOCIND = "+draft.getDocInd() ) ;
            sqlBuffer.append ( SqlRunner.END_DELIM ) ;
            ((DocumentRow)docList.elementAt(i)).freeDocument() ;
         }

         i++ ;
      } /* while  */

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Now, send the buffer                                    */           
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( continueProcess )
         rc = QITSqlRunner.sqlRunner ( sqlBuffer.toString() ) ;

      return( rc ) ;
   } /* beginProcess  */


   /*------------------------------------------------------------*/
   /* stopProcess
    */
   /**
    *    This method will stop the processing at the next
    *  available point
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void stopProcess () {
      continueProcess = false ;
   }

} /* DocStatusFieldChanger */
