package com.ibm.nzna.projects.qit.doc.fieldchanger ;                    
/*-----------------------------------------------------------*/
/*   DocTagsFieldChanger                                     */
/*                                                           */
/*   Description:                                            */
/*      Source code for: DocTagsFieldChanger                 */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.quest.doc.* ;
import com.ibm.nzna.projects.common.storedProc.sqlRunner.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.storedProc.sqlRunner.* ;
import com.ibm.nzna.projects.qit.doc.* ;
/**
 * This field changer will change the Document Publishing Tags of 
 * a list of documents
 *
 * @version 1.0, 11/22/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   DocTagsFieldChanger                                     */
/*                                                           */
/*-----------------------------------------------------------*/
public class DocTagsFieldChanger extends Object implements DocConst, FieldChanger, AppConst {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private boolean continueProcess = true ;





   /*------------------------------------------------------------*/
   /* beginProcess
    */
   /**
    *    This method will begin processing the document
    *  list passed
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean beginProcess ( Vector docList, Object data, boolean updateOnly, DocFieldChangerPanel changerPanel ) {
      boolean           rc        = false ;
      int               i         = 0 ;
      int               size      = docList.size() ;
      StringBuffer      sqlBuffer = new StringBuffer() ;
      DocumentDraft            draft    = null ;
      PublishingTagsRec tagsRec   = (PublishingTagsRec) data ;                                 

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Form what big buffer to send to SQL Runner              */
      /*                                                           */
      /*-----------------------------------------------------------*/
      while ( ( continueProcess ) && ( i < size ) ) {
         draft = FieldChangerUtil.getDraftFromRow ( (DocumentRow)docList.elementAt(i) ) ;

         if ( draft != null ) {

            sqlBuffer.append ( "UPDATE QUEST.DOCUMENTS SET " ) ;
            sqlBuffer.append ( "WEBABLE       = '"+getYN ( tagsRec.webable       )        +"', " ) ;
            sqlBuffer.append ( "WEBONLY       = '"+getYN ( tagsRec.webOnly       )        +"', " ) ;
            sqlBuffer.append ( "FAXABLE       = '"+getYN ( tagsRec.faxable       )        +"', " ) ;
            sqlBuffer.append ( "FLASHNEWS     = '"+getYN ( tagsRec.hotFlash      )        +"', " ) ;
            sqlBuffer.append ( "FLASHDATE     =  "+getNullable(tagsRec.flashDate )         +", " ) ;
            sqlBuffer.append ( "FAQ           = '"+getYN ( tagsRec.faq           )        +"', " ) ;
            sqlBuffer.append ( "EMAILABLE     = '"+getYN ( tagsRec.eMailable     )        +"', " ) ;
            sqlBuffer.append ( "EMAILABLEDATE = "+getNullable(tagsRec.eMailableDate)      +", " ) ;
            sqlBuffer.append ( "KNOWLEDGEBASE = '"+getYN ( tagsRec.knowledgeBase )        +"', " ) ;
            sqlBuffer.append ( "REVIEWPERIOD  =  "+tagsRec.monthsToReview+", " ) ;
            sqlBuffer.append ( "DBUSER = '"+UserSystem.getUserId()+"', " ) ;
            sqlBuffer.append ( "CHANGEDTIME = CURRENT TIMESTAMP, " ) ;
            sqlBuffer.append ( "COMMENT = '"+Text.cleanDBString ( draft.getOriginalComments()+"\n"+draft.getComments() )+"' " ) ;
            sqlBuffer.append ( "WHERE DOCIND = "+draft.getDocInd() ) ;
            sqlBuffer.append ( SqlRunner.END_DELIM ) ;
            ((DocumentRow)docList.elementAt(i)).freeDocument() ;
         }
         i++ ;
      } /* while  */

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Now, send the buffer                                    */           
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( continueProcess )
         rc = QITSqlRunner.sqlRunner ( sqlBuffer.toString() ) ;

      return( rc ) ;
   } /* beginProcess  */


   /*------------------------------------------------------------*/
   /* stopProcess
    */
   /**
    *    This method will stop the processing at the next
    *  available point
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void stopProcess () {
      continueProcess = false ;
   }


   private static String getYN ( boolean b ) {
      return( b ? "Y" : "N" ) ;
   }

   private static String getNullable ( String string ) {
      if ( string != null )
         return( "'"+string+"'" ) ;

      return( "NULL" ) ;
   }
} /* DocTagsFieldChanger */
