package com.ibm.nzna.projects.qit.doc.fieldchanger ;    
/*-----------------------------------------------------------*/
/*   FieldChanger                                            */
/*                                                           */
/*   Description:                                            */
/*      Source code for: FieldChanger                        */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
/**
 * This interface defines the methods that a class will need to be a FieldChanger 
 *
 *
 * @version 1.0, 11/22/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   FieldChanger                                            */
/*                                                           */
/*-----------------------------------------------------------*/
public interface FieldChanger {




   /*------------------------------------------------------------*/
   /* beginProcess
    */
   /**
    *    This method must begin the process of 
    *  changing the documents identified in 'docList'. This
    *  method should not return until an unrecoverable error occurs
    *  or all processing is complete
    *  
    *
    *  @param docList The Vector of DocRecs that need to be changed.
    *  @param data The Data Object to change the field to
    *  @param updateOnly The FieldChanger should only update information, not Update and Replace information
    *  @param DocFieldChangerPanel The panel that holds the current status
    *
    *  @return TRUE if everything went Ok
    *//*---------------------------------------------------------*/
   public abstract boolean beginProcess ( Vector docList, Object data, boolean updateOnly, DocFieldChangerPanel changerPanel ) ;




   /*------------------------------------------------------------*/
   /* stopProcess
    */
   /**
    *    This method should notify the process
    *  that it should stop at the next available point. Please
    *  note that any update to a document MUST complete, in
    *  the event that a stop is called in the middle of an update,
    *  the current Document should be processed fully and then stopped.
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public abstract void stopProcess () ;

} /* FieldChanger */
