package com.ibm.nzna.projects.qit.doc.gui ;     
/*-----------------------------------------------------------*/
/*   DocumentTable                                           */
/*                                                           */
/*   Description:                                            */
/*      Source code for: DocumentTable                       */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import java.util.* ;
import com.ibm.nzna.projects.qit.doc.* ;
import com.ibm.nzna.projects.qit.doc.model.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.projects.qit.app.* ;
/**
 * This subclass of MultiList is used to display documents. Any
 * QuestApplet that needs to display a list of documents should
 * do so with this control.
 *
 *
 * @version 1.0, 4/4/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   DocumentTable                                           */
/*                                                           */
/*-----------------------------------------------------------*/
public class DocumentTable extends MultiList implements DocConst, AppConst {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    Default constructor creates the default
    *  table
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public DocumentTable () {
      super ( GUISystem.getFontUtil() ) ;
      initialize() ;
   }





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will create a DocumentTable
    *  with the documents that are in the vector passed
    *  
    *
    *  @param documents A Vector of DocumentList objects to show
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public DocumentTable ( Vector documents ) {
      super ( GUISystem.getFontUtil() ) ;
      initialize() ;
      setDocuments ( documents ) ;
   }




   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will initialize our default control
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void initialize () {
      String[] listTitle = { 
         " ",
         Str.getStr ( STR_DOC_IND ),
         Str.getStr ( STR_TITLE ),
         Str.getStr ( STR_LOTUS_NOTES_ID ),
         Str.getStr ( STR_LAST_TOUCHED_BY ),
         Str.getStr ( STR_LAST_TOUCHED_ON )} ;

      setForeground      ( Color.black ) ;
      setWordWrap        ( true ) ;
      setColumnHeadings  ( listTitle ) ;
      showColumnHeadings ( true ) ;
      setOddLinesColor   ( new Color ( 230, 230, 230 ) ) ;


      setDefaultColumnWidths() ;
   } /* initialize  */




   /*------------------------------------------------------------*/
   /* setDocuments
    */
   /**
    *    This method will set the documents that
    *  we have. The current set of documents being
    *  viewed will be erased
    *
    *  @param documents A Vector of DocumentList objects to show
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setDocuments ( Vector documents ) {
      setData ( documents ) ;
   }


   public void setColumnWidth ( int column, int width ) {
      super.setColumnWidth ( column, width ) ;
      PropertySystem.putDetailList ( PROPERTY_DOCUMENT_COLUMN_WIDTHS, this ) ;
   }


   /**
     * This method will set the title of a specific column
     **/
   public void setColumnTitle ( int column, String title ) {
      String[] listTitle = { 
         " ",
         Str.getStr ( STR_DOC_IND ),
         Str.getStr ( STR_TITLE ),
         Str.getStr ( STR_LOTUS_NOTES_ID ),
         Str.getStr ( STR_LAST_TOUCHED_BY ),
         Str.getStr ( STR_LAST_TOUCHED_ON )} ;

      listTitle[column]=title ;

      setColumnHeadings ( listTitle ) ;
      setDefaultColumnWidths() ;
   }


   /**
     * this method will set the default column widths
     **/
   public void setDefaultColumnWidths () {
      if ( !PropertySystem.getDetailList ( PROPERTY_DOCUMENT_COLUMN_WIDTHS, this ) ) {
         setColumnWidth     ( 0, 20 ) ;
         setColumnWidth     ( 1, 75  ) ;
         setColumnWidth     ( 2, 300 ) ;
         setColumnWidth     ( 3, 100 ) ;
         setColumnWidth     ( 4, 100 ) ;
         setColumnWidth     ( 5, 200 ) ;
      } /* if  */
   }
} /* DocumentTable */
