package com.ibm.nzna.projects.qit.doc.history ;     
/*-----------------------------------------------------------*/
/*   DocHistoryRec                                           */
/*                                                           */
/*   Description:                                            */
/*      Source code for: DocHistoryRec                       */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.qit.doc.* ;
/**
 * This class represents a single document in history 
 *
 *
 * @version 1.0, 8/30/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   DocHistoryRec                                           */
/*                                                           */
/*-----------------------------------------------------------*/
public class DocHistoryRec extends Object implements MultiListSort, DocConst, AppConst, MultiListRow {



   private String prettyUser = null ;
   private String stopDate   = null ;
   private int    docInd     = 0 ;
   private int    existingDocInd = 0 ;




   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This constructor initializes the DocHistoryRec
    *  to the DocRec passed in
    *  
    *
    *  @param docRec The DocRec in history to represent
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public DocHistoryRec ( int docInd, String stopDate, String prettyUser, int existingDocInd) {
      this.docInd = docInd ;
      this.stopDate = stopDate ;
      this.prettyUser = prettyUser ;
      this.existingDocInd = existingDocInd ;
   }





   /*------------------------------------------------------------*/
   /* getColumnData
    */
   /**
    *    This method will return the data that is supposed
    *  to be showing in a column
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public Object getColumnData ( int column ) {
      Object retObj = null ;


      switch ( column ) {



         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   The request indicator                                   */
         /*                                                           */
         /*-----------------------------------------------------------*/
         case 0 :
            retObj = ""+docInd ;
            break ;                          


            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   The time the document was published                     */
            /*                                                           */
            /*-----------------------------------------------------------*/
         case 1 :
            retObj = stopDate ;
            break ;                  


            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   The person who published it                             */
            /*                                                           */
            /*-----------------------------------------------------------*/
         case 2 :
            retObj = prettyUser ;
            break ;

      }

      return( retObj ) ;

   }

       
   public int compareTo ( MultiListSort row, int column ) {
      int rc = 0 ;

      if ( row instanceof DocHistoryRec ) {
         DocHistoryRec historyRow = (DocHistoryRec) row ;

         switch ( column ) {
            case 0 :
               if ( historyRow.docInd > docInd )
                  rc=1 ;
               else
                  rc=2 ;
               break ;

            case 1 :
               String stopDate  = historyRow.stopDate ;
               String stopDate2 = stopDate;

               rc = CDate.compareDate ( stopDate, stopDate2, CDate.DATE_DATE ) ;
               break ;

            case 2 :
               String dbUser  = historyRow.prettyUser ;
               String dbUser2 = prettyUser ;

               rc = dbUser.compareTo ( dbUser2 ) ;
               break ;
         }
      }

      return( rc ) ;
   }


   public int getDocInd () {
      return ( docInd ) ;
   }

   public int getExistingDocInd () {
      return ( existingDocInd ) ;
   }
} /* DocHistoryRec */
