package com.ibm.nzna.projects.qit.ftp_explorer ;   
/*-----------------------------------------------------------*/
/*   FTPNavPanel                                             */
/*                                                           */
/*   Description:                                            */
/*      Source code for: FTPNavPanel                         */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import javax.swing.* ;
import javax.swing.event.* ;
import java.awt.* ;
import java.util.* ;
import java.awt.event.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.shared.gui.* ;
/**
 * This nav panel goes with the FTPExplorerPanel 
 *
 *
 * @version 1.0, 4/14/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   FTPNavPanel                                             */
/*                                                           */
/*-----------------------------------------------------------*/
public class FTPNavPanel extends JPanel implements ActionListener, NavPanel, AppConst {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Titles                                                  */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private static final String[] fileTitle = { 
      "", 
      Str.getStr ( STR_FILENAME ), 
      Str.getStr ( STR_SIZE )
   } ;

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private GUI                                             */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private NavList      directories       = new NavList () ;
   private JScrollPane  scr_DIRECTORY     = new JScrollPane ( directories ) ;
   private HotLinkLabel pb_UPDIR          = null ;      

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private FTPExplorerPanel panel         = null ;






   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public FTPNavPanel ( FTPExplorerPanel panel ) {
      this.panel = panel ;
   }


   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will initialize our nav panel
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void initialize () {

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create the controls                                     */
      /*                                                           */
      /*-----------------------------------------------------------*/
      pb_UPDIR    = new HotLinkLabel ( "..                        .", ImageSystem.getImageIcon ( this, ImageSystem.UP_DIR ) ) ;        
      scr_DIRECTORY.setBorder ( GUISystem.emptyBorder ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add action listeners                                    */
      /*                                                           */
      /*-----------------------------------------------------------*/
      pb_UPDIR.addActionListener ( this ) ;       


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add the controls                                        */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( new BorderLayout() );
      directories.add ( pb_UPDIR ) ;
      add ( scr_DIRECTORY, BorderLayout.CENTER ) ;

   }




   /*------------------------------------------------------------*/
   /* start
    */
   /**
    *    This method will start our panel
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void start () {
   }




   /*------------------------------------------------------------*/
   /* stop
    */
   /**
    *    This method will free our resources
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void stop () {
   }




   /*------------------------------------------------------------*/
   /* getJComponent
    */
   /**
    *    This method will return an instance of this
    *  panel
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public JComponent getJComponent () {
      return( this ) ;
   }




   /*------------------------------------------------------------*/
   /* getTitle
    */
   /**
    *    This method will return our title
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getTitle () {
      return( Str.getStr ( STR_DIRECTORIES ) ) ;
   }


   protected void clear () {
      directories.removeAll() ;
      directories.add ( pb_UPDIR ) ;

   }




   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will be called when an action
    *  event is thrown
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {

      if ( e.getSource() == pb_UPDIR )
         panel.changeDir ( ".." ) ;

      else if ( e.getSource() instanceof HotLinkLabel ) {
         panel.changeDir ( ((HotLinkLabel)e.getSource()).getText() ) ;
      }
   }



   /*------------------------------------------------------------*/
   /* refreshList
    */
   /**
    *    This method will refresh our list with the 
    *  vector passed in
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void refreshList ( Vector vec ) {
      clear() ;

      if ( ( vec != null ) && ( vec.size() > 0 ) ) {
         int          i      =  0 ;
         int          size   = vec.size() ;
         HotLinkLabel newDir = null ;
         HotLinkGroup group  = new HotLinkGroup () ;
         ImageIcon    folder = ImageSystem.getImageIcon ( this, ImageSystem.CLOSE_FOLDER ) ;

         while ( i < size ) {
            newDir = new HotLinkLabel ( vec.elementAt(i).toString(), folder ) ;
            newDir.addActionListener ( this ) ;
            group.add ( newDir ) ;
            directories.add ( newDir ) ;
            i++ ;
         }

      }
   }

} /* FTPNavPanel */
