package com.ibm.nzna.projects.qit.gui ;    
/*-----------------------------------------------------------*/
/*   BlankNavPanel                                           */
/*                                                           */
/*   Description:                                            */
/*      Source code for: BlankNavPanel                       */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import javax.swing.* ;
import com.ibm.nzna.projects.qit.app.* ;
/**
 * This is a generic NavPanel that holds a simple JPanel.
 *
 * @version 1.0, 4/23/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   BlankNavPanel                                            */
/*                                                           */
/*-----------------------------------------------------------*/
public class BlankNavPanel extends JPanel implements NavPanel, AppConst {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private GUI Members                                     */
   /*                                                           */
   /*-----------------------------------------------------------*/

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private String title = null ;




   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will create and initialize the BlankNavPanel.
    *  
    *  
    *
    *  @param title The title of the panel
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public BlankNavPanel ( String title ) {
      this.title = title ;
   }




   /*------------------------------------------------------------*/
   /* getTitle
    */
   /**
    *    This method will return our title
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getTitle () {
      return( title ) ;
   }




   /*------------------------------------------------------------*/
   /* getJComponent
    */
   /**
    *    This method will return our component
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return JComponent
    *//*---------------------------------------------------------*/
   public JComponent getJComponent () {
      return( this ) ;
   }





   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will initialize our controls and
    *  variables
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return boolean
    *//*---------------------------------------------------------*/
   public void initialize () {
   }





   /*------------------------------------------------------------*/
   /* start
    */
   /**
    *    This method will do nothing
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void start () {
   }




   /*------------------------------------------------------------*/
   /* stop
    */
   /**
    *    This method will remove all our items and
    *  will release our resources
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void stop () {
      removeAll() ;
   }




   /*------------------------------------------------------------*/
   /* setDynamicPanel
    */
   /**
    *    This method will set the dynamicPanel that
    *  we use. If a NULL is passed, no dynamicPanel
    *  will show
    *
    *  @param panel The panel to add
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setJPanel ( JPanel panel ) {
      removeAll() ;
      setLayout ( new BorderLayout() ) ;
      add ( panel, BorderLayout.CENTER ) ;
   }





} /* BlankNavPanel */
