package com.ibm.nzna.projects.qit.gui ;
/*-----------------------------------------------------------*/
/*   Browser                                                 */
/*                                                           */
/*   Description:                                            */
/*      Source code for: Browser                             */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This interface defines the methods needed for any Java HTML Browser 
 *
 *
 * @version 1.0, 8/6/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   Browser                                                 */
/*                                                           */
/*-----------------------------------------------------------*/
public interface Browser {



   /**
     *  This method will return TRUE if the browser can go back
     **/
   public abstract boolean canGoBack () ;

   /**
     *  This method will return TRUE if the browser can go forward
     **/
   public abstract boolean canGoForward () ;


   /**
     *  This method should make the browser go back a page
     **/
   public abstract void back() ;

   /**
     *  This method should make the browser go forward a page
     **/
   public abstract void forward() ;

   /**
     *  This method should make the browser stop
     **/
   public abstract void stop () ;

   /**
     *  This method will make the browser load a URL
     **/
   public abstract void loadURL ( String url ) ;

   /**
     *  This method will make the browser reload the current page
     **/
   public abstract void reload () ;

   /**
     *  This method will make the browser set the current content
     * to the string of HTML Passed
     **/
   public abstract void setPageContent ( String pageContent ) ;

   /**
     *  This method will return the source code for the page that
     * is being displayed
     **/
   public abstract String getSource () ;



   /**                    
     *  This method must add a BrowserListener to the browser
     **/
   public abstract void addBrowserListener ( BrowserListener listener ) ;

   /**
     *  This method must remove a BrowserListener from the browser
     **/
   public abstract void removeBrowserListener ( BrowserListener listener ) ;


   /**
     *  This method must return the actual JComponent that will be used
     **/
   public abstract java.awt.Component getComponent () ;



} /* Browser */
