package com.ibm.nzna.projects.qit.gui ;              
/*-----------------------------------------------------------*/
/*   BrowserListener                                         */
/*                                                           */
/*   Description:                                            */
/*      Source code for: BrowserListener                     */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This listener has methods that are called by the Browser control 
 *
 *
 * @version 1.0, 2/10/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   BrowserListener                                         */
/*                                                           */
/*-----------------------------------------------------------*/
public interface BrowserListener {






   /*------------------------------------------------------------*/
   /* pageStopped
    */
   /**
    *    This method will be called once a page
    *  is loaded completely.
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public abstract void pageStopped () ;




   /*------------------------------------------------------------*/
   /* pageStarted
    */
   /**
    *    This method will be called when a page
    *  has begun to load.
    *  
    *
    *  @param url The name of the site loading
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public abstract void pageStarted ( String url ) ;




   /*------------------------------------------------------------*/
   /* mouseOverLink
    */
   /**
    *    This method will be called when the
    *  mouse has moved over a link
    *  
    *
    *  @param url The url that the mouse is over
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public abstract void mouseOverLink ( String url ) ;





   /*------------------------------------------------------------*/
   /* mouseLinkExit
    */
   /**
    *    This method will be called when the mouse
    *  has left a link
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public abstract void mouseLinkExit () ;





   /*------------------------------------------------------------*/
   /* linkClicked
    */
   /**
    *    This method will be called once a link
    *  has been selected
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public abstract boolean linkClicked ( String url ) ;



   /**
     *  This method will be called of any status change
     **/
   public abstract void statusChange ( String status, int value, int max ) ;
} /* BrowserListener */
