package com.ibm.nzna.projects.qit.gui ;
/*-----------------------------------------------------------*/
/*   GlassItem                                               */
/*                                                           */
/*   Description:                                            */
/*      Source code for: GlassItem                           */
/*                                                           */
/*                                                           */
/*         @Copyright  1997 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import com.ibm.nzna.shared.gui.* ;
/**
 * This container item will appear to be made of glass.  
 *
 *
 * @version 1.0, 7/23/1998 
 * @author  David Lentz
 */

/*-----------------------------------------------------------*/
/*                                                           */
/*   GlassItem                                               */
/*                                                           */
/*-----------------------------------------------------------*/
public class GlassItem extends Object implements java.io.Serializable, MultiListRow {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Vars                                                    */
   /*                                                           */
   /*-----------------------------------------------------------*/
   public  String  descript          = null ;
   private int     id                = 0 ;
   private boolean honorColor        = false ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This creates a blank GlassItem
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public GlassItem () {
   }


   /*-----------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This will create the Glass Item with the
    *  specified description and id
    *  
    *
    *  @param id The Id of this item
    *  @param descript The description that should show
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public GlassItem ( int id, String descript ) {
      this.id       = id ;
      this.descript = descript ;
   }

   public GlassItem ( int id, boolean honorColor, String descript ) {
      this.id = id ;
      this.descript = descript ;
      this.honorColor = honorColor ;
   }

   /*-----------------------------------------------------------*/
   /* toString
    */
   /**
    *    This method simply returns the description
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String toString () {
      return( descript ) ;
   }




   /*-----------------------------------------------------------*/
   /* getDisplayDescript
    */
   /**
    *    This method will return our description as 
    *  a character array
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public char[] getDisplayDescript ( int column ) {
      if ( column == 0 )
         return( descript.toCharArray() ) ;
      return( new String ( "" ).toCharArray() );
   }


   public Object getColumnData ( int column ) {
      return( descript ) ;
   }

   /*-----------------------------------------------------------*/
   /* paintImage
    */
   /**
    *    This method will paint our image
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   //public boolean paintImage ( ContainerWin containerWin, int requestType, int column , Graphics g, Rectangle drawingRect, Rectangle clipRect, float frame) {
   //   boolean bHandled = false ;
   //   switch ( requestType ) {
   //      case (PAINT_DESCRIPT | PAINT_IMAGE) :
   //         break ;

   //      case PAINT_DESCRIPT:
   //         if ( honorColor )
   //            g.setColor ( SystemData.getNavColor() ) ;
   //         break ;

   //      case PAINT_IMAGE:
   //         break ;

   //      case PAINT_SELECTION:
   //         break ;

   //      case PAINT_DESELECTION:        
   //         break ;

   //      case PAINT_MOUSE_EXIT:
   //         break ;
   //      case PAINT_MOUSE_ENTER:
   //         break ;
   //      case PAINT_ANIMATE_IDLE:
   //         break ;
   //      case PAINT_MOUSEDOWN:
   //         break ;
   //      case PAINT_MOUSEUP:
   //         break ;
   //      case PAINT_CURSOR :
   //         //bHandled = !( containerWin.getSelectionImage() == null ) ;
   //         break ;
   //   }
   //   return(bHandled) ;
   //}


   public int columnCount() {
      return( 2 ) ;
   }

   public int getId () {
      return( id ) ;
   }

   public void setDescript ( String descript ) {
      this.descript = descript ;
   }

   public void setId ( int id ) {
      this.id = id ;
   }


} /* GlassItem */
