package com.ibm.nzna.projects.qit.gui ;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.awt.peer.*;
import sun.awt.*;
import java.util.*;
import com.ibm.nzna.shared.util.* ;
import java.io.* ;
import com.ibm.nzna.projects.qit.app.* ;
import nothome.mswindows.* ;

public class IEBrowser extends JComponent implements IEEventListener, Browser {

   private int nextFileNum=1  ;
   private Vector browserListeners = new Vector ( 1 ) ;
   private IECanvas ieCanvas = null ;
   private int max = 0 ;
   private int value = 0 ;
   private String status = null ;

   public IEBrowser () {
      ieCanvas = new IECanvas() ;
      ieCanvas.addIEEventListener ( this ) ;
      setLayout ( new BorderLayout() ) ;
      add ( ieCanvas ) ;

   }
   public void reload() {
      ieCanvas.rld();
   }

   // Callback notifiers
   public void onStatusTextChange(final String status) {
      this.status = status ;
      fireStatusEvent() ;
   }

   public void onTitleChange(final String status) {
      System.out.println ( "onTitleChange:"+status ) ;
   }

   public void onDocumentComplete(final String status) {
      System.out.println ( "onDocumentComplete(a). Status:"+status ) ;
      max=0;
      value=0;
      this.status=null ;
      fireStatusEvent() ;
   }

   public void onBeforeNavigate2(final String url) {
      firePageStarted ( url ) ;
      System.out.println ( "onBeforeNavigate2. URL:"+url ) ;

   }

   public void onNavigateComplete2(final String status) {
      firePageStopped () ;
      this.status = status ;
      fireStatusEvent() ;
   }

   public void onDownloadComplete() {
      status=null ;
      max=0;
      value=0;
      fireStatusEvent() ;
   }


   public void onProgressChange(final int progress, final int max) {
      System.out.println ( "ProgressChange. Progress:"+progress+" max:"+max ) ;
      value=progress ;
      this.max=max ;
      fireStatusEvent() ;
   }

   public void onCommandStateChange(final int command, final boolean enabled) {
   }

   public void onQuit() {
   }

   /**
    *	@returns true if the default IE context menu is to be displayed, false
    *  if we provide our own.
    */
   public boolean showContextMenu(int x, int y) {
      return true; // Use IE's context menu.
   }

   public boolean canGoBack () {
      return( false ) ;
   }

   public boolean canGoForward () {
      return( false ) ;
   }

   public void forward () {
      ieCanvas.goForward() ;
   }

   public void back () {
      ieCanvas.goBackward() ;
   }

   public String getSource() {
      return( "" ) ;
   }


   public void loadURL ( String url ) {
      ieCanvas.setURL ( url ) ;
   }

   public void setPageContent ( String content ) {
      try {
         String filename = PropertySystem.getString ( PropertySystem.PROPERTY_TEMP_DIR )+
                           File.separator+
                           (nextFileNum++)+"_"+System.currentTimeMillis()+"_temp.html" ;

         FileUtil.saveFile ( filename, content ) ;
         loadURL ( filename ) ;

      } catch ( Exception e ) {
         LogSystem.log ( 1, e, false ) ;
      }
   }

   public void stop () {
   }


   public void addBrowserListener ( BrowserListener listener ) {
      browserListeners.addElement ( listener ) ;
   }

   public void removeBrowserListener ( BrowserListener listener ) {
      browserListeners.removeElement ( listener ) ;
   }

   public Component getComponent () {
      return( this ) ;
   }

   public boolean showContextMenu ( ) {
      return( false ) ;
   }


   /**
     *  this method will fire a status event out
     **/
   private void fireStatusEvent () {
      if ( browserListeners != null ) {
         int i    = 0 ;
         int size = browserListeners.size() ;

         while ( i < size ) {
            ((BrowserListener)browserListeners.elementAt(i)).statusChange ( status, value, max ) ;
            i++ ;
         }
      }
   }

   /**
     *  this method will fire a page started event
     **/
   private void firePageStarted ( String url ) {
      if ( browserListeners != null ) {
         int i    = 0 ;
         int size = browserListeners.size() ;

         while ( i < size ) {
            ((BrowserListener)browserListeners.elementAt(i)).pageStarted ( url ) ;
            i++ ;
         }
      }
   }

   /**
     *  this method will fire a page stopped
     **/
   private void firePageStopped () {
      if ( browserListeners != null ) {
         int i    = 0 ;
         int size = browserListeners.size() ;

         while ( i < size ) {
            ((BrowserListener)browserListeners.elementAt(i)).pageStopped ( ) ;
            i++ ;
         }
      }
   }
}
