package com.ibm.nzna.projects.qit.gui ;
/*-----------------------------------------------------------*/
/*   JTitle                                                  */
/*                                                           */
/*   Description:                                            */
/*      Source code for: JTitle                              */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This class is a subclass of JPanel which simply holds
 * a JLabel and draws the nice blue background underneath it
 *
 *
 * @version 1.0, 8/25/1999 
 * @author  David Lentz
 */
import java.awt.* ;
import javax.swing.* ;
import com.ibm.nzna.projects.qit.app.* ;


/*-----------------------------------------------------------*/
/*                                                           */
/*   JTitle                                                  */
/*                                                           */
/*-----------------------------------------------------------*/
public class JTitle extends JPanel implements AppConst {

    /*-----------------------------------------------------------*/
    /*                                                           */
    /*   Vars                                                    */
    /*                                                           */
    /*-----------------------------------------------------------*/
    private JLabel  st_LABEL  = null ;
    //private JLabel  st_LABEL2 = null ;
    private boolean showSkin  = false ;





    /*------------------------------------------------------------*/
    /* Constructor
     */
    /**
     *    This creates an empty title
     *  
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public JTitle () {
        init("") ;
    }






    /*------------------------------------------------------------*/
    /* Constructor
     */
    /**
     *    This constructor creates a JTitle
     *  initialized to the String index passed in
     *  
     *
     *  @param strIndex The String Index to use
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public JTitle ( int strIndex ) {
        init ( Str.getStr ( strIndex ) ) ;
    }

    /*------------------------------------------------------------*/
    /* Constructor
     */
    /**
     *    This will create a title initialized to the text
     *  passed in
     *  
     *
     *  @param text The text to set
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public JTitle ( String text ) {
        init ( text ) ;
    }





    /*------------------------------------------------------------*/
    /* init
     */
    /**
     *    This method will initialize our control
     *  
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    private void init ( String text ) {
        try {
            st_LABEL  = new JLabel ( text ) ;
            //st_LABEL2 = new JLabel ( text ) ;
            setLayout ( null ) ;
            //add ( st_LABEL2 ) ;
            add ( st_LABEL ) ;
            st_LABEL.setOpaque ( false ) ;
            //st_LABEL2.setOpaque ( false ) ;
            showSkin = PropertySystem.getBool ( PropertySystem.PROPERTY_SHOWSKIN ) ;
            st_LABEL.setFont ( FontSystem.largeTitleFont ) ;
            //st_LABEL2.setFont ( FontSystem.largeTitleFont ) ;
            //st_LABEL2.setForeground ( new Color ( 230, 230, 230 ) ) ;
            setOpaque ( !showSkin ) ;
        } catch ( Exception e ) {
        }
    }






    /*------------------------------------------------------------*/
    /* setFont
     */
    /**
     *    This method will set the font we display
     *  characters in
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void setFont ( Font font ) {
        if ( st_LABEL != null ) {
            st_LABEL.setFont ( font ) ;
            //st_LABEL2.setFont ( font ) ;
        }
        revalidate() ;
    }



    public void doLayout () {
       Dimension size = getSize() ;

       super.doLayout () ;
       //st_LABEL2.setBounds ( 2, 2, size.width-3, size.height-3 ) ;
       st_LABEL.setBounds ( 0, 0, size.width-1, size.height-1 ) ;
    }

    public Dimension getPreferredSize() {
       return ( st_LABEL.getPreferredSize() ) ;
    }
    public Dimension getMinimumSize() {
       return ( st_LABEL.getPreferredSize() ) ;
    }

    /*------------------------------------------------------------*/
    /* setText
     */
    /**
     *    This method will set the text that we display
     *  
     *  
     *
     *  @param text The new Text
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void setText ( String text ) {
        if ( st_LABEL != null )
            st_LABEL.setText ( text ) ;
        revalidate() ;

        try {
            showSkin = PropertySystem.getBool ( PropertySystem.PROPERTY_SHOWSKIN ) ;
            setOpaque ( !showSkin ) ;
        } catch ( Exception e ) {
        }
    }




    /*------------------------------------------------------------*/
    /* setForeground
     */
    /**
     *    This method will set our foreground color
     *  
     *  
     *
     *  @param color The new foreground
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void setForeground ( Color color ) {
        if ( st_LABEL != null )
            st_LABEL.setForeground ( color ) ;
        revalidate() ;
    }






    /*------------------------------------------------------------*/
    /* paintComponent
     */
    /**
     *    This method will paint our component
     *  
     *  
     *
     *  @param g The graphics context
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void paintComponent ( Graphics g ) {                                
       Graphics2D g2   = (Graphics2D) g ;

       /* Anti Alias  */
       g2.setRenderingHint ( RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON ) ;

        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   Only paint ourselves if we are not textured             */
        /*                                                           */
        /*-----------------------------------------------------------*/
        if ( !showSkin ) {
            Rectangle rect = (Rectangle) g.getClip() ;             

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Fill the clip with white                                */
            /*                                                           */
            /*-----------------------------------------------------------*/
            g.setColor ( Color.white ) ;
            g.fillRect ( rect.x, rect.y, rect.width, rect.height ) ;  

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Draw the fade                                           */
            /*                                                           */
            /*-----------------------------------------------------------*/
            //g.drawImage ( ImageSystem.getImage ( this, ImageSystem.TITLE_BACKGROUND ), 0, 0, this ) ;
        }

        paintChildren ( g ) ;
    }





} /* JTitle */
