package com.ibm.nzna.projects.qit.gui ;         
/*-----------------------------------------------------------*/
/*   ListActionPanel                                         */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ListActionPanel                     */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.projects.qit.app.* ;
/**
 * This panel subclasses the button panel and can be used to provide
 * quick actions to items in any type of list. The panel should be positioned
 * directly underneath a list and should be as wide as the list.
 *
 *
 * @version 1.0, 11/11/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ListActionPanel                                         */
/*                                                           */
/*-----------------------------------------------------------*/
public class ListActionPanel extends ButtonPanel implements AppConst {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Static Members                                          */     
   /*                                                           */
   /*-----------------------------------------------------------*/
   private static final Dimension minSize = new Dimension ( 100, 18 ) ;
   


   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    Creates the panel
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public ListActionPanel () {
      super() ;
      setBorder     ( GUISystem.grayBorder ) ;
      setBackground ( new Color ( 230, 230, 230 ) ) ;
      setArrowImage ( ImageSystem.getImageIcon ( this, ImageSystem.BUTTONPANEL_LEFT ),
                      ImageSystem.getImageIcon ( this, ImageSystem.BUTTONPANEL_RIGHT ) ) ;             
   }




   /*------------------------------------------------------------*/
   /* addSeparator
    */
   /**
    *    This method will add a separator
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void addSeparator () {
      add ( new ToolBarSeparator ( new Dimension ( 1, GUISystem.getRowHeight() ) ) ) ;
   }





   /*------------------------------------------------------------*/
   /* getPreferredSize
    */
   /**
    *    This method will return our preferred ( and Minimum)
    *  size
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public Dimension getPreferredSize () {
      return( getMinimumSize() ) ;
   }




   /*------------------------------------------------------------*/
   /* getMinimumSize
    */
   /**
    *    This method will return our minimum size
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public Dimension getMinimumSize () {
      return( minSize ) ;
   }
} /* ListActionPanel */
