package com.ibm.nzna.projects.qit.gui ;         
/*-----------------------------------------------------------*/
/*   NavPanelWrapper                                         */
/*                                                           */
/*   Description:                                            */
/*      Source code for: NavPanelWrapper                     */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import javax.swing.* ;
/**
 * This is a convience class who just wraps a single JComponent into a NavPanel 
 *
 *
 * @version 1.0, 9/11/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   NavPanelWrapper                                         */
/*                                                           */
/*-----------------------------------------------------------*/
public class NavPanelWrapper extends JPanel implements NavPanel {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private String       title     = null ;
   private JComponent   component = null ;




   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This constructor initializes the panel to the values passed
    *  in
    *  
    *
    *  @param descript The Description of the NavPanel
    *  @param component The JComponent to use as the panel
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public NavPanelWrapper ( String title, JComponent component ) {
      this.component = component ;
      this.title  = title ;
   }




   /*------------------------------------------------------------*/
   /* getTitle
    */
   /**
    *    This method will return the title of this
    *  panel
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getTitle () {
      return( title ) ;
   }




   /*------------------------------------------------------------*/
   /* getJComponent
    */
   /**
    *    THis method will return the component
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public JComponent getJComponent () {
      return( component ) ;
   }





   /*------------------------------------------------------------*/
   /* start
    */
   /**
    *    This method does nothing
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void start () {
   }




   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method simply adds the component to our
    *  panel
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void initialize () {
      setLayout ( new BorderLayout () ) ;
      add ( component, BorderLayout.CENTER ) ;
   }





   /*------------------------------------------------------------*/
   /* stop
    */
   /**
    *    This method just removes all of our components
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void stop () {
      removeAll() ;
   }
} /* NavPanelWrapper */
