package com.ibm.nzna.projects.qit.gui ;
/*-----------------------------------------------------------*/
/*   SelectUserDlg                                           */
/*                                                           */
/*   Description:                                            */
/*      Source code for: SelectUserDlg                       */
/*                                                           */
/*                                                           */
/*         @Copyright  1997 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * Allows the user to select a user to be added to a Group 
 *
 *
 * @version 1.0, 7/1/1998 
 * @author  David Lentz
 */
import java.awt.* ;
import java.util.Vector ;
import javax.swing.* ;
import javax.swing.border.TitledBorder ;
import java.awt.event.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.shared.gui.* ;



/*-----------------------------------------------------------*/
/*                                                           */
/*   SelectUserDlg                                           */
/*                                                           */
/*-----------------------------------------------------------*/
public class SelectUserDlg extends JDialog implements ActionListener, AppConst {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Controls                                                */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private JLabel       st_DESCRIPT      = new JLabel    ( Str.getStr ( STR_PLEASE_SELECT_A_USER ) ) ;
   private MultiList    userList         = new MultiList ( GUISystem.getFontUtil() ) ;
   private JPanel       pnl_USERLIST     = new JPanel    ( ) ;
   private JTitle       st_TITLE         = new JTitle    ( Str.getStr ( STR_USERS ) ) ;
   private DButton      pb_SELECT        = new DButton   ( Str.getStr ( STR_SELECT ) ) ;
   private DButton      pb_CANCEL        = new DButton   ( Str.getStr ( STR_CANCEL ) ) ;
   private DButton      pb_SEARCH        = new DButton   ( Str.getStr ( STR_SEARCH ) ) ;
   private JPanel       brd_SEARCH       = new JPanel    ( ) ;
   private JPanel       brd_USERS        = new JPanel    ( ) ;
   private JTextField   ef_SEARCH        = new JTextField ( new MaskDocument ( MaskDocument.MASKTYPE_UNKNOWN, 80 ), "", 0 ) ;

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Vars                                                    */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private UserRec userRec          = null;
   private Vector  retVec           = null ;
   private Vector  userVec          = null ;
   private boolean multiple         = false ;
   private boolean showManagersOnly = false ;
   private int     rowHeight        = 18 ;


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Static                                                  */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private static final String[] userTitle = { Str.getStr ( STR_USERID ), Str.getStr ( STR_NAME )} ;



   /*-----------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will create our dialog
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public SelectUserDlg ( Frame parent ) {
      super ( parent, Str.getStr ( STR_PLEASE_SELECT_A_USER ), true ) ;

      init ( ) ;
   }

   public SelectUserDlg ( Frame parent, boolean multiple ) {
      super ( parent, Str.getStr ( STR_PLEASE_SELECT_A_USER ), true ) ;

      this.multiple = multiple ;
      init ( ) ;
   }

   public SelectUserDlg ( Frame parent, boolean multiple, boolean showManagersOnly ) {
      super ( parent, Str.getStr ( STR_PLEASE_SELECT_A_USER ), true ) ;

      this.showManagersOnly = showManagersOnly ;
      this.multiple = multiple ;
      init ( ) ;
   }

   public SelectUserDlg ( Frame parent, Vector userVec ) {
      super ( parent, Str.getStr ( STR_PLEASE_SELECT_A_USER ), true ) ;

      this.userVec = userVec ;
      this.multiple = multiple ;
      init (  ) ;
   }

   public SelectUserDlg ( Frame parent, Vector userVec, boolean multiple ) {
      super ( parent, Str.getStr ( STR_PLEASE_SELECT_A_USER ), true ) ;

      this.userVec = userVec ;
      this.multiple = multiple ;
      init ( ) ;
   }

   public SelectUserDlg ( Frame parent, Vector userVec, boolean multiple, boolean showManagersOnly ) {
      super ( parent, Str.getStr ( STR_PLEASE_SELECT_A_USER ), true ) ;

      this.showManagersOnly = showManagersOnly ;
      this.userVec          = userVec ;
      this.multiple         = multiple ;
      init ( ) ;
   }


   public SelectUserDlg ( Frame parent, UserRec userRec ) {
      super ( parent, Str.getStr ( STR_PLEASE_SELECT_A_USER ), true ) ;

      this.userRec = userRec ;
      init (  ) ;
   }




   public SelectUserDlg ( JDialog parent ) {
      super ( parent, Str.getStr ( STR_PLEASE_SELECT_A_USER ), true ) ;

      init ( ) ;
   }

   public SelectUserDlg ( JDialog parent, boolean multiple ) {
      super ( parent, Str.getStr ( STR_PLEASE_SELECT_A_USER ), true ) ;

      this.multiple = multiple ;
      init ( ) ;
   }

   public SelectUserDlg ( JDialog parent, boolean multiple, boolean showManagersOnly ) {
      super ( parent, Str.getStr ( STR_PLEASE_SELECT_A_USER ), true ) ;

      this.showManagersOnly = showManagersOnly ;
      this.multiple = multiple ;
      init ( ) ;
   }

   public SelectUserDlg ( JDialog parent, Vector userVec ) {
      super ( parent, Str.getStr ( STR_PLEASE_SELECT_A_USER ), true ) ;

      this.userVec = userVec ;
      this.multiple = multiple ;
      init (  ) ;
   }

   public SelectUserDlg ( JDialog parent, Vector userVec, boolean multiple ) {
      super ( parent, Str.getStr ( STR_PLEASE_SELECT_A_USER ), true ) ;

      this.userVec = userVec ;
      this.multiple = multiple ;
      init ( ) ;
   }

   public SelectUserDlg ( JDialog parent, Vector userVec, boolean multiple, boolean showManagersOnly ) {
      super ( parent, Str.getStr ( STR_PLEASE_SELECT_A_USER ), true ) ;

      this.showManagersOnly = showManagersOnly ;
      this.userVec          = userVec ;
      this.multiple         = multiple ;
      init ( ) ;
   }


   public SelectUserDlg ( JDialog parent, UserRec userRec ) {
      super ( parent, Str.getStr ( STR_PLEASE_SELECT_A_USER ), true ) ;

      this.userRec = userRec ;
      init (  ) ;
   }




   /*------------------------------------------------------------*/
   /* init
    */
   /**
    *    This method will initialize our window
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void init () {
      setResizable ( false ) ;
      createControls() ;
      refreshList() ;
      setSize ( 340, 300 ) ;
      WinUtil.centerWindow ( this ) ;
      addWindowListener ( new ComponentPopFocus ( ef_SEARCH ) ) ;
   }




   /*------------------------------------------------------------*/
   /* getResult
    */
   /**
    *    This method will show the window, waits for
    *  the user to select a user, and then will
    *  return a vector of what was selected.
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return NULL if the user canceled
    *//*---------------------------------------------------------*/
   public Vector getResult() {
      setVisible ( true ) ;
      return( retVec ) ;
   }



   /*-----------------------------------------------------------*/
   /* createControls
    */
   /**
    *    This method will create and attach all of our
    *  controls
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void createControls () {


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Set properties                                          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      userList.setColumnHeadings ( userTitle ) ;
      userList.setColumnWidth ( 1, 250 ) ;
      userList.setForeground ( Color.black ) ;
      userList.setRowHeight(18) ;
      brd_SEARCH.setBorder ( new TitledBorder ( Str.getStr ( STR_SEARCH ) ) ) ;
      brd_USERS.setBorder ( new TitledBorder ( "" ) ) ;
      brd_SEARCH.setLayout ( null ) ;
      brd_USERS.setLayout ( null ) ;
      userList.setBorder ( null ) ;
      userList.showColumnHeadings ( false ) ;
      pnl_USERLIST.setBackground ( Color.white ) ;
      pnl_USERLIST.setBorder ( GUISystem.loweredBorder ) ;
      st_TITLE.setFont ( FontSystem.defaultFont ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add controls to the bordered panels                     */
      /*                                                           */
      /*-----------------------------------------------------------*/
      pnl_USERLIST.setLayout ( new BorderLayout() ) ;
      pnl_USERLIST.add ( st_TITLE, BorderLayout.NORTH ) ;
      pnl_USERLIST.add ( userList ) ;
      brd_SEARCH.add ( ef_SEARCH ) ;
      brd_SEARCH.add ( pb_SEARCH ) ;
      brd_USERS.add ( pnl_USERLIST ) ;                   

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Set initial size of components                          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      ef_SEARCH.setBounds ( 10, 15, 200, rowHeight ) ;
      pb_SEARCH.setBounds ( 210, 15, 90, rowHeight ) ;
      pnl_USERLIST.setBounds ( 10, 15, 300, 150 ) ;  

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add Listeners                                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      ef_SEARCH.addActionListener ( this ) ;
      pb_SEARCH.addActionListener ( this ) ;
      userList.addActionListener ( this ) ;
      pb_CANCEL.addActionListener ( this ) ;
      pb_SELECT.addActionListener ( this ) ;      

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add our controls                                        */
      /*                                                           */
      /*-----------------------------------------------------------*/
      getContentPane().setLayout ( null ) ;
      getContentPane().add ( brd_SEARCH ) ;
      getContentPane().add ( brd_USERS ) ;
      getContentPane().add ( pb_SELECT ) ;
      getContentPane().add ( pb_CANCEL ) ;
   }




   /*-----------------------------------------------------------*/
   /* refreshList
    */
   /**
    *    This method is called after window initialization.
    *  We will use this time to populate our ContainerWin
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void refreshList () {

      if ( userVec == null ) {
         Vector vector     = null ;

         if ( showManagersOnly )
            vector = UserSystem.getManagerList() ;
         else
            vector = UserSystem.getAllUserVec() ;

         new com.ibm.nzna.shared.sort.QuickSort ( vector ) ;
         if ( vector != null )
            userList.add ( vector ) ;
      }

      else
         userList.add ( userVec ) ;

      if ( userRec != null )
         userList.setSelectedItem ( userRec, true ) ;

      ef_SEARCH.requestFocus() ;
      userList.paintAll(userList.getGraphics() ) ;
   }




   /*-----------------------------------------------------------*/
   /* layoutControls
    */
   /**
    *    This method will lay out all of our controls
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      int       x         = 10 ;
      int       y         = 10 ;
      Dimension size      = getSize() ;

      super.doLayout() ;
      size.height-=30 ;

      brd_SEARCH.setBounds ( x, y, size.width-(x*2), (rowHeight*2)+5 ) ;
      y+=(rowHeight*2)+5 ;

      brd_USERS.setBounds ( x, y, size.width-(x*2), size.height-50-y ) ;

      pb_SELECT.setBounds ( x, size.height-40, 70, 25 ) ;
      pb_CANCEL.setBounds ( x+75, size.height-40, 90, 25 ) ;
   } /* layoutControls */



   /*-----------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method responds to actions being fired
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {

      if ( e.getSource() == ef_SEARCH )
         search() ;
      else if ( e.getSource() instanceof DButton ) {
         DButton button = (DButton) e.getSource() ;

         if ( pb_CANCEL == button ) {
            retVec = null ;
            dispose() ;
         }

         else if ( pb_SEARCH == button )
            search() ;

         else if ( pb_SELECT == button ) {
            if ( saveData () )
               dispose() ;
         }
      } else if ( e.getSource() == userList ) {
         if ( saveData() )
            dispose() ;
      }
   }




   /*-----------------------------------------------------------*/
   /* saveData
    */
   /**
    *    This method will save all of the selections and
    *  return
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return TRUE = Data was saved Ok, FALSE - No data was saved
    *//*---------------------------------------------------------*/
   public boolean saveData () {
      boolean rc     = false ;
      retVec = userList.getSelection() ;

      if ( retVec == null )
         GUISystem.printBox ( Str.getStr ( STR_ERROR ), Str.getStr ( STR_MUST_SELECT_ITEM ) ) ;
      else
         rc = true ;

      return( rc ) ;
   }


   /*------------------------------------------------------------*/
   /* search
    */
   /**
    *    This method will search through the
    *  current list and try to find an item matching
    *  the description in the find field.
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void search () {
      String            searchStr  = ef_SEARCH.getText() ;

      if ( ( searchStr != null ) && ( searchStr.length() > 0 ) ) {
         Vector userVec = UserSystem.getAllUserVec() ;
         int i = 0 ;

         /* Uppercase the search str */
         searchStr = searchStr.toUpperCase() ;

         if ( userVec != null ) {
            int          length  = 0 ;
            boolean      found   = false ;
            UserRec      userRec = null ;

            length = userVec.size() ;

            while ( ( !found ) && ( i < length ) ) {
               userRec = (UserRec) userVec.elementAt(i) ;
               if ( ( userRec != null ) &&
                    ( userRec.getUserId().toUpperCase().indexOf ( searchStr ) != -1 ) ||
                    ( userRec.getName().toUpperCase().indexOf ( searchStr ) != -1 ) )
                  found = true ;
               i++ ;
            }

            if ( found )
               userList.setSelectedItem ( userRec, true ) ;
         }
      }

   } /* find */

} /* SelectUserDlg */ 
