package com.ibm.nzna.projects.qit.gui ;
/*-----------------------------------------------------------*/
/*   TexturePanel                                            */
/*                                                           */
/*   Description:                                            */
/*      Source code for: TexturePanel                        */
/*                                                           */
/*                                                           */
/*         @Copyright  1998 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * A simple panel that draws the default texture 
 *
 *
 * @version 1.0, 7/12/1999 
 * @author  David Lentz
 */
import java.awt.* ;
import javax.swing.* ;

/*-----------------------------------------------------------*/
/*                                                           */
/*   TexturePanel                                            */
/*                                                           */
/*-----------------------------------------------------------*/
public class TexturePanel extends JPanel  {
   private int        imageHeight    = 0 ;
   private int        logoWidth      = 0 ;
   private int        logoHeight     = 0 ;
   private boolean    paintLogo      = false ;
   private Image      logoImage      = null ;
   private boolean    paint          = true ;
   private Image      textureImage   = null ;


   /*------------------------------------------------------------*/
   /* TexturePanel
    */
   /**
    *    This will create our panel
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public TexturePanel () {
   }

   public TexturePanel ( Image textureImage ) {
      logoImage = null ;
      this.textureImage = textureImage ;
   }

   /*------------------------------------------------------------*/
   /* paintComponent
    */
   /**
    *    This method will repaint our component
    *  with our texture
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void paintComponent ( Graphics g ) {
      Dimension size  = getSize() ;

      //VOYtry {
      //VOY   if ( paint ) {
      //VOY      if ( ( SystemData.textureBack() ) ) {
      //VOY         int       tiley = 0 ;

      //VOY         //if ( imageHeight == 0 )
      //VOY         //   imageHeight = SystemData.getImage(ImageSystem.IMAGEBACK1).getHeight(SystemData.getMainWin()) ;

      //VOY         //while ( tiley < size.height ) {
      //VOY         //   g.drawImage ( SystemData.getImage ( ImageSystem.IMAGEBACK1 ), 0, tiley, this ) ;
      //VOY         //   tiley+=imageHeight ;
      //VOY         //}

      //VOY         EGraphics.wallPaper ( 0, 0, size.width, size.height, this, g, textureImage ) ;
      //VOY         g.setColor ( Color.black ) ;
      //VOY         g.drawLine ( 0, 0, size.width, 0 ) ;
      //VOY         paintChildren ( g ) ;
      //VOY      } else
      //VOY         super.paintComponent ( g ) ;

      //VOY      if ( paintLogo )
      //VOY         paintLogo ( g, size ) ;
      //VOY   } else
      //VOY      super.paintComponent ( g ) ;

      //VOY} catch ( Exception e ) {
      //VOY}
   }




   /*------------------------------------------------------------*/
   /* setPaintLogo
    */
   /**
    *    This method will set the 'Paint Logo'
    *  property. If TRUE, the Quest logo will
    *  be painted in the center of this panel
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setPaintLogo ( boolean paintLogo ) {
      this.paintLogo = paintLogo ;
   }





   /*------------------------------------------------------------*/
   /* paintLogo
    */
   /**
    *    This method will paint the quest logo
    *  centered on the window
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void paintLogo ( Graphics g, Dimension size ) {
      if ( logoImage != null )
         g.drawImage ( logoImage, ((size.width/2)-(logoWidth/2)), ((size.height/2)-(logoHeight/2)), this ) ;
   }




   /*------------------------------------------------------------*/
   /* setPaint
    */
   /**
    *    This method will either turn painting on or
    *  off. 
    *  
    *
    *  @param paint FALSE = do not paint, TRUE = paint
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setPaint ( boolean paint ) {
      this.paint = paint ;
   }

   public void moveOff () {
      Graphics g = getGraphics() ;

      for ( int i = 0; i < 200; i++ ) {
      }
   }

} /* TexturePanel */
