package com.ibm.nzna.projects.qit.gui ;      
/*-----------------------------------------------------------*/
/*   UserStatPanel                                           */
/*                                                           */
/*   Description:                                            */
/*      Source code for: UserStatPanel                       */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import com.ibm.nzna.projects.qit.gui.* ; 
import com.ibm.nzna.projects.qit.app.* ; 
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.common.quest.* ;
/**
 * This is the search panel that will show in the navigational
 * area of the search window. This panel will actually just send
 * a message to the content panel to initiate a search.
 *
 *
 * @version 1.0, 1/13/100 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   UserStatPanel                                           */
/*                                                           */
/*-----------------------------------------------------------*/
public class UserStatPanel extends JPanel implements ActionListener, AppConst, NavPanel, UserStatListener, PropertyListener {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Vars                                            */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private AnalogClock  clock                  = null ;
   private JLabel       st_TITLE               = new JLabel ( Str.getStr ( STR_STATS_AS_OF ) ) ;
   private JLabel       st_DOCUMENTS_PUBLISHED = new JLabel ( Str.getStr ( STR_DOCUMENTS_PUBLISHED ) ) ;
   private JLabel       st_PRODUCTS_PUBLISHED  = new JLabel ( Str.getStr ( STR_PRODUCTS_PUBLISHED ) ) ;
   private JLabel       st_DOC_THIS_YEAR       = new JLabel ( Str.getStr ( STR_THIS_YEAR ) ) ;
   private JLabel       st_DOC_THIS_MONTH      = new JLabel ( Str.getStr ( STR_THIS_MONTH ) ) ;
   private JLabel       st_DOC_TODAY           = new JLabel ( Str.getStr ( STR_TODAY ) ) ;
   private JLabel       st_PRODUCT_THIS_YEAR   = new JLabel ( Str.getStr ( STR_THIS_YEAR ) ) ;
   private JLabel       st_PRODUCT_THIS_MONTH  = new JLabel ( Str.getStr ( STR_THIS_MONTH ) ) ;
   private JLabel       st_PRODUCT_TODAY       = new JLabel ( Str.getStr ( STR_TODAY ) ) ;
   private JLabel       st_PRODUCT_THIS_WEEK   = new JLabel ( Str.getStr ( STR_THIS_WEEK ) ) ;
   private JLabel       st_DOC_THIS_WEEK       = new JLabel ( Str.getStr ( STR_THIS_WEEK ) ) ;

   private JLabel       stt_DOC_THIS_YEAR       = new JLabel ( "0" ) ;
   private JLabel       stt_DOC_THIS_MONTH      = new JLabel ( "0" ) ;
   private JLabel       stt_DOC_TODAY           = new JLabel ( "0" ) ;
   private JLabel       stt_DOC_THIS_WEEK       = new JLabel ( "0" ) ;
   private JLabel       stt_PRODUCT_THIS_WEEK   = new JLabel ( "0" ) ;
   private JLabel       stt_PRODUCT_THIS_YEAR   = new JLabel ( "0" ) ;
   private JLabel       stt_PRODUCT_THIS_MONTH  = new JLabel ( "0" ) ;
   private JLabel       stt_PRODUCT_TODAY       = new JLabel ( "0" ) ;

   private JLabel       st_TOTAL_DOCS           = new JLabel ( Str.getStr ( STR_TOTAL_NUMBER_OF_DOCUMENTS ) ) ;
   private JLabel       st_TOTAL_PRODUCTS       = new JLabel ( Str.getStr ( STR_TOTAL_NUMBER_OF_PRODUCTS ) ) ;
   private JLabel       st_TOTAL_FAMILIES       = new JLabel ( Str.getStr ( STR_TOTAL_NUMBER_OF_FAMILIES ) ) ;
   private JLabel       st_TOTAL_FILE_ATTACH    = new JLabel ( Str.getStr ( STR_TOTAL_NUMBER_OF_FILE_ATTACHMENTS ) ) ;

   private JLabel       stt_TOTAL_DOCS           = new JLabel ( "0" ) ;
   private JLabel       stt_TOTAL_PRODUCTS       = new JLabel ( "0" ) ;
   private JLabel       stt_TOTAL_FAMILIES       = new JLabel ( "0" ) ;
   private JLabel       stt_TOTAL_FILE_ATTACH    = new JLabel ( "0" ) ;

   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will construct our nav panel
    *  
    *  
    *
    *  @param helpPage The Help Page to use
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public UserStatPanel ( ) {
   }


   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will be called before the
    *  nav panel is shown. We will initialize GUI,
    *  and other vars here
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void initialize () {

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create our controls                                     */
      /*                                                           */
      /*-----------------------------------------------------------*/
      clock        = new AnalogClock() ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust Properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      clock.showDate ( true ) ;
      clock.setOpaque ( false ) ;
      clock.setClockFaceImage ( ImageSystem.getImageIcon ( this, ImageSystem.CLOCK_FACE ).getImage() ) ;
      clock.setClockFaceImageOffset (10, 7 ) ;
      st_TITLE.setOpaque ( false ) ;
      st_TITLE.setFont ( new Font ( "SansSerif", Font.BOLD, 12 ) ) ; 
      //st_TITLE.setBackground ( (Color)javax.swing.UIManager.getDefaults().get ( "List.selectionBackground" ) ) ;
      //st_TITLE.setForeground ( (Color)javax.swing.UIManager.getDefaults().get ( "List.selectionForeground" ) ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add Listeners                                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      UserStatSystem.addUserStatListener ( this ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add our controls                                        */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( null ) ;
      add ( clock ) ;
      add ( st_TITLE ) ;
      add ( st_DOCUMENTS_PUBLISHED ) ;
      add ( st_PRODUCTS_PUBLISHED ) ;
      add ( st_DOC_THIS_YEAR ) ;
      add ( st_DOC_THIS_MONTH ) ;
      add ( st_DOC_TODAY ) ;
      add ( st_PRODUCT_THIS_YEAR ) ;
      add ( st_PRODUCT_THIS_MONTH ) ;
      add ( st_PRODUCT_TODAY ) ;
      add ( stt_DOC_THIS_YEAR ) ;
      add ( stt_DOC_THIS_MONTH ) ;
      add ( stt_DOC_TODAY ) ;
      add ( stt_PRODUCT_THIS_YEAR ) ;
      add ( stt_PRODUCT_THIS_MONTH ) ;
      add ( stt_PRODUCT_TODAY ) ;
      add ( st_TOTAL_DOCS ) ;
      add ( st_TOTAL_PRODUCTS ) ;
      add ( st_TOTAL_FAMILIES ) ;
      add ( st_TOTAL_FILE_ATTACH ) ;
      add ( st_DOC_THIS_WEEK ) ;
      add ( st_PRODUCT_THIS_WEEK ) ;
      add ( stt_DOC_THIS_WEEK ) ;
      add ( stt_PRODUCT_THIS_WEEK ) ;
      add ( stt_TOTAL_DOCS ) ;
      add ( stt_TOTAL_PRODUCTS ) ;
      add ( stt_TOTAL_FAMILIES ) ;
      add ( stt_TOTAL_FILE_ATTACH ) ;
   }






   /*------------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will lay out and position
    *  all of our components
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size        = getSize() ;
      int       rowHeight   = GUISystem.getRowHeight() ;
      int       y           = 0 ;
      int       clockHeight = 45 ;
      int       x           = 5 ;

      super.doLayout() ;

      clock.setBounds ( 0, 0, size.width, clockHeight ) ;
      y+=clockHeight ;

      y=80 ;
      st_TITLE.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight+8 ;

      st_DOCUMENTS_PUBLISHED.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight ;

      st_DOC_THIS_YEAR.setBounds ( x+20, y, 100, rowHeight ) ;
      stt_DOC_THIS_YEAR.setBounds ( x+120, y, 100, rowHeight ) ;
      y+=rowHeight ;

      st_DOC_THIS_MONTH.setBounds ( x+20, y, 100, rowHeight ) ;
      stt_DOC_THIS_MONTH.setBounds ( x+120, y, 100, rowHeight ) ;
      y+=rowHeight ;

      st_DOC_THIS_WEEK.setBounds ( x+20, y, 100, rowHeight ) ;
      stt_DOC_THIS_WEEK.setBounds ( x+120, y, 100, rowHeight ) ;
      y+=rowHeight ;

      st_DOC_TODAY.setBounds ( x+20, y, 100, rowHeight ) ;
      stt_DOC_TODAY.setBounds ( x+120, y, 100, rowHeight ) ;
      y+=rowHeight*2 ;

      st_PRODUCTS_PUBLISHED.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight ;

      st_PRODUCT_THIS_YEAR.setBounds ( x+20, y, 100, rowHeight ) ;
      stt_PRODUCT_THIS_YEAR.setBounds ( x+120, y, 100, rowHeight ) ;
      y+=rowHeight ;

      st_PRODUCT_THIS_MONTH.setBounds ( x+20, y, 100, rowHeight ) ;
      stt_PRODUCT_THIS_MONTH.setBounds ( x+120, y, 100, rowHeight ) ;
      y+=rowHeight ;

      st_PRODUCT_THIS_WEEK.setBounds ( x+20, y, 100, rowHeight ) ;
      stt_PRODUCT_THIS_WEEK.setBounds ( x+120, y, 100, rowHeight ) ;
      y+=rowHeight ;

      st_PRODUCT_TODAY.setBounds ( x+20, y, 100, rowHeight ) ;
      stt_PRODUCT_TODAY.setBounds ( x+120, y, 100, rowHeight ) ;
      y+=rowHeight*2 ;

      st_TOTAL_DOCS.setBounds ( x, y, 150, rowHeight ) ;
      stt_TOTAL_DOCS.setBounds ( x+150, y, 150, rowHeight ) ;
      y+=rowHeight ;

      st_TOTAL_PRODUCTS.setBounds ( x, y, 150, rowHeight ) ;
      stt_TOTAL_PRODUCTS.setBounds ( x+150, y, 150, rowHeight ) ;
      y+=rowHeight ;

      st_TOTAL_FAMILIES.setBounds ( x, y, 150, rowHeight ) ;
      stt_TOTAL_FAMILIES.setBounds ( x+150, y, 150, rowHeight ) ;
      y+=rowHeight ;

      st_TOTAL_FILE_ATTACH.setBounds ( x, y, 150, rowHeight ) ;
      stt_TOTAL_FILE_ATTACH.setBounds ( x+150, y, 150, rowHeight ) ;
      y+=rowHeight ;

   }

   /*------------------------------------------------------------*/
   /* start
    */
   /**
    *    This method will be called once the
    *  panel is shown.
    *
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void start () {
      setText() ;
   }





   /*------------------------------------------------------------*/
   /* stop
    */
   /**
    *    Doing cleanup
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void stop () {
      UserStatSystem.removeUserStatListener ( this ) ;
   }





   /*------------------------------------------------------------*/
   /* getTitle
    */
   /**
    *    This method will return the title of the
    *  nav panel
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public String getTitle () {
      return( "" ) ; //Str.getStr ( STR_USERSTATS ) ) ;
   }



   /*------------------------------------------------------------*/
   /* getJComponent
    */
   /**
    *    This method will return an instance
    *  of this panel
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return JComponent
    *//*---------------------------------------------------------*/
   public JComponent getJComponent () {
      return( this ) ;
   }



   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will be called once an
    *  action event is fired
    *  
    *
    *  @param e The event
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {

   }





   /*------------------------------------------------------------*/
   /* getPreferredSize
    */
   /**
    *    This method will return the preferred
    *  size of our panel
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public Dimension getMinimumSize () {
      return( GUISystem.defaultNavSize ) ;
   }





   /*------------------------------------------------------------*/
   /* setText
    */
   /**
    *    This method will set our text
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void setText () {
      String statDate = Constants.getStrConst ( "QQ_STAT_DATE" ) ;

      stt_DOC_THIS_YEAR.setText          ( Constants.getStrConst (  "QQ_DOC_PUB_THIS_YEAR" ) ) ;
      stt_DOC_THIS_WEEK.setText          ( Constants.getStrConst (  "QQ_DOC_PUB_THIS_WEEK" ) ) ;
      stt_DOC_TODAY.setText              ( Constants.getStrConst (  "QQ_DOC_PUB_THIS_DAY" ) ) ;
      stt_DOC_THIS_MONTH.setText         ( Constants.getStrConst (  "QQ_DOC_PUB_THIS_MONTH" ) ) ;
      stt_PRODUCT_THIS_YEAR.setText      ( Constants.getStrConst (  "QQ_PROD_PUB_THIS_YEAR" ) ) ;
      stt_PRODUCT_THIS_WEEK.setText      ( Constants.getStrConst (  "QQ_PROD_PUB_THIS_WEEK" ) ) ;
      stt_PRODUCT_TODAY.setText          ( Constants.getStrConst (  "QQ_PROD_PUB_THIS_DAY" ) ) ;
      stt_PRODUCT_THIS_MONTH.setText     ( Constants.getStrConst (  "QQ_PROD_PUB_THIS_MONTH" ) ) ;
      stt_TOTAL_DOCS.setText             ( Constants.getStrConst (  "QQ_TOTAL_DOCS" ) ) ;
      stt_TOTAL_PRODUCTS.setText         ( Constants.getStrConst (  "QQ_TOTAL_PRODUCTS" ) ) ;
      stt_TOTAL_FAMILIES.setText         ( Constants.getStrConst (  "QQ_TOTAL_FAMILIES" ) ) ;
      stt_TOTAL_FILE_ATTACH.setText     ( Constants.getStrConst (  "QQ_TOTAL_FILES" ) ) ;
      st_TITLE.setText ( Str.getStr ( STR_STATS_AS_OF )+" "+DateSystem.prettyDateFromDate ( statDate ) ) ;

   }   





   /*------------------------------------------------------------*/
   /* userStatChanged
    */
   /**
    *    This method will be called when a user statistic
    *  changes.
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void userStatChanged () {
   }




   /*------------------------------------------------------------*/
   /* propertyChanged
    */
   /**
    *    This method will be called when a property
    *  we are listening for has been changed
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void propertyChanged ( int property, Object value ) {
   }

   public void setOpaque ( boolean o ) {
   }

   public void paintComponent ( Graphics g ) {
      Dimension size     = getSize() ;
      int       topWidth = ImageSystem.getImageIcon ( this, ImageSystem.USERSTAT_TOP ).getImage().getWidth(this) ;

      com.ibm.nzna.shared.util.WinUtil.wallPaper ( this, g, ImageSystem.getImage ( this, ImageSystem.USERSTAT_BACKGROUND ) ) ;
      if ( topWidth > 0 ) {
         for ( int i = 0; i < size.width ; i+=topWidth )
            g.drawImage ( ImageSystem.getImageIcon ( this, ImageSystem.USERSTAT_TOP ).getImage(), i, 0, this ) ;
      }
      paintChildren ( g ) ;
   }


} /* UserStatPanel */
