package com.ibm.nzna.projects.qit.gui.popup;
/*-----------------------------------------------------------*/
/*   FileRecRenderer                                         */
/*                                                           */
/*   Description:                                            */
/*      Source code for: FileRecRenderer                     */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This ListCellRenderer subclass can be used in JLists that display FileRecs 
 *
 *
 * @version 1.0, 5/20/1999 
 * @author  David Lentz
 */
import javax.swing.* ;  
import java.awt.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.doc.* ;
   

/*-----------------------------------------------------------*/
/*                                                           */
/*   FileRecRenderer                                         */
/*                                                           */
/*-----------------------------------------------------------*/
public class FileRecRenderer extends Component implements ListCellRenderer, AppConst {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Static Members                                          */   
   /*                                                           */
   /*-----------------------------------------------------------*/
   public static Color     lightBlue = new Color ( 209, 210, 249 ) ;
   public static Font      boldFont  = new Font ( "Sans Serif", Font.BOLD, 12 ) ;
   public static Font      font      = new Font ( "Sans Serif", Font.PLAIN, 12 ) ;
   public static Dimension prefSize  = new Dimension ( 200, 42 ) ;
   
   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Vars                                                    */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private DocFileRec fileRec       = null ;
   private boolean    isSelected    = false ;
   private int        index         = 0 ;




   /*------------------------------------------------------------*/
   /* getListCellRendererComponent
    */
   /**
    *    This method will return the component
    *  used to draw our line. This will be an instance
    *  of this object
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public Component getListCellRendererComponent( JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
      fileRec = (DocFileRec) value ;
      this.isSelected = isSelected ;
      this.index      = index ;
      return this;
   }





   /*------------------------------------------------------------*/
   /* paint
    */
   /**
    *    This method will paint our object
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void paint ( Graphics g ) {
      Dimension size = getSize() ;

      /* First paint our background */
      if ( ((index/2)*2) != index )
         g.setColor ( lightBlue ) ;
      else
         g.setColor ( Color.white ) ;

      g.fillRect ( 0, 0, size.width, size.height ) ;


      g.setColor ( Color.black ) ;
      g.drawString ( fileRec.sFilename+" - "+fileRec.descript, 2, 12 ) ;
      g.drawString ( Str.getStr ( STR_SIZE )+": "+fileRec.fileSize+"   "+Str.getStr ( STR_LOCATION )+": "+fileRec.fileURL, 2, 25 ) ;

      if ( isSelected )
         g.drawRect ( 0, 0, size.width-1, size.height-1 ) ;

   }


   public Dimension getPreferredSize () {
      return ( prefSize ) ;
   }

   public Dimension getMinimumSize () {
      return ( prefSize ) ;
   }

} /* FileRecRenderer */
