package com.ibm.nzna.projects.qit.gui.popup ;
/*-----------------------------------------------------------*/
/*   PopUpBrandFamily                                        */
/*                                                           */
/*   Description:                                            */
/*      Source code for: PopUpBrandFamily                    */
/*                                                           */
/*                                                           */
/*         @Copyright  1998 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This pop up allows the association of a Brand/Family to a document. 
 *
 * @version 1.0, 6/1/1999 
 * @author  David Lentz
 */
import java.awt.* ;
import java.io.* ;
import java.awt.event.* ;
import java.util.* ;
import javax.swing.* ;
import javax.swing.tree.* ;
import javax.swing.event.* ;
import com.ibm.nzna.projects.qit.doc.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.qit.dbgui.* ;
import com.ibm.nzna.projects.qit.app.util.* ;
import com.ibm.nzna.projects.qit.doc.docmaint.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.quest.brand.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.util.* ;

/*-----------------------------------------------------------*/
/*                                                           */
/*   PopUpBrandFamily                                        */
/*                                                           */
/*-----------------------------------------------------------*/
public class PopUpBrandFamily extends PopUpPanel implements Runnable, MouseListener, ItemListener, AppConst, ActionListener, ListSelectionListener {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Static                                                  */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private static final Insets insets = new Insets ( 0, 0, 0, 0 ) ;

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Controls                                                */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private DList                    cnr_FAMILY         = null ;
   private JLabel                   st_BRANDS          = null ;
   private JLabel                   st_SELECTHELP      = null ;
   private JLabel                   st_ASSOCFAMILIES   = null ;
   private DButton                  pb_ASSOCIATEALL    = null ;
   private DButton                  pb_ASSOCIATENONE   = null ;
   private JScrollPane              scr_FAMILY         = null ;
   private DButton                  pb_RIGHT           = null ;
   private DButton                  pb_LEFT            = null ;
   private DButton                  pb_RIGHTALL        = null ;
   private JLabel                   st_STATUS          = null ;
   private PopUpBrandFamilyListener listener           = null ;
   private JComboBox                cb_BRANDS          = null ;
   private JList                    lb_FAMILY          = null ;
   private JScrollPane              scr_LBFAMILY       = null ;
   private DefaultListModel         listModel          = new DefaultListModel() ;


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Vars                                                    */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private ProdDocRec    workRec       = null ;
   private ProdDocRec    originalRec   = null ;
   private boolean       cachedTree    = false ;



   /*-----------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This will create a PopUpBrandFamily Panel
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public PopUpBrandFamily ( PopUpDlg popUpDlg ) {
      super(popUpDlg) ;

      setLayout ( null ) ;

      /* Create our controls  */
      cnr_FAMILY       = new DList() ;
      st_SELECTHELP    = new JLabel      ( Str.getStr ( STR_IDIOT_DIRECTIONS ) ) ;
      st_BRANDS        = new JLabel      ( Str.getStr ( STR_BRAND ) ) ;
      st_ASSOCFAMILIES = new JLabel      ( Str.getStr ( STR_ASSOCIATED_FAMILIES ) ) ;
      pb_ASSOCIATEALL  = new DButton     ( Str.getStr ( STR_ASSOC_TO_ALL ) ) ;
      pb_ASSOCIATENONE = new DButton     ( Str.getStr ( STR_DIRECT_ASSOC ) );
      scr_FAMILY       = new JScrollPane ( cnr_FAMILY ) ;
      pb_LEFT          = new DButton     ( "<<" ) ;
      pb_RIGHT         = new DButton     ( ">>" ) ;
      pb_RIGHTALL      = new DButton     ( ">>" ) ;
      st_STATUS        = new JLabel      ( "" ) ;
      cb_BRANDS        = new JComboBox   ( TypeList.getInstance().getTypeList ( TypeList.TYPE_BRAND ) ) ;
      lb_FAMILY        = new JList       ( listModel ) ;
      scr_LBFAMILY     = new JScrollPane ( lb_FAMILY ) ;

      /* Add each GUI control  */
      add ( st_SELECTHELP ) ;
      add ( st_BRANDS ) ;
      add ( st_ASSOCFAMILIES ) ;
      add ( cb_BRANDS ) ;
      add ( scr_LBFAMILY ) ;
      add ( pb_LEFT ) ;
      add ( pb_RIGHT ) ;
      add ( pb_RIGHTALL ) ;
      add ( scr_FAMILY ) ;
      add ( pb_ASSOCIATEALL ) ;
      add ( pb_ASSOCIATENONE ) ;
      add ( st_STATUS ) ;

      /* Hide the two associate buttons for now  */
      pb_ASSOCIATEALL.setVisible ( false ) ;
      pb_ASSOCIATENONE.setVisible ( false ) ;

      /* Assign some properties */
      pb_RIGHT.setMargin ( insets ) ;
      pb_RIGHTALL.setMargin ( insets ) ;
      pb_RIGHTALL.setForeground ( Color.blue ) ;
      pb_LEFT.setMargin  ( insets ) ;
      st_STATUS.setForeground ( Color.blue ) ;
      lb_FAMILY.addMouseListener ( this ) ;

      /* Add our action Listeners */
      pb_LEFT.addActionListener           ( this ) ;
      pb_RIGHT.addActionListener          ( this ) ;
      pb_RIGHTALL.addActionListener       ( this ) ;
      pb_ASSOCIATEALL.addActionListener   ( this ) ;
      pb_ASSOCIATENONE.addActionListener  ( this ) ;
      cb_BRANDS.addItemListener           ( this ) ;
      cnr_FAMILY.addListSelectionListener ( this ) ;
      lb_FAMILY.addListSelectionListener  ( this ) ;



   }





   /*------------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will layout and position all
    *  of our controls
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size            = getSize() ;
      int       halfHeight      = size.height/2 ;
      int       half            = (size.width/2)-5 ;
      int       rowHeight       = GUISystem.getRowHeight() ;
      int       y               = 0 ;
      int       x               = 10 ;
      int       halfButtonWidth = 25 ;

      super.doLayout() ;

      st_SELECTHELP.setBounds ( x, 0, size.width-(x*2), rowHeight ) ;
      y+=rowHeight ;

      st_BRANDS.setBounds ( x, y, half-halfButtonWidth-(x*2), rowHeight ) ;
      st_ASSOCFAMILIES.setBounds ( half+halfButtonWidth+x, y, half-halfButtonWidth-x, rowHeight ) ;
      y+=rowHeight ;

      cb_BRANDS.setBounds ( x, y, half-halfButtonWidth-(x*2), rowHeight ) ;
      scr_FAMILY.setBounds ( half+halfButtonWidth+x, y, half-halfButtonWidth-x, size.height-80 ) ;
      y+=rowHeight+2 ;

      scr_LBFAMILY.setBounds ( x, y, half-halfButtonWidth-(x*2), size.height-82-rowHeight ) ;


      pb_ASSOCIATEALL.setBounds ( half+halfButtonWidth+x, size.height-30, half-halfButtonWidth-x, 25 ) ;
      pb_ASSOCIATENONE.setBounds ( half+halfButtonWidth+x, size.height-30, half-halfButtonWidth-x, 25 ) ;

      pb_LEFT.setBounds ( half-halfButtonWidth, halfHeight-50, halfButtonWidth*2, 25 ) ;
      pb_RIGHT.setBounds ( half-halfButtonWidth, halfHeight-15, halfButtonWidth*2, 25 ) ;
      pb_RIGHTALL.setBounds ( half-halfButtonWidth, halfHeight+20, halfButtonWidth*2, 25 ) ;

      st_STATUS.setBounds ( 0, size.height-30, half, 25 ) ;

   }


   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will be called when an action
    *  event is fired
    *  
    *
    *  @param e The event
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {
      if ( !readOnly ) {
         if ( e.getSource() instanceof DButton ) {
            DButton button = (DButton) e.getSource() ;

            if ( pb_RIGHT == button )
               associateFamily ( false ) ;

            else if ( pb_RIGHTALL == button )
               associateFamily ( true ) ;

            else if ( pb_LEFT == button )
               deassociateFamily() ;

            else if ( pb_ASSOCIATEALL == button )
               associateAll() ;

            else if ( pb_ASSOCIATENONE == button )
               associateNone() ;
         }

      }

   }






   /*------------------------------------------------------------*/
   /* associateFamily
    */
   /**
    *    This method will associate all selected
    *  families and add them to the list.
    *  
    *
    *  @param all - Associate as an all
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void associateFamily ( boolean all ) {

      setEnabled ( false ) ;

      try {
         Object[] families = lb_FAMILY.getSelectedValues() ;

         if ( ( families != null ) && ( families.length > 0 ) ) {
            int i    = 0 ;

            while ( i < families.length ) {
               if ( families[i] != null ) {
                  DocFamilyRec docFamRec = new DocFamilyRec ( ((TypeGroupRec)families[i]).getBrandGroupInd() ) ;

                  PropertySystem.putInt ( PropertySystem.PROPERTY_LAST_SELECTED_BRANDFAMILY, ((TypeGroupRec)families[i]).getBrandGroupInd() ) ;

                  st_STATUS.setText ( Str.getStr ( STR_ASSOCIATING )+" "+docFamRec.toString() ) ;
                  if ( all )
                     workRec.addFamilyAllAssociation ( docFamRec ) ;
                  else
                     workRec.addFamilyAssociation ( docFamRec ) ;
                  st_STATUS.setText ( "" ) ;

                  cnr_FAMILY.setListData  ( workRec.getAssociatedFamilies() ) ;
                  pb_ASSOCIATEALL.setVisible ( false ) ;
                  pb_ASSOCIATENONE.setVisible ( false ) ;

               }
               i++ ;
            }
         }
      } catch ( Exception e ) {
         LogSystem.log ( 1, e, false ) ;
         GUISystem.printBox ( STR_INFO, STR_ERROR_IN_LAST_ACTION ) ;
      }

      if ( listener != null )
         listener.brandFamilyChanged ( this ) ;

      setEnabled ( true ) ;

   }





   /*------------------------------------------------------------*/
   /* deassociateFamily
    */
   /**
    *    This method will de associate a family
    *  from the document. This will remove the
    *  entry from the right list and add it to the left list
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void deassociateFamily() {
      Object[] values = cnr_FAMILY.getSelectedValues() ;

      setEnabled ( false ) ;

      try {

         if ( ( values != null ) && ( values.length > 0 ) ) {
            int i    = 0 ;

            while ( i < values.length ) {

               workRec.deAssociateFamily ( (DocFamilyRec) values[i] ) ;               

               i++ ;
            }

            cnr_FAMILY.setListData ( workRec.getAssociatedFamilies() ) ;
            pb_ASSOCIATEALL.setVisible ( false ) ;
            pb_ASSOCIATENONE.setVisible ( false ) ;

         }

      } catch ( Exception e ) {
         LogSystem.log ( 1, e ) ;
      }

      if ( listener != null )
         listener.brandFamilyChanged ( this ) ;

      setEnabled ( true ) ;
   }





   /*------------------------------------------------------------*/
   /* refreshData
    */
   /**
    *    This method will refresh our data with the
    *  data passed in. The data passed in must
    *  be a ProdDocRec
    *
    *  @param data The data to refresh with
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void refreshData ( Object data ) {

      try {
         TypeBrandRec brandRec      = (TypeBrandRec) TypeList.getInstance().objectFromInd ( PropertySystem.getInt ( PropertySystem.PROPERTY_DEFAULT_BRAND ), TypeList.TYPE_BRAND ) ;
         TypeBrandRec lastBrandRec  = (TypeBrandRec) Brands.brandRecFromBrandGroupInd ( PropertySystem.getInt ( PropertySystem.PROPERTY_LAST_SELECTED_BRANDFAMILY ) ) ;

         if ( data instanceof ProdDocRec ) {
            ProdDocRec prodRec = (ProdDocRec) data ;

            /* If we were passed a null, create a blank record  */
            if ( data == null )
               workRec = new ProdDocRec() ;

            /* Otherwise, work with a copy of the record  */
            else
               workRec = (ProdDocRec) prodRec.clone() ;
         } else
            workRec = new ProdDocRec() ;


         /* Now, popuplate our lists */
         cnr_FAMILY.setListData ( workRec.getAssociatedFamilies() ) ;
         pb_ASSOCIATEALL.setVisible ( false ) ;
         pb_ASSOCIATENONE.setVisible ( false ) ;            


         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Auto select the brand. If the user doesn't have a last  */
         /* selected brand, use their default brand                   */
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( lastBrandRec == null )
            lastBrandRec = brandRec ;


         if ( lastBrandRec != null )
            cb_BRANDS.setSelectedItem ( lastBrandRec ) ;


      } catch ( Exception e ) {
         LogSystem.log ( 1, e ) ;
      }
   }




   /*------------------------------------------------------------*/
   /* valueChanged
    */
   /**
    *    This method will be called when a user
    *  hits the list box
    *  
    *
    *  @param e The event
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void valueChanged ( ListSelectionEvent e ) {
      if ( !e.getValueIsAdjusting() ) {
         if ( e.getSource() == cnr_FAMILY ) {
            Object[] values    = cnr_FAMILY.getSelectedValues() ;
            int      allCount  = 0 ;
            int      normCount = 0 ;

            if ( values != null ) {
               int i = 0 ;

               /* First, figure out how many alls we have
                  because this determines which button we
                  will show  */
               while ( i < values.length ) {
                  if ( ((DocFamilyRec)values[i]).getAll() )
                     allCount++ ;
                  else
                     normCount++ ;
                  i++ ;
               }

               pb_ASSOCIATEALL.setVisible  ( normCount > allCount ) ;
               pb_ASSOCIATENONE.setVisible ( allCount >= normCount ) ;
            } else {
               pb_ASSOCIATEALL.setVisible ( false ) ;
               pb_ASSOCIATENONE.setVisible ( false ) ;
            }

            if ( listener != null )
               listener.brandFamilyChanged ( this ) ;
         }


         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   If the user selected a Family, make sure that we save it*/
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( e.getSource() == lb_FAMILY ) {
            Vector   saveVec  = new Vector ( 1 ) ;
            Object[] selected = lb_FAMILY.getSelectedValues() ;

            if ( ( selected != null ) && ( selected.length > 0 ) ) {
               for ( int i = 0; i < selected.length; i++ ) {
                  saveVec.addElement ( new Integer ( ((TypeGroupRec)selected[i]).getInd() ) ) ;
               }

               PropertySystem.put ( PropertySystem.PROPERTY_LAST_SELECTED_FAMILIES, saveVec ) ;
            }
         }
      }

   } /* valueChanged  */





   /*------------------------------------------------------------*/
   /* itemStateChanged
    */
   /**
    *    This method is called when an item is changed
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void itemStateChanged ( ItemEvent e ) {
      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   CB_BRANDS                                               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( e.getSource() == cb_BRANDS ) {
         TypeBrandRec brandRec = (TypeBrandRec) cb_BRANDS.getSelectedItem(); 

         if ( brandRec != null ) {
            TypeGroupRec groupRec      = (TypeGroupRec) TypeList.getInstance().objectFromInd ( PropertySystem.getInt ( PropertySystem.PROPERTY_DEFAULT_GROUP ), TypeList.TYPE_FAMILY ) ;
            TypeGroupRec lastGroupRec  = (TypeGroupRec) Brands.groupRecFromBrandGroupInd ( PropertySystem.getInt ( PropertySystem.PROPERTY_LAST_SELECTED_BRANDFAMILY ) ) ;
            Vector       familyVec     = Brands.groupsFromBrand ( brandRec.getInd() ) ;
            Vector       lastFamilyVec = (Vector) PropertySystem.get ( PropertySystem.PROPERTY_LAST_SELECTED_FAMILIES ) ;

            addToModel ( familyVec ) ;

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Auto select the group. If the user doesn't have a last  */
            /* selected group, use their default group                   */
            /*                                                           */
            /*-----------------------------------------------------------*/
            if ( lastGroupRec == null )
               lastGroupRec = groupRec ;

            if ( lastGroupRec != null )
               lb_FAMILY.setSelectedValue ( lastGroupRec, true ) ;

            try {
               PropertySystem.putInt ( PropertySystem.PROPERTY_LAST_SELECTED_BRANDFAMILY, Brands.brandGroupIndFromBrandGroup ( brandRec.getInd(), groupRec.getInd() ) ) ;
            } catch ( Exception ex ) {
            }

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   OK, select all of the last selected families            */
            /*                                                           */
            /*-----------------------------------------------------------*/
            try {
               if ( ( lastFamilyVec != null ) && ( lastFamilyVec.size() > 0 ) ) {
                  int              i         = 0 ;
                  int              size      = lastFamilyVec.size() ;
                  int[]            indices   = new int[size] ;

                  while ( i < size ) {
                     indices[i] = listModel.indexOf ( TypeList.getInstance().objectFromInd ( ((Integer)lastFamilyVec.elementAt(i)).intValue(),
                                                                                             TypeList.TYPE_FAMILY ) ) ;
                     i++ ;
                  }

                  lb_FAMILY.setSelectedIndices ( indices ) ;
                  lb_FAMILY.ensureIndexIsVisible ( indices[0] ) ;
               }
            } catch ( Exception e3 ) {
               e3.printStackTrace() ;
               if ( lb_FAMILY.getModel() == null )
                  System.out.println ( "Model is null!" ) ;
            }


         }
      }

   }



   /*------------------------------------------------------------*/
   /* associateAll
    */
   /**
    *    this method will associate all families
    *  selected as 'All' families.
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void associateAll () {
      Object[] values    = cnr_FAMILY.getSelectedValues() ;
      int      allCount  = 0 ;
      int      normCount = 0 ;

      if ( values != null ) {
         int i = 0 ;

         /* First, figure out how many alls we have
            because this determines which button we
            will show  */
         while ( i < values.length ) {
            workRec.addFamilyAllAssociation ( (DocFamilyRec) values[i] ) ;
            i++ ;
         }

      }

      pb_ASSOCIATEALL.setVisible ( false ) ;
      pb_ASSOCIATENONE.setVisible ( true ) ;
      revalidate() ;
      repaint() ;

      if ( listener != null )
         listener.brandFamilyChanged ( this ) ;
   }




   /*------------------------------------------------------------*/
   /* associateNone
    */
   /**
    *    this method will take away the associate all
    *  property from all families selected
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void associateNone() {
      Object[] values    = cnr_FAMILY.getSelectedValues() ;
      int      allCount  = 0 ;
      int      normCount = 0 ;

      if ( values != null ) {
         int i = 0 ;

         /* First, figure out how many alls we have
            because this determines which button we
            will show  */
         while ( i < values.length ) {
            workRec.addFamilyAssociation ( (DocFamilyRec) values[i] ) ;
            i++ ;
         }                                           

      }

      pb_ASSOCIATEALL.setVisible ( true ) ;
      pb_ASSOCIATENONE.setVisible ( false ) ;
      revalidate() ;
      repaint() ;

      if ( listener != null )
         listener.brandFamilyChanged ( this ) ;

   }




   /*------------------------------------------------------------*/
   /* setEnabled
    */
   /**
    *    This method will either enable or disable
    *  our controls
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setEnabled ( boolean enable ) {
      pb_RIGHTALL.setEnabled      ( enable ) ;
      pb_RIGHT.setEnabled         ( enable ) ;
      pb_LEFT.setEnabled          ( enable ) ;
      if ( popUpDlg != null )
         popUpDlg.setEnabled         ( enable ) ;
      pb_ASSOCIATEALL.setEnabled  ( enable ) ;
      pb_ASSOCIATENONE.setEnabled ( enable ) ;
   }


   /*-----------------------------------------------------------*/
   /* setFocus
    */
   /**
    *    This method will be called when the PopUpDlg
    *  is done initializing and is now ready to let
    *  the user enter data.
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setFocus() {
      cb_BRANDS.requestFocus() ;
   }

   /*-----------------------------------------------------------*/
   /* saveData
    */
   /**
    *    This method will determine if the user has
    *  entered the data needed to close the popup
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return The string entered if any
    *//*---------------------------------------------------------*/
   public Object saveData() {
      Object retRec = null ;

      try {

         if ( requireData ) {
            if ( !workRec.hasFamilies() )
               GUISystem.printBox ( STR_ERROR, STR_MUST_SELECT_ITEM ) ;
            else {
               retRec = workRec.clone() ;
            }
         } else
            retRec = workRec.clone() ;

      } catch ( Exception e ) {
         LogSystem.log ( 1, e ) ;
      }

      return( retRec ) ;
   }


   /*-----------------------------------------------------------*/
   /* setRequired
    */
   /**
    *    This method will tell the entry field to either
    *  require data or not
    *  
    *
    *  @param requireData = TRUE if we should not close until data is entered
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setRequired ( boolean requireData ) {
      this.requireData = requireData ;
   }


   /*------------------------------------------------------------*/
   /* hiding
    */
   /**
    *    This method will be called when the dialog
    *  we are in hides itself. We will clean up
    *  our resources here
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void hiding () {
      workRec = null ;

      cnr_FAMILY.setListData ( new Vector ( 1 ) ) ;

   }




   /*------------------------------------------------------------*/
   /* setPopUpBrandFamilyListener
    */
   /**
    *    This method will set the listener who is
    *  notified of changes made to the Brand/Family
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setPopUpBrandFamilyListener ( PopUpBrandFamilyListener listener ) {
      this.listener = listener ;
   }

   public ProdDocRec getWorkingRec () {
      return( workRec ) ;
   }





   /*------------------------------------------------------------*/
   /* mousePressed
    */
   /**
    *    This method will respond to mouse events
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void mouseClicked ( MouseEvent e ) {
      if ( e.getClickCount() >= 2 ) {
         new Thread ( this ).start() ;
      }
   }

   public void mouseReleased ( MouseEvent e ) {}
   public void mousePressed  ( MouseEvent e ) {}
   public void mouseEntered  ( MouseEvent e ) {}
   public void mouseExited   ( MouseEvent e ) {}


   public void run () {
      associateFamily ( false ) ;
   }

   private void addToModel ( Vector vec ) {
      listModel.removeAllElements() ;

      if ( ( vec != null ) && ( vec.size() > 0 ) ) {
         for ( int i = 0; i < vec.size(); i++ ) 
            listModel.addElement ( vec.elementAt(i) ) ;
      }
   }
} /* PopUpBrandFamily */
