package com.ibm.nzna.projects.qit.gui.popup ;
/*-----------------------------------------------------------*/
/*   PopUpCheck                                              */
/*                                                           */
/*   Description:                                            */
/*      Source code for: PopUpCheck                          */
/*                                                           */
/*                                                           */
/*         @Copyright  1997 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import java.util.* ;
import javax.swing.* ;
import com.ibm.nzna.projects.qit.app.* ;
/**
 * This panel holds YES and NO radio buttons 
 *
 *
 * @version 1.0, 6/28/1998 
 * @author  Maria Paredes
 *
 * Change History
 * 3/23/2000     DAL     Moved into new QIT 2.0
 */


/*-----------------------------------------------------------*/
/*                                                           */
/*   PopUpCheck                                              */
/*                                                           */
/*-----------------------------------------------------------*/
public class PopUpCheck extends PopUpPanel implements AppConst {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Controls                                                */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private JLabel         st_DESCRIPT   = new JLabel ( "" ) ;
   private ButtonGroup    cbGroup       = new ButtonGroup () ;
   private JRadioButton   rb_YES        = new JRadioButton ( Str.getStr ( STR_YES  ), true ) ;
   private JRadioButton   rb_NO         = new JRadioButton ( Str.getStr ( STR_NO ), false ) ;

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Vars                                                    */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private int             rowHeight      = 18 ;
   public static final int FIELD_YES      = 6 ;  
   public static final int FIELD_NO       = 4 ;  

   /*-----------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This will create a PopUpCheck Panel
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public PopUpCheck ( PopUpDlg popUpDlg ) {
      super(popUpDlg) ;
      setLayout ( null ) ;
      
      add ( st_DESCRIPT ) ;
      add ( rb_YES ) ;
      add ( rb_NO ) ;

      cbGroup.add ( rb_YES ) ;
      cbGroup.add ( rb_NO ) ;

   }


                

   /*-----------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will be subclassed to size and
    *  position our controls
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size = getSize();
      int y = 40 ;
      int x = 50 ;
      
      super.doLayout() ;

      st_DESCRIPT.setBounds ( 0, 0, size.width, rowHeight*2 ) ;

      rb_YES.setBounds ( x, y, 200, rowHeight ) ;
      y+=rowHeight ;

      rb_NO.setBounds ( x, y + 5, 200, rowHeight ) ;
      y+=rowHeight ;

   }


   /*-----------------------------------------------------------*/
   /* setDescript
    */
   /**
    *    We subclass this method to set our description
    *  
    *  
    *
    *  @param descript
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setDescript ( String descript ) {
      st_DESCRIPT.setText ( descript ) ;
   }

   /*-----------------------------------------------------------*/
   /* saveData
    */
   /**
    *    This method will determine if the user has
    *  selected YES or NO before closing the popup
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return TRUE(for YES) or FALSE (for NO)
    *//*---------------------------------------------------------*/
   public Object saveData () {
      Object retObj = null ;

      if ( rb_YES.isSelected() ) {
         retObj = ( new Boolean ( true ) ) ;
      }else if ( rb_NO.isSelected () ) {
         retObj = ( new Boolean ( false ) ) ;
      }else
         GUISystem.printBox ( Str.getStr ( STR_ERROR ), Str.getStr ( STR_SELECT_YES_NO ) ) ;

      return ( retObj ) ;

   }

} /* PopUpCheck */
