
package com.ibm.nzna.projects.qit.gui.popup ;
/*-----------------------------------------------------------*/
/*   PopUpDates                                              */
/*                                                           */
/*   Description:                                            */
/*      Source code for: PopUpDates                          */
/*                                                           */
/*                                                           */
/*         @Copyright                                        */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.event.* ;
import java.awt.* ;
import javax.swing.* ;
import java.util.*;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.qit.doc.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.quest.status.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.common.quest.product.*;
import com.ibm.nzna.projects.qit.product.*;
import com.ibm.nzna.projects.qit.product.manager.masschange.*;
/**
 * This panel holds an entry field and a description. 
 *
 *
 * @version 1.0, 6/28/2001 
 * 
 */


/*-----------------------------------------------------------*/
/*                                                           */
/*   PopUpDates                                              */
/*                                                           */
/*-----------------------------------------------------------*/
public class PopUpDates extends PopUpPanel implements FocusListener, AppConst, ActionListener,ItemListener,ProductConst {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Controls                                                */
   /*                                                           */
   /*-----------------------------------------------------------*/

   private JLabel       st_DESCRIPT       = new JLabel ( Str.getStr ( STR_PLEASE_SELECT_DATES ) ) ;
   private JLabel       st_DATES          = new JLabel ( Str.getStr ( STR_DATES ) ) ;
   private JLabel       st_GEOS           = new JLabel ( Str.getStr ( STR_GEO ) ) ;
   private JLabel       st_COUNTRIES      = new JLabel ( Str.getStr ( STR_COUNTRY ) ) ;
   private JLabel       st_ACTUAL_DATE    = new JLabel ( Str.getStr ( STR_ACTUAL_DATE ) ) ;
   private JLabel       st_TARGET_DATE    = new JLabel ( Str.getStr ( STR_TARGET_DATE ) ) ;

   private JComboBox    cb_DATE_TYPE      = new JComboBox() ;
   private JComboBox    cb_GEOGRAPHY      = new JComboBox() ;
   private JComboBox    cb_COUNTRIES      = new JComboBox() ;

   private DateEntryField ef_ACTUAL_DATE    = new DateEntryField() ;
   private DateEntryField ef_TARGET_DATE    = new DateEntryField() ;

   private ProductDate  productDate             = null;
   private Vector       productList             = new Vector();
   private Vector       typeDatesList           = new Vector();
   private Vector       typeCountryCodeList     = new Vector();
   private Vector       dates                   = new Vector(); 
   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Vars                                                    */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private int       rowHeight = GUISystem.getRowHeight() ;


   /*-----------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This will create a PopUpDatesPanel
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public PopUpDates ( PopUpDlg popUpDlg ) {
      super(popUpDlg) ;
      setLayout ( null ) ;

      /* Adjust some properties  */
      ef_ACTUAL_DATE.addActionListener ( this ) ;
      ef_TARGET_DATE.addActionListener ( this ) ;
      cb_GEOGRAPHY.addItemListener(this);

      add ( st_DESCRIPT ) ;
      add ( st_DATES );
      add ( cb_DATE_TYPE ) ;
      add ( st_GEOS ) ;
      add ( cb_GEOGRAPHY ) ;
      add ( st_COUNTRIES );
      add ( cb_COUNTRIES );
      add ( st_ACTUAL_DATE );
      add ( ef_ACTUAL_DATE ) ;
      add ( st_TARGET_DATE );
      add ( ef_TARGET_DATE ) ;
   }                            

   /*-----------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will be subclassed to size and
    *  position our controls
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size = getSize();
      int       y    = 0 ;

      super.doLayout() ;

      st_DESCRIPT.setBounds ( 0, 0, size.width, rowHeight ) ;
      y+=rowHeight+2 ;

      cb_DATE_TYPE.setBounds ( 0, y, 230, rowHeight ) ;
      y+=rowHeight+7 ;


      st_GEOS.setBounds ( 0, y, size.width, rowHeight ) ;
      y+=rowHeight ;

      cb_GEOGRAPHY.setBounds ( 0, y, 170, rowHeight ) ;
      y+=rowHeight+2 ;

      st_COUNTRIES.setBounds(0,y ,size.width,rowHeight);
      y+=rowHeight ;

      cb_COUNTRIES.setBounds ( 0, y, 150, rowHeight ) ;
      y+=rowHeight+2 ;


      st_ACTUAL_DATE.setBounds(0,y ,size.width,rowHeight);
      y+=rowHeight ;

      ef_ACTUAL_DATE.setBounds ( 0, y, 170, rowHeight ) ;
      y+=rowHeight+2 ;

      st_TARGET_DATE.setBounds(0,y ,size.width,rowHeight);
      y+=rowHeight ;

      ef_TARGET_DATE.setBounds ( 0, y, 170, rowHeight ) ;
   }



   /*-----------------------------------------------------------*/
   /* setDescript
    */
   /**
    *    We subclass this method to set our description
    *  
    *  
    *
    *  @param descript
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setDescript ( String descript ) {
   }



   /*-----------------------------------------------------------*/
   /* saveData
    */
   /**
    *    This method will determine if the user has
    *  entered the data needed to close the popup
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return The string entered if any
    *//*---------------------------------------------------------*/
   public Object saveData () {
      try {
         if ( (cb_GEOGRAPHY.getSelectedItem()==null)&&(cb_COUNTRIES.getSelectedItem()==null)&&(cb_DATE_TYPE.getSelectedItem()==null) ) {
            GUISystem.printBox ( Str.getStr ( STR_ERROR ), Str.getStr ( STR_MUST_SELECT_ITEM ) ) ;
            return (null);
         } else {
            int countryCodeInd =((TypeCountryCodeRec)cb_COUNTRIES.getSelectedItem()).getInd();
            int dateTypeInd    =((TypeDateRec)cb_DATE_TYPE.getSelectedItem()).getInd();
            String actualDate  =ef_ACTUAL_DATE.getText();
            String targetDate  =ef_TARGET_DATE.getText();
            ProductDateObject dateObject=new ProductDateObject(dateTypeInd,countryCodeInd,actualDate,targetDate);
            return(dateObject);
         }
      } catch ( Exception e ) {
         LogSystem.log ( 1, e, false ) ;
      }

      return( null ) ;

   }

   /*-----------------------------------------------------------*/
   /* refreshData
    */
   /**
    *    This method will refresh all of our data
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void refreshData ( Object dataObj ) {
      setData();
   } 


   public void setData ( ) {
      //TypeList.refreshList(cb_GEOGRAPHY,TypeList.TYPE_GEOGRAPHY, null);
       Vector geoList=(Vector)(TypeList.getInstance()).getTypeList(TypeList.TYPE_GEOGRAPHY);
       geoList.removeElement ( TypeList.getInstance().objectFromInd ( 6, TypeList.TYPE_GEOGRAPHY ) ) ;

       if((geoList!=null)&&(geoList.size()>0)){
           for(int i=0;i<geoList.size();i++){
               cb_GEOGRAPHY.addItem(geoList.elementAt(i));
           }
       }
      TypeList.refreshList(cb_DATE_TYPE,TypeList.TYPE_DATE,null);
      ef_ACTUAL_DATE.setText ( new CDate ( CDate.DATE_DATE ).today() ) ;
      ef_TARGET_DATE.setText ( new CDate ( CDate.DATE_DATE ).today() ) ;
   } 




   /*-----------------------------------------------------------*/
   /* setFocus
    */
   /**
    *    This method will be called when the PopUpDlg
    *  is done initializing and is now ready to let
    *  the user enter data.
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setFocus() {
/*      if ( cb_STATUS != null )
         cb_STATUS.requestFocus() ;*/
   }



   /*-----------------------------------------------------------*/
   /* StatusHit
    */
   /**
    *    This method will respond to the entry
    *  field being used
    *  
    *             
    *  @param 
    *  @param 
    *  @param 
    *
    *  @return 
    */
   public void actionPerformed ( ActionEvent e ) {
      String text = ef_ACTUAL_DATE.getText().trim() ;
      String date = CDate.format4DigitYear ( text, CDate.DATE_DATE ) ;

      ef_ACTUAL_DATE.setText ( date ) ;

      String text1 = ef_TARGET_DATE.getText().trim() ;
      String date1 = CDate.format4DigitYear ( text1, CDate.DATE_DATE ) ;

      ef_TARGET_DATE.setText ( date1 ) ;



      if ( saveData() != null ) {
         if ( popUpDlg != null )
            popUpDlg.okHit ( PopUpDlg.PB_OK ) ;
      }

   }


   /*-----------------------------------------------------------*/
   /* setReadOnly
    */
   /**
    *    This method will change this pop up to be
    *  read only
    *  
    *             
    *  @param readOnly TRUE = make read only, false Make no read only
    *  @param 
    *  @param 
    *
    *  @return 
    */
   public void setReadOnly ( boolean readOnly ) {
      super.setReadOnly ( readOnly ) ;
      ef_ACTUAL_DATE.setEnabled ( !readOnly ) ;
      ef_TARGET_DATE.setEnabled ( !readOnly ) ;
      cb_DATE_TYPE.setEnabled ( !readOnly ) ;
   }

   public void focusGained ( FocusEvent e ) {
   }



   public void itemStateChanged(ItemEvent ie) {

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   cb_GEOGRAPHY                                            */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( ie.getSource() == cb_GEOGRAPHY ) {
         System.out.println("insideaction");
         refreshCountries();

      }
   }
   /*------------------------------------------------------------*/
   /* focusLost
    */
   /**
    *    This method will be called when the
    *  entry field for the status date loses focus. We
    *  will use this time to format the date correctly
    *
    *  @param e The event
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void focusLost ( FocusEvent e ) {
   }



/*    public void setSelection ( Vector data ) {
        if ( data != null ) {
            for ( int dataIndex = 0 ; dataIndex < data.size() ; dataIndex++ ) {
                cb_GEOGRAPHY.setSelectedValue ( data.elementAt( dataIndex ) , true ) ;
            }
        }
    }*/


   public void setDefaults () {
//      cb_GEOGRAPHY. ;
      //    jl_COUNTRIES.clearSelection();
      //    setMultiSelect ( false ) ;
   }

   private void refreshCountries() {
      TypeGeoRec geoRec=(TypeGeoRec)cb_GEOGRAPHY.getSelectedItem();
      Vector countryVector=geoRec.getCountryVec();
      cb_COUNTRIES.removeAllItems();
      for ( int i=0;i<countryVector.size();i++ ) {
         cb_COUNTRIES.addItem(countryVector.elementAt(i));
      }

   }
} /* PopUpDates */
