package com.ibm.nzna.projects.qit.gui.popup ;
/*-----------------------------------------------------------*/
/*   PopUpDescript                                           */
/*                                                           */
/*   Description:                                            */
/*      Source code for: PopUpDescript                       */
/*                                                           */
/*                                                           */
/*         @Copyright  1997 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import javax.swing.* ;
import com.ibm.nzna.projects.qit.app.* ;
/**
 * This panel holds just a static text wrapping field
 *
 *
 * @version 1.0, 6/28/1998 
 * @author  David Lentz
 */


/*-----------------------------------------------------------*/
/*                                                           */
/*   PopUpDescript                                           */
/*                                                           */
/*-----------------------------------------------------------*/
public class PopUpDescript extends PopUpPanel implements AppConst {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Controls                                                */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private JLabel st_DESCRIPT       = new JLabel ( "" ) ;


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Vars                                                    */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private int       rowHeight     = 18 ;


   /*-----------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This will create a PopUpDescriptPanel
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public PopUpDescript ( PopUpDlg popUpDlg ) {
      super(popUpDlg) ;
      setLayout ( null ) ;
      add ( st_DESCRIPT ) ;
      st_DESCRIPT.setVerticalAlignment ( SwingConstants.TOP ) ;

   }
           

   /*-----------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will be subclassed to size and
    *  position our controls
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size = getSize();

      st_DESCRIPT.setBounds ( 0, 20, size.width, size.height ) ;
   }



   /*-----------------------------------------------------------*/
   /* setDescript
    */
   /**
    *    We subclass this method to set our description
    *  
    *  
    *
    *  @param descript
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setDescript ( String descript ) {
      st_DESCRIPT.setText ( descript ) ;
   }



   /*-----------------------------------------------------------*/
   /* saveData
    */
   /**
    *    This method will determine if the user has
    *  entered the data needed to close the popup
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return The string entered if any
    *//*---------------------------------------------------------*/
   public Object saveData () {
      return ( new String ( "A" ) ) ;
   }


   /*-----------------------------------------------------------*/
   /* getDescript
    */
   /**
    *    This method will return the entry field instance
    *  to the caller.
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Instance of an Descript
    *//*---------------------------------------------------------*/
   public JLabel getStaticText () {
      return ( st_DESCRIPT ) ;
   }



   /*-----------------------------------------------------------*/
   /* refreshData
    */
   /**
    *    This method will refresh all of our data
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void refreshData ( Object dataObj ) {
      if ( dataObj != null ) {
         if ( dataObj instanceof String ) {
            String tempStr = (String) dataObj ;

            st_DESCRIPT.setText ( tempStr ) ;
         } else
            st_DESCRIPT.setText ( "" ) ;
      } else
         st_DESCRIPT.setText ( "" ) ;

   }




   /*-----------------------------------------------------------*/
   /* setFocus
    */
   /**
    *    This method will be called when the PopUpDlg
    *  is done initializing and is now ready to let
    *  the user enter data.
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setFocus() {
   }

} /* PopUpDescript */
