package com.ibm.nzna.projects.qit.gui.popup ;
/*-----------------------------------------------------------*/
/*   PopUpEmail                                              */
/*                                                           */
/*   Description:                                            */
/*      Source code for: PopUpEmail                          */
/*                                                           */
/*                                                           */
/*         @Copyright  1998 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This popup holds the fields needed for a data object to support eMailing. 
 *
 *
 * @version 1.0, 3/8/1999 
 * @author  David Lentz
 */
import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.doc.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.util.* ;



/*-----------------------------------------------------------*/
/*                                                           */
/*   PopUpEmail                                              */
/*                                                           */
/*-----------------------------------------------------------*/
public class PopUpEmail extends PopUpPanel implements FocusListener, ActionListener, AppConst {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Controls                                                */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private JTextArea       mle_COMMENTS     = null ;
   private JScrollPane     scr_COMMENTS     = null ;
   private JTextArea       mle_DESCRIPT     = null ;
   private JCheckBox       ck_EMAILABLE     = null ;
   private DateEntryField  ef_EMAILABLEDATE = null ;
   private JLabel          st_EMAILABLEDATE = null ;
   private JTextArea       mle_DATEHELP     = null ;
   private JLabel          st_BODYHELP      = null ;
   private JTextArea       mle_DATEHELP2    = null ;
   private SpellCheckPanel pnl_SPELLCHECK   = null ;

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Vars                                                    */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private int                rowHeight = 18 ;
   private PublishingTagsRec  pubRec    = null ; 




   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This will create a blank eMail Pop Up
    *  
    *  
    *
    *  @param PopUpDlg The pop up dialog that this panel will be on
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public PopUpEmail ( PopUpDlg popUpDlg ) {
      super(popUpDlg) ;
      setLayout ( null ) ;

      /* Create the Swing Components we will use */
      mle_COMMENTS      = new JTextArea() ;
      mle_DESCRIPT      = new JTextArea() ;
      scr_COMMENTS      = new JScrollPane ( mle_COMMENTS ) ;
      ef_EMAILABLEDATE  = new DateEntryField () ; 
      st_EMAILABLEDATE  = new JLabel ( Str.getStr ( STR_EMAILABLE_DATE ) ) ;
      ck_EMAILABLE      = new JCheckBox ( Str.getStr ( STR_EMAILABLE ) ) ;
      mle_DATEHELP      = new JTextArea ( Str.getStr ( STR_EMAILABLE_DATEHELP1 ) ) ;
      mle_DATEHELP2     = new JTextArea ( Str.getStr ( STR_EMAILABLE_DATEHELP2 ) );
      st_BODYHELP       = new JLabel ( Str.getStr ( STR_EMAILABLE_BODY_HELP ) ) ;
      pnl_SPELLCHECK    = new SpellCheckPanel () ;

      /* Add our listeners  */
      ck_EMAILABLE.addActionListener ( this ) ;

      /* Add the controls */
      add ( mle_DATEHELP2 ) ;
      add ( ck_EMAILABLE ) ;
      add ( st_EMAILABLEDATE ) ;
      add ( ef_EMAILABLEDATE ) ;
      add ( mle_DATEHELP ) ;
      add ( scr_COMMENTS ) ;
      add ( st_BODYHELP ) ;
      add ( pnl_SPELLCHECK ) ;
      add ( mle_DESCRIPT ) ;

      pnl_SPELLCHECK.setTextComponent ( mle_COMMENTS ) ;

      /* Adjust some properties */
      mle_COMMENTS.setDocument ( new MaskDocument ( MaskDocument.MASKTYPE_UNKNOWN, 1024 ) ) ;
      WinUtil.setJTextAreaAsLabel ( mle_DESCRIPT ) ;
      WinUtil.setJTextAreaAsLabel ( mle_DATEHELP ) ;
      WinUtil.setJTextAreaAsLabel ( mle_DATEHELP2 ) ;
      mle_DESCRIPT.setFont  ( FontSystem.defaultFont ) ;
      mle_DATEHELP.setFont  ( FontSystem.defaultFont ) ;
      mle_DATEHELP2.setFont ( FontSystem.defaultFont ) ;

      mle_COMMENTS.setLineWrap ( true ) ;
      mle_COMMENTS.setWrapStyleWord ( true ) ;

      ef_EMAILABLEDATE.setEnabled ( false ) ;
      mle_COMMENTS.setEnabled ( false ) ;

      requireData = true ;
   }



   /*-----------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will be subclassed to size and
    *  position our controls
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size      = getSize();
      int       rowHeight = 18 ;
      int       y         = 0 ;

      super.doLayout() ;

      mle_DESCRIPT.setBounds ( 0, 0, size.width, rowHeight*2 ) ;
      y+=rowHeight*2-6 ;

      ck_EMAILABLE.setBounds ( 0, y, 100, rowHeight ) ;

      st_EMAILABLEDATE.setBounds ( 100, y, 100, rowHeight ) ;
      ef_EMAILABLEDATE.setBounds ( 200, y, 100, rowHeight ) ;
      y+=rowHeight ;                

      mle_DATEHELP.setBounds ( 0, y, size.width, rowHeight ) ;
      y+=rowHeight-2 ;

      mle_DATEHELP2.setBounds ( 0, y, size.width, rowHeight ) ;
      y+=rowHeight-2 ;

      st_BODYHELP.setBounds ( 0, y, size.width, rowHeight ) ;
      y+=rowHeight-2 ;

      pnl_SPELLCHECK.setBounds ( 0, y, pnl_SPELLCHECK.getPreferredSize().width, pnl_SPELLCHECK.getPreferredSize().height ) ;
      scr_COMMENTS.setBounds ( 0, y+pnl_SPELLCHECK.getPreferredSize().height, size.width, size.height-y-pnl_SPELLCHECK.getPreferredSize().height ) ; //size.width, size.height-y ) ;

   }


   /*-----------------------------------------------------------*/
   /* setDescript
    */
   /**
    *    We subclass this method to set our description
    *  
    *  
    *
    *  @param descript
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setDescript ( String descript ) {
      mle_DESCRIPT.setText ( descript ) ;
      doLayout() ;
   }



   /*-----------------------------------------------------------*/
   /* saveData
    */
   /**
    *    This method will determine if the user has
    *  entered the data needed to close the popup
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return The string entered if any
    *//*---------------------------------------------------------*/
   public Object saveData () {
      boolean rc = false ;
      String comments = mle_COMMENTS.getText() ;
      String date     = ef_EMAILABLEDATE.getText().trim() ;

      date = CDate.format4DigitYear ( date, CDate.DATE_DATE ) ;
      ef_EMAILABLEDATE.setText ( date ) ;

      /* Only worry about the date if this is eMailable. */
      if ( CDate.checkDate ( date, CDate.DATE_DATE ) == 0 ) {
         if ( !CDate.isFutureDate ( date, CDate.DATE_DATE ) ) {

            /* Only report the error if this is emailable */
            if ( ck_EMAILABLE.isSelected() )
               GUISystem.printBox ( Str.getStr ( STR_ERROR ), Str.getStr ( STR_EMAILDATE_IN_PAST ) ) ;
            else {
               date = null ;
               rc   = true ;
            }
         } else
            rc = true ;
      } else {
         /* Only report the error if this is emailable */
         if ( ck_EMAILABLE.isSelected() )
            GUISystem.printBox ( Str.getStr ( STR_ERROR ), Str.getStr ( STR_DATE_ENTERED_WRONG ) ) ;
         else {
            date = null ;
            rc = true ;
         }
      }


      if ( rc ) {
         if ( ( comments != null ) && ( comments.length() > 0 ) ) {
            pubRec.eMailable     = ck_EMAILABLE.isSelected() ;
            pubRec.eMailableDate = date ;
            pubRec.eMailComments = comments ;
         } else {

            /* If this is not emailable, don't ask for a comment field */
            if ( ck_EMAILABLE.isSelected() ) {
               GUISystem.printBox ( Str.getStr ( STR_ERROR ), Str.getStr ( STR_MUST_ENTER_EMAIL_COMMENTS ) ) ;
               rc = false ;
               pubRec.eMailComments = "" ;
            }
         }

      }

      if ( rc )
         return( pubRec ) ;
      else
         return( null ) ;
   }


   /*-----------------------------------------------------------*/
   /* refreshData
    */
   /**
    *    This method will refresh all of our data
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void refreshData ( Object dataObj ) {

      /* If the object is not null, just refresh our data  */
      if ( dataObj != null ) {
         if ( dataObj instanceof PublishingTagsRec ) {
            this.pubRec = (PublishingTagsRec) dataObj ;

            ck_EMAILABLE.setSelected ( pubRec.eMailable ) ;

            if ( pubRec.eMailable ) {
               ef_EMAILABLEDATE.setText ( pubRec.eMailableDate ) ;
               mle_COMMENTS.setText ( pubRec.eMailComments ) ;
               mle_COMMENTS.setEnabled ( true ) ;
               ef_EMAILABLEDATE.setEnabled ( true ) ;
            } else {
               ef_EMAILABLEDATE.setText( pubRec.eMailableDate ) ;
               mle_COMMENTS.setText( pubRec.eMailComments ) ;
               ef_EMAILABLEDATE.setEnabled ( false ) ;
               mle_COMMENTS.setEnabled ( false ) ;
            }

         }
      }

      /* Otherwise, create a new publication rec for our data  */
      else {
         pubRec = new PublishingTagsRec() ;

         ck_EMAILABLE.setSelected ( false ) ;
         ef_EMAILABLEDATE.setText( "" ) ;
         mle_COMMENTS.setText( "" ) ;
      }

   }




   /*-----------------------------------------------------------*/
   /* setFocus
    */
   /**
    *    This method will be called when the PopUpDlg
    *  is done initializing and is now ready to let
    *  the user enter data.
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setFocus() {
      if ( ck_EMAILABLE.isSelected() )
         ef_EMAILABLEDATE.requestFocus() ;
   }





   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will be called when our
    *  check box is selected or deselected
    *  
    *
    *  @param e The ActionEvent
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {
      if ( e.getSource() == ck_EMAILABLE ) {
         ef_EMAILABLEDATE.setEnabled ( ck_EMAILABLE.isSelected() ) ;
         mle_COMMENTS.setEnabled ( ck_EMAILABLE.isSelected() ) ;

         if ( ck_EMAILABLE.isSelected() )
            ef_EMAILABLEDATE.requestFocus() ;
      }
   }


   public void focusGained ( FocusEvent e ) {
   }




   /*------------------------------------------------------------*/
   /* focusLost
    */
   /**
    *    This method will be called when the
    *  entry field for the mail date loses focus. We
    *  will use this time to format the date correctly
    *
    *  @param e The event
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void focusLost ( FocusEvent e ) {
   }


} /* PopUpEmail */

