package com.ibm.nzna.projects.qit.gui.popup ;
/*-----------------------------------------------------------*/
/*   PopUpFileList                                           */
/*                                                           */
/*   Description:                                            */
/*      Source code for: PopUpFileList                       */
/*                                                           */
/*                                                           */
/*         @Copyright  1997 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.io.* ;
import java.awt.event.* ;
import java.awt.* ;
import java.util.* ;
import java.net.* ;
import javax.swing.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.qit.ftp.* ;
import com.ibm.nzna.projects.qit.ftp.* ;
import com.ibm.nzna.projects.qit.app.util.* ;
import com.ibm.nzna.projects.qit.doc.* ;
import com.ibm.nzna.projects.common.quest.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.ftp.FTP.* ;
/**
 * This panel holds an entry field and a description. 
 *
 *
 * @version 1.0, 6/28/1998 
 * @author  Chad Meadows
 *
 * @version 1.0.2, 5/4/1999
 * @author  David Lentz - Added new ftpRecStatus support
 * @author  David Lentz - Added new File Positioning capabilities.
 */


/*-----------------------------------------------------------*/
/*                                                           */
/*   PopUpFileList                                           */
/*                                                           */
/*-----------------------------------------------------------*/
public class PopUpFileList extends PopUpPanel implements PopUpConst, ActionListener, AppConst, PopUpListener {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Static                                                  */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private static final String THREAD_COPYFILETOTEMP="CFTP" ;

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Controls                                                */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private JLabel       st_DESCRIPT       = new JLabel ( "" ) ;
   private JList        lb_DATALIST       = new JList() ;
   private JScrollPane  scr_DATALIST      = new JScrollPane ( lb_DATALIST ) ;
   private DButton      pb_ADD            = new DButton ( Str.getStr ( STR_ADD ) ) ;
   private DButton      pb_REMOVE         = new DButton ( Str.getStr ( STR_REMOVE ) )  ;
   private DButton      pb_EDITFILE       = new DButton ( Str.getStr ( STR_EDIT_REFRESH ) ) ;
   private DButton      pb_DETACH         = new DButton ( Str.getStr ( STR_DETACH ) ) ;
   private DButton      pb_DETACHPUB      = new DButton ( Str.getStr ( STR_DETACH_PROD ) );
   private DButton      pb_DEASSOC        = new DButton ( Str.getStr ( STR_DEASSOCIATE ) ) ;
   private DButton      pb_UP             = new DButton ( "/\\" ) ;
   private DButton      pb_DOWN           = new DButton ( "\\/" ) ;

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Vars                                                    */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private int        rowHeight      = 18 ;
   private boolean    requireData    = false ;
   private DocFileRec fileRec        = null ;
   private Vector     retVec         = null ;
   private DocFileRec curFileRec     = null ;
   private boolean    onOddRow       = false ;
   private PopUpDlg   popUpDlg       = null ;
   private String     lastFileLoc    = null ;

   private static final int FIELD_DESCRIPT = 1 ;
   private static final int FIELD_VERSION  = 2 ;
   private static final int FIELD_LOCATION = 3 ;
   private static final int FIELD_URL      = 4 ;

   /*-----------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This will create a PopUpFileListPanel
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public PopUpFileList ( PopUpDlg popUpDlg ) {
      super(popUpDlg) ;
      setLayout ( null ) ;
      add ( st_DESCRIPT ) ;
      add ( scr_DATALIST ) ;
      add ( pb_ADD ) ;
      add ( pb_REMOVE ) ;
      add ( pb_EDITFILE ) ;
      add ( pb_DETACH ) ;
      add ( pb_DETACHPUB ) ;
      add ( pb_DEASSOC ) ;
      add ( pb_UP ) ;
      add ( pb_DOWN ) ;

      pb_UP.addActionListener ( this ) ;
      pb_DOWN.addActionListener ( this ) ;
      pb_ADD.addActionListener ( this ) ;
      pb_REMOVE.addActionListener ( this ) ;
      pb_EDITFILE.addActionListener ( this ) ;
      pb_DETACH.addActionListener ( this ) ;
      pb_DETACHPUB.addActionListener ( this ) ;
      pb_DEASSOC.addActionListener ( this ) ;
      //lb_DATALIST.addActionListener ( this ) ;

      lb_DATALIST.setCellRenderer ( new FileRecRenderer() ) ;
   }


   /*-----------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will be subclassed to size and
    *  position our controls
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size = getSize();
      int y = 0 ;

      super.doLayout() ;

      st_DESCRIPT.setBounds ( 0, y, size.width, rowHeight ) ;
      y += rowHeight ;

      scr_DATALIST.setBounds ( 0, y , size.width-50, size.height - 98 ) ;
      pb_UP.setBounds ( size.width-50, y, 45, 25 ) ;
      pb_DOWN.setBounds ( size.width-50, y+30, 45, 25 ) ;
      y += size.height - 98 + 5 ;

      pb_ADD.setBounds ( 0, y, 70, 25 ) ;
      pb_REMOVE.setBounds ( 75, y, 90, 25 ) ;
      pb_EDITFILE.setBounds ( 95+75, y, 130, 25 ) ;
      y+=27 ;

      pb_DETACH.setBounds ( 0, y, 90, 25 ) ;
      pb_DETACHPUB.setBounds ( 95, y, 135, 25 ) ;
      pb_DEASSOC.setBounds ( 235, y, 130, 25 ) ;


   }

   /*-----------------------------------------------------------*/
   /* buttonHit
    */
   /**
    *    This method responds to buttons being pressed
    *  
    *  
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {

      try {

         if ( e.getSource() instanceof DButton ) {
            DButton button = (DButton) e.getSource() ;

            if ( pb_ADD == button ) {
               if ( addFile() ) {
                  showWizard() ;
               }
            }

            else if ( pb_EDITFILE == button ) {
               curFileRec = (DocFileRec) lb_DATALIST.getSelectedValue() ;


               if ( curFileRec != null ) {
                  boolean cont = false ;

                  this.fileRec = curFileRec ;

                  if ( GUISystem.printBox ( STR_QUESTION, STR_DO_YOU_HAVE_A_NEWER_FILE ) )
                     cont = refreshNewFile() ;
                  else
                     cont = true ;

                  if ( cont ) {
                     //fileRec.updateRecStatus ( fileRec.REC_NOCHANGE ) ;
                     fileRec.updateRecStatus ( fileRec.REC_UPDATE ) ;
                     fileRec.setFTPRecStatus ( fileRec.REC_UPDATE ) ;
                     showWizard() ;
                  }
               } else
                  GUISystem.printBox ( Str.getStr ( STR_ERROR ), Str.getStr ( STR_MUST_SELECT_ITEM ) ) ;
            }

            else if ( pb_DETACH == button ) {
               DocFileRec selectedDocFileRec = ( DocFileRec )lb_DATALIST.getSelectedValue() ;

               if ( selectedDocFileRec != null ) {
                  File[]        files       = GUISystem.getFileOpen ( GUISystem.getParentDefWin ( this ) ,
                                                                      Str.getStr ( STR_DETACH ), 
                                                                      PropertySystem.getString ( PropertySystem.PROPERTY_DETACH_DIRECTORY ),
                                                                      Text.stripPath ( selectedDocFileRec.sFilename),
                                                                      false ) ;


                  if ( files != null ) {
                     String locFilename = null ;
                     String locDir      = null ;

                     /* Get where the user wants
                        to save the file  */
                     locFilename = files[0].getName() ;
                     locDir      = files[1].getAbsolutePath() ;

                     detachFile ( true, locFilename, locDir ) ;
                  }

               } else
                  GUISystem.printBox ( Str.getStr ( STR_ERROR ), Str.getStr ( STR_MUST_SELECT_ITEM ) ) ;
            }

            else if ( pb_REMOVE == button ) {
               DocFileRec selectedDocFileRec = ( DocFileRec )lb_DATALIST.getSelectedValue() ;

               if ( selectedDocFileRec != null ) {
                  selectedDocFileRec.updateRecStatus ( fileRec.REC_NOCHANGE ) ;
                  selectedDocFileRec.updateRecStatus ( fileRec.REC_DELETE ) ;
                  selectedDocFileRec.setFTPRecStatus ( fileRec.REC_DELETE  ) ;
                  refreshFileList() ;
               } else
                  GUISystem.printBox ( Str.getStr ( STR_ERROR ), Str.getStr ( STR_MUST_SELECT_ITEM ) ) ;
            }

            else if ( pb_DETACHPUB == button )
               detachFromPub() ;

            else if ( pb_DEASSOC == button ) {
               DocFileRec selectedDocFileRec = ( DocFileRec )lb_DATALIST.getSelectedValue() ;

               if ( selectedDocFileRec != null ) {
                  boolean rc = GUISystem.printBox ( STR_QUESTION, STR_ARE_YOU_SURE_DEASSOCIATE ) ;

                  if ( rc ) {
                     selectedDocFileRec.deAssociate() ;
                     refreshFileList() ;
                  }
               } else
                  GUISystem.printBox ( Str.getStr ( STR_ERROR ), Str.getStr ( STR_MUST_SELECT_ITEM ) ) ;

            }

            else if ( pb_UP == button ) {
               DocFileRec selectedDocFileRec = ( DocFileRec )lb_DATALIST.getSelectedValue() ;

               if ( selectedDocFileRec != null ) {
                  int index = lb_DATALIST.getSelectedIndex() ;

                  if ( index > 0 ) {
                     retVec.removeElement ( selectedDocFileRec ) ;
                     retVec.insertElementAt ( selectedDocFileRec, index-1 ) ;
                     //lb_DATALIST.removeAll() ;
                     //lb_DATALIST.setListData ( retVec ) ;
                     refreshFileList() ;
                  }
               }
            }

            else if ( pb_DOWN == button ) {
               DocFileRec selectedDocFileRec = ( DocFileRec )lb_DATALIST.getSelectedValue() ;

               if ( selectedDocFileRec != null ) {
                  int index = lb_DATALIST.getSelectedIndex() ;

                  if ( index < retVec.size() ) {
                     retVec.removeElement ( selectedDocFileRec ) ;
                     retVec.insertElementAt ( selectedDocFileRec, index+1 ) ;
                     //lb_DATALIST.removeAll() ;
                     //lb_DATALIST.setListData ( retVec ) ;
                     refreshFileList() ;
                  }
               }
            }
         }
      } catch ( Exception ex ) {
         LogSystem.log ( 1, ex ) ;
      }
   }

   /*-----------------------------------------------------------*/
   /* showWizard
    */
   /**
    *  
    *             
    *  @param 
    *  @param 
    *  @param 
    *
    *  @return 
    */
   public boolean showWizard () {
      popUpDlg = new PopUpDlg ( GUISystem.getParentDefWin ( this )  ) ;

      showPopUp ( FIELD_DESCRIPT, PopUpDlg.WIZARD ) ;
      return( true ) ;
   }

   /*-----------------------------------------------------------*/
   /* setDescript
    */
   /**
    *    We subclass this method to set our description
    *  
    *  
    *
    *  @param descript
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setDescript ( String descript ) {
      st_DESCRIPT.setText ( descript ) ;
   }

   /*-----------------------------------------------------------*/
   /* addFile
    */
   /**
    * adds a file to the media vector.   
    * queries the user for information about the file. 
    *  
    *
    *  @param descript
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean addFile () {
      boolean      gotFile  = false ;

      try {

         /* Open the file dialog and get the file the user selects */
         File[] openFile = GUISystem.getFileOpen ( GUISystem.getParentDefWin ( this ), 
                                                   Str.getStr ( STR_FILE_ATTACHMENT ), 
                                                   PropertySystem.getString ( PropertySystem.PROPERTY_IMPORT_DIRECTORY ) ) ;
         String       filename = null ;
         String       dir      = null ;

         setCursor ( Cursor.getPredefinedCursor ( Cursor.WAIT_CURSOR ) ) ;


         /* If the user picked a file from the dialog */
         if ( openFile != null ) {
            File sysFile = openFile[0] ;

            fileRec = new DocFileRec () ;
            fileRec.fileSize = (long)sysFile.length() ;
            fileRec.updateRecStatus ( fileRec.REC_NOCHANGE ) ;
            fileRec.updateRecStatus ( fileRec.REC_INSERT ) ;
            fileRec.sFilename = sysFile.getAbsolutePath() ;

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Make sure that the filename is good                     */                          
            /*                                                           */
            /*-----------------------------------------------------------*/
            if ( ( FileUtil.filenameFromPath ( fileRec.sFilename ).indexOf ( ")" ) >=0 ) ||
                 ( FileUtil.filenameFromPath ( fileRec.sFilename ).indexOf ( " " ) >=0 ) ||
                 ( FileUtil.filenameFromPath ( fileRec.sFilename ).indexOf ( "(" ) >=0 ) ||
                 ( FileUtil.filenameFromPath ( fileRec.sFilename ).indexOf ( "*" ) >=0 ) ||
                 ( FileUtil.filenameFromPath ( fileRec.sFilename ).indexOf ( "'" ) >=0 ) ||
                 ( FileUtil.filenameFromPath ( fileRec.sFilename ).indexOf ( "!" ) >=0 ) ||
                 ( FileUtil.filenameFromPath ( fileRec.sFilename ).indexOf ( "@" ) >=0 ) ||
                 ( FileUtil.filenameFromPath ( fileRec.sFilename ).indexOf ( "$" ) >=0 ) ||
                 ( FileUtil.filenameFromPath ( fileRec.sFilename ).indexOf ( "%" ) >=0 ) ||
                 ( FileUtil.filenameFromPath ( fileRec.sFilename ).indexOf ( "^" ) >=0 ) ||
                 ( FileUtil.filenameFromPath ( fileRec.sFilename ).indexOf ( "\"" ) >=0 ) )
               GUISystem.printBox ( STR_INFO, STR_INVALID_FILENAME ) ;
            else {
               
               
               PropertySystem.putString ( PropertySystem.PROPERTY_IMPORT_DIRECTORY,
                                          openFile[1].getAbsolutePath() ) ;

               /* This fixes a windows 2000 bug. Windows 2000 puts 2 back slashes in */
               fileRec.sFilename = Text.replaceAllStrInStr ( fileRec.sFilename, File.separator+File.separator, File.separator ) ;

               /* We must copy the file to the current temporary directory   */
               /* The file will then be ftp'ed from this directory to the    */
               /* FTP server when the document is saved.                     */
               LogSystem.log ( 1, "Copying File "+fileRec.sFilename+" To Temp Directory from "+openFile[1].getAbsolutePath() ) ;
               gotFile = copyFile() ;

               /* We must now let the FTP factory know that it will have
                  to insert this file up there! */
               if ( gotFile )
                  fileRec.setFTPRecStatus ( DocFileRec.REC_INSERT  ) ;
            }

         }

      } catch ( Exception e ) {
         LogSystem.log ( 1, e ) ;
      }
      setCursor ( Cursor.getPredefinedCursor ( Cursor.DEFAULT_CURSOR ) ) ;

      return( gotFile ) ;
   }


   /*-----------------------------------------------------------*/
   /* refreshNewFile
    */
   /**
    * copies a file to the temp directory 
    *  
    *
    *  @param descript
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean refreshNewFile () {
      boolean      gotFile  = false ;

      try {

         /* Open the file dialog and get the file the user selects */
         File[] openFile = GUISystem.getFileOpen ( GUISystem.getParentDefWin ( this ), 
                                                   Str.getStr ( STR_FILE_ATTACHMENT ), 
                                                   PropertySystem.getString ( PropertySystem.PROPERTY_IMPORT_DIRECTORY ) ) ;
         String       filename = null ;
         String       dir      = null ;

         setCursor ( Cursor.getPredefinedCursor ( Cursor.WAIT_CURSOR ) ) ;


         /* If the user picked a file from the dialog */
         if ( ( openFile != null ) && ( openFile[0] != null ) ) {
            File sysFile = openFile[0] ;        

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Save our property                                       */
            /*                                                           */
            /*-----------------------------------------------------------*/
            PropertySystem.putString ( PropertySystem.PROPERTY_IMPORT_DIRECTORY,
                                       openFile[1].getAbsolutePath() ) ;

            fileRec.sFilename = sysFile.getAbsolutePath() ;

            /* This fixes a windows 2000 bug. Windows 2000 puts 2 back slashes in */
            fileRec.sFilename = Text.replaceAllStrInStr ( fileRec.sFilename, File.separator+File.separator, File.separator ) ;

            /* We must copy the file to the current temporary directory   */
            /* The file will then be ftp'ed from this directory to the    */
            /* FTP server when the document is saved.                     */
            LogSystem.log ( 1, "Copying File "+fileRec.sFilename+" To Temp Directory from "+openFile[1].getAbsolutePath() ) ;
            gotFile = QuestUtil.copyFileToTempDir ( fileRec.sFilename ) ;

            /* We must now let the FTP factory know that it will have
               to insert this file up there! */
            if ( gotFile )
               fileRec.setFTPRecStatus ( DocFileRec.REC_UPDATE  ) ;
            else
               GUISystem.printBox ( Str.getStr ( STR_INFO ), "Cannot copy file to temp. directory" ) ;

         }

      } catch ( Exception e ) {
         LogSystem.log ( 1, e ) ;
      }
      setCursor ( Cursor.getPredefinedCursor ( Cursor.DEFAULT_CURSOR ) ) ;

      return( gotFile ) ;
   }

   /*-----------------------------------------------------------*/
   /* popupAction
    */
   /**
    *    This method will respond to pop up dialogs
    *  being closed
    *  
    *             
    *  @param 
    *  @param 
    *  @param 
    *
    *  @return 
    */
   public void popupAction ( int id, PopUpDlg popUpDlg, int action, Object data ) {
      switch ( action ) {
         case PopUpDlg.PB_NEXT :
         case PopUpDlg.PB_OK :

            if ( data != null ) {
               savePopUpData ( id, data ) ;
               if ( id == FIELD_DESCRIPT )
                  showPopUp ( FIELD_VERSION, WIZARD ) ;
               else if ( id == FIELD_VERSION ) {
                  showPopUp ( FIELD_LOCATION, WIZARD ) ;
               } else if ( id == FIELD_LOCATION ) {
                  showPopUp ( FIELD_URL, WIZARD ) ;
               }
            }
            break ;

         case PopUpDlg.PB_BACK :
            if ( id == FIELD_VERSION )
               showPopUp ( FIELD_DESCRIPT, WIZARD ) ;
            else if ( id == FIELD_LOCATION ) {
               showPopUp ( FIELD_VERSION, WIZARD ) ;
            } else if ( id == FIELD_URL ) {
               showPopUp ( FIELD_LOCATION, WIZARD ) ;
            }

            break ;

         case PopUpDlg.PB_CANCEL :
            /* Otherwise, they cancelled the wizard, so all changes must revert back to the
               original. If this is a new record, we must go back to the ProdMaintPanel */
            break ;

         case PopUpDlg.PB_FINISH :

            /* This will be processing the finish button */
            if ( id == FIELD_URL ) {


               savePopUpData ( id, data ) ;

               /* If the file rec's status was an insert, add it to our vector  */
               if ( fileRec.getRecStatus() == fileRec.REC_INSERT ) {
                  if ( !retVec.contains ( fileRec ) )
                     retVec.addElement ( fileRec ) ;
               }

               refreshFileList() ;
               lastFileLoc = fileRec.fileLoc ;


            }
            break ;
      }
   }


   /*-----------------------------------------------------------*/
   /* showPopUp
    */
   /**
    *    This method will bring up the correct pop up
    *  for the field passed.
    *  
    *             
    *  @param fieldId The Id of the field to show ( FIELD_PRODNUM etc... )
    *  @param popUpType The Type of Pop Up. POPUP, or PopUpDlg.WIZARD
    *  @param 
    *
    *  @return 
    */
   void showPopUp ( int fieldId, int popUpType ) {

      /* If we are on the last panel to show, turn on the finish button,
         and turn the next button off */
      if ( fieldId == FIELD_VERSION ) {
         popUpDlg.showNextButton   ( true ) ;
         popUpDlg.showBackButton ( true ) ;
         popUpDlg.showFinishButton ( false ) ;
      } /* if we are not on the last panel */

      /* If we are on the first panel, turn off the back button
         and the finish button, then turn on the next button */
      else if ( fieldId == FIELD_DESCRIPT ) {
         popUpDlg.showBackButton ( false ) ;
         popUpDlg.showFinishButton ( false ) ;
         popUpDlg.showNextButton ( true ) ;
      }

      /* Otherwise, show the next and back button, but not the finish button */
      else if ( fieldId == FIELD_URL ) {
         popUpDlg.showBackButton ( true ) ;
         popUpDlg.showNextButton ( false ) ;
         popUpDlg.showFinishButton ( true ) ;
      } else {
         popUpDlg.showBackButton ( true ) ;
         popUpDlg.showNextButton ( true ) ;
         popUpDlg.showFinishButton ( false ) ;
      }

      switch ( fieldId ) {
         case FIELD_DESCRIPT:
            PopUpMLE   popupDescript = (PopUpMLE) popUpDlg.refreshPopUp ( fieldId, POPUP_MLE, fileRec.descript, popUpType,  fileRec.sFilename, Str.getStr ( STR_DESCRIPTION ), this ) ;

            popupDescript.setRequired ( true ) ;
            popupDescript.setMaximumLength ( LENGTH_FILEGENINFO ) ;
            popupDescript.refreshData ( fileRec.descript ) ;
            popupDescript.setRequired ( true ) ;
            break ;

         case FIELD_VERSION :                                                                                                                              
            PopUpEntryField popupVersion = (PopUpEntryField) popUpDlg.refreshPopUp ( fieldId, POPUP_ENTRYFIELD, fileRec.version, popUpType,  fileRec.sFilename, Str.getStr ( STR_VERSION ), this ) ; 
            popupVersion.setMaximumLength ( LENGTH_FILEVERSION ) ;
            popupVersion.refreshData ( fileRec.version ) ;
            popupVersion.setRequired ( true ) ;
            break ;

         case FIELD_LOCATION :
            PopUpList popupList = (PopUpList) popUpDlg.refreshPopUp ( fieldId, POPUP_LIST, fileRec.locations , popUpType,  fileRec.sFilename, Str.getStr ( STR_SELECT_LOCATION ) , this ) ;

            if ( ( fileRec.fileLoc != null ) && ( fileRec.fileLoc.length() > 0 ) )
               popupList.setSelection ( fileRec.fileLoc ) ;
            else if ( lastFileLoc != null )
               popupList.setSelection ( lastFileLoc ) ;

            popupList.setRequired ( true ) ;
            break ;

         case FIELD_URL : {
               String fileURL = Constants.getStrConst( "IT_FILEURL" ) ;
               PopUpEntryField popupURL = (PopUpEntryField) popUpDlg.refreshPopUp ( fieldId, POPUP_ENTRYFIELD, fileRec.fileURL, popUpType, fileRec.sFilename, Str.getStr ( STR_URL ), this ) ; 

               if ( fileURL != null ) {

                  /*-----------------------------------------------------------*/
                  /*                                                           */
                  /*   If this is not a private dir. Just append the dir.      */
                  /*                                                           */
                  /*-----------------------------------------------------------*/
                  if ( fileRec.fileLoc.indexOf ( "private" ) == -1 )
                     fileURL = fileURL +"/pub/pccbbs/"+fileRec.fileLoc +"/"+ Text.stripPath( fileRec.sFilename );

                  /*-----------------------------------------------------------*/
                  /*                                                           */
                  /*   Otherwise, prepend the user id/passw, then the dir.     */
                  /*                                                           */
                  /*-----------------------------------------------------------*/
                  else {

                     if ( fileRec.fileLoc.indexOf ( "ate/thinkpad" ) >=0 )
                        fileURL = "ftp://thinkpad:ftp4tpad@ftp.pc.ibm.com/pub/"+fileRec.fileLoc +"/"+ Text.stripPath( fileRec.sFilename );
                     else if ( fileRec.fileLoc.indexOf ( "ate/network" ) >=0 )
                        fileURL = "ftp://network:n3tw0rk@ftp.pc.ibm.com/pub/"+fileRec.fileLoc +"/"+ Text.stripPath( fileRec.sFilename );
                     else if ( fileRec.fileLoc.indexOf ( "ate/options" ) >=0 )
                        fileURL = "ftp://options:opt10ns@ftp.pc.ibm.com/pub/"+fileRec.fileLoc +"/"+ Text.stripPath( fileRec.sFilename );
                     else
                        fileURL = fileURL +"/pub/"+fileRec.fileLoc +"/"+ Text.stripPath( fileRec.sFilename );
                  }
               }


               popupURL.setRequired ( true ) ;
               popupURL.setMaximumLength ( LENGTH_FILEURL ) ;
               popupURL.refreshData ( fileURL ) ;

            }
            break ;
      }

   } /* showPopUp */

   /*-----------------------------------------------------------*/
   /* savePopUpData
    */
   /**
    *    This method will take the data that a pop up
    *  has collected, and save it to our record.
    *  
    *
    *  @param id The ID of the FIELD
    *  @param Data The Data that was saved
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void savePopUpData ( int id, Object data ) {

      /* Set our rec status */
      //docRec.updateRecStatus ( Rec_UPDATE ) ;
      /* switch on the field id */
      switch ( id ) {
         case FIELD_DESCRIPT:
            fileRec.descript = (String) data ;
            break ;
         case FIELD_VERSION:
            fileRec.version = (String) data ;
            break ;
         case FIELD_LOCATION:
            fileRec.fileLoc = (String) data ;
            break ;
         case FIELD_URL:
            fileRec.fileURL = (String) data ;
            break ;
      }
   }

   /*-----------------------------------------------------------*/
   /* saveData
    */
   /**
    *    This method will determine if the user has
    *  entered the data needed to close the popup
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return The string entered if any
    *//*---------------------------------------------------------*/
   public Object saveData () {
      return( retVec ) ;

   }

   /*-----------------------------------------------------------*/
   /* refreshData
    */
   /**
    *    This method will refresh all of our data
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void refreshData ( Object dataObj ) {
      boolean useDefaultVec = true ;

      try {
         if ( dataObj != null ) {
            if ( dataObj instanceof Vector ) {
               Vector mediaVec = (Vector) dataObj ;

               if ( ( mediaVec != null ) && ( mediaVec.size() > 0 ) ) {
                  int i      = 0 ;
                  int length = mediaVec.size() ;

                  retVec = new Vector ( length ) ;

                  while ( i < length )
                     retVec.addElement ( ((DocFileRec)mediaVec.elementAt(i++)).clone() ) ;

                  useDefaultVec = false ;
               }
            }
         }
      } catch ( Exception e ) {
         LogSystem.log ( 1, e ) ;
      }


      if ( useDefaultVec )
         retVec = new Vector ( 5, 1) ;

      refreshFileList() ;
   }




   /*-----------------------------------------------------------*/
   /* setFocus
    */
   /**
    *    This method will be called when the PopUpDlg
    *  is done initializing and is now ready to let
    *  the user enter data.
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setFocus() {
      lb_DATALIST.requestFocus() ;
   }



   /*-----------------------------------------------------------*/
   /* setSelection
    */
   /**
    *    This method will set what is currently selected
    *  
    *  
    *
    *  @param data The object to be selected
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setSelection ( Object data ) {
   }

   /*-----------------------------------------------------------*/
   /* setSelection
    */
   /**
    *    This method will set what is currently selected
    *  
    *  
    *
    *  @param data The object to be selected
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setSelection ( Vector data ) {
      if ( data != null ) {
         //for ( int dataIndex = 0 ; dataIndex < data.size() ; dataIndex++ ) {
         //   lb_DATALIST.setSelected ( data.elementAt( dataIndex ) , true ) ;
         //}
      }
   }

   /*-----------------------------------------------------------*/
   /* setReadOnly
    */
   /**
    *    This method will change this pop up to be
    *  read only
    *  
    *             
    *  @param readOnly TRUE = make read only, false Make no read only
    *  @param 
    *  @param 
    *
    *  @return 
    */
   public void setReadOnly ( boolean readOnly ) {
      super.setReadOnly ( readOnly ) ;
      pb_ADD.setEnabled ( !readOnly ) ;
      pb_REMOVE.setEnabled ( !readOnly ) ;
      pb_EDITFILE.setEnabled ( !readOnly ) ;
   }




   /*------------------------------------------------------------*/
   /* copyFile
    */
   /**
    *    This method will copy a file from the source to the
    *  temporary directory. It will put up the animation to
    *  show that it is working
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private boolean copyFile () {
      boolean      rc         = false ;

      try {
         String tempDir = PropertySystem.getString ( PropertySystem.PROPERTY_TEMP_DIR ) ;

         GUISystem.getParentDefWin(this).setStatus  ( STR_COPY_FILE_TO_TEMP ) ;

         /* Copy the file */
         if ( QuestUtil.copyFileToTempDir ( fileRec.sFilename,
                                            Text.stripPath ( fileRec.sFilename ).toLowerCase() ) ) {

            /* Rename the file in the file record so that it is pulled from the
               temp directory */
            fileRec.sFilename = tempDir+File.separator+Text.stripPath ( fileRec.sFilename ).toLowerCase() ;

            rc = true ;
         }
      } catch ( Exception e ) {
         LogSystem.log ( 1, e ) ;
      }

      GUISystem.getParentDefWin(this).setStatus ( null ) ;

      return( rc ) ;
   }



   /*------------------------------------------------------------*/
   /* detachFile
    */
   /**
    *    This method will detach the selected file
    *  from the FTP Server. It will first try to detach the
    *  file from the Temp FTP Server. If that can not be done,
    *  it will try to detach the file from the production ftp
    *  server.
    *
    *  @param useTempServer TRUE = get file from temp FTP Server
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void detachFile ( boolean useTempServer, String locFilename, String locDir ) {
      DocFileRec detachDocFileRec = (DocFileRec) lb_DATALIST.getSelectedValue() ;
      String        ftpDir           = null ;
      String        ftpHost          = null ;
      String        ftpUser          = null ;
      String        ftpPassword      = null ;
      AppDefaultWin parentWin        = GUISystem.getParentDefWin ( this ) ;

      setEnabled ( false ) ;
      try {

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   If we have a valid record, continue                     */
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( detachDocFileRec != null ) {

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   If we have a valid Filename and Directory to save to    */
            /*                                                           */
            /*-----------------------------------------------------------*/
            if ( ( locFilename != null ) &&
                 ( locDir      != null ) ) {
               Ftp ftp = new Ftp () ;                                 

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   Set up our host name, user id and location              */
               /*                                                           */
               /*-----------------------------------------------------------*/
               if ( useTempServer ) {
                  ftpDir      = Constants.getStrConst ( "IT_FILELOCTEMP" ) ;
                  ftpHost     = Constants.getStrConst ( "IT_FILEHOSTTEMP" ) ;
                  ftpUser     = FTP_USERID ;
                  ftpPassword = FTP_PASSWORD ;
               } else {
                  ftpDir      = "/home/ftp/pub/pccbbs/"+detachDocFileRec.fileLoc ; //Constants.getStrConst ( "IT_FILELOC" ) ;
                  ftpHost     = Constants.getStrConst ( "IT_FILEHOST" ) ;
                  ftpUser     = FTP_USERID_PRODUCTION ;
                  ftpPassword = FTP_PASSWORD_PRODUCTION ;
               }

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   Add the path separator if we don't already have it      */                                         
               /*                                                           */
               /*-----------------------------------------------------------*/
               if ( !locDir.endsWith ( File.separator ) )
                  locDir+=File.separator ;

               try {


                  /*-----------------------------------------------------------*/
                  /*                                                           */
                  /*   Connect                                                 */
                  /*                                                           */
                  /*-----------------------------------------------------------*/
                  parentWin.setStatus ( Str.getStr ( STR_CONNECTING ) ) ;
                  LogSystem.log ( 1, "Logging into FTP Site:" ) ;
                  LogSystem.log ( 1, "   Host:"+ftpHost ) ;
                  LogSystem.log ( 1, "   Host Directory:"+ftpDir ) ;
                  LogSystem.log ( 1, "   Local Directory:"+locDir ) ; 
                  LogSystem.log ( 1, "   Filename:"+detachDocFileRec.sFilename ) ;
                  ftp.setHost ( ftpHost ) ;
                  ftp.setUser ( ftpUser ) ;
                  ftp.setPassword ( ftpPassword ) ;
                  ftp.connect() ; 

                  /*-----------------------------------------------------------*/
                  /*                                                           */
                  /*   Login                                                   */
                  /*                                                           */
                  /*-----------------------------------------------------------*/
                  parentWin.setStatus ( STR_DOWNLOADING ) ;
                  ftp.login() ;         

                  /*-----------------------------------------------------------*/
                  /*                                                           */
                  /*   Set the image type                                      */
                  /*                                                           */
                  /*-----------------------------------------------------------*/
                  if ( locFilename.toUpperCase().endsWith ( ".TXT" ) )
                     ftp.setType ( Ftp.ASCII )  ;
                  else
                     ftp.setType ( Ftp.IMAGE )  ;




                  /*-----------------------------------------------------------*/
                  /*                                                           */
                  /*   Change Directories                                      */
                  /*                                                           */
                  /*-----------------------------------------------------------*/
                  ftp.cd ( ftpDir ) ;
                  LogSystem.log ( 1, "Changed Directory To:"+ftpDir ) ;   

                  /*-----------------------------------------------------------*/
                  /*                                                           */
                  /*   Get the file                                            */
                  /*                                                           */
                  /*-----------------------------------------------------------*/
                  ftp.get ( detachDocFileRec.sFilename, locDir+locFilename ) ;

                  ftp.disconnect() ;
                  GUISystem.printBox ( STR_INFO, STR_COMPLETE ) ;
                  ftp = null ;
                  System.gc() ;

               } catch ( Exception e ) {
                  if ( useTempServer ) {
                     ftp.disconnect() ;
                     ftp = null ;
                     detachFile ( false, locFilename, locDir ) ;
                  } else
                     GUISystem.printBox ( STR_INFO, STR_ERROR_IN_LAST_ACTION ) ;

                  LogSystem.log ( 1, e, false ) ;
               }

            }

         } else
            GUISystem.printBox ( Str.getStr ( STR_ERROR ), Str.getStr ( STR_MUST_SELECT_ITEM ) ) ;

      } catch ( Exception e ) {
         LogSystem.log ( 1, e ) ;
         GUISystem.printBox ( Str.getStr ( STR_INFO ), Str.getStr ( STR_DETACH_FAILED ) ) ;
      }

      parentWin.setStatus ( null ) ;
      setEnabled ( true ) ;
   }





   /*------------------------------------------------------------*/
   /* detachFromPub
    */
   /**
    *    This method will detach the selected file
    *  from the production ftp sites
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void detachFromPub () {
      DocFileRec detachDocFileRec = (DocFileRec) lb_DATALIST.getSelectedValue() ;

      setEnabled ( false ) ;

      try {
         if ( detachDocFileRec != null ) {
            URL     url  = new URL ( detachDocFileRec.fileURL ) ;
            boolean cont = GUISystem.printBox ( STR_QUESTION, STR_ARE_YOU_SURE_DETACH_PUB ) ;

            if ( ( detachDocFileRec.fileLoc == null ) || ( detachDocFileRec.fileLoc.length() < 1 ) )
               detachDocFileRec.fileLoc = url.getFile().substring ( 0, url.getFile().lastIndexOf ( "/" ) ) ;

            if ( cont )
               downloadFile ( "/home/ftp/pub/pccbbs/"+detachDocFileRec.fileLoc, detachDocFileRec.sFilename ) ;

         } else
            GUISystem.printBox ( STR_INFO, STR_MUST_SELECT_ITEM ) ;
      } catch ( Exception e ) {
         LogSystem.log ( 1, e );
      }

      setEnabled ( true ) ;
   }





   /*------------------------------------------------------------*/
   /* downloadFile
    */
   /**
    *    This method will download a file from the 
    *  production FTP Server
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void downloadFile ( String siteDir, String localFile ) {
      boolean          cont           = false ;
      File             file           = null ;
      FileOutputStream out            = null ;
      InputStream      in             = null ;
      int              readByteLength = 1024 ; // The number of byte to read at a time
      int              fileLength     = 0 ;
      FTPSite          ftpSite        = null ;
      String           strFtpSite     = Constants.getStrConst ( "IT_PRODFTP" ) ;
      String           localDir       = PropertySystem.getString ( PropertySystem.PROPERTY_TEMP_DIR ) ;



      try {

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Open the FTP Site                                       */
         /*                                                           */
         /*-----------------------------------------------------------*/
         ftpSite = new FTPSite ( strFtpSite,
                                 FTP_USERID_PRODUCTION,
                                 localDir,
                                 siteDir,
                                 FTP_PASSWORD_PRODUCTION ) ;
         if ( ftpSite.connect() ) {
            LogSystem.log ( 1, "Connecting to:"+strFtpSite ) ;


            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Log in                                                  */
            /*                                                           */
            /*-----------------------------------------------------------*/
            if ( ftpSite.login() ) {

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   Get the File                                            */
               /*                                                           */
               /*-----------------------------------------------------------*/
               cont = ftpSite.setLocalDir ( localDir ) ;
               LogSystem.log ( 1, "Setting Local Directory to:"+localDir+"   rc:"+cont ) ;

               if ( cont )
                  cont = ftpSite.setRemoteDir ( siteDir ) ;

               LogSystem.log ( 1, "Setting Local Directory to:"+siteDir+"   rc:"+cont ) ;

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   If anything but .txt, set to binary                     */
               /*                                                           */
               /*-----------------------------------------------------------*/
               if ( localFile.toUpperCase().endsWith ( ".TXT" ) )
                  ftpSite.setAscii() ;
               else
                  ftpSite.setBinary() ;

               if ( cont ) {
                  LogSystem.log ( 1, "   Getting file:"+localFile ) ;
                  cont = ftpSite.get ( Text.stripPath ( localFile ) ) ;
                  LogSystem.log ( 1, "   Done Get. rc:"+cont ) ;
               }

               ftpSite.disconnect() ;

               if ( cont )
                  GUISystem.printBox ( STR_INFO, STR_COMPLETE ) ;
               else
                  GUISystem.printBox ( STR_ERROR, STR_DOWNLOAD_NOT_COMPLETE ) ;
            } /* Logging in */
         } /* connect */
      } catch ( Exception e ) {
         LogSystem.log ( 1, e ) ;
      }

      GUISystem.getParentDefWin ( this ).setStatus ( null ) ;
   }





   /*------------------------------------------------------------*/
   /* refreshFileList
    */
   /**
    *    This method will refresh our list with all of
    *  the files that are supposed to be in the list
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void refreshFileList() {

      if ( retVec != null ) {
         Vector  vec  = new Vector ( 10 ) ;
         DocFileRec rec  = null ;
         boolean onOddRow = true ;
         int     i        = 0 ;
         int     length   = retVec.size() ;

         while ( i < length ) {
            rec = (DocFileRec) retVec.elementAt(i) ;
            onOddRow = rec.onOddRow = !onOddRow ;

            if ( ( rec != null ) && 
                 ( rec.getRecStatus() != rec.REC_DELETE ) &&
                 ( rec.getRecStatus() != rec.REC_NOINSERT ) )
               vec.addElement ( rec ) ;
            i++ ;
         }

         lb_DATALIST.setListData ( vec ) ;
      }
   }





   /*------------------------------------------------------------*/
   /* hiding
    */
   /**
    *    This method will be called when our window
    *  is hiding
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void hiding () {
      fileRec        = null ;
      curFileRec     = null ;
   }





   /*------------------------------------------------------------*/
   /* setEnabled
    */
   /**
    *    This method will either enable or disable
    *  the controls on this window
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setEnabled ( boolean enabled ) {
      pb_ADD.setEnabled ( enabled ) ;
      pb_REMOVE.setEnabled ( enabled ) ;
      pb_EDITFILE.setEnabled ( enabled ) ;
      pb_DETACH.setEnabled ( enabled ) ;
      pb_DETACHPUB.setEnabled ( enabled ) ;
      pb_DEASSOC.setEnabled ( enabled ) ;
      if ( popUpDlg != null )
         popUpDlg.setEnabled ( enabled ) ;
   }


} /* PopUpFileList */

