package com.ibm.nzna.projects.qit.gui.popup ;
/*-----------------------------------------------------------*/
/*   PopUpLocation                                           */
/*                                                           */
/*   Description:                                            */
/*      Source code for: PopLocation                         */
/*                                                           */
/*                                                           */
/*         @Copyright  1997 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.event.* ;
import java.awt.* ;
import javax.swing.* ;
import java.util.*;
import javax.swing.event.*;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.qit.doc.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.quest.status.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.qit.product.*;
import com.ibm.nzna.projects.common.quest.*;
import com.ibm.nzna.shared.gui.*;
import com.ibm.nzna.projects.qit.dbgui.*;
/**
 * This panel holds an Locale Object for a product. 
 *
 *
 * @version 1.0, 6/28/1998 
 * @author  Jag.
 */


/*-----------------------------------------------------------*/
/*                                                           */
/*   PopUpLocation                                             */
/*                                                           */
/*-----------------------------------------------------------*/
public class PopUpLocation extends PopUpPanel implements ProductConst, AppConst, ActionListener,LocaleDlgListener,ListSelectionListener {

    /*-----------------------------------------------------------*/
    /*                                                           */
    /*   Controls                                                */
    /*                                                           */
    /*-----------------------------------------------------------*/
    private JLabel       st_DESCRIPT       = new JLabel ( Str.getStr ( STR_PLEASE_SELECT_LOCATION ) ) ;
    private JList        results           = new JList() ;
    private JScrollPane  j_SCROLL_PANE     = new JScrollPane(results);
    private DButton      add               = new DButton(Str.getStr(STR_ADD));
    private DButton      remove            = new DButton(Str.getStr(STR_REMOVE));
    private DButton      worldWide         = new DButton(Str.getStr(STR_WORLDWIDE));
    com.ibm.nzna.projects.common.quest.LocaleRec localeRec=null;
    /*-----------------------------------------------------------*/
    /*                                                           */
    /*   Vars                                                    */
    /*                                                           */
    /*-----------------------------------------------------------*/
    private int       rowHeight = GUISystem.getRowHeight() ;


    /*-----------------------------------------------------------*/
    /* Constructor
     */
    /**
     *    This will create a PopUpLocation
     *  
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public PopUpLocation ( PopUpDlg popUpDlg ) {
        super(popUpDlg) ;
        setLayout ( null ) ;
        requireData=true;
        results.setModel(new DefaultListModel());
        remove.setEnabled(false);
        add(st_DESCRIPT);
        add(add);
        add(remove);
        add(worldWide);
        add(j_SCROLL_PANE);
        add.addActionListener(this);
        remove.addActionListener(this);
        worldWide.addActionListener(this);
        results.addListSelectionListener(this);

    }                            

    /*-----------------------------------------------------------*/
    /* doLayout
     */
    /**
     *    This method will be subclassed to size and
     *  position our controls
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void doLayout () {
        Dimension size = getSize();
        int       y    = 0 ;

        super.doLayout() ;

        st_DESCRIPT.setBounds ( 140, 0, size.width, rowHeight ) ;
        y+=rowHeight+2 ;

        j_SCROLL_PANE.setBounds ( 60, y, 300, rowHeight*6 ) ;
        y+=rowHeight+100 ;

        add.setBounds ( 90, y, 70, rowHeight ) ;


        remove.setBounds ( 170, y, 70, rowHeight ) ;


        worldWide.setBounds ( 250, y,70 , rowHeight ) ;



    }



    /*-----------------------------------------------------------*/
    /* setDescript
     */
    /**
     *    We subclass this method to set our description
     *  
     *  
     *
     *  @param descript
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void setDescript ( String descript ) {
    }



    /*-----------------------------------------------------------*/
    /* saveData
     */
    /**
     *    This method will determine if the user has
     *  entered the data needed to close the popup
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return The string entered if any
     *//*---------------------------------------------------------*/
    public Object saveData() {
       Object retRec = null ;

       if ( requireData ) {
          if ( ( localeRec.isWorldWide() == false ) &&
               ( localeRec.countryCount() == 0 ) )
             GUISystem.printBox ( Str.getStr ( STR_ERROR ), Str.getStr ( STR_MUST_SELECT_ITEM ) ) ;
          else {
             retRec = localeRec ;
          }
       }

       return( retRec ) ;
    }

    /*-----------------------------------------------------------*/
    /* refreshData
     */
    /**
     *    This method will refresh all of our data
     *  
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void refreshData ( Object dataObj ) {
        if(dataObj instanceof com.ibm.nzna.projects.common.quest.LocaleRec){
            com.ibm.nzna.projects.common.quest.LocaleRec localeRec=(com.ibm.nzna.projects.common.quest.LocaleRec)dataObj;
            setDefaults(localeRec);
        }

    }




    private void setDefaults(com.ibm.nzna.projects.common.quest.LocaleRec localeRec) {
        this.localeRec=localeRec;
    }

    public void actionPerformed ( ActionEvent e ) {
        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   The 'Select' Push Button                                */
        /*                                                           */
        /*-----------------------------------------------------------*/
        if ( e.getSource() == add ) {
           LocaleDlg dlg = new LocaleDlg ( GUISystem.getParentDefWin ( this ) ) ;

           dlg.setLocaleDlgListener ( this ) ;
           dlg.waitForUser() ;
        }


        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   The 'Remove' Push Button                                */
        /*                                                           */
        /*-----------------------------------------------------------*/
        else if ( e.getSource() == remove ) {
           removeItem() ;
        }

        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   World Wide                                              */
        /*                                                           */
        /*-----------------------------------------------------------*/
        else if ( e.getSource () == worldWide ) {

           /*-----------------------------------------------------------*/
           /*                                                           */
           /*   If we do not have a LocaleRec yet, create one           */
           /*                                                           */
           /*-----------------------------------------------------------*/
           if ( localeRec == null ) {
              localeRec = new com.ibm.nzna.projects.common.quest.LocaleRec () ;
           }

           /*-----------------------------------------------------------*/
           /*                                                           */
           /*   Set world wide                                          */
           /*                                                           */
           /*-----------------------------------------------------------*/
           localeRec.setWorldWide ( true ) ;
           populateList ( localeRec ) ;


        }
    }
    

   /**
     *  This method will be called when a selection is changed in the
     * list of countries/geos
     **/
   public void valueChanged ( ListSelectionEvent e ) {
      if ( isEnabled() )
         remove.setEnabled ( results.getSelectedValue() != null ) ;
   }



    /**
      *  This method will be called when a country list is selected by the user
      * in the LocaleDlg pop up
      *
      * @param The countries
      **/
    public void localeDlgAddCountries ( Object[] countries ) {
       try {

          /*-----------------------------------------------------------*/
          /*                                                           */
          /*   If we do not have a LocaleRec yet, create one           */
          /*                                                           */
          /*-----------------------------------------------------------*/
          if ( localeRec == null ) {
             localeRec = new com.ibm.nzna.projects.common.quest.LocaleRec () ;
          }

          /*-----------------------------------------------------------*/
          /*                                                           */
          /*   Add all of the selected countries                       */
          /*                                                           */
          /*-----------------------------------------------------------*/
          for ( int i = 0; i < countries.length; i++ )
             localeRec.addCountry ( (TypeCountryCodeRec)countries[i] ) ;       

          /*-----------------------------------------------------------*/
          /*                                                           */
          /*   Refresh our data                                        */
          /*                                                           */
          /*-----------------------------------------------------------*/
          populateList ( localeRec ) ;
       } catch ( Exception e ) {
          LogSystem.log ( 1, e, false ) ;
       }
    }

    /**
      *  This method will be called when a geography is selected by the user in
      * the LocaleDlg pop up
      * 
      * @param The geography
      **/
    public void localeDlgAddGeo ( TypeGeoRec geoRec ) {
       try {
          /*-----------------------------------------------------------*/
          /*                                                           */
          /*   If we do not have a LocaleRec yet, create one           */
          /*                                                           */
          /*-----------------------------------------------------------*/
          if ( localeRec == null ) {
             localeRec = new com.ibm.nzna.projects.common.quest.LocaleRec () ;
          }

          /*-----------------------------------------------------------*/
          /*                                                           */
          /*   Add the geography and refresh                           */
          /*                                                           */
          /*-----------------------------------------------------------*/
          localeRec.addGeography ( geoRec ) ;
          populateList ( localeRec ) ;

       } catch ( Exception e ) {
          LogSystem.log ( 1, e, false ) ;
       }
    }

    /* This method will allow user to set Multiselect for List.*/

    public void setMultiSelect ( boolean allowMulti ) {
        if ( allowMulti )
            results.setSelectionMode ( ListSelectionModel.MULTIPLE_INTERVAL_SELECTION ) ;
        else
            results.setSelectionMode ( ListSelectionModel.SINGLE_SELECTION ) ;
    }

    /*-----------------------------------------------------------*/
    /* setRequired
     */
    /**
     *    This method will tell the entry field to either
     *  require data or not
     *  
     *
     *  @param requireData = TRUE if we should not close until data is entered
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void setRequired ( boolean requireData ) {
        this.requireData = requireData ;
    }


    /* This method will remove all items from the list*/

    private void removeItem () {
        Object[]  items     = results.getSelectedValues() ;

        if ( ( items != null ) && ( items.length > 0 ) && ( localeRec != null ) ) {

            for ( int i = 0; i < items.length; i++ ) {

                /*-----------------------------------------------------------*/
                /*                                                           */
                /*   Remove the Geography                                    */
                /*                                                           */
                /*-----------------------------------------------------------*/
                if ( items[i] instanceof TypeGeoRec )
                    localeRec.removeGeography ( (TypeGeoRec) items[i] ) ;

                /*-----------------------------------------------------------*/
                /*                                                           */
                /*   Remove the Country                                      */
                /*                                                           */
                /*-----------------------------------------------------------*/
                else if ( items[i] instanceof TypeCountryCodeRec )
                    localeRec.removeCountry ( (TypeCountryCodeRec) items[i] ) ;

                /*-----------------------------------------------------------*/
                /*                                                           */
                /*   The only string that would be here is the 'World Wide'  */
                /*                                                           */
                /*-----------------------------------------------------------*/
                else if ( items[i] instanceof String )
                    localeRec.setWorldWide ( false ) ;
            }

              populateList ( localeRec ) ;
        } /* if we have selected items and a locale rec  */
    } /* removeItems  */



    /**
      * This method will take a LocaleRec and populate our list with all
      * of it's contents
      *
      * @param LocaleRec The localeRec to use when populating
      */
    public void populateList ( com.ibm.nzna.projects.common.quest.LocaleRec  localeRec ) {
       DefaultListModel model = ((DefaultListModel)results.getModel()) ;

       /* First, clear out the old list box  */
       model.clear() ;

       if ( localeRec != null ) {

          /*-----------------------------------------------------------*/
          /*                                                           */
          /*   Enable/Disable the World Wide Button and the Select/Help*/
          /*                                                           */
          /*-----------------------------------------------------------*/
          if ( isEnabled() ) {
             worldWide.setEnabled ( !localeRec.isWorldWide() ) ;
             add.setEnabled ( !localeRec.isWorldWide() ) ;
          }

          /*-----------------------------------------------------------*/
          /*                                                           */
          /*   If this is world wide, simply put the string in there   */
          /*                                                           */
          /*-----------------------------------------------------------*/
          if ( localeRec.isWorldWide() ) {
             Vector vec = new Vector ( 1 ) ;

             model.addElement ( "<html><body><font size=5><b>"+Str.getStr ( STR_WORLDWIDE )+"</b></font></body></html>" ) ;
          }

          /*-----------------------------------------------------------*/
          /*                                                           */
          /*   otherwise, add all of the items                         */
          /*                                                           */
          /*-----------------------------------------------------------*/
          else {
             Vector allGeos   = localeRec.getGeoListContainingAll() ;
             Vector countries = localeRec.getSingleCountryList() ;                 


             /*-----------------------------------------------------------*/
             /*                                                           */
             /*   Add all of the Geographies                              */
             /*                                                           */
             /*-----------------------------------------------------------*/
             if ( ( allGeos != null ) && ( allGeos.size() > 0 ) ) {
                int i       = 0 ;
                int size    = allGeos.size() ;

                while ( i < size ) {
                   if ( ((TypeGeoRec)allGeos.elementAt(i)).valid() ) {
                      ((TypeGeoRec)allGeos.elementAt(i)).setEnhanceOutput ( true ) ;
                      model.addElement ( allGeos.elementAt(i++) ) ;
                   }
                }
             }

             /*-----------------------------------------------------------*/
             /*                                                           */
             /*   Add the associated countries                            */
             /*                                                           */
             /*-----------------------------------------------------------*/
             if ( ( countries != null ) && ( countries.size() > 0 ) ) {
                int i       = 0 ;
                int size    = countries.size() ;

                while ( i < size ) {
                   if ( ((TypeCountryCodeRec)countries.elementAt(i)).valid() )
                      model.addElement ( countries.elementAt(i++) ) ;
                }
             }

          }
       }
    } /* populate list  */

    public void setEnabled ( boolean enable ) {
       super.setEnabled ( enable ) ;
       worldWide.setEnabled ( enable ) ;
       remove.setEnabled ( enable ) ;
       add.setEnabled ( enable ) ;

    }



} /* PopUpLocation */

