package com.ibm.nzna.projects.qit.gui.popup ;
/*-----------------------------------------------------------*/
/*   PopUpPanel                                              */
/*                                                           */
/*   Description:                                            */
/*      Source code for: PopUpPanel                          */
/*                                                           */
/*                                                           */
/*         @Copyright  1997 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import javax.swing.* ;
import com.ibm.nzna.shared.gui.wizard.* ;
/**
 * This panel is the super class to all panels that can be placed in a PopUpDlg. 
 *
 *
 * @version 1.0, 6/28/1998 
 * @author  David Lentz
 */


/*-----------------------------------------------------------*/
/*                                                           */
/*   PopUpPanel                                              */
/*                                                           */
/*-----------------------------------------------------------*/
public class PopUpPanel extends WizardStep {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Vars                                                    */
   /*                                                           */
   /*-----------------------------------------------------------*/
   protected PopUpDlg  popUpDlg       = null ;
   protected boolean   requireData    = false ;
   protected boolean   readOnly       = false ;

   public PopUpPanel ( PopUpDlg popUpDlg ) {
      this.popUpDlg = popUpDlg ;
   }





   /*-----------------------------------------------------------*/
   /* refreshData
    */
   /**
    *    This method has to be over ridden so that you
    *  can make the panel pop your data into your
    *  fields
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void refreshData ( Object data ) {
   }



   /*-----------------------------------------------------------*/
   /* saveData
    */
   /**
    *    This method must be over ridden to save your
    *  data. If your data is not ok to save, put up an
    *  error message and return NULL.
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return The Object that is saved, or NULL if nothing was saved
    *//*---------------------------------------------------------*/
   public Object saveData () {
      return( null ) ;
   }

   public boolean saveInfo () {
      return( saveData() != null ) ;
   }


   /*-----------------------------------------------------------*/
   /* setDescript
    */
   /**
    *    This method is called to notify you to update
    *  your description area with the description
    *  passed in.
    *
    *  @param descript The description to update with
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setDescript ( String descript ) {
   }



   /*-----------------------------------------------------------*/
   /* setFocus
    */
   /**
    *    This method should be overridden to set
    *  the field which will require focus first.
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setFocus() {
   }



   /*-----------------------------------------------------------*/
   /* setRequired
    */
   /**
    *    This method will tell the entry field to either
    *  require data or not
    *  
    *
    *  @param requireData = TRUE if we should not close until data is entered
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setRequired ( boolean requireData ) {
      this.requireData = requireData ;
   }



   /*-----------------------------------------------------------*/
   /* setSelection
    */
   /**
    *    This method is for any pop up that has a list
    *  that can be selected. It will select the
    *  record passed in
    *
    *  @param data The data object to be selected
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setSelection ( Object data ) {
   }




   /*------------------------------------------------------------*/
   /* hiding
    */
   /**
    *    This method can be subclassed. It is called
    *  when the PopUpDlg needs to display another
    *  PopUpPanel and this panel is going to be hidden
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void hiding() {
   }


   /*-----------------------------------------------------------*/
   /* setReadOnly
    */
   /**
    *    This method will set the pop up to be read only
    *  
    *  
    *             
    *  @param 
    *  @param 
    *  @param 
    *
    *  @return 
    */
   public void setReadOnly ( boolean readOnly ) {
      this.readOnly = readOnly ;
   }

   public void refreshInfo () {
      setFocus() ;
   }
} /* PopUpPanel */
