package com.ibm.nzna.projects.qit.gui.popup ;
/*-----------------------------------------------------------*/
/*   PopUpPublication                                        */
/*                                                           */
/*   Description:                                            */
/*      Source code for: PopUpPublication                    */
/*                                                           */
/*                                                           */
/*         @Copyright  1997 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This panel holds an entry field and a description. 
 *
 *
 * @version 1.0, 6/28/1998 
 * @author  David Lentz
 */
import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.qit.doc.fieldchanger.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.shared.util.* ;

/*-----------------------------------------------------------*/
/*                                                           */
/*   PopUpPublication                                        */
/*                                                           */
/*-----------------------------------------------------------*/
public class PopUpPublication extends PopUpPanel implements FocusListener, AppConst, ActionListener {

   private String[] validMonthsToReview = { "1  "+Str.getStr ( STR_MONTHS ),
      "2  "+Str.getStr ( STR_MONTHS ),
      "3  "+Str.getStr ( STR_MONTHS ),
      "4  "+Str.getStr ( STR_MONTHS ),
      "5  "+Str.getStr ( STR_MONTHS ),
      "6  "+Str.getStr ( STR_MONTHS ),
      "7  "+Str.getStr ( STR_MONTHS ),
      "8  "+Str.getStr ( STR_MONTHS ),
      "9  "+Str.getStr ( STR_MONTHS ),
      "10 "+Str.getStr ( STR_MONTHS ),
      "11 "+Str.getStr ( STR_MONTHS ),
      "12 "+Str.getStr ( STR_MONTHS ),
      "24 "+Str.getStr ( STR_MONTHS ),
      "36 "+Str.getStr ( STR_MONTHS )} ;


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Controls                                                */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private JCheckBox    ck_WEBABLE           = new JCheckBox  ( Str.getStr ( STR_WEBABLE ) ) ;
   private JCheckBox    ck_WEBONLY           = new JCheckBox  ( Str.getStr ( STR_WEBONLY ) ) ;
   private JCheckBox    ck_FAXABLE           = new JCheckBox  ( Str.getStr ( STR_FAXABLE ) ) ;
   private JCheckBox    ck_HOTFLASH          = new JCheckBox  ( Str.getStr ( STR_HOT_NEWS ) ) ;
   private JCheckBox    ck_KNOWLEDGE         = new JCheckBox  ( Str.getStr ( STR_KNOWLEDGE_BASE ) ) ;
   private JCheckBox    ck_FAQ               = new JCheckBox  ( Str.getStr ( STR_FAQ ) ) ;
   private DateEntryField ef_FLASHDATE         = new DateEntryField() ;
   private JLabel       st_FLASHDATE         = new JLabel     ( Str.getStr ( STR_FLASH_DATE )) ;
   private JLabel       st_MONTHSUNTILREVIEW = new JLabel     ( Str.getStr ( STR_MONTHS_TO_REVIEW )) ;
   private JComboBox    cb_MONTHSUNTILREVIEW = new JComboBox  ( validMonthsToReview) ;


   private PublishingTagsRec publishingTagsRec  = null ;

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Vars                                                    */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private int       rowHeight     = 18 ;


   /*-----------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This will create a PopUpEntryFieldPanel
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public PopUpPublication ( PopUpDlg popUpDlg ) {
      super(popUpDlg) ;
      setLayout ( null ) ;

      add ( ck_WEBABLE   ) ;
      add ( ck_WEBONLY   ) ;
      add ( ck_FAXABLE   ) ;
      add ( ck_FAQ       ) ;
      add ( ck_HOTFLASH  ) ;
      add ( st_FLASHDATE ) ;
      add ( ef_FLASHDATE ) ;
      add ( ck_KNOWLEDGE ) ;
      add ( st_MONTHSUNTILREVIEW ) ;
      add ( cb_MONTHSUNTILREVIEW ) ;

      /* Add our listeners  */
      ef_FLASHDATE.addActionListener ( this ) ;
      ck_HOTFLASH.addActionListener ( this ) ;
      ef_FLASHDATE.addFocusListener ( this ) ;

      /* Disable Web Only for now  */
      ck_WEBONLY.setSelected ( true ) ;
      ck_WEBONLY.setVisible ( false ) ;
   } 

   public void focusGained ( FocusEvent e ) {
   }

   public void focusLost ( FocusEvent e ) {
      fixDate() ;
   }

   /*-----------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will be subclassed to size and
    *  position our controls
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size = getSize();

      super.doLayout() ;

      ck_WEBABLE.setBounds            ( 0,                   0,            size.width / 2, rowHeight ) ;
      ck_WEBONLY.setBounds            ( size.width / 2 + 1,  0,            size.width / 2, rowHeight ) ;
      ck_FAXABLE.setBounds            ( 0,                   rowHeight*1,  size.width / 2, rowHeight ) ;
      ck_FAQ.setBounds                ( 0,                   rowHeight*2,  size.width / 2, rowHeight ) ;
      st_FLASHDATE.setBounds          ( size.width / 2 + 1,  rowHeight*2,  size.width / 2, rowHeight ) ;
      ck_HOTFLASH.setBounds           ( 0,                   rowHeight*3,  size.width / 2, rowHeight ) ; 
      ef_FLASHDATE.setBounds          ( size.width / 2 + 1,  rowHeight*3,  (size.width / 2)-10, rowHeight ) ;
      ck_KNOWLEDGE.setBounds          ( 0,                   rowHeight*4,  size.width / 2, rowHeight ) ;
      st_MONTHSUNTILREVIEW.setBounds  ( 0,                   rowHeight*5,  size.width / 2, rowHeight ) ;
      cb_MONTHSUNTILREVIEW.setBounds  ( 0,                   rowHeight*6,  size.width / 2, rowHeight ) ;
   }



   /*-----------------------------------------------------------*/
   /* setDescript
    */
   /**
    *    We subclass this method to set our description
    *  
    *  
    *
    *  @param descript
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setDescript ( String descript ) {
      //st_DESCRIPT.setText ( descript ) ;
   }



   /*-----------------------------------------------------------*/
   /* saveData
    */
   /**
    *    This method will determine if the user has
    *  entered the data needed to close the popup
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return The string entered if any
    *//*---------------------------------------------------------*/
   public Object saveData () {
      Object retRec = null ;

      /* get the values from the fields */
      publishingTagsRec.webable         = ck_WEBABLE.isSelected() ;
      publishingTagsRec.webOnly         = ck_WEBONLY.isSelected() ;   
      publishingTagsRec.faxable         = ck_FAXABLE.isSelected() ;   
      publishingTagsRec.hotFlash        = ck_HOTFLASH.isSelected() ;   
      publishingTagsRec.faq             = ck_FAQ.isSelected() ;
      publishingTagsRec.flashDate       = ef_FLASHDATE.getText() ;
      publishingTagsRec.knowledgeBase   = ck_KNOWLEDGE.isSelected() ;
      publishingTagsRec.monthsToReview  = new Integer ( ((String)cb_MONTHSUNTILREVIEW.getSelectedItem()).substring(0,3).trim() ).intValue();

      /* If data is required, we must let the user know what data we mean! */

      if ( ( publishingTagsRec.hotFlash ) && ( CDate.checkDate ( publishingTagsRec.flashDate, CDate.DATE_DATE ) != 0 ) )
         GUISystem.printBox ( Str.getStr ( STR_ERROR ), Str.getStr ( STR_MUST_ENTER_FLASH_NEWS_DATE ) ) ;

      else if ( ( publishingTagsRec.hotFlash ) && ( ( !CDate.isFutureDate ( publishingTagsRec.flashDate, CDate.DATE_DATE ) )) )
         GUISystem.printBox ( Str.getStr ( STR_ERROR ), Str.getStr ( STR_FLASH_DATE_IN_PAST ) ) ;

      /* Ok, the months to review can be between 1 and 12. It can also be 24 or 36 */
      else if ( ( ( publishingTagsRec.monthsToReview < 1 ) || ( publishingTagsRec.monthsToReview > 12 ) ) &&
                ( publishingTagsRec.monthsToReview != 24 ) &&
                ( publishingTagsRec.monthsToReview != 36 ) )
         GUISystem.printBox ( Str.getStr ( STR_ERROR ), Str.getStr ( STR_MUST_ENTER_VALID_MONTHS_TO_REVIEW ) ) ;

      else {
         /* If we are not flash news or emailable, make sure the dates are null! */
         if ( !publishingTagsRec.hotFlash )
            publishingTagsRec.flashDate = null;

         retRec = publishingTagsRec ;
      }

      return( retRec ) ;

   }


   /*-----------------------------------------------------------*/
   /* refreshData
    */
   /**
    *    This method will refresh all of our data
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void refreshData ( Object dataObj ) {
      if ( dataObj != null ) {
         if ( dataObj instanceof PublishingTagsRec )
            publishingTagsRec = ( PublishingTagsRec ) dataObj ;

      } else
         publishingTagsRec = new PublishingTagsRec() ;

      ck_WEBABLE.setSelected   ( publishingTagsRec.webable ) ;
      ck_FAQ.setSelected       ( publishingTagsRec.faq ) ;
      //ck_WEBONLY.setSelected   ( publishingTagsRec.webOnly ) ;  
      ck_WEBONLY.setSelected   ( true ) ;  
      ck_FAXABLE.setSelected   ( publishingTagsRec.faxable ) ;  
      ck_HOTFLASH.setSelected  ( publishingTagsRec.hotFlash ) ;
      ef_FLASHDATE.setText     ( publishingTagsRec.flashDate ) ;
      ck_KNOWLEDGE.setSelected ( publishingTagsRec.knowledgeBase  ) ;

      if ( publishingTagsRec.monthsToReview <= 12 )
         cb_MONTHSUNTILREVIEW.setSelectedItem ( validMonthsToReview[publishingTagsRec.monthsToReview-1] ) ;
      else {
         if ( publishingTagsRec.monthsToReview == 24 )
            cb_MONTHSUNTILREVIEW.setSelectedItem ( validMonthsToReview[12] ) ;
         else if ( publishingTagsRec.monthsToReview == 36 )
            cb_MONTHSUNTILREVIEW.setSelectedItem ( validMonthsToReview[13] ) ;
      }

      ef_FLASHDATE.setEnabled ( ck_HOTFLASH.isSelected() ) ;

   }




   /*-----------------------------------------------------------*/
   /* setFocus
    */
   /**
    *    This method will be called when the PopUpDlg
    *  is done initializing and is now ready to let
    *  the user enter data.
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setFocus() {
      ck_WEBABLE.requestFocus() ;
   }



   /*-----------------------------------------------------------*/
   /* entryFieldHit
    */
   /**
    *    This method will respond to the entry
    *  field being used
    *  
    *             
    *  @param 
    *  @param 
    *  @param 
    *
    *  @return 
    */
   public void actionPerformed ( ActionEvent e ) {

      if ( e.getSource() == ef_FLASHDATE ) {
         fixDate() ;
         if ( ( saveData() != null ) && ( popUpDlg != null ) )
            popUpDlg.okHit ( PopUpDlg.PB_OK ) ;
      }

      else if ( e.getSource() == ck_HOTFLASH ) {
         ef_FLASHDATE.setEnabled ( ck_HOTFLASH.isSelected() ) ;
         if ( !ck_HOTFLASH.isSelected() )
            ef_FLASHDATE.setText ( "" ) ;
         else
            ef_FLASHDATE.requestFocus() ;
      }
   }

   /*-----------------------------------------------------------*/
   /* setReadOnly
    */
   /**
    *    This method will change this pop up to be
    *  read only
    *  
    *             
    *  @param readOnly TRUE = make read only, false Make no read only
    *  @param 
    *  @param 
    *
    *  @return 
    */
   public void setReadOnly ( boolean readOnly ) {
      super.setReadOnly ( readOnly ) ;
      ck_WEBABLE.setEnabled ( !readOnly ) ;
      ck_WEBONLY.setEnabled ( !readOnly ) ;
      ck_FAXABLE.setEnabled ( !readOnly ) ;
      ck_HOTFLASH.setEnabled ( !readOnly ) ;
      ef_FLASHDATE.setEnabled ( !readOnly ) ;
      cb_MONTHSUNTILREVIEW.setEnabled ( !readOnly ) ;
      ck_KNOWLEDGE.setEnabled ( !readOnly ) ;

   }





   /*------------------------------------------------------------*/
   /* fixDate
    */
   /**
    *    This method will fix the ef_FLASHDATE
    *  entry field so that it displays a 4 digit year
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void fixDate () {
   }

} /* PopUpPublication */
