package com.ibm.nzna.projects.qit.gui.popup ;
/*-----------------------------------------------------------*/
/*   PopUpUserEntry                                          */
/*                                                           */
/*   Description:                                            */
/*      Source code for: PopUpUserEntry                      */
/*                                                           */
/*                                                           */
/*         @Copyright  1997 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.qit.app.* ;
/**
 * This panel holds an entry field and a description. 
 *
 *
 * @version 1.0, 6/28/1998 
 * @author  David Lentz
 */


/*-----------------------------------------------------------*/
/*                                                           */
/*   PopUpUserEntry                                         */
/*                                                           */
/*-----------------------------------------------------------*/
public class PopUpUserEntry extends PopUpPanel implements AppConst {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Controls                                                */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private UserEntryPanel ef_DESCRIPT = new UserEntryPanel (  ) ;


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Vars                                                    */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private int       rowHeight     = 18 ;


   /*-----------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This will create a PopUpUserEntryPanel
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public PopUpUserEntry ( PopUpDlg popUpDlg ) {
      super(popUpDlg) ;
      setLayout ( null ) ;
      add ( ef_DESCRIPT ) ;
      ef_DESCRIPT.setShowFullName ( true ) ;
   }



   /*-----------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will be subclassed to size and
    *  position our controls
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size = getSize() ;

      ef_DESCRIPT.setBounds ( 0, 0, size.width, rowHeight*4 ) ;
   }



   /*-----------------------------------------------------------*/
   /* setDescript
    */
   /**
    *    We subclass this method to set our description
    *  
    *  
    *
    *  @param descript
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setDescript ( String descript ) {
   }



   /*-----------------------------------------------------------*/
   /* saveData
    */
   /**
    *    This method will determine if the user has
    *  entered the data needed to close the popup
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return The string entered if any
    *//*---------------------------------------------------------*/
   public Object saveData () {
      String str = ef_DESCRIPT.getUserId() ;

      if ( ( ( str == null ) || ( str.length() < 1 ) ) && ( requireData ) ) {
         GUISystem.printBox ( Str.getStr ( STR_ERROR ), Str.getStr ( STR_MUST_ENTER_VALUE ) ) ;
         str = null ;
      } else if ( str == null )
         str = "" ;

      return ( str ) ;
   }

   /*-----------------------------------------------------------*/
   /* refreshData
    */
   /**
    *    This method will refresh all of our data
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void refreshData ( Object dataObj ) {
      if ( dataObj != null ) {
         if ( dataObj instanceof String ) {
            String tempStr = (String) dataObj ;

            ef_DESCRIPT.setText ( tempStr ) ;
         } else if ( dataObj instanceof UserRec )
            ef_DESCRIPT.setText ( ((UserRec)dataObj).getUserId() ) ;
      } else
         ef_DESCRIPT.setText ( "" ) ;

   }




   /*-----------------------------------------------------------*/
   /* setFocus
    */
   /**
    *    This method will be called when the PopUpDlg
    *  is done initializing and is now ready to let
    *  the user enter data.
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setFocus() {
      ef_DESCRIPT.requestFocus() ;
   }

   /*------------------------------------------------------------*/
   /* hiding
    */
   /**
    *    This method has been subclassed to remove
    *  any attributes that the entry field has set so
    *  the next time we are shown, we are shown as the default entry field
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void hiding () {
      ef_DESCRIPT.setText ( null ) ;
   }

   /*-----------------------------------------------------------*/
   /* setReadOnly
    */
   /**
    *    This method will change this pop up to be
    *  read only
    *  
    *             
    *  @param readOnly TRUE = make read only, false Make no read only
    *  @param 
    *  @param 
    *
    *  @return 
    */
   public void setReadOnly ( boolean readOnly ) {
      super.setReadOnly ( readOnly ) ;
      ef_DESCRIPT.setEnabled ( !readOnly ) ;
   }



} /* PopUpUserEntry */
