package com.ibm.nzna.projects.qit.notify ;
/*-----------------------------------------------------------*/
/*   Notify                                                  */
/*                                                           */
/*   Description:                                            */
/*      Source code for: Notify                              */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import javax.swing.* ;
import com.ibm.nzna.projects.qit.app.* ;
/**
 * This QuestApplet reads through a user's notifications and allows 
 * them to delete, forward or reply to a notification
 *
 * @version 1.0, 3/31/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   Notify                                                  */
/*                                                           */
/*-----------------------------------------------------------*/
public class Notify extends Object implements java.io.Serializable, QuestApplet, AppConst, Authority {






   /*------------------------------------------------------------*/
   /* getAuthority
    */
   /**
    *    This method will return 0 since there is
    *  no authority needed
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public int getAuthority () {
      return( AUTH_NOAUTHREQ ) ;
   }





   /*------------------------------------------------------------*/
   /* canChat
    */
   /**
    *    This QuestApplet will not chat
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean canChat () {
      return( false ) ;
   }





   /*------------------------------------------------------------*/
   /* start
    */
   /**
    *    This method will be called when the user
    *  has selected us to start and we are done 
    *  initializing
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void start () {
      WindowSystem.createPanel ( new NotifyPanel () ) ;
   }





   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will be called when the user
    *  has selected to run this QuestApplet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean initialize () {
      return( true ) ;
   }




   /*------------------------------------------------------------*/
   /* getIcon
    */
   /**
    *    This method will return the icon associated
    *  to this Quest Applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return ImageIcon
    *//*---------------------------------------------------------*/
   public ImageIcon getIcon () {
      return( ImageSystem.getImageIcon ( MainWindow.getInstance(), ImageSystem.NOTIFY_LARGE ) ) ;
   }





   /*------------------------------------------------------------*/
   /* getSmallIcon
    */
   /**
    *    This method will return the small icon
    *  associated to this quest applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public ImageIcon getSmallIcon () {
      return( ImageSystem.getImageIcon ( MainWindow.getInstance(), ImageSystem.NOTIFY_SMALL ) ) ;
   }






   /*------------------------------------------------------------*/
   /* getDescription
    */
   /**
    *    This method will return the full name description
    *  of this QuestApplet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getDescription () {
      return( Str.getStr ( STR_NOTIFY_DESCRIPTION ) ) ;
   }






   /*------------------------------------------------------------*/
   /* getName
    */
   /**
    *    This method will return the name of this
    *  QuestApplet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getName () {
      return( Str.getStr ( STR_IN_BOX ) ) ;
   }




} /* Notify */
