package com.ibm.nzna.projects.qit.print ;
/*-----------------------------------------------------------*/
/*   Preview                                            */
/*                                                           */
/*   Description:                                            */
/*      Source code for: Preview                             */
/*                                                           */
/*                                                           */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import java.util.* ;
import javax.swing.* ;
import javax.swing.JTree.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.qit.doc.docedit.*;
import com.ibm.nzna.projects.qit.doc.*;
import com.ibm.nzna.shared.gui. *;
import com.ibm.nzna.shared.util.* ;
import java.awt.print.*;
import java.awt.print.PrinterJob;
/**
 * This class basically will Preview just about anything. Please see the constructors for more information 
 *
 * @version 6/8/2001 
 * @author  Shashi
 *
 */
/*-----------------------------------------------------------*/
/*                                                           */
/*   Print                                                   */
/*                                                           */
/*-----------------------------------------------------------*/
public class Preview extends Object implements AppConst {


    /*-----------------------------------------------------------*/
    /*                                                           */
    /*   Static Members                                          */
    /*                                                           */
    /*-----------------------------------------------------------*/
    private static ApplicationPanel currentPanel;
    private static PrintPreview     printPreview;
    /*------------------------------------------------------------*/
    /* PreviewPrint
     */
    /**
     *    This constructor takes any object and
     *  tried to call the correct constructor
     *  for the object passed
     *
     *  @param object The Object to preview. There must be a 'preview' Method in this class supporting the type of this object
     *  @param parent The parnet frame of the preview dialog
     *  @param jobName The Job Name to use
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public Preview ( Object object, Frame parent, String jobName ) {

        if ( object instanceof MultiList ) {
            preview ( (MultiList)object, parent, jobName ) ;
        } else if ( object instanceof JTree ) {
            preview ( (JTree)object, parent, jobName ) ;
        } else if ( object instanceof JDialog ) {
            preview ( (JDialog)object, parent, jobName ) ;
        } else if ( object instanceof JTextArea ) {
            preview ( (JTextArea)object, parent, jobName ) ;
        } else if ( object instanceof JPanel ) {
            preview ( (JPanel)object, parent, jobName ) ;
        } else if ( object instanceof JTable ) {
            preview ( (JTable)object, parent, jobName ) ;
        }
    }

    public Preview ( Object object, Frame parent, String jobName, ApplicationPanel cp) {
        this.currentPanel =  cp;

        if ( object instanceof MultiList ) {
            preview ( (MultiList)object, parent, jobName ) ;
        } else if ( object instanceof JTree ) {
            preview ( (JTree)object, parent, jobName ) ;
        } else if ( object instanceof JDialog ) {
            preview ( (JDialog)object, parent, jobName ) ;
        } else if ( object instanceof JTextArea ) {
            preview ( (JTextArea)object, parent, jobName ) ;
        } else if ( object instanceof JPanel ) {
            preview ( (JPanel)object, parent, jobName ) ;
        } else if ( object instanceof JTable ) {
            preview ( (JTable)object, parent, jobName ) ;
        }
    }

    public static void setCurrentPanel(ApplicationPanel panel){
        currentPanel = panel;
    }

    /*------------------------------------------------------------*/
    /* Constructor
     */
    /**
     *    This constructor will preview a MultiList.
     *  
     *  
     *
     *  @param multiList The MultiList to print
     *  @param parentWin The Parent Window to make the preview dialog a child of
     *  @param jobName The name of the job to preview
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public static void preview ( MultiList multiList, Frame parentWin, String jobName ) {
        new PrintPreview((Container)multiList, currentPanel, parentWin);         
        
    }

    /*------------------------------------------------------------*/
    /* Preview
     */
    /**
     *    This will print a JTree.
     *  
     *  
     *
     *  @param tree The JTree to print
     *  @param parentWin The Parent Window to make the print dialog a child of
     *  @param jobName The name of the job to print
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public static void preview ( JTree tree, Frame parentWin, String jobName ) {
        new PrintPreview((Container)tree, currentPanel, parentWin);
    } /* Preview */

    /*------------------------------------------------------------*/
    /* Preview
     */
    /**
     *    This will preview a JPanel.
     *  
     *  
     *
     *  @param printOwner The JPanel
     *  @param parentWin The Parent Window to make the preview dialog a child of
     *  @param jobName The name of the job to preview
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/

    public static void preview ( JPanel panel, Frame parentWin, String jobName ) {
        new PrintPreview((Container)panel, currentPanel, parentWin);
    } /* preview */

    /*------------------------------------------------------------*/
    /* Preview
     */
    /**
     *    This will print a JDialog.
     *  
     *  
     *
     *  @param printOwner The JDialog
     *  @param parentWin The Parent Window to make the print dialog a child of
     *  @param jobName The name of the job to print
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/

    public static void preview ( JDialog dialog, Frame parentWin, String jobName ) {
        new PrintPreview((Container)dialog, currentPanel, parentWin);
    } /* Preview */

    /*------------------------------------------------------------*/
    /* Preview
     */
    /**
     *    This will print a JTextArea.
     *  
     *  
     *
     *  @param printOwner The JTextArea
     *  @param parentWin The Parent Window to make the print dialog a child of
     *  @param jobName The name of the job to print
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/

    public static void preview ( JTextArea dialog, Frame parentWin, String jobName ) {
        new PrintPreview((Container)dialog, currentPanel, parentWin);
    } /* Preview */
    /*------------------------------------------------------------*/
    /* Preview
     */
    /**
     *    This will print a JTable.
     *  
     *  
     *
     *  @param printOwner The JTable
     *  @param parentWin The Parent Window to make the print dialog a child of
     *  @param jobName The name of the job to print
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/

    public static void preview ( JTable dialog, Frame parentWin, String jobName ) {
        new PrintPreview((Container)dialog, currentPanel, parentWin);
    } /* Preview */


} /* Preview */

