package com.ibm.nzna.projects.qit.print ;
/*-----------------------------------------------------------*/
/*   Print                                                   */
/*                                                           */
/*   Description:                                            */
/*      Source code for: Print                               */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import java.awt.image.*;
import java.util.* ;
import javax.swing.* ;
import javax.swing.JTree.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.qit.doc.docedit.*;
import com.ibm.nzna.projects.qit.doc.*;
import com.ibm.nzna.shared.gui. *;
import com.ibm.nzna.shared.util.* ;
import java.awt.print.PrinterJob;
/**
 * This class basically will print just about anything. Please see the constructors for more 
 * information 
 *
 * @version 6/8/2001 
 * @author  Shashi
 *
 */
/*-----------------------------------------------------------*/
/*                                                           */
/*   Print                                                   */
/*                                                           */
/*-----------------------------------------------------------*/
public class Print extends Object implements AppConst {


    /*-----------------------------------------------------------*/
    /*                                                           */
    /*   Static Members                                          */
    /*                                                           */
    /*-----------------------------------------------------------*/
    public final static int PAGE_TOP         = 40 ;
    public final static int PAGE_LEFT        = 30 ;
    public final static int PAGE_BOTTOM      = 10 ;
    private static int height           =  0 ;
    private static int x                =  0 ;
    private static ApplicationPanel        applicationPanel;

    /*------------------------------------------------------------*/
    /* Print
     */
    /**
     *    This constructor takes any object and
     *  tried to call the correct constructor
     *  for the object passed
     *
     *  @param object The Object to print. There must be a 'print' Method in this class supporting the type of this object
     *  @param parent The parnet frame of the print dialog
     *  @param jobName The Job Name to use
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public Print ( Object object, Frame parent, String jobName ) {

        if ( object instanceof MultiList ) {
            print ( (MultiList)object, parent, jobName ) ;
        } else if ( object instanceof JTree ) {
            print ( (JTree)object, parent, jobName ) ;
        } else if ( object instanceof JTextArea ) {
            print ( (JTextArea)object, parent, jobName ) ;
        } else if ( object instanceof JPanel ) {
            print ( (JPanel)object, parent, jobName ) ;
        } else if ( object instanceof JDialog ) {
            print ( (JDialog)object, parent, jobName ) ;
        } else if ( object instanceof JList ) {
            print ( (JList)object, parent, jobName ) ;

        } //else if ( object instanceof PrintOwner ) {
        //  System.out.println("JPanel");
        //  print ( (PrintOwner)object, parent, jobName ) ;
        // }
    }

    /*------------------------------------------------------------*/
    /* Constructor
     */
    /**
     *    This constructor will print a MultiList.
     *  
     *  
     *
     *  @param multiList The MultiList to print
     *  @param parentWin The Parent Window to make the print dialog a child of
     *  @param jobName The name of the job to print
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public static void print ( MultiList multiList, Frame parentWin, String jobName ) {


        Vector        data   = multiList.getData() ;
        AppDefaultWin defWin = null ;

        if ( parentWin instanceof AppDefaultWin )
            defWin = (AppDefaultWin)parentWin ;

        if ( ( data != null ) && ( data.size() > 0 ) ) {
            Vector   headings   = multiList.getColumnHeadings () ;
            PrintJob printJob   = Toolkit.getDefaultToolkit().getPrintJob ( parentWin, jobName, null ) ;

            if ( printJob != null ) {
                int            numOfPages = 0 ;
                Graphics       graphics   = null ;
                int            y          = 0 ;
                int            rowHeight  = GUISystem.getRowHeight() ;
                Dimension      dimension  = printJob.getPageDimension() ;
                dimension.height-=(PAGE_BOTTOM) ;
                numOfPages = multiList.getNumOfPages ( dimension ) ;
                multiList.print(printJob, dimension);
                printJob.end();
            } //else
              //  GUISystem.printBox ( STR_INFO, STR_CANNOT_PRINT_ON_CLIENT ) ;
             
        } else
            GUISystem.printBox ( parentWin, STR_INFO, STR_NOTHING_TO_PRINT ) ;
        if ( defWin != null )
            defWin.setStatus ( Str.getStr ( STR_DONE ), 2 ) ;
          
    }


    /*------------------------------------------------------------*/
    /* print
     */
    /**
     *    This will print a JTree.
     *  
     *  
     *
     *  @param tree The JTree to print
     *  @param parentWin The Parent Window to make the print dialog a child of
     *  @param jobName The name of the job to print
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/


    public static void print ( JTree tree, Frame parentWin, String jobName ) {

        PrintJob    printJob   = Toolkit.getDefaultToolkit().getPrintJob ( parentWin, jobName, null ) ;
        Dimension   dimension  = printJob.getPageDimension() ;
        Graphics    graphics   = null ;
        int         y          = 0 ;
        int         rowHeight  = GUISystem.getRowHeight() ;
        int         rowCount   = tree.getRowCount();
        int         height     = tree.getHeight();
        int         numPages   = getNumPages(tree.getHeight());

        if ( printJob != null ) {
            int Xcor=15;
            int Ycor=PAGE_TOP;
            int width=612;
            int page=0;
            Graphics gr =null;
            Graphics treeGraphics = tree.getGraphics();

            BufferedImage img = new BufferedImage(tree.getWidth(),tree.getHeight(), BufferedImage.TYPE_INT_RGB);
            Graphics bg = img.getGraphics();
            tree.paintAll(bg);

            for ( page = 0; page <numPages; page++ ) {
                BufferedImage subImage = null;
                if (page != numPages-1)
                    subImage =img.getSubimage(0,page*684,612,684);
                else
                    subImage = img.getSubimage(0,page*684,612,tree.getHeight()-page*684);

                PagePreview pv = new PagePreview(612,684,subImage);
                pv.setDS(printJob.getPageDimension());

                graphics = printJob.getGraphics() ;   
                pv.print ( graphics ) ;

                //   paintFooter ( graphics, printJob.getPageDimension(), page+1, numPages ) ;
            }
            printJob.end();
        } else
            GUISystem.printBox ( STR_INFO, STR_CANNOT_PRINT_ON_CLIENT ) ;

    }


    /*------------------------------------------------------------*/
    /* print
     */
    /**
     *    This will print a JPanel.
     *  
     *  
     *
     *  @param printOwner The JPanel
     *  @param parentWin The Parent Window to make the print dialog a child of
     *  @param jobName The name of the job to print
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public static void print ( JPanel panel, Frame parentWin, String jobName ) {

        PrintJob    printJob   = Toolkit.getDefaultToolkit().getPrintJob ( parentWin, jobName, null ) ;
        Dimension   dimension  = printJob.getPageDimension() ;
        Graphics    graphics   = null ;
        int         y          = 0 ;
        int         rowHeight  = GUISystem.getRowHeight() ;
        //   int         rowCount   = panel.getRowCount();
        int         height     = panel.getHeight();
        int         numPages   = getNumPages(panel.getHeight());

        if ( printJob != null ) {
            int Xcor=15;
            int Ycor=PAGE_TOP;
            int width=612;
            int page=0;
            Graphics gr =null;
            Graphics panelGraphics = panel.getGraphics();

            BufferedImage img = new BufferedImage(panel.getWidth(),panel.getHeight(), BufferedImage.TYPE_INT_RGB);
            Graphics bg = img.getGraphics();
            
            panel.paintAll(bg);

            for ( page = 0; page <numPages; page++ ) {
                BufferedImage subImage = null;

                if (page != numPages-1)
                    subImage =img.getSubimage(0,page*684,612,684);
                else
                    subImage = img.getSubimage(0,page*684,612,panel.getHeight()-page*684);

                PagePreview pv = new PagePreview(612,684,subImage);
                pv.setDS(printJob.getPageDimension());

                graphics = printJob.getGraphics() ;
                graphics.translate ( 15, 5 ) ;
                pv.print ( graphics ) ;

                //   paintFooter ( graphics, printJob.getPageDimension(), page+1, numPages ) ;
            }
            printJob.end();
        } else
            GUISystem.printBox ( STR_INFO, STR_CANNOT_PRINT_ON_CLIENT ) ;

    }
    /*------------------------------------------------------------*/
    /* print
     */
    /**
     *    This will print a JTextArea.
     *  
     *  
     *
     *  @param printOwner The JTextArea
     *  @param parentWin The Parent Window to make the print dialog a child of
     *  @param jobName The name of the job to print
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/

    public static void print ( JTextArea textArea, Frame parentWin, String jobName ) {
        PrintJob printJob   = Toolkit.getDefaultToolkit().getPrintJob ( parentWin, jobName, null ) ;
        Graphics graphics   = null ;
        int      y          = 0 ;
        int      rowHeight  = GUISystem.getRowHeight() ;

        if ( printJob != null ) {
            graphics = printJob.getGraphics() ;
            paintHeaderFooter ( graphics, printJob.getPageDimension(), 1, 1 ) ;
            graphics.translate ( 15, PAGE_TOP ) ;
            textArea.print ( graphics ) ;
        } else
            GUISystem.printBox ( STR_INFO, STR_CANNOT_PRINT_ON_CLIENT ) ;
    } /* Print */
    /*------------------------------------------------------------*/
    /* print
     */
    /**
     *    This will print a JList.
     *  
     *  
     *
     *  @param printOwner The JList
     *  @param parentWin The Parent Window to make the print dialog a child of
     *  @param jobName The name of the job to print
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/

    public static void print ( JList list, Frame parentWin, String jobName ) {
        PrintJob printJob   = Toolkit.getDefaultToolkit().getPrintJob ( parentWin, jobName, null ) ;
        Graphics graphics   = null ;
        int      y          = 0 ;
        int      rowHeight  = GUISystem.getRowHeight() ;

        if ( printJob != null ) {
            graphics = printJob.getGraphics() ;
            paintHeaderFooter ( graphics, printJob.getPageDimension(), 1, 1 ) ;
            graphics.translate ( 15, PAGE_TOP ) ;
            list.print ( graphics ) ;
        } else
            GUISystem.printBox ( STR_INFO, STR_CANNOT_PRINT_ON_CLIENT ) ;
    } /* Print */

    /*------------------------------------------------------------*/
    /* print
     */
    /**
     *    This will print a JDialog.
     *  
     *  
     *
     *  @param printOwner The JDialog
     *  @param parentWin The Parent Window to make the print dialog a child of
     *  @param jobName The name of the job to print
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/

    public static void print ( JDialog dialog, Frame parentWin, String jobName ) {
        PrintJob printJob   = Toolkit.getDefaultToolkit().getPrintJob ( parentWin, jobName, null ) ;
        Graphics graphics   = null ;
        int      y          = 0 ;
        int      rowHeight  = GUISystem.getRowHeight() ;

        if ( printJob != null ) {
            graphics = printJob.getGraphics() ;
            paintHeader ( graphics, printJob.getPageDimension()) ;
            graphics.translate ( 15, PAGE_TOP ) ;
            dialog.print ( graphics ) ;
        } else
            GUISystem.printBox ( STR_INFO, STR_CANNOT_PRINT_ON_CLIENT ) ;
        printJob.end();
    } /* Print */

    /*------------------------------------------------------------*/
    /* print
     */
    /**
     *    This will print a PrintOwner.
     *  
     *  
     *
     *  @param printOwner The PrintOwner
     *  @param parentWin The Parent Window to make the print dialog a child of
     *  @param jobName The name of the job to print
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/

    /*public static void print ( PrintOwner printOwner, Frame parentWin, String jobName ) {
        PrintJob printJob   = Toolkit.getDefaultToolkit().getPrintJob ( parentWin, jobName, null ) ;
        Graphics graphics   = null ;
        int      y          = 0 ;
        int      rowHeight  = GUISystem.getRowHeight() ;

        if ( printJob != null ) {
            graphics = printJob.getGraphics() ;
            graphics.translate ( 15, PAGE_TOP ) ;
            printOwner.printToPrinter ( printJob ) ;
        } else
            GUISystem.printBox ( STR_INFO, STR_CANNOT_PRINT_ON_CLIENT ) ;
    } *//* Print */


    /*------------------------------------------------------------*/
    /* paintHeaderFooter
     */
    /**
     *    This method will paint the header and
     *  footer on each page
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/

    private static void paintHeaderFooter ( Graphics g, Dimension size, int currentPage, int pageNum ) {
        paintHeader ( g, size ) ;
        paintFooter ( g, size, currentPage, pageNum ) ;
    }

    private static void paintHeader ( Graphics g, Dimension size ) {
        if ( g != null ) {
            Font font = g.getFont() ;

            g.setFont ( FontSystem.largeTitleFont ) ;
            g.setColor ( Color.black ) ;
            g.drawString ( "Quest", PAGE_LEFT, 30 ) ;
            g.drawLine ( PAGE_LEFT, 32, size.width-PAGE_LEFT, 32 ) ;
            g.drawLine ( PAGE_LEFT, 33, size.width-PAGE_LEFT, 33 ) ;
            g.drawLine ( PAGE_LEFT, 34, size.width-PAGE_LEFT, 34 ) ;
            g.drawLine ( PAGE_LEFT, 35, size.width-PAGE_LEFT, 35 ) ;
            g.setFont ( font ) ;
        }
    }

    private static void paintFooter ( Graphics g, Dimension size, int currentPage, int pageNum ) {
        if ( g != null ) {
            Font         font    = g.getFont() ;
            String       pageStr = currentPage+" "+Str.getStr ( STR_OF )+" "+pageNum ;
            FontMetrics  fm      = null ;

            g.drawLine ( PAGE_LEFT, size.height-65, size.width-PAGE_LEFT, size.height-65 ) ;
            g.drawLine ( PAGE_LEFT, size.height-63, size.width-PAGE_LEFT, size.height-63 ) ;
            g.drawLine ( PAGE_LEFT, size.height-62, size.width-PAGE_LEFT, size.height-62 ) ;
            g.setFont ( FontSystem.smallFont ) ;
            fm = g.getFontMetrics() ;
            g.drawString ( DateSystem.getDate ( CDate.DATE_DATE ), PAGE_LEFT, size.height-53 ) ;
            g.drawString ( pageStr, 
                           (size.width/2)-(SwingUtilities.computeStringWidth ( fm, pageStr)/2),
                           size.height-53 ) ;
            g.setFont ( font ) ;
        }
    }

    private static int getHeaderFooterHeight () {
        return( PAGE_TOP+PAGE_BOTTOM ) ;
    }
    /*------------------------------------------------------------*/
    /* getNumPages
     */
    /**
     *    This method will return the number of pages
     *  
     *
     *  @param heught of the panel
     *
     *  @return number of pages
     *//*---------------------------------------------------------*/

    private static int getNumPages(int height)
    {                                                                      
        int pageCount = height/702;
        pageCount = pageCount+1;
        return pageCount;
    } 


} /* Print */

    /*
        This inner class extends JPanel to serve as a placeholder for 
        the image of each printed page preview. 
    */
class PagePreview extends JPanel {
    protected int m_w;
    protected int m_h;
    protected Image m_source;
    protected Image m_img;

    public PagePreview(int w, int h, Image source) {
        m_w = w;
        m_h = h;
        m_source= source;
        m_img = m_source;
        m_img.flush();
    }

    public Dimension getPreferredSize() {
        return new Dimension(m_w+5, 
                             m_h+5);
    }

    public Dimension getMaximumSize() {
        return getPreferredSize();
    }

    public Dimension getMinimumSize() {
        return getPreferredSize();
    }

    public void paint(Graphics g) {
        paintHeader(g);
        g.drawImage(m_img, 2, 40, this);
    }

    private Dimension size=new Dimension();
    public void setDS(Dimension size){
        this.size=size;
    }

    private  void paintHeader ( Graphics g) {
        if ( g != null ) {
            Font font = g.getFont() ;

            g.setFont ( FontSystem.largeTitleFont ) ;
            g.setColor ( Color.black ) ;
            g.drawString ( "Quest", Print.PAGE_LEFT, 30 ) ;
            g.drawLine ( Print.PAGE_LEFT, 32, size.width-Print.PAGE_LEFT, 32 ) ;
            g.drawLine ( Print.PAGE_LEFT, 33, size.width-Print.PAGE_LEFT, 33 ) ;
            g.drawLine ( Print.PAGE_LEFT, 34, size.width-Print.PAGE_LEFT, 34 ) ;
            g.drawLine ( Print.PAGE_LEFT, 35, size.width-Print.PAGE_LEFT, 35 ) ;
            g.setFont ( font ) ;
        }
    }

}
