package com.ibm.nzna.projects.qit.print ;
/*-----------------------------------------------------------*/
/*   PrintDialogue                                           */
/*                                                           */
/*   Description:                                            */
/*      Source code for: PrintDialogue                       */
/*                                                           */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import java.awt.event.*;
import java.util.* ;
import javax.swing.* ;
import java.awt.print.*;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.qit.doc.docedit.*;
import com.ibm.nzna.projects.qit.doc.*;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.util.* ;
import java.awt.print.PrinterJob;
/**
/*------------------------------------------------------------------------------------------*/
/*                                                                                          */
/*   PrintDialogue                                                                          */
/*                                                                                          */
/* This class opens the PrintDialogue window to view the Prievew and options for printing.  */
/* Depends on user selection the Printer Dialogue or Privew Panel will be opened.           */
/* 
/* @version 6/8/2001 
/* @author  Shashi                                                                                         */
/*------------------------------------------------------------------------------------------*/

public class PrintDialogue extends JFrame implements AppConst, ActionListener,WindowListener {


    JPanel topPanel, middlePanel, bottomPanel;
    JLabel header;
    JLabel middlePanelText;
    JButton print, preview, cancel;
    public ApplicationPanel currentPanel;
    Frame  p;
/*-----------------------------------------------------------*/
/*                                                           */
/*   Constructor for PrintDialogue                           */
/*                                                           */
/*-----------------------------------------------------------*/
    public PrintDialogue(ApplicationPanel currentPanel,Frame parentWin){
        super("PrintDialogue"); 
        this.currentPanel = currentPanel;
        initialize();
       
        setSize(400,200);
        setResizable(false);
        
        WinUtil.centerChildInParent ( this, this.currentPanel ) ;
        p=parentWin;
        p.setEnabled(false);
        setVisible(true);
       
    }
    /*------------------------------------------------------------*/
    /* initialize
     */
    /**
     *    This method will initialize our PrintDialogue. It
     *  will create our panels and adjust our properties
     *  
     *
     *//*---------------------------------------------------------*/

      
    private void initialize(){
        
        header = new JLabel("PrintDialogue");
        topPanel = new JPanel();
        topPanel.add(header);


        middlePanelText= new JLabel("Select the Options for Preview or Print");
        middlePanel = new JPanel();
        middlePanel.add(middlePanelText);

        print = new JButton  ("   Print  ");
        preview = new JButton("  Preview ");
        cancel = new JButton ("  Cancel  ");

        bottomPanel = new JPanel();
        bottomPanel.add(print);
        bottomPanel.add(preview);
        bottomPanel.add(cancel);

        print.addActionListener(this);
        preview.addActionListener(this);
        cancel.addActionListener(this);

        getContentPane().setLayout ( new BorderLayout () ) ;

        getContentPane().add ( topPanel, BorderLayout.NORTH ) ;       
        getContentPane().add ( middlePanel, BorderLayout.CENTER ) ;
        getContentPane().add ( bottomPanel, BorderLayout.SOUTH ) ;

        addWindowListener ( this ) ;

    }
    /*------------------------------------------------------------*/
    /* ActionPerformed
     */
    /**
     *    This method will be called when a
     *   button has been pressed
     *  
     *
     *//*---------------------------------------------------------*/

    public void actionPerformed(ActionEvent ae)
    {
        if (ae.getSource()==print) {
            p.setEnabled(true);
            if ( ( currentPanel != null ) && 
                 ( currentPanel.getQuestPanel() != null  ) && ( currentPanel.getQuestPanel() instanceof PrintPanel )) {
                new Print ( ((PrintPanel)currentPanel.getQuestPanel()).getPrintObject(),this,currentPanel.getQuestPanel().getName() ) ;
            } else {
                GUISystem.printBox ( this, STR_INFO, STR_PRINTING_NOT_SUPPORTED ) ;
            }
            dispose();
        } else if (ae.getSource()==preview) {
            p.setEnabled(true);
            if ( ( currentPanel != null ) && 
                 ( currentPanel.getQuestPanel() != null  ) && ( currentPanel.getQuestPanel() instanceof PreviewPanel )) {

               Preview.setCurrentPanel(currentPanel);
               Preview prev = new Preview(((PreviewPanel)currentPanel.getQuestPanel()).getPreviewObject(),this,currentPanel.getQuestPanel().getName()) ;
            } else {
                GUISystem.printBox ( this, STR_INFO, STR_PRINTING_NOT_SUPPORTED ) ;
            }
            dispose();
            /*
              new PrintPreview(currentPanel,currentPanel);
              dispose();
            */

        } else if (ae.getSource()==cancel) {
            
            p.setEnabled(true);
            dispose();
        }

        // dispose();
    }

    /*------------------------------------------------------------*/
    /* windowDeactivated
     */
    /**
     *    This method will be called when this
     *  window is to be deactivated
     *  
     *
     *  @param e The event
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void windowDeactivated ( WindowEvent e ) {
        
    }



    /*------------------------------------------------------------*/
    /* windowActivated
     */
    /**
     *    This method will be called when the
     *  window is going to be activated
     *  
     *
     *  @param e The event
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void windowActivated ( WindowEvent e ) {

    }




    /*------------------------------------------------------------*/
    /* windowOpened
     */
    /**
     *    This method will be called when this
     *  window is opened
     *  
     *
     *  @param e The event
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void windowOpened ( WindowEvent e ) {
       //   p.setEnabled(false);
    }





    /*------------------------------------------------------------*/
    /* windowClosed
     */
    /**
     *    This method will be called as one of the
     *  last methods once this window is closed
     *  
     *
     *  @param e The event
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void windowClosed ( WindowEvent e ) {
      //  p.setEnabled(true);
    }




    /*------------------------------------------------------------*/
    /* windowDeiconified
     */
    /**
     *    This method will be called when this
     *  window is risen from an icon state
     *  
     *
     *  @param e The event
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void windowDeiconified ( WindowEvent e ) {

    }




    /*------------------------------------------------------------*/
    /* windowIconified
     */
    /**
     *    This method will be called when this
     *  window is iconified
     *  
     *
     *  @param e The WindowEvent
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void windowIconified ( WindowEvent e ) {
       p.setVisible ( true ) ;
    }




    /*------------------------------------------------------------*/
    /* windowClosing
     */
    /**
     *    This method will be called when something
     *  wants to close this window
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void windowClosing ( WindowEvent e ) {                            
        dispose() ;
        p.setVisible ( true ) ;
        p.setEnabled(true);
    }

}





