
package com.ibm.nzna.projects.qit.print ;
/*-----------------------------------------------------------*/
/*   PrintPreview                                            */
/*                                                           */
/*   Description:                                            */
/*      Source code for: Print                               */
/*                                                           */
/*                                                           */
/*         @Copyright  2001 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.util.*;
import java.awt.print.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.doc.docedit.*;
import com.ibm.nzna.projects.qit.doc.*;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.util.* ;
import java.awt.print.PrinterJob;
/**
 * This class basically will print just about anything. Please see the constructors for more 
 * information
 /*-----------------------------------------------------------*/
/* PrintPreview                                              */
/*                                                           */
/* This class basically will Preview just about anything.    */
/* @version 6/9/2001 
/* @author  Shashi
/*                                                           */
/*                                                           */
/*-----------------------------------------------------------*/

public class PrintPreview extends JFrame implements AppConst,WindowListener {


    protected         int               m_wPage;      //width of the default printing page.
    protected         int               m_hPage;      //height of the default printing page.
    protected         JComboBox         m_cbScale;    //combobox which selects a scale for preview
    protected         PreviewContainer  m_preview;    //container which holds previewing pages.
    ApplicationPanel  currentPanel;                   // The current panel that is showing
    public            AppDefaultWin     parentWin;    //  
    BufferedImage             offScreenImage;                 //The Image created from the currentPanel
    Frame  p;

    /**
     *  Default Constructor
     **/

    public PrintPreview(Container appPanel,ApplicationPanel currentP, Frame parentWin)
    {
        super("PrintPreview");
        this.currentPanel = (ApplicationPanel)currentP;
        this.parentWin = (AppDefaultWin)parentWin;

        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   Adjust properties                                       */
        /*                                                           */
        /*-----------------------------------------------------------*/

        setSize(600, 600);
        getContentPane().setLayout(new BorderLayout());
        WinUtil.centerWindow ( this ) ;
        p=parentWin;
        p.setEnabled(false);
        setVisible(true);

        /*
          ToolBar which holds the control buttons
        */

        JToolBar tb = new JToolBar();
        /*
          Print Button
        */
        JButton bt = new JButton("Print");
        ActionListener lst = new ActionListener() 
        { 
            public void actionPerformed(ActionEvent e)
            {

                p.setEnabled(true);
                print();
                dispose();
            }

        };

        bt.addActionListener(lst);
        bt.setAlignmentY(0.5f);
        bt.setMargin(new Insets(2,8,2,8));
        tb.add(bt);
        setVisible(true);


        /*
           Close  Button
         */
        bt = new JButton("Close");
        lst = new ActionListener() 
        { 
            public void actionPerformed(ActionEvent e)
            { 
                p.setEnabled(true);
                dispose();

            }
        };
        bt.addActionListener(lst);
        bt.setAlignmentY(0.5f);
        bt.setMargin(new Insets(2,8,2,8));
        tb.add(bt);
        setVisible(true);

        /*
           ComboBox whoch controls the scale of Image Preview
         */

        String[] scales = { "50 %", "25 %", "75 %", "100 %"};
        m_cbScale = new JComboBox(scales);

        lst = new ActionListener() 
        { 
            public void actionPerformed(ActionEvent e)
            { 
                Thread runner = new Thread() {
                    public void run() {
                        String str = m_cbScale.getSelectedItem().toString();
                        if (str.endsWith("%"))
                            str = str.substring(0, str.length()-1);
                        str = str.trim();
                        int scale = 0;
                        try {
                            scale = Integer.parseInt(str);
                        } catch (NumberFormatException ex) {
                            return;
                        }
                        int w = (int)(m_wPage*scale/100);
                        int h = (int)(m_hPage*scale/100);

                        Component[] comps = m_preview.getComponents();
                        for (int k=0; k<comps.length; k++) {
                            if (!(comps[k] instanceof PagePreview))
                                continue;
                            PagePreview pp = (PagePreview)comps[k];
                            pp.setScaledSize(w, h);
                        }
                        m_preview.doLayout();
                        m_preview.getParent().getParent().validate();
                    }
                };
                runner.start();
            }

        };
        m_cbScale.addActionListener(lst);
        m_cbScale.setMaximumSize(m_cbScale.getPreferredSize());
        m_cbScale.setEditable(true);
        tb.addSeparator();
        tb.add(m_cbScale);
        getContentPane().add(tb, BorderLayout.NORTH);
        setVisible(true);
        addWindowListener ( this ) ;

        m_preview = new PreviewContainer();

        int         width              =  appPanel.getWidth() ;
        int         height             =  appPanel.getHeight() ;


        if (width==0 || height==0) {
            System.err.println("Unable to determine default page size");
            return;
        }



        /*
        an instance of BufferedImage is created with width  and height . 
        */
        if (appPanel instanceof MultiList) {
            offScreenImage = ((MultiList)appPanel).getPreviewImage();
            height = offScreenImage.getHeight();
            width =  offScreenImage.getWidth();
        } else {

            offScreenImage      =  new BufferedImage(width,height,BufferedImage.TYPE_INT_RGB);
            Graphics g=offScreenImage.getGraphics();
            g.setColor(Color.white);
            g.fillRect(0, 0, m_wPage, m_hPage);
            appPanel.paintAll(g);
        } 

        m_wPage = width;
        m_hPage = height;
        int scale = 50;
        int w = (int)(m_wPage*scale/100);
        int h = (int)(m_hPage*scale/100);

        /*
         a new PagePreview component is created and newly created 
         BufferedImage is passed to the PagePreview constructor
         */

        PagePreview pp = new PagePreview(w, h, offScreenImage);
        m_preview.add(pp);


        JScrollPane ps = new JScrollPane(m_preview);
        getContentPane().add(ps, BorderLayout.CENTER);
        setDefaultCloseOperation(DISPOSE_ON_CLOSE);
        setVisible(true);

    }
     /*------------------------------------------------------------*/
    /* windowDeactivated
     */
    /**
     *    This method will be called when this
     *  window is to be deactivated
     *  
     *
     *  @param e The event
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void windowDeactivated ( WindowEvent e ) {
        
    }



    /*------------------------------------------------------------*/
    /* windowActivated
     */
    /**
     *    This method will be called when the
     *  window is going to be activated
     *  
     *
     *  @param e The event
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void windowActivated ( WindowEvent e ) {

    }




    /*------------------------------------------------------------*/
    /* windowOpened
     */
    /**
     *    This method will be called when this
     *  window is opened
     *  
     *
     *  @param e The event
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void windowOpened ( WindowEvent e ) {
       //   p.setEnabled(false);
    }





    /*------------------------------------------------------------*/
    /* windowClosed
     */
    /**
     *    This method will be called as one of the
     *  last methods once this window is closed
     *  
     *
     *  @param e The event
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void windowClosed ( WindowEvent e ) {
      //  p.setEnabled(true);
    }




    /*------------------------------------------------------------*/
    /* windowDeiconified
     */
    /**
     *    This method will be called when this
     *  window is risen from an icon state
     *  
     *
     *  @param e The event
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void windowDeiconified ( WindowEvent e ) {

    }




    /*------------------------------------------------------------*/
    /* windowIconified
     */
    /**
     *    This method will be called when this
     *  window is iconified
     *  
     *
     *  @param e The WindowEvent
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void windowIconified ( WindowEvent e ) {
        p.setVisible ( true ) ;
    }




    /*------------------------------------------------------------*/
    /* windowClosing
     */
    /**
     *    This method will be called when something
     *  wants to close this window
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void windowClosing ( WindowEvent e ) {                            
        dispose() ;
        p.setVisible ( true ) ;
        p.setEnabled(true);
    }

    private void print () {

        if ( ( currentPanel != null ) && 
             ( currentPanel.getQuestPanel() != null  ) &&
             ( currentPanel.getQuestPanel() instanceof PrintPanel ) ) {
            new Print ( ((PrintPanel)currentPanel.getQuestPanel()).getPrintObject(),
                        this,
                        currentPanel.getQuestPanel().getName() ) ;
        } else
            GUISystem.printBox ( this, STR_INFO, STR_PRINTING_NOT_SUPPORTED ) ;
    }

    /*
      This inner class extends JPanel to serve as a container for PagePreview components. 
      The only reason this custom container is developed is because we have specific layout 
      requirements. (we assume scrolling functionality will be made available).
    */


    class PreviewContainer extends JPanel {
        protected int H_GAP = 16 ;
        protected int V_GAP = 10 ;

        public Dimension getPreferredSize()
        {
            int n = getComponentCount();
            if (n == 0)
                return new Dimension(H_GAP, V_GAP);
            Component comp = getComponent(0);
            Dimension dc = comp.getPreferredSize();
            int w = dc.width;
            int h = dc.height;

            Dimension dp = getParent().getSize();
            int nCol = Math.max((dp.width-H_GAP)/(w+H_GAP), 1);
            int nRow = n/nCol;
            if (nRow*nCol < n)
                nRow++;

            int ww = nCol*(w+H_GAP) + H_GAP ;
            int hh = nRow*(h+V_GAP) + V_GAP ;
            Insets ins = this.getInsets();
            return new Dimension(ww+ins.left+ins.right,hh+ins.top+ins.bottom);
        }

        public Dimension getMaximumSize()
        {
            return getPreferredSize();
        }

        public Dimension getMinimumSize()
        {
            return getPreferredSize();
        }

        public void doLayout()
        {
            Insets ins = this.getInsets();
            int x = ins.left + H_GAP;
            int y = ins.top + V_GAP;

            int n = getComponentCount();
            if (n == 0)
                return;
            Component comp = getComponent(0);
            Dimension dc = comp.getPreferredSize();
            int w = dc.width;
            int h = dc.height;
            Dimension dp = getParent().getSize();
            int nCol = Math.max((dp.width-H_GAP)/(w+H_GAP), 1);
            int nRow = n/nCol;
            if (nRow*nCol < n)
                nRow++;

            int index = 0;
            for (int k = 0; k<nRow; k++) {
                for (int m = 0; m<nCol; m++) {
                    if (index >= n)
                        return;
                    comp = getComponent(index++);
                    comp.setBounds(x, y, w, h);
                    x += w+H_GAP;
                }
                y += h+V_GAP;
                x = ins.left + H_GAP;
            }
        }

    }

    /*
        This inner class extends JPanel to serve as a placeholder for 
        the image of each printed page preview. 
    */

    class PagePreview extends JPanel {

        protected int m_w ;             // current component's width 
        protected int m_h ;             // current component's height 
        protected Image appPanel ;      // source image depicting the previewed page in full scale
        protected Image m_img ;         // scaled image currently used for rendering


        /**
         *  PagePreview Constructor
        **/

        public PagePreview(int w, int h, Image source)
        {
            m_w = w;
            m_h = h;
            appPanel= source;
            m_img = appPanel.getScaledInstance(m_w, m_h,Image.SCALE_SMOOTH);
            m_img.flush();
            this.setBackground(Color.white);
            this.setBorder(new MatteBorder(1, 1, 2, 2, Color.black));

        }

        public void setScaledSize(int w, int h)
        {
            m_w = w;
            m_h = h;
            m_img = appPanel.getScaledInstance(m_w, m_h,Image.SCALE_SMOOTH);
            repaint();
        }

        public Dimension getPreferredSize()
        {
            Insets ins = this.getInsets();
            return new Dimension(m_w+ins.left+ins.right,m_h+ins.top+ins.bottom);
        }

        public Dimension getMaximumSize()
        {
            return getPreferredSize();
        }

        public Dimension getMinimumSize()
        {
            return getPreferredSize();
        }

        public void paint(Graphics g)
        {
            g.setColor(getBackground());
            g.fillRect(0, 0, this.getWidth(), this.getHeight());
            g.drawImage(m_img, 0, 0, this);
            paintBorder(g);

        }
    }
}




