package com.ibm.nzna.projects.qit.product.gui ;         
/*-----------------------------------------------------------*/
/*   BrandMappingRow                                         */
/*                                                           */
/*   Description:                                            */
/*      Source code for: BrandMappingRow                     */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
/**
 * This object holds the Brand/Family/Series and Quest Brand/Family  for
 * use in a MultiList.
 *
 *
 * @version 1.0, 9/3/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   BrandMappingRow                                         */
/*                                                           */
/*-----------------------------------------------------------*/
public class BrandMappingRow extends Object implements MultiListRow, MultiListSort {

   public TypeCategoryRec oBrand    = null ;
   public TypeCategoryRec oFamily   = null ;
   public TypeCategoryRec oSeries   = null ;
   public TypeCategoryRec brand     = null ;
   public TypeCategoryRec family    = null ;



   public Object getColumnData ( int column ) {
      Object retObject = null ;

      switch ( column ) {
         case 0 :
            retObject=oBrand ;
            break ;

         case 1 :
            retObject=oFamily ;
            break ;

         case 2 :
            retObject = oSeries ;
            break ;

         case 3 :
            retObject = brand ;
            break ;

         case 4 :
            retObject = family ;
            break ;
      }

      if ( retObject == null )
         return( "" ) ;
      return( retObject ) ;
   }


   public int compareTo ( MultiListSort sort, int column ) {
      int rc = 0 ;

      try {
         BrandMappingRow sortRow = (BrandMappingRow) sort ;

         switch ( column ) {
            case 0 :
               if ( oBrand == null )
                  rc = -1 ;
               else if ( sortRow.oBrand == null )
                  rc = 1 ;
               else
                  rc = sortRow.oBrand.toString().compareTo ( oBrand.toString()) ;
               break ;

            case 1 :
               if ( oFamily == null )
                  rc = -1 ;
               else if ( sortRow.oFamily == null )
                  rc = 1 ;
               else
                  rc = sortRow.oFamily.toString().compareTo ( oFamily.toString()) ;
               break ;

            case 2 :
               if ( oSeries == null )
                  rc = -1 ;
               else if ( sortRow.oSeries == null )
                  rc = 1 ;
               else
                  rc = sortRow.oSeries.toString().compareTo ( oSeries.toString()) ;
               break ;

            case 3 :
               if ( brand == null )
                  rc = -1 ;
               else if ( sortRow.brand == null )
                  rc = 1 ;
               else
                  rc = sortRow.brand.toString().compareTo ( brand.toString()) ;
               break ;

            case 4 :
               if ( family == null )
                  rc = -1 ;
               else if ( sortRow.family == null )
                  rc = 1 ;
               else
                  rc = sortRow.family.toString().compareTo ( family.toString()) ;
               break ;
         }
      } catch ( Exception e ) {
         return( 1 ) ;
      }

      return( rc ) ;
   }
} /* BrandMappingRow */
