package com.ibm.nzna.projects.qit.product.gui ;         
/*-----------------------------------------------------------*/
/*   CountryMappingRow                                       */
/*                                                           */
/*   Description:                                            */
/*      Source code for: CountryMappingRow                   */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
/**
 * This object holds the Brand/Family/Series and Quest Brand/Family  for
 * use in a MultiList.
 *
 *
 * @version 1.0, 9/3/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   CountryMappingRow                                       */
/*                                                           */
/*-----------------------------------------------------------*/
public class CountryMappingRow extends Object implements MultiListRow, MultiListSort {

   public TypeCategoryRec    oGeo       = null ;
   public TypeCategoryRec    oCountry   = null ;
   public TypeCountryCodeRec countryRec = null ;



   public Object getColumnData ( int column ) {
      Object retObject = null ;

      switch ( column ) {
         case 0 :
            retObject=oGeo ;
            break ;

         case 1 :
            retObject=oCountry ;
            break ;

         case 2 :
            retObject = countryRec ;
            break ;

      }

      if ( retObject == null )
         return( "" ) ;
      return( retObject ) ;
   }


   public int compareTo ( MultiListSort sort, int column ) {
      int rc = 0 ;

      try {
         CountryMappingRow sortRow = (CountryMappingRow)sort ;

         switch ( column ) {
            case 0 :
               if ( oGeo == null )
                  rc = -1 ;
               else if ( sortRow.oGeo == null )
                  rc = 1 ;
               else
                  rc = sortRow.oGeo.toString().compareTo ( oGeo.toString()) ;
               break ;

            case 1 :
               if ( oCountry == null )
                  rc = -1 ;
               else if ( sortRow.oCountry == null )
                  rc = 1 ;
               else
                  rc = sortRow.oCountry.toString().compareTo ( oCountry.toString()) ;
               break ;

            case 2 :
               if ( countryRec == null )
                  rc = -1 ;
               else if ( sortRow.countryRec == null )
                  rc = 1 ;
               else
                  rc = sortRow.countryRec.toString().compareTo ( countryRec.toString()) ;
               break ;
         }
      } catch ( Exception e ) {
         return( 1 ) ;
      }

      return( rc ) ;
   }
} /* CountryMappingRow */
