package com.ibm.nzna.projects.qit.product.history ;
/*-----------------------------------------------------------*/
/*   ProductHistory                                          */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ProductHistory                      */
/*                                                           */
/*                                                           */
/*         @Copyright  2001 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/

/**
 *
 *
 * This QuestApplet allows an author to view history on a product
 *
 *
 * @author  Brian R Bokor
 * @version 1.0
 */

import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.product.history.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.qit.product.*;
import com.ibm.nzna.projects.common.quest.product.*;
import javax.swing.* ;

/*----------------------------------------------------
/*
/* ProductHistory Class
/*
/*----------------------------------------------------*/
public class ProductHistory extends Object implements QuestApplet, AppConst, ProductConst {

    /*-----------------------------------------------------------*/
    /*                                                           */
    /*   Private Members                                         */
    /*                                                           */
    /*-----------------------------------------------------------*/

   /**
    * This will be used to set up the QuestPanel for where the
    * product's will be displayed.
    */
    private ProductHistoryPanel productHistoryPanel = null ;
    /**
    * This is where the ProductHistory came from
    */
    private QuestPanel          previousPanel       = null ;

    /*------------------------------------------------------------*/
    /* Constructor
     */
    /**
     *    This constructor like all good Quest Applets
     *  does nothing
     *
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public ProductHistory( ) {
    }/*constuctor*/

    /*------------------------------------------------------------*/
    /* Constructor
     */
    /**
     *    This constructor like all good Quest Applets
     *  does nothing
     *
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public ProductHistory( QuestPanel previousPanel ) {
      this.previousPanel = previousPanel ;
    }/*constructor*/

    /*------------------------------------------------------------*/
    /* getName
     */
    /**
     *    This method will return the name
     *  of this Quest Applet
     *
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public String getName() {
      return( Str.getStr ( STR_PRODUCT_HISTORY ) ) ;
    }/*getName*/

    /*------------------------------------------------------------*/
    /* getDescription
     */
    /**
     *    This method will return a user readable
     *  description of this Quest Applet
     *
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public String getDescription() {
      return( Str.getStr ( STR_PRODUCT_HISTORY_DESCRIPTION ) ) ;
    }/*getDescription*/

    /*------------------------------------------------------------*/
    /* getAuthority
     */
    /**
     *    This method will return 0, since everyone
     *  has access to the browser
     *
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public int getAuthority() {
      return ( 0 );
    }/*getAuthority*/

    /*------------------------------------------------------------*/
    /* canChat
     */
    /**
     *    This method will return TRUE, since
     *  the web browser can chat with other
     *  web browsers
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public boolean canChat() {
      return ( false );
    }/*canChat*/

    /*------------------------------------------------------------*/
    /* initialize
     */
    /**
     *    This method will initialize our browser
     *  bean as well as get everything else
     *  ready
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public boolean initialize( ) {
        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   First, create our panel that holds the browser          */
        /*                                                           */
        /*-----------------------------------------------------------*/
      if ( previousPanel == null )
        productHistoryPanel = new ProductHistoryPanel ( null ) ;
      else
        productHistoryPanel = new ProductHistoryPanel ( previousPanel ) ;

      return( true ) ;
    }/*initialize*/

    /*------------------------------------------------------------*/
    /* start
     */
    /**
     *    This method will be called when our
     *  initialization has completed, and we
     *  can now add ourselves to a window
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void start() {
         WindowSystem.createPanel ( productHistoryPanel ) ;
    }/*start*/

    /*------------------------------------------------------------*/
    /* stop
     */
    /**
     *    This method will be called when we need
     *  to clean up and stop our Panel
     *
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return boolean
     *//*---------------------------------------------------------*/
    public boolean stop() {
      return ( true );
    }/*stop*/

    /*------------------------------------------------------------*/
    /* shutdown
     */
    /**
     *    This method will be called to ask us
     *  if we can shutdown. Of course we can.
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return boolean
     *//*---------------------------------------------------------*/
    public boolean shutdown() {
      return ( true );
    }/*shutdown*/

    /*------------------------------------------------------------*/
    /* getSmallIcon
     */
    /**
     *    This method will return the small icon
     *  representing this Quest Applet
     *
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public ImageIcon getSmallIcon() {
      return( ImageSystem.getImageIcon ( this, ImageSystem.PRODUCT_HISTORY_SMALL ) ) ;
    }/*getSmallIcon

    /*------------------------------------------------------------*/
    /* getIcon
     */
    /**
     *    This method will return our normal
     *  sized icon
     *
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return ImageIcon
     *//*---------------------------------------------------------*/
    public ImageIcon getIcon() {
        return( ImageSystem.getImageIcon ( this, ImageSystem.PRODUCT_HISTORY_LARGE ) ) ;
    }/*getIcon*/
}/* ProductHistory */
