package com.ibm.nzna.projects.qit.product.history;
/*-----------------------------------------------------------*/
/*   ProductHistoryRec                                       */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ProductHistoryRec                   */
/*                                                           */
/*                                                           */
/*         @Copyright  2001 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.qit.product.* ;
import com.ibm.nzna.projects.common.quest.product.*;
/**
 * This class represents a single Product in history
 *
 *
 * @version 1.0, 06/07/2001
 * @author  Brian Bokor
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ProductHistoryRec                                       */
/*                                                           */
/*-----------------------------------------------------------*/
public class ProductHistoryRec extends Object implements ProductConst, AppConst{  

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/

   /**
    *  This variable is the ProdInd of the current Product
    */
    protected int    prodInd              = 0 ;
   /**
    *  This variable is the CreatedBy of the current Product
    */                                                     
    protected String createdBy            = null ;
   /**
    *  This variable is the CreatedBy of the current Product 
    */                                               
    protected String stopDate             = null ;


   /*------------------------------------------------------------*/
   /* setProdInd
    */
   /**
    *    This Method will set the ProdInd of the DB record
    *
    *
    *  @param int
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
    public void setProdInd ( int prodInd  ) {
      this.prodInd = prodInd ;
    }/* setProdInd */

   /*------------------------------------------------------------*/
   /* setCreatedBy
    */
   /**
    *    This Method will set Created By String of the DB record
    *
    *
    *  @param String
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
    public void setCreatedBy ( String createdBy  ) {
      this.createdBy = createdBy ;
    }/* setCreatedBy */

   /*------------------------------------------------------------*/
   /* setStopDate
    */
   /**
    *    This Method will set StopDate String of the DB record
    *
    *
    *  @param String
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
    public void setStopDate ( String stopDate  ) {
      this.stopDate = stopDate ;
    }/* setStopDate */

   /*------------------------------------------------------------*/
   /* getProdInd
    */
   /**
    *    This Method will get the ProdInd for the product
    *    history list in the left nav
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return int
    *//*---------------------------------------------------------*/
    public int getProdInd ( ) {
      return ( prodInd );
    }/* getProdInd */

   /*------------------------------------------------------------*/
   /* getCreatedBy
    */
   /**
    *    This Method will get Created By String for the product
    *    history list in the left nav
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String
    *//*---------------------------------------------------------*/
    public String getCreatedBy ( ) {
      return ( createdBy ) ;
    }/* getCreatedBy */

   /*------------------------------------------------------------*/
   /* getStopDate
    */
   /**
    *    This Method will get StopDate String for the product
    *    history list in the left nav
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String
    *//*---------------------------------------------------------*/
    public String getStopDate ( ) {
      return ( stopDate ) ;
    }/* getStopDate */        
}/* ProductHistoryRec */

