package com.ibm.nzna.projects.qit.product.history;
/*-----------------------------------------------------------*/
/*   ProductHistoryRow                                       */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ProductHistoryRow                   */
/*                                                           */
/*                                                           */
/*         @Copyright  2001 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.qit.product.* ;
import com.ibm.nzna.projects.common.quest.product.*;
/**
 * This class represents a single row in the MultiList
 *
 *
 * @version 1.0, 08/28/2001
 * @author  Brian Bokor
 */                              

/*-----------------------------------------------------------*/
/*                                                           */
/*   ProductHistoryRow                                       */
/*                                                           */
/*-----------------------------------------------------------*/
public class ProductHistoryRow extends Object implements MultiListRow{ 

   /**
    *  This is the Product that is the Row listed in the MultiList
    */
    public ProductHistoryRec historyRec   = null ;
   
   
   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This Method will take in a ProductHistoryRec
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
    public ProductHistoryRow ( ProductHistoryRec historyRec ) {
        this.historyRec = historyRec;
    }/*constructor*/

    /*------------------------------------------------------------*/
   /* getColumnData
    */
   /**
    *    This Method will return the data supposed to be in 
    *    MultiList's columns
    *
    *  @param int
    *  @param None
    *  @param None
    *
    *  @return Object
    *//*---------------------------------------------------------*/
    public Object getColumnData ( int column ) {

        Object object    = null;  

        switch( column ){
            case 0:
                object = ""+historyRec.getProdInd();
                break;
            case 1:
                object = historyRec.getStopDate();
                break;
            case 2:
                object = historyRec.getCreatedBy();
                break;
         }/*end of switch*/

        return( object );

    }/* getColumnData */

   
   /*------------------------------------------------------------*/
   /* getProdInd
    */
   /**
    *    This Method will return the ProductHistoryRec's ProdInd for
    *    searching for that product in the Database
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return int
    *//*---------------------------------------------------------*/
    public int getProductInd (  ) {
        return( historyRec.getProdInd() ) ;
    }/* getProductInd */
}/*ProductHistoryRow*/

