package com.ibm.nzna.projects.qit.product.history ;
/*-----------------------------------------------------------*/
/*   ProductHistorySQL                                       */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ProductHistorySQL                   */
/*                                                           */
/*                                                           */
/*         @Copyright  2001 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.sql.* ;
import java.util.Vector ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.qit.doc.* ;
import com.ibm.nzna.shared.db.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.common.quest.product.*;
import com.ibm.nzna.projects.qit.product.*;
/**
 * This class hold a routine for manipulating history records
 * of a Product
 *
 * @version 1.0, 06/14/2001
 * @author  Brian Bokor
 */


/*-----------------------------------------------------------*/
/*                                                           */
/*   ProductHistorySQL                                       */
/*                                                           */
/*-----------------------------------------------------------*/
public class ProductHistorySQL extends Object implements ProductConst, AppConst {


   /*-----------------------------------------------------------*/
   /* readHistory
    */
   /**
    *    This method will read a product's history records
    *
    *
    *
    *  @param docInd The Existing Document Ind to check history for
    *  @param
    *  @param
    *
    *  @return Vector The vector of Products
    *//*--------------------------------------------------------*/
   public static Vector readHistory ( AppDefaultWin win, int prodInd ) {

      int       historyNumber = 0;
      String    rtnName       = "readHistory" ;
      SQLMethod sql           = new SQLMethod ( DatabaseSystem.QUEST, rtnName, 5 ) ;
      int       sqlCode       = 0 ;
      Vector    retVec        = new Vector ( 10, 1 ) ;

      win.setStatus ( STR_PLEASE_WAIT ) ;

      if ( sql != null ) {
         try {
            ProductHistoryRec historyRec  = null ;
            Statement stmt      = sql.createStatement() ;

            if ( stmt != null ) {

                ResultSet rs = stmt.executeQuery ( "SELECT A.PRODUCTIND, A.STOPDATE, A.CREATEDBY "+ 
                                                   "  FROM PRODRAFT.PRODUCT A, PRODUCT.PRODUCT B "+               
                                                   " WHERE A.EXISTINGPRODUCTIND = "+prodInd+" AND "+              
                                                   "       A.STOPDATE IS NOT NULL AND" +                          
                                                   "       B.PRODUCTIND = A.EXISTINGPRODUCTIND" +                 
                                                   " ORDER BY 1" ) ;                                              


               LogSystem.beginLogSection ( "Reading Product History" ) ;

               while ( rs.next() ) { 

                  historyRec = new ProductHistoryRec() ;

                  historyRec.setProdInd ( rs.getInt(1) ) ;                                  
                  historyRec.setStopDate ( CDate.convertDate ( CDate.DATE_DBDATE,           
                                                               CDate.DATE_DATE,             
                                                               rs.getString(2).trim() ) ) ; 
                  historyRec.setCreatedBy ( rs.getString(3).trim() ) ;                      

                  retVec.addElement ( new ProductHistoryRow( historyRec ) ) ;
                  historyNumber++;
                  LogSystem.log ( 1, "Found " + historyNumber + "Product History Record" ) ;
               }/*while*/

               rs.close() ;
               LogSystem.endLogSection ();
            }/*if*/

         } catch ( Exception e ) {
            sql.rollBack() ;
            LogSystem.log ( 1, e ) ;
         }
      } /* if */

      sql.close() ;
      win.setStatus ( null ) ;

      return( retVec ) ;
   } /* readHistory */
} /* ProductHistorySQL */

