package com.ibm.nzna.projects.qit.product.manager ;   
/*-----------------------------------------------------------*/
/*   BrandMapDlg                                             */
/*                                                           */
/*   Description:                                            */
/*      Source code for: BrandMapDlg                         */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.sql.* ;
import java.awt.* ;
import java.awt.event.* ;
import java.util.* ;
import javax.swing.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.db.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.qit.product.* ;
import com.ibm.nzna.projects.qit.product.gui.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.quest.brand.* ;
import com.ibm.nzna.projects.common.quest.product.* ;
/**
 * This window allows the user to make a mapping between OPIC/M 
 * Brands/Family/Series and Quest Brands/Families
 *
 *
 * @version 1.0, 9/3/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   BrandMapDlg                                             */
/*                                                           */
/*-----------------------------------------------------------*/
public class BrandMapDlg extends JDialog implements ActionListener, AppConst, ProductConst {


   /**
     *  This is the mapping that we are editing
     **/
   private BrandMappingRow mapRow = null ;

   /**
     *  This is the Ok Button
     **/
   private DButton pb_OK      = new DButton ( Str.getStr ( STR_OK ) ) ;

   /**
     *  This is the Cancel button
     **/
   private DButton pb_CANCEL  = new DButton ( Str.getStr ( STR_CANCEL ) ) ;

   /**
     *  This is the text for the OPIC/M Brand
     **/
   private JLabel st_OBRAND   = new JLabel ( "OBrand" ) ;

   /**
     *  This is the text for the OPIC/M Family
     **/
   private JLabel st_OFAMILY = new JLabel ( "OFamily" ) ;

   /**
     *  This is the text for the OPIC/M Series
     **/
   private JLabel st_OSERIES = new JLabel ( "OSeries" ) ;

   /**
     *  This is the JLabel for the Quest Brand
     **/
   private JLabel st_BRAND = new JLabel ( Str.getStr ( STR_BRAND ) ) ;

   /**
     *  This is the JLabel for the Quest Family
     **/
   private JLabel st_FAMILY = new JLabel ( Str.getStr ( STR_FAMILY ) ) ;

   /**
     *  This is the Drop down for OPIC/M Brands
     **/
   private JComboBox cb_OBRAND = new JComboBox ( ) ;

   /**
     *  This is the Drop Down for the OPIC/M Families
     **/
   private JComboBox cb_OFAMILY = new JComboBox ( ) ;

   /**
     *  This is the Drop Down for the OPIC/M Series
     **/
   private JComboBox cb_OSERIES = new JComboBox ( ) ;

   /**
     *  This is the Drop Down for the Quest Brand
     **/
   private JComboBox cb_BRAND = new JComboBox ( ) ;

   /**
     *  This is the Drop Down for the Quest Family
     **/
   private JComboBox cb_FAMILY = new JComboBox ( ) ;


   /**
     *  This is the 'New' button for a new OPIC/M Brand
     **/
   private HotLinkLabel pb_NEW_OBRAND = new HotLinkLabel ( Str.getStr ( STR_NEW ) ) ;

   /**
     *  This is the 'New' button for a new OPIC/M Family
     **/
   private HotLinkLabel pb_NEW_OFAMILY = new HotLinkLabel ( Str.getStr ( STR_NEW ) ) ;


   /**
     *  This is the 'New' button for a new OPIC/M Series
     **/
   private HotLinkLabel pb_NEW_OSERIES = new HotLinkLabel ( Str.getStr ( STR_NEW ) ) ;


   /**
     *  Default constructor shows the dialog and does not return
     * until the user closes the window
     **/
   public BrandMapDlg ( Frame parent, BrandMappingRow mapRow ) {
      super ( parent, Str.getStr ( STR_DATA_MAPPING ), true ) ;
      this.mapRow = mapRow ;
      initialize () ;

      setVisible ( true ) ;
   }

   /**
     *  This method will initialize and add our GUI
     **/
   private void initialize () {
      Container contentPane = getContentPane() ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setResizable ( false ) ;      
      pb_NEW_OBRAND.showSelection ( false ) ;
      pb_NEW_OFAMILY.showSelection ( false ) ;
      pb_NEW_OSERIES.showSelection ( false ) ;
      cb_OBRAND.setModel ( new DefaultComboBoxModel() ) ;
      cb_OFAMILY.setModel ( new DefaultComboBoxModel() ) ;
      cb_OSERIES.setModel ( new DefaultComboBoxModel() ) ;
      cb_BRAND.setModel ( new DefaultComboBoxModel() ) ;
      cb_FAMILY.setModel ( new DefaultComboBoxModel() ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add Listeners                                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      pb_OK.addActionListener          ( this ) ;
      pb_CANCEL.addActionListener      ( this ) ;
      cb_OBRAND.addActionListener      ( this ) ;
      cb_OFAMILY.addActionListener     ( this ) ;
      cb_OSERIES.addActionListener     ( this ) ;
      cb_BRAND.addActionListener       ( this ) ;
      cb_FAMILY.addActionListener      ( this ) ;
      pb_NEW_OBRAND.addActionListener  ( this ) ;
      pb_NEW_OFAMILY.addActionListener ( this ) ;
      pb_NEW_OSERIES.addActionListener ( this ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add Data                                                */
      /*                                                           */
      /*-----------------------------------------------------------*/
      WinUtil.setJComboBoxData ( cb_OBRAND,  TypeCategory.getCategories ( TypeCategory.LEVEL_OPICM_BRAND ) ) ;
      WinUtil.setJComboBoxData ( cb_OFAMILY, createEmptyList() ) ;
      WinUtil.setJComboBoxData ( cb_OSERIES, createEmptyList() ) ;
      WinUtil.setJComboBoxData ( cb_BRAND,   Brands.getBrands() ) ;
      WinUtil.setJComboBoxData ( cb_FAMILY,  createEmptyList() ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add our GUI                                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      contentPane.setLayout ( null ) ;
      contentPane.add ( st_OBRAND ) ;
      contentPane.add ( cb_OBRAND ) ;
      contentPane.add ( pb_NEW_OBRAND ) ;
      contentPane.add ( st_OFAMILY ) ;
      contentPane.add ( cb_OFAMILY ) ;
      contentPane.add ( pb_NEW_OFAMILY ) ;
      contentPane.add ( st_OSERIES ) ;
      contentPane.add ( cb_OSERIES ) ;
      contentPane.add ( pb_NEW_OSERIES ) ;
      contentPane.add ( st_BRAND ) ;
      contentPane.add ( cb_BRAND ) ;
      contentPane.add ( st_FAMILY ) ;
      contentPane.add ( cb_FAMILY ) ;
      contentPane.add ( pb_OK ) ;
      contentPane.add ( pb_CANCEL ) ;                                       


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Select the value from the mapping we were passed        */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( mapRow != null ) {
         if ( mapRow.oBrand != null )
            cb_OBRAND.setSelectedItem ( mapRow.oBrand ) ;
         if ( mapRow.oFamily != null )
            cb_OFAMILY.setSelectedItem ( mapRow.oFamily ) ;
         if ( mapRow.oSeries != null )
            cb_OSERIES.setSelectedItem ( mapRow.oSeries ) ;
         if ( mapRow.brand != null )
            cb_BRAND.setSelectedItem ( mapRow.brand ) ;
         if ( mapRow.family != null )
            cb_FAMILY.setSelectedItem ( mapRow.family ) ;


         cb_OBRAND.setEnabled  ( mapRow.oBrand  == null ) ;
         cb_OFAMILY.setEnabled ( mapRow.oFamily == null ) ;
         cb_OSERIES.setEnabled ( mapRow.oSeries == null ) ;
      }


      setSize ( 400, 200 );
      WinUtil.centerWindow ( this ) ;
   }


   /**
     *  This method will lay out and position all of our controls
     **/
   public void doLayout ( ) {
      Dimension size      = getSize () ;
      int       rowHeight = GUISystem.getRowHeight () ;
      int       x         = 35 ;
      int       y         = 5 ;

      super.doLayout() ;

      st_OBRAND.setBounds ( x, y, 100, rowHeight ) ;
      cb_OBRAND.setBounds ( x+100, y, 200, rowHeight ) ;
      pb_NEW_OBRAND.setBounds ( x+305, y, 70, rowHeight ) ;
      y+=rowHeight+5 ;

      st_OFAMILY.setBounds ( x, y, 100, rowHeight ) ;
      cb_OFAMILY.setBounds ( x+100, y, 200, rowHeight ) ;
      pb_NEW_OFAMILY.setBounds ( x+305, y, 70, rowHeight ) ;
      y+=rowHeight+5 ;

      st_OSERIES.setBounds ( x, y, 100, rowHeight ) ;
      cb_OSERIES.setBounds ( x+100, y, 200, rowHeight ) ;
      pb_NEW_OSERIES.setBounds ( x+305, y, 70, rowHeight ) ;
      y+=rowHeight+5 ;

      st_BRAND.setBounds ( x, y, 100, rowHeight ) ;
      cb_BRAND.setBounds ( x+100, y, 200, rowHeight ) ;
      y+=rowHeight+5 ;

      st_FAMILY.setBounds ( x, y, 100, rowHeight ) ;
      cb_FAMILY.setBounds ( x+100, y, 200, rowHeight ) ;
      y+=rowHeight+5 ;

      pb_OK.setBounds ( 5, size.height-60, 75, 25 ) ;
      pb_CANCEL.setBounds ( 85, size.height-60, 75, 25 ) ;
   }


   /**
     *  This method will be called when the user selects a
     * drop down
     **/
   public void actionPerformed ( ActionEvent e ) {

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   cb_OBRAND                                               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( e.getSource() == cb_OBRAND ) {
         if ( selectionValid ( cb_OBRAND ) )
            refreshOFamilies ( (TypeCategoryRec)cb_OBRAND.getSelectedItem() ) ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   cb_OFAMILY                                              */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == cb_OFAMILY ) {
         if ( selectionValid ( cb_OFAMILY ) )
            refreshOSeries ( (TypeCategoryRec) cb_OFAMILY.getSelectedItem() ) ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Brand                                                   */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == cb_BRAND ) {
         if ( selectionValid ( cb_BRAND ) )
            refreshFamilies ( (TypeCategoryRec)cb_BRAND.getSelectedItem() ) ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_OK                                                   */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_OK ) {
         if ( saveData() )
            dispose() ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_CANCEL                                               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_CANCEL )
         dispose() ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_NEW_OBRAND                                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_NEW_OBRAND )
         createNewOBrand() ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_NEW_OFAMILY                                          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_NEW_OFAMILY ) {
         if ( selectionValid ( cb_OBRAND ) )
            createNewOFamily() ;
         else
            GUISystem.printBox ( this, "Info", "Please select an OPIC/M Brand first" ) ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_NEW_OSERIES                                          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_NEW_OSERIES ) {
         if ( selectionValid ( cb_OFAMILY ) )
            createNewOSeries() ;
         else
            GUISystem.printBox ( this, "Info", "Please select an OPIC/M Family first" ) ;
      }



   }


   /**
     *  This method will return an empty list with a 'Select an Item'
     * in it
     **/
   private Vector createEmptyList () {
      Vector list = new Vector () ;
      list.addElement ( Str.getStr ( STR_SELECT_ITEM ) ) ;
      return( list ) ;
   }

   /**
     *  This method will determine if an item in a JComboBox is valid
     * for a selection. It determines this by looking if the selected item
     * is an instance of TypeCategoryRec
     **/
   private boolean selectionValid ( JComboBox comboBox ) {
      return( comboBox.getSelectedItem() instanceof TypeCategoryRec ) ;
   }


   /**
     *  This method will refresh the OPIC/M Families under the brand
     * passed in
     **/
   private void refreshOFamilies ( TypeCategoryRec brand ) {

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   First, take off the current drop downs                  */
      /*                                                           */
      /*-----------------------------------------------------------*/
      ((DefaultComboBoxModel)cb_OFAMILY.getModel()).removeAllElements() ;
      ((DefaultComboBoxModel)cb_OSERIES.getModel()).removeAllElements() ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Now, recreate them                                      */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( brand != null ) {
         WinUtil.setJComboBoxData ( cb_OFAMILY, TypeCategory.getChildCategories ( brand.getInd(), TypeCategory.LEVEL_OPICM_FAMILY )  ) ;
         try {
            WinUtil.setJComboBoxData ( cb_OSERIES, TypeCategory.getChildCategories ( ((TypeCategoryRec)cb_OFAMILY.getSelectedItem()).getInd(), TypeCategory.LEVEL_OPICM_SERIES ) ) ;
         } catch ( Exception e ) {
            WinUtil.setJComboBoxData ( cb_OSERIES, createEmptyList() ) ;
         }
      } else {
         WinUtil.setJComboBoxData ( cb_OFAMILY, createEmptyList() ) ;
         WinUtil.setJComboBoxData ( cb_OSERIES, createEmptyList() ) ;
      }

      doLayout() ;
   }


   /**
     *  This method will refresh the OPIC/M Series by the family passed in
     **/
   private void refreshOSeries ( TypeCategoryRec family ) {

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Remove the control                                      */
      /*                                                           */
      /*-----------------------------------------------------------*/
      ((DefaultComboBoxModel)cb_OSERIES.getModel()).removeAllElements() ;

      if ( family != null )
         WinUtil.setJComboBoxData ( cb_OSERIES, TypeCategory.getChildCategories ( family.getInd(), TypeCategory.LEVEL_OPICM_SERIES ) ) ;
      else
         WinUtil.setJComboBoxData ( cb_OSERIES, createEmptyList() ) ;

      doLayout() ;
   }


   /**
     *  This method will refresh the list of quest families
     **/
   private void refreshFamilies ( TypeCategoryRec brand ) {
      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Remove the control                                      */
      /*                                                           */
      /*-----------------------------------------------------------*/
      ((DefaultComboBoxModel)cb_FAMILY.getModel()).removeAllElements() ;

      if ( brand != null )
         WinUtil.setJComboBoxData ( cb_FAMILY, TypeCategory.getChildCategories ( brand.getInd(), TypeCategory.LEVEL_FAMILY ) ) ;
      else
         WinUtil.setJComboBoxData ( cb_FAMILY, createEmptyList() ) ;

      doLayout() ;
   }



   /**
     *  This method will save our data and will return TRUE if all data is present
     **/
   private boolean saveData () {
      TypeCategoryRec oBrand  = (TypeCategoryRec)cb_OBRAND.getSelectedItem() ;
      TypeCategoryRec oFamily = (TypeCategoryRec)cb_OFAMILY.getSelectedItem() ;
      TypeCategoryRec oSeries = (TypeCategoryRec)cb_OSERIES.getSelectedItem() ;
      TypeCategoryRec brand   = (TypeCategoryRec)cb_BRAND.getSelectedItem() ;
      TypeCategoryRec family  = (TypeCategoryRec)cb_FAMILY.getSelectedItem() ;
      boolean         saved   = false ;

      if ( ( oBrand != null ) &&
           ( oFamily != null ) &&
           ( oSeries != null ) &&
           ( brand != null ) &&
           ( family != null ) ) {
         StatusWin statusWin = new StatusWin ( GUISystem.getParentDefWin ( this ) ) ;

         statusWin.setVisible ( true ) ;
         statusWin.setText ( "Creating OPIC/M Brand/Family/Series Mapping" ) ;
         mapRow.oBrand  = oBrand ;
         mapRow.oFamily = oFamily ;
         mapRow.oSeries = oSeries ;
         mapRow.brand   = brand ;
         mapRow.family  = family ;
         saved = saveMappingToDatabase() ;

         if ( saved ) {
            statusWin.setText ( "Converting all current misfits ..." ) ;
            saved = convertMisfits ( statusWin ) ;
         }

         statusWin.dispose() ;

      } else
         GUISystem.printBox ( this, "Info", "Please select a value for all fields" ) ;

      return( saved ) ;
   }


   /**
     *  This method will save the mapping to the OPICM.BRANDFAMILYMAP table
     **/
   private boolean saveMappingToDatabase () {
      SQLMethod sqlMethod = new SQLMethod ( DatabaseSystem.QUEST, "saveMappingToDatabase", 5 ) ;
      boolean   rc        = false ;

      try {
         Statement stmt = sqlMethod.createStatement() ;

         stmt.executeUpdate ( "DELETE FROM OPICM.BRANDFAMILYMAP WHERE OPICMTYPECATIND = "+mapRow.oSeries.getInd() ) ;
         stmt.executeUpdate ( "INSERT INTO OPICM.BRANDFAMILYMAP VALUES ( "+mapRow.oSeries.getInd()+", "+mapRow.family.getInd()+")" ) ;

         rc = true ;
      } catch ( Exception e ) {
         LogSystem.log ( 1, e, false ) ;
         sqlMethod.rollBack() ;
         GUISystem.printBox ( this, STR_ERROR, STR_ERROR_IN_LAST_ACTION ) ;
      }

      sqlMethod.close() ;

      return( rc ) ;
   }


   /**
     *  This method will convert all current misfits that fall under this
     * new mapping
     **/
   private boolean convertMisfits ( StatusWin statusWin ) {
      Vector    misfits   = getMisfits ( statusWin ) ;
      boolean   rc        = true ;

      if ( misfits.size() > 0 ) {
         int             i              = 0 ;
         int             size           = misfits.size() ;
         ProductDraft    draft          = null ;
         int             converted      = 0 ;
         int             readRC         = 0 ;                  
         TypeCategoryRec brandRec       = (TypeCategoryRec)cb_BRAND.getSelectedItem() ;
         TypeCategoryRec familyRec      = (TypeCategoryRec)cb_FAMILY.getSelectedItem() ;
         TypeCategoryRec defaultProject = TypeCategory.getDraftCategoryFromDescription ( "Default", 
                                                                                         TypeCategory.LEVEL_PROJECT, 
                                                                                         mapRow.family.getInd() ) ;                                              

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   If we could not find the default project, create it now */
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( defaultProject == null ) {
            statusWin.setText ( "Creating Default Project" ) ;
            defaultProject = TypeCategory.createDraftTypeCategory ( mapRow.family.getInd(),
                                                                    "Default",
                                                                    TypeCategory.LEVEL_PROJECT,
                                                                    0,
                                                                    "N",
                                                                    UserSystem.getUserId() ) ;
            TypeCategory.writeToDatabase() ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Ok, now process each misfit                             */
         /*                                                           */
         /*-----------------------------------------------------------*/
         while ( ( i < size ) && ( rc ) ) {
            statusWin.setText ( "Reading Misfit "+(i+1)+" of "+size ) ;
            draft = new ProductDraft ( ((Integer)misfits.elementAt(i)).intValue() ) ;
            readRC = draft.readFromDatabase() ;

            switch ( readRC ) {
               
               case 0 :
                  int             saveRC     = 0 ;                          
                  TypeCategoryRec projectRec = draft.getProject() ;

                  if ( projectRec.getParentCatInd() != familyRec.getInd() ) {
                     projectRec.setParentCatInd ( familyRec.getInd() ) ;
                     draft.setProject ( projectRec ) ;
                  }

                  /*-----------------------------------------------------------*/
                  /*                                                           */
                  /*   Set the Brand/Family of the product                     */
                  /*                                                           */
                  /*-----------------------------------------------------------*/
                  draft.setBrand   ( TypeCategory.getDraftCategory ( brandRec.getInd() ) ) ;
                  draft.setFamily  ( TypeCategory.getDraftCategory ( familyRec.getInd() ) ) ;
                  draft.setMisfit  ( false ) ;

                  statusWin.setText ( "Saving Misfit "+(i+1)+" of "+size ) ;
                  saveRC = draft.writeToDatabase() ;
                  
                  if ( saveRC != 0 )
                     LogSystem.log ( 1, "Couldn't save draft to database. ProductInd:"+((Integer)misfits.elementAt(i)).intValue()+". rc:"+saveRC ) ;
                  else {
                     converted++ ;
                     try {
                        draft.checkOut ( null ) ;
                     } catch ( Exception e ) {
                        LogSystem.log ( 1, e, false ) ;
                     }
                  }
                  break ;

               default:
                  LogSystem.log ( 1, "Couldn't read in misfit productInd "+((Integer)misfits.elementAt(i)).intValue()+". rc:"+rc ) ;
                  rc = false ;
                  break ;
            }

            i++ ;
         }

         GUISystem.printBox ( this, "Info", "Converted "+converted+" misfits of "+size ) ;
      }

      return( rc ) ;   
   }


   /**
     *  This method will find all misfits and will return a Vector of their
     * product indicators
     **/
   private Vector getMisfits ( StatusWin statusWin ) {
      Vector     misfits   = new Vector ( 1 ) ;
      SQLMethod  sqlMethod = new SQLMethod ( DatabaseSystem.QUEST, "getMisfits", 5 ) ;

      try {
         int       i    = 0 ;
         Statement stmt = sqlMethod.createStatement() ;
         ResultSet rs   = stmt.executeQuery ( "SELECT A.PRODUCTIND "+
                                              "FROM PRODRAFT.CATEGORY A, "+
                                              "     PRODRAFT.PRODUCT B "+
                                              "WHERE A.TYPECATIND = "+mapRow.oSeries.getInd()+" AND "+
                                              "      A.PRODUCTIND = B.PRODUCTIND AND "+
                                              "      B.MISFIT = 'Y'" ) ;

         while ( rs.next() ) {
            misfits.addElement ( new Integer ( rs.getInt(1) ) ) ;
            i++ ;
            statusWin.setText ( "Found Misfits ... "+i ) ;
         }

         rs.close() ;

      } catch ( Exception e ) {
         LogSystem.log ( 1, e, false ) ;
         sqlMethod.rollBack() ;
         misfits = new Vector ( 1 ) ;
         GUISystem.printBox ( this, STR_ERROR, STR_ERROR_IN_LAST_ACTION ) ;
      }

      return( misfits ) ;
   }



   /**
     *  This method will add an OPIC/M Brand to the database
     **/
   private void createNewOBrand () {
      String oBrand = new SingleEntryDlg ( this, 
                                           Str.getStr ( STR_NEW ), 
                                           Str.getStr ( STR_OPICM_BRAND ), 
                                           "", 
                                           new MaskDocument ( MaskDocument.MASKTYPE_UNKNOWN,
                                                              254 ) ).getResult() ;

      if ( ( oBrand != null ) && ( oBrand.length() > 0 ) ) {
         TypeCategoryRec oBrandRec = TypeCategory.createTypeCategory ( 0,
                                                                       oBrand,
                                                                       TypeCategory.LEVEL_OPICM_BRAND,
                                                                       0,
                                                                       "N",
                                                                       UserSystem.getUserId() ) ;

         TypeCategory.createDraftTypeCategory ( oBrandRec.getInd(),
                                                0,
                                                oBrand,
                                                TypeCategory.LEVEL_OPICM_BRAND,
                                                0,
                                                "N",
                                                UserSystem.getUserId() ) ;

         if ( ( oBrandRec != null ) && ( TypeCategory.writeToDatabase() == 0 ) ) {
            ((DefaultComboBoxModel)cb_OBRAND.getModel()).addElement ( oBrandRec ) ;
            cb_OBRAND.setSelectedItem ( oBrandRec ) ;
         }

      }
   } /* createNewOBrand  */


   /**
     *  This method will add an OPIC/M Family to the database
     **/
   private void createNewOFamily () {
      String oFamily = new SingleEntryDlg ( this, 
                                            Str.getStr ( STR_NEW ), 
                                            Str.getStr ( STR_OPICM_FAMILY ), 
                                            "", 
                                            new MaskDocument ( MaskDocument.MASKTYPE_UNKNOWN,
                                                               254 ) ).getResult() ;

      if ( ( oFamily != null ) && ( oFamily.length() > 0 ) ) {
         TypeCategoryRec oBrandRec  = ((TypeCategoryRec)cb_OBRAND.getSelectedItem());
         TypeCategoryRec oFamilyRec = TypeCategory.createTypeCategory ( oBrandRec.getInd(),
                                                                        oFamily,
                                                                        TypeCategory.LEVEL_OPICM_FAMILY,
                                                                        0,
                                                                        "N",
                                                                        UserSystem.getUserId() ) ;

         TypeCategory.createDraftTypeCategory ( oFamilyRec.getInd(),
                                           oBrandRec.getInd(),
                                           oFamily,
                                           TypeCategory.LEVEL_OPICM_FAMILY,
                                           0,
                                           "N",
                                           UserSystem.getUserId() ) ;

         if ( ( oFamilyRec != null ) && ( TypeCategory.writeToDatabase() == 0 ) ) {
            ((DefaultComboBoxModel)cb_OFAMILY.getModel()).addElement ( oFamilyRec ) ;
            cb_OFAMILY.setSelectedItem ( oFamilyRec ) ;
         }

      }
   } /* createNewOFamily  */



   /**
     *  This method will add an OPIC/M Series to the database
     **/
   private void createNewOSeries () {
      String oSeries = new SingleEntryDlg ( this, 
                                            Str.getStr ( STR_NEW ), 
                                            Str.getStr ( STR_OPICM_SERIES ), 
                                            "", 
                                            new MaskDocument ( MaskDocument.MASKTYPE_UNKNOWN,
                                                               254 ) ).getResult() ;

      if ( ( oSeries != null ) && ( oSeries.length() > 0 ) ) {
         TypeCategoryRec oFamilyRec = ((TypeCategoryRec)cb_OFAMILY.getSelectedItem());
         TypeCategoryRec oSeriesRec = TypeCategory.createTypeCategory ( oFamilyRec.getInd(),
                                                                        oSeries,
                                                                        TypeCategory.LEVEL_OPICM_SERIES,
                                                                        0,
                                                                        "N",
                                                                        UserSystem.getUserId() ) ;

         TypeCategory.createDraftTypeCategory ( oSeriesRec.getInd(),
                                                oFamilyRec.getInd(),
                                                oSeries,
                                                TypeCategory.LEVEL_OPICM_SERIES,
                                                0,
                                                "N",
                                                UserSystem.getUserId() ) ;

         if ( ( oSeriesRec != null ) && ( TypeCategory.writeToDatabase() == 0 ) ) {
            ((DefaultComboBoxModel)cb_OSERIES.getModel()).addElement ( oSeriesRec ) ;
            cb_OSERIES.setSelectedItem ( oSeriesRec ) ;
         }

      }
   } /* createNewOSeries  */

} /* BrandMapDlg */
