package com.ibm.nzna.projects.qit.product.manager ;     
/*-----------------------------------------------------------*/
/*   PMViewPanel                                             */
/*                                                           */
/*   Description:                                            */
/*      Source code for: PMViewPanel                         */
/*                                                           */
/*                                                           */
/*         @Copyright  2001 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import java.util.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.qit.customview.* ;
import com.ibm.nzna.projects.qit.avalon.oanav.views.* ;
import com.ibm.nzna.projects.qit.avalon.base.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.quest.brand.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.qit.product.manager.views.* ;
import com.ibm.nzna.projects.qit.product.* ;
/**
 * This is the Nav panel for the views in Product Management. 
 *
 *
 * @version 1.0, 
 * @author  
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   PMViewPanel                                             */
/*                                                           */
/*-----------------------------------------------------------*/
public class PMViewPanel extends JPanel implements  ProductConst, NavPanel, AppConst, ActionListener {



   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private NavListGroup           brandOpenDraft          = null ;
   private NavListGroup           brandOpenDraftType      = null ;
   private NavListGroup           brandExistingProduct    = null ;
   private NavListGroup           misfitOpicmProject      = null ;
   private NavListGroup           misfitADate             = null ;
   private ProductManagementPanel productManagementPanel  = null ;
   private JComboBox              cb_VIEWS                = null ;
   private NavList                navList                 = null ;
   private Vector                 customViewComponents    = new Vector ( 1, 1 ) ;
   private JScrollPane            scrollPane              = null ; 
   private Vector                 opicmBrand              = (Vector)TypeCategory.getCategories(TypeCategory.LEVEL_OPICM_BRAND).clone() ;






   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method does nothing but assign our
    *  local vars
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public PMViewPanel ( ProductManagementPanel productManagementPanel ) {
      this.productManagementPanel = productManagementPanel ;

      initialize () ;
   }





   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will initialize our panel. This includes
    *  creating all of our controls and attaching
    *  them to this panel
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void initialize () {
      Vector      views     = (Vector)TypeCategory.getCategories(TypeCategory.LEVEL_BRAND).clone() ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create our GUI                                          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      navList    = new NavList() ;
      scrollPane = new JScrollPane ( navList ) ;     

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create our other views                                  */
      /*                                                           */
      /*-----------------------------------------------------------*/
      views.removeElement ( Brands.getCrossBrand() ) ;

      if ( UserSystem.hasBPMAuth() )
         views.insertElementAt ( Str.getStr ( STR_DATA_MAPPING ), 0 ) ;

      views.insertElementAt ( Str.getStr ( STR_MISFITS ), 0 ) ;
      views.insertElementAt ( Str.getStr ( STR_SELECT_A_VIEW ), 0 ) ;
      cb_VIEWS = new JComboBox ( views ) ;             

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setOpaque ( false ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add Action Listeners                                    */
      /*                                                           */
      /*-----------------------------------------------------------*/
      cb_VIEWS.addActionListener ( this ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add our Controls                                        */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( null ) ;
      add ( cb_VIEWS,  BorderLayout.NORTH ) ;
      add ( scrollPane, BorderLayout.CENTER ) ;        

      /*------------------------*/
      /*                        */
      /*  Auto-Select the brand */
      /*                        */
      /*------------------------*/
      if ( (opicmBrand != null) && (opicmBrand.size() > 0 ) ) {
         for ( int i = 0; i < opicmBrand.size(); i++ ) {
            if ( (PropertySystem.getPreferredBrand() != 0)  && 
                 ((PropertySystem.getPreferredBrand() != ((TypeCategoryRec)(opicmBrand).elementAt(i)).getInd())) ) {
               cb_VIEWS.setSelectedItem ( TypeCategory.getCategory ( PropertySystem.getPreferredBrand() ) ) ;
            }


         }
      }

   }


   /**
     *  This method will lay out and position our components
     **/
   public void doLayout () {
      Dimension size = getSize() ;
      int       x    = 5 ;
      int       y    = 5 ;
      int       rowHeight = GUISystem.getRowHeight () ;

      cb_VIEWS.setBounds ( x, y, size.width-(x*2)+1, rowHeight ) ;
      y+=rowHeight ;

      scrollPane.setBounds ( x, y, size.width-(x*2), size.height-y ) ;
   }



   /*------------------------------------------------------------*/
   /* start
    */
   /**
    *    This method will be called once we are
    *  showing. We will do nothing here
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void start () {

      try {
         TypeCategoryRec brandRec =  TypeCategory.getCategory ( PropertySystem.getInt ( PropertySystem.PROPERTY_DEFAULT_BRAND ) ) ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Select the default brand                                */
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( brandRec != null ) {
            cb_VIEWS.setSelectedItem ( brandRec ) ;
            productManagementPanel.setBrand ( brandRec ) ;
         } else
            productManagementPanel.setBrand ( (TypeCategoryRec) cb_VIEWS.getSelectedItem() ) ;

      } catch ( Exception e ) {
      }
   }




   /*------------------------------------------------------------*/
   /* stop
    */
   /**
    *    This method will remove all of our controls
    *  and will free all of our resources
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void stop () {
      removeAll() ;
   }


   /*------------------------------------------------------------*/
   /* getTitle
    */
   /**
    *    This method will return the title of this nav
    *  panel
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public String getTitle () {
      return( Str.getStr ( STR_PRODUCT_VIEWS ) ) ;
   }




   /*------------------------------------------------------------*/
   /* getJComponent
    */
   /**
    *    This method will simply return this class
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return JComponent
    *//*---------------------------------------------------------*/
   public JComponent getJComponent () {
      return( this ) ;
   }




   /*------------------------------------------------------------*/
   /* createBrandViews
    */
   /**
    *    This method will create all of the necessary
    *  views for Brand views.
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void createBrandViews ( ) {
      HotLinkGroup buttonGroup = new HotLinkGroup () ;
      HotLinkLabel label       = null ;

      removeCurrentSubViews() ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create the Open Draft Views                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      brandOpenDraft = new NavListGroup ( Str.getStr ( STR_OPEN_DRAFTS ) ) ;
      navList.add ( brandOpenDraft ) ;
      brandOpenDraft.add( label = new HotLinkLabel( (Str.getStr(STR_BY)+" "+Str.getStr(STR_ANNOUNCE_DATE)) ,
                                                    null, 
                                                    PMViews.VIEW_BRAND_DRAFT_ANNOUNCE_DATE )) ;
      buttonGroup.add ( label ) ;
      brandOpenDraft.add( label = new HotLinkLabel( (Str.getStr(STR_BY)+" "+Str.getStr(STR_PROJECT)),
                                                    null, 
                                                    PMViews.VIEW_BRAND_DRAFT_PROJECT )) ;
      buttonGroup.add ( label ) ;
      brandOpenDraft.expand() ;





      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create the Brand Open Draft Type Views                  */
      /*                                                           */
      /*-----------------------------------------------------------*/
      brandOpenDraftType = new NavListGroup ( Str.getStr ( STR_BY)+" "+Str.getStr(STR_DRAFT_TYPE ) ) ;
      brandOpenDraft.add (brandOpenDraftType ) ;

      brandOpenDraftType.add( label = new HotLinkLabel(Str.getStr(STR_NEW) ,
                                                       null, 
                                                       PMViews.VIEW_BRAND_DRAFT_TYPE_NEW )) ;
      buttonGroup.add ( label ) ;

      brandOpenDraftType.add( label = new HotLinkLabel(Str.getStr(STR_UPDATE) ,
                                                       null, 
                                                       PMViews.VIEW_BRAND_DRAFT_TYPE_UPDATE )) ;
      buttonGroup.add ( label ) ;
      brandOpenDraftType.add( label = new HotLinkLabel(Str.getStr(STR_DELETE)  ,
                                                       null, 
                                                       PMViews.VIEW_BRAND_DRAFT_TYPE_DELETE )) ;
      buttonGroup.add ( label ) ;
      brandOpenDraftType.expand() ;




      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create the Existing Products Views                      */
      /*                                                           */
      /*-----------------------------------------------------------*/
      brandExistingProduct = new NavListGroup ( Str.getStr ( STR_EXISTING_PRODUCTS ) ) ;
      navList.add ( brandExistingProduct ) ;
      brandExistingProduct.add( label = new HotLinkLabel( Str.getStr ( STR_BY)+" "+Str.getStr(STR_FAMILY ) ,
                                                          null, 
                                                          PMViews.VIEW_BRAND_PRODUCT_FAMILY )) ;
      buttonGroup.add ( label ) ;
      brandExistingProduct.add( label = new HotLinkLabel( Str.getStr ( STR_BY)+" "+Str.getStr(STR_PROJECT ) ,
                                                          null, 
                                                          PMViews.VIEW_BRAND_PRODUCT_PROJECT )) ;
      buttonGroup.add ( label ) ;
      brandExistingProduct.add( label = new HotLinkLabel((Str.getStr(STR_BY)+" "+Str.getStr(STR_ANNOUNCE_DATE)) ,
                                                         null, 
                                                         PMViews.VIEW_BRAND_PRODUCT_ANNOUNCE_DATE )) ;
      buttonGroup.add ( label ) ;
      brandExistingProduct.expand() ;



      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add action listeners to all nav lists groups            */
      /*                                                           */
      /*-----------------------------------------------------------*/
      brandOpenDraft.addActionListener  ( this ) ;
      brandOpenDraftType.addActionListener  ( this ) ;
      brandExistingProduct.addActionListener ( this ) ;

   }



   /**
     *  This method will create the views for misfits
     **/
   private void createMisfitViews () {
      HotLinkGroup buttonGroup = new HotLinkGroup () ;
      HotLinkLabel label       = null ;



      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   This method will remove all current views               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      removeCurrentSubViews() ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create the Open Draft Views                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      //Vector opicmBrand =  (Vector)TypeCategory.getCategories(TypeCategory.LEVEL_OPICM_BRAND).clone() ;

      misfitOpicmProject =  new  NavListGroup(Str.getStr(STR_BY_OPICM_PROJECT_NAME )) ; 
      navList.add ( misfitOpicmProject ) ;

      misfitADate = new NavListGroup(Str.getStr(STR_BY_ANNOUNCE_DATE)) ;
      navList.add ( misfitADate ) ;



      if ( (opicmBrand != null) && (opicmBrand.size() > 0) ) {
         for ( int i = 0; i < opicmBrand.size(); i++ ) {

            misfitOpicmProject.add( label = new HotLinkLabel( ((TypeCategoryRec)opicmBrand.elementAt(i)).getDescript() ,
                                                              null, 
                                                              PMViews.VIEW_MISFIT_OPICM_PROJECT )) ;
            buttonGroup.add(label);
            misfitADate.add( label = new HotLinkLabel( ((TypeCategoryRec)opicmBrand.elementAt(i)).getDescript() ,
                                                       null, 
                                                       PMViews.VIEW_MISFIT_ANNOUNCE_DATE )) ;
            buttonGroup.add(label) ;

         }

      }



      misfitOpicmProject.addActionListener( this ) ;
      misfitADate.addActionListener( this ) ;
      navList.addActionListener( this ) ;

   }


   /**
     *  This method will create the views for the Data Mapping
     **/
   private void createMappingViews () {
      HotLinkGroup buttonGroup = new HotLinkGroup () ;
      HotLinkLabel label       = null ;                                

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   This method will remove all current views               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      removeCurrentSubViews() ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create the Open Draft Views                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      label = new HotLinkLabel( (Str.getStr(STR_BRAND_FAMILY_SERIES )) ,
                                null, 
                                PMViews.VIEW_DATAMAP_BRAND_FAMILY_SERIES ) ;
      navList.add ( label ) ;
      buttonGroup.add ( label ) ;
      label = new HotLinkLabel( (Str.getStr(STR_GEOGRAPHY_COUNTRY)),
                                null, 
                                PMViews.VIEW_DATAMAP_GEO_COUNTRY ) ;
      buttonGroup.add ( label ) ;
      navList.add ( label ) ;

      navList.addActionListener ( this ) ;
   }

   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will be called when an action
    *  event is fired
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {

      /*------------------------*/
      /*                        */    
      /*  If this is a view hit */
      /*                        */    
      /*------------------------*/
      if ( e.getSource() instanceof HotLinkLabel ) {
         String actionCommand = ((HotLinkLabel)e.getSource()).getActionCommand() ;
         String text = ((HotLinkLabel)e.getSource()).getText() ;

         if ( TypeCategory.getCategoryFromDescription( text ) instanceof TypeCategoryRec ) {
            productManagementPanel.setBrand( TypeCategory.getCategoryFromDescription( text ) ) ;
         }

         productManagementPanel.setView ( actionCommand ) ;
      }

      else if ( e.getSource() == cb_VIEWS ) {

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   IF they selected a brand, just set the brand            */
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( cb_VIEWS.getSelectedItem() instanceof TypeCategoryRec ) {
            TypeCategoryRec brandRec = (TypeCategoryRec) cb_VIEWS.getSelectedItem() ;

            productManagementPanel.setBrand ( brandRec ) ;
            createBrandViews() ;
            revalidate() ;
         }


         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Otherwise, figure out what they hit and set accord.     */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( cb_VIEWS.getSelectedItem() instanceof String ) {
            String selectedItem = (String)cb_VIEWS.getSelectedItem() ;

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Misfits                                                 */
            /*                                                           */
            /*-----------------------------------------------------------*/
            if ( selectedItem.equals ( Str.getStr ( STR_MISFITS ) ) ) {
               productManagementPanel.setBrand ( null ) ;
               createMisfitViews() ;
               revalidate() ;
            }

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Data Mapping                                            */
            /*                                                           */
            /*-----------------------------------------------------------*/
            else if ( selectedItem.equals ( Str.getStr ( STR_DATA_MAPPING ) ) ) {
               productManagementPanel.setBrand ( null ) ;
               createMappingViews() ;
               revalidate() ;
            }

         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   By default, remove everything                           */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else {
            removeCurrentSubViews() ;
            revalidate() ;
         }

      }
   } /* actionPerformed  */


   /**
     *  This method will remove all current sub views and all action listeners
     **/
   private void removeCurrentSubViews () {
      navList.removeAll() ;

      if ( brandOpenDraft != null )
         brandOpenDraft.removeActionListener ( this ) ;
      if ( brandOpenDraftType != null )
         brandOpenDraftType.removeActionListener ( this ) ;
      if ( brandExistingProduct != null )
         brandExistingProduct.removeActionListener ( this ) ;
      if ( misfitOpicmProject != null )
         misfitOpicmProject.removeActionListener ( this ) ;
      if ( misfitADate != null )
         misfitADate.removeActionListener ( this ) ;



   }


} /* PMViewPanel */