package com.ibm.nzna.projects.qit.product.manager.masschange ;                    
/*-----------------------------------------------------------*/
/*   ProductBaseModelFieldChanger                            */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ProductBaseModelFieldChanger        */
/*                                                           */
/*                                                           */
/*         @Copyright  2001 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.storedProc.sqlRunner.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.storedProc.sqlRunner.* ;
import com.ibm.nzna.projects.qit.doc.* ;
import com.ibm.nzna.projects.qit.product.* ;
import com.ibm.nzna.projects.common.quest.product.*;
import com.ibm.nzna.projects.qit.product.*;
/**
 * This field changer will change the Basemodel Field of 
 * a list of products
 *
 * @version 1.0, 05/20/2001 
 * @author  Jag.
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ProductBaseModelFieldChanger                            */
/*                                                           */
/*-----------------------------------------------------------*/
public class ProductBaseModelFieldChanger extends Object implements  AppConst ,ProductConst{


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private boolean continueProcess = true ;





   /*------------------------------------------------------------*/
   /* beginProcess
    */
   /**
    *    This method must begin the process of 
    *  changing the products identified in 'productList'. 
    *  
    *
    *  @param prodDraftList The Vector of Products that need to be changed.
    *  @param data The Data Object to change the field to
    *  @param actionType will tell us, user selected Append,Replace or Remove 
    *  @param comments user comments on this masschange.
    *
    *  @return nothing.
    *//*---------------------------------------------------------*/
   public  boolean beginProcess ( Vector productList, Object data, String actionType,String comments ) {
      boolean      rc        = false ;
      int          i         = 0 ;
      int          size      = productList.size() ;
      StringBuffer sqlBuffer = new StringBuffer() ;
      ProductDraft      productDraft   = null ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Sending buffer to SQL Runner                            */                                 
      /*                                                           */
      /*-----------------------------------------------------------*/
      if(actionType.equals(Str.getStr(STR_REPLACE))){
          while ( ( continueProcess ) && ( i < size ) ) {
             productDraft = (ProductDraft)productList.elementAt(i) ;
             sqlBuffer.append ( "UPDATE PRODRAFT.PRODUCT SET BASEMODEL = '"+((String)data)+"', " ) ;
             sqlBuffer.append ( "LASTTOUCHEDBY = '"+UserSystem.getUserId()+"', " ) ;
             sqlBuffer.append ( "LASTTOUCHEDON = CURRENT TIMESTAMP, " ) ;
             sqlBuffer.append ( "COMMENTS = '"+Text.cleanDBString ( comments )+"' ") ;
             sqlBuffer.append ( "WHERE PRODUCTIND = "+productDraft.getProductInd() ) ;
             sqlBuffer.append ( SqlRunner.END_DELIM ) ;
             i++ ;
          } /* while  */
      }/* if */

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Now, send the buffer                                    */           
      /*                                                           */
      /*-----------------------------------------------------------*/
      rc = QITSqlRunner.sqlRunner ( sqlBuffer.toString() ) ;
      if( !rc ){
           GUISystem.printBox(STR_INFO,STR_WIZARD_PROBLEM);
      }
      return rc;
   } /* beginProcess  */


   /*------------------------------------------------------------*/
   /* stopProcess
    */
   /**
    *    This method will stop the processing at the next
    *  available point
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void stopProcess () {
      continueProcess = false ;
   }

} /* ProductBaseModelFieldChanger */
