package com.ibm.nzna.projects.qit.product.manager.masschange ;                    
/*-----------------------------------------------------------*/
/*   ProductBrandFamilyFieldChanger                          */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ProductBrandFamilyFieldChanger      */
/*                                                           */
/*                                                           */
/*         @Copyright  2001 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.storedProc.sqlRunner.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.storedProc.sqlRunner.* ;
import com.ibm.nzna.projects.qit.doc.* ;
import com.ibm.nzna.projects.qit.product.* ;
import com.ibm.nzna.projects.common.quest.product.*;
/**
 * This field changer will change the Brand  of 
 * a list of products
 *
 * @version 1.0, 05/20/2001 
 * @author  Jag
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ProductBrandFamilyFieldChanger                          */
/*                                                           */
/*-----------------------------------------------------------*/
public class ProductBrandFamilyFieldChanger extends Object implements  AppConst , ProductConst {


    /*-----------------------------------------------------------*/
    /*                                                           */
    /*   Private Members                                         */
    /*                                                           */
    /*-----------------------------------------------------------*/
    private boolean continueProcess = true ;





    /*------------------------------------------------------------*/
    /* beginProcess
     */
    /**
     *    This method must begin the process of 
     *  changing the products identified in 'productList'. 
     *  
     *
     *  @param prodDraftList The Vector of Products that need to be changed.
     *  @param brand The Data Object to change the field to Brand
     *  @param family the data object to change the field to family
     *  @param actionType will tell us, user selected Append,Replace or Remove 
     *  @param comments user comments on this masschange.
     *
     *  @return nothing.
     *//*---------------------------------------------------------*/
    public void beginProcess ( Vector productList, Object brand, Object family, String actionType, String comments ) {
        boolean      rc             = false ;
        int          i              = 0 ;
        int          size           = productList.size() ;
        ProductDraft productDraft   = null ;
        boolean      yesProcess     = false;                                 
        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   Checking actionType based on the user selection         */
        /*                                                           */
        /*-----------------------------------------------------------*/
        if (actionType.equals(Str.getStr(STR_REPLACE))) {
            while ( ( continueProcess ) && ( i < size ) ) {
                productDraft = (ProductDraft)productList.elementAt(i) ;
                TypeCategoryRec selectedBrand =(TypeCategoryRec)brand;
                TypeCategoryRec selectedFamily =(TypeCategoryRec)family;
                int sqlID=0;


                /* Check the project in the TypeCategory Table if we don't have create one under family*/

                TypeCategoryRec project = TypeCategory.getDraftCategoryFromDescription( productDraft.getProject().getDescript(), TypeCategory.LEVEL_PROJECT,selectedFamily.getInd());
                if (project==null) {
                    project = TypeCategory.createDraftTypeCategory ( selectedFamily.getInd() ,productDraft.getProject().getDescript() , TypeCategory.LEVEL_PROJECT, 0, "N", UserSystem.getUserId() ) ;
                }
                //TypeCategory.writeToDatabase();
                project.writeToDatabase();
                productDraft.setProject(project);

                /* Check the selected productDraft product type if it is option.*/
                /* Create subCategory and part number for that.*/

                if (productDraft.getProductType()==TypeList.PRODUCTTYPE_OPTION) {
                    TypeCategoryRec subCategory= TypeCategory.getDraftCategoryFromDescription( productDraft.getSubCategory().getDescript(), TypeCategory.LEVEL_SUBCATEGORY,project.getInd());
                    if (subCategory==null) {
                        subCategory = TypeCategory.createDraftTypeCategory ( project.getInd() ,productDraft.getSubCategory().getDescript() , TypeCategory.LEVEL_SUBCATEGORY, 0, "N", UserSystem.getUserId() ) ;
                    }
                    subCategory.writeToDatabase();
                    productDraft.setSubCategory(subCategory);
                    TypeCategoryRec partNumber=TypeCategory.getDraftCategoryFromDescription( productDraft.getPartNumber().getDescript(), TypeCategory.LEVEL_PARTNUMBER,subCategory.getInd());

                    if (partNumber==null) {
                        partNumber= TypeCategory.createDraftTypeCategory ( subCategory.getInd() ,productDraft.getPartNumber().getDescript() , TypeCategory.LEVEL_PARTNUMBER, 0, "N", UserSystem.getUserId() ) ;
                    }
                    partNumber.writeToDatabase();
                    productDraft.setPartNumber(partNumber);
                }
                /*Check whether selected productDraft is System or Monitor*/
                else {
                    TypeCategoryRec machine = TypeCategory.getDraftCategoryFromDescription( productDraft.getMachine().getDescript(), TypeCategory.LEVEL_MACHINE,project.getInd());
                    if (machine==null) {
                        machine = TypeCategory.createDraftTypeCategory ( project.getInd() ,productDraft.getMachine().getDescript() , TypeCategory.LEVEL_MACHINE, 0, "N", UserSystem.getUserId() ) ;
                    }
                    machine.writeToDatabase();
                    productDraft.setMachine(machine);

                    TypeCategoryRec model = TypeCategory.getDraftCategoryFromDescription( productDraft.getModel().getDescript(), TypeCategory.LEVEL_MODEL,machine.getInd());
                    if (model==null) {
                        model = TypeCategory.createDraftTypeCategory ( machine.getInd() ,productDraft.getModel().getDescript() , TypeCategory.LEVEL_MODEL, 0, "N", UserSystem.getUserId() ) ;
                    }
                    model.writeToDatabase();
                    productDraft.setModel(model);
                }

                //TypeCategory.writeToDatabase();
                productDraft.setLastTouchedBy(UserSystem.getUserId());
                productDraft.setComment( Text.cleanDBString ( comments ) );
                sqlID =productDraft.writeToDatabase();
                if ( sqlID !=0 ) {
                    //stopProcess();
                    yesProcess =GUISystem.printBox(STR_QUESTION,STR_WIZARD_PROBLEM);
                    LogSystem.log(1,"Could not able to set the brand for  product  "+productDraft.getProductInd());
                    if (!yesProcess) {
                        stopProcess();
                    }
                }
                i++ ;
            } /* while  */
        }/* if */

    } /* beginProcess  */


    /*------------------------------------------------------------*/
    /* stopProcess
     */
    /**
     *    This method will stop the processing at the next
     *  available point
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void stopProcess () {
        continueProcess = false ;
    }

} /* ProductBrandFamilyFieldChanger */
