package com.ibm.nzna.projects.qit.product.manager.masschange ;                    
/*-----------------------------------------------------------*/
/*   ProductCustomerFieldChanger                             */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ProductCustomerFieldChanger         */
/*                                                           */
/*                                                           */
/*         @Copyright  2001 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.storedProc.sqlRunner.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.storedProc.sqlRunner.* ;
import com.ibm.nzna.projects.qit.doc.* ;
import com.ibm.nzna.projects.qit.product.* ;
import com.ibm.nzna.projects.common.quest.product.*;
/**
 * This field changer will change the Product CustomerId of 
 * a list of products
 *
 * @version 1.0, 05/20/2001 
 * @author  Jag.
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ProductCustomerFieldChanger                             */
/*                                                           */
/*-----------------------------------------------------------*/
public class ProductCustomerFieldChanger extends Object implements   AppConst,ProductConst {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private boolean continueProcess = true ;





   /*------------------------------------------------------------*/
   /* beginProcess
    */
   /**
    *    This method must begin the process of 
    *  changing the documents identified in 'productList'. This
    *  method should not return until an unrecoverable error occurs
    *  or all processing is complete
    *  
    *
    *  @param productList The Vector of Products that need to be changed.
    *  @param data The Data Object to change the field to
    *  @param actionType which represents(Append,Replace,Remove)
    *  @param comments entered by the user while doing masschange.
    *
    *  @return TRUE if everything went Ok
    *//*---------------------------------------------------------*/
   public boolean beginProcess ( Vector productList, Object data, String actionType, String comments ) {
      boolean      rc        = false ;
      int          i         = 0 ;
      int          size      = productList.size() ;
      StringBuffer sqlBuffer = new StringBuffer() ;
      ProductDraft      productDraft   = null ;
      TypeCustomerRec typeCustomerRec=(TypeCustomerRec)data;
      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Form what big buffer to send to SQL Runner              */                                 
      /*                                                           */
      /*-----------------------------------------------------------*/
      if(actionType.equals(Str.getStr(STR_REPLACE))){
          while ( ( continueProcess ) && ( i < size ) ) {
             productDraft = (ProductDraft)productList.elementAt(i) ;
             sqlBuffer.append ( "UPDATE PRODRAFT.PRODUCT SET TYPECUSTOMERIND = "+typeCustomerRec.getInd()+", " ) ;
             sqlBuffer.append ( "LASTTOUCHEDBY = '"+UserSystem.getUserId()+"', " ) ;
             sqlBuffer.append ( "LASTTOUCHEDON = CURRENT TIMESTAMP, " ) ;
             sqlBuffer.append ( "COMMENTS = '"+Text.cleanDBString ( comments )+"' " ) ;
             sqlBuffer.append ( "WHERE PRODUCTIND = "+productDraft.getProductInd() ) ;
             sqlBuffer.append ( SqlRunner.END_DELIM ) ;
             i++ ;
          } /* while  */
      }/* if */

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Now, send the buffer                                    */           
      /*                                                           */
      /*-----------------------------------------------------------*/
      rc = QITSqlRunner.sqlRunner ( sqlBuffer.toString() ) ;
      if( !rc ){
           GUISystem.printBox(STR_INFO,STR_WIZARD_PROBLEM);
      }
      
      return rc;
      
   } /* beginProcess  */


   /*------------------------------------------------------------*/
   /* stopProcess
    */
   /**
    *    This method will stop the processing at the next
    *  available point
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void stopProcess () {
      continueProcess = false ;
   }

} /* DocBFTMFieldChanger */
