package com.ibm.nzna.projects.qit.product.manager.masschange ;                    
/*-----------------------------------------------------------*/
/*   ProductDateFieldsChanger                                */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ProductDateFieldsChanger            */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.quest.product.*;
import com.ibm.nzna.projects.common.storedProc.sqlRunner.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.storedProc.sqlRunner.* ;
import com.ibm.nzna.projects.qit.doc.* ;
import com.ibm.nzna.projects.qit.product.*;
/**
 * This field changer will change the Date Fields of 
 * a list of Products.
 *
 * @version 1.0, 05/20/2001 
 * @author  Jag.
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ProductDateFieldsChanger                                    */
/*                                                           */
/*-----------------------------------------------------------*/
public class ProductDateFieldsChanger extends Object implements  AppConst,ProductConst {


    /*-----------------------------------------------------------*/
    /*                                                           */
    /*   Private Members                                         */
    /*                                                           */
    /*-----------------------------------------------------------*/
    private boolean continueProcess = true ;





    /*------------------------------------------------------------*/
    /* beginProcess
     */
    /**
     *    This method must begin the process of 
     *  changing the documents identified in 'productList'. This
     *  method should not return until an unrecoverable error occurs
     *  or all processing is complete
     *  
     *
     *  @param productList The Vector of Products that need to be changed.
     *  @param data The Data Object to change the field to
     *  @param String actionType (Append,Remove,Replace) selected by the user.
     *  @param String comments entered by the user in masschange wizard process.    
     *//*---------------------------------------------------------*/
    public void beginProcess ( Vector productList, Object userSelectedDate, String actionType, String comments ) {
        boolean      rc        = false ;
        int          i         = 0 ;
        int          size      = productList.size() ;
        StringBuffer sqlBuffer = new StringBuffer() ;
        ProductDraft      productDraft   = null ;
        Vector myDates =new Vector();
        boolean yesProcess=false;                                 
        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   Form what big buffer to send to SQL Runner              */
        /*                                                           */
        /*-----------------------------------------------------------*/

        while ( ( continueProcess ) && ( i < size ) ) {
            productDraft = (ProductDraft)productList.elementAt(i) ;                                 

            /*------------------------------------------------------------*/
            /*                                                            */
            /* Check If actionType is Replace                             */
            /* and Checking whether this productDraft has ProductDates    */
            /* If it has then update the TargetDate and ActualDate entered*/
            /* by the user during the wizard process.                     */
            /*------------------------------------------------------------*/
            if (actionType.equals(Str.getStr(STR_REPLACE))) {
                if ((productDraft.getDates()).size()>0) {
                    if ((isDateExisting(productDraft,userSelectedDate,getProductDateList(productDraft)))) {
                        ProductDateObject userDateObject =getUserDate(productDraft,userSelectedDate);
                        try {
                            Vector dates=getReplaceDates(productDraft,userSelectedDate,getProductDateList(productDraft));
                            productDraft.setDates(dates);
                        } catch (IllegalArgumentException ie) {
                            LogSystem.log(1,ie);
                        }
                    }
                }
                /* If productDraft don't have any dates associated to it Append the date
                   seleted by the user.*/
                else {
                    actionType=Str.getStr(STR_APPEND);
                }
            }/*end if*/

            if (actionType.equals(Str.getStr(STR_APPEND))) {
                if (! (isDateExisting(productDraft,userSelectedDate,getProductDateList(productDraft)))) {
                    ProductDateObject userDateObject =getUserDate(productDraft,userSelectedDate);
                    try {
                        ProductDate dateForAppend= new ProductDate(userDateObject.getProductInd(),userDateObject.getDateTypeInd());
                        dateForAppend.setCountryCodeInd(userDateObject.getCountryCodeInd());
                        dateForAppend.setActualDate(userDateObject.getActualDate());
                        dateForAppend.setTargetDate(userDateObject.getTargetDate());
                        productDraft.addDate(dateForAppend);
                    } catch (IllegalArgumentException ie) {
                        LogSystem.log(1,ie);
                    }
                }
            }
            if (actionType.equals(Str.getStr(STR_REMOVE))) {
                if ((isDateExisting(productDraft,userSelectedDate,getProductDateList(productDraft)))) {
                    ProductDateObject userDateObject =getUserDate(productDraft,userSelectedDate);
                    try {
                        Vector datesForRemove=getRemoveDates(productDraft,userSelectedDate,getProductDateList(productDraft));
                        productDraft.setDates(datesForRemove);
                    } catch (IllegalArgumentException ie) {
                        LogSystem.log(1,ie);
                    }
                }
            }
            productDraft.setLastTouchedBy(UserSystem.getUserId());
            productDraft.setComment(Text.cleanDBString ( comments ));
            int sqlID =productDraft.writeToDatabase();
            if ( sqlID !=0 ) {
                yesProcess =GUISystem.printBox(STR_QUESTION,STR_WIZARD_PROBLEM);
                LogSystem.log(1,"Could not able add or remove ProductDate for  product  "+productDraft.getProductInd());
                if (!yesProcess) {
                    stopProcess();
                }
            }
            i++ ;
        } /* while  */

    } /* beginProcess  */


    /*------------------------------------------------------------*/
    /* stopProcess
     */
    /**
     *    This method will stop the processing at the next
     *  available point
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void stopProcess () {
        continueProcess = false ;
    }


    /*-----------------------------------------------------------*/
    /*                                                           */
    /*   This method will give Vector of ProductDates with all   */
    /*   indicators                                              */                                 
    /*                                                           */
    /*-----------------------------------------------------------*/
    private Vector getProductDateList(ProductDraft productDraft){
        Vector dateObjects=new Vector();
        if (productDraft!=null) {
            Vector existingDates=new Vector(productDraft.getDates());
            if ((existingDates!=null)&&(existingDates.size()>0)) {
                for (int i=0;i<existingDates.size();i++) {
                    ProductDate productDate=(ProductDate)existingDates.elementAt(i);
                    ProductDateObject dateObject=new ProductDateObject(productDate.getProductInd(),productDate.getDateType(),productDate.getCountryCodeInd());
                    dateObjects.addElement(dateObject);
                }
            }
        }
        return dateObjects;
    }
    /*-----------------------------------------------------------*/
    /*                                                           */
    /*   This method will check  all product dates in   product  */
    /*   draft  with userSelectedDate                            */
    /*                                                           */                                 
    /*                                                           */
    /*-----------------------------------------------------------*/
    private boolean isDateExisting(ProductDraft productDraft,Object userProductDate,Vector dateObjects){
        boolean returnCode=false;
        ProductDateObject userDate=(ProductDateObject)userProductDate;
        ProductDateObject userDateForCompare=new ProductDateObject(productDraft.getProductInd(),userDate.getDateTypeInd(),userDate.getCountryCodeInd());
        if ((dateObjects!=null)&&(dateObjects.size()>0)) {
            for (int i=0;i<dateObjects.size();i++) {
                if (userDateForCompare.equals((ProductDateObject)dateObjects.elementAt(i))) {
                    returnCode= true;
                }
            }
        }
        return returnCode;
    }
    /* this methosd set productind for userSelected date*/

    private ProductDateObject getUserDate(ProductDraft productDraft,Object userDate){
        ProductDateObject userDateObject=(ProductDateObject)userDate;
        userDateObject.setProductInd(productDraft.getProductInd());
        return userDateObject;
    }

    /* This method will return Vector of  dates by replacing the actualDate and targetDate */
    /* for userSelectedDate.*/


    private Vector getReplaceDates(ProductDraft productDraft,Object userProductDate,Vector dateObjects){
        Vector existingDates=productDraft.getDates();
        ProductDateObject userDate=(ProductDateObject)userProductDate;
        ProductDateObject userDateForCompare=new ProductDateObject(productDraft.getProductInd(),userDate.getDateTypeInd(),userDate.getCountryCodeInd());
        if ((dateObjects!=null)&&(dateObjects.size()>0)) {
            for (int i=0;i<dateObjects.size();i++) {
                if (userDateForCompare.equals((ProductDateObject)dateObjects.elementAt(i))) {
                    ProductDate dateObject=(ProductDate)existingDates.elementAt(i);
                    dateObject.setActualDate(userDate.getActualDate());
                    dateObject.setTargetDate(userDate.getTargetDate());
                    existingDates.removeElementAt(i);
                    existingDates.insertElementAt(dateObject,i);
                }
            }
        }
        return existingDates;

    }

    /* This method will return Vector of ProductDates by removing the UserSelectedDate */



    private Vector getRemoveDates(ProductDraft productDraft,Object userProductDate,Vector dateObjects){
        Vector existingDates=productDraft.getDates();
        ProductDateObject userDate=(ProductDateObject)userProductDate;
        ProductDateObject userDateForCompare=new ProductDateObject(productDraft.getProductInd(),userDate.getDateTypeInd(),userDate.getCountryCodeInd());
        if ((dateObjects!=null)&&(dateObjects.size()>0)) {
            for (int i=0;i<dateObjects.size();i++) {
                if (userDateForCompare.equals((ProductDateObject)dateObjects.elementAt(i))) {
                    ProductDate dateObject=(ProductDate)existingDates.elementAt(i);
                    existingDates.removeElementAt(i);
                }
            }
        }
        return existingDates;

    }


} /* ProductDateFieldsChanger */
