
package com.ibm.nzna.projects.qit.product.manager.masschange ;                    
/*-----------------------------------------------------------*/
/*   ProductLocaleFieldChanger                               */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ProductLocaleFieldChanger           */
/*                                                           */
/*                                                           */
/*         @Copyright  2001 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.storedProc.sqlRunner.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.storedProc.sqlRunner.* ;
import com.ibm.nzna.projects.qit.doc.* ;
import com.ibm.nzna.projects.common.quest.product.*;
import com.ibm.nzna.projects.common.quest.*;
import com.ibm.nzna.projects.qit.product.*;
/**
 * This field changer will change the Product Locale field of 
 * a list of products
 *
 * @version 1.0, 05/20/2001 
 * @author  Jag.
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ProductLocaleFieldChanger                               */
/*                                                           */
/*-----------------------------------------------------------*/
public class ProductLocaleFieldChanger extends Object implements   ProductConst,AppConst {


    /*-----------------------------------------------------------*/
    /*                                                           */
    /*   Private Members                                         */
    /*                                                           */
    /*-----------------------------------------------------------*/
    private boolean continueProcess = true ;





    /*------------------------------------------------------------*/
    /* beginProcess
     */
    /**
     *    This method must begin the process of 
     *  changing the products identified in 'productList'. This
     *  method should not return until an unrecoverable error occurs
     *  or all processing is complete
     *  
     *
     *  @param prodDraftList The Vector of Products that need to be changed.
     *  @param data The Data Object to change the field to
     *  @param String actionType to find out user Selected Append ,Replace,Remove.
     *  @param String comments entered by the user while doing masschange.
     *
     *  @return TRUE if everything went Ok
     *//*---------------------------------------------------------*/
    public void beginProcess ( Vector productList, Object data, String actionType, String comments ) {
        boolean  yesProcess         = false ;
        int      i                  = 0 ;
        int      size               = productList.size() ;
        ProductDraft productDraft   = null ;                                 
        int sqlID=0;
        com.ibm.nzna.projects.common.quest.LocaleRec userLocaleRec=(com.ibm.nzna.projects.common.quest.LocaleRec)data;

        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   Form what big buffer to send to SQL Runner              */
        /*                                                           */
        /*-----------------------------------------------------------*/
        try {
            while ( ( continueProcess ) && ( i < size ) ) {
                productDraft = (ProductDraft)productList.elementAt(i) ;
                com.ibm.nzna.projects.common.quest.LocaleRec localeRec=productDraft.getLocale();
                if(userLocaleRec.isWorldWide()){
                   localeRec.setWorldWide(true);
                   productDraft.setLocale(userLocaleRec);
                }
                else{
                    if (actionType.equals(Str.getStr(STR_REMOVE))) {
                        localeRec=removeLocale(userLocaleRec ,localeRec);
                        productDraft.setLocale(localeRec);
                    } else if(actionType.equals(Str.getStr(STR_REPLACE))){
                        productDraft.setLocale(userLocaleRec);
                      }else if(actionType.equals(Str.getStr(STR_APPEND))){
                          localeRec=appendLocale(userLocaleRec,localeRec);
                          productDraft.setLocale(localeRec);
                      }
                      

                }
                productDraft.setLastTouchedBy(UserSystem.getUserId());
                productDraft.setComment( Text.cleanDBString ( comments ) );
                sqlID =productDraft.writeToDatabase();

                if ( sqlID !=0 ) {
                    LogSystem.log(1,"Could not able to set the locale for  product  "+productDraft.getProductInd());
                    yesProcess =GUISystem.printBox(STR_QUESTION,STR_WIZARD_PROBLEM);
                    if (!yesProcess) {
                        stopProcess();
                    }
                }
                i++ ;
            } /* while  */

        } catch (Exception e) {
            LogSystem.log(1,e);
        }
    } /* beginProcess  */


    /*------------------------------------------------------------*/
    /* stopProcess
     */
    /**
     *    This method will stop the processing at the next
     *  available point
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void stopProcess () {
        continueProcess = false ;
    }






    /* This method will add all selected countries to LocaleRec object
       and will return LocaleRec object */




    private com.ibm.nzna.projects.common.quest.LocaleRec appendLocale(com.ibm.nzna.projects.common.quest.LocaleRec userLocaleRec,com.ibm.nzna.projects.common.quest.LocaleRec localeRec){
        if(localeRec==null){
            localeRec=userLocaleRec;
            return(localeRec);
        }
        else{
            Vector allGeos   = userLocaleRec.getGeoListContainingAll() ;
            Vector countries = userLocaleRec.getSingleCountryList() ;                 


            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Add all of the Geographies                              */
            /*                                                           */
            /*-----------------------------------------------------------*/
            if ( ( allGeos != null ) && ( allGeos.size() > 0 ) ) {
               int i       = 0 ;
               int size    = allGeos.size() ;

               while ( i < size ) {
                  if ( ((TypeGeoRec)allGeos.elementAt(i)).valid() ) {
                     ((TypeGeoRec)allGeos.elementAt(i)).setEnhanceOutput ( true ) ;
                     localeRec.addGeography((TypeGeoRec)allGeos.elementAt(i++) ) ;
                  }
               }
            }

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Add the associated countries                            */
            /*                                                           */
            /*-----------------------------------------------------------*/
            if ( ( countries != null ) && ( countries.size() > 0 ) ) {
               int i       = 0 ;
               int size    = countries.size() ;

               while ( i < size ) {
                  if ( ((TypeCountryCodeRec)countries.elementAt(i)).valid() )
                     localeRec.addCountry ((TypeCountryCodeRec) countries.elementAt(i++) ) ;
               }
            }


            return(localeRec);

        }
    }


    /* This method will add all selected countries and Geographies to LocaleRec object
       and will return LocaleRec object */
    private com.ibm.nzna.projects.common.quest.LocaleRec removeLocale(com.ibm.nzna.projects.common.quest.LocaleRec userLocaleRec,com.ibm.nzna.projects.common.quest.LocaleRec localeRec){
        if(localeRec!=null){
            Vector allGeos   = userLocaleRec.getGeoListContainingAll() ;
            Vector countries = userLocaleRec.getSingleCountryList() ;                 


            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Remove all of the Geographies                           */
            /*                                                           */
            /*-----------------------------------------------------------*/
            if ( ( allGeos != null ) && ( allGeos.size() > 0 ) ) {
               int i       = 0 ;
               int size    = allGeos.size() ;

               while ( i < size ) {
                  if ( ((TypeGeoRec)allGeos.elementAt(i)).valid() ) {
                     ((TypeGeoRec)allGeos.elementAt(i)).setEnhanceOutput ( true ) ;
                     localeRec.removeGeography((TypeGeoRec)allGeos.elementAt(i++) ) ;
                  }
               }
            }

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Remove all associated countries                         */
            /*                                                           */
            /*-----------------------------------------------------------*/
            if ( ( countries != null ) && ( countries.size() > 0 ) ) {
               int i       = 0 ;
               int size    = countries.size() ;

               while ( i < size ) {
                  if ( ((TypeCountryCodeRec)countries.elementAt(i)).valid() )
                     localeRec.removeCountry ((TypeCountryCodeRec) countries.elementAt(i++) ) ;
               }
            }
        }
            return(localeRec);
    }


} /* ProductLocaleFieldChanger */
