package com.ibm.nzna.projects.qit.product.manager.masschange ;                    
/*-----------------------------------------------------------*/
/*   ProductMachineFieldChanger                              */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ProductMachineFieldChanger          */
/*                                                           */
/*                                                           */
/*         @Copyright  2001 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.storedProc.sqlRunner.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.storedProc.sqlRunner.* ;
import com.ibm.nzna.projects.qit.doc.* ;
import com.ibm.nzna.projects.qit.product.* ;
import com.ibm.nzna.projects.common.quest.product.*;
/**
 * This field changer will change the Machine  of 
 * a list of products
 *
 * @version 1.0, 05/20/2001 
 * @author  
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ProductMachineFieldChanger                              */
/*                                                           */
/*-----------------------------------------------------------*/
public class ProductMachineFieldChanger extends Object implements  AppConst,ProductConst {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private boolean continueProcess = true ;





   /*------------------------------------------------------------*/
   /* beginProcess
    */
   /**
    *    This method must begin the process of 
    *  changing the products identified in 'productList'. This
    *  method should not return until an unrecoverable error occurs
    *  or all processing is complete
    *  
    *
    *  @param prodDraftList The Vector of Products that need to be changed.
    *  @param data The Data Object to change the field to
    *  @param String actionType to find out user Selected Append ,Replace,Remove.
    *  @param String comments entered by the user.
    *
    *  @return TRUE if everything went Ok
    *//*---------------------------------------------------------*/
   public void beginProcess ( Vector productList, Object data, String actionType, String comments ) {
      boolean      yesProcess= false ;
      int          i         = 0 ;
      int          size      = productList.size() ;
      ProductDraft      productDraft   = null ;
      TypeCategoryRec project=null;
      TypeCategoryRec newMachine=null;
      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Form what big buffer to send to SQL Runner              */                                 
      /*                                                           */
      /*-----------------------------------------------------------*/
      try{
          if(actionType.equals(Str.getStr(STR_REPLACE))){
              while ( ( continueProcess ) && ( i < size ) ) {
                 productDraft = (ProductDraft)productList.elementAt(i) ;
                 project=productDraft.getProject();
                 int sqlID=0;
                 if((productDraft.getProductType()==TypeList.PRODUCTTYPE_SYSTEM)||(productDraft.getProductType()==TypeList.PRODUCTTYPE_MONITOR)){

                     /* First check in the TypeCategory table userEntered Machine present or not.*/
                     /* If it is not there Create one in typeCategoryTable.*/
                     TypeCategoryRec machine = TypeCategory.getDraftCategoryFromDescription( (String)data, TypeCategory.LEVEL_MACHINE,project.getInd());
                     if(machine==null){
                          machine = TypeCategory.createDraftTypeCategory ( project.getInd() ,(String)data, TypeCategory.LEVEL_MACHINE, 0, "N", UserSystem.getUserId() ) ;
                     }
                     productDraft.setMachine(machine);
                     /* set The model for the productDraft*/
                     TypeCategoryRec model = TypeCategory.getDraftCategoryFromDescription( productDraft.getModel().getDescript(), TypeCategory.LEVEL_MODEL,machine.getInd());
                     if(model==null){
                          model = TypeCategory.createDraftTypeCategory ( machine.getInd() ,productDraft.getModel().getDescript() , TypeCategory.LEVEL_MODEL, 0, "N", UserSystem.getUserId() ) ;
                     }
                     productDraft.setModel(model);
                     TypeCategory.writeToDatabase();
                     productDraft.setLastTouchedBy(UserSystem.getUserId());
                     productDraft.setComment(Text.cleanDBString ( comments ));
                     sqlID =productDraft.writeToDatabase();
                 }
                 if( sqlID !=0 ){
                      LogSystem.log(1,"Could not able to set the machine for  product  "+productDraft.getProductInd());
                      yesProcess =GUISystem.printBox(STR_QUESTION,STR_WIZARD_PROBLEM);
                      if(!yesProcess){
                          stopProcess();
                      }
                 }
                 i++ ;
              } /* while  */
          }/* if */

      }
      catch(Exception e){
          LogSystem.log(1,e);
      }
   } /* beginProcess  */


   /*------------------------------------------------------------*/
   /* stopProcess
    */
   /**
    *    This method will stop the processing at the next
    *  available point
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void stopProcess () {
      continueProcess = false ;
   }

} /* ProductMachineFieldChanger */
