package com.ibm.nzna.projects.qit.product.manager.masschange ;                    
/*-----------------------------------------------------------*/
/*   ProductModelFieldChanger                                */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ProductModelFieldChanger            */
/*                                                           */
/*                                                           */
/*         @Copyright  2001 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.storedProc.sqlRunner.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.storedProc.sqlRunner.* ;
import com.ibm.nzna.projects.qit.doc.* ;
import com.ibm.nzna.projects.qit.product.* ;
import com.ibm.nzna.projects.common.quest.product.*;
/**
 * This field changer will change the Model Field of 
 * a list of products
 *
 * @version 1.0, 05/20/2001 
 * @author  
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ProductModelFieldChanger                                */
/*                                                           */
/*-----------------------------------------------------------*/
public class ProductModelFieldChanger extends Object implements  AppConst,ProductConst {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private boolean continueProcess = true ;





   /*------------------------------------------------------------*/
   /* beginProcess
    */
   /**
    *    This method must begin the process of 
    *  changing the products identified in 'productList'. This
    *  method should not return until an unrecoverable error occurs
    *  or all processing is complete
    *  
    *
    *  @param prodDraftList The Vector of Products that need to be changed.
    *  @param data The Data Object to change the field to
    *  @param String actionType to find out user Selected Append ,Replace,Remove.
    *  @param ProductFieldChangerPanel The panel that holds the current status
    *
    *  @return TRUE if everything went Ok
    *//*---------------------------------------------------------*/
   public void beginProcess ( Vector productList, Object data, String actionType, String comments ) {
      boolean      yesProcess        = false ;
      int          i         = 0 ;
      int          size      = productList.size() ;
      StringBuffer sqlBuffer = new StringBuffer() ;
      ProductDraft      productDraft   = null ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Form what big buffer to send to SQL Runner              */                                 
      /*                                                           */
      /*-----------------------------------------------------------*/
      try{
          if(actionType.equals(Str.getStr(STR_REPLACE))){
              System.out.println("Inside model class");
              while ( ( continueProcess ) && ( i < size ) ) {
                 productDraft = (ProductDraft)productList.elementAt(i) ;
                 productDraft.setModel((TypeCategoryRec)data);
                 productDraft.setLastTouchedBy(UserSystem.getUserId());
                 productDraft.setComment( Text.cleanDBString ( comments ) );
                 int sqlID =productDraft.writeToDatabase();
                 if( sqlID !=0 ){
                     //stopProcess();
                      LogSystem.log(1,"Could not able to set the machine for  product  "+productDraft.getProductInd());
                      yesProcess =GUISystem.printBox(STR_QUESTION,STR_WIZARD_PROBLEM);
                      if(!yesProcess){
                          stopProcess();
                      }
                 }
                 i++ ;
              } /* while  */
          }/* if */

      }
      catch(Exception e){
          LogSystem.log(1,e);
      }
   } /* beginProcess  */


   /*------------------------------------------------------------*/
   /* stopProcess
    */
   /**
    *    This method will stop the processing at the next
    *  available point
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void stopProcess () {
      continueProcess = false ;
   }

} /* ProductBaseModelFieldChanger */
