

package com.ibm.nzna.projects.qit.product.manager.masschange ;                    
/*-----------------------------------------------------------*/
/*   ProductPartNumFieldChanger                                */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ProductPartNumFieldChanger            */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.storedProc.sqlRunner.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.storedProc.sqlRunner.* ;
import com.ibm.nzna.projects.qit.doc.* ;
import com.ibm.nzna.projects.common.quest.product.*;
import com.ibm.nzna.projects.qit.product.*;
/**
 * This field changer will change the Product Part Number of 
 * a list of products
 *
 * @version 1.0, 05/20/2001 
 * @author  
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ProductPartNumFieldChanger                                */
/*                                                           */
/*-----------------------------------------------------------*/
public class ProductPartNumFieldChanger extends Object implements  AppConst,ProductConst {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private boolean continueProcess = true ;
   public void beginProcess ( Vector productList, Object data, String actionType, String comments ) {

       int          i              = 0 ;
       int          size           = productList.size() ;
       ProductDraft productDraft   = null ;
       boolean      yesProcess     = false;


   /*------------------------------------------------------------*/
   /* beginProcess
    */
   /**
    *    This method must begin the process of 
    *  changing the documents identified in 'productList'. This
    *  method should not return until an unrecoverable error occurs
    *  or all processing is complete
    *  
    *
    *  @param productList The Vector of Products that need to be changed.
    *  @param data The Data Object to change the field to
    *  @param updateOnly The FieldChanger should only update information, not Update and Replace information
    *  @param ProductFieldChangerPanel The panel that holds the current status
    *
    *  @return TRUE if everything went Ok
    *//*---------------------------------------------------------*/
   if(actionType.equals(Str.getStr(STR_REPLACE))){
       while ( ( continueProcess ) && ( i < size ) ) {
          productDraft = (ProductDraft)productList.elementAt(i) ;
          productDraft.setPartNumber((TypeCategoryRec)data);
          productDraft.setLastTouchedBy(UserSystem.getUserId());
          productDraft.setComment(Text.cleanDBString ( comments ));
          int sqlID =productDraft.writeToDatabase();
          if( sqlID !=0 ){
              //stopProcess();
               yesProcess =GUISystem.printBox(STR_QUESTION,STR_WIZARD_PROBLEM);
               LogSystem.log(1,"Could not able to set the brand for  product  "+productDraft.getProductInd());
               if(!yesProcess){
                   stopProcess();
               }
          }
          i++ ;
       } /* while  */
   }/* if */

} /* beginProcess  */


/*------------------------------------------------------------*/
/* stopProcess
 */
/**
 *    This method will stop the processing at the next
 *  available point
 *  
 *
 *  @param None
 *  @param None
 *  @param None
 *
 *  @return Nothing
 *//*---------------------------------------------------------*/
public void stopProcess () {
   continueProcess = false ;
}

} /* ProductPartNumFieldChanger */
