

package com.ibm.nzna.projects.qit.product.manager.masschange ;                    
/*-----------------------------------------------------------*/
/*   ProductProjectFieldChanger                              */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ProductProjectFieldChanger          */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.storedProc.sqlRunner.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.storedProc.sqlRunner.* ;
import com.ibm.nzna.projects.qit.doc.* ;
import com.ibm.nzna.projects.common.quest.product.*;
import com.ibm.nzna.projects.qit.product.*;
/**
 * This field changer will change the Product's project of 
 * a list of products
 *
 * @version 1.0, 05/20/2001 
 * @author  Jag.
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ProductProjectFieldChanger                                */
/*                                                           */
/*-----------------------------------------------------------*/
public class ProductProjectFieldChanger extends Object implements  AppConst,ProductConst {


    /*-----------------------------------------------------------*/
    /*                                                           */
    /*   Private Members                                         */
    /*                                                           */
    /*-----------------------------------------------------------*/
    private boolean continueProcess = true ;
    /*------------------------------------------------------------*/
    /* beginProcess
     */
    /**
     *    This method must begin the process of 
     *  changing the documents identified in 'productList'. This
     *  method should not return until an unrecoverable error occurs
     *  or all processing is complete
     *  
     *
     *  @param productList The Vector of Products that need to be changed.
     *  @param data The Data Object to change the field to
     *  @param project entered  by the user.
     *  @param String comments entered by the user.
     *
     *  @return TRUE if everything went Ok
     *//*---------------------------------------------------------*/
    public void beginProcess ( Vector productList, Object data, String actionType, String comments ) {

        int          i              = 0 ;
        int          size           = productList.size() ;
        ProductDraft productDraft   = null ;
        boolean      yesProcess     = false;


        if (actionType.equals(Str.getStr(STR_REPLACE))) {
            while ( ( continueProcess ) && ( i < size ) ) {
                productDraft = (ProductDraft)productList.elementAt(i) ;
                productDraft.setBrand(productDraft.getBrand());
                productDraft.setFamily(productDraft.getFamily());
                TypeCategoryRec project = TypeCategory.getDraftCategoryFromDescription( (String)data, TypeCategory.LEVEL_PROJECT,productDraft.getFamily().getInd());
                if (project==null) {
                    project = TypeCategory.createDraftTypeCategory ( productDraft.getFamily().getInd() ,(String)data , TypeCategory.LEVEL_PROJECT, 0, "N", UserSystem.getUserId() ) ;
                }
                productDraft.setProject(project);
                if (productDraft.getProductType()==TypeList.PRODUCTTYPE_OPTION) {
                    TypeCategoryRec subCategory= TypeCategory.getDraftCategoryFromDescription( productDraft.getSubCategory().getDescript(), TypeCategory.LEVEL_SUBCATEGORY,project.getInd());
                    if (subCategory==null) {
                        subCategory = TypeCategory.createDraftTypeCategory ( project.getInd() ,productDraft.getSubCategory().getDescript() , TypeCategory.LEVEL_SUBCATEGORY, 0, "N", UserSystem.getUserId() ) ;
                    }
                    productDraft.setSubCategory(subCategory);
                    TypeCategoryRec partNumber=TypeCategory.getDraftCategoryFromDescription( productDraft.getPartNumber().getDescript(), TypeCategory.LEVEL_PARTNUMBER,subCategory.getInd());

                    if (partNumber==null) {
                        partNumber= TypeCategory.createDraftTypeCategory ( subCategory.getInd() ,productDraft.getPartNumber().getDescript() , TypeCategory.LEVEL_PARTNUMBER, 0, "N", UserSystem.getUserId() ) ;
                    }
                    productDraft.setPartNumber(partNumber);
                } else {
                    TypeCategoryRec machine = TypeCategory.getDraftCategoryFromDescription( productDraft.getMachine().getDescript(), TypeCategory.LEVEL_MACHINE,project.getInd());
                    if (machine==null) {
                        machine = TypeCategory.createDraftTypeCategory ( project.getInd() ,productDraft.getMachine().getDescript() , TypeCategory.LEVEL_MACHINE, 0, "N", UserSystem.getUserId() ) ;
                    }
                    productDraft.setMachine(machine);

                    TypeCategoryRec model = TypeCategory.getDraftCategoryFromDescription( productDraft.getModel().getDescript(), TypeCategory.LEVEL_MODEL,machine.getInd());
                    if (model==null) {
                        model = TypeCategory.createDraftTypeCategory ( machine.getInd() ,productDraft.getModel().getDescript() , TypeCategory.LEVEL_MODEL, 0, "N", UserSystem.getUserId() ) ;
                    }
                    productDraft.setModel(model);
                }

                TypeCategory.writeToDatabase();
                productDraft.setLastTouchedBy(UserSystem.getUserId());
                productDraft.setComment( Text.cleanDBString ( comments ) );
                int sqlID =productDraft.writeToDatabase();
                if ( sqlID !=0 ) {
                    //stopProcess();
                    yesProcess =GUISystem.printBox(STR_QUESTION,STR_WIZARD_PROBLEM);
                    LogSystem.log(1,"Could not able to set the project for  product  "+productDraft.getProductInd());
                    if (!yesProcess) {
                        stopProcess();
                    }
                }
                i++ ;
            } /* while  */
        }/* if */

    } /* beginProcess  */


/*------------------------------------------------------------*/
/* stopProcess
 */
/**
 *    This method will stop the processing at the next
 *  available point
 *  
 *
 *  @param None
 *  @param None
 *  @param None
 *
 *  @return Nothing
 *//*---------------------------------------------------------*/
    public void stopProcess () {
        continueProcess = false ;
    }

} /* ProductProjectFieldChanger */
