
package com.ibm.nzna.projects.qit.product.manager.masschange ;                    
/*-----------------------------------------------------------*/
/*   ProductSubCategoryFieldChanger                          */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ProductSubCategoryFieldChanger      */
/*                                                           */
/*                                                           */
/*         @Copyright  2001 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.doc.* ;
import com.ibm.nzna.projects.qit.product.*;
import com.ibm.nzna.projects.common.quest.product.*;
/**
 * This field changer will change the subcategory of 
 * a list of products
 *
 * @version 1.0, 05/20/2001 
 * @author  Jag.
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ProductSubCategoryFieldChanger                          */
/*                                                           */
/*-----------------------------------------------------------*/
public class ProductSubCategoryFieldChanger extends Object implements   AppConst,ProductConst {


    /*-----------------------------------------------------------*/
    /*                                                           */
    /*   Private Members                                         */
    /*                                                           */
    /*-----------------------------------------------------------*/
    private boolean continueProcess = true ;





    /*------------------------------------------------------------*/
    /* beginProcess
     */
    /**
     *    This method must begin the process of 
     *  changing the documents identified in 'productList'. This
     *  method should not return until an unrecoverable error occurs
     *  or all processing is complete
     *  
     *
     *  @param productList The Vector of Products that need to be changed.
     *  @param data The Data Object to change the field to
     *  @param actiontype selected by the user.
     *  @param String comments for product draft.
     *
     *  
     *//*---------------------------------------------------------*/
    public void beginProcess ( Vector productList, Object data, String actionType, String comments ) {

        int          i              = 0 ;
        int          size           = productList.size() ;
        ProductDraft productDraft   = null ;
        boolean      yesProcess     = false;
        int sqlID=0;
        if (actionType.equals(Str.getStr(STR_REPLACE))) {
            while ( ( continueProcess ) && ( i < size ) ) {
                productDraft = (ProductDraft)productList.elementAt(i) ;
                TypeCategoryRec project=productDraft.getProject();
                /* Set The SubCategory for selected productDrafts*/
                if (productDraft.getProductType()==TypeList.PRODUCTTYPE_OPTION) {
                    TypeCategoryRec subCategory= TypeCategory.getDraftCategoryFromDescription( (String)data, TypeCategory.LEVEL_SUBCATEGORY,project.getInd());
                    if (subCategory==null) {
                        subCategory = TypeCategory.createDraftTypeCategory ( project.getInd() ,(String)data , TypeCategory.LEVEL_SUBCATEGORY, 0, "N", UserSystem.getUserId() ) ;
                    }
                    productDraft.setSubCategory(subCategory);
                    TypeCategoryRec partNumber=TypeCategory.getDraftCategoryFromDescription( productDraft.getPartNumber().getDescript(), TypeCategory.LEVEL_PARTNUMBER,subCategory.getInd());
                    /* Set the PartNumber for the selected ProductDrafts*/
                    if (partNumber==null) {
                        partNumber= TypeCategory.createDraftTypeCategory ( subCategory.getInd() ,productDraft.getPartNumber().getDescript() , TypeCategory.LEVEL_PARTNUMBER, 0, "N", UserSystem.getUserId() ) ;
                    }
                    productDraft.setPartNumber(partNumber);
                    TypeCategory.writeToDatabase();
                    productDraft.setLastTouchedBy(UserSystem.getUserId());
                    productDraft.setComment(Text.cleanDBString ( comments ));
                    sqlID =productDraft.writeToDatabase();
                }
                if ( sqlID !=0 ) {
                    yesProcess =GUISystem.printBox(STR_QUESTION,STR_WIZARD_PROBLEM);
                    LogSystem.log(1,"Could not able to set the brand for  product  "+productDraft.getProductInd());
                    if (!yesProcess) {
                        stopProcess();
                    }
                }
                i++ ;
            } /* while  */
        }/* if */

    } /* beginProcess  */


/*------------------------------------------------------------*/
/* stopProcess
 */
/**
 *    This method will stop the processing at the next
 *  available point
 *  
 *
 *  @param None
 *  @param None
 *  @param None
 *
 *  @return Nothing
 *//*---------------------------------------------------------*/
    public void stopProcess () {
        continueProcess = false ;
    }

} /* ProductSubCategoryFieldChanger */
