package com.ibm.nzna.projects.qit.product.manager.productview;
/*-----------------------------------------------------------*/
/*   Source File
/*
/*   Filename:      PRODUCTVIEWPANEL
/*   Creation Date: MAY 29, 2001
/*
/*
/*
/*         @Copyright  2001
/*          All Rights Reserved
/*
/*
/*-----------------------------------------------------------*/
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import com.ibm.nzna.shared.gui.*;
import com.ibm.nzna.projects.qit.app.*;
import com.ibm.nzna.projects.qit.gui.*;
import com.ibm.nzna.projects.common.quest.type.*;
import com.ibm.nzna.projects.qit.product.manager.* ;


/**
 *
 *
 * This panel holds all of the different types of views supported for searching on Products
 * @version 1
 * @author Venu Sanka
 */

/*----------------------------------------------------*/
/*
/* ProductViewPanel
/*
/*----------------------------------------------------*/
public class ProductViewPanel extends JPanel implements  ActionListener, AppConst {

    /*-----------------------------------------------------------*/
    /*                                                           */
    /*   PrivateGUIMembers                                       */
    /*                                                           */
    /*-----------------------------------------------------------*/

    /**
     * The drop down for views 
     *
     */
    private JComboBox   cb_VIEWS            = null ;

    /**
     * The JPanel for holding the selection criterion for DataMapping view 
     */
    private JPanel      brd_DATAMAP         = null ;

    /**
     * The JPanel for holding the selection criterion for Misfit view 
     */
    private JPanel      brd_MISFIT          = null ;

    /**
     * The JPanel for holding the selection criterion for Brand views 
     */
    private JPanel      brd_BRAND           = null ;

    /**
     * The JPanel for holding the OpenDrafts selection 
     */
    private NavListGroup      openDraftBrandList     = null ;

    /**
     * The drop down for views 
     */
    private NavListGroup      existingProductsBrandList  = null ;



    /*-----------------------------------------------------------*/
    /*                                                           */
    /*   Secondary View Lists                                    */
    /*                                                           */
    /*-----------------------------------------------------------*/
    private NavListGroup     openDraftBrandByProject  = null ;
    private NavListGroup     existingProductsBrandByFamily  = null ;
    private NavListGroup     existingProductsBrandByProject = null ;


    private NavListGroup     misfitBrand              = null ;
    private NavListGroup     misfitFamily             = null ;
    private NavListGroup     misfitSeries             = null ;
    private NavListGroup     misfitByProjectName      = null ;


    /*-----------------------------------------------------------*/
    /*                                                           */
    /*   Private Members                                         */
    /*                                                           */
    /*-----------------------------------------------------------*/
    private Vector listeners           =  new Vector (1, 1) ;
    private HotLinkGroup hotLinkGroup  =  new HotLinkGroup () ;
    private boolean initialized        =  false ;
    private JScrollPane  viewScroll    =  null ;

    private ProductManagementPanel productManagementPanel = new ProductManagementPanel() ;



    

    /*------------------------------------------------------------*/
    /* Constructor
     */
    /**
     * Default Constructor
     *
     * @param None
     * @param None
     * @param None
     *
     * @return Nothing
     *//*---------------------------------------------------------*/
    public ProductViewPanel () {

        createGUI() ;
    }

    /*------------------------------------------------------------*/
    /* createGUI
     */
    /**
     * This method will create our GUI and add it to our panel
     *
     * @param None
     * @param None
     * @param None
     *
     * @return Nothing
     *//*---------------------------------------------------------*/
    private void createGUI () {
        Vector views = (Vector)TypeList.getInstance().getTypeList( TypeList.TYPE_BRAND ).clone();

        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   Add the special 'Select a View'                         */
        /*                                                           */
        /*-----------------------------------------------------------*/
        views.insertElementAt(new TypeBrandRec ( -1, Str.getStr( STR_SELECT_A_VIEW ), 0 ), 0 ) ;

        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   Create the controls                                     */
        /*                                                           */
        /*-----------------------------------------------------------*/
        cb_VIEWS     =  new JComboBox ( views ) ;
        
        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   Add the GUI                                             */
        /*                                                           */
        /*-----------------------------------------------------------*/
        setLayout ( null ) ;
        add ( cb_VIEWS ) ;
        



    }


    /*------------------------------------------------------------*/
    /* doLayout
     */
    /**
     *    This method will lay out and position all of
     *  our controls
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void doLayout () {
        //if ( initialized ) {
        Dimension size      = getSize() ;
        int       x         = 5 ;
        int       y         = 5 ;
        int       rowHeight = GUISystem.getRowHeight() ;

        super.doLayout() ;

        
        cb_VIEWS.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
        y+=rowHeight+5 ;

        //viewScroll.setBounds ( 2, y, size.width-4, size.height-y ) ;
        //}
    }


    /*------------------------------------------------------------*/
    /* setPanel
     */
    /**
     * This method will set the JPanel based on the selection in the JComboBox.
     * BrandViews or DataMappingView or MisfitView may be selected in the Combo drop down
     *
     * @param None
     * @param None
     * @param None
     *
     * @return Nothing
     *//*---------------------------------------------------------*/
    public void setPanel () {
    }



    /*------------------------------------------------------------*/
    /* actionPerformed
     */
    /**
     *    This method will be called when an action
     *  event is fired
     *  
     *
     *  @param e The event
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void actionPerformed ( ActionEvent e ) {

        
    } /* actionPerformed */



    
}
/* ProductViewPanel */
