package com.ibm.nzna.projects.qit.product.manager.property ;           
/*-----------------------------------------------------------*/
/*   GeneralPage                                             */
/*                                                           */
/*   Description:                                            */
/*      Source code for: GeneralPage                         */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import java.awt.event.* ;
import java.util.* ;
import javax.swing.* ;
import javax.swing.event.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.projects.qit.product.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.help.* ;
/**
 * This page has general user adjustable settings for the Product Views 
 *
 *
 * @version 1.0, 1/1/1998 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   GeneralPage                                             */
/*                                                           */
/*-----------------------------------------------------------*/
public class GeneralPage extends JPanel implements ProductConst, AppConst {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private JCheckBox ck_WORD_WRAP         = new JCheckBox ( Str.getStr ( STR_WORD_WRAP ) ) ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    Default constructor
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public GeneralPage () {
      createGUI () ;
   }


   /*------------------------------------------------------------*/
   /* createGUI
    */
   /**
    *    This method will create and add our 
    *  GUI components
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void createGUI () {


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add listeners                                           */
      /*                                                           */
      /*-----------------------------------------------------------*/

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add the GUI                                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( null ) ;
      add ( ck_WORD_WRAP ) ;
      ck_WORD_WRAP.setSelected ( PropertySystem.getBool ( PROPERTY_PRODUCT_MGMT_WORD_WRAP ) ) ;

   }





   /*------------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will lay out and position all
    *  of our components
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout ( ) {
      Dimension size      = getSize() ;
      int       rowHeight = GUISystem.getRowHeight() ;
      int       x         = 5 ;
      int       y         = 5 ;

      super.doLayout() ;
      ck_WORD_WRAP.setBounds ( x, y, size.width-(x*2), rowHeight ) ;

   }




   /*------------------------------------------------------------*/
   /* saveData
    */
   /**
    *    This method will save the data on our
    *  screen. It will return TRUE if all data
    *  was saved
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean saveData () {
      boolean oldWrap = PropertySystem.getBool ( PROPERTY_PRODUCT_MGMT_WORD_WRAP ) ;

      if ( oldWrap != ck_WORD_WRAP.isSelected() )
         GUISystem.printBox ( "Info", "For the word wrap change to take affect, you must restart Product Management" ) ;
      PropertySystem.putBool ( PROPERTY_PRODUCT_MGMT_WORD_WRAP, ck_WORD_WRAP.isSelected() ) ;


      return( true ) ;
   }



} /* GeneralPage */
