package com.ibm.nzna.projects.qit.product.manager.views ;
/*-----------------------------------------------------------*/
/*   PMView                                                  */
/*                                                           */
/*   Description:                                            */
/*      Source code for: PMView                              */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import javax.swing.tree.* ;
import com.ibm.nzna.shared.gui.ViewTreeNode ;
import com.ibm.nzna.projects.common.quest.type.TypeCategoryRec ;
/**
 * The PMView Interface is here to define the methods that 
 * the Product Management panel uses
 *
 * @version 1.0, 8/28/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   PMView                                                  */
/*                                                           */
/*-----------------------------------------------------------*/
public interface PMView  {


   /**
     *  This method should be subclassed to return
     * the starting JTreeModel for a JTree for the view
     **/
   public abstract DefaultTreeModel getJTreeModel () ;

   /**
     *  This method should be subclassed to refresh a view from
     * the database under the ViewTreeNode passed in.
     **/
   public abstract void refreshViewTree ( DefaultTreeModel treeModel, ViewTreeNode node ) ;


   /**
     *  This method should return the width in pixels of the padding/buffer space
     * before the title columns begin in the DetailJTree
     **/
   public abstract int getTitlePadding () ;

   /**
     *  This method must return the name of the view
     **/
   public abstract String getName () ;


   /**
     *  This method must return the brand that this view uses
     **/
   public abstract TypeCategoryRec getBrand () ;


   /**
     *  This method must return the FULL SQL that would return all
     * normal products from this view in one query
     **/
   public abstract String getFullSQL () ;


   /**
     * This method returns the column names that the view shows. These
     * column names must be returned in a String array
     **/
   public abstract String[] getColumnNames () ;

   /**
     * This method returns the column widths in the form of an integer
     * array
     **/
   public abstract int[] getColumnWidths() ;
} /* PMView */
