package com.ibm.nzna.projects.qit.product.manager.views ;         
/*-----------------------------------------------------------*/
/*   ViewDataMapGC                                           */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ViewDataMapGC                       */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
import javax.swing.tree.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.product.* ;
import com.ibm.nzna.projects.qit.product.gui.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.quest.product.* ;
import com.ibm.nzna.shared.gui.* ;
/**
 * This view will list all OPIC/M Geos/Countries and their
 * Corresponding Quest Counties
 *
 * @version 1.0, 4/18/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ViewDataMapGC                                           */
/*                                                           */
/*-----------------------------------------------------------*/
public class ViewDataMapGC extends Object implements ProductConst, PMNavView, AppConst {

   /*------------------------------------------------------------*/
   /* getName
    */
   /**
    *    This method will return the user readable
    *  description of this view
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getName () {
      return( Str.getStr ( STR_GEOGRAPHY_COUNTRY ) ) ;
   }

   /*------------------------------------------------------------*/
   /* getShortName
    */
   /**
    *    This method will return the user readable  short
    *  description of this view
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getShortName () {
      return( Str.getStr ( STR_GEOGRAPHY_COUNTRY ) ) ;
   }


   /**
     *  This view does not support brands, so this method does nothing
     **/
   public void setBrand ( TypeCategoryRec categoryRec ) {

   }

   /**
     *  This method will return the Complete JTree Model for this view
     **/
   public DefaultTreeModel getJTreeModel () {
      DefaultMutableTreeNode root      = null ;
      Vector                 mapVector = createMappingVector() ;
      DefaultTreeModel       model     = new DefaultTreeModel ( root = new DefaultMutableTreeNode() ) ;       

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add each mapping                                        */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( ( mapVector != null ) && ( mapVector.size() > 0 ) ) {
         int i    = 0 ;
         int size = mapVector.size() ;

         while ( i < size ) {
            MutableTreeWrapper newNode = new MutableTreeWrapper () ;

            newNode.setDataObject ( mapVector.elementAt(i) ) ;
            model.insertNodeInto ( newNode, root, 0 ) ;
            i++ ;
         }
      }
      return( model ) ;
   }


   /**
     *  This method will refresh the view in a tree. This method does not 
     * support this so this method does nothing
     **/
   public void refreshViewTree ( DefaultTreeModel model, ViewTreeNode node ) {
   }


   /**
     *  This method will return the amount of pixels that should be in place
     * before the first column of this view
     **/
   public int getTitlePadding () {
      return( 10 ) ;
   }


   /**
     *  This method will create a vector of all OPIC/M Geographics and COuntries and
     * and their corresponding Quest Geographies/Countries
     *
     * @return Vector
     **/
   private Vector createMappingVector () {
      Vector       seriesVec  = TypeCategory.getCategories ( TypeCategory.LEVEL_OPICM_COUNTRY ) ;
      Vector       mappingVec = new Vector ( 1 ) ;          
      OPICMMapper  mapper     = new OPICMMapper () ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Process each series                                     */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( ( seriesVec != null ) && ( seriesVec.size() > 0 ) ) {
         int i    = 0 ;
         int size = seriesVec.size() ;

         while ( i < size ) {
            CountryMappingRow mapRow  = new CountryMappingRow() ;
            TypeCategoryRec   country = (TypeCategoryRec)seriesVec.elementAt(i) ;

            mapRow.oCountry   = country ;
            mapRow.oGeo       = TypeCategory.getCategory ( country.getParentCatInd() ) ;
            mapRow.countryRec = mapper.getQuestCountryFromOPICM ( mapRow.oGeo.toString(), mapRow.oCountry.toString() ) ;
            mappingVec.addElement ( mapRow ) ;
            i++ ;
         }
      }

      return( mappingVec ) ;
   }

   public TypeCategoryRec getBrand () {
      return( null ) ;
   }

   public String getFullSQL () {
      return( null ) ;
   }




   /**
     * This method will return the column names for this view
     **/
   public String[] getColumnNames () {
      String[] columnHeadings = {
         "OGeography",
         "OCountry",
         Str.getStr ( STR_COUNTRY )
      };

      return( columnHeadings ) ;
   } /* getColumnNames  */


   /**
     * This method will return the width (in pixels) of each column
     **/
   public int[] getColumnWidths () {
      int[] widths = {
          150,
          150,
          150 } ;

      return( widths ) ;
   }

} /* ViewDataMapGC */
