package com.ibm.nzna.projects.qit.product.productEdit ; 
/*-----------------------------------------------------------*/
/*   OtherInfoPanel                                          */
/*                                                           */
/*   Description:                                            */
/*      Source code for: OtherInfoPanel                      */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.event.* ;
import java.awt.* ;
import javax.swing.* ;
import com.ibm.nzna.projects.qit.app.*;
import com.ibm.nzna.projects.qit.product.*;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.quest.product.* ;
/**
 * This panel holds the Offering, Customer Name, Warranty, Input and
 * source
 *
 * @version 1.0, 8/26/2001 
 * @author  David Lentz
 */


public class OtherInfoPanel extends DPanel implements ActionListener, FocusListener, ProductPropertyListener, AppConst, ProductConst {


   /**
     *  This is the JLabel for the Base Model
     **/
   public JLabel st_BASE = new JLabel ( Str.getStr ( STR_BASE_MODEL ) ) ;

   /**
     *  This is the JTextField for the base model
     **/
   public JTextField ef_BASE = new JTextField ( new MaskDocument ( MaskDocument.MASKTYPE_UNKNOWN, 7 ), "", 0 ) ;

   /**
     * This is the label for the offering
     **/
   public JLabel st_OFFERING = new JLabel ( "*"+Str.getStr ( STR_OFFERING ) ) ;

   /**
     * This is the label for the customer name
     **/
   public JLabel st_CUSTOMER = new JLabel ( "*"+Str.getStr ( STR_CUSTOMER ) ) ;

   /**
     * This is the label for the warranty
     **/
   public JLabel st_WARRANTY = new JLabel ( "*"+Str.getStr ( STR_WARRANTY ) ) ;

   /**
     * This is the JLabel for the Input 
     **/
   public JLabel st_INPUT = new JLabel ( Str.getStr ( STR_INPUT ) ) ;

   /**
     * This is the JLabel for the Source
     **/
   public JLabel st_SOURCE = new JLabel ( Str.getStr ( STR_SOURCE ) ) ;

   /**
     * This is the Drop down for offering
     **/
   public JComboBox cb_OFFERING = new JComboBox ( TypeList.getInstance().getTypeList ( TypeList.TYPE_OFFERING ) ) ;

   /**
     * This is the Drop down for customer
     **/
   public JComboBox cb_CUSTOMER = new JComboBox ( TypeList.getInstance().getTypeList ( TypeList.TYPE_CUSTOMER ) ) ;

   /**
     * This is the Warranty drop down
     **/
   public JComboBox cb_WARRANTY = new JComboBox ( TypeList.getInstance().getTypeList ( TypeList.TYPE_WARRANTY ) ) ;

   /**
     * This is the Input Static Text
     **/
   public JLabel stt_INPUT = new JLabel () ;

   /**
     * This is the JTextField for the source
     **/
   public JTextField ef_SOURCE = new JTextField () ;


   /**
     *  This is the product we are editing
     **/
   public Product product = null ;

   /**
     * This flag tells the actionPerformed method if it should process actions
     **/
   private boolean processActions = true ;



   /**
     * Default Constructor
     **/
   public OtherInfoPanel () {

      /*--------------------*/
      /*                    */
      /*  Adjust properties */
      /*                    */
      /*--------------------*/
      setBackground ( Color.white ) ;
      setPreferredSize ( new Dimension ( 550, GUISystem.getRowHeight()*6 ) ) ;                                                    


      /*----------------*/
      /*                */
      /*  Add listeners */
      /*                */
      /*----------------*/
      ef_BASE.addFocusListener ( this ) ;
      ef_SOURCE.addFocusListener    ( this ) ;
      cb_WARRANTY.addActionListener ( this ) ;
      cb_CUSTOMER.addActionListener ( this ) ;
      ef_SOURCE.addActionListener   ( this ) ;
      cb_OFFERING.addActionListener ( this ) ;



      /*--------------*/
      /*              */
      /*  Add the gui */
      /*              */
      /*--------------*/
      setLayout ( null ) ;
      add ( st_BASE ) ;
      add ( ef_BASE ) ;
      add ( st_OFFERING ) ;
      add ( cb_OFFERING ) ;
      add ( st_CUSTOMER ) ;
      add ( cb_CUSTOMER ) ;
      add ( st_WARRANTY ) ;
      add ( cb_WARRANTY ) ;
      add ( st_INPUT ) ;
      add ( stt_INPUT ) ;
      add ( st_SOURCE ) ;
      add ( ef_SOURCE) ;
   }



   public void doLayout () {
      Dimension size      = getSize() ;
      int       x         = 0 ;
      int       y         = 0 ;
      int       rowHeight = GUISystem.getRowHeight () ;

      st_BASE.setBounds ( x, y, 100, rowHeight ) ;
      ef_BASE.setBounds ( x+140, y, 100, rowHeight ) ;
      y+=rowHeight ;

      st_OFFERING.setBounds ( x, y, 100, rowHeight ) ;
      cb_OFFERING.setBounds ( x+140, y, 200, rowHeight ) ;
      y+=rowHeight ;

      st_CUSTOMER.setBounds ( x, y, 100, rowHeight ) ;
      cb_CUSTOMER.setBounds ( x+140, y, 200, rowHeight ) ;
      y+=rowHeight ;


      st_WARRANTY.setBounds ( x, y, 100, rowHeight ) ;
      cb_WARRANTY.setBounds ( x+140, y, 300, rowHeight ) ;
      y+=rowHeight ;


      st_INPUT.setBounds ( x, y, 100, rowHeight ) ;
      stt_INPUT.setBounds ( x+140, y, 100, rowHeight ) ;
      y+=rowHeight ;



      st_SOURCE.setBounds ( x, y, 100, rowHeight ) ;
      ef_SOURCE.setBounds ( x+140, y, 200, rowHeight ) ;
      y+=rowHeight ;

   }


   /**
     *  This method will set the product that we are working on
     **/
   public void setProduct ( Product product ) {
      if ( this.product != product ) {
         if ( this.product != null )
            this.product.removeProductPropertyListener ( this ) ;

         this.product = product ;
         product.addProductPropertyListener ( this ) ;
      }

      refresh () ;
   }


   /**
     *  This method will refresh our data
     **/
   private void refresh () {
      String source = product.getSource() ;

      processActions = false ;

      try {
         if ( product.getBaseModel() != null )
         ef_BASE.setText ( product.getBaseModel() ) ;

      cb_CUSTOMER.setSelectedItem ( TypeList.getInstance().objectFromInd ( product.getCustomer(), 
                                                                           TypeList.TYPE_CUSTOMER ) ) ;

      cb_WARRANTY.setSelectedItem ( TypeList.getInstance().objectFromInd ( product.getWarranty(), 
                                                                           TypeList.TYPE_WARRANTY ) ) ;

      cb_OFFERING.setSelectedItem ( TypeList.getInstance().objectFromInd ( product.getOffering(), 
                                                                           TypeList.TYPE_OFFERING ) ) ;

      if ( product instanceof ProductDraft ) {
         if ( ((ProductDraft)product).isOPICM() ) {
            if ( source.indexOf ( "(OPIC/M)" ) == -1 )
               source = "(OPIC/M) "+source ;
         }
      }

      stt_INPUT.setText ( product.getInput() ) ;
      ef_SOURCE.setText ( source ) ; 
      } catch ( Exception e ) {
         LogSystem.log ( 1, e, false ) ;
         GUISystem.printBox ( "Info", "Could not populate the 'Other Info'. Please report this problem to the 1-888-IBM-HELP desk" ) ;
      }

      processActions = true ;

   }


   public void productChanged ( Product product, int property ) {
      if ( ( property == Product.BASEMODEL ) ||
           ( property == Product.CUSTOMER ) ||
           ( property == Product.WARRANTY ) ||
           ( property == Product.OFFERING ) ) {
         product.setPropertyChangeEnabled ( false ) ;
         refresh() ;
         product.setPropertyChangeEnabled ( true ) ;
      }
   }


   /**
     *  Does nothing
     **/
   public void focusGained ( FocusEvent e ) {
   }


   /**
     *  This method will save our base model information
     **/
   public void focusLost ( FocusEvent e ) {

      if ( e.getSource() == ef_BASE )
         product.setBaseModel ( ef_BASE.getText() ) ;

      else if ( e.getSource() == ef_SOURCE ) {
         String source = ef_SOURCE.getText() ;

         if ( product instanceof ProductDraft ) {
            if ( ((ProductDraft)product).isOPICM() ) {
               if ( source.indexOf ( "(OPIC/M)" ) == -1 )
                  source = "(OPIC/M) "+source ;
            }
         }

         product.setSource ( source ) ;
      }
   }


   /**
     *  This method will be called when the user selects items in our
     * drop downs. We will save the data when they do that
     **/
   public void actionPerformed ( ActionEvent e ) {

      if ( processActions ) {

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Warranty                                                */
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( e.getSource() == cb_WARRANTY )
            product.setWarranty ( ((TypeWarrantyRec)cb_WARRANTY.getSelectedItem()).getInd() ) ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Offering                                                */
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( e.getSource() == cb_OFFERING )
            product.setOffering ( ((TypeOfferingRec)cb_OFFERING.getSelectedItem()).getInd() ) ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Customer                                                */
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( e.getSource() == cb_CUSTOMER )
            product.setCustomer ( ((TypeCustomerRec)cb_CUSTOMER.getSelectedItem()).getInd() ) ;
      }
   }



   /**
     *  This method will enable/disable all controls on this panel
     **/
   protected void setEditable ( boolean editable ) {
      cb_CUSTOMER.setEnabled ( editable ) ;
      cb_OFFERING.setEnabled ( editable ) ;
      cb_WARRANTY.setEnabled ( editable ) ;
      ef_BASE.setEnabled     ( editable ) ;
   }
}
