package com.ibm.nzna.projects.qit.product.productEdit ;            
/*-----------------------------------------------------------*/
/*   ProductSaveStatusPanel                                  */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ProductSaveStatusPanel              */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import javax.swing.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.product.* ;
import com.ibm.nzna.projects.common.quest.product.* ;
import com.ibm.nzna.projects.common.quest.type.* ;     
/**
 * This panel holds the status of a document saving 
 *
 *
 * @version 1.0, 8/22/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ProductSaveStatusPanel                                  */
/*                                                           */
/*-----------------------------------------------------------*/
public class ProductSaveStatusPanel extends JPanel implements AppConst, ProductConst {


   /**
     *  This is the Label for saving the document
     **/
   private JLabel st_PRODUCT = new JLabel ( Str.getStr ( STR_SAVING_PRODUCT ) );

   /**
     *  This is the Check Box for saving the document
     **/
   private JCheckBox ck_PRODUCT = new JCheckBox (  );

   /**
     *  This is the status area
     **/
   private JLabel st_OUTPUT = new JLabel () ;


   /**
     *  Our title
     **/
   private JLabel st_TITLE = new JLabel ( Str.getStr ( STR_SAVING_PRODUCT ) ) ;


   /**
     *  Default constructor
     **/
   public ProductSaveStatusPanel ( ProductDraft draft ) {

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      ck_PRODUCT.setEnabled ( false ) ;
      st_PRODUCT.setEnabled ( false ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add our GUI                                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      add ( st_TITLE ) ;
      add ( st_PRODUCT ) ;
      add ( st_OUTPUT ) ;
      add ( ck_PRODUCT ) ;
   }



   /**
     *  This method lays out our GUI
     **/
   public void doLayout () {
      Dimension size      = getSize() ;
      int       x         = 5 ;
      int       y         = 15 ;
      int       rowHeight = GUISystem.getRowHeight () ;

      super.doLayout() ;

      st_TITLE.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight ;

      ck_PRODUCT.setBounds ( x, y, 20, rowHeight ) ;
      st_PRODUCT.setBounds ( x+20, y, size.width-(x*2), rowHeight ) ;

      y+=rowHeight ;

      st_OUTPUT.setBounds ( x, size.height-(rowHeight*2), size.width-(x*2), rowHeight*2 ) ;

   }


   /**
     *  This method will enable/disable the Products label. If it is
     * enabled, all other controls will be disabled
     **/
   public void enableProductsLabel ( boolean enable ) {
      st_PRODUCT.setEnabled ( enable ) ;
   }

   /**
     *  this method will set the selected state of the
     * check box for PRODUCT
     **/
   public void setProductsSelected ( boolean state ) {
      ck_PRODUCT.setSelected ( state ) ;
   }

   /**
     *  This method will set the status that is shown
     **/
   public void setText ( String status ) {
      st_OUTPUT.setText ( status ) ;
   }
} /* ProductSaveStatusPanel */
