package com.ibm.nzna.projects.qit.product.productEdit ;
/*-----------------------------------------------------------*/
/*   ProductSaver                                            */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ProductSaver                        */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.io.* ;
import java.util.* ;
import java.sql.* ;
import javax.swing.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.app.util.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.qit.product.* ;
import com.ibm.nzna.projects.common.quest.product.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.quest.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.shared.db.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.ftp.FTP.* ;

/**
 * This object has the capability to save/publish any document in any way 
 *
 *
 * @version 1.0, 8/22/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ProductSaver                                            */
/*                                                           */
/*-----------------------------------------------------------*/
public class ProductSaver extends Object implements AppConst, ProductConst {


   /**
     *  This method will simply save a draft
     *
     * @param draft The ProductDraft to save
     *
     * @returns TRUE if saved
     **/
   public static boolean saveDraft ( ProductDraft draft, ProductSaveStatusPanel statusPanel ) {
      boolean saved = false ;                                                                  
      int sqlCode = 0 ;

      if ( statusPanel != null ) {
         statusPanel.enableProductsLabel ( true ) ;
         statusPanel.setProductsSelected ( true ) ;
         statusPanel.setText ( "Saving product Draft" ) ;
      }
      draft.setLastTouchedBy ( UserSystem.getUserId() ) ;                        
      sqlCode = draft.writeToDatabase() ;

      switch ( sqlCode ) {
         case 0 :
            saved = true ;
            draft.updateRecStatus ( ProductDraft.REC_NOCHANGE ) ;
            break ;

         default:
            LogSystem.log ( 1, "Cannot write product. SQLCode returned:"+sqlCode ) ;
            saved = false ;
            break ;
      }

      return( saved ) ;
   }


   /**
     *  This method will simply publish a draft
     *
     * @param draft The ProductDraft to publish
     *
     * @returns TRUE if saved
     **/
   public static boolean publishDraft ( ProductDraft draft, ProductSaveStatusPanel statusPanel ) {
      boolean saved   = false ;                 
      int     sqlCode = 0 ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Ok, first, adjust some closing properties               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      draft.setLastTouchedBy ( UserSystem.getUserId() ) ;

      if ( statusPanel != null )
         statusPanel.setText ( "Publishing ..." ) ;
      
      sqlCode = draft.publish() ;

      switch ( sqlCode ) {
         case 0 :
            saved = true ;
            break ;

         default:
            LogSystem.log ( 1, "Could not publish product. reopening old draft")  ;
            draft.setStopDate ( null ) ;
            draft.writeToDatabase() ;
            saved = false ;
            break;
      }

      return( saved ) ;
   }
} /* ProductSaver */

