package com.ibm.nzna.projects.qit.product.productEdit.property ;           
/*-----------------------------------------------------------*/
/*   FormOrderPage                                           */
/*                                                           */
/*   Description:                                            */
/*      Source code for: FormOrderPage                       */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import java.awt.event.* ;
import java.util.* ;
import javax.swing.* ;
import javax.swing.event.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.projects.qit.product.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.help.* ;
/**
 * This page has user adjustable settings for the Product Form Views 
 *
 *
 * @version 1.0, 1/1/1998 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   FormOrderPage                                           */
/*                                                           */
/*-----------------------------------------------------------*/
public class FormOrderPage extends JPanel implements ActionListener, ProductConst, AppConst {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   /**
     *  This is the JList model
     **/
   private DefaultListModel listModel = null ;

   /**
     *  This is the JLabel describing help
     **/
   private JLabel st_HELP  = new JLabel ( Str.getStr ( STR_FORM_ORDER_HELP ) ) ;

   /**
     *  This is the JList holding all of the fields
     **/
   private JList lb_FORMS = new JList ( ) ;

   /**
     *  This is the JScroll Pane holding the items
     **/
   private JScrollPane scr_FORMS = new JScrollPane ( lb_FORMS ) ;

   /**
     *  This is the Up buttons
     **/
   private DButton pb_UP = new DButton ( Str.getStr ( STR_UP ) ) ;

   /**
     *  This is the Down button
     **/
   private DButton pb_DOWN = new DButton ( Str.getStr ( STR_DOWN ) ) ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    Default constructor
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public FormOrderPage () {
      createGUI () ;
   }


   /*------------------------------------------------------------*/
   /* createGUI
    */
   /**
    *    This method will create and add our 
    *  GUI components
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void createGUI () {          

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create the gUI                                          */     
      /*                                                           */
      /*-----------------------------------------------------------*/
      listModel = new DefaultListModel () ;
      lb_FORMS.setModel ( listModel ) ;
      

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      WinUtil.setListData ( (Vector)PropertySystem.get ( PROPERTY_PRODUCT_EDITOR_LAYOUT ), listModel ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add listeners                                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      pb_UP.addActionListener   ( this ) ;
      pb_DOWN.addActionListener ( this ) ;  

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add the GUI                                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( null ) ;
      add ( st_HELP ) ;
      add ( scr_FORMS ) ;
      add ( pb_UP ) ;
      add ( pb_DOWN ) ;



   }





   /*------------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will lay out and position all
    *  of our components
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout ( ) {
      Dimension size      = getSize() ;
      int       rowHeight = GUISystem.getRowHeight() ;
      int       x         = 5 ;
      int       y         = 5 ;

      super.doLayout() ;
      st_HELP.setBounds ( x, y, size.width-(x*2), rowHeight*2 ) ;
      y+=rowHeight*2  ;

      scr_FORMS.setBounds ( x, y, size.width-(x*2), size.height-90 ) ;

      pb_UP.setBounds ( x, size.height-35, 70, 25 ) ;
      pb_DOWN.setBounds ( x+75, size.height-35, 70, 25 ) ;

   }




   /*------------------------------------------------------------*/
   /* saveData
    */
   /**
    *    This method will save the data on our
    *  screen. It will return TRUE if all data
    *  was saved
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean saveData () {
      boolean rc = true ;
      Vector  newForms = new Vector ( 1 ) ;
      int     size     = listModel.size() ;

      for ( int i = 0; i < size; i++ )
         newForms.addElement ( listModel.elementAt(i) ) ;

      PropertySystem.put ( PROPERTY_PRODUCT_EDITOR_LAYOUT, newForms ) ;


      return( rc ) ;
   }





   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will be called when an action
    *  event is fired on us
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {
      if ( e.getSource() == pb_UP )
         WinUtil.moveItemUp ( lb_FORMS ) ;
      if ( e.getSource() == pb_DOWN )
         WinUtil.moveItemDown ( lb_FORMS ) ;

   }


} /* FormOrderPage */
