package com.ibm.nzna.projects.qit.product.productExport ;       
/*-----------------------------------------------------------*/
/*   ProductFileStep                                         */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ProductFileStep                     */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import javax.swing.* ;
import java.awt.* ;
import java.awt.event.* ;
import java.io.* ;
import com.ibm.nzna.shared.gui.wizard.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.qit.product.* ;
import com.ibm.nzna.projects.qit.app.* ;
/**
 * This wizard step allows the user to select the file to export
 *
 *
 * @version 1.0, 9/9/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ProductFileStep                                         */
/*                                                           */
/*-----------------------------------------------------------*/
public class ProductFileStep extends WizardStep implements ActionListener, AppConst, ProductConst {

   /**
     *  This is the property object which we will save our information to
     **/
   private ProductExportProperty exportProperty = null ;

   /**
     *  The label for filename
     **/
   private JLabel st_FILENAME = new JLabel ( Str.getStr ( STR_FILENAME ) ) ;

   /**
     *  The entry field for filename
     **/
   private JTextField ef_FILENAME = new JTextField () ;

   /**
     *  The browse button
     **/
   private DButton pb_BROWSE = new DButton ( Str.getStr ( STR_BROWSE ) ) ;

   /**
     *  Default Constructor
     **/
   public ProductFileStep ( Wizard wizard, ProductExportProperty exportProperty ) {

      setWizard ( wizard ) ;
      this.exportProperty = exportProperty ;         

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   add listeners                                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      pb_BROWSE.addActionListener ( this ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add our GUI                                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( null ) ;
      add ( st_FILENAME ) ;
      add ( ef_FILENAME ) ;
      add ( pb_BROWSE ) ;                       

   }


   /**
     *  This method will lay out and size our controls
     **/
   public void doLayout () {
      Dimension size      = getSize() ;
      int       rowHeight = GUISystem.getRowHeight () ;
      int       x         = 10 ;
      int       y         = 30 ;

      st_FILENAME.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight+2 ;

      ef_FILENAME.setBounds ( x, y, 250, rowHeight ) ;
      pb_BROWSE.setBounds ( x+255, y, 80, rowHeight ) ;
   }

   /**
     *  This method will save our information and return TRUE
     **/
   public boolean saveInfo () {
      String  filename = ef_FILENAME.getText() ;
      boolean rc       = false ;

      try {
         File newFile = null ;
         
         if ( !filename.toUpperCase().endsWith ( ".CSV" ) )
            filename+=".csv" ;
         
         newFile = new File ( filename ) ;

         exportProperty.setFilename ( filename ) ;
         rc = true ;
      } catch ( Exception e ) {
         GUISystem.printBox ( WinUtil.getParentJDialog ( this ),
                              Str.getStr ( STR_INFO ),
                              "Please enter a valid directory and filename to export to" ) ;
      }

      return( rc ) ;
   }


   /**
     *  This method will refresh our information
     **/
   public void refreshInfo () {
      if ( exportProperty.getFilename() != null )
         ef_FILENAME.setText ( exportProperty.getFilename () ) ;
   }


   /**
     *  This method will return our title text
     **/
   public String getTitle () {
      return( Str.getStr ( STR_EXPORT_WIZ_TITLE_FILENAME ) ) ;
   }


   /**
     *  This method will be called if the user hits the browse button
     **/
   public void actionPerformed ( ActionEvent e ) {
      if ( e.getSource() == pb_BROWSE ) {
         File[] exportFile = GUISystem.getFileOpen ( GUISystem.getParentDefWin ( this ),
                                                     "Export To ...",
                                                     "",
                                                     false ) ;

         if ( exportFile != null ) {
            ef_FILENAME.setText ( exportFile[0].getAbsolutePath() ) ;
         }
      }
   }
} /* ProductFileStep */
