package com.ibm.nzna.projects.qit.product.productImport ;
/*-----------------------------------------------------------*/
/*   ProductImportConst                                      */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ProductImportConst                  */
/*                                                           */
/*                                                           */
/*         @Copyright  2001 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * These constants are specifically for indexing the importable attributes in a Quest 3.0 ProductDraft object.
 *
 *
 * @version 1.0, 7/27/2001
 * @author  Asha Rucker
 *
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ProductImportConst                                      */
/*                                                           */
/*-----------------------------------------------------------*/
public interface ProductImportConst {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /* Fields                                                    */
   /*                                                           */
   /*-----------------------------------------------------------*/
    /**
     * This represents the brand.
     */
    public static final int INDEX_BRAND         = 0 ;

    /**
     * This represents the family.
     */
    public static final int INDEX_FAMILY        = 1 ;

    /**
     * This represents the product number (for systems and monitors only).
     */
    public static final int INDEX_PRODUCTNUMBER = 2 ;

    /**
     * This represents the machine type (for systems and monitors only).
     */
    public static final int INDEX_MACHINE       = 3 ;

    /**
     * This represents the model (for systems and monitors only).
     */
    public static final int INDEX_MODEL         = 4 ;

    /**
     * This represents the Quest description.
     */
    public static final int INDEX_DESCRIPT      = 5 ;

    /**
     * This represents the locale.
     */
    public static final int INDEX_LOCALE        = 6 ;

    /**
     * This represents the project name.
     */
    public static final int INDEX_PROJECT	= 7;

    /**
     * This represents the comment.
     */
    public static final int INDEX_COMMENT       = 8;

    /**
     * This represents the warranty.
     */
    public static final int INDEX_WARRANTY      = 9;


    /**
     * This represents the offering.  It is optional for import.
     */
    public static final int INDEX_OFFERING	= 10;

    /**
     * This represents the customer name.  It is optional for import.
     */
    public static final int INDEX_CUSTOMERNAME	= 11;


    /**
     * This represents the part number (for options only).
     */
    public static final int INDEX_PARTNUMBER	= 11 ;

    /**
     * This represents the OBI family type (for options only).
     */
    public static final int INDEX_OBIFAMILYTYPE	= 12 ;

    /**
     * This represents the country.
     */
    public static final int INDEX_COUNTRY	= 13;


    public static final int NEW_PRODUCT         = 0;

    public static final int EXISTING_PRODUCT    = 1;

    public static final int DRAFT_EXISTS        = 2;
    


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Viewer Constants                                        */     
   /*                                                           */
   /*-----------------------------------------------------------*/

    /**
     * This attribute denotes that the batch is to perform both inserts and updates.
     */
    public static final int INSERTUPDATE        = 0 ;

    /**
     * This attribute denotes  that the batch is to only insert new products. 
     */
    public static final int INSERTONLY          = 1 ;

    /**
     * This denotes that the batch is to only update existing products.
     */
    public static final int UPDATEONLY          = 2 ;





   /*---------------------------------------------------------------*/
   /*                                                               */
   /*   Static Members that are related to a table in the database  */
   /*                                                               */
   /*---------------------------------------------------------------*/


    /**
     * This denotes that the batch will only import system products. 
     */
    public static final int SYSTEMSONLY	    	 = 1 ;   // defined in PRODUCT.TYPEPRODUCT

    /**
     * This denotes that the batch will only import option products. 
     */
    public static final int OPTIONSONLY	         = 2 ;   // defined in PRODUCT.TYPEPRODUCT

    /**
     * This denotes that the batch will only import monitor products.
     */
    public static final int MONITORSONLY         = 3 ;   // defined in PRODUCT.TYPEPRODUCT

    public static final int WITHDRAWN_DATE       = 1 ;   // defined in PRODUCT.TYPEDATE
    public static final int ANNOUNCED_DATE       = 2 ;   // defined in PRODUCT.TYPEDATE    
    public static final int PRE_ANNOUNCED_DATE   = 4 ;   // defined in PRODUCT.TYPEDATE
    public static final int GA_DATE              = 5 ;   // defined in PRODUCT.TYPEDATE
    public static final int EO_SERVICE_DATE      = 6 ;   // defined in PRODUCT.TYPEDATE
    public static final int EO_MAN_DATE          = 7 ;   // defined in PRODUCT.TYPEDATE
    public static final int EO_MARKET_DATE       = 8 ;   // defined in PRODUCT.TYPEDATE
    public static final int EO_PROD_DATE         = 9 ;   // defined in PRODUCT.TYPEDATE
    public static final int SHIP_SUPPORT_DATE    = 10 ;  // defined in PRODUCT.TYPEDATE
    public static final int FIRST_ORDER_DATE     = 11 ;  // defined in PRODUCT.TYPEDATE

    public static final int DELETED_XREF_DATE    = 3 ;   // defined in PRODUCT.TYPEDATE
       
} /* ProductImportConst */
