package com.ibm.nzna.projects.qit.promail ;     
/*-----------------------------------------------------------*/
/*   EMailSearchRec                                          */
/*                                                           */
/*   Description:                                            */
/*      Source code for: EMailSearchRec                      */
/*                                                           */
/*                                                           */
/*         @Copyright  1997 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.projects.qit.app.* ;
import java.util.* ;
/**
 * This record holds information about a EMail search
 *
 *
 * @version 1.0, 7/16/1998 
 * @author  David Lentz
 */


/*-----------------------------------------------------------*/
/*                                                           */
/*   EMailSearchRec                                          */
/*                                                           */
/*-----------------------------------------------------------*/
public class EMailSearchRec extends SearchRec {

   public static final int SEARCH_DOCUMENT            = 1 ;
   public static final int SEARCH_DOCTEMPLATE         = 2 ;        


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Static Search Types                                     */
   /*                                                           */
   /*   These search types MUST NEVER CHANGE unless you also    */
   /* change the DOCMAINT and DOCREQMAINT stored procedures.    */
   /* These values are defined in the stored procedure.         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   public static final int SEARCH_EMAIL      = 123 ;

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Directions                                              */
   /*                                                           */
   /*-----------------------------------------------------------*/
   public static final int PB_PREV    = 1 ;
   public static final int PB_NEXT    = 2 ;


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Vars                                                    */
   /*                                                           */
   /*-----------------------------------------------------------*/
   public int         brandGroupInd      = 0 ;
   public int         searchType         = 0 ;
   public int         fromCount          = 0 ;
   public int         newFromCount       = 0 ;   
   public int         actualCount        = 0 ;
   public int         typeDocInd         = 0 ;
   public int         directionInd       = 0 ;  /* gets prev or next button indicators */
   public String      descript           = "" ;

   public EMailSearchRec () {
   }


   public EMailSearchRec ( String descript, int brandGroupInd, int searchType, int intSearchArg, String strSearchArg, int fromCount, SearchListener listener ) {
      this.descript          = descript ;
      this.brandGroupInd     = brandGroupInd ;
      this.searchType        = searchType ;
      this.intSearchArg      = intSearchArg ;
      this.strSearchArg      = strSearchArg ;
      this.fromCount         = 0 ;
      this.listener          = listener ;
   }


   public String toString () {
      return( new String ( "EMailSearchRec - \n   Search Type:"+searchType+"\n   brandGroupInd:"+brandGroupInd+"\n   intSearchArg:"+intSearchArg+"\n   strSearchArg:"+strSearchArg+"\n   typeDocInd:"+typeDocInd+"\n   fromCount:"+fromCount+"\n   actualCount:"+actualCount ) ) ;
   }

} /* EMailSearchRec */
