package com.ibm.nzna.projects.qit.promail ;    
/*-----------------------------------------------------------*/
/*   ProMail                                                 */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ProMail                             */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.common.quest.* ;
import com.ibm.nzna.shared.db.* ;
import javax.swing.* ;
/**
 * This QuestApplet allows an author view information about
 * the proactive eMails in Quest.
 *
 *
 * @version 1.0, 1/26/100 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ProMail                                                 */
/*                                                           */
/*-----------------------------------------------------------*/
public class ProMail extends Object implements java.io.Serializable, QuestApplet, AppConst {



   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private ProMailPanel promailMaintPanel = null ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This constructor like all good Quest Applets
    *  does nothing
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public ProMail () {
   }





   /*------------------------------------------------------------*/
   /* getName
    */
   /**
    *    This method will return the name
    *  of this Quest Applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getName () {
      return( Str.getStr ( STR_PROMAIL ) ) ;
   }




   /*------------------------------------------------------------*/
   /* getDescription
    */
   /**
    *    This method will return a user readable
    *  description of this Quest Applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getDescription () {
      return( Str.getStr ( STR_PROMAIL_DESCRIPT ) ) ;
   }





   /*------------------------------------------------------------*/
   /* canChat
    */
   /**
    *    This method will return TRUE, since
    *  the web browser can chat with other
    *  web browsers
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean canChat () {
      return( true ) ;
   }




   /*------------------------------------------------------------*/
   /* getAuthority
    */
   /**
    *    This method will return 0, since everyone
    *  has access to the browser
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public int getAuthority () {
      return( 0 ) ;
   }




   /*------------------------------------------------------------*/
   /* stop
    */
   /**
    *    This method will be called when we need
    *  to clean up and stop our Applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void stop () {
   }




   /*------------------------------------------------------------*/
   /* start
    */
   /**
    *    This method will be called when our
    *  initialization has completed, and we
    *  can now add ourselves to a window
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void start () {


      /*------------------------------------------------------------*/
      /* Create a connection to CLIO
       */
      /**
       *    
       *  
       *  
       *
       *  @param None
       *  @param None
       *  @param None
       *
       *  @return Nothing
       *//*---------------------------------------------------------*/
      if ( DatabaseSystem.createConnection ( DatabaseSystem.CLIO,
                                             Constants.getStrConst ( "IT_CLIODBNAME" ),
                                             Constants.getStrConst ( "IT_CLIOSERVER" ),
                                             Constants.getStrConst ( "IT_CLIOPORTNUM" ),
                                             "esupport",
                                             "ESUPP0RT" ) )
         WindowSystem.createPanel ( promailMaintPanel ) ;
      //if ( DatabaseSystem.createConnection ( DatabaseSystem.CLIO,
      //                                       Constants.getStrConst ( "IT_CLIODBNAME" ),
      //                                       Constants.getStrConst ( "IT_CLIOSERVER" ),
      //                                       Constants.getStrConst ( "IT_CLIOPORTNUM" ),
      //                                       "esupport",
      //                                       "ESUPP0RT" ) ) {
      //   /*-----------------------------------------------------------*/
      //   /*                                                           */
      //   /*   Add this browser to the main window                     */
      //   /*                                                           */
      //   /*-----------------------------------------------------------*/
      //   WindowSystem.createPanel ( promailMaintPanel ) ;
      //} else
      //   GUISystem.printBox ( STR_INFO, STR_CANNOT_CONNECT_TO_CLIO ) ;

   }




   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will initialize our browser
    *  bean as well as get everything else
    *  ready
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean initialize () {

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   First, create our panel that holds the browser          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      promailMaintPanel = new ProMailPanel () ;                          
      return( true ) ;
   }




   /*------------------------------------------------------------*/
   /* getSmallIcon
    */
   /**
    *    This method will return the small icon
    *  representing this Quest Applet
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public ImageIcon getSmallIcon () {
      return( ImageSystem.getImageIcon ( this, ImageSystem.PROMAIL_SMALL ) ) ;
   }





   /*------------------------------------------------------------*/
   /* getIcon
    */
   /**
    *    This method will return our normal
    *  sized icon
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return ImageIcon
    *//*---------------------------------------------------------*/
   public ImageIcon getIcon () {
      return( ImageSystem.getImageIcon ( this, ImageSystem.PROMAIL_LARGE ) ) ;
   }





} /* ProMail */
