package com.ibm.nzna.projects.qit.promail ;       
/*-----------------------------------------------------------*/
/*   ProMailNavPanel                                         */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ProMailNavPanel                     */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import java.util.* ;
import java.awt.event.* ;
import javax.swing.* ;
import com.ibm.nzna.projects.common.quest.type.* ;
import com.ibm.nzna.projects.common.quest.brand.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.shared.gui.* ;  
/**
 * This is the NavPanel for the ProMailPanel 
 *
 *
 * @version 1.0, 8/28/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ProMailNavPanel                                         */
/*                                                           */
/*-----------------------------------------------------------*/
public class ProMailNavPanel extends JPanel implements ProMailConst, NavPanel, AppConst, ActionListener {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private GUI Members                                     */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private JTitle       st_BRAND       = null ;
   private JComboBox    cb_BRAND       = null ;
   private JTitle       st_VIEW        = null ;
   private NavList      viewList       = null ;
   private JScrollPane  viewScroll     = null ;


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private ProMailPanel proMailPanel      = null ;
   private int          view              = 0 ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This constructor simply assigns the ProMailPanel
    *  
    *  
    *
    *  @param proMailPanel The ProMailPanel to initialize to
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public ProMailNavPanel ( ProMailPanel proMailPanel ) {
      this.proMailPanel = proMailPanel ;
   }






   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will initialize all variables and
    *  GUI components
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void initialize () {   
      HotLinkGroup buttonGroup = new HotLinkGroup () ;
      HotLinkLabel label       = null ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create our GUI                                          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      st_BRAND   = new JTitle    ( Str.getStr ( STR_BRAND ) ) ;
      st_VIEW    = new JTitle    ( Str.getStr ( STR_VIEWS ) ) ;
      viewList   = new NavList   ( ) ;
      cb_BRAND   = new JComboBox ( getBrandList() ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      viewList.setBackground ( Color.white ) ;       
      st_BRAND.setFont ( FontSystem.smallTitleFont ) ;
      st_VIEW.setFont  ( FontSystem.smallTitleFont ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add our controls                                        */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( null ) ;
      add ( st_BRAND ) ;
      add ( st_VIEW ) ;
      add ( cb_BRAND ) ;
      add ( viewList ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add action listeners                                    */           
      /*                                                           */
      /*-----------------------------------------------------------*/
      viewList.addActionListener ( this ) ;
      

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add Views                                               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      viewList.add ( label = new HotLinkLabel ( Str.getStr ( STR_ALL ),            VIEW_ALL ) ) ;
      buttonGroup.add ( label ) ;
      viewList.add ( label = new HotLinkLabel ( Str.getStr ( STR_BY_EMAILDATE ),   VIEW_EMAILABLE_DATE ) ) ;
      buttonGroup.add ( label ) ;
      viewList.add ( label = new HotLinkLabel ( Str.getStr ( STR_BY_DATERANGE ),   VIEW_DATE_RANGE ) ) ;
      buttonGroup.add ( label ) ;
      viewList.add ( label = new HotLinkLabel ( Str.getStr ( STR_BY_DOCID ),       VIEW_DOCID ) ) ;
      buttonGroup.add ( label ) ;
      viewList.add ( label = new HotLinkLabel ( Str.getStr ( STR_TONIGHTS_EMAIL ), VIEW_EMAIL_TONIGHT ) ) ;
      buttonGroup.add ( label ) ;

   } /* initialize */




   /*------------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will lay out and position all of our
    *  controls
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size      = getSize() ;
      int       x         = 0 ;
      int       y         = 0 ;
      int       rowHeight = GUISystem.getRowHeight () ;

      super.doLayout() ;

      st_BRAND.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight ;

      cb_BRAND.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight+5 ;

      st_VIEW.setBounds ( x, y, size.width-(x*2), rowHeight ) ;
      y+=rowHeight ;

      viewList.setBounds ( x, y, size.width-(x*2), size.height-y-5 ) ;

   }


   /*------------------------------------------------------------*/
   /* getTitle
    */
   /**
    *    This method will return our title
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getTitle () {
      return( Str.getStr ( STR_VIEWS ) ) ;
   }

   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will be called when an action
    *  event is fired to us
    *  
    *
    *  @param event The Event
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent event ) {

      if ( event.getSource() instanceof HotLinkLabel )
         proMailPanel.setView ( ((HotLinkLabel)event.getSource()).getId() ) ;
   }




   /*------------------------------------------------------------*/
   /* stop
    */
   /**
    *    This method will be called when we have
    *  been closed and should stop processing
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void stop () {
   }




   /*------------------------------------------------------------*/
   /* getJComponent
    */
   /**
    *    This method will return the JComponent
    *  that this panel is
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public JComponent getJComponent () {
      return( this ) ;
   }




   /*------------------------------------------------------------*/
   /* start
    */
   /**
    *    This method will be called once we are
    *  initialized and are showing. We will refresh
    *  data here
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void start () {
      TypeCategoryRec brandRec = Brands.getBrand ( PropertySystem.getInt ( PropertySystem.PROPERTY_DEFAULT_BRAND ) ) ;

      if ( brandRec != null )
         cb_BRAND.setSelectedItem ( brandRec ) ;
   }





   /*------------------------------------------------------------*/
   /* getBrandList
    */
   /**
    *    This method will return all brands, with the
    *  special 'All Brands' element
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private Vector getBrandList () {
      Vector vec = Brands.getBrands() ;

      vec.insertElementAt( Str.getStr ( STR_ALL_BRANDS ), 0 ) ;

      return( vec ) ;
   }





   /*------------------------------------------------------------*/
   /* getBrand
    */
   /**
    *    This method will return the brand that is currently
    *  selected. It will return NULL if the 'All Brands'
    *  is selected
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   protected TypeCategoryRec getBrand () {
      try {
         return( (TypeCategoryRec)cb_BRAND.getSelectedItem() ) ;
      } catch ( Exception e ) {
      }
      return( null ) ;
   }




   /*------------------------------------------------------------*/
   /* getView
    */
   /**
    *    This method will return one of the predefined
    *  VIEW_XXX as defined in ProMailConst
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return int
    *//*---------------------------------------------------------*/
   public int getView () {
      return( view ) ;
   }

} /* ProMailNavPanel */
