package com.ibm.nzna.projects.qit.promail ;
/*-----------------------------------------------------------*/
/*   ProMailSystem                                           */
/*                                                           */
/*   Description:                                            */
/*      Source code for  ProMailSystem                       */
/*                                                           */
/*                                                           */
/*         @Copyright  1998 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This class holds static methods usefull with Proactive eMail 
 *
 *
 * @version 1.0, 9/3/1999 
 * @author  David Lentz
 */
import com.ibm.nzna.projects.common.quest.doc.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.shared.util.* ;

/*-----------------------------------------------------------*/
/*                                                           */
/*   ProMailSystem                                           */
/*                                                           */
/*-----------------------------------------------------------*/
public class ProMailSystem extends Object implements AppConst {


   private static String header = null ;
   private static String footer = null ;



   /*------------------------------------------------------------*/
   /* createEMailPreview
    */
   /**
    *    This method will create the entire preview
    *  string that would be sent to a customer when
    *  proactive email is run.
    *
    *  @param document The Document to generate the email from
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public static String createEMailPreview ( Document document ) {
      String retStr = "" ;

      if ( document != null ) {
         try {
            String            eMailComments = document.getEMailComments() ;

            if ( ( eMailComments != null ) && ( eMailComments.length() > 0 ) ) {
               int      i                  = 0 ;
               String[] eMailCommentsArray = null ;

               eMailComments = Text.replaceAllStrInStr ( eMailComments, "   ", " " ) ;
               eMailComments = Text.replaceAllStrInStr ( eMailComments, "  ", " " ) ;

               eMailCommentsArray = Text.formatStringLineBreaks ( eMailComments, 77 ) ;

               eMailComments="" ;
               if ( eMailCommentsArray != null ) {
                  while ( i < eMailCommentsArray.length ) {
                     eMailComments+=eMailCommentsArray[i]+"\n" ;
                     i++ ;
                  }
               }
            }


            getHeader() ;
            getFooter() ;

            if ( ( header != null ) && ( footer != null ) ) {

               retStr=header+
                      "\n\n"+
                      eMailComments+
                      "\n\nhttp://www.pc.ibm.com/support/qtechinfo/"+document.getFilename()+".html"+
                      "\n"+footer ;

            }

         } catch ( Exception e ) {
            LogSystem.log ( 1, e ) ;
         }
      }

      return( retStr ) ;
   }






   /*------------------------------------------------------------*/
   /* clearHeaderFooter
    */
   /**
    *    This method will clear the Header and Footer
    *  strings so that the next time they are used
    *  it will be read from the database
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public static void clearHeaderFooter () {
      header=null ;
      footer=null ;
   }



   /*------------------------------------------------------------*/
   /* getFooter
    */
   /**
    *    This method will return the current footer
    *  for eMail
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String 
    *//*---------------------------------------------------------*/
   public static String getFooter() {
      if ( footer == null )
         footer       = ProMailSQL.getFooter() ;
      if ( footer.length() == 0 )
         footer=null ;

      return( footer ) ;
   }

   /*------------------------------------------------------------*/
   /* getHeader
    */
   /**
    *    This method will return the current header
    *  for eMail
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String 
    *//*---------------------------------------------------------*/
   public static String getHeader() {
      if ( header == null )
         header       = ProMailSQL.getHeader() ;
      if ( header.length() == 0 )
         header=null ;

      return( header ) ;
   }


} /* ProMailSystem */
