package com.ibm.nzna.projects.qit.recyclebin ;                 
/*-----------------------------------------------------------*/
/*   RecycleBinNavPanel                                      */
/*                                                           */
/*   Description:                                            */
/*      Source code for: RecycleBinNavPanel                  */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.shared.gui.* ;
import javax.swing.* ;
import java.awt.event.* ;
import java.awt.* ;
/**
 * This nav panel is tied to the RecyleBinPanel 
 *
 *
 * @version 1.0, 4/10/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   RecycleBinNavPanel                                      */
/*                                                           */
/*-----------------------------------------------------------*/
public class RecycleBinNavPanel extends JPanel implements NavPanel, AppConst, ActionListener {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private GUI Members                                     */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private DButton   pb_PRODUCTS       = null ;
   private DButton   pb_DOCS           = null ;      
   private DButton   pb_QUESTIONS      = null ;
   private DButton   pb_ACTIONS        = null ;
   private DButton   pb_SYMPTOMS       = null ;
   private DButton   pb_LINKS          = null ;
   private DButton   pb_LINKGROUPS     = null ;

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private RecycleBinPanel panel = null ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This constructor simplies assigns local vars
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public RecycleBinNavPanel ( RecycleBinPanel panel ) {
      this.panel = panel ;
   }





   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will initialize our GUI
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void initialize () {
      NavList navList = new NavList() ;     

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create our GUI                                          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      navList.add ( pb_PRODUCTS   = new DButton ( Str.getStr ( STR_PRODUCTS ) ) ) ;
      navList.add ( pb_DOCS       = new DButton ( Str.getStr ( STR_DOCUMENT ) ) ) ;        
      //navList.add ( pb_QUESTIONS  = new DButton ( Str.getStr ( STR_QUESTIONS ) ) ) ;
      //navList.add ( pb_ACTIONS    = new DButton ( Str.getStr ( STR_ACTIONS ) ) ) ;
      //navList.add ( pb_LINKS      = new DButton ( Str.getStr ( STR_LINK ) ) ) ;
      //navList.add ( pb_LINKGROUPS = new DButton ( Str.getStr ( STR_LINK_GROUP ) ) ) ;
      //navList.add ( pb_SYMPTOMS   = new DButton ( Str.getStr ( STR_SYMPTOMS ) ) ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      navList.setOpaque ( false ) ;      

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add listeners                                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      navList.addActionListener ( this ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add our GUI                                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( new BorderLayout () ) ;
      add ( navList, BorderLayout.CENTER ) ;

   }





   /*------------------------------------------------------------*/
   /* getTitle
    */
   /**
    *    This method will return our title
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getTitle () {
      return( Str.getStr ( STR_FIELDS ) ) ;
   }




   /*------------------------------------------------------------*/
   /* getJComponent
    */
   /**
    *    This method will return an instance of this
    *  class
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return JComponent
    *//*---------------------------------------------------------*/
   public JComponent getJComponent() {
      return( this ) ;
   }





   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will be called when our buttons
    *  are hit
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {
      if ( e.getSource() instanceof DButton ) {
         panel.setRecycleList ( ((DButton)e.getSource()).getText() ) ;
      }
   }




   /*------------------------------------------------------------*/
   /* start
    */
   /**
    *    This method does nothing
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void start() {
   }




   /*------------------------------------------------------------*/
   /* stop
    */
   /**
    *    This method releases our resources
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void stop () {
      removeAll() ;
   }
} /* RecycleBinNavPanel */
