package com.ibm.nzna.projects.qit.recyclebin ;       
/*-----------------------------------------------------------*/
/*   RecycleBinPanel                                         */
/*                                                           */
/*   Description:                                            */
/*      Source code for: RecycleBinPanel                     */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.projects.qit.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.gui.* ;  
import com.ibm.nzna.projects.qit.print.* ;  
import com.ibm.nzna.projects.qit.doc.gui.* ;  
import com.ibm.nzna.projects.qit.product.gui.* ;  
import com.ibm.nzna.shared.gui.* ;
import java.awt.event.* ;
import javax.swing.* ;
import java.awt.* ;
import java.util.* ;
/**
 * This panel allows the user to surf the recycled objects  in Quest 
 *
 *
 * @version 1.0, 4/10/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   RecycleBinPanel                                         */
/*                                                           */
/*-----------------------------------------------------------*/
public class RecycleBinPanel extends JPanel implements PreviewPanel, PrintPanel, AppConst, QuestPanel, ActionListener {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Static Members                                          */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private static final String[] listTitle = {"","","","",""} ;


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private GUI Members                                     */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private RecycleBinNavPanel navPanel    = null ;
   private ActionButton       pb_DELETE   = null ;
   private ActionButton       pb_CLOSE    = null ;
   private ActionButton       pb_RESTORE  = null ;
   private JTitle             st_TITLE    = null ;
   private MultiList          cnr_DATA    = null ;
   private DocumentTable      documents   = null ;
   private ProductTable       products    = null ;



   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private boolean inThread      = false ;
   private String  recycleList   = "" ;





   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will be called when we need
    *  to initialize ourselves
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean initialize () {     

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create our GUI                                          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      navPanel = new RecycleBinNavPanel ( this ) ;
      pb_RESTORE = new ActionButton ( Str.getStr ( STR_RESTORE ), ImageSystem.getImageIcon ( this, ImageSystem.SAVE ),   Str.getStr ( STR_RESTORE_RECYCLED_ITEM ) ) ;
      pb_DELETE  = new ActionButton ( Str.getStr ( STR_DELETE ),  ImageSystem.getImageIcon ( this, ImageSystem.DELETE ), Str.getStr ( STR_DELETE_RECYCLED_ITEM ) ) ;
      pb_CLOSE   = new ActionButton ( Str.getStr ( STR_CLOSE ),   ImageSystem.getImageIcon ( this, ImageSystem.CLOSE ),  Str.getStr ( STR_CLOSE_THIS_PANEL ) ) ;
      st_TITLE   = new JTitle ( "" ) ;
      cnr_DATA   = new MultiList ( GUISystem.getFontUtil() ) ;        
      documents  = new DocumentTable () ;
      products   = new ProductTable() ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      st_TITLE.setOpaque ( false ) ;
      setBackground ( Color.white ) ;
      //cnr_DATA.showColumnHeadings ( false ) ;             

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add Action Listeners                                    */
      /*                                                           */
      /*-----------------------------------------------------------*/
      pb_CLOSE.addActionListener   ( this ) ;
      pb_RESTORE.addActionListener ( this ) ;
      pb_DELETE.addActionListener  ( this ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add the GUI                                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( new BorderLayout() ) ;
      add ( st_TITLE, BorderLayout.NORTH ) ;

      return( true ) ;
   }


   /*------------------------------------------------------------*/
   /* copyText
    */
   /**
    *    this method will do nothing right now
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean copyText () {
      return( false ) ;
   }

   /*------------------------------------------------------------*/
   /* pasteText
    */
   /**
    *    this method will do nothing right now
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean pasteText () {
      return( false ) ;
   }

   /*------------------------------------------------------------*/
   /* cutText
    */
   /**
    *    this method will do nothing right now
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean cutText () {
      return( false ) ;
   }




   /*------------------------------------------------------------*/
   /* panelSelected
    */
   /**
    *    This method will be called when we have
    *  been selected to show
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void panelSelected () {
   }




   /*------------------------------------------------------------*/
   /* panelDeselected
    */
   /**
    *    This method will be called when another
    *  panel has received focus over us
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void panelDeselected () {
   }




   /*------------------------------------------------------------*/
   /* getJComponent
    */
   /**
    *    This method will return an instance of this
    *  class
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public JComponent getJComponent () {
      return( this ) ;
   }




   /*------------------------------------------------------------*/
   /* getName
    */
   /**
    *    This method will return our name
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getName () {
      return( Str.getStr ( STR_RECYCLE_BIN ) ) ;
   }




   /*------------------------------------------------------------*/
   /* getIcon
    */
   /**
    *    This method will return our icon
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public ImageIcon getIcon () {
      return( ImageSystem.getImageIcon ( this, ImageSystem.SMALL_RECYCLE_BIN ) ) ;
   }




   /*------------------------------------------------------------*/
   /* start
    */
   /**
    *    This method will be called once we are
    *  showing 
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void start () {
      AppDefaultWin parentWin = GUISystem.getParentDefWin ( this ) ;             

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add our action buttons                                  */
      /*                                                           */
      /*-----------------------------------------------------------*/
      parentWin.addActionComponent ( this, pb_CLOSE ) ;
      parentWin.addActionComponent ( this, pb_DELETE ) ;
      parentWin.addActionComponent ( this, pb_RESTORE ) ;
   }




   /*------------------------------------------------------------*/
   /* stop
    */
   /**
    *    This method will be called when the user
    *  wants to close us.
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return TRUE
    *//*---------------------------------------------------------*/
   public boolean stop () {
      if ( Qit.getEnabled() ) {
         removeAll() ;
         return( true ) ;
      }
      return( false ) ;
   }




   /*------------------------------------------------------------*/
   /* shutdown
    */
   /**
    *    This method will be called when the user
    *  wants to shut down
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean shutdown () {
      return( Qit.getEnabled() ) ;
   }





   /*------------------------------------------------------------*/
   /* getDefaultNavPanel
    */
   /**
    *    This method will be called when we need to
    *  return our default nav panel
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public NavPanel getDefaultNavPanel () {
      return( (NavPanel) navPanel ) ;
   }




   /*------------------------------------------------------------*/
   /* refresh
    */
   /**
    *    This method will be called when we need
    *  to refresh our data on the panel
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void refresh () {
      Vector vec = null ;

      GUISystem.getParentDefWin ( this ).setStatus ( STR_PLEASE_WAIT ) ;

      System.out.println ( "Refreshing") ;
      remove ( documents ) ;
      remove ( products ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Products                                                */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( recycleList.equals ( Str.getStr ( STR_PRODUCTS ) ) ) {
         add ( products, BorderLayout.CENTER ) ;
         cnr_DATA = products ;

         products.setProducts ( RecycleSQL.readRecycledProducts () ) ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Documents                                               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( recycleList.equals ( Str.getStr ( STR_DOCUMENT ) ) ) {
         add ( documents, BorderLayout.CENTER ) ;
         cnr_DATA = documents ;

         documents.setDocuments ( RecycleSQL.readRecycledDocuments() ) ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Quetions                                                */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( recycleList.equals ( Str.getStr ( STR_QUESTIONS ) ) ) {
         cnr_DATA.setColumnWidth ( 0, 15 ) ;
         cnr_DATA.setColumnWidth ( 1, 15 ) ;
         cnr_DATA.setColumnWidth ( 2, 100 ) ;
         cnr_DATA.setColumnWidth ( 3, 300 ) ;
         cnr_DATA.setColumnWidth ( 4, 300 ) ;
         vec = RecycleSQL.readRecycledQuestions() ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Actions                                                 */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( recycleList.equals ( Str.getStr ( STR_ACTIONS ) ) ) {
         cnr_DATA.setColumnWidth ( 0, 15 ) ;
         cnr_DATA.setColumnWidth ( 1, 15 ) ;
         cnr_DATA.setColumnWidth ( 2, 100 ) ;
         cnr_DATA.setColumnWidth ( 3, 300 ) ;
         cnr_DATA.setColumnWidth ( 4, 300 ) ;
         vec = RecycleSQL.readRecycledActions() ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Symptoms                                                */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( recycleList.equals ( Str.getStr ( STR_SYMPTOMS ) ) ) {
         cnr_DATA.setColumnWidth ( 0, 15 ) ;
         cnr_DATA.setColumnWidth ( 1, 15 ) ;
         cnr_DATA.setColumnWidth ( 2, 100 ) ;
         cnr_DATA.setColumnWidth ( 3, 300 ) ;
         cnr_DATA.setColumnWidth ( 4, 300 ) ;
         vec = RecycleSQL.readRecycledSymptoms() ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Links                                                   */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( recycleList.equals ( Str.getStr ( STR_LINKS ) ) ) {
         cnr_DATA.setColumnWidth ( 0, 15 ) ;
         cnr_DATA.setColumnWidth ( 1, 15 ) ;
         cnr_DATA.setColumnWidth ( 2, 100 ) ;
         cnr_DATA.setColumnWidth ( 3, 300 ) ;
         cnr_DATA.setColumnWidth ( 4, 300 ) ;
         vec = RecycleSQL.readRecycledLinks() ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Symptoms                                                */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( recycleList.equals ( Str.getStr ( STR_SYMPTOMS ) ) ) {
         cnr_DATA.setColumnWidth ( 0, 15 ) ;
         cnr_DATA.setColumnWidth ( 1, 15 ) ;
         cnr_DATA.setColumnWidth ( 2, 100 ) ;
         cnr_DATA.setColumnWidth ( 3, 300 ) ;
         cnr_DATA.setColumnWidth ( 4, 300 ) ;
         vec = RecycleSQL.readRecycledSymptoms() ;
      }


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   LinkGroups                                              */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( recycleList.equals ( Str.getStr ( STR_LINK_GROUPS ) ) ) {
         cnr_DATA.setColumnWidth ( 0, 15 ) ;
         cnr_DATA.setColumnWidth ( 1, 15 ) ;
         cnr_DATA.setColumnWidth ( 2, 100 ) ;
         cnr_DATA.setColumnWidth ( 3, 300 ) ;
         cnr_DATA.setColumnWidth ( 4, 300 ) ;
         vec = RecycleSQL.readRecycledLinkGroups() ;
      }

      invalidate() ;
      GUISystem.getParentDefWin ( this ).setStatus ( null ) ;
   }




   /*------------------------------------------------------------*/
   /* setRecycleList
    */
   /**
    *    This method will set what type of recycled
    *  list we are showing
    *  
    *
    *  @param recycleList
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   protected void setRecycleList ( String recycleList ) {

      if ( Qit.getEnabled () ) {
         st_TITLE.setText ( recycleList ) ;
         this.recycleList = recycleList ;
         refresh() ;
      }
   }




   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will be called when a button
    *  is pressed
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {

      if ( Qit.getEnabled() ) {

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_CLOSE                                                */
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( e.getSource() == pb_CLOSE )
            GUISystem.getParentDefWin ( this ).closePanel ( this, null ) ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   pb_RESTORE                                              */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( e.getSource() == pb_RESTORE )
            restore() ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   pb_DELETE                                               */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( e.getSource() == pb_DELETE )
            delete() ;

      }
   }




   /*------------------------------------------------------------*/
   /* restore
    */
   /**
    *    This method will restore all selected items
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void restore () {
      Vector vec = cnr_DATA.getSelection() ;

      if ( ( vec != null ) && ( vec.size() > 0 ) ) {
         GUISystem.getParentDefWin ( this ).setStatus ( STR_PLEASE_WAIT ) ;
         Qit.setEnabled ( false ) ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Products                                                */
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( recycleList.equals ( Str.getStr ( STR_PRODUCTS ) ) )
            RecycleSQL.restoreProducts ( vec ) ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Documents                                               */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( recycleList.equals ( Str.getStr ( STR_DOCUMENT ) ) )
            RecycleSQL.restoreDocuments ( vec ) ;

         ///*-----------------------------------------------------------*/
         ///*                                                           */
         ///*   Questions                                               */
         ///*                                                           */
         ///*-----------------------------------------------------------*/
         //else if ( recycleList.equals ( Str.getStr ( STR_QUESTIONS ) ) )
         //   RecycleSQL.restoreQuestions ( vec ) ;

         ///*-----------------------------------------------------------*/
         ///*                                                           */
         ///*   Actions                                                 */
         ///*                                                           */
         ///*-----------------------------------------------------------*/
         //else if ( recycleList.equals ( Str.getStr ( STR_ACTIONS ) ) )
         //   RecycleSQL.restoreActions ( vec ) ;

         ///*-----------------------------------------------------------*/
         ///*                                                           */
         ///*   Symptoms                                                */
         ///*                                                           */
         ///*-----------------------------------------------------------*/
         //else if ( recycleList.equals ( Str.getStr ( STR_SYMPTOMS ) ) )
         //   RecycleSQL.restoreSymptoms ( vec ) ;

         ///*-----------------------------------------------------------*/
         ///*                                                           */
         ///*   LinkGroups                                              */
         ///*                                                           */
         ///*-----------------------------------------------------------*/
         //else if ( recycleList.equals ( Str.getStr ( STR_LINK_GROUPS ) ) )
         //   RecycleSQL.restoreLinkGroups ( vec ) ;


         ///*-----------------------------------------------------------*/
         ///*                                                           */
         ///*   Links                                                   */
         ///*                                                           */
         ///*-----------------------------------------------------------*/
         //else if ( recycleList.equals ( Str.getStr ( STR_LINKS ) ) )
         //   RecycleSQL.restoreLinks ( vec ) ;

         GUISystem.getParentDefWin ( this ).setStatus ( null ) ;
         Qit.setEnabled ( true ) ;
         refresh() ;
      } else
         GUISystem.printBox ( STR_INFO, STR_MUST_SELECT_ITEM ) ;
   }


   /*------------------------------------------------------------*/
   /* delete
    */
   /**
    *    This method will delete all selected items
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void delete () {
      Vector vec = cnr_DATA.getSelection() ;

      if ( ( vec != null ) && ( vec.size() > 0 ) ) {
         GUISystem.getParentDefWin ( this ).setStatus ( STR_PLEASE_WAIT ) ;
         Qit.setEnabled ( false ) ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Products                                                */
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( recycleList.equals ( Str.getStr ( STR_PRODUCTS ) ) )
            RecycleSQL.deleteProducts ( vec ) ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Documents                                               */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( recycleList.equals ( Str.getStr ( STR_DOCUMENT ) ) )
            RecycleSQL.deleteDocuments ( vec ) ;

         ///*-----------------------------------------------------------*/
         ///*                                                           */
         ///*   Questions                                               */
         ///*                                                           */
         ///*-----------------------------------------------------------*/
         //else if ( recycleList.equals ( Str.getStr ( STR_QUESTIONS ) ) )
         //   RecycleSQL.deleteQuestions ( vec ) ;

         ///*-----------------------------------------------------------*/
         ///*                                                           */
         ///*   Actions                                                 */
         ///*                                                           */
         ///*-----------------------------------------------------------*/
         //else if ( recycleList.equals ( Str.getStr ( STR_ACTIONS ) ) )
         //   RecycleSQL.deleteActions ( vec ) ;


         ///*-----------------------------------------------------------*/
         ///*                                                           */
         ///*   Links                                                   */
         ///*                                                           */
         ///*-----------------------------------------------------------*/
         //else if ( recycleList.equals ( Str.getStr ( STR_LINKS ) ) )
         //   RecycleSQL.deleteLinks ( vec ) ;


         ///*-----------------------------------------------------------*/
         ///*                                                           */
         ///*   LinkGroups                                              */
         ///*                                                           */
         ///*-----------------------------------------------------------*/
         //else if ( recycleList.equals ( Str.getStr ( STR_LINK_GROUPS ) ) )
         //   RecycleSQL.deleteLinkGroups ( vec ) ;


         ///*-----------------------------------------------------------*/
         ///*                                                           */
         ///*   Symptoms                                                */
         ///*                                                           */
         ///*-----------------------------------------------------------*/
         //else if ( recycleList.equals ( Str.getStr ( STR_SYMPTOMS ) ) )
         //   RecycleSQL.deleteSymptoms ( vec ) ;


         GUISystem.getParentDefWin ( this ).setStatus ( null ) ;
         Qit.setEnabled ( true ) ;
         refresh() ;
      } else
         GUISystem.printBox ( STR_INFO, STR_MUST_SELECT_ITEM ) ;
   }



   /*------------------------------------------------------------*/
   /* bookmark
    */
   /**
    *    This method will be called if the user
    *  has hit the 'Bookmark' button. 
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return FALSE if Bookmarking is supported, TRUE if bookmarked
    *//*---------------------------------------------------------*/
   public boolean bookmark  () {
      return( false ) ;
   }

/**
     *  This method will will give the printing support to this panel.
     **/
   public Object getPrintObject() {
       return ( new Print ( this, GUISystem.getParentDefWin ( this ), "Quest Recycle Bin" ) ) ;
   }
   /**
     *  This method will will give the preview support to this panel.
     **/
   public Object getPreviewObject() {
       return ( new Preview ( this, GUISystem.getParentDefWin ( this ), "Quest Recycle Bin" ) ) ;
   }} /* RecycleBinPanel */
