package com.ibm.nzna.projects.qit.sample ; 
/*-----------------------------------------------------------*/
/*   SampleRec                                               */
/*                                                           */
/*   Description:                                            */
/*      Source code for: SampleRec                           */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.shared.gui.* ;     // All of the classes for the MultiList
/**
 * This is a sample data object that the SamplePanel uses to read in data and to display data 
 *
 *
 * @version 1.0, 2/12/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   SampleRec                                               */
/*                                                           */
/*-----------------------------------------------------------*/
public class SampleRec extends Object implements
MultiListRow, // Implement MultiListRow so we can show in a MultiList!
MultiListSort {      // If you implement MultiListRow, you can implement MultiListSort
//                 so that when the user chooses a column to sort, you get sorted 



   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private int       docInd         = 0 ;
   private String    title          = null ;




   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This default constructor initializes our
    *  values
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public SampleRec ( int docInd, String title ) {
      setDocInd ( docInd ) ;
      setTitle  ( title ) ;
   }







   /*------------------------------------------------------------*/
   /* getColumnData
    */
   /**
    *    This method will return the data to show in
    *  a certain column.
    *  
    *
    *  @param column The column to return data for. 
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public Object getColumnData ( int column ) {
      Object retObject = null ;

      switch ( column ) {
         
         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   Column 0 is the left most column                        */                       
         /*                                                           */
         /*-----------------------------------------------------------*/
         case 0 :
            retObject = ""+docInd ;
            break ;

         case 1 :
            retObject = title ;
            break ;
      }

      return( retObject ) ;
   }


   
   
   
      /*------------------------------------------------------------*/
      /* compareTo
       */
      /**
       *    This method will be called when the MultiList
       *  needs to resort the data in it. We will be asked
       *  to compare ourselves to another MultiListSort
       *  object. Normally this other MultiListSort object is another
       *  object of the same type. In this case 'SampleRec'.
       *
       *  @param compareRec The Object to compare with
       *  @param column The column to compare data with
       *  @param None
       *
       *  @return 1 if greater, 0 if equal, -1 if less
       *//*---------------------------------------------------------*/
   public int compareTo ( MultiListSort compareRec, int column ) {
      int rc = 0 ;

      if ( compareRec instanceof SampleRec ) {

         switch ( column ) {
            case 0 : // our DocInd
               if ( ((SampleRec)compareRec).getDocInd() > getDocInd() )
                  rc = -1 ;
               else if ( ((SampleRec)compareRec).getDocInd() < getDocInd() )
                  rc = 1 ;
               break ;

            case 1 : // our title
               rc = ((SampleRec)compareRec).getTitle().compareTo ( getTitle() ) ;
               break ;
         }
      }

      return ( rc ) ;
   }



   /*------------------------------------------------------------*/
   /* setTitle
    */
   /**
    *    This method will set our title to display
    *  
    *  
    *
    *  @param title The title to show
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setTitle ( String title ) {
      this.title = title ;
   }




   /*------------------------------------------------------------*/
   /* setDocInd
    */
   /**
    *    This method will set our document indicator
    *  to display
    *  
    *
    *  @param docInd The DocInd to show
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setDocInd ( int docInd ) {
      this.docInd = docInd ;
   }





   /*------------------------------------------------------------*/
   /* getTitle
    */
   /**
    *    This method will return our title to show
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return String
    *//*---------------------------------------------------------*/
   public String getTitle () {
      return( title ) ;
   }





   /*------------------------------------------------------------*/
   /* getDocInd
    */
   /**
    *    This method will return our document indicator
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public int getDocInd () {
      return( docInd ) ;
   }


} /* SampleRec */
