package com.ibm.nzna.projects.qit.skins.Classic ;        
/*-----------------------------------------------------------*/
/*   SkinInitializeWindow                                    */
/*                                                           */
/*   Description:                                            */
/*      Source code for: SkinInitializeWindow                */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;  
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.qit.app.* ;
/**
 * This is the small window that appears and shows the user intialize information 
 *
 *
 * @version 1.0, 4/17/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   SkinInitializeWindow                                    */
/*                                                           */
/*-----------------------------------------------------------*/
public class SkinInitializeWindow extends Window implements InitializeWindow, Runnable {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Controls                                                */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private Label label = new Label ( "", Label.CENTER ) ;
   private Image splash  = null ;
   private Image splash1 = null ;
   private Image splash2 = null ;




   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will create our window
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public SkinInitializeWindow () {
      super ( new Frame() ) ;        

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      label.setBackground ( Color.black ) ;
      label.setForeground ( Color.white ) ;                     

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Read in the SPLASH image                                */
      /*                                                           */
      /*-----------------------------------------------------------*/
      splash  = ImageSystem.getImage ( this, "splash.gif" ) ;
      splash1 = ImageSystem.getImage ( this, "splash1.gif" ) ;
      splash2 = ImageSystem.getImage ( this, "splash2.gif" ) ;



      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add our control                                         */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( null ) ;
      add ( label ) ;

      setSize ( splash.getWidth ( this ), splash.getHeight ( this ) ) ;
      WinUtil.centerWindow ( this ) ;
      setVisible ( true ) ;                  

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Kick off our animate thread                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      new Thread ( this ).start() ;

   }




   /*------------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will lay out and position our
    *  controls
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size = getSize() ;

      label.setBounds ( 30, size.height-50, size.width-60, GUISystem.getRowHeight() ) ;
   }






   /*------------------------------------------------------------*/
   /* setText
    */
   /**
    *    This method will set the text that is being
    *  displayed
    *  
    *
    *  @param text The text that is being displayed
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setText ( String text ) {
      label.setText ( text ) ;
   }





   /*------------------------------------------------------------*/
   /* setText
    */
   /**
    *    This method will set the text that is being displayed
    *  
    *  
    *
    *  @param strInd The String indicator defined in AppConst
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setText ( int strInd ) {
      label.setText ( Str.getStr ( strInd ) ) ;
   }





   /*------------------------------------------------------------*/
   /* paint
    */
   /**
    *    This method will paint our component
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void paint ( Graphics g ) {
      g.drawImage ( splash, 0, 0, this ) ;
   }





   /*------------------------------------------------------------*/
   /* run
    */
   /**
    *    Runs through our initialize thread
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void run () {
      Graphics g = null ;

      try {
         while ( true ) {
            Thread.currentThread().sleep ( 1000 ) ;
            g = getGraphics() ;
            g.drawImage ( splash1, 0, 0, this ) ;
            Thread.currentThread().sleep ( 100 ) ;
            g.drawImage ( splash, 0, 0, this ) ;
            Thread.currentThread().sleep ( 50 ) ;
            g.drawImage ( splash1, 0, 0, this ) ;
            Thread.currentThread().sleep ( 100 ) ;
            g.drawImage ( splash2, 0, 0, this ) ;
            Thread.currentThread().sleep ( 50 ) ;
            g.drawImage ( splash, 0, 0, this ) ;
            Thread.currentThread().sleep ( 50 ) ;
            g.drawImage ( splash2, 0, 0, this ) ;
            Thread.currentThread().sleep ( 70 ) ;
            g.drawImage ( splash1, 0, 0, this ) ;
            Thread.currentThread().sleep ( 70 ) ;
            g.drawImage ( splash, 0, 0, this ) ;

            Thread.currentThread().sleep ( 9000 ) ;
            
         }
      } catch ( Exception e ) {
      }
   }
} /* SkinInitializeWindow */
