package com.ibm.nzna.projects.qit.skins.Marble ;        
/*-----------------------------------------------------------*/
/*   SkinInitializeWindow                                    */
/*                                                           */
/*   Description:                                            */
/*      Source code for: SkinInitializeWindow                */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;  
import javax.swing.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.qit.app.* ;
/**
 * This is the small window that appears and shows the user intialize information 
 *
 *
 * @version 1.0, 4/17/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   SkinInitializeWindow                                    */
/*                                                           */
/*-----------------------------------------------------------*/
public class SkinInitializeWindow extends Window implements InitializeWindow {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Controls                                                */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private Label label = new Label ( "", Label.CENTER ) ;
   private Image splash  = null ;




   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will create our window
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public SkinInitializeWindow () {
      super ( new Frame() ) ;        

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      label.setForeground ( Color.black ) ;                     
      //label.setOpaque ( false )  ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Read in the SPLASH image                                */
      /*                                                           */
      /*-----------------------------------------------------------*/
      splash  = ImageSystem.getImage ( this, "splash.gif" ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add our control                                         */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( null ) ;
      add ( label ) ;

      setSize ( splash.getWidth ( this ), splash.getHeight ( this ) ) ;
      WinUtil.centerWindow ( this ) ;
      setVisible ( true ) ;                  

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Kick off our animate thread                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      //new Thread ( this ).start() ;

   }




   /*------------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will lay out and position our
    *  controls
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size = getSize() ;

      super.doLayout() ;
      label.setBounds ( 65, size.height-57, size.width-125, GUISystem.getRowHeight() ) ;
   }






   /*------------------------------------------------------------*/
   /* setText
    */
   /**
    *    This method will set the text that is being
    *  displayed
    *  
    *
    *  @param text The text that is being displayed
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setText ( String text ) {
      label.setText ( text ) ;
   }





   /*------------------------------------------------------------*/
   /* setText
    */
   /**
    *    This method will set the text that is being displayed
    *  
    *  
    *
    *  @param strInd The String indicator defined in AppConst
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setText ( int strInd ) {
      label.setText ( Str.getStr ( strInd ) ) ;
   }





   /*------------------------------------------------------------*/
   /* paint
    */
   /**
    *    This method will paint our component
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void paint ( Graphics g ) {
      g.drawImage ( splash, 0, 0, this ) ;
   }
} /* SkinInitializeWindow */
