package com.ibm.nzna.projects.qit.web ;    
/*-----------------------------------------------------------*/
/*   WebBrowser                                              */
/*                                                           */
/*   Description:                                            */
/*      Source code for: WebBrowser                          */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.shared.util.* ;
import javax.swing.* ;
/**
 * This QuestApplet is a simple Web Browser 
 *
 *
 * @version 1.0, 1/26/100 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   WebBrowser                                              */
/*                                                           */
/*-----------------------------------------------------------*/
public class WebBrowser extends Object implements java.io.Serializable, QuestApplet, AppConst {



    /*-----------------------------------------------------------*/
    /*                                                           */
    /*   Private members                                         */
    /*                                                           */
    /*-----------------------------------------------------------*/
    private WebBrowserPanel webBrowserPanel = null ;





    /*------------------------------------------------------------*/
    /* Constructor
     */
    /**
     *    This constructor like all good Quest Applets
     *  does nothing
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public WebBrowser () {
    }





    /*------------------------------------------------------------*/
    /* getName
     */
    /**
     *    This method will return the name
     *  of this Quest Applet
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public String getName () {
        return( Str.getStr ( STR_WEBBROWSER ) ) ;
    }




    /*------------------------------------------------------------*/
    /* getDescription
     */
    /**
     *    This method will return a user readable
     *  description of this Quest Applet
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public String getDescription () {
        return( Str.getStr ( STR_WEBBROWSER_DESCRIPTION ) ) ;
    }





    /*------------------------------------------------------------*/
    /* canChat
     */
    /**
     *    This method will return TRUE, since
     *  the web browser can chat with other
     *  web browsers
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public boolean canChat () {
        return( true ) ;
    }




    /*------------------------------------------------------------*/
    /* getAuthority
     */
    /**
     *    This method will return 0, since everyone
     *  has access to the browser
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public int getAuthority () {
        return( 0 ) ;
    }




    /*------------------------------------------------------------*/
    /* stop
     */
    /**
     *    This method will be called when we need
     *  to clean up and stop our Applet
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void stop () {
    }




    /*------------------------------------------------------------*/
    /* start
     */
    /**
     *    This method will be called when our
     *  initialization has completed, and we
     *  can now add ourselves to a window
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void start () {


        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   Add this browser to the main window                     */
        /*                                                           */
        /*-----------------------------------------------------------*/
        WindowSystem.createPanel ( webBrowserPanel ) ;
    }




    /*------------------------------------------------------------*/
    /* initialize
     */
    /**
     *    This method will initialize our browser
     *  bean as well as get everything else
     *  ready
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public boolean initialize () {                                         

        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   First, create our panel that holds the browser          */
        /*                                                           */
        /*-----------------------------------------------------------*/
        LogSystem.log ( 3, "Web Browser Initialize Started" ) ;
        webBrowserPanel = new WebBrowserPanel () ;                          

        LogSystem.log ( 3, "Web Browser Initialized" ) ;
        return( true ) ;
    }




    /*------------------------------------------------------------*/
    /* getSmallIcon
     */
    /**
     *    This method will return the small icon
     *  representing this Quest Applet
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public ImageIcon getSmallIcon () {
        return( ImageSystem.getImageIcon ( this, ImageSystem.SMALL_WEBBROWSER ) ) ;
    }





    /*------------------------------------------------------------*/
    /* getIcon
     */
    /**
     *    This method will return our normal
     *  sized icon
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return ImageIcon
     *//*---------------------------------------------------------*/
    public ImageIcon getIcon () {
        return( ImageSystem.getImageIcon ( this, ImageSystem.WEBBROWSER ) ) ;
    }





} /* WebBrowser */
