package com.ibm.nzna.projects.qit.wordproc ;
/*-----------------------------------------------------------*/
/*   WordProcFrame                                           */
/*                                                           */
/*   Description:                                            */
/*      Source code for: WordProcFrame                       */
/*                                                           */
/*                                                           */
/*         @Copyright  1998 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This frame is a basic frame that will hold the Word Processor 
 *
 *
 * @version 1.0, 6/7/1999 
 * @author  David Lentz
 */
import java.awt.* ;
import java.awt.event.* ;
import java.util.* ;
import java.io.* ;
import javax.swing.* ;
//import javax.swing.text.* ;
//import javax.swing.text.html.* ;
import javax.swing.event.* ;
import lotus.wp.* ;
import lotus.wp.ifx.* ;
import lotus.fc.* ;
import com.ibm.nzna.projects.qit.app.* ;
import com.ibm.nzna.projects.qit.app.util.* ;
import com.ibm.nzna.projects.qit.doc.* ;
import com.ibm.nzna.projects.qit.doc.gui.* ;
import com.ibm.nzna.projects.qit.gui.* ;
import com.ibm.nzna.projects.common.quest.doc.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.shared.spell.* ;
import com.ibm.nzna.shared.gui.* ;

/*-----------------------------------------------------------*/
/*                                                           */
/*   WordProcFrame                                           */
/*                                                           */
/*-----------------------------------------------------------*/
public final class WordProcFrame extends Frame implements DataLengths, StampedGraphicDlgListener, WPHTMLGeneratorListener, SelectDocListener, AppConst, KeyListener, ActionListener, Runnable, WindowListener {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Static Vars                                             */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private static final Insets taskBarButtonMargin    = new Insets ( 0, 0, 0, 0 ) ; 

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Thread Names                                            */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private static final String THREAD_INITIALIZE         = "Init" ;
   private static final String THREAD_SPELLCHECK         = "SPELLCHECK" ;
   private static final String THREAD_SAVECONTENTANDEXIT = "SAVECONTENTANDEXIT" ;
   private static final String THREAD_SAVECONTENT        = "SAVECONTENT" ;
   private static final String THREAD_AUTOSAVE           = "AUTOSAVE" ;
   private static final String THREAD_SETCONTENT         = "SETCONTENT" ;
   private static final String THREAD_WAITANDSETCONTENT  = "WAITANDSETCONTENT" ;

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Controls                                                */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private WordProcessorBean wordProc      = null ;
   private Panel             toolBar       = null ;
   private Panel             actionBar     = null ;
   private Panel             toolBarPanel  = null ;
   private Panel             cardPanel     = null ;
   private Panel             fontBar       = null ;
   private Browser           pnl_PREVIEW   = null ;
   private TextArea          mle_EDITTAGS   = null ;
   private FlowLayout        toolBarLayout  = null ;


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Tool Bar controls                                       */
   /*                                                           */
   /*-----------------------------------------------------------*/
   protected DButton            pb_CLOSE          = null ;
   protected DButton            pb_TABLE          = null ;
   protected DButton            pb_TABLEPROP      = null ;
   protected DButton            pb_CENTERALIGN    = null ;
   protected DButton            pb_LEFTALIGN      = null ;
   protected DButton            pb_RIGHTALIGN     = null ;
   protected DButton            pb_SAVE           = null ;
   protected DButton            pb_LINK           = null ;
   protected DButton            pb_IMPORTGRAPHIC  = null ;
   protected DButton            pb_BOLD           = null ;
   protected DButton            pb_ITALIC         = null ;
   protected DButton            pb_UNDERLINE      = null ;
   protected DButton            pb_STRIKETHROUGH  = null ;
   protected DButton            pb_CLEAR          = null ;
   protected DButton            pb_HORIZLINE      = null ;
   protected DButton            pb_CUT            = null ;
   protected DButton            pb_COPY           = null ;
   protected DButton            pb_PASTE          = null ;
   protected DButton            pb_UNDO           = null ;
   protected DButton            pb_BULLETLIST     = null ;
   protected DButton            pb_NUMERICLIST    = null ;
   protected DButton            pb_FIND           = null ;
   protected DButton            pb_FINDAGAIN      = null ;
   protected DButton            pb_DOCLINK        = null ;
   protected DButton            pb_SPELL          = null ;
   protected DButton            pb_RESTARTWP      = null ;
   protected DButton            pb_PREVIEW        = null ;
   protected DButton            pb_LINKTARGET     = null ;
   protected DButton            pb_IMPORTHTML     = null ;
   protected DButton            pb_DELETEROW      = null ;
   protected DButton            pb_DELETECOL      = null ;
   protected DButton            pb_INSERTROW      = null ;
   protected DButton            pb_INSERTCOL      = null ;
   protected DButton            pb_STAMPEDGRAPHIC = null ;

   protected DButton            pb_HELV          = null ;
   protected DButton            pb_COURIER       = null ;
   protected DButton            pb_HELV10        = null ;
   protected DButton            pb_MONO10        = null ;
   protected DButton            pb_DEFAULT       = null ;
   protected DButton            pb_BLACK         = null ;
   protected DButton            pb_RED           = null ;
   protected DButton            pb_BLUE          = null ;
   protected DButton            pb_PROPERTY      = null ;
   protected DButton            pb_COMMENTS      = null ;
   protected DButton            pb_DELCOMMENTS   = null ;
   protected DButton            pb_EDITTAGS      = null ;


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Menu Items                                              */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private MenuBar        menuBar            = null ;
   private Menu           MNU_FILE           = null ;
   private MenuItem       MNU_QUIT           = null ;
   private Menu           MNU_HELP           = null ;
   private MenuItem       MNU_GENERIC        = null ;
   private MenuItem       MNU_PANEL          = null ;
   private MenuItem       MNU_INDEX          = null ;
   private MenuItem       MNU_USERPREF       = null ;       
   private Menu           MNU_EDIT           = null ;
   private MenuItem       MNU_CUT            = null ;
   private Menu           MNU_COPY           = null ;
   private MenuItem       MNU_COPYASTEXT     = null ;
   private MenuItem       MNU_COPYASDOC      = null ;
   private Menu           MNU_PASTE          = null ;
   private MenuItem       MNU_PASTEASTEXT    = null ;
   private MenuItem       MNU_PASTEASDOC     = null ;
   private MenuItem       MNU_PASTEASPRODUCT = null ;
   private MenuItem       MNU_CLEARDOC       = null ;
   private MenuItem       MNU_SELECTALL      = null ;
   private Menu           MNU_STYLES         = null ;
   private Menu           MNU_HEADING        = null ;
   private Menu           MNU_BODY           = null ;
   private MenuItem       MNU_MAINHEAD       = null ;
   private MenuItem       MNU_SUBHEAD        = null ;
   private MenuItem       MNU_SUBSUBHEAD     = null ;
   private MenuItem       MNU_DEFAULTBODY    = null ;
   private MenuItem       MNU_MONOBODY       = null ;
   private MenuItem       MNU_WARNINGBODY    = null ;
   private MenuItem       MNU_STANDARDS      = null ;


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Vars                                                    */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private String             htmlText           = null ;
   private DocumentDraft      document           = null ;
   private int                fieldId            = 0 ;
   private boolean            wordProcStarted    = false ;
   private boolean            processKey         = false ;
   private TextElement        curSelectedText    = null  ;
   private ParagraphStyle     curParagraph       = null  ;
   private boolean            inPreviewMode      = false ;       
   private boolean            changed            = false ;
   private String             prevFindString     = null ;
   private boolean            nextLinkAsTarget   = false ;
   private boolean            currentlySaving    = false ;
   private Thread             autoSaveThread     = null ;
   private boolean            continueAutoSave   = true ;
   private String             autoSaveContent    = null ;
   private boolean            enabled            = true ;
   private boolean            editingTags        = false ;
   private StampedGraphicDlg  stampedGraphicDlg  = null ;

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Text Attributes                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private boolean isBold       = false ;
   private boolean isItalic     = false ;
   private boolean isUnderlined = false ;
   private boolean isStriked    = false ;


   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will create and add the word processor
    *  to our frame
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public WordProcFrame ( DocumentDraft document, int fieldId ) {
      super ( Str.getStr ( STR_WORDPROCESSOR ) ) ;

      /* Add ouselves as a window listener */
      addWindowListener ( this ) ;

      /* Set our location and size */

      if ( !setBoundsFromINI() ) {
         Rectangle rect = MainWindow.getInstance().getBounds() ;

         setBounds ( rect.x, rect.y, rect.width, rect.height-19 ) ;
      }

      /* Set our variables */
      this.document   = document ;
      this.fieldId  = fieldId ;

      /* Kick off the thread that will initialize us */
      new Thread ( this, THREAD_INITIALIZE ).start() ;

   }


   public WordProcFrame () {
   }




   /*------------------------------------------------------------*/
   /* setBoundsFromINI
    */
   /**
    *    This method will set the bounds of this
    *  window from the last position in the INI file
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return TRUE if the bounds are set, FALSE if not
    *//*---------------------------------------------------------*/
   private boolean setBoundsFromINI () {
      Rectangle rect = (Rectangle) QuestUtil.readObjectFromDisk ( "wpframe.loc" ) ;

      if ( rect != null ) {
         setBounds ( rect.x, rect.y, rect.width, rect.height-19 ) ;
         return( true ) ;
      }

      return( false ) ;
   }


   /*------------------------------------------------------------*/
   /* initialize
    */
   /**
    *    This method will initialize all controls in the
    *  window. The will include creating and adding
    *  the controls to our window and panels
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void initialize () {
      ButtonPanel toolBarButtonPanel = new ButtonPanel () ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Initialize the menu's and tool bars                     */
      /*                                                           */
      /*-----------------------------------------------------------*/
      initializeMenu() ;
      initializeToolbars() ;                  

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create all other gui controls                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      mle_EDITTAGS  = new TextArea() ;
      toolBarPanel  = new Panel() ;
      cardPanel     = new Panel() ;              

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create the Word Processor                               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( !wordProcStarted )
         createWordProcessor() ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust some properties                                  */
      /*                                                           */
      /*-----------------------------------------------------------*/
      toolBarPanel.setBackground ( Color.lightGray ) ;
      cardPanel.setBackground    ( Color.lightGray ) ;
      actionBar.setBackground    ( Color.lightGray ) ;
      fontBar.setBackground      ( Color.lightGray ) ;
      cardPanel.setBackground    ( Color.lightGray ) ;
      toolBar.setBackground      ( Color.lightGray ) ;
      //toolBar.setBorder          ( null ) ;               
      toolBarButtonPanel.setArrowImage ( ImageSystem.getImageIcon ( this, ImageSystem.BUTTONPANEL_LEFT ),
                                         ImageSystem.getImageIcon ( this, ImageSystem.BUTTONPANEL_RIGHT ) ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create the Preview Browser                              */
      /*                                                           */
      /*-----------------------------------------------------------*/
      pnl_PREVIEW = GUISystem.createBrowser() ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Set the layouts                                         */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setLayout ( new BorderLayout() ) ;
      toolBarPanel.setLayout ( new BorderLayout(0, 0) ) ;
      cardPanel.setLayout ( new CardLayout ( 2, 2 ) ) ;
      fontBar.setLayout ( new FlowLayout ( FlowLayout.LEFT ) ) ;                  


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add the controls to our panel                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      //toolBarButtonPanel.add ( toolBar ) ;
      //toolBarPanel.add ( toolBar,   BorderLayout.NORTH ) ;
      //toolBarPanel.add ( fontBar,   BorderLayout.CENTER ) ;
      //toolBarPanel.add ( actionBar, BorderLayout.SOUTH ) ;


      setLayout ( null ) ;
      add ( toolBar ) ;
      add ( fontBar ) ;
      add ( actionBar ) ;
      add ( cardPanel ) ;

      cardPanel.add ( wordProc,     "wordProc" ) ;
      cardPanel.add ( pnl_PREVIEW.getComponent(),  "pnl_PREVIEW" ) ;
      cardPanel.add ( mle_EDITTAGS, "mle_EDITTAGS" ) ;
      invalidate() ;          

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Set ourselves Visible                                   */
      /*                                                           */
      /*-----------------------------------------------------------*/
      setBoundsFromINI () ;
      setVisible ( true ) ;     


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Refresh our Data                                        */
      /*                                                           */
      /*-----------------------------------------------------------*/
      refreshData ( document, fieldId, THREAD_SETCONTENT );                

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create the auto-save thread                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      new Thread ( this, THREAD_AUTOSAVE ) ;
   }


   public void doLayout ( ) {
      Dimension size = getSize() ;
      int       tempHeight = 0 ;
      int       y          = getInsets().top ;
      int       x          = getInsets().left ;

      super.doLayout () ;

      size.width = size.width-(x*2) ;

      try {
         toolBar.setSize ( size.width, 21 ) ;
         tempHeight = toolBarLayout.preferredLayoutSize ( toolBar ).height ;
         toolBarLayout.layoutContainer ( toolBar ) ;
         toolBar.setBounds ( 0, y, size.width, tempHeight ) ;
         y+=tempHeight ;

         fontBar.setSize ( size.width, 21 ) ;
         tempHeight = fontBar.getPreferredSize().height ;
         fontBar.setBounds ( 0, y, size.width, tempHeight ) ;
         y+=tempHeight ;

         actionBar.setSize ( size.width, 21 ) ;
         tempHeight = actionBar.getPreferredSize().height ;
         actionBar.setBounds ( 0, y, size.width, tempHeight ) ;
         y+=tempHeight ;

         cardPanel.setBounds ( 0, y, size.width, size.height-y-10 ) ;
      } catch ( Exception e ) {
      }

   }

   /*------------------------------------------------------------*/
   /* run
    */
   /**
    *    This method will run an operation in a thread. The
    *  operation that is run depends on what the name
    *  of the thread is
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void run () {
      String name = Thread.currentThread().getName() ;                               

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   THREAD_INITIALIZE - Initializes the Window              */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( name.equals ( THREAD_INITIALIZE ) )
         initialize() ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   THREAD_SPELLCHECK                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( name.equals ( THREAD_SPELLCHECK ) ) {
         spellCheck(true) ;
      } /* THREAD_SPELLCHECK */

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   THREAD_SAVECONTENT                                      */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( name.equals ( THREAD_SAVECONTENT ) ) {
         saveContent() ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   THREAD_SAVECONTENTANDEXIT                               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( name.equals ( THREAD_SAVECONTENTANDEXIT ) ) {
         if ( saveContent() )
            windowClosing ( null ) ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   THREAD_AUTOSAVE                                         */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( name.equals ( THREAD_AUTOSAVE ) )
         processAutoSave() ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   THREAD_SETCONTENT                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( name.equals ( THREAD_SETCONTENT ) ) {
         setContent() ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   THREAD_WAITANDSETCONTENT                                */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( name.equals ( THREAD_WAITANDSETCONTENT ) ) {
         try {
            Thread.currentThread().sleep ( 1000 ) ;
         } catch ( Exception e ) {
         }
         setContent() ;
      }
   }





   /*------------------------------------------------------------*/
   /* windowClosing
    */
   /**
    *    We have intercepted this message because
    *  we want to destroy the word processor
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void windowClosing ( WindowEvent e ) {
      if ( enabled ) {

         if ( e == null ) {
            Rectangle rect = getBounds() ;

            QuestUtil.writeObjectToDisk ( "wpframe.loc", rect ) ;

            MainWindow.getInstance().requestFocus() ;
            MainWindow.getInstance().toFront() ;
            finalize() ;
         } else
            checkClose() ;
      }
   }


   /*------------------------------------------------------------*/
   /* finalize
    */
   /**
    *    This method is subclassed so that we can
    *  call the destroy methods on the word processor
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void finalize () {
      try {
         if ( wordProcStarted ) {
            WordProcUtil.destroyWordProcessor ( wordProc ) ;
            wordProcStarted = false ;
         }

         continueAutoSave = false ;
         if ( autoSaveThread != null )
            autoSaveThread.interrupt() ;

         remove ( toolBar ) ;
         toolBar         = null ;
         actionBar       = null ;
         wordProc        = null ;
         curSelectedText = null ;
         curParagraph    = null ;
         dispose() ;
         super.finalize() ;
         System.gc() ;

      } catch ( Throwable e ) {
         e.printStackTrace() ;
      }
   }




   /*------------------------------------------------------------*/
   /* initializeToolbar
    */
   /**
    *    This method will initialize our toolbars. This will
    *  create, add and modify each button
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void initializeToolbars () {


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create the tool bar and set some properties             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      toolBar   = new Panel () ;
      actionBar = new Panel () ;
      fontBar   = new Panel () ;

      toolBar.setLayout ( toolBarLayout = new FlowLayout ( FlowLayout.LEFT ) ) ;
      toolBar.setBackground ( Color.lightGray ) ;
      actionBar.setLayout ( new FlowLayout ( FlowLayout.LEFT ) ) ;
      actionBar.setBackground ( Color.lightGray ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create all of the task bar buttons                      */
      /*                                                           */
      /*-----------------------------------------------------------*/
      pb_STAMPEDGRAPHIC = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.STAMPEDGRAPHIC ) ) ;
      pb_TABLE          = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.TABLE ) ) ;
      pb_TABLEPROP      = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.TABLEPROP ) ) ;
      pb_CENTERALIGN    = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.CENTERALIGN ) ) ;
      pb_RIGHTALIGN     = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.LEFTALIGN   ) ) ;
      pb_LEFTALIGN      = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.RIGHTALIGN  ) ) ;
      pb_LINK           = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.LINK ) ) ;
      pb_LINKTARGET     = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.LINKTARGET ) ) ;
      pb_IMPORTGRAPHIC  = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.GRAPHIC ) ) ;
      pb_HORIZLINE      = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.HORIZLINE ) ) ;
      pb_CUT            = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.CUT    ) ) ;
      pb_COPY           = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.COPY   ) ) ;
      pb_PASTE          = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.PASTE  ) ) ;
      pb_UNDO           = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.UNDO   ) ) ;
      pb_FIND           = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.FIND   ) ) ;
      pb_FINDAGAIN      = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.FINDAGAIN ) ) ;
      pb_DOCLINK        = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.DOCLINKBP ) ) ;
      pb_SPELL          = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.SPELL ) ) ;
      pb_BOLD           = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.BOLD ) ) ;
      pb_ITALIC         = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.ITALIC ) ) ;
      pb_UNDERLINE      = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.UNDERLINE ) ) ;
      pb_STRIKETHROUGH  = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.STRIKE ) ) ;
      pb_BULLETLIST     = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.ORDERLIST ) ) ;
      pb_NUMERICLIST    = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.NUMERICLIST   ) ) ;
      pb_IMPORTHTML     = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.IMPORTHTML ) ) ;                 
      pb_INSERTROW      = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.INSERTROW ) ) ;
      pb_INSERTCOL      = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.INSERTCOL ) ) ;
      pb_DELETECOL      = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.DELETECOL ) ) ;
      pb_DELETEROW      = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.DELETEROW ) ) ;             
      pb_COMMENTS       = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.COMMENTS ) ) ;             
      pb_DELCOMMENTS    = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.DELCOMMENTS ) ) ;             

      pb_BLACK          = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.BLACK ) ) ;             
      pb_RED            = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.RED ) ) ;             
      pb_BLUE           = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.BLUE ) ) ;             
      pb_PROPERTY       = newToolBarButton ( ImageSystem.getImageIcon ( this, ImageSystem.PROPERTY ) ) ;             

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Handle the text only buttons                            */
      /*                                                           */
      /*-----------------------------------------------------------*/
      pb_RESTARTWP     = new DButton ( Str.getStr ( STR_RESTART_WP ) ) ;
      pb_HELV10        = new DButton ( Str.getStr ( STR_DEFAULT_FONT_SIZE ) ) ;
      pb_MONO10        = new DButton ( Str.getStr ( STR_COURIER_10 ) ) ;
      pb_DEFAULT       = new DButton ( Str.getStr ( STR_TITLE_FONT ) ) ;
      pb_RESTARTWP.addActionListener ( this ) ;
      pb_HELV10.addActionListener ( this ) ;
      pb_MONO10.addActionListener ( this ) ;
      pb_DEFAULT.addActionListener ( this ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add all of the buttons to the task bar                  */
      /*                                                           */
      /*-----------------------------------------------------------*/
      toolBar.add ( pb_UNDO ) ;
      toolBar.add ( pb_COMMENTS ) ;
      toolBar.add ( pb_DELCOMMENTS ) ;
      toolBar.add ( new ToolBarSeparator() ) ;
      toolBar.add ( pb_PROPERTY ) ;
      toolBar.add ( new ToolBarSeparator() ) ;
      toolBar.add ( pb_IMPORTHTML ) ;
      toolBar.add ( new ToolBarSeparator() ) ;
      toolBar.add ( pb_CUT ) ;
      toolBar.add ( pb_COPY ) ;
      toolBar.add ( pb_PASTE ) ;
      toolBar.add ( new ToolBarSeparator() ) ;
      toolBar.add ( pb_FIND ) ;
      toolBar.add ( pb_FINDAGAIN ) ;
      toolBar.add ( new ToolBarSeparator() ) ;
      toolBar.add ( pb_SPELL ) ;
      toolBar.add ( new ToolBarSeparator() ) ;
      toolBar.add ( pb_IMPORTGRAPHIC ) ;
      toolBar.add ( pb_STAMPEDGRAPHIC ) ;
      toolBar.add ( new ToolBarSeparator() ) ;
      toolBar.add ( pb_BULLETLIST ) ;
      toolBar.add ( pb_NUMERICLIST ) ;
      toolBar.add ( new ToolBarSeparator() ) ;
      toolBar.add ( pb_BOLD ) ;
      toolBar.add ( pb_ITALIC ) ;
      toolBar.add ( pb_STRIKETHROUGH ) ;
      toolBar.add ( new ToolBarSeparator() ) ;
      toolBar.add ( pb_HORIZLINE ) ;
      toolBar.add ( pb_LINK ) ;
      toolBar.add ( pb_DOCLINK ) ;
      toolBar.add ( pb_LINKTARGET ) ;
      toolBar.add ( new ToolBarSeparator() ) ;
      toolBar.add ( pb_TABLE ) ;
      toolBar.add ( pb_TABLEPROP ) ;
      toolBar.add ( pb_INSERTROW ) ;
      toolBar.add ( pb_INSERTCOL ) ;
      toolBar.add ( pb_DELETEROW ) ;
      toolBar.add ( pb_DELETECOL ) ;
      toolBar.add ( new ToolBarSeparator() ) ;
      toolBar.add ( pb_LEFTALIGN ) ;
      toolBar.add ( pb_CENTERALIGN ) ;
      toolBar.add ( pb_RIGHTALIGN ) ;
      toolBar.add ( new ToolBarSeparator() ) ;
      //toolBar.add ( pb_RESTARTWP ) ;          

      fontBar.add ( pb_HELV10 ) ;
      fontBar.add ( pb_DEFAULT ) ;
      fontBar.add ( pb_MONO10 ) ;
      fontBar.add ( pb_BLACK ) ;
      fontBar.add ( pb_BLUE ) ;
      fontBar.add ( pb_RED ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Set the Tool Tip text                                   */
      /*                                                           */
      /*-----------------------------------------------------------*/
      pb_STAMPEDGRAPHIC.setToolTipText ( Str.getStr ( STR_STAMPED_GRAPHIC ) ) ;
      pb_IMPORTHTML.setToolTipText ( Str.getStr ( STR_IMPORT_HTML ) ) ;
      pb_UNDO.setToolTipText ( Str.getStr ( STR_UNDO_LAST_ACTION ) ) ;
      pb_CUT.setToolTipText ( Str.getStr ( STR_CUT ) ) ;
      pb_COPY.setToolTipText ( Str.getStr ( STR_COPY ) ) ;
      pb_PASTE.setToolTipText ( Str.getStr ( STR_PASTE ) ) ;
      pb_FIND.setToolTipText ( Str.getStr ( STR_FIND ) ) ;
      pb_FINDAGAIN.setToolTipText ( Str.getStr ( STR_FIND_AGAIN ) ) ;
      pb_SPELL.setToolTipText ( Str.getStr ( STR_SPELL ) ) ;
      pb_BOLD.setToolTipText ( Str.getStr ( STR_BOLD_TEXT ) ) ;
      pb_ITALIC.setToolTipText ( Str.getStr ( STR_ITALIC_TEXT ) ) ;
      pb_STRIKETHROUGH.setToolTipText ( Str.getStr ( STR_STRIKE_OUT_TEXT ) ) ;
      pb_HORIZLINE.setToolTipText ( Str.getStr ( STR_HORIZONTAL_LINE ) ) ;
      pb_LINK.setToolTipText ( Str.getStr ( STR_NEW_URL_LINK ) ) ;
      pb_LINKTARGET.setToolTipText ( Str.getStr ( STR_LINK_TARGET ) ) ;
      pb_DOCLINK.setToolTipText ( Str.getStr ( STR_CREATE_DOC_LINK ) ) ;
      pb_IMPORTGRAPHIC.setToolTipText ( Str.getStr ( STR_IMPORT_GRAPHIC ) ) ;
      pb_BULLETLIST.setToolTipText ( Str.getStr ( STR_BULLET_LIST ) ) ;
      pb_NUMERICLIST.setToolTipText ( Str.getStr ( STR_NUMERIC_LIST ) ) ;
      pb_TABLE.setToolTipText ( Str.getStr ( STR_CREATE_TABLE ) ) ;
      pb_TABLEPROP.setToolTipText ( Str.getStr ( STR_TABLE_PROP ) ) ;
      pb_LEFTALIGN.setToolTipText ( Str.getStr ( STR_LEFT_ALIGN ) ) ;
      pb_RIGHTALIGN.setToolTipText ( Str.getStr ( STR_RIGHT_ALIGN ) ) ;
      pb_CENTERALIGN.setToolTipText ( Str.getStr ( STR_CENTER_ALIGN ) ) ;
      pb_RESTARTWP.setToolTipText ( Str.getStr ( STR_RESTART_WP ) ) ;
      pb_DELETEROW.setToolTipText ( Str.getStr ( STR_DELETE_ROW ) ) ;
      pb_INSERTROW.setToolTipText ( Str.getStr ( STR_INSERT_ROW ) ) ;
      pb_INSERTCOL.setToolTipText ( Str.getStr ( STR_INSERT_COL ) ) ;
      pb_DELETECOL.setToolTipText ( Str.getStr ( STR_DELETE_COL ) ) ;                
      pb_COMMENTS.setToolTipText ( Str.getStr ( STR_EDITOR_COMMENTS ) ) ;
      pb_DELCOMMENTS.setToolTipText ( Str.getStr ( STR_DELETE_EDITOR_COMMENTS ) ) ;
      pb_PROPERTY.setToolTipText ( Str.getStr ( STR_PROPERTIES ) ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create the Action Buttons                               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      pb_SAVE    = new DButton ( Str.getStr ( STR_SAVE ),      ImageSystem.getImageIcon ( this, ImageSystem.SAVE  ) ) ;
      pb_CLOSE   = new DButton ( Str.getStr ( STR_CLOSE ),     ImageSystem.getImageIcon ( this, ImageSystem.CLOSE  ) ) ;           
      pb_CLEAR   = new DButton ( Str.getStr ( STR_CLEAR ),     ImageSystem.getImageIcon ( this, ImageSystem.NEW ) ) ;           
      pb_PREVIEW = new DButton ( Str.getStr ( STR_PREVIEW ),   ImageSystem.getImageIcon ( this, ImageSystem.SAVE ) ) ;
      pb_EDITTAGS = new DButton ( Str.getStr ( STR_EDITTAGS ), ImageSystem.getImageIcon ( this, ImageSystem.EDIT ) ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add action listeners                                    */
      /*                                                           */
      /*-----------------------------------------------------------*/
      pb_SAVE.addActionListener     ( this ) ;
      pb_CLOSE.addActionListener    ( this ) ;          
      pb_PREVIEW.addActionListener  ( this ) ;
      pb_CLEAR.addActionListener    ( this ) ;
      pb_EDITTAGS.addActionListener  ( this ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add the action bars                                     */
      /*                                                           */
      /*-----------------------------------------------------------*/
      actionBar.add ( pb_SAVE ) ;
      actionBar.add ( pb_CLOSE ) ;
      actionBar.add ( pb_PREVIEW ) ;
      actionBar.add ( pb_CLEAR ) ;
      actionBar.add ( pb_EDITTAGS ) ;

   } /* createTaskBar */




   /*------------------------------------------------------------*/
   /* initializeMenu
    */
   /**
    *    This method will create our menu items
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void initializeMenu () {
      menuBar      = new MenuBar () ;                    

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create all Menu Items and Menus                         */
      /*                                                           */
      /*-----------------------------------------------------------*/
      MNU_EDIT           = new Menu     ( Str.getStr ( STR_EDIT ) ) ;
      MNU_CUT            = new MenuItem ( Str.getStr ( STR_CUT ) ) ;
      MNU_COPY           = new Menu     ( Str.getStr ( STR_COPY ) ) ;
      MNU_COPYASTEXT     = new MenuItem ( Str.getStr ( STR_COPYASTEXT ) ) ;
      MNU_PASTE          = new Menu     ( Str.getStr ( STR_PASTE ) ) ;
      MNU_PASTEASTEXT    = new MenuItem ( Str.getStr ( STR_PASTEASTEXT ) ) ;
      MNU_PASTEASDOC     = new MenuItem ( Str.getStr ( STR_PASTEASDOC ) ) ;
      MNU_PASTEASPRODUCT = new MenuItem ( Str.getStr ( STR_PASTEASPRODUCT ) ) ;
      MNU_SELECTALL      = new MenuItem ( Str.getStr ( STR_SELECT_ALL ) ) ;
      MNU_STYLES         = new Menu     ( Str.getStr ( STR_STYLES ) ) ;
      MNU_HEADING        = new Menu     ( Str.getStr ( STR_HEADING ) ) ;
      MNU_BODY           = new Menu     ( Str.getStr ( STR_BODY ) ) ;
      MNU_MAINHEAD       = new MenuItem ( Str.getStr ( STR_MAINHEADING ) ) ;
      MNU_SUBHEAD        = new MenuItem ( Str.getStr ( STR_SUBHEADING ) ) ;
      MNU_SUBSUBHEAD     = new MenuItem ( Str.getStr ( STR_SUBSUBHEADING ) ) ;
      MNU_DEFAULTBODY    = new MenuItem ( Str.getStr ( STR_DEFAULTBODY ) ) ;
      MNU_MONOBODY       = new MenuItem ( Str.getStr ( STR_MONOBODY ) ) ;
      MNU_WARNINGBODY    = new MenuItem ( Str.getStr ( STR_WARNINGBODY ) ) ;         
      MNU_HELP           = new Menu     ( Str.getStr ( STR_HELP ) ) ;
      MNU_STANDARDS      = new MenuItem ( Str.getStr ( STR_STANDARDS ) ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add action Listeners                                    */
      /*                                                           */
      /*-----------------------------------------------------------*/
      MNU_PASTEASTEXT.addActionListener      ( this ) ;
      MNU_PASTEASDOC.addActionListener       ( this ) ;
      MNU_PASTEASPRODUCT.addActionListener   ( this ) ;
      MNU_COPYASTEXT.addActionListener       ( this ) ;
      MNU_CUT.addActionListener              ( this ) ;
      MNU_SELECTALL.addActionListener        ( this ) ;
      MNU_WARNINGBODY.addActionListener      ( this ) ;
      MNU_MONOBODY.addActionListener         ( this ) ;
      MNU_DEFAULTBODY.addActionListener      ( this ) ;
      MNU_SUBSUBHEAD.addActionListener       ( this ) ;
      MNU_SUBHEAD.addActionListener          ( this ) ;
      MNU_MAINHEAD.addActionListener         ( this ) ;      
      MNU_STANDARDS.addActionListener        ( this ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add the Edit Menu                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      menuBar.add            ( MNU_EDIT ) ;
      MNU_EDIT.add           ( MNU_CUT ) ;
      MNU_EDIT.add           ( MNU_COPY ) ;
      MNU_COPY.add           ( MNU_COPYASTEXT ) ;
      MNU_EDIT.add           ( MNU_PASTE ) ;
      MNU_PASTE.add          ( MNU_PASTEASTEXT ) ;
      MNU_PASTE.add          ( MNU_PASTEASDOC ) ;
      MNU_PASTE.add          ( MNU_PASTEASPRODUCT ) ;
      MNU_EDIT.add           ( MNU_SELECTALL ) ;        

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add the Styles menu                                     */
      /*                                                           */
      /*-----------------------------------------------------------*/
      menuBar.add            ( MNU_STYLES ) ;
      MNU_STYLES.add         ( MNU_HEADING ) ;
      MNU_STYLES.add         ( MNU_BODY ) ;
      MNU_HEADING.add        ( MNU_MAINHEAD ) ;
      MNU_HEADING.add        ( MNU_SUBHEAD ) ;
      MNU_HEADING.add        ( MNU_SUBSUBHEAD ) ;
      MNU_BODY.add           ( MNU_DEFAULTBODY ) ;
      MNU_BODY.add           ( MNU_MONOBODY ) ;
      MNU_BODY.add           ( MNU_WARNINGBODY ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Help Menu                                               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      menuBar.add ( MNU_HELP ) ;
      MNU_HELP.add ( MNU_STANDARDS ) ;

      setMenuBar ( menuBar ) ;
   }

   /*------------------------------------------------------------*/
   /* newToolBarButton
    */
   /**
    *    This method will create an image task bar
    *  button for the word processor's task bar
    *  
    *
    *  @param imageIcon The new Image Icon to use
    *  @param None
    *  @param None
    *
    *  @return DButton The new instance of the button
    *//*---------------------------------------------------------*/
   private DButton newToolBarButton ( ImageIcon icon ) {
      DButton retButton = new DButton ( icon ) ;

      retButton.setFocusPainted ( false ) ;
      retButton.addActionListener ( this ) ;
      retButton.setMargin ( taskBarButtonMargin ) ;

      return( retButton ) ;
   }






   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will be called when an
    *  action we are listening for has been fired
    *  
    *
    *  @param e The Action Event
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {
      boolean setFocus = true ;       

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Handle Button HIts                                      */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( e.getSource() instanceof DButton ) {
         DButton button = (DButton) e.getSource() ;

         /* Set our changed flag automatically if this is not close */
         if ( pb_CLOSE != button )
            changed = true ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_CLOSE                                                */
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( button == pb_CLOSE ) {
            setFocus = false ;
            checkClose() ;

         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_SAVE                                                 */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( button == pb_SAVE ) {
            try {
               if ( inPreviewMode )
                  setPreviewMode ( false ) ;
               if ( PropertySystem.getBool ( PropertySystem.PROPERTY_SAVE_AND_CLOSE ) )
                  new Thread ( this, THREAD_SAVECONTENTANDEXIT ).start() ;
               else
                  new Thread ( this, THREAD_SAVECONTENT ).start() ;
            } catch ( Exception ex1 ) {
            }
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_STAMPEDGRAPHIC                                       */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( button == pb_STAMPEDGRAPHIC ) {
            if ( stampedGraphicDlg != null ) {
               stampedGraphicDlg.setVisible ( true ) ;
               stampedGraphicDlg.requestFocus() ;
            } else
               stampedGraphicDlg = new StampedGraphicDlg ( this, this ) ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_EDITTAGS                                             */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( button == pb_EDITTAGS ) {
            editTags ( !editingTags ) ;            
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_RESTARTWP                                            */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( button == pb_RESTARTWP ) {
            cardPanel.remove ( wordProc ) ;
            wordProc=null ;
            wordProcStarted = false ;
            System.gc() ;
            createWordProcessor() ;
            cardPanel.add ( wordProc, "wordProc" ) ;
            if ( autoSaveContent != null ) {
               wordProc.setDocumentContentsAsHTML ( autoSaveContent ) ;
               setPageLayout() ;
            }
            setVisible ( true ) ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_BOLD = Toggles the bold attribute                    */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_BOLD == button )
            setBold() ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_ITALIC = Toggles the italic attribute                */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_ITALIC == button )
            setItalic() ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_UNDERLINE = Toggles the underline attribute          */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_UNDERLINE == button )
            setUnderline() ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_STRIKETHROUGH = Toggles the Strikethrough attribute  */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_STRIKETHROUGH == button )
            setStrikethrough() ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_DELCOMMENTS                                          */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_DELCOMMENTS == button ) {
            if ( GUISystem.printBox ( this, STR_QUESTION, STR_ARE_YOU_SURE_REMOVE_EDITOR_COMMENTS ) )
               removeEditorComments() ;

         }


         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_CENTERALIGN = Set the center alignment               */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_CENTERALIGN == button ) {
            wordProc.findSelectedTextElement().setAlignment ( "center" ) ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_LEFTALIGN = Set the left alignment                   */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_LEFTALIGN == button ) {
            wordProc.findSelectedTextElement().setAlignment ( "left" ) ;
         }


         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_RIGHTALIGN = Set the right alignment                 */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_RIGHTALIGN == button ) {
            wordProc.findSelectedTextElement().setAlignment ( "right" ) ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_CLEAR = Clears the document's contents               */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_CLEAR == button ) {

            if ( inPreviewMode )
               setPreviewMode ( false ) ;

            if ( editingTags )
               editTags ( false ) ;

            /* Ask the user if they are sure they wish to do this */
            if ( GUISystem.printBox ( this, STR_QUESTION, STR_ARE_YOU_SURE_CLEAR_DOC ) )
               clearDocument ( true ) ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_COMMENTS                                             */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_COMMENTS == button )
            insertEditorComments() ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_COPY = Copies data from the word processor           */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_COPY == button )
            wordProc.copy() ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_PASTE = Pastes data from the clipboard to the wp     */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_PASTE == button )
            wordProc.paste() ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_CUT = Cuts data out of the wp to the clipboard       */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_CUT == button )
            wordProc.cut() ;


         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_HORIZLINE = Insets a horizontal line into the wp     */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_HORIZLINE == button )
            wordProc.insertHorizontalLine ( "line("+System.currentTimeMillis()+")" ) ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_IMPORTHTML - Imports an HTML File                    */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_IMPORTHTML == button )
            importHTML () ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_IMPORTGRAPHIC = Inserts a graphic into the wp        */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_IMPORTGRAPHIC == button )
            importGraphic() ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_LINK = Adds a new hot link to the field              */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_LINK == button ) {
            String linkStr = new SingleEntryDlg ( this,
                                                  Str.getStr ( STR_NEW_LINK ), 
                                                  Str.getStr ( STR_NEW_LINK ),
                                                  "http://",
                                                  new MaskDocument ( MaskDocument.MASKTYPE_UNKNOWN, 254 ) ).getResult() ;

            if ( linkStr != null )
               wordProc.insertLink ( "l"+DateSystem.getDate ( com.ibm.nzna.shared.util.CDate.DATE_STAMP ), linkStr ) ;
            setFocus = true ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_LINKTARGET = Will add a new link target              */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_LINKTARGET == button ) {
            if ( GUISystem.printBox ( this, STR_QUESTION, STR_ARE_YOU_SURE_LINK_TARGET ) ) {
               String linkStr = new SingleEntryDlg ( this,
                                                     Str.getStr ( STR_NEW_LINK ), 
                                                     Str.getStr ( STR_NEW_LINK ),
                                                     "http://",
                                                     new MaskDocument ( MaskDocument.MASKTYPE_UNKNOWN, 254 ) ).getResult() ;

               if ( linkStr != null )
                  wordProc.insertLink ( "l"+DateSystem.getDate ( com.ibm.nzna.shared.util.CDate.DATE_STAMP ), linkStr+"_(newwin)" ) ;
            }
            setFocus = true ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_PREVIEW = Moves the app into preview mode            */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_PREVIEW == button ) {
            setPreviewMode ( !inPreviewMode ) ;
            setFocus = !inPreviewMode ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_TABLE = Adds a new table to the document             */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_TABLE == button ) {
            new TablePropertyDlg ( this, wordProc, null ) ;
            setFocus = false ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_PROPERTY                                             */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_PROPERTY == button ) {
            Table table = (Table) wordProc.findCurrentObject ( "Table" ) ;
            Link  link  = (Link) wordProc.findCurrentObject ( "link" ) ;

            if ( link != null ) {
               String newLink = new SingleEntryDlg ( this, 
                                                     Str.getStr ( STR_EDIT_LINK ), 
                                                     Str.getStr ( STR_EDIT_LINK ), 
                                                     link.getDestination(), 
                                                     new MaskDocument ( MaskDocument.MASKTYPE_UNKNOWN, 254 ) ).getResult() ;

               if ( newLink != null )
                  link.setDestination ( newLink ) ;

            } else if ( table != null )
               new TablePropertyDlg ( this, wordProc, table ) ;
         }


         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_TABLEPROP = Starts the table property dialog         */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_TABLEPROP == button ) {
            Table table = (Table) wordProc.findCurrentObject ( "Table" ) ;

            if ( table != null ) {
               new TablePropertyDlg ( this, wordProc, table ) ;
            } else
               GUISystem.printBox ( this, STR_INFO, STR_POSITION_CURSOR_IN_TABLE ); 

            setFocus = false ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_INSERTROW                                            */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_INSERTROW == button ) {
            TableCell tableCell = (TableCell) wordProc.findCurrentObject ( "TableCell" ) ;

            if ( tableCell != null ) {
               tableCell.getTable().insertRow ( tableCell.getRowIndex() ) ;
            } else
               GUISystem.printBox ( this, STR_INFO, STR_POSITION_CURSOR_IN_TABLE ); 

            setFocus = false ;
         }


         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_INSERTCOL                                            */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_INSERTCOL == button ) {
            TableCell tableCell = (TableCell) wordProc.findCurrentObject ( "TableCell" ) ;

            if ( tableCell != null ) {
               tableCell.getTable().insertColumn ( tableCell.getColumnIndex() ) ;
            } else
               GUISystem.printBox ( this, STR_INFO, STR_POSITION_CURSOR_IN_TABLE ); 

            setFocus = false ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_DELETEROW                                            */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_DELETEROW == button ) {
            TableCell tableCell = (TableCell) wordProc.findCurrentObject ( "TableCell" ) ;

            if ( tableCell != null ) {
               tableCell.getTable().deleteRow ( tableCell.getRowIndex() ) ;
            } else
               GUISystem.printBox ( this, STR_INFO, STR_POSITION_CURSOR_IN_TABLE ); 

            setFocus = false ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_DELETECOL                                            */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_DELETECOL == button ) {
            TableCell tableCell = (TableCell) wordProc.findCurrentObject ( "TableCell" ) ;

            if ( tableCell != null ) {
               tableCell.getTable().deleteColumn ( tableCell.getColumnIndex() ) ;
            } else
               GUISystem.printBox ( this, STR_INFO, STR_POSITION_CURSOR_IN_TABLE ); 

            setFocus = false ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_UNDO = Causes one undo action                        */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_UNDO == button )
            wordProc.undo() ;


         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_BULLETLIST = Creates a new bullet list               */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_BULLETLIST == button )
            createBulletList() ;


         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_NUMERICLIST = Creates an ordered list                */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_NUMERICLIST == button )
            createOrderedList() ;


         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_FIND = Initiates a search                            */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_FIND == button ) {
            prevFindString = new SingleEntryDlg ( this,
                                                  Str.getStr ( STR_FIND ), 
                                                  Str.getStr ( STR_SEARCH_FOR ),
                                                  prevFindString,
                                                  new MaskDocument ( MaskDocument.MASKTYPE_UNKNOWN, 254 ) ).getResult() ;
            if ( prevFindString != null )
               find() ;
         }


         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_FINDAGAIN = Repeats the last search                  */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_FINDAGAIN == button ) {
            if ( ( prevFindString == null ) || ( prevFindString.length() == 0 ) ) {
               prevFindString = new SingleEntryDlg ( this,
                                                     Str.getStr ( STR_FIND ), 
                                                     Str.getStr ( STR_SEARCH_FOR ),
                                                     prevFindString,
                                                     new MaskDocument ( MaskDocument.MASKTYPE_UNKNOWN, 254 ) ).getResult() ;
               if ( prevFindString != null )
                  find() ;
            } else
               find() ;
         }


         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_DOCLINK = Creates a new doc link                     */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_DOCLINK == button ) {
            new SelectDocDlg ( SelectDocDlg.SELECTTYPE_SINGLE, false ).getInstance().addSelectDocListener ( this ) ;
            setFocus = false ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_SPELL = Initiates the spell checker                  */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_SPELL == button ) {
            if ( inPreviewMode )
               setPreviewMode ( false ) ;
            if ( editingTags )
               editTags ( false ) ;

            new Thread ( this, THREAD_SPELLCHECK ).start() ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_MONO10                                               */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_MONO10 == button ) {
            curSelectedText = wordProc.findSelectedTextElement() ;
            curSelectedText.setFontSize ( 10 ) ;
            curSelectedText.setFontName ( "Courier" ) ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   pb_DEFAULT                                               */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_DEFAULT == button ) {
            curSelectedText = wordProc.findSelectedTextElement() ;
            curSelectedText.setFontSize ( 12 ) ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   pb_HELV10                                               */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_HELV10 == button ) {
            curSelectedText = wordProc.findSelectedTextElement() ;
            curSelectedText.setFontSize ( 10 ) ;
            curSelectedText.setFontName ( "Helvetica" ) ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_RED                                                  */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_RED == button ) {
            curSelectedText = wordProc.findSelectedTextElement() ;
            curSelectedText.setTextColor ( new Color(255,0,0) ) ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_BLUE                                                 */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_BLUE == button ) {
            curSelectedText = wordProc.findSelectedTextElement() ;
            curSelectedText.setTextColor ( new Color(0,0,255) ) ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   PB_BLACK                                                */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( pb_BLACK == button ) {
            curSelectedText = wordProc.findSelectedTextElement() ;
            curSelectedText.setTextColor ( Color.black ) ;
         }

      }


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Handle Menu Item Hits                                   */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() instanceof MenuItem ) {
         MenuItem menuItem = (MenuItem) e.getSource() ;  


         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   MNU_SELECTALL                                           */
         /*                                                           */
         /*-----------------------------------------------------------*/
         if ( menuItem == MNU_SELECTALL ) {
            wordProc.gotoBeginningOfDocument ( false ) ;
            wordProc.gotoEndOfDocument ( true ) ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   MNU_PASTEASTEXT                                         */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( menuItem == MNU_PASTEASTEXT )
            paste () ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   MNU_PASTEASPRODUCT                                      */
         /*                                                           */
         /*-----------------------------------------------------------*/
         //VOY else if ( menuItem == MNU_PASTEASPRODUCT )
         //VOY    paste ( CLIPTYPE_PRODUCT ) ;

         //VOY /*-----------------------------------------------------------*/
         //VOY /*                                                           */
         //VOY /*   MNU_PASTEASDOCUMENT                                     */
         //VOY /*                                                           */
         //VOY /*-----------------------------------------------------------*/
         //VOY else if ( menuItem == MNU_PASTEASDOC )
         //VOY    paste ( CLIPTYPE_DOCUMENT ) ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   MNU_COPYASTEXT                                          */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( menuItem == MNU_COPYASTEXT )
            wordProc.copy() ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   MNU_COPYASDOC                                           */
         /*                                                           */
         /*-----------------------------------------------------------*/
         //VOY else if ( menuItem == MNU_COPYASDOC )
         //VOY    copy ( CLIPTYPE_DOCUMENT ) ;

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   MNU_MAINHEADING                                         */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( menuItem == MNU_MAINHEAD ) {
            curSelectedText = wordProc.findSelectedTextElement() ;
            lotus.wp.ifx.Position startPosition = curSelectedText.getStartPosition() ;
            lotus.wp.ifx.Position endPosition   = curSelectedText.getEndPosition() ;

            wordProc.setRefreshEnabled ( false ) ;
            curSelectedText.setTextColor ( new Color ( 0, 0, 255 ) ) ;
            curSelectedText.setFontSize ( 14 ) ;
            curSelectedText.setFontName ( "Helvetica" ) ;
            curSelectedText.setBold ( true ) ;
            wordProc.createTextElement ( startPosition, endPosition ) ;
            wordProc.setRefreshEnabled ( true ) ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   MNU_SUBHEADING                                          */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( menuItem == MNU_SUBHEAD ) {
            curSelectedText = wordProc.findSelectedTextElement() ;
            lotus.wp.ifx.Position startPosition = curSelectedText.getStartPosition() ;
            lotus.wp.ifx.Position endPosition   = curSelectedText.getEndPosition() ;

            wordProc.setRefreshEnabled ( false ) ;
            curSelectedText.setTextColor ( Color.black ) ;
            curSelectedText.setFontSize ( 12 ) ;
            curSelectedText.setFontName ( "Helvetica" ) ;
            curSelectedText.setBold ( true ) ;
            wordProc.createTextElement ( startPosition, endPosition ) ;
            wordProc.setRefreshEnabled ( true ) ;

            wordProc.setRefreshEnabled ( false ) ;
            curSelectedText.setTextColor ( Color.black ) ;
            curSelectedText.setFontSize ( 12 ) ;
            curSelectedText.setFontName ( "Helvetica" ) ;
            curSelectedText.setBold ( true ) ;
            wordProc.createTextElement ( startPosition, endPosition ) ;
            wordProc.setRefreshEnabled ( true ) ;

         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   MNU_SUBSUBHEADING                                       */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( menuItem == MNU_SUBSUBHEAD ) {
            curSelectedText = wordProc.findSelectedTextElement() ;
            lotus.wp.ifx.Position startPosition = curSelectedText.getStartPosition() ;
            lotus.wp.ifx.Position endPosition   = curSelectedText.getEndPosition() ;

            wordProc.setRefreshEnabled ( false ) ;
            curSelectedText.setTextColor ( Color.blue ) ;
            curSelectedText.setFontSize ( 12 ) ;
            curSelectedText.setFontName ( "Helvetica" ) ;
            curSelectedText.setBold ( false ) ;
            wordProc.createTextElement ( startPosition, endPosition ) ;
            wordProc.setRefreshEnabled ( true ) ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   MNU_DEFAULTBODY                                         */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( menuItem == MNU_DEFAULTBODY ) {
            curSelectedText = wordProc.findSelectedTextElement() ;
            lotus.wp.ifx.Position startPosition = curSelectedText.getStartPosition() ;
            lotus.wp.ifx.Position endPosition   = curSelectedText.getEndPosition() ;

            wordProc.setRefreshEnabled ( false ) ;
            curSelectedText.setTextColor ( Color.black ) ;
            curSelectedText.setFontSize ( 12 ) ;
            curSelectedText.setFontName ( "Helvetica" ) ;
            curSelectedText.setBold ( false ) ;
            curSelectedText.setItalic ( false ) ;
            curSelectedText.setStrikethrough ( false ) ;
            wordProc.createTextElement ( startPosition, endPosition ) ;
            wordProc.setRefreshEnabled ( true ) ;
         }


         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   MNU_MONOBODY                                            */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( menuItem == MNU_MONOBODY ) {
            curSelectedText = wordProc.findSelectedTextElement() ;
            lotus.wp.ifx.Position startPosition = curSelectedText.getStartPosition() ;
            lotus.wp.ifx.Position endPosition   = curSelectedText.getEndPosition() ;

            wordProc.setRefreshEnabled ( false ) ;
            curSelectedText.setTextColor ( Color.black ) ;
            curSelectedText.setFontSize ( 12 ) ;
            curSelectedText.setFontName ( "Courier" ) ;
            curSelectedText.setBold ( false ) ;
            curSelectedText.setItalic ( false ) ;
            curSelectedText.setStrikethrough ( false ) ;
            wordProc.createTextElement ( startPosition, endPosition ) ;
            wordProc.setRefreshEnabled ( true ) ;
         }

         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   MNU_WARNINGBODY                                         */
         /*                                                           */
         /*-----------------------------------------------------------*/
         else if ( menuItem == MNU_WARNINGBODY ) {
            curSelectedText = wordProc.findSelectedTextElement() ;
            lotus.wp.ifx.Position startPosition = curSelectedText.getStartPosition() ;
            lotus.wp.ifx.Position endPosition   = curSelectedText.getEndPosition() ;

            wordProc.setRefreshEnabled ( false ) ;
            curSelectedText.setTextColor ( new Color ( 255, 0, 0 ) ) ;
            curSelectedText.setFontSize ( 12 ) ;
            curSelectedText.setFontName ( "Helvetica" ) ;
            curSelectedText.setBold ( true ) ;
            curSelectedText.setItalic ( false ) ;
            curSelectedText.setStrikethrough ( false ) ;
            wordProc.createTextElement ( startPosition, endPosition ) ;
            wordProc.setRefreshEnabled ( true ) ;
         }


         /*-----------------------------------------------------------*/
         /*                                                           */
         /*   MNU_STANDARDS                                           */
         /*                                                           */
         /*-----------------------------------------------------------*/
         //VOY else if ( menuItem == MNU_STANDARDS ) 
         //VOY     SystemData.showHelp ( "standards_help.html" ) ;

      }


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Set the focus back                                      */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( setFocus ) {
         if ( editingTags )
            mle_EDITTAGS.requestFocus() ;
         else
            wordProc.requestFocus() ;
      }
   }


   /*------------------------------------------------------------*/
   /* getCurSelectedText
    */
   /**
    *    This method will attempt to get the currently
    *  selected text from the word processor. It will
    *  return TRUE if the selected text object obtained is not null
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return TRUE = curselectedText is not null
    *//*---------------------------------------------------------*/
   private boolean getCurSelectedText () {

      curSelectedText = wordProc.findSelectedTextElement() ;
      curParagraph = curSelectedText.getParagraphStyle() ;

      isBold = curSelectedText.getBold() ;
      isItalic = curSelectedText.getItalic() ;
      isUnderlined = curSelectedText.getUnderline() ;
      isStriked    = curSelectedText.getStrikethrough() ;

      return( ( curSelectedText != null ) && ( curParagraph != null ) ) ;

   } /* getCurSelectedText */




   /*------------------------------------------------------------*/
   /* setBold
    */
   /**
    *    This method will toggle the bold attribute of the currently
    *  selected text.
    *  
    *
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void setBold ( ) {

      /* If the selected text is null, handle things carefully */
      /* because the word processor will auto select some words. We
         need to deselect those words. */
      if ( wordProc.getSelectedText() == null ) {
         lotus.wp.ifx.Position endPosition = null ;

         /* First, get the current text selection object  */
         getCurSelectedText() ;

         /* Get the start position */
         endPosition = curSelectedText.getEndPosition() ;

         /* Set the bold param */
         curSelectedText.setBold ( !isBold ) ;

         /* Adjust the start position to the end position */
         endPosition.gotoPosition ( curSelectedText.getStartPosition() ) ;
      }

      /* Otherwise, just set the bold */
      else if ( getCurSelectedText() ) {
         lotus.wp.ifx.Position startPosition = curSelectedText.getStartPosition() ;
         lotus.wp.ifx.Position endPosition   = curSelectedText.getEndPosition() ;

         curSelectedText.setBold ( !curSelectedText.getBold() ) ;

         wordProc.createTextElement ( startPosition, endPosition ) ;
      }

   } /* setBold */


   /*------------------------------------------------------------*/
   /* setUnderline
    */
   /**
    *    This method will toggle the bold attribute of the currently
    *  selected text.
    *  
    *
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void setUnderline ( ) {

      /* If the selected text is null, handle things carefully */
      /* because the word processor will auto select some words. We
         need to deselect those words. */
      if ( wordProc.getSelectedText() == null ) {
         lotus.wp.ifx.Position endPosition = null ;

         /* First, get the current text selection object  */
         getCurSelectedText() ;

         /* Get the start position */
         endPosition = curSelectedText.getEndPosition() ;

         /* Set the bold param */
         curSelectedText.setUnderline ( false ) ;

         /* Adjust the start position to the end position */
         endPosition.gotoPosition ( curSelectedText.getStartPosition() ) ;
      }

      /* Otherwise, just set the bold */
      else {
         getCurSelectedText() ;
         curSelectedText.setUnderline ( false ) ;
      }

      wordProc.requestFocus() ;

   } /* setUnderline */


   /*------------------------------------------------------------*/
   /* setStrikethrough
    */
   /**
    *    This method will toggle the bold attribute of the currently
    *  selected text.
    *  
    *
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void setStrikethrough ( ) {

      /* If the selected text is null, handle things carefully */
      /* because the word processor will auto select some words. We
         need to deselect those words. */
      if ( wordProc.getSelectedText() == null ) {
         lotus.wp.ifx.Position endPosition = null ;

         /* First, get the current text selection object  */
         getCurSelectedText() ;

         /* Get the start position */
         endPosition = curSelectedText.getEndPosition() ;

         /* Set the bold param */
         curSelectedText.setStrikethrough ( !isStriked ) ;

         /* Adjust the start position to the end position */
         endPosition.gotoPosition ( curSelectedText.getStartPosition() ) ;
      }

      /* Otherwise, just set the bold */
      else if ( getCurSelectedText() ) {
         lotus.wp.ifx.Position startPosition = curSelectedText.getStartPosition() ;
         lotus.wp.ifx.Position endPosition   = curSelectedText.getEndPosition() ;

         curSelectedText.setStrikethrough ( !curSelectedText.getStrikethrough() ) ;

         wordProc.createTextElement ( startPosition, endPosition ) ;
      }

      wordProc.requestFocus() ;

   } /* setStrikethrough */

   /*------------------------------------------------------------*/
   /* setItalic
    */
   /**
    *    This method will toggle the bold attribute of the currently
    *  selected text.
    *  
    *
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void setItalic ( ) {

      /* If the selected text is null, handle things carefully */
      /* because the word processor will auto select some words. We
         need to deselect those words. */
      if ( wordProc.getSelectedText() == null ) {
         lotus.wp.ifx.Position endPosition = null ;

         /* First, get the current text selection object  */
         getCurSelectedText() ;

         /* Get the start position */
         endPosition = curSelectedText.getEndPosition() ;

         /* Set the bold param */
         curSelectedText.setItalic ( !isItalic ) ;

         /* Adjust the start position to the end position */
         endPosition.gotoPosition ( curSelectedText.getStartPosition() ) ;
      }

      /* Otherwise, just set the bold */
      else if ( getCurSelectedText() ) {
         lotus.wp.ifx.Position startPosition = curSelectedText.getStartPosition() ;
         lotus.wp.ifx.Position endPosition   = curSelectedText.getEndPosition() ;

         curSelectedText.setItalic ( !curSelectedText.getItalic() ) ;

         wordProc.createTextElement ( startPosition, endPosition ) ;
      }

      wordProc.requestFocus() ;

   } /* setItalic */





   /*------------------------------------------------------------*/
   /* keyPressed
    */
   /**
    *    This method will process KeyPressed
    *  events sent to us from our panels
    *  
    *
    *  @param e The KeyEvent
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void keyPressed ( KeyEvent e ) {

      changed = true ;
      if ( processKey ) {

         switch ( e.getKeyCode() ) {
            

            case KeyEvent.VK_B :
               if ( e.isControlDown() )
                  setBold() ;
               break ;

            case KeyEvent.VK_I :
               if ( e.isControlDown() )
                  setItalic() ;
               break ;

            case KeyEvent.VK_U :
               //if ( e.isControlDown() )
               //   setUnderline() ;
               break ;

            case KeyEvent.VK_S :
               if ( e.isControlDown() )
                  setStrikethrough() ;
               break ;

               /* Override Control-C to Copy */
            case KeyEvent.VK_C :
               if ( e.isControlDown() )
                  wordProc.copy() ;
               break ;

               /* Override Control-V to Paste */
            case KeyEvent.VK_V :
               if ( e.isControlDown() )
                  wordProc.paste() ;
               break ;

            case KeyEvent.VK_INSERT :
               if ( e.isShiftDown() )
                  wordProc.paste() ;
               else if ( e.isControlDown() ) {
                  wordProc.copy() ;
               }
               break ;

            case KeyEvent.VK_DELETE :
               if ( e.isShiftDown() )
                  wordProc.cut() ;
               break ;

               /* Override Control-X to delete */
            case  KeyEvent.VK_X :
               if ( e.isControlDown() )
                  wordProc.cut() ;
               break ;

            case KeyEvent.VK_A :
               if ( e.isControlDown() )
                  selectAll() ;
               break ;

         } /* switch */

         /* Do not process the next one */
         processKey = false ;

      }

      /* Process the next key */
      else
         processKey = true ;

   } /* keyPressed */


   /*------------------------------------------------------------*/
   /* refreshData
    */
   /**
    *    This method will kil the current data that
    *  is in the word processor and set it's contents
    *  to the doc recs additional info or body field.
    *
    *  @param document The doc rec to get data from
    *  @param id The id of the field to use
    *  @param threadName The name of the thread to kick off to set the content
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void refreshData ( DocumentDraft document, int fieldId, String threadName ) {

      setDefaultTitle () ;

      if ( fieldId == Document.BODY ) {
         DocumentBody body = document.getDocumentBody() ;

         if ( body != null )
            autoSaveContent = body.getBody() ;
      }

      else if ( fieldId == Document.ADDITIONAL_INFO )
         autoSaveContent = document.getAdditionalInfo() ;

      new Thread ( this, threadName ).start() ;

      requestFocus() ;
      toFront() ;
   }


   /*------------------------------------------------------------*/
   /* refreshData
    */
   /**
    *    This method will kill the current data that is
    *  in the word processor, and set it's contents
    *  to the DocRec's additional Info or Body field passed.
    *
    *  @param htmlText The HTML Text to use
    *  @param fieldId  The id of the field to edit
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void refreshData ( DocumentDraft document, int fieldId ) {
      refreshData ( document, fieldId, THREAD_SETCONTENT ) ;
   }





   /*------------------------------------------------------------*/
   /* createWordProcessor
    */
   /**
    *    This method will create our word processor
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void createWordProcessor () {
      LogSystem.log ( 1, "Creating Word Processor" ) ;
      wordProc = new WordProcessorBean() ;
      WordProcUtil.addKeyListeners ( this, wordProc ) ;
      setPageLayout() ;
      LogSystem.log ( 1, "Stopped Creating Word Processor" ) ;
   }


   /*------------------------------------------------------------*/
   /* selectAll
    */
   /**
    *    This method will select all of the document
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void selectAll () {
      wordProc.gotoBeginningOfDocument ( false ) ;
      wordProc.gotoEndOfDocument ( true ) ;
   }





   /*------------------------------------------------------------*/
   /* setPreviewMode
    */
   /**
    *    This method will set our preview mode
    *  on or off
    *  
    *
    *  @param previewMode TRUE = turn on, FALSE = turn off
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void setPreviewMode ( boolean previewMode ) {
      this.inPreviewMode = previewMode ;

      if ( previewMode ) {
         String previewStr = null ;

         if ( !editingTags )
            previewStr = WordProcUtil.createHTML ( wordProc, document ) ;
         else
            previewStr = mle_EDITTAGS.getText() ;

         //WPHTMLGenerator.generateHTML(wordProc, this ) );

         if ( previewStr != null ) {

            ((CardLayout)cardPanel.getLayout()).show ( cardPanel, "pnl_PREVIEW" ) ;
            pnl_PREVIEW.setPageContent ( previewStr ) ;
            pb_PREVIEW.setText ( Str.getStr ( STR_EDIT ) ) ;
         }
      } else {
         if ( !editingTags )
            ((CardLayout)cardPanel.getLayout()).show ( cardPanel, "wordProc" ) ;
         else
            ((CardLayout)cardPanel.getLayout()).show ( cardPanel, "mle_EDITTAGS" ) ;

         pb_PREVIEW.setText ( Str.getStr ( STR_PREVIEW ) ) ;
      }

      if ( !previewMode ) {
         if ( !editingTags ) {
            wordProc.gotoBeginningOfDocument(false) ;
            wordProc.requestFocus() ;
         }
      }
   }


   /*------------------------------------------------------------*/
   /* clearDocument
    */
   /**
    *    This method will clear the document contents
    *  in the word processor
    *  
    *
    *  @param inThread TRUE = Clear the contents in a thread, FALSE if not
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void clearDocument ( boolean inThread ) {
      WordProcUtil.setDocContent ( wordProc, document, "<font name=\"Helvetica\" size=14> </font>" ) ;
      setPageLayout() ;
   }


   /*------------------------------------------------------------*/
   /* importHTML
    */
   /**
    *    This method will allow the user to import an
    *  HTML file into the word processor. It will
    *  strip out tags that refer to font, applets, javascript etc..
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void importHTML () {
      StatusWin statusWin = null ;

      try {
         File[]       openFile = GUISystem.getFileOpen ( this, 
                                                         Str.getStr ( STR_IMPORT_HTML ), 
                                                         PropertySystem.getString ( PropertySystem.PROPERTY_IMPORT_HTML_DIR ) ) ;
         String       filename = null ;
         String       dir      = null ;
         String       htmlFile = null ;


         if ( ( openFile != null ) && ( openFile[0] != null ) && ( openFile[1] != null ) ) {

            try {

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   Put up our status                                       */
               /*                                                           */
               /*-----------------------------------------------------------*/
               statusWin = new StatusWin ( this ) ;
               statusWin.setText ( Str.getStr ( STR_IMPORTING_HTML ) ) ;

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   Load the file into a string                             */
               /*                                                           */
               /*-----------------------------------------------------------*/
               htmlFile = FileUtil.readFile ( openFile[0].getAbsolutePath() ) ;                                    

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   Set our INI value for the next time they import         */
               /*                                                           */
               /*-----------------------------------------------------------*/
               PropertySystem.putString ( PropertySystem.PROPERTY_IMPORT_HTML_DIR, htmlFile ) ;

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   If we got a file, save it to the temp dir.              */
               /*                                                           */
               /*-----------------------------------------------------------*/
               if ( htmlFile != null ) {
                  String saveFilename = PropertySystem.getString ( PropertySystem.PROPERTY_TEMP_DIR )+File.separator+"tmp.html" ;  

                  /*-----------------------------------------------------------*/
                  /*                                                           */
                  /*   Put in a couple of spaces so after the import they can  */
                  /* type.                                                     */
                  /*                                                           */
                  /*-----------------------------------------------------------*/
                  FileUtil.saveFile ( saveFilename, "<p><font face=\"Helvetica, Arial\" size=3></p><p><font face=\"Helvetica, Arial\" size=3></p>" ) ;
                  wordProc.insertDocument ( "FILE:/"+saveFilename ) ;    

                  /*-----------------------------------------------------------*/
                  /*                                                           */
                  /*   Insert the HTML                                         */
                  /*                                                           */
                  /*-----------------------------------------------------------*/
                  FileUtil.saveFile ( saveFilename, htmlFile ) ;
                  wordProc.insertDocument ( "FILE:/"+saveFilename ) ;

               } /* if htmlFile */

            } catch ( java.io.FileNotFoundException ex ) {
            }

         }

      } catch ( Exception e ) {
         LogSystem.log ( 1, e ) ;
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Close our status window                                 */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( statusWin != null )
         statusWin.dispose() ;

   }




   /*------------------------------------------------------------*/
   /* cleanHTMLImportFile
    */
   /**
    *    This method will clean our tags from an
    *  imported HTML File.
    *  
    *
    *  @param htmlString The html string to clean
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private String cleanHTMLImportFile ( String HTMLString ) {
      HTMLParse htmlParse          = null ;
      HTMLTag   tagRec             = null ;
      String    tagStr             = null ;
      int       i                  = 0 ;

      /* First, add a new line character to certain tags */
      htmlParse = new HTMLParse ( HTMLString ) ;

      while ( i < htmlParse.tagCount() ) {

         tagStr = htmlParse.getTag(i) ;
         if ( tagStr != null ) {

            tagStr = tagStr.toUpperCase() ;

            /*-----------------------------------------------------------*/
            /*                                                           */
            /*   Kill these tags                                         */
            /*                                                           */
            /*-----------------------------------------------------------*/
            if ( ( tagStr.indexOf ( "STYLE" ) >= 0 ) ||
                 ( tagStr.indexOf ( "FONT" ) >= 0 ) ||
                 ( tagStr.indexOf ( "APPLET" ) >= 0 ) ||
                 ( tagStr.indexOf ( "PARAM" ) >= 0 ) ||
                 ( tagStr.indexOf ( "HREF" ) >= 0 ) ||
                 ( tagStr.indexOf ( "FRAME" ) >= 0 ) ||
                 ( tagStr.indexOf ( "H1" ) >= 0 ) || 
                 ( tagStr.indexOf ( "H2" ) >= 0 ) ||
                 ( tagStr.indexOf ( "H3" ) >= 0 ) ||
                 ( tagStr.indexOf ( "H4" ) >= 0 ) ||
                 ( tagStr.indexOf ( "H5" ) >= 0 ) ||
                 ( tagStr.indexOf ( "H6" ) >= 0 ) ||
                 ( tagStr.indexOf ( "IMG" ) >= 0 ) ||
                 ( tagStr.indexOf ( "MAILTO" ) >= 0 ) ||
                 ( tagStr.indexOf ( "!" ) >= 0 ) ||
                 ( tagStr.indexOf ( "META" ) >= 0 ) ||
                 ( tagStr.indexOf ( "FORM" ) >= 0 ) ||
                 ( tagStr.indexOf ( "SCRIPT" ) >= 0 ) ||
                 ( tagStr.indexOf ( "COMMENT" ) >= 0 ) ||
                 ( tagStr.indexOf ( "CLEAR" ) >= 0 ) ||
                 ( tagStr.indexOf ( "HTML" ) >= 0 ) ||
                 ( tagStr.indexOf ( "ARCHIVE" ) >= 0 ) ||
                 ( tagStr.indexOf ( "HEAD" ) >= 0 ) ) {
               htmlParse.removeTag ( i ) ;
            } else if ( tagStr.indexOf ( "BGCOLOR" ) >= 0 ) {
               tagStr = Text.replaceInStr ( tagStr, "BGCOLOR", "" ) ;
               htmlParse.replaceTag ( i, tagStr ) ;
            }

            else if ( tagStr.indexOf ( "COLOR" ) >= 0 ) {
               htmlParse.removeTag(i) ;
            }

            //else if ( tagStr.indexOf ( "<TABLE" ) >= 0 ) {
            //   htmlParse.replaceTag ( i, "<TABLE NAME=\"Table."+i+"\">" ) ;
            //}
         } /* if */
         i++ ;

      }/* while */
      HTMLString = htmlParse.getHTMLString() ;

      return( HTMLString ) ;

   } /* cleanHTMLImportFile */

   /*------------------------------------------------------------*/
   /* importGraphic
    */
   /**
    *    This method will import an external graphic
    *  into the word processor
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void importGraphic() {
      try {
         File[] openFile = GUISystem.getFileOpen ( this, Str.getStr ( STR_IMPORT_GRAPHIC ), 
                                                   PropertySystem.getString ( PropertySystem.PROPERTY_IMPORT_GRAPHIC_DIR ) ) ;
         String filename = null ;
         String dir      = null ;

         if ( ( openFile != null ) && ( openFile[0] != null ) && ( openFile[1] != null ) ) {

            filename = openFile[0].getName() ;
            dir      = openFile[1].getAbsolutePath() ;

            if ( ( filename != null ) && ( dir != null ) ) {

               if ( filename.indexOf ( " " ) == -1 ) {
                  if ( filename.length() > LENGTH_GRAPHICNAME )
                     GUISystem.printBox ( this, STR_INFO, STR_GRAPHIC_NAME_TOO_LONG ) ;
                  else {
                     PropertySystem.putString ( PropertySystem.PROPERTY_IMPORT_GRAPHIC_DIR, dir ) ;
                     if ( ( filename.endsWith ( "JPG" ) ) || ( filename.endsWith ( "GIF" ) ) ||
                          ( filename.endsWith ( "jpg" ) ) || ( filename.endsWith ( "gif" ) ) ) {
                        String newGraphicName = null ;

                        newGraphicName = document.getExistingDocInd()+"_"+filename ;

                        if ( QuestUtil.copyFileToTempDir ( dir+File.separator+filename, newGraphicName ) )
                           wordProc.insertImage ( newGraphicName, "FILE:/"+PropertySystem.getString ( PropertySystem.PROPERTY_TEMP_DIR )+File.separator+newGraphicName ) ;
                        else
                           GUISystem.printBox ( this, STR_INFO, STR_CANNOT_COPY_GRAPHIC_TO_TEMP ) ;

                     } else
                        GUISystem.printBox ( this, STR_INFO, STR_ONLY_GIF_OR_JPG ) ;
                  }
               } else
                  GUISystem.printBox ( this, STR_INFO, STR_GRAPHIC_CANNOT_HAVE_SPACES_IN_NAME ) ;
            }
         }
      } catch ( Exception e ) {
         LogSystem.log ( 1, e ) ;
      }
   }



   /*------------------------------------------------------------*/
   /* createOrderedList
    */
   /**
    *    This method will create an ordered list
    *  in the word processor
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void createOrderedList () {
      ParagraphStyle oldParagraphStyle = null ;

      if ( getCurSelectedText() ) {
         curSelectedText = wordProc.findSelectedTextElement() ;
         oldParagraphStyle = curSelectedText.getParagraphStyle() ;

         if ( ( !oldParagraphStyle.getLeaderType().equals ( "numeric" ) ) ) {
            ParagraphStyle numericStyle = wordProc.createParagraphStyle ( "Ordered List ("+System.currentTimeMillis()+")", "OLLI" ) ;

            numericStyle.setLeaderType ( "numeric" ) ;
            numericStyle.setNumberFormat ( "decimal" ) ;
            numericStyle.setSpaceAfter ( 5 ) ;
            numericStyle.setFontName ( "Helvetica" ) ;
            numericStyle.setFontSize ( 12 ) ;
            curSelectedText.setParagraphStyle ( numericStyle ) ;
            wordProc.gotoEndOfParagraph(false) ;
         } else {
            wordProc.gotoEndOfParagraph(false) ;
            curSelectedText = wordProc.findSelectedTextElement() ;
            curSelectedText.setParagraphStyle ( oldParagraphStyle = wordProc.findParagraphStyle ( "Body" ) ) ; //oldParagraphStyle = wordProc.createParagraphStyle ( "p"+System.currentTimeMillis(), "P" ) ) ;
            oldParagraphStyle.setFontName ( "Helvetica" ) ;
            oldParagraphStyle.setFontSize ( 12 ) ;
            //wordProc.insertLineBreak() ;
         }
      }
      //wordProc.findSelectedTextElement().setParagraphStyle(wordProc.findParagraphStyle("ULLI"));
   } /* createOrderedList */

   /*------------------------------------------------------------*/
   /* createBulletList
    */
   /**
    *    This method will create a bullet list in
    *  the word processor
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void createBulletList () {
      ParagraphStyle oldParagraphStyle = null ;

      if ( getCurSelectedText() ) {
         curSelectedText = wordProc.findSelectedTextElement() ;
         oldParagraphStyle = curSelectedText.getParagraphStyle() ;

         if ( ( !oldParagraphStyle.getLeaderType().equals ( "bullet" ) ) ) {
            ParagraphStyle paragraphStyle = wordProc.createParagraphStyle ( "Bullet List ("+System.currentTimeMillis()+")", "ULLI" ) ;

            paragraphStyle.setLeaderType ( "bullet" ) ;
            paragraphStyle.setBulletCharacter ( (char) 0x25cf ) ;
            paragraphStyle.setSpaceAfter ( -1 ) ;
            paragraphStyle.setFontName ( "Helvetica" ) ;
            paragraphStyle.setFontSize ( 12 ) ;
            curSelectedText.setParagraphStyle ( paragraphStyle ) ;
            wordProc.gotoEndOfParagraph(false) ;

         } else {
            wordProc.gotoEndOfParagraph(false) ;
            curSelectedText = wordProc.findSelectedTextElement() ;
            curSelectedText.setParagraphStyle ( oldParagraphStyle = wordProc.findParagraphStyle ( "Body" ) ) ; //oldParagraphStyle = wordProc.createParagraphStyle ( "p"+System.currentTimeMillis(), "P" ) ) ;
            oldParagraphStyle.setFontName ( "Helvetica" ) ;
            oldParagraphStyle.setFontSize ( 12 ) ;
            //wordProc.insertLineBreak() ;
         }
      }
   }



   /*-----------------------------------------------------------*/
   /* stdDialogClosed
    */
   /**
    *    This method will respond to dialogs we are 
    *  listening to
    *  
    *             
    *  @param id The ID of the dialog
    *  @param data The user data passed back from the dialog
    *  @param 
    *
    *  @return 
    */
   public void selectDocComplete ( Vector vec ) {
      boolean requestFocus = true ;

      if ( vec != null ) {
         DocumentRow lDocRec = (DocumentRow) vec.elementAt(0) ;

         createDocLink ( lDocRec ) ;

      } /* if */

      if ( requestFocus )
         wordProc.requestFocus() ;

   } /* stdDialogClosed */


   /*-----------------------------------------------------------*/
   /* createDocLink
    */
   /**
    *    This method will create a doc link in the
    *  word processor as an html link. If the document
    *  passed in does not have a lotus notes id, the doc link is not created
    *             
    *  @param document The DocRec to link
    *  @param 
    *  @param 
    *
    *  @return 
    */
   public void createDocLink ( DocumentRow document ) {

      if ( document != null ) {

         if ( document.isDraft() )
            GUISystem.printBox ( this, STR_ERROR, STR_CANNOT_LINK_TO_REQUEST ) ;
         else if ( ( document.getFilename() == null ) || 
                   ( document.getFilename().length() == 0 ) )
            GUISystem.printBox ( this, STR_ERROR, STR_CANNOT_LINK_WITH_NO_ID ) ;
         else {
            String selection     = wordProc.getSelectedText() ;
            Vector documentLinks = this.document.getDocumentLinks() ;

            /* Add this to the list of links */
            if ( documentLinks == null )
               documentLinks = new Vector ( 1, 1 ) ;
            documentLinks.addElement ( new DocumentLink ( this.document.getDocInd(),
                                                          document.getDocumentInd(),
                                                          document.getTitle() ) ) ;
            this.document.setDocumentLinks ( documentLinks ) ;

            if ( selection != null ) {
               wordProc.insertLink ( "l"+DateSystem.getDate ( com.ibm.nzna.shared.util.CDate.DATE_STAMP ), 
                                     document.getFilename()+".html" ) ;
            } else {
               try {
                  String tempDir  = PropertySystem.getString ( PropertySystem.PROPERTY_TEMP_DIR ) ;
                  String filename = tempDir+File.separator+"tmp.html" ;
                  String str      = null ;

                  /* Copy over the graphic to the temp dir  */
                  QuestUtil.copyFileToTempDir ( tempDir+File.separator+"doclink.gif" ) ;

                  /* Write the html for lotus, since they can't seem to do it correctly */
                  str =     "<a href=\""+document.getFilename()+".html\">" ;
                  str = str+"<img src=\""+tempDir+"doclink.gif\" WIDTH=\"13\" HEIGHT=\"16\">" ;
                  str = str+"</a>" ;

                  /* Write the file and close it up */
                  FileUtil.saveFile ( filename, str ) ;

                  /* Now, insert the temp file */
                  wordProc.insertDocument ( "FILE:"+filename ) ;

                  /* Add the doc link graphic */
                  wordProc.gotoNextCharacter ( false ) ;
               } catch ( Exception e ) {
                  LogSystem.log ( 1, e ) ;
               }
            }
         }
      }
   }



   /*------------------------------------------------------------*/
   /* find
    */
   /**
    *    This method will find the prevFindStr
    *  text in the text of the document
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean find () {


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   If we are not editing tags, search the WP               */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( !editingTags ) {
         SearchOptions searchOpt = wordProc.getSearchOptions() ;

         curSelectedText = wordProc.findSelectedTextElement() ;
         if ( ( searchOpt != null ) && ( curSelectedText != null ) ) {
            searchOpt.setExactMatch ( true ) ;
            if ( curSelectedText.gotoText ( prevFindString, searchOpt ) ) {
               wordProc.gotoEndOfWord ( true ) ;
               wordProc.gotoBeginningOfWord ( true ) ;
            }
         }
      }


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Otherwise, search the editor                            */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else {
         String text  = mle_EDITTAGS.getText() ;
         int    start = mle_EDITTAGS.getSelectionEnd() ;
         int    found = text.indexOf ( prevFindString, start ) ;

         if ( found >= 0 ) {
            mle_EDITTAGS.setSelectionStart ( found ) ;
            mle_EDITTAGS.setSelectionEnd ( found+prevFindString.length() ) ;
         }




      }
      return( true ) ;
   }


   /*-----------------------------------------------------------*/
   /* spellCheck
    */
   /**
    *    This method will spell check the document
    *  
    *  
    *             
    *  @param 
    *  @param 
    *  @param 
    *
    *  @return 
    */
   private boolean spellCheck ( boolean displayMsg ) {
      JSpellToolkit   spellToolkit = spellToolkit = new SpellChecker().getToolkit() ;
      JSpellErrorInfo errorInfo    = null ;
      String          text         = wordProc.getDocumentContents() ;
      int             missCount    = 0 ;
      SpellCheckDlg   spellDlg     = null ;
      int             wordCount    = wordProc.getWordCount() ;
      int             startIndex   = 0 ;
      boolean         forceStop    = false ;

      try {

         /* Position the cursor at the top of the document */
         wordProc.gotoBeginningOfDocument ( false ) ;

         /* Initialize the spell checker's rawCheck */
         spellToolkit.initRawCheck ( text ) ;

         /* Execute a raw check of the contents */
         errorInfo = spellToolkit.rawCheck() ;

         /* If we have the first mis-spelled word, present it */
         if ( errorInfo != null ) {
            boolean cont = true ;
            int     i    = 0 ;

            /* Create our spell checker dialog */
            spellDlg = new SpellCheckDlg ( this, errorInfo ) ;

            while ( ( i < wordCount ) && ( cont ) && ( errorInfo != null ) ) {

               /* They misspelled a word, update our counter */
               missCount++ ;

               /* Set the prevFindString because find will use it to highlight the word! */
               prevFindString = errorInfo.getWord() ;
               find() ;

               /* Set up the startIndex variable. We will use
                  this the next time we do a raw check. We will
                  use this in a call to substring so that every
                  time we go through this loop, the raw check will
                  have a smaller and smaller set of text to go through */
               startIndex = text.indexOf ( prevFindString ) ;
               if ( startIndex != -1 ) {
                  startIndex+=prevFindString.length() ;

                  /* Get what the user wants to do with
                     the word */
                  /* Create our spell checker dialog */
                  //spellDlg = new SpellCheckDlg ( this, errorInfo ) ;
                  errorInfo = spellDlg.getErrorInfo(errorInfo) ;

                  /* Replace the word that is wrong */
                  if ( errorInfo != null ) {
                     if ( errorInfo.buttonHit == SpellCheckDlg.PB_REPLACE ) {
                        setSelectedText ( errorInfo.getWord() ) ;
                     } else if ( errorInfo.buttonHit == SpellCheckDlg.PB_STOP ) {
                        cont = false ;
                        forceStop = true ;
                     }
                  }

                  if ( cont ) {

                     /* Clear the selection */
                     try {
                        wordProc.gotoNextWord ( false ) ;
                     } catch ( ArrayIndexOutOfBoundsException ex ) {
                     }

                     /* Get the next word  */
                     errorInfo = spellToolkit.rawCheck() ;
                  }
               } else
                  cont = false ;

               i++ ;
            }

         } /* if */

         /* Close the dialog window if we opened it */
         if ( spellDlg != null )
            spellDlg.dispose() ;

         /* Tell the user if they did a good job or not */
         if ( ( !forceStop ) && ( displayMsg ) ) {
            if ( missCount == 0 )
               GUISystem.printBox ( this, 
                                Str.getStr ( STR_INFO ), 
                                "No Misspelled Words" ) ;
            else
               GUISystem.printBox ( this, 
                                Str.getStr ( STR_INFO ), 
                                Str.getStr ( STR_SPELL_CHECK_COMPLETE ) ) ;
         }
      } catch ( Exception e ) {
      }

      return( true ) ;

   }

   /*------------------------------------------------------------*/
   /* setSelectedText
    */
   /**
    *    This method will set the text that is currently
    *  selected in the word processor
    *  
    *
    *  @param text The new text to set to
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void setSelectedText ( String text ) {
      curSelectedText = wordProc.findSelectedTextElement() ;
      if ( curSelectedText != null )
         curSelectedText.setText ( text ) ;
   } /* setSelectedText */


   /*------------------------------------------------------------*/
   /* saveContent
    */
   /**
    *    This method will save the contents of the
    *  word processor into the correct fields of the DocRec, or
    *  if there is no DocRec, to the WordProcRec.
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean saveContent () {
      boolean rc              = false ;
      String  saveFileContent = null ;

      currentlySaving = true ;
      try {

         /* First, spell check the document if we should  */
         //if ( QuestINI.getINIBooleanValue ( Str.INI_AUTOSPELL, true ) ) {
         //    //SystemData.initSpellCheck() ;
         //    spellCheck ( false ) ;
         //    st_STATUS.setStatus ( Str.getStr ( STR_SAVING ), true ) ;
         //}

         /* If we have a document, process it */
         if ( document != null ) {

            /* Save the html */
            //saveFileContent = WordProcUtil.prepareHTMLForSave ( wordProc, document, null ) ;
            //saveFileContent = WordProcUtil.createHTML ( wordProc, document ) ;
            if ( !editingTags )
               saveFileContent = WordProcUtil.createHTML ( wordProc, document ) ;
            else {
               saveFileContent = mle_EDITTAGS.getText() ;

               if ( saveFileContent.indexOf ( "QuestInput" ) == -1 )
                  saveFileContent+="<META NAME=Generator CONTENT=QuestInput>" ;
            }

            //WPHTMLGenerator.generateHTML ( wordProc, this ) ;
            WordProcUtil.assembleGraphics ( wordProc, document ) ;
            WordProcUtil.assembleDocLinks ( wordProc, document, saveFileContent ) ;


            if ( saveFileContent != null ) {
               if ( fieldId == Document.ADDITIONAL_INFO )
                  document.setAdditionalInfo ( saveFileContent ) ;
               else if ( fieldId == Document.BODY ) {
                  DocumentBody body = new DocumentBody ( saveFileContent ) ;

                  document.setDocumentBody ( body ) ;
               }
               rc = true ;
            }

         }


      } catch ( Exception e ) {
         LogSystem.log ( 1, e ) ;
      }


      changed = false ;
      currentlySaving = false ;
      return( rc ) ;
   } /* saveContent */





   /*------------------------------------------------------------*/
   /* processAutoSave
    */
   /**
    *    This method will continually loop until the
    *  continueAutoSave flag is false auto saving the content of the
    *  word processor. It will wait for 2 minutes between each auto save
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void processAutoSave () {

      continueAutoSave = true ;

      try {
         while ( continueAutoSave ) {
            Thread.currentThread().sleep ( 120000 ) ;

            autoSaveContent = wordProc.getDocumentContentsAsHTML() ;
         }
      } catch ( Exception e ) {
      }
   }





   /*------------------------------------------------------------*/
   /* enableApp
    */
   /**
    *    This method will either enable or disable
    *  user functions in the window
    *  
    *
    *  @param enable TRUE = enable, allowing user intervention, FALSE = disable
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void enableApp ( boolean enable ) {
      if ( toolBar != null )
         toolBar.setEnabled ( enable ) ;
      if ( wordProc != null )
         wordProc.setEnabled ( enable ) ;
      if ( actionBar != null )
         actionBar.setEnabled ( enable ) ;
      this.enabled = enable ;
   }


   /*------------------------------------------------------------*/
   /* copy
    */
   /**
    *    This method will copy our current document
    *  to the internal clipboard
    *  
    *
    *  @param clipType The type of clipboard
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean copy ( int clipType ) {
      boolean rc = false ;

      //VOY if ( clipType == CLIPTYPE_DOCUMENT )
      //VOY     SystemData.addToInternalClipboard ( CLIPTYPE_DOCUMENT, document ) ;

      return( rc ) ;
   }

   /*-----------------------------------------------------------*/
   /* paste
    */
   /**
    *    This method will paste an internal item into
    *  the word processor. The action depends on
    *  what type of item it is. For a Document, a Doc Link is created. For a Product, only the product number is pasted in
    *             
    *  @param clipType
    *  @param 
    *  @param 
    *
    *  @return 
    */
   public boolean paste ( int clipType ) {
      //VOY ClipboardItem clipItem = SystemData.getInternalClipboardItem ( clipType ) ;
      //VOY boolean       rc       = false ;

      //VOY if ( clipItem != null ) {

      //VOY     if ( clipType == CLIPTYPE_DOCUMENT ) {
      //VOY         createDocLink ( (DocRec) clipItem.getClipData() ) ;
      //VOY         rc = true ;
      //VOY     } else if ( clipType == CLIPTYPE_PRODUCT ) {
      //VOY         ProductRec prodRec = (ProductRec) clipItem.getClipData() ;

      //VOY         if ( prodRec != null )
      //VOY             wordProc.insertText ( (String) prodRec.getFieldData ( PRODFIELD_PRODUCTNUMBER ) ) ;
      //VOY         rc = true ;
      //VOY     }
      //VOY }
      return( false ) ;
   }




   /*------------------------------------------------------------*/
   /* paste
    */
   /**
    *    This method does a simple paste
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean paste () {
      wordProc.paste() ;
      return( true ) ;
   }




   /*------------------------------------------------------------*/
   /* checkClose
    */
   /**
    *    This method will check to see if we
    *  have made any changes, if we haven't, this
    *  method will close the panel
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void checkClose () {
      if ( changed ) {

         /* If the user answered 'Yes' to 'Do you wish to save', then save! */
         if ( GUISystem.printBox ( this, STR_QUESTION, STR_DO_YOU_WISH_TO_SAVE ) )
            new Thread ( this, THREAD_SAVECONTENTANDEXIT ).start() ;
         else
            windowClosing(null) ;
      } else
         windowClosing(null) ;
   }




   /*------------------------------------------------------------*/
   /* setDefaultTitle
    */
   /**
    *    This method will set our title to the default
    *  title which will be STR_WORDPROCESSOR - Doc Title
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void setDefaultTitle () {
      if ( ( document != null ) && ( document.getFilename() != null ) )
         setTitle ( Str.getStr ( STR_WORDPROCESSOR )+" - "+document.getFilename() ) ;
      else
         setTitle ( Str.getStr ( STR_WORDPROCESSOR ) ) ;
   }

   //public void mouseOverLinkExited(MouseOverLinkEvent e) {
   //}
   //public void mouseOverLinkEntered(MouseOverLinkEvent e ) {
   //}

   //public void mouseOverLinkMoved(MouseOverLinkEvent e) {}
   //public void mouseOverLinkClicked(MouseOverLinkEvent e) {}
   public void windowClosed ( WindowEvent e ) {
   }
   public void windowIconified ( WindowEvent e ) {
   }
   public void windowDeiconified ( WindowEvent e ) {
   }
   public void windowActivated ( WindowEvent e ) {
      try {
         if ( toolBar != null )
            toolBar.repaint() ;
         if ( actionBar != null )
            actionBar.repaint() ;
      } catch ( Exception ex ) {
      }
   }
   public void windowDeactivated ( WindowEvent e ) {
   }
   public void windowOpened ( WindowEvent e ) {
   }
   public void keyReleased ( KeyEvent e ) {
   }
   public void keyTyped ( KeyEvent e ) {
   }


   public void setStatus ( String status ) {
   }



   /*------------------------------------------------------------*/
   /* setPageLayout
    */
   /**
    *    This method will go through all of the 
    *  document pieces and makes them conform
    *  to the Quest standard
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void setPageLayout () {
      WPEnumeration wpEnum = wordProc.enumerateParagraphStyles() ;
      ParagraphStyle style = null ;

      /* Go through all of the paragraphs and set them to Helv
         if they are Times roman  */
      while ( wpEnum.hasMoreNames() ) {
         style = wordProc.findParagraphStyle ( wpEnum.nextName() ) ;

         if ( style.getFontName().indexOf ( "imes" ) >= 0 )
            style.setFontName ( "Helvetica" ) ;
      }

      style = wordProc.findParagraphStyle ( "Body" ) ;
      if ( style != null )
         style.setFontName ( "Helvetica" ) ;

      style = wordProc.findParagraphStyle ( "OLLI" ) ;
      if ( style != null )
         style.setFontName ( "Helvetica" ) ;

      style = wordProc.findParagraphStyle ( "ULLI" ) ;
      if ( style != null )
         style.setFontName ( "Helvetica" ) ;

   }




   /*------------------------------------------------------------*/
   /* HTMLGeneratorStatus
    */
   /**
    *    This method simply sets our status
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void HTMLGeneratorStatus ( String status ) {
      //st_STATUS.setStatus ( status, true ) ;
   }





   /*------------------------------------------------------------*/
   /* setContent
    */
   /**
    *    This method will massage the content
    *  of the body or additional info field and
    *  will set the content in the word processor
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void setContent () {
      String content = "" ;

      if ( fieldId == Document.BODY ) {
         DocumentBody body = document.getDocumentBody() ;

         if ( body != null )
            content = body.getBody() ;
      } else if ( fieldId == Document.ADDITIONAL_INFO )
         content = document.getAdditionalInfo() ;

      wordProc.setDocumentContentsAsHTML ( WordProcUtil.prepareHTMLForEdit ( document, 
                                                                             content ) ) ;
      setPageLayout() ;
   }




   /*------------------------------------------------------------*/
   /* setStatusValue
    */
   /**
    *    This method will set our status bar
    *  value
    *  
    *
    *  @param int value The new value
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setStatusValue ( int value ) {
      //st_STATUS.setStatusValue ( value ) ;
   }

   public void setStatusMax ( int max ) {
      //st_STATUS.setStatusMax ( max ) ;
   }

   public void setStatus ( int status ) {
      setStatus ( Str.getStr ( status ) ) ;
   }




   /*------------------------------------------------------------*/
   /* insertEditorComments
    */
   /**
    *    This method will make the currently selected
    *  text the editor's comments.
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void insertEditorComments () {
      if ( getCurSelectedText() ) {
         curSelectedText.setFontName  ( "Helvetica" ) ;
         curSelectedText.setTextColor ( new Color ( 0, 150, 0 ) ) ;
         curSelectedText.setFontSize  ( 14 ) ;
         wordProc.insertBookmark ( "EditorComments-"+System.currentTimeMillis() ) ;
      } else {
         String comment = new SingleEntryDlg ( this, 
                                               Str.getStr ( STR_EDITOR_COMMENTS ), 
                                               Str.getStr ( STR_EDITOR_COMMENTS ),
                                               "",
                                               new MaskDocument ( MaskDocument.MASKTYPE_UNKNOWN, 254 ) ).getResult() ;

         try {
            if ( comment != null ) {
               String fileName = PropertySystem.getString ( PropertySystem.PROPERTY_TEMP_DIR )+File.separator+"editorComments.html" ;
               FileUtil.saveFile ( fileName, "<a name=\"EditorComments ("+UserSystem.getUserName()+") -"+System.currentTimeMillis()+"\">"+
                                   "<font face=\"Helvetica\" size=3 color=\"green\">"+
                                   comment+
                                   "</font></a>" ) ;
               wordProc.insertDocument ( "FILE:/"+fileName ) ;
            }
         } catch ( Exception e ) {
            LogSystem.log ( 1, e ) ;
         }
      }
   }





   /*------------------------------------------------------------*/
   /* removeEditorComments
    */
   /**
    *    This method will remove all editor comments
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void removeEditorComments () {
      setStatus ( Str.getStr ( STR_REMOVING_EDITOR_COMMENTS ) ) ;

      try {
         String html = wordProc.getDocumentContentsAsHTML () ;

         if ( ( html != null ) && ( html.indexOf ( "EditorComments" ) >= 0 ) ) {
            int    startIndex  = 0 ;
            int    endIndex    = 0 ;
            String sub1        = "" ;
            String sub2        = "" ;
            String commentText = "" ;

            while ( html.indexOf ( "EditorComments", startIndex ) >= 0 ) {
               startIndex = html.indexOf ( "EditorComments", startIndex )-9 ;
               endIndex   = html.indexOf ( "</A>", startIndex )+4 ;
               sub1       = html.substring ( 0,        startIndex ) ;
               sub2       = html.substring ( endIndex, html.length() ) ;
               commentText = (html.substring(html.indexOf ( "\">", startIndex)+2, endIndex-4 ) ) ;                                    

               /*-----------------------------------------------------------*/
               /*                                                           */
               /*   Ask the user if they wish to delete the comment         */
               /*                                                           */
               /*-----------------------------------------------------------*/
               if ( GUISystem.printBox ( this, STR_QUESTION, STR_ARE_YOU_SURE_DELETE_EDITOR_COMMENTS ) )
                  html=sub1+sub2 ;

               startIndex+=19 ;
            }

            wordProc.setDocumentContentsAsHTML ( html ) ;

         }

      } catch ( Exception e ) {
         LogSystem.log ( 1, e ) ;
      }
      setStatus ( null ) ;
   }





   /*------------------------------------------------------------*/
   /* editTags
    */
   /**
    *    This method toggles the 'Edit Tags' mode. This
    *  mode allows the user to alter the actual HTML
    *  tags. If we are in edit tag mode, then the tags will be
    *  saved, and the WYSIWYG editor will be started. If we are
    *  in WYSIWYG mode, we will go into editing the tags
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void editTags ( boolean editTags ) {
      if ( editTags != editingTags ) {
         editingTags = editTags ;

         if ( editingTags ) {
            String saveFileContent = WordProcUtil.createHTML ( wordProc, document ) ;
            ((CardLayout)cardPanel.getLayout()).show ( cardPanel, "mle_EDITTAGS" ) ;

            pb_EDITTAGS.setText ( Str.getStr ( STR_EDIT_WYSIWYG ) ) ;
            if ( saveFileContent != null ) {
               mle_EDITTAGS.setText ( saveFileContent ) ;
            }

         } else {
            String content = mle_EDITTAGS.getText() ;

            pb_EDITTAGS.setText ( Str.getStr ( STR_EDITTAGS ) ) ;
            ((CardLayout)cardPanel.getLayout()).show ( cardPanel, "wordProc" ) ;
            wordProc.clear() ;

            /* Fix up a couple of things */
            content = WordProcUtil.prepareHTMLForEdit ( document, content ) ;
            wordProc.setDocumentContentsAsHTML ( content ) ;

         }

         cardPanel.setVisible ( false ) ;
         cardPanel.setVisible ( true ) ;
         toolBarPanel.setVisible ( false ) ;
         toolBarPanel.setVisible ( true ) ;
         actionBar.setVisible ( false ) ;
         actionBar.setVisible ( true ) ;
         toolBar.setVisible ( false ) ;
         toolBar.setVisible ( true ) ;
         fontBar.setVisible ( false ) ;
         fontBar.setVisible ( true ) ;
      }
   }





   /*------------------------------------------------------------*/
   /* isEditingDoc
    */
   /**
    *    This method will return TRUE if the
    *  document being edited is passed
    *  
    *
    *  @param document The document to check for
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public boolean isEditingDoc ( DocumentDraft document ) {
      return( this.document.getDocInd() == document.getDocInd() ) ;
   }








   /*------------------------------------------------------------*/
   /* stampGraphic
    */
   /**
    *    This method will be called when the user
    *  wishes to stamp a graphic into the document
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void stampGraphic ( String graphicName ) {
      try {
         if ( graphicName != null ) {
            String retStr  = DateSystem.getDate ( com.ibm.nzna.shared.util.CDate.DATE_STAMP ) ;
            String tempDir = PropertySystem.getString ( PropertySystem.PROPERTY_TEMP_DIR ) ;

            retStr = Text.replaceAllStrInStr (retStr, ".", "" ) ;
            retStr = Text.replaceAllStrInStr (retStr, "-", "" ) ;

            QuestUtil.copyFileToTempDir ( tempDir+File.separator+graphicName ) ;
            wordProc.insertImage ( graphicName+retStr, "FILE:"+tempDir+graphicName ) ;
         }
      } catch ( Exception e ) {
         LogSystem.log ( 1, e ) ;
      }
   }

} /* WordProcFrame */
