package com.ibm.nzna.projects.qit.workspace ;      
/*-----------------------------------------------------------*/
/*   DesktopPanel                                            */
/*                                                           */
/*   Description:                                            */
/*      Source code for: DesktopPanel                        */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import javax.swing.* ;
import java.awt.* ; 
/**
 * This panel holds all of the applet icons. It's main purpose
 * is to layout the icons from top left, to bottom right. Each
 * icon will be sized to a box of 60x60 regardless of the icons
 * actual preferred size.
 *
 *
 * @version 1.0, 1/29/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   DesktopPanel                                            */
/*                                                           */
/*-----------------------------------------------------------*/
public class DesktopPanel extends JPanel {



    /*-----------------------------------------------------------*/
    /*                                                           */
    /*   Static Members                                          */
    /*                                                           */
    /*-----------------------------------------------------------*/
    private static final int ICON_HEIGHT        = 60 ;
    private static final int ICON_WIDTH         = 110 ;      

    /*-----------------------------------------------------------*/
    /*                                                           */
    /*   Private Members                                         */
    /*                                                           */
    /*-----------------------------------------------------------*/
    private Dimension prefSize      = new Dimension ( (ICON_WIDTH+5)*4, 100 ) ;


    /*------------------------------------------------------------*/
    /* Constructor
     */
    /**
     *    Creates and initializes the panel
     *  
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public DesktopPanel () {         

        /*-----------------------------------------------------------*/
        /*                                                           */
        /*   Set our properties                                      */
        /*                                                           */
        /*-----------------------------------------------------------*/
        setBackground ( Color.white ) ;
        setLayout ( null ) ;
    }





    /*------------------------------------------------------------*/
    /* doLayout
     */
    /**
     *    This method will lay out and position
     *  all of the icons added to this panel
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void doLayout () {
        Dimension   size           = getSize() ;
        int         i              = 0 ;
        Component[] componentArray = getComponents() ;
        int         x              = 10 ;
        int         y              = 10 ;

        if ( componentArray != null ) {
            while ( i < componentArray.length ) {
                componentArray[i].setBounds ( x, y, ICON_WIDTH, ICON_HEIGHT ) ;
                x+=ICON_WIDTH+5 ;
                if ( (x+ICON_WIDTH+5) > size.width ) {
                    x=10 ;
                    y+=ICON_HEIGHT+5 ;
                }

                i++ ;
            }
            prefSize.height = y+ICON_HEIGHT ;
        }
    }






    /*------------------------------------------------------------*/
    /* getPreferredSize
     */
    /**
     *    This method will determine the preferred
     *  size of our panel
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public Dimension getPreferredSize() {
        Dimension   size           = getSize() ;
        int         i              = 0 ;
        Component[] componentArray = getComponents() ;
        int         x              = 0 ;
        int         y              = 0 ;

        if ( componentArray != null ) {
            int rows = 1 ;

            if ( componentArray.length > 10 )
                rows = componentArray.length/5 ;

            prefSize.height=rows*(ICON_HEIGHT+5) ;
        }

        return( prefSize ) ;
    }




    /*------------------------------------------------------------*/
    /* getMinimumSize
     */
    /**
     *    This method will return the minimum
     *  size of this panel
     *                                                          
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Dimension
     *//*---------------------------------------------------------*/
    public Dimension getMinimumSize () {
        return( getPreferredSize() );
    }

} /* DesktopPanel */
