package com.ibm.nzna.projects.qit.workspace ;              
/*-----------------------------------------------------------*/
/*   FirstAppletRunDlg                                       */
/*                                                           */
/*   Description:                                            */
/*      Source code for: FirstAppletRunDlg                   */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This dialog asks the user if they wish to always start 
 * a particular Quest Applet when Quest starts.
 *
 * @version 1.0, 3/8/2001 
 * @author  David Lentz
 */
import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.projects.qit.app.* ;


/*-----------------------------------------------------------*/
/*                                                           */
/*   FirstAppletRunDlg                                       */
/*                                                           */
/*-----------------------------------------------------------*/
public class FirstAppletRunDlg extends JDialog implements ActionListener, AppConst {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Return Codes                                            */
   /*                                                           */
   /*-----------------------------------------------------------*/
   public static final int YES         = 1 ;
   public static final int NO          = 2 ;
   public static final int NEVER       = 3 ;   

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   GUI Controls                                            */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private JLabel      output            = null ;
   private DButton     pb_YES            = null ;
   private DButton     pb_NO             = null ;
   private DButton     pb_NEVER          = null ;
   private ButtonPanel buttonPanel       = null ;


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Vars                                                    */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private int rc = 0 ;



   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will create but not show
    *  our window. Please call the 'getResult'
    *  method to show the window and wait for a repsonse
    *
    *  @param parent The parent frame
    *  @param name The name of the applet
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public FirstAppletRunDlg ( Frame parent, String name ) {
      super ( parent, Str.getStr ( STR_QUESTION ), true ) ;     
      Container contentPane = getContentPane() ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create our GUI                                          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      output      = new JLabel ( Str.getStr ( STR_DO_YOU_WANT_TO_RUN )+" '"+name+"' "+Str.getStr ( STR_FIRST_ALWAYS ) ) ;
      pb_YES      = new DButton ( Str.getStr ( STR_YES ) ) ;
      pb_NO       = new DButton ( Str.getStr ( STR_NO ) ) ;
      pb_NEVER    = new DButton ( Str.getStr ( STR_NEVER_ASK ) ) ;
      buttonPanel = new ButtonPanel () ;        

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Set properties                                          */     
      /*                                                           */
      /*-----------------------------------------------------------*/
      output.setVerticalAlignment ( SwingConstants.TOP ) ;
      

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add Action Listeners                                    */
      /*                                                           */
      /*-----------------------------------------------------------*/
      pb_YES.addActionListener   ( this ) ;
      pb_NO.addActionListener    ( this ) ;
      pb_NEVER.addActionListener ( this ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   add our GUI                                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      contentPane.setLayout ( new BorderLayout (5,5) ) ;
      buttonPanel.add ( pb_YES ) ;
      buttonPanel.add ( pb_NO ) ;
      buttonPanel.add ( pb_NEVER ) ;
      contentPane.add ( output, BorderLayout.CENTER ) ;
      contentPane.add ( buttonPanel, BorderLayout.SOUTH ) ;

      GUISystem.setPropertiesOnPanel ( this ) ;

   }





   /*------------------------------------------------------------*/
   /* getResult
    */
   /**
    *    This method will show the window and return one of the 
    *  predefined return codes (YES, NO or NEVER)
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public int getResult () {
      setSize ( 400, 200 ) ;
      WinUtil.centerWindow ( this ) ;
      setVisible ( true ) ;

      return( rc ) ;
   }




   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will be called when an action
    *  event is sent to us
    *  
    *
    *  @param e The event
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_YES                                                  */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( e.getSource() == pb_YES )
         rc = YES ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_NO                                                   */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_NO )
         rc = NO ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   pb_NEVER                                                */
      /*                                                           */
      /*-----------------------------------------------------------*/
      else if ( e.getSource() == pb_NEVER )
         rc = NEVER ;


      dispose() ;

   }


} /* FirstAppletRunDlg */
