package com.ibm.nzna.projects.supportcom ;     
/*-----------------------------------------------------------*/
/*   SupportClient                                           */
/*                                                           */
/*   Description:                                            */
/*      Source code for: SupportClient                       */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import javax.swing.event.* ;
import javax.swing.border.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.shared.gui.* ;
import com.ibm.nzna.shared.gui.wizard.* ;
/**
 * A simple test client 
 *
 *
 * @version 1.0, 3/20/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   SupportClient                                           */
/*                                                           */
/*-----------------------------------------------------------*/
public class SupportClient extends JFrame implements ActionListener, WizardListener {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private GUI Members                                     */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private Wizard          wizard            = null ;
   private ListPanel       sideList          = null ;
   private DButton         st_GOTOHOME       = null ;
   private BeginWizardStep beginStep         = null ;
   private InfoStep        welcomeStep       = null ;
   private JPanel          gotoHomePanel     = null ;

   private DButton         st_CONFIGURATION  = null ;
   private DButton         st_CENTRAL        = null ;
   private DButton         st_CONSOLE        = null ;
   private DButton         st_DIAGNOSE       = null ;





   /*------------------------------------------------------------*/
   /* main
    */
   /**
    *    This main method takes no arguments
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public static void main ( String[] args ) {
      new SupportClient() ;
   }




   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    The default constructor initializes and shows
    *  the window
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public SupportClient () {

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   First, create the GUI                                   */
      /*                                                           */
      /*-----------------------------------------------------------*/
      createGUI () ;

   } /* SupportClient */





   /*------------------------------------------------------------*/
   /* createGUI
    */
   /**
    *    This method will initialize and add all GUI
    *  components
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void createGUI () {
      Container contentPane = getContentPane() ;
      Font      largeFont   = null ;
      Color     lightBlue   = new Color ( 153, 204, 255 ) ;                       

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Set the look and feel to Windows                        */
      /*                                                           */
      /*-----------------------------------------------------------*/
      try {
         UIManager.setLookAndFeel ( "com.sun.java.swing.plaf.windows.WindowsLookAndFeel" ) ;
      } catch ( Exception e ) {
      }

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create our Font for the Side List                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      largeFont = new Font ( "DialogOutput", Font.BOLD, 14 ) ;

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create the GUI                                          */
      /*                                                           */
      /*-----------------------------------------------------------*/
      wizard            = new Wizard () ;
      st_GOTOHOME       = new DButton ( "Goto My Online Support Homepage" ) ;
      sideList          = new ListPanel () ;
      gotoHomePanel     = new JPanel () ;

      st_CONFIGURATION  = new DButton ( "<html><body><font size=3 face=\"Helvetica, Arial\"><b>Configuration</b></font></body></html>" ) ;
      st_CENTRAL        = new DButton ( "<html><body><font size=3 face=\"Helvetica, Arial\"><b>Support Action Central</b></font></body></html>" ) ;
      st_CONSOLE        = new DButton ( "<html><body><font size=3 face=\"Helvetica, Arial\"><b>Protection Console</b></font></body></html>" ) ;
      st_DIAGNOSE       = new DButton ( "<html><body><font size=3 face=\"Helvetica, Arial\"><b>Diagnose & Fix</b></font></body></html>" ) ;

      beginStep         = new BeginWizardStep() ;
      welcomeStep       = new InfoStep ( "<html><body><font size=2 face=\"Helvetica, Arial\">Welcome to the Support.com stuff. Please select a link to your left</font></body></html>" ) ;        

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Adjust properties                                       */
      /*                                                           */
      /*-----------------------------------------------------------*/
      welcomeStep.setTitle ( "<html><body><font size=2 face=\"Helvetica, Arial\" size=2><b>Welcome</b><br>&nbsp;&nbsp;&nbsp;Select a link to begin</font></body></html>" ) ;
      beginStep.setTitle ( "<html><body><font size=2 face=\"Helvetica, Arial\" size=2><b>Support.com</b><br>&nbsp;&nbsp;&nbsp;Select a button below</font></body></html>" ) ;

      st_GOTOHOME.actAsLink ( true ) ;
      st_CONFIGURATION.actAsLink ( true ) ;
      st_CENTRAL.actAsLink ( true ) ;
      st_CONSOLE.actAsLink ( true ) ;
      st_DIAGNOSE.actAsLink ( true ) ;
      st_GOTOHOME.setHighlightForeground ( new Color ( 0, 0, 255 ) ) ;
      st_GOTOHOME.setFocusPainted ( false ) ;

      st_CONFIGURATION.setPreferredSize ( new Dimension ( 100, 35 ) ) ;
      st_CENTRAL.setPreferredSize ( new Dimension ( 100, 35 ) ) ;
      st_CONSOLE.setPreferredSize ( new Dimension ( 100, 35 ) ) ;
      st_DIAGNOSE.setPreferredSize ( new Dimension ( 100, 35 ) ) ;


      st_CONFIGURATION.setFont ( largeFont ) ;
      st_CENTRAL.setFont ( largeFont ) ;
      st_CONSOLE.setFont ( largeFont ) ;
      st_DIAGNOSE.setFont ( largeFont ) ;

      st_CONFIGURATION.setBackground ( lightBlue )  ;
      st_CENTRAL.setBackground ( lightBlue )  ;
      st_CONSOLE.setBackground ( lightBlue )  ;
      st_DIAGNOSE.setBackground ( lightBlue )  ;

      sideList.setBorder ( new BevelBorder ( BevelBorder.LOWERED ) ) ;
      sideList.setBackground ( lightBlue ) ;
      gotoHomePanel.setBorder ( new LineBorder ( Color.black ) ) ;
      gotoHomePanel.setBackground ( Color.white ) ;  
      st_GOTOHOME.setBorderPainted ( false ) ;
      st_GOTOHOME.setBackground ( Color.white ) ;      

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add listeners                                           */
      /*                                                           */
      /*-----------------------------------------------------------*/
      wizard.addWizardListener ( this ) ;
      st_GOTOHOME.addActionListener ( this ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Add the GUI                                             */
      /*                                                           */
      /*-----------------------------------------------------------*/
      sideList.add ( st_CONFIGURATION ) ;
      sideList.add ( st_CENTRAL       ) ;
      sideList.add ( st_CONSOLE       ) ;
      sideList.add ( st_DIAGNOSE      ) ;
      gotoHomePanel.setLayout ( new FlowLayout ( FlowLayout.CENTER, 0, 0 ) ) ;
      gotoHomePanel.add ( st_GOTOHOME ) ;

      contentPane.setLayout ( null ) ;
      contentPane.add ( wizard ) ;
      contentPane.add ( sideList ) ;
      contentPane.add ( gotoHomePanel ) ;

      wizard.setCurrentStep ( welcomeStep ) ;


      setSize ( 600, 400 ) ;
      WinUtil.centerWindow ( this ) ;
      setVisible ( true ) ;


   } /* createGUI */





   /*------------------------------------------------------------*/
   /* doLayout
    */
   /**
    *    This method will lay out and position
    *  all of our GUI
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void doLayout () {
      Dimension size         = getSize() ;
      int       gotoHeight   = 21 ;
      Dimension gotoPrefSize = st_GOTOHOME.getMinimumSize() ;

      super.doLayout() ;

      size.height-=getInsets().top ;

      sideList.setBounds ( 0, 5, 195, size.height-gotoHeight-10 ) ;
      wizard.setBounds ( 200, 5, size.width-205, size.height-gotoHeight-10 ) ;
      gotoHomePanel.setBounds ( 0, size.height-gotoHeight, size.width, gotoHeight ) ;

   }





   /*------------------------------------------------------------*/
   /* nextPerformed
    */
   /**
    *    This method will be called when the next
    *  button is pressed in the wizard
    *  
    *
    *  @param e The event
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void nextPerformed ( WizardEvent e) {
      WizardStep currentStep = wizard.getCurrentStep() ;

      if ( currentStep == welcomeStep )
         wizard.setCurrentStep ( beginStep ) ;

      adjustButtons() ;
   }

   /*------------------------------------------------------------*/
   /* finishPerformed
    */
   /**
    *    This method will be called when the finish
    *  button is pressed in the wizard
    *  
    *
    *  @param e The event
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void finishPerformed ( WizardEvent e) {
   }

   /*------------------------------------------------------------*/
   /* cancelPerformed
    */
   /**
    *    This method will be called when the cancel
    *  button is pressed in the wizard
    *  
    *
    *  @param e The event
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void cancelPerformed ( WizardEvent e) {
   }

   /*------------------------------------------------------------*/
   /* backPerformed
    */
   /**
    *    This method will be called when the back
    *  button is pressed in the wizard
    *  
    *
    *  @param e The event
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void backPerformed ( WizardEvent e) {
      WizardStep currentStep = wizard.getCurrentStep() ;

      if ( currentStep == beginStep )
         wizard.setCurrentStep ( welcomeStep ) ;

      adjustButtons() ;
   }



   /*------------------------------------------------------------*/
   /* adjustButtons
    */
   /**
    *    This method will look at what step is
    *  currently showing and will decide which
    *  buttons to show in the wizard
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private void adjustButtons () {
      WizardStep step = wizard.getCurrentStep() ;

      if ( step == welcomeStep )
         wizard.showButtons ( true,     // Show next
                              false,    // Show Back
                              true,     // Show Cancel
                              false ) ; // Show Finish
      else if ( step == beginStep )
         wizard.showButtons ( false, true, false, true ) ;
      else
         wizard.showButtons ( true, true, true, false ) ;
   }




   /*------------------------------------------------------------*/
   /* actionPerformed
    */
   /**
    *    This method will be called when an action
    *  event is fired on us
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void actionPerformed ( ActionEvent e ) {

      if ( e.getSource() == st_GOTOHOME ) {
         try {
            String[] parms = { "D:\\Program Files\\Internet Explorer\\IEXPLORE.EXE", "http://www.pc.ibm.com/support" } ;

            Runtime.getRuntime().exec ( parms ) ;
         } catch ( Exception exception ) {
            exception.printStackTrace() ;
         }
      }

   }


} /* SupportClient */
