/*-----------------------------------------------------------*/
/*   ChangeComments                                          */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ChangeComments                      */      
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.sql.* ;
import java.util.* ;
import com.ibm.nzna.shared.db.* ; 
import com.ibm.nzna.shared.util.* ; 
/**
 * This program changes the comments  
 *
 *
 * @version 1.0, 11/1/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ChangeComments                                          */
/*                                                           */
/*-----------------------------------------------------------*/
public class changeComments {  


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Static Vars                                             */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private static String dbHost     = "localhost" ;
   private static String dbName     = "quest" ;
   private static String dbPort     = "5703" ;
   private static String userId     = "quest" ;
   private static String password   = "j0hnny" ;





   /*------------------------------------------------------------*/
   /* main
    */
   /**
    *    This is the main entry point for the program
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public static void main ( String[] args ) {                                   

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Create a log system to log our info in                  */
      /*                                                           */
      /*-----------------------------------------------------------*/
      new LogSystem ( 1, "changeComment.out" ) ;


      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Connect to DB/2                                         */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( connect() ) {
         System.out.println ( "Connected to Quest!" ) ;

         runstuff() ;
         runstuff2() ;
      }

      System.exit(0) ;
   }





   /*------------------------------------------------------------*/
   /* connect
    */
   /**
    *    This method will establish the connection to
    *  the database
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   private static boolean connect () {
      boolean rc = false ;

      try {
         new DatabaseSystem ( true, LogSystem.getInstance(), false ) ;

         rc = DatabaseSystem.createConnection ( DatabaseSystem.QUEST, 
                                                dbName,
                                                dbHost,
                                                dbPort,
                                                userId,
                                                password ) ;

      } catch ( Exception e ) {
         LogSystem.log ( 1, e ) ;
      }
      return( rc ) ;
   }

   public static void runstuff () {
      SQLMethod sqlMethod = new SQLMethod ( DatabaseSystem.QUEST, "runstuff", 5 ) ;

      try {
         Statement stmt = sqlMethod.createStatement() ;
         ResultSet rs   = stmt.executeQuery ( "SELECT A.EDGEIND, B.DOCCLASSIND FROM OA.EDGE A, OA.ANSWER B "+
                                              "WHERE A.ANSWERIND = B.ANSWERIND" ) ;
         Vector processVec = new Vector (1 ) ;
         int count = 0 ;

         while ( rs.next() ) {
            processVec.addElement ( new it ( rs.getInt(1), rs.getInt(2) ) ) ;
            count++ ;
         }

         stmt = null ;
         sqlMethod.close() ;
         sqlMethod = new SQLMethod ( DatabaseSystem.QUEST, "runstuff(2)", 5 ) ;
         int i = 0 ;
         int size = processVec.size() ;
         Statement upStmt = sqlMethod.createStatement() ;
         it itt = null ;

         while ( i < size ) {
            itt = (it)processVec.elementAt(i) ;
            System.out.println ( "Updaing "+i+" of "+count+"   Edge "+itt.edgeInd+" With DocClass:"+itt.docClassInd ) ;
            upStmt.executeUpdate ( "UPDATE OA.EDGE SET DOCCLASSIND = "+itt.docClassInd+" where edgeind = "+itt.edgeInd ) ;
            i++ ;
         }

         sqlMethod.close() ;

      } catch ( Exception e ) {
         e.printStackTrace() ;
      }
   }


   public static void runstuff2 () {
      SQLMethod sqlMethod = new SQLMethod ( DatabaseSystem.QUEST, "runstuff", 5 ) ;

      try {
         Statement stmt = sqlMethod.createStatement() ;
         ResultSet rs   = stmt.executeQuery ( "SELECT A.EDGEIND, B.DOCCLASSIND FROM OA.EDGE A, OA.SYMPTOM B, OA.EDGEGROUP C "+
                                              "WHERE A.EDGEGROUPIND = C.EDGEGROUPIND AND A.ANSWERIND IS NULL AND C.SYMPTOMIND = B.SYMPTOMIND" ) ;
         Vector processVec = new Vector (1 ) ;
         int    count      = 0 ;

         while ( rs.next() ) {
            processVec.addElement ( new it ( rs.getInt(1), rs.getInt(2) ) ) ;
            count++ ;
         }

         stmt = null ;
         sqlMethod.close() ;
         sqlMethod = new SQLMethod ( DatabaseSystem.QUEST, "runstuff(2)", 5 ) ;
         int i = 0 ;
         int size = processVec.size() ;
         Statement upStmt = sqlMethod.createStatement() ;
         it itt = null ;


         while ( i < size ) {
            itt = (it)processVec.elementAt(i) ;
            System.out.println ( "Updaing Edge "+i+" of "+count+"  "+itt.edgeInd+" With DocClass:"+itt.docClassInd ) ;
            upStmt.executeUpdate ( "UPDATE OA.EDGE SET DOCCLASSIND = "+itt.docClassInd+" where edgeind = "+itt.edgeInd ) ;
            i++ ;
         }

         sqlMethod.close() ;

      } catch ( Exception e ) {
         e.printStackTrace() ;
      }
   }

} /* ChangeComments */

class it extends Object {
   public int edgeInd = 0 ;
   public int docClassInd = 0 ;

   public it ( int edgeInd, int docClassInd ) {
      this.edgeInd = edgeInd ;
      this.docClassInd = docClassInd ;
   }
}
