package com.ibm.nzna.samples.mq ;
import com.ibm.nzna.shared.mq.* ;
import com.ibm.nzna.shared.util.* ;
import java.util.* ;

   /*********************************************************
   * This is a sample class for using session states using 
   * mq series
   * 
   *
   * Legal: Copyright (c) 2000 IBM. All Rights Reserved.
   * Created: 5/9/100  2:44pm
   * @author 
   * @version
   *********************************************************/
public class MQSessionStateSample {
   static final String           fileSeparator        = System.getProperties().getProperty("file.separator") ;
   final static int numMessages = 2000 ;
   static String                 propertyFilename     = "samples"+ fileSeparator +"samples.MQSessionState.properties" ;
   public static void main( String argv[] ) {
      SessionManager sessionManager      = null ;
      /* Create an instance of the class */
      sessionManager = (SessionManager) new FireWalkerMGR() ;
      /* Initialize the session Manager */
      /* Load the properties file for the shared data manager */
      Properties sessionManagerProperties = new Properties() ;
      if ( !StandardPropertyLoader.load ( sessionManagerProperties, propertyFilename) ) {
         System.out.println( "MQSessionStateSample:  unable to load="+ propertyFilename) ;
         System.exit(-1) ;
      }
      /* Initialize the session Manager */
      sessionManager.init( sessionManagerProperties ) ;
      /* Set initial time of test */
      long millis = System.currentTimeMillis() ;
      /* Perform a performance test of the queue */
      for ( int count = 0 ; count < numMessages ; count++ ) {
         /* Place Object in queue */
         sessionManager.put ( "test", "sample text" ) ;
         /* Get Object from the queue */
         Object object = sessionManager.get ( "test") ;
         /* Show Progresss */
         if ( (count % 10) == 0) {
            System.out.print("Processed Messages: "+count+"\r") ;
         }
      }
      /* Set completed time */
      long duration = System.currentTimeMillis() - millis ;
      /* Show results of test */
      System.out.println( "Duration of test:  "+(duration/1000)+" seconds") ;
      System.out.println( "Time per message:  "+duration/numMessages+" milli seconds") ;
   }
}
