package com.ibm.nzna.samples.mq ;
import com.ibm.nzna.shared.mq.* ;
import com.ibm.nzna.shared.util.* ;
import java.util.* ;

   /*********************************************************
   * This is a sample class for using session states using 
   * mq series
   * 
   *
   * Legal: Copyright (c) 2000 IBM. All Rights Reserved.
   * Created: 5/9/100  2:44pm
   * @author 
   * @version
   *********************************************************/
public class MQSharedDataClientSample {
   static final String           fileSeparator        = System.getProperties().getProperty("file.separator") ;
   final static int numMessages = 1000 ;
   static String                 propertyFilename     = "samples"+ fileSeparator +"samples.MQSharedDataClient.properties" ;

   public static void main( String argv[] ) {
      SharedDataManager sharedDataManager      = null ;
      /* Create an instance of the class */
      sharedDataManager = (SharedDataManager) new FireWalkerMGR() ;
      /* Load the properties file for the shared data manager */
      Properties sharedDataManagerProperties = new Properties() ;
      if ( !StandardPropertyLoader.load ( sharedDataManagerProperties, propertyFilename) ) {
         System.out.println( "MQSharedDataClientSample:  unable to load="+ propertyFilename ) ;
         System.exit(-1) ;
      }
      /* Initialize the session Manager */
      sharedDataManager.init( sharedDataManagerProperties ) ;
      /* Set initial time of test */
      long millis = System.currentTimeMillis() ;
      /* Perform a performance test of the queue */
      for ( int count = 0 ; count < numMessages ; count++ ) {
         /* Place Object in queue */
         String key = sharedDataManager.put ( "Shared Data" ) ;
         /* Get Object from the queue using the key  */
         /* This will get the object placed by the   */
         /* server.  This get will get from a different queue */
         Object object = sharedDataManager.get ( key ) ;
         /* Show Progresss */
         if ( (count % 10) == 0) {
            System.out.print("Processed Messages: "+count+"\r") ;
         }
      }
      /* Set completed time */
      long duration = System.currentTimeMillis() - millis ;
      /* Show results of test */
      System.out.println( "Duration of test:  "+(duration/1000)+" seconds") ;
      System.out.println( "Time per message:  "+duration/numMessages+" milli seconds") ;
   }
}
