package com.ibm.nzna.samples.mq ;
import com.ibm.nzna.shared.mq.* ;
import com.ibm.nzna.shared.util.* ;
import java.util.* ;

   /*********************************************************
   * This is a sample class for using session states using 
   * mq series
   * 
   *
   * Legal: Copyright (c) 2000 IBM. All Rights Reserved.
   * Created: 5/9/100  2:44pm
   * @author 
   * @version
   *********************************************************/
public class MQSharedDataServerSample {
   static final String           fileSeparator        = System.getProperties().getProperty("file.separator") ;
   final static int              numMessages          = 1000 ;
   static String                 propertyFilename     = "samples"+ fileSeparator +"samples.MQSharedDataServer.properties" ;
   public static void main( String argv[] ) {
      SharedDataManager sharedDataManager      = null ;
      /* Create an instance of the class */
      sharedDataManager = (SharedDataManager) new FireWalkerMGR() ;
      /* Load the properties file for the shared data manager */
      Properties sharedDataManagerProperties = new Properties() ;
      if ( !StandardPropertyLoader.load ( sharedDataManagerProperties, propertyFilename ) ) {
         System.out.println( "MQSharedDataServerSample:  unable to load="+ propertyFilename) ;
         System.exit(-1) ;
      }
      /* Initialize the session Manager */
      sharedDataManager.init( sharedDataManagerProperties ) ;
      /* Set initial time of test */
      long millis = System.currentTimeMillis() ;
      /* Perform a performance test of the queue */
      for ( int count = 0 ; count < numMessages ; count++ ) {
         /* Wait for any message delivered to our queue */
         SharedDataObject sharedDataObject = sharedDataManager.get () ;
         Object object = sharedDataObject.object ;
         String key    = sharedDataObject.id ;
         /* Return a message to the client application    */
         /* Using the same id we received for the message */
         /* The message will be returned in a different   */
         /* queue than which it was received.             */
         sharedDataManager.put ( key, "Message received" ) ;
         /* Show Progresss */
         if ( (count % 10) == 0) {
            System.out.print("Processed Messages: "+count+"\r") ;
         }
      }
      /* Set completed time */
      long duration = System.currentTimeMillis() - millis ;
      /* Show results of test */
      System.out.println( "Duration of test:  "+(duration/1000)+" seconds") ;
      System.out.println( "Time per message:  "+duration/numMessages+" milli seconds") ;
   }
}
