package com.ibm.nzna.shared.db ;                       
/*-----------------------------------------------------------*/
/*   DatabaseStatusNotify                                    */
/*                                                           */
/*   Description:                                            */
/*      Source code for: DatabaseStatusNotify                */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
/**
 * This thread notifies all Status Listeners of a particular status change in a database 
 *
 *
 * @version 1.0, 8/1/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   DatabaseStatusNotify                                    */
/*                                                           */
/*-----------------------------------------------------------*/
public class DatabaseStatusNotify extends Object implements Runnable {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private Vector   statusListenerVec = null ;
   private int      statusType        = 0 ;
   private Database database          = null ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This method will initialize and kick off our
    *  thread
    *  
    *
    *  @param statusType The new Status Type
    *  @param database The database that the status is reflected on
    *  @param statusListenerVec The vector of status listeners to nofify
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public DatabaseStatusNotify ( int statusType, Database database, Vector statusListenerVec ) {
      this.statusType        = statusType ;
      this.database          = database ;
      this.statusListenerVec = statusListenerVec ;

      new Thread ( this ).start() ;
   }



   /*------------------------------------------------------------*/
   /* run
    */
   /**
    *    This thread will walk through our vector, notifying
    *  all listeners
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void run () {
      if ( statusListenerVec != null ) {
         int i    = 0 ;
         int size = statusListenerVec.size() ;

         while ( i < size ) {
            ((DatabaseStatusListener)statusListenerVec.elementAt(i)).databaseStatusChange ( statusType, database ) ;
            i++ ;
         }
      }
   }

} /* DatabaseStatusNotify */
