// 
//   $Header: /home/cvs/cvsroot/javaroot/com/ibm/nzna/shared/ftp/FTP/FtpBeanInfo.java,v 1.1.1.1.4.2 2001/09/24 18:39:42 dlentz Exp $
// 
//   Copyright (c) 1997 Eastfork Object Space (EOS)
//   All Rights Reserved
//   No part of this program may be copied, used or delivered to
//   anyone without the express written consent of EOS
//

package com.ibm.nzna.shared.ftp.FTP ;

import java.awt.Image;
import java.beans.*;

/**
 * BeanInfo for the Ftp bean.
 * @author Morten Hindsholm (mhi@eos.dk)
 * @version $Revision: 1.1.1.1.4.2 $
 **/
public class FtpBeanInfo extends SimpleBeanInfo {

    /**
     * Get a list of the FTP bean's properties
     **/
    public PropertyDescriptor[] getPropertyDescriptors() {
        try {
            PropertyDescriptor port = new PropertyDescriptor(Ftp.PORT, Ftp.class);
            port.setExpert(true);
            port.setBound(true);
            PropertyDescriptor bufferSize = new PropertyDescriptor(Ftp.BUFFER_SIZE, Ftp.class);
            bufferSize.setExpert(true);
            bufferSize.setBound(true);
            PropertyDescriptor connected = new PropertyDescriptor(Ftp.CONNECTED, Ftp.class, "isConnected", null);
            connected.setBound(true);
            PropertyDescriptor host = new PropertyDescriptor(Ftp.HOST, Ftp.class);
            host.setBound(true);
            PropertyDescriptor password = new PropertyDescriptor(Ftp.PASSWORD, Ftp.class);
            password.setBound(true);
            password.setPropertyEditorClass(PasswordEditor.class);
            PropertyDescriptor timeout = new PropertyDescriptor(Ftp.TIMEOUT, Ftp.class);
            timeout.setBound(true);
            PropertyDescriptor trace = new PropertyDescriptor(Ftp.TRACE, Ftp.class);
            trace.setBound(true);
            PropertyDescriptor traceDest = new PropertyDescriptor(Ftp.TRACE_DESTINATION, Ftp.class);
            traceDest.setBound(true);
            traceDest.setHidden(true);
            PropertyDescriptor type = new PropertyDescriptor(Ftp.TYPE, Ftp.class);
            type.setBound(true);
            type.setHidden(true);
            PropertyDescriptor user = new PropertyDescriptor(Ftp.USER, Ftp.class);
            user.setBound(true);
            PropertyDescriptor pd[] = { port, bufferSize, connected, host, password,
                                        timeout, trace, traceDest, type, user };
            return pd;
        }
        catch (Exception e) {
            throw new Error(e.toString());
        }
    }

    // Icons
    Image iconColor16x16 = null;
    Image iconColor32x32 = null;

    /**
     * Get a particular icon for this bean
     **/
    public Image getIcon(int iconKind) {
        switch (iconKind) {
          case BeanInfo.ICON_COLOR_16x16:
            if (iconColor16x16 == null) {
                iconColor16x16 = loadImage("icon16x16.gif");
            }
            return iconColor16x16;
          case BeanInfo.ICON_COLOR_32x32:
            if (iconColor32x32 == null) {
                iconColor32x32 = loadImage("icon32x32.gif");
            }
            return iconColor32x32;
        }
        return null;
    }


}

