// 
//   $Header: /home/cvs/cvsroot/javaroot/com/ibm/nzna/shared/ftp/FTP/FtpListener.java,v 1.1.1.1.4.2 2001/09/24 18:39:42 dlentz Exp $
// 
//   Copyright (c) 1997 Eastfork Object Space (EOS)
//   All Rights Reserved
//   No part of this program may be copied, used or delivered to
//   anyone without the express written consent of EOS
// 

package com.ibm.nzna.shared.ftp.FTP ;

/**
 * The FtpListener interface is used to keep track of an FTP
 * file transfer. During the file transfer, the methods in this
 * interface will be called with statistical information about
 * the transfer.
 * @author Morten Hindsholm (mhi@eos.dk)
 * @version $Revision: 1.1.1.1.4.2 $
 **/
public interface FtpListener extends java.util.EventListener {

    /**
     * This method is called whenever a reply is received from the host
     * @param re information about the reply
     **/
    void ftpReply(ReplyEvent re);

    /**
     * This method is called when a file transfer is initiated.
     * @param te information about the transfer
     **/
    void transferStarted(TransferEvent te);

    /**
     * This method may be called a number of times during a file transfer.
     * @param te information about the transfer
     **/
    void transferProgress(TransferEvent te);

    /**
     * This method is called when a file transfer is completed.
     * Check the parameter to see if the transfer completed successfully.
     * @param te information about the transfer
     **/    
    void transferEnded(TransferEvent te);
}
