// 
//   $Header: /home/cvs/cvsroot/javaroot/com/ibm/nzna/shared/ftp/FtpError.java,v 1.1.1.1.4.2 2001/09/24 18:39:43 dlentz Exp $
// 
//   Copyright (c) 1997 Eastfork Object Space (EOS)
//   All Rights Reserved
//   No part of this program may be copied, used or delivered to
//   anyone without the express written consent of EOS
//

package com.ibm.nzna.shared.ftp ;

import java.io.IOException;

/**
 * This class signals an FTP error.
 * The error code can be obtained by calling <code>getReplyCode()</code>
 * and the error message by calling <code>getMessage()</code>
 * @author Morten Hindsholm (mhi@eos.dk)
 * @version $Revision: 1.1.1.1.4.2 $
 **/
public class FtpError extends IOException {

    /** The FTP reply **/
    FtpReply reply;

    public FtpError(FtpReply reply) {
        super(reply.getMessage());
        this.reply = reply;
    }

    /**
     * Get the FTP reply code.
     * This is the three-digit code returned by the FTP host.
     **/
    public int getReplyCode() {
        return reply.getCode();
    }
    
}

