package com.ibm.nzna.shared.ftp ;                                         
/*-----------------------------------------------------------*/
/*   LocalFileNotFoundException                              */
/*                                                           */
/*   Description:                                            */
/*      Source code for: LocalFileNotFoundException          */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This exception is thrown from the FTP Manager when a local file is 
 * not found when needed to FTP to the FTP site.
 *
 * @version 1.0, 7/25/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   LocalFileNotFoundException                              */
/*                                                           */
/*-----------------------------------------------------------*/
public class LocalFileNotFoundException extends Exception {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */      
   /*                                                           */
   /*-----------------------------------------------------------*/
   private FTPFile ftpFile = null ;
   



   /*------------------------------------------------------------*/
   /* LocalFileNotFoundException
    */
   /**
    *    This Constructor will create the standard
    *  Exception
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public LocalFileNotFoundException ( FTPFile ftpFile ) {
      super() ;
      this.ftpFile = ftpFile ;
   }




   /*------------------------------------------------------------*/
   /* getFTPFile
    */
   /**
    *    This method will return the FTPFile that
    *  threw the Exception.
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return FTPFile
    *//*---------------------------------------------------------*/
   public FTPFile getFTPFile () {
      return( ftpFile ) ;
   }

} /* LocalFileNotFoundException */
