package com.ibm.nzna.shared.ftp.sun ;
/*-----------------------------------------------------------*/
/*   SunFTP                                                  */
/*                                                           */
/*   Description:                                            */
/*      Source code for: SunFTP                              */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.io.*;
import java.net.*;
import java.util.*;
import sun.net.*;
import sun.net.ftp.*;
/**
 * This class should not be used for production work, it 
 * was written by Watson Research and uses non-supported sun.* packages
 *
 *
 * @version 1.0, 2/19/2001 
 * @author  David Lentz
 */

/*-----------------------------------------------------------*/
/*                                                           */
/*   SunFTP                                                  */
/*                                                           */
/*-----------------------------------------------------------*/
public class SunFTP extends FtpClient {

   public static void main ( String args[] ) {
      try {
         SunFTP ff = new SunFTP ( "f3.pc.ibm.com", "quest", "hgra2l" ) ;
         Vector v = ff.lsDir() ;

         for ( int i = 0; i < v.size(); i++ ) {
            System.out.println ( v.elementAt(i) ) ;
         }
      } catch ( Exception e ) {
         e.printStackTrace() ;
      }


   }


   int m_lastReturnCode = -1;

   public SunFTP(String aHost,String aUser, String aPass) throws Exception
   {
      super(aHost);
      super.login(aUser,aPass);
      super.binary();
   }

   private void feedBack(String aString) {
      System.out.println(aString);
   }


   public boolean changeDir(String aDir) {
      try {
         super.cd(aDir);
      } catch ( Exception exc ) {
         return(false);
      }
      return(true);
   }

   public Vector lsDir() {
      Vector result = new Vector();

      try {
         String t;      
         sun.net.TelnetInputStream tis = super.list();
         DataInputStream dis = new DataInputStream(tis);
         while ( (t = dis.readLine()) != null )
            result.addElement(t);
         dis.close();
      } catch ( Exception e ) {
      }

      return(result);
   }



   public int getLastReturnCode() {
      return(m_lastReturnCode);
   }


   public boolean putFile(String aFileName) {

      boolean state = true;
      sun.net.TelnetOutputStream tos = null;
      try {
         tos = super.put(aFileName);
         FileInputStream fis = new FileInputStream(aFileName);

         int buffLength = 4096;

         byte[] data = new byte[buffLength];

         for ( int bytesRead = 0; bytesRead != -1; ) {
            bytesRead = fis.read(data, 0, buffLength);
            if ( bytesRead > 0 ) {
               tos.write(data,0,bytesRead);
            }
         }
      } catch ( Exception e ) {
         state = false;
      }

      try {
         tos.close();
      } catch ( Exception f ) {
      }

      return(state);

   }

   public ByteArrayOutputStream getFile(String aFileName) {
      String t = new String("");
      ByteArrayOutputStream baos = new ByteArrayOutputStream();
      try {
         sun.net.TelnetInputStream tis = super.get(aFileName);
         DataInputStream dis = new DataInputStream(tis);
         baos = this.readFully(dis);
      } catch ( Exception exc ) {
      }
      return(baos);
   }



   public int doCommand(String strCommand)
   throws IOException
   {
      return(issueCommand(strCommand));
   }


   private static ByteArrayOutputStream readFully(DataInputStream in) throws IOException
   {
      ByteArrayOutputStream baos = new ByteArrayOutputStream();
      int buffLength = 4096;
      byte[] data = new byte[buffLength];
      for ( int bytesRead = 0; bytesRead != -1; ) {
         bytesRead = in.read(data, 0, buffLength);
         if ( bytesRead > 0 ) {
            baos.write(data,0,bytesRead);
         }
      }
      return(baos);     
   }



   protected int issueCommand(String cmd) throws IOException
   {
      m_lastReturnCode = super.issueCommand(cmd);
      return(m_lastReturnCode);
   }


   protected Socket openDataConnection(String strCommand) throws IOException
   {
      String addrString;
      Socket dataSocket;
      int    port;
      // Switch server to passive mode
      issueCommand("PASV");
      String resp = getResponseString();
//      feedBack("Response to PASV command was:  " + resp);
      // get response and parse the addr/port to get file from
      StringTokenizer tok = new StringTokenizer(resp, "(");
      tok.nextToken(); //Skip first part
      addrString = tok.nextToken("(,") + "." + tok.nextToken(",") + "." + tok.nextToken() + "." + tok.nextToken();
      port =  (Integer.valueOf(tok.nextToken()).intValue() * 256) + Integer.valueOf(tok.nextToken(",)")).intValue();
//      feedBack("address is " + addrString + " and the port number is " + port);
      // Create thread to issue the RETR (file retrieve)
      FtpClientThread thd = new FtpClientThread(this, strCommand);
      thd.start();

//      feedBack("About to connect to data stream");
      // connect to the data port
      dataSocket = new Socket(addrString, port);
      // Synch up with other thread. To avoid any race conditions
      //  This way we know Socket is connected and Commnd to server
      //  has completed.....
      try {
         thd.join();
      } catch ( Exception e ) {
      }
      thd.checkException();            // allow thread to throw saved exception
      return(dataSocket);
   }

}

// Class added to handle multiple ip problem
class FtpClientThread extends Thread {
   private SunFTP   client;
   private String       command;
   private IOException  m_exception = null;

   public FtpClientThread(SunFTP c, String cmd) {
      client = c;
      command = cmd;
   }

   public void checkException() throws IOException
   {
      if ( m_exception != null ) {
//         client.feedBack("Throwing saved exception in FtpClientThread.checkException.");
         throw m_exception;
      }
   }

   public void run() {

      try {
         client.doCommand(command);
      } catch ( IOException e ) {
//         client.feedBack("Exception issuing command " + command + " : " + e.getMessage());
         m_exception = e;              // save the exception
      }
   }
}
