package com.ibm.nzna.shared.gui ;                       
/*-----------------------------------------------------------*/
/*   ExtendedMultiListRow                                    */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ExtendedMultiListRow                */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This interface defines method that an Extended version 
 * of a MultiListRow needs to implement. The Extended version
 * of the MultiListRow allows the following extended capabilities:<br><br>
 *
 * <pre>
 * 1. Different Colored text<br>
 * 2. Notifications of column size changes<br>
 *
 *
 * @version 1.0, 11/27/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ExtendedMultiListRow                                    */
/*                                                           */
/*-----------------------------------------------------------*/
public interface ExtendedMultiListRow extends MultiListRow {




   /*------------------------------------------------------------*/
   /* columnSized
    */
   /**
    *    This method will be called when a column
    *  is sized.
    *  
    *
    *  @param column The column number that was sized
    *  @param pixelWidth The new width in pixels
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public abstract void columnSized ( int column, int pixelWidth ) ;




   /*------------------------------------------------------------*/
   /* adjustColumnGraphics
    */
   /**
    *    This method can be used to do a lot of things,
    *  mainly it is used to set Color, Font etc.. attributes
    *  right before text is drawn into the column. Please do not
    *  adjust the ClipRect!
    *
    *  @param columnNum The column number that is going to draw
    *  @param graphics The Graphics context to adjust
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public abstract void adjustColumnGraphics ( int column, java.awt.Graphics g ) ;


} /* ExtendedMultiListRow */
