package com.ibm.nzna.shared.gui ;
/*-----------------------------------------------------------*/
/*   MutableTreeWrapper                                      */
/*                                                           */
/*   Description:                                            */
/*      Source code for: MutableTreeWrapper                  */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import javax.swing.tree.* ;     
/**
 * This is simply an object that can be inserted into a tree, and allows 
 * you to put any object into a JTree
 *
 * @version 1.0, 3/30/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   MutableTreeWrapper                                      */
/*                                                           */
/*-----------------------------------------------------------*/
public class MutableTreeWrapper extends DefaultMutableTreeNode implements MultiListSort {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Private Members                                         */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private Object dataObject = null ;





   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This constructor initializes to the dataObject passed in
    *  
    *  
    *
    *  @param dataObject The default data object
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public MutableTreeWrapper ( Object dataObject ) {
      setDataObject ( dataObject ) ;
   }


   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    The default constructor
    *  
    *  
    *
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public MutableTreeWrapper ( ) {
   }





   /*------------------------------------------------------------*/
   /* setDataObject
    */
   /**
    *    This method will set the data object that
    *  this record represents
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setDataObject ( Object dataObject ) {
      this.dataObject = dataObject ;
   }





   /*------------------------------------------------------------*/
   /* getDataObject
    */
   /**
    *    This method will return the data object
    *  that this record represents
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Object
    *//*---------------------------------------------------------*/
   public Object getDataObject () {
      return( dataObject ) ;
   }

   public int compareTo ( MultiListSort sort, int column ) {

      if ( dataObject instanceof MultiListSort ) {

         if ( sort instanceof MutableTreeWrapper )
            return( ((MultiListSort)dataObject).compareTo ( ((MultiListSort)((MutableTreeWrapper)sort).dataObject), column ) ) ;

         return( ((MultiListSort)dataObject).compareTo ( (MultiListSort)dataObject, column ) ) ;
      }

      return( 0 ) ;
   }


   /**
     *  This method will remove all children properly
     **/
   public void removeAll () {
      removeAllChildren();
   }


} /* MutableTreeWrapper */
