package com.ibm.nzna.shared.gui ;       
/*-----------------------------------------------------------*/
/*   NoTabJTextArea                                          */
/*                                                           */
/*   Description:                                            */
/*      Source code for: NoTabJTextArea                      */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import javax.swing.* ;
import java.awt.event.* ;
/**
 * This simple subclass of JTextArea does not allow the 'Tab'  
 * to be pressed. Instead of putting in 3 blank spaces, the tab
 * will transfer focus
 *
 *
 * @version 1.0, 8/16/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   NoTabJTextArea                                          */
/*                                                           */
/*-----------------------------------------------------------*/
public class NoTabJTextArea extends JTextArea implements KeyListener {

   public NoTabJTextArea ( String text ) {
      super ( text ) ;
      initialize () ;
   }

   public NoTabJTextArea ( ) {
      super() ;
      initialize() ;
   }

   public NoTabJTextArea ( MaskDocument document ) {
      super ( document ) ;
      initialize() ;
   }

   private void initialize () {
      addKeyListener ( this ) ;
   }

   public void keyPressed ( KeyEvent e ) {

      switch ( e.getKeyCode() ) {
         case e.VK_TAB :
            e.consume() ;
            transferFocus() ;
            break ;
      }
   }

   public void keyReleased ( KeyEvent e ) {
      switch ( e.getKeyCode() ) {
         case e.VK_TAB :
            System.out.println ( "KEY RELEASED TAB" ) ;
            break ;
      }
   }

   public void keyTyped ( KeyEvent e ) {
      switch ( e.getKeyCode() ) {
         case e.VK_TAB :
            System.out.println ( "KEY TYPED TAB" ) ;
            break ;
      }

   }
} /* NoTabJTextArea */
