package com.ibm.nzna.shared.gui ;
/*-----------------------------------------------------------*/
/*   StringTreeNode                                          */
/*                                                           */
/*   Description:                                            */
/*      Source code for: StringTreeNode                      */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import javax.swing.* ;
import javax.swing.tree.* ; 
/**
 * This is a simple tree node that will only represent a string. This
 * object may be put into a JTree control but it's only purpose is 
 * to have a description. The toString method will return that description.
 * There is an optional id and dataObject property that may be used to
 * store additional information
 *
 *
 * @version 1.0, 3/1/1999 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   StringTreeNode                                          */
/*                                                           */
/*-----------------------------------------------------------*/
public class StringTreeNode extends DefaultMutableTreeNode {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Vars                                                    */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private String descript = null ;
   private int    id       = -1 ;
   private Object data     = null ;





   /*------------------------------------------------------------*/
   /* StringTreeNode
    */
   /**
    *    This will create the default StringTreeNode
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public StringTreeNode ( String descript ) {
      setDescript ( descript ) ;
   }

   public StringTreeNode ( String descript, int id ) {
      setDescript ( descript ) ;
      setId ( id ) ;
   }

   public StringTreeNode ( String descript, int id, Object data ) {
      setDescript ( descript ) ;
      setId ( id ) ;
      setData ( data ) ;
   }

   public StringTreeNode ( String descript, Object data ) {
      setDescript ( descript ) ;
      setData ( data ) ;
   }





   /*------------------------------------------------------------*/
   /* toString
    */
   /**
    *    This method will return our description
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String toString () {
      return( descript ) ;
   }



   /*------------------------------------------------------------*/
   /* setData
    */
   /**
    *    This method will set the data property
    *  
    *  
    *
    *  @param data The new data
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setData ( Object data ) {
      this.data = data ;
   }




   /*------------------------------------------------------------*/
   /* getData
    */
   /**
    *    This method will return the value of the data
    *  property
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return int 
    *//*---------------------------------------------------------*/
   public Object getData () {
      return( data ) ;
   }



   /*------------------------------------------------------------*/
   /* setId
    */
   /**
    *    This method will set the ID property
    *  
    *  
    *
    *  @param id The new ID
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setId ( int id ) {
      this.id = id ;
   }




   /*------------------------------------------------------------*/
   /* getId
    */
   /**
    *    This method will return the value of the id
    *  property
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return int 
    *//*---------------------------------------------------------*/
   public int getId () {
      return( id ) ;
   }





   /*------------------------------------------------------------*/
   /* setDescript
    */
   /**
    *    This method will set the descript property
    *  
    *  
    *
    *  @param descript  The new description
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setDescript ( String descript ) {
      this.descript = descript ;
   }




} /* StringTreeNode */
