package com.ibm.nzna.shared.gui ;
/*-----------------------------------------------------------*/
/*   ToolBarSeparator                                        */
/*                                                           */
/*   Description:                                            */
/*      Source code for: ToolBarSeparator                    */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import javax.swing.* ;     
import java.awt.* ;
/**
 * This component is a simple ToolBar Separator for a JPanel. 
 *
 *
 * @version 1.0, 2/16/100 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   ToolBarSeparator                                        */
/*                                                           */
/*-----------------------------------------------------------*/
public class ToolBarSeparator extends JComponent {



    /*-----------------------------------------------------------*/
    /*                                                           */
    /*   Private Vars                                            */
    /*                                                           */
    /*-----------------------------------------------------------*/
    private Dimension prefSize     = new Dimension ( 3, 20 ) ;


    public ToolBarSeparator() {
    }

    public ToolBarSeparator ( Dimension prefSize ) {
       this.prefSize = prefSize ;
    }


    /*------------------------------------------------------------*/
    /* getPreferredSize
     */
    /**
     *    This method will return our preferred
     *  size
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public Dimension getPreferredSize () {
        return( prefSize ) ;
    }






    /*------------------------------------------------------------*/
    /* getMaximumSize
     */
    /**
     *    This method will return our maximum size
     *  
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public Dimension getMaximumSize ()  {
        return( getPreferredSize() ) ;
    }




    /*------------------------------------------------------------*/
    /* getMinimumSize
     */
    /**
     *    This method will return out minimum size
     *  
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public Dimension getMinimumSize () {
        return( getPreferredSize() ) ;
    }




    /*------------------------------------------------------------*/
    /* paintComponent
     */
    /**
     *    This method will paint our component
     *  
     *  
     *
     *  @param g The graphics context to paint into
     *  @param None
     *  @param None
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public void paintComponent ( Graphics g ) {
        g.setColor ( Color.gray ) ;
        g.drawLine ( 0, 0, 0,prefSize.height ) ;
        g.setColor ( Color.white ) ;
        g.drawLine ( 1, 0, 1, prefSize.height ) ;
    }
} /* ToolBarSeparator */
