package com.ibm.nzna.shared.gui.wizard ;
/*-----------------------------------------------------------*/
/*   WizardDlg                                               */
/*                                                           */
/*   Description:                                            */
/*      Source code for: WizardDlg                           */
/*                                                           */
/*                                                           */
/*         @Copyright  1998 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.awt.* ;
import javax.swing.* ;
/**
 * This is a convience Dialog to show a Wizard. The only constructor
 * takes a parent frame and an array of Wizard Steps. This array will
 * be presented in order in the Wizard. The constructor will return
 * immediatly without showing anything. To show the dialog, call the
 * processWizard method. This method will not return until the wizard
 * is complete.
 *
 *
 * @version 1.0, 12/21/1998 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   WizardDlg                                               */
/*                                                           */
/*-----------------------------------------------------------*/
public class WizardDlg extends JDialog implements WizardListener {


    /*-----------------------------------------------------------*/
    /*                                                           */
    /*   Vars                                                    */
    /*                                                           */
    /*-----------------------------------------------------------*/
    Wizard wizard = null ;



    /*------------------------------------------------------------*/
    /* Constructor
     */
    /**
     *    This constructor will create and initialize the dialog
     *  but it will not show anything. Use the processWIzard
     *  method to show and wait for the dialog
     *
     *  @param parent The parent frame
     *  @param title The title of the dialog
     *  @param steps The array of WizardSteps to display
     *
     *  @return Nothing
     *//*---------------------------------------------------------*/
    public WizardDlg ( Frame parent, String title ) {
        super ( parent, title, true ) ;
        Point pt = parent.getLocation() ;

        wizard = new Wizard() ;
        wizard.addWizardListener ( this ) ;
        getContentPane().setLayout ( new BorderLayout() ) ;
        getContentPane().add ( wizard, BorderLayout.CENTER ) ;
        setSize ( 480, 360 ) ;
        setLocation ( pt.x+20, pt.y+20 ) ;
        setResizable ( false ) ;
    }

    public void processWizard () {
        setVisible ( true ) ;
    }


    public void cancelPerformed ( WizardEvent event ) {
        dispose() ;
    }

    public void finishPerformed ( WizardEvent event ) {
        dispose() ;
    }

    public void nextPerformed ( WizardEvent event ) {}
    public void backPerformed ( WizardEvent event ) {}





    /*------------------------------------------------------------*/
    /* getWizard
     */
    /**
     *    This method will return the instance of the Wizard
     *  we are using
     *  
     *
     *  @param None
     *  @param None
     *  @param None
     *
     *  @return Wizard
     *//*---------------------------------------------------------*/
    public Wizard getWizard () {
        return( wizard ) ;
    }


} /* WizardDlg */
