package com.ibm.nzna.shared.gui.wizard ;
/*-----------------------------------------------------------*/
/*   WizardListener                                          */
/*                                                           */
/*   Description:                                            */
/*      Source code for: SwingListener                       */
/*                                                           */
/*                                                           */
/*         @Copyright  1998 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This Listener defines methods that will be called during
 * the processing of a Wizard.
 *
 *
 * @version 1.0, 12/21/1998 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   SwingListener                                           */
/*                                                           */
/*-----------------------------------------------------------*/
public interface WizardListener {




   /*------------------------------------------------------------*/
   /* nextPerformed
    */
   /**
    *    This method will be called after the 'next'
    *  button has been pushed and the WizardStep
    *  that is showing has completed saving any information.
    *
    *  @param event The WizardEvent corresponding with this event
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public abstract void nextPerformed ( WizardEvent event ) ;





   /*------------------------------------------------------------*/
   /* cancelPerformed
    */
   /**
    *    This method will be called if the user
    *  cancels out of the wizard at any time.
    *  
    *
    *  @param event The WizardEvent corresponding with this event
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public abstract void cancelPerformed ( WizardEvent event ) ;





   /*------------------------------------------------------------*/
   /* finishPerformed
    */
   /**
    *    This method will be called if the Wizard
    *  has completely finished all WizardSteps and
    *  all WizardSteps have returned TRUE from the saveInfo() method.
    *
    *  @param event The WizardEvent corresponding with this event
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public abstract void finishPerformed( WizardEvent event ) ;



   /*------------------------------------------------------------*/
   /* backPerformed
    */
   /**
    *    This method will be called after the 'back' 
    *  button has been pressed and the WizardStep
    *  showing has returned from it's backOut() method.
    *
    *  @param event The WizardEvent corresponding with this event
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public abstract void backPerformed ( WizardEvent event ) ;


} /* SwingListener */
