package com.ibm.nzna.shared.io ;
import java.util.* ;
import java.io.* ;

   /*********************************************************
   * This class will fully load the data from an input stream
   * into a byte array buffer.
   *
   * Legal: Copyright (c) 2000 IBM. All Rights Reserved.
   * Created: 4/5/100  2:09pm
   * @author 
   * @version
   *********************************************************/
public class InputStreamLoader extends Object {

   /*********************************************************
   * Reads from an input stream until there is no more data
   * from the input stream.  Fills a byte buffer which it 
   * returns as the result.
   *
   * Author:  
   * Created: 4/5/100  2:30pm
   * @param   io        The input stream to read from.
   * @return            A byte array with the data from the input stream.
   *********************************************************/
   public static byte[] load ( InputStream io ) {
      byte[] byteBuffer = new byte[ 8192 ] ;
      byte[] bytes      = null ;
      try {
         int readSize = io.available() ;
         if ( readSize < 1024 ) {
            readSize = 1024 ;
         }
         /* set initial buffer size to the size available */
         bytes = new byte[ readSize ] ;
         /* read the contents of the input stream into our buffer */
         boolean continueReading = true ;
         int     totalBytes      = 0 ;
         while ( continueReading ) {
            /* read from the input stream */
            int bytesRead = io.read( bytes, 0, readSize ) ;
            /* Is there more data available to read */
            if ( bytesRead > 0) {
               /* Add to the total byte count */
               totalBytes += bytesRead ;
               /* Do we need to increase the size of the buffer */
               if ( byteBuffer.length <= totalBytes ) {
                  byte newBuffer[] = new byte[ byteBuffer.length * 2 ] ;
                  System.arraycopy( byteBuffer, 0, newBuffer, 0 , byteBuffer.length ) ;
                  byteBuffer = newBuffer ;
               }
               /* copy to the new byteArray */
               System.arraycopy( bytes, 0, byteBuffer, totalBytes - bytesRead , bytesRead) ;
            }
            else {
               continueReading = false ;
               /* Set the byte array to the size of data read */
               byte newBuffer[] = new byte [ totalBytes ] ;
               System.arraycopy( byteBuffer, 0, newBuffer, 0, totalBytes ) ;
               byteBuffer = newBuffer ;
            }
         }
      }
      catch ( Exception e ) {
         e.printStackTrace() ;
      }
      return ( byteBuffer ) ;
   }
}
