package com.ibm.nzna.shared.lang ;
import  com.ibm.nzna.shared.io.* ;
import  java.io.* ;
   /*********************************************************
   * This is the base exception for generated exceptions for
   * our applications.  All exceptions should extend this class 
   * and should also use a unique errorCode. 
   * 
   *
   * Legal: Copyright (c) 2000 IBM. All Rights Reserved.
   * Created: 7/19/100  2:04pm
   * @author 
   * @version
   *********************************************************/
public class StandardException extends Exception {
   private int errorCode = 0 ;
   /*********************************************************
   * Creates an exception with a detail message description and
   * an errorCode for reference.
   * 
   *
   * Author:  
   * Created: 7/19/100  2:11pm
   * @param detail The exception description.
   * @param errorCode The error code used for reference of the problem.
   * @return
   *********************************************************/
   public StandardException ( String detail, int errorCode ) {
      super( detail ) ;
      this.errorCode = errorCode ;
   }
   /*********************************************************
   * Returns the error code placed by the method which threw
   * the exception.
   * 
   *
   * Author:  
   * Created: 7/19/100  2:11pm
   * @param
   * @return
   *********************************************************/
   public int getErrorCode () {
      return ( errorCode ) ;
   }
   /*********************************************************
   * Converts a stack dump into a string
   * 
   *
   * Author:  
   * Created: 7/20/100  5:54pm
   * @param
   * @return
   *********************************************************/
   public static String getStackTrace( Throwable object ) {
      String stackTrace = "Unable to get stack trace" ;
      try {
         OutputStreamCapture  out   = new OutputStreamCapture( 1000 ) ;
         PrintStream          sOut  = new PrintStream( out ) ;
         object.printStackTrace( sOut ) ;
         stackTrace = new String ( out.getBytes() ) ;
      } catch ( Exception e ) {
         e.printStackTrace() ;
      }
      return ( stackTrace ) ;
   }
}
