package com.ibm.nzna.shared.mq ;

import javax.servlet.* ;

import javax.servlet.http.* ;

import java.io.* ;

import java.net.* ;

import java.util.* ;

   /*********************************************************

   * The SessionManager keeps track of state information for

   * web interactions.  The state information is persisted

   * by the implementor of this interface.  This allows

   * the Web code or servlet to be independent of the method

   * by which state information is tracked.

   * 

   *

   * Legal: Copyright (c) 2000 IBM. All Rights Reserved.

   * Created: 4/14/100  6:03pm

   * @author 

   * @version

   *********************************************************/

public interface SessionManager {

   /*********************************************************

   * Initialize the input class.  This is provided for classes

   * which may need some prior initialization for efficiency.

   * This would be database connections or other similar tasks.

   * 

   *

   * Author:  

   * Created: 4/19/100  12:38pm

   * @param propertyBasename The basename of the property file. 

   * 

   * @return

   *********************************************************/

   abstract void init( Properties properties ) ;

   /*********************************************************

   * Makes this data available to other applications who use 

   * this interface.

   * 

   *

   * Author:  

   * Created: 4/18/100  2:00pm

   * @param key Identifier for this data to be referenced.

   * @param object The data to share.

   * @return

   *********************************************************/

   abstract void put ( String key, Object object ) ;



   /*********************************************************

   * 

   * 

   *

   * Author:  

   * Created: 4/14/100  6:08pm

   * @param key The identifier by which the data should be retrieved.

   * @return The object associated with the key value.

   *********************************************************/

   abstract Object get ( String key ) ;

}

