package com.ibm.nzna.shared.mq ;



   /*********************************************************

   * This class is an interface for inter process communication.

   * 

   *

   * Legal: Copyright (c) 2000 IBM. All Rights Reserved.

   * Created: 4/18/100  1:59pm

   * @author 

   * @version

   *********************************************************/

public interface SharedDataManager extends SessionManager {

   /*********************************************************

   * Places an object to be shared in the shared data manager.

   * A unique key is generated when this object is placed

   * in the shared data manager.  This key is used to get

   * the object back from the shared data manager.

   * 

   *

   * Author:  

   * Created: 4/14/100  6:03pm

   * @param data The data object to be placed in the session manager

   * @return A unique string identifier which is used as the key value

   * to get the data object.

   *********************************************************/

   abstract String put (Object data) ;



   /*********************************************************

   * Gets any object available for this application.  This

   * method blocks until there is an object available.

   * 

   *

   * Author:  

   * Created: 4/18/100  7:22pm

   * @param

   * @return

   *********************************************************/

   abstract SharedDataObject get () ;

}

