package com.ibm.nzna.shared.pom ;
/*-----------------------------------------------------------*/
/*   POMUtil                                                 */
/*                                                           */
/*   Description:                                            */
/*      Source code for: POMUtil                             */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.* ;
/**
 * This utility class has static methods useful when working 
 * with PersistentRec objects in the Persistent Object Model
 *
 * @version 1.0, 6/19/2001 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   POMUtil                                                 */
/*                                                           */
/*-----------------------------------------------------------*/
public class POMUtil {


   /**
     *  This method will return TRUE if any PersistentRec (or subclass
     * of PersistentRec) has changed in the Vector passed in. A Change
     * will be returned TRUE if at least 1 object has a status of
     * REC_DELETE, REC_INSERT or REC_UPDATE as defined in PersistentRec.<br><br>
     *
     * <b>Please Note</b> that if you pass any object in the Vector that
     * does not extend PersistentRec then this method will fail with a TypeCast exception
     *
     * @param dataVector The vector of PersistentRec objects.
     *
     * @returns TRUE/FALSE
     *
     * @see com.ibm.nzna.shared.pom.PersistentRec
     **/
   public static boolean vectorContainsChanges ( Vector dataVector ) {
      boolean containsChanges = false ;

      if ( ( dataVector != null ) && ( dataVector.size() > 0 ) ) {
         int i         = 0 ;
         int size      = dataVector.size() ;

         while ( ( !containsChanges ) && ( i < size ) ) {
            containsChanges =  ((PersistentRec)dataVector.elementAt(i)).modified() ;
            i++ ;
         }
      }

      return( containsChanges ) ;
   }


} /* POMUtil */
