

package com.ibm.nzna.shared.servlet ;   

import javax.servlet.* ;

import javax.servlet.http.* ;

import java.io.* ;

import java.net.* ;

import java.util.* ;

import com.ibm.nzna.shared.util.* ;

import com.ibm.nzna.shared.mq.* ;

import com.ibm.nzna.shared.servlet.template.* ;

import com.ibm.nzna.shared.lang.* ;



   /*********************************************************

   * This class allows for administration of the servlet.  

   *

   * Legal: Copyright (c) 2000 IBM. All Rights Reserved.

   * Created: 3/28/100  7:35pm

   * @author Chad Meadows

   * @version 1.0

   *********************************************************/

public class ServletBaseAdmin {

   private final static String newLine = "<BR>\n" ;

   public static boolean admin ( ServletBase servletBase, HttpServletRequest req , HttpServletResponse resp , String adminCommand ) {

      ServletOutputStream servletOutput = null ;

      /* If set true, the servlet will process the request normally */

      /* otherwise the service must be handled here.                */

      System.out.println( "ServletBaseAdmin: "+ adminCommand) ;

      boolean continueServiceRequest = false ;

      try {

         /* This is used to write our output to the WebServer */

         servletOutput = resp.getOutputStream() ;

         /* What admin command was passed */

         if ( adminCommand.equals( "show.info")) {

            servletOutput.print( "Library Build: "+ BuildInfo.buildNumber + newLine ) ;

            servletOutput.print( "Library Date:  "+ BuildInfo.buildDate   + newLine ) ;



            Enumeration enum = req.getParameterNames () ;

            servletOutput.print( "Parameter Names: " + newLine ) ;

            while (enum.hasMoreElements()) {

               String parameterName    = (String) enum.nextElement() ;

               String parameterValue   = (String) req.getParameter( parameterName ) ;

               servletOutput.print( parameterName + "=" + parameterValue + newLine ) ;

            }



            servletOutput.print( newLine ) ;

            servletOutput.print( "Header Names: " + newLine ) ;

            enum = req.getHeaderNames() ;

            while (enum.hasMoreElements()) {

               String parameterName    = (String) enum.nextElement() ;

               String parameterValue   = (String) req.getHeader( parameterName ) ;

               servletOutput.print( parameterName + "=" + parameterValue + newLine ) ;

            }



            servletOutput.print( newLine ) ;

            servletOutput.print( "Request Values: " + newLine ) ;

            servletOutput.print( "Request URL:        "    + HttpUtils.getRequestURL( req )    + newLine ) ;

            servletOutput.print( "Remote User:        "    + req.getRemoteUser()               + newLine ) ;

            servletOutput.print( "Remote Address:     "    + req.getRemoteAddr()               + newLine ) ;

            servletOutput.print( "Remote Host:        "    + req.getRemoteHost()               + newLine ) ;

            servletOutput.print( "Server Name:        "    + req.getServerName()               + newLine ) ;

            servletOutput.print( "Server Port:        "    + req.getServerPort()               + newLine ) ;

            servletOutput.print( "Scheme:             "    + req.getScheme()                   + newLine ) ;

            servletOutput.print( "Protocol:           "    + req.getProtocol()                 + newLine ) ;

            servletOutput.print( "get Method:         "    + req.getMethod()                   + newLine ) ;

            servletOutput.print( "Path Info:          "    + req.getPathInfo()                 + newLine ) ;

            servletOutput.print( "Path Translated:    "    + req.getPathTranslated()           + newLine ) ;

            servletOutput.print( "Request URI:        "    + req.getRequestURI()               + newLine ) ;

            servletOutput.print( "Servlet Path:       "    + req.getServletPath()              + newLine ) ;

            servletOutput.print( "Authentication:     "    + req.getAuthType()                 + newLine ) ;

            servletOutput.print( "Servlet Config:     "    + servletBase.getServletInfo()      + newLine ) ;

            servletOutput.print( newLine ) ;

            servletOutput.print( "System Properties: " + newLine ) ;



            Properties systemProperties = System.getProperties() ;

            enum = systemProperties.keys() ;

            while ( enum.hasMoreElements() ) {

               String parameterName    = (String) enum.nextElement() ;

               String parameterValue   = (String) systemProperties.get( parameterName ) ;

               servletOutput.print( parameterName + "=" + parameterValue + newLine ) ;

            }



            servletOutput.print( newLine ) ;

            servletOutput.print( "Servlet Properties: " + newLine ) ;

            Properties servletProperties = servletBase.properties ;

            enum = servletProperties.keys() ;

            while ( enum.hasMoreElements() ) {

               String parameterName    = (String) enum.nextElement() ;

               String parameterValue   = (String) (servletProperties.get( parameterName ).toString()) ;

               servletOutput.print( parameterName + "=" + parameterValue + newLine ) ;

            }



            servletOutput.close() ;

         }

         else if ( adminCommand.equals( "log.request") ) {

            /* toggle the log request value */

            servletBase.logRequestEnabled = !servletBase.logRequestEnabled ;

            

            servletOutput.print( "Logging of requests is now set: "+ servletBase.logRequestEnabled ) ;

            /* Do not continue processing in the servlet Base */

            continueServiceRequest = false ;

            servletOutput.close() ;

         }

         else {

            servletOutput.print( "Unknown command " ) ;

            /* Do not continue processing in the servlet Base */

            continueServiceRequest = false ;

            servletOutput.close() ;

         }

      }

      catch (Exception e ) {

         e.printStackTrace() ;

      }

      

      return ( continueServiceRequest ) ;

   }

}

