package com.ibm.nzna.shared.servlet ;

import javax.servlet.* ;

import javax.servlet.http.* ;

import java.io.* ;

import java.net.* ;

import java.util.* ;

import com.ibm.nzna.shared.servlet.* ;



   /*********************************************************

   * This class provides utility and convenience methods for Servlets.

   *

   * Legal: Copyright (c) 2000 IBM. All Rights Reserved.

   * Created: 4/18/100  1:34pm

   * @author 

   * @version

   *********************************************************/

public class ServletUtil {

   /*********************************************************

   * Fully qualifies a URL using the servername and port on which

   * we are executing.

   * 

   *

   * Author:  

   * Created: 8/29/100  8:16pm

   * @param

   * @return

   *********************************************************/

   public static String qualifyURL ( String url, SessionState sessionState ) {

      HttpRequest          httpRequest          = sessionState.getRequest() ;

      HttpServletRequest   httpServletRequest   = httpRequest.getServletRequest() ;

      StringBuffer         qualifiedURL         = null ;

      /* Is the url already qualified */

      if (( !url.startsWith("http")) && ( !url.startsWith("HTTP"))) {

         /* Create the string buffer */

         qualifiedURL = new StringBuffer() ;

         /* Get the host we are on */

         String host = httpServletRequest.getServerName() ;

         /* Get the port we are on */

         int    port = httpServletRequest.getServerPort() ;

         /* Add the protocal, machine and port */

         qualifiedURL.append( "http://" ) ;

         qualifiedURL.append( host ) ;

         /* If port not default 80 add port number */

         if ( port != 80 ) {

            qualifiedURL.append( ":" + port ) ;

         }

         /* Add slash if url does not begin with slash */

         if ( !url.startsWith("/" )) {

            /* Add slash separator between host and path */

            qualifiedURL.append( "/" ) ;

         }

         /* Finally add the path */

         qualifiedURL.append( url ) ;



         /* Set the value to return */

         url = qualifiedURL.toString() ;

      }

      return ( url ) ;

   }

   /*********************************************************

   * Creates a querystring from a hashtable of keys with

   * string arrays for the values.

   * 

   *

   * Author:  

   * Created: 8/29/100  8:17pm

   * @param

   * @return

   *********************************************************/

   public static String createQueryString ( Hashtable hashtable ) {

      StringBuffer queryString = new StringBuffer () ;

      Enumeration keyEnum = (Enumeration) hashtable.keys() ;

      while ( keyEnum.hasMoreElements() ) {

         String key = ( String ) keyEnum.nextElement() ;

         String[] valueArray = (String[]) hashtable.get( key ) ;

         for ( int item = 0; item < valueArray.length ; item++ ) {

            queryString.append( URLEncoder.encode( key ) ) ;

            queryString.append( '=' ) ;

            queryString.append( URLEncoder.encode( valueArray[ item ] )) ;

            queryString.append( '&' ) ;

         }

      }

      /* We do this to remove the extra '&' appended to the end */

      if ( queryString.length() > 1 ) {

         queryString.setLength(queryString.length() - 1) ;

      }



      return ( queryString.toString()) ;

   }

}

