package com.ibm.nzna.shared.servlet ;



import HTTPClient.* ;

import java.io.* ;

import java.net.* ;

import java.util.* ;

import com.ibm.nzna.shared.util.* ;

import com.ibm.nzna.shared.servlet.template.* ;

   /*********************************************************

   * <b><font color="maroon">Description:</b></font>

   *  Standard Error, reads in a template html file from the 

   *  location specified by the url.  

   *  Substitution is performed on the content by the following

   *  ##SUBJECT## is replaced by subject

   *  ##USERMSG## is replaced by userMessage

   *  ##DETAILMSG## is replaced by detailMessage

   *

   * <p><b><font color="olive">Legal:</b></font> Copyright (c) 1998 IBM. All Rights Reserved.

   * <p><b><font color="teal">Created:</b></font> 8/5/1999  2:32pm

   * @author 

   * @version

   *********************************************************/

public class StandardError {

   /* Set default timeout to 5 seconds */

   public static int timeout  = 5000 ;

   /* The file containing the template */

   public final static String templateFileProperty = "standard" + System.getProperty( "file.separator" ) + "error.template.html" ;



   public static String get ( InputStream inputStream, String subject, String userMessage, String detailMessage ) {

      String            lbl_subject       = "##SUBJECT##" ;

      String            lbl_usermsg       = "##USERMSG##" ;  

      String            lbl_detailmsg     = "##DETAILMSG##" ;

      String            label             = "" ;

      String            inputLine         = null ;

      int               lineCount         = 0 ;

      InputStreamReader inputStreamReader = null ;

      BufferedReader    bufferedReader    = null ;



      try {



         inputStreamReader = new InputStreamReader( inputStream ) ;

         bufferedReader    = new BufferedReader( inputStreamReader ) ;



         // Read the contents of the input stream into a string

         while ( (inputLine = bufferedReader.readLine()) != null ) { 

            label += inputLine + "\n" ;

         }



         label = RegularExpression.substitute( lbl_subject, subject, label ) ;

         label = RegularExpression.substitute( lbl_usermsg, userMessage, label ) ;

         label = RegularExpression.substitute( lbl_detailmsg, detailMessage, label)  ;



         bufferedReader.close() ;

      } catch( InterruptedIOException ioe ) {

         ioe.printStackTrace() ;

         System.out.println( "Timeout expired" ) ;

      } catch( IOException ie ) {

         ie.printStackTrace() ;

         System.out.println( ie ) ;

      }

      return label ;

   }



   public static String get ( URL url, String subject, String userMessage, String detailMessage  ) {

      InputStream       inputStream       = null ;

      String            output            = "" ;



      try {

         HTTPConnection httpConnection = new HTTPConnection( url ) ;

         httpConnection.setTimeout( timeout ) ;  // connection expiration



         HTTPResponse httpResponse = httpConnection.Post( url.getFile() ) ;



         // Open an input stream to read the template file data

         inputStream       = httpResponse.getInputStream() ;



         output = get ( inputStream,  subject,  userMessage,  detailMessage ) ;

      } catch( InterruptedIOException ioe ) {

         ioe.printStackTrace() ;

         System.out.println( "Timeout expired" ) ;

      } catch( ModuleException modex ) {

         modex.printStackTrace() ;

         System.out.println( modex ) ;

      } catch( ProtocolNotSuppException pnse ) {

         pnse.printStackTrace() ;

         System.out.println( pnse ) ;

      } catch( IOException ie ) {

         ie.printStackTrace() ;

         System.out.println( ie ) ;

      }



      return ( output ) ;

   }

   public static String get ( String file, String subject, String userMessage, String detailMessage )  throws MalformedURLException  {

      String            output   = null ;

      /* Determine if the file is a URL or a hard file */

      if ( (file.toUpperCase().indexOf("HTTP:")) == -1) {

         /* This is a disk based file */

         /* Use the template loader class */

         ResourceTemplateLoader templateLoader = new ResourceTemplateLoader() ;

         InputStream io = templateLoader.getInputStream( file ) ;



         output = get ( io ,  subject,  userMessage,  detailMessage ) ;

      }

      else {

         /* This is a URL */

         output = get ( new URL (file), subject,  userMessage,  detailMessage ) ;

      }



      return ( output ) ;

   }



   public static String get ( String subject, String userMessage, String detailMessage )  {

      String            output   = null ;



      ResourceTemplateLoader templateLoader = new ResourceTemplateLoader() ;

      InputStream io = templateLoader.getInputStream( templateFileProperty ) ;

      if ( io != null ) {

         output = get ( io ,  subject,  userMessage,  detailMessage ) ;

      }

      else { 

         output = subject + "\n" + userMessage + "\n <!-- \n" + detailMessage + "\n-->" ;

      }



      return ( output ) ;

   }



}  /* StandardError */

