
package com.ibm.nzna.shared.servlet.contentmodule ;
import com.ibm.nzna.shared.servlet.* ;
import com.ibm.nzna.shared.mq.* ;
import com.ibm.nzna.shared.util.* ;
import java.util.* ;
import java.io.* ;
   /*********************************************************
   * This class provides a means to log url clicks from the 
   * web user.  This is done by proxy of the request.  This implementation
   * logs the data via a mqSeries message queue.
   *
   * Legal: Copyright (c) 2000 IBM. All Rights Reserved.
   * Created: 4/19/100  1:43pm
   * @author 
   * @version
   *********************************************************/
public class ProxyLogger extends SharedInterface {
   public static final String urlRedirectKey = "url.redirect.proxy.logger" ;
   /*********************************************************
   * Collect the html to present to the page.  The session data
   * is passed to the sharedDataManager.  An application using
   * the sharedDataManager will collect our session data and
   * produce a html result to be displayed.  The result is then
   * returned to us in a Hashtable with the key.
   * 
   *
   * Author:  
   * Created: 4/18/100  1:36pm
   * @param sessionState the session state of the web user.
   * @return HTML string to be rendered on the web page.
   *********************************************************/
   public String getHTML ( SessionState sessionState ) {
      /* Get the url which we must log from the request */
      HttpRequest httpRequest = sessionState.getRequest() ;
      if ( httpRequest == null ) {
         log.writeLog( "httpRequest is null") ;
      }
      String url = httpRequest.getParameter( urlRedirectKey ) ;
      if (url != null ) {
         /* Set control data */
         Hashtable sessionData = sessionState.getSessionData() ;
         sessionData.put( "msg.sender", "ViewPortProxyLogger" ) ;
         sessionData.put( "ViewPortProxyLogger.url", url ) ;
         /* Place the sessionState object */
         log.writeLog("ViewPortProxyLogger: Sending tracking info", 10) ;
         sharedDataManager.put ( sessionState ) ;

         /* Set the redirect header */
         try {
            log.writeLog("ViewPortProxyLogger: redirect: "+ url, 10) ;
            httpRequest.sendRedirect( url ) ;
         }
         catch (Exception e ) {
            e.printStackTrace() ;
         }
      }
      return ( "" );
   }
}
