package com.ibm.nzna.shared.servlet.filter ;
import javax.servlet.* ;
import javax.servlet.http.* ;
import java.io.* ;
import java.net.* ;
import java.util.* ;
import com.ibm.nzna.shared.servlet.* ;
   /*********************************************************
   * Formats data through filtering.  This is an interface class
   * for the ViewPort servlet.  This interface provides a standard
   * by which data can be formatted from the input of the ViewPort
   * servlet.  The filters may be chained through the use of a 
   * ViewPortFilterManager.
   * 
   *
   * Legal: Copyright (c) 2000 IBM. All Rights Reserved.
   * Created: 4/14/100  5:50pm
   * @author 
   * @version
   * @see ViewPortFilterManager
   *********************************************************/
public interface ContentFilter {
   /*********************************************************
   * Initialize the input class.  This is provided for classes
   * which may need some prior initialization for efficiency.
   * This would be database connections or other similar tasks.
   * 
   *
   * Author:  
   * Created: 4/19/100  12:38pm
   * @param The properties object.
   * 
   * @return
   *********************************************************/
   abstract void init( Properties properties ) ;

   /*********************************************************
   * Applies a filter to the input string and returns a String
   * result.
   * 
   *
   * Author:  
   * Created: 4/14/100  5:52pm
   * @param
   * @return
   *********************************************************/
   abstract public String filter ( String inputData, SessionState sessionState ) ;
}
