
package com.ibm.nzna.shared.servlet.filter ;
import javax.servlet.* ;
import javax.servlet.http.* ;
import java.io.* ;
import java.net.* ;
import java.util.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.shared.servlet.* ;
import com.ibm.nzna.shared.servlet.contentmodule.* ;
   /*********************************************************
   * Remaps the server name to the name specified.
   *
   * Legal: Copyright (c) 2000 IBM. All Rights Reserved.
   * Created: 4/14/100  5:50pm
   * @author 
   * @version
   * @see ViewPortFilterManager
   *********************************************************/
public class HostServerMapping implements ContentFilter {
   Properties  properties     = null ;
   String      hostServer     = null ;
   String      newHostServer  = null ;

   public final static String hostSubstitute = "HostServerMapping.host.substitute" ;
   /*********************************************************
   * Initialize the input class.  This is provided for classes
   * which may need some prior initialization for efficiency.
   * This would be database connections or other similar tasks.
   * 
   *
   * Author:  
   * Created: 4/19/100  12:38pm
   * @param The properties object.
   * 
   * @return
   *********************************************************/
   public void init( Properties properties ) {
      try {
         this.properties = properties ;
         /* Set the content url value */
         URL url = new URL( properties.getProperty( URLInput.contentUrl )) ;
         hostServer = url.getHost() ;
         /* Set the value to change the host to */
         newHostServer = properties.getProperty( hostSubstitute , hostServer ) ;
      }
      catch ( Exception e ) {
         System.err.println( e ) ;
      }
   }

   /*********************************************************
   * Applies a filter to the input string and returns a String
   * result.
   * 
   *
   * Author:  
   * Created: 4/14/100  5:52pm
   * @param
   * @return
   *********************************************************/
   public String filter ( String inputData, SessionState sessionState ) {
      /* Replace all host references with the new mapping */
      String content = RegularExpression.substitute( hostServer , newHostServer , inputData) ;
      return ( content ) ;
   }
}
