

package com.ibm.nzna.shared.servlet.template ;

import javax.servlet.* ;

import javax.servlet.http.* ;

import java.io.* ;

import java.net.* ;

import java.util.* ;

import com.ibm.nzna.shared.util.* ;

   /*********************************************************

   * Loads a template.  Keeps templates cached for better 

   * response.

   *

   * Legal: Copyright (c) 2000 IBM. All Rights Reserved.

   * Created: 4/14/100  5:50pm

   * @author 

   * @version

   *********************************************************/

public class ResourceTemplateLoader extends TemplateLoader {

   static final String           fileSeparator       = System.getProperties().getProperty("file.separator") ;

   /** The location of the properties files to attempt to load **/

   static final String           defaultResourcePath = "com"+fileSeparator+"ibm"+fileSeparator+"nzna"+fileSeparator+"templates"+fileSeparator ;



   /*********************************************************

   * Initialize the template loader.

   *

   * Author:  

   * Created: 4/14/100  5:52pm

   * @param

   * @return

   *********************************************************/

   public void init ( Properties properties ) {

   }



   /*********************************************************

   * Loads a template.

   * 

   *

   * Author:  

   * Created: 5/16/100  5:30pm

   * @param templateId The filename of the template to load.

   * @return The contents of the template file or null if unable to load.

   *********************************************************/

   public String loadTemplate( String templateId ) {

      /* Load the template using the resource loader */

      byte[] bytes = ResourceLoader.load ( defaultResourcePath + templateId ) ;

      /* If resource not loaded from this location try the root */

      if ( bytes == null ) {

         bytes = ResourceLoader.load ( templateId ) ;

      }

      /* Return a string containing the template */

      if ( bytes != null ) {

         return ( new String ( bytes )) ;

      }

      else 

         /* Unable to load resource */

         return ( null ) ;

   }

   /*********************************************************

   * Loads a template.

   * 

   *

   * Author:  

   * Created: 5/16/100  5:30pm

   * @param templateId The filename of the template to load.

   * @return The contents of the template file or null if unable to load.

   *********************************************************/

   public InputStream getInputStream( String templateId ) {

      /* Load the template using the resource loader */

      InputStream io = ResourceLoader.getInputStream ( defaultResourcePath + templateId ) ;

      return ( io ) ;

   }

   /*********************************************************

   * Get the templates resource root path from the classpath.

   * 

   *

   * Author:  

   * Created: 6/21/100  7:44pm

   * @param

   * @return The classpath entry which contains the properties files.

   *********************************************************/

   public static String getPath() {

      String path = null ;

      /* First search using the default resource path */

      path = ResourceLoader.getPath( defaultResourcePath ) ;

      return ( path ) ;

   }



}

