package com.ibm.nzna.shared.servlet.template ;
import javax.servlet.* ;
import javax.servlet.http.* ;
import java.io.* ;
import java.net.* ;
import java.util.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.shared.io.* ;
import com.ibm.nzna.shared.lang.* ;
import com.ibm.nzna.shared.servlet.* ;
import com.ibm.nzna.shared.servlet.viewport.filter.* ;
import com.ibm.nzna.shared.servlet.viewport.* ;
import HTTPClient.* ;

   /*********************************************************
   * The template module contains the logic for loading the correct
   * template based on the session state data.  The PageGenTEmplateModule
   * does not properly conform to the design of template modules.
   * Template modules should not return content, but it was necessary
   * in this instance to interface with the Legacy PageGen code for
   * creating the navigation.
   *
   * Legal: Copyright (c) 2000 IBM. All Rights Reserved.
   * Created: 4/14/100  5:50pm
   * @author 
   * @version
   *********************************************************/
public class SimpleTemplateModule extends TemplateModule {
   /* Logging module */
   LogModule                log                     = null ;
   String                   template                = null ;
   final String             templateKey             = "servlet.template.simple.name" ;

   /*********************************************************
   * Initializes the module based on the properties input.
   * servlet.template.module.bindings=The bindings property file.
   * servlet.template.module.filters=The filters property file.
   *
   * Author:  
   * Created: 4/14/100  5:52pm
   * @param
   * @return
   *********************************************************/
   public void init( Properties properties , TemplateLoader templateLoader ) {
      super.init( properties , templateLoader ) ;

      /* Get the logging module */
      log = LogManager.getLogModule ( properties ) ;
      /* Get the template */
      template = (String) properties.get( templateKey ) ;

   }


   /*********************************************************
   * Gets the PageGen template.  This method must get the correct
   * template depending on the the site. ( eSupport, info tips, business partner )
   *
   * Author:  
   * Created: 4/14/100  5:52pm
   * @param
   * @return
   *********************************************************/
   public String getTemplate ( SessionState sessionState ) {
      String templateForm = templateLoader.getTemplate( template ) ;
      return ( templateForm ) ;
   }
}
