package com.ibm.nzna.shared.servlet.template ;

import javax.servlet.* ;

import javax.servlet.http.* ;

import java.io.* ;

import java.net.* ;

import java.util.* ;



   /*********************************************************

   * Loads a template.  Keeps templates cached for better 

   * response.

   *

   * Legal: Copyright (c) 2000 IBM. All Rights Reserved.

   * Created: 4/14/100  5:50pm

   * @author 

   * @version

   *********************************************************/

public abstract class TemplateLoader {

   /* Cached templates */

   Hashtable templates = new Hashtable() ;

   /*********************************************************

   * Initialize the template loader.

   *

   * Author:  

   * Created: 4/14/100  5:52pm

   * @param

   * @return

   *********************************************************/

   abstract public void init ( Properties properties ) ;



   /*********************************************************

   * Gets a template by using the template id.

   *

   * Author:  

   * Created: 4/14/100  5:52pm

   * @param

   * @return

   *********************************************************/

   public String getTemplate ( String templateId ) {

      /* Check to see if this template has been loaded */

      if ( templates.containsKey(templateId) ) {

         /* return the requested template */

         return ( (String) templates.get( templateId )) ;

      }

      else {

         /* load the template */

         String template = loadTemplate( templateId ) ;

         /* Cache the template */

         templates.put( templateId, template ) ;

         return ( template ) ;

      }

   }

   /*********************************************************

   * Loads a template.

   * 

   *

   * Author:  

   * Created: 5/16/100  5:30pm

   * @param

   * @return

   *********************************************************/

   abstract protected String loadTemplate( String templateId ) ;

   abstract protected InputStream getInputStream( String templateId ) ;

}

