package com.ibm.nzna.shared.servlet.viewport ;
import com.ibm.nzna.shared.servlet.* ;
import com.ibm.nzna.shared.servlet.ViewPortInput ;
import com.ibm.nzna.shared.mq.* ;
import com.ibm.nzna.shared.util.* ;
import com.ibm.nzna.shared.lang.* ;
import java.util.* ;
   /*********************************************************
   * This class provides a data connection to a shared Data Manager.
   *
   * Legal: Copyright (c) 2000 IBM. All Rights Reserved.
   * Created: 4/19/100  1:43pm
   * @author 
   * @version
   *********************************************************/
public class ViewPortSharedDataInput extends ViewPortSharedInterface {
   /*********************************************************
   * Collect the html to present to the page.  The session data
   * is passed to the sharedDataManager.  An application using
   * the sharedDataManager will collect our session data and
   * produce a html result to be displayed.  The result is then
   * returned to us in a Hashtable with the key.
   * 
   *
   * Author:  
   * Created: 4/18/100  1:36pm
   * @param sessionState the session state of the web user.
   * @return HTML string to be rendered on the web page.
   *********************************************************/
   public String getHTML ( SessionState sessionState ) throws StandardException {
      String result = null ;
      /* Place the sessionState object */
      String key = sharedDataManager.put ( sessionState ) ;
      /* Wait for reply with same key */
      System.out.println( "ViewPortSharedDataInput: waiting for key "+key) ;
      Hashtable hashtable = (Hashtable) sharedDataManager.get ( key ) ;
      /* Perform 2nd attempt if result is null    */
      /* This was added specifically for MQSeries */
      /* Which sometimes does not process the     */
      /* First request after a reconnect          */
      if ( hashtable == null ) {
         System.out.println( "ViewPortSharedDataInput: resending request") ;
         /* Place the sessionState object */
         key = sharedDataManager.put ( sessionState ) ;
         System.out.println( "ViewPortSharedDataInput: retry for key "+key) ;
         hashtable = (Hashtable) sharedDataManager.get ( key ) ;
      }
      System.out.println( "ViewPortSharedDataInput: Received result") ;
      /* return the html data */
      String dataKey = (String) properties.get( "viewPortSharedDataInput.dataKey" ) ;
      if ( dataKey == null ) {
         System.out.println("ViewPortSharedDataInput:  viewPortSharedDataInput.dataKey not defined") ;
      }
      if ( hashtable != null ) {
         result = (String) hashtable.get( dataKey ) ;
      }
      else {
         throw ( new StandardException ("No data collected from input interface", 1001) );
      }
      return ( result );
   }
}
