package com.ibm.nzna.shared.spell ;         
/*-----------------------------------------------------------*/
/*   JSpellErrorInfo                                         */
/*                                                           */
/*   Description:                                            */
/*      Source code for: JSpellErrorInfo                     */
/*                                                           */
/*                                                           */
/*         @Copyright  1997 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This class represents a mispelled word 
 *
 *
 * @version 1.0, 10/6/1998 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   JSpellErrorInfo                                         */
/*                                                           */
/*-----------------------------------------------------------*/
public class JSpellErrorInfo {

   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   vars                                                    */
   /*                                                           */
   /*-----------------------------------------------------------*/
   protected String word;
   protected int position;
   protected String[] suggestions;
   protected TextInfo textInfo;
   public    int buttonHit ;




   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This will create and populate a JSpellErrorInfo record
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public JSpellErrorInfo(WordBundle checkWord,String[] suggestions,TextInfo textInfo)
   {
      this.word=checkWord.getWord();
      this.position=checkWord.getPosition();
      this.suggestions=suggestions;
      this.textInfo=textInfo;
   }




   /*------------------------------------------------------------*/
   /* getWord
    */
   /**
    *    Returns the misspelled word
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String getWord () {
      return ( word ) ;
   }




   /*------------------------------------------------------------*/
   /* getPosition
    */
   /**
    *    The integer index of the word in the string
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public int getPosition() {
      return ( position ) ;
   }




   /*------------------------------------------------------------*/
   /* getEndPosition
    */
   /**
    *    The position where the word ends
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public int getEndPosition() {
      return ( position+word.length() ) ;
   }





   /*------------------------------------------------------------*/
   /* getSuggestions
    */
   /**
    *    Returns an array of strings. The strings
    *  are suggestions to the user
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public String[] getSuggestions () {
      return ( suggestions ) ;
   }




   /*------------------------------------------------------------*/
   /* setWord
    */
   /**
    *    This method will set the word
    *  
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public void setWord ( String word ) {
      this.word = word ;
   }
}
