package com.ibm.nzna.shared.spell ;
import java.util.*;
import java.io.*;
import java.awt.*;
import java.net.*;

public class JSpellTestApp extends Frame
{
	Button checkIt;
	Button rawCheck;
	TextArea text;
	JSpellToolkit jst;

	public static void main(String args[])
	{
		JSpellTestApp x=new JSpellTestApp();
	}

	public JSpellTestApp()
	{
		super("Spelling Client Test Driver");
		checkIt=new Button("Check Spelling (GUI)");
		rawCheck=new Button("Check Spelling (no GUI)");
		text=new TextArea("Type your text here",24,80);
		setLayout(new BorderLayout());
		Panel controlPanel=new Panel();
		controlPanel.setLayout(new FlowLayout());
		controlPanel.add(checkIt);
		controlPanel.add(rawCheck);
		add("North",controlPanel);
		add("Center",text);
		pack();

		/* Initialize Spell Check Engine */
		jst=new JSpellToolkit();
		/* Done Initializing */
		
		show();
	}

	public boolean handleEvent(Event event)
	{
		switch(event.id)
		{
			case Event.ACTION_EVENT:
				if(event.target==checkIt)
				{	setTitle("Checking Spelling");
					// Check Spelling
					jst.check(text);	// pass the TextArea!!
					setTitle("Spelling Test Driver");
				}
				if(event.target==rawCheck)
				{
					setTitle("Checking Spelling (no GUI)");
					System.out.println("Starting Spell Check");
					jst.initRawCheck(text.getText());
					JSpellErrorInfo Jerror;
					do
					{
						Jerror=jst.rawCheck();
						if(Jerror!=null)
						{
							System.out.println("Misspelled Word: "+Jerror.word);
							System.out.println("    At Position: "+Jerror.position);
							System.out.print(  "    Suggestions: ");
							if(Jerror.suggestions[0]==null)
								System.out.print("None");
							else
								for(int i=0;i<10 && Jerror.suggestions[i]!=null;i++)
									System.out.print(Jerror.suggestions[i]+" ");
							System.out.println();
							System.out.println();
						}
					} while (Jerror!=null);
					System.out.println("Finished Checking");
					setTitle("Spelling Test Driver");
				}
				return true;
			case Event.WINDOW_DESTROY:
				dispose();
				System.exit(0);
				break;
		}
		return super.handleEvent(event);
	}
}

