package com.ibm.nzna.shared.spell ;    
/*-----------------------------------------------------------*/
/*   SpellChecker                                            */
/*                                                           */
/*   Description:                                            */
/*      Source code for: SpellChecker                        */
/*                                                           */
/*                                                           */
/*         @Copyright  2000 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This is the base class for all applications that wish to use a Spell Checker. 
 *
 *
 * @version 1.0, 3/23/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   SpellChecker                                            */
/*                                                           */
/*-----------------------------------------------------------*/
public class SpellChecker extends Object {


   /*-----------------------------------------------------------*/
   /*                                                           */
   /*   Members                                                 */
   /*                                                           */
   /*-----------------------------------------------------------*/
   private static JSpellToolkit spellToolkit = null ;
   private static SpellChecker  instance     = null ;



   /*------------------------------------------------------------*/
   /* Constructor
    */
   /**
    *    This will create a JSpellToolkit object
    *  for use in an application
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public SpellChecker () {            

      /*-----------------------------------------------------------*/
      /*                                                           */
      /*   Only create 1 per JVM                                   */
      /*                                                           */
      /*-----------------------------------------------------------*/
      if ( instance == null ) {
         spellToolkit = new JSpellToolkit () ;
         instance = this ;
      }
   }





   /*------------------------------------------------------------*/
   /* getToolkit
    */
   /**
    *    This method will return the JSpellToolkit
    *  for the Spell Checker
    *  
    *
    *  @param None
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public static JSpellToolkit getToolkit () {
      return( spellToolkit ) ;
   }

} /* SpellChecker */
