package com.ibm.nzna.shared.spell ;                 
/*-----------------------------------------------------------*/
/*   SpellPanelListener                                      */
/*                                                           */
/*   Description:                                            */
/*      Source code for: SpellPanelListener                  */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
/**
 * This interface is notified of events from the SpellPanel 
 *
 *
 * @version 1.0, 10/18/2000 
 * @author  David Lentz
 */



/*-----------------------------------------------------------*/
/*                                                           */
/*   SpellPanelListener                                      */
/*                                                           */
/*-----------------------------------------------------------*/
public interface SpellPanelListener {




   /*------------------------------------------------------------*/
   /* spellCheckComplete
    */
   /**
    *    This method will be called when a spell
    *  check has completed.
    *  
    *
    *  @param foundErrors TRUE if any errors were found and corrected, FALSE no errors found
    *  @param None
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public abstract void spellCheckComplete ( boolean foundErrors ) ;




   /*------------------------------------------------------------*/
   /* spellCheckWord
    */
   /**
    *    This method will be called when a misspelled
    *  word has been encountered
    *  
    *
    *  @param word The word that is misspelled
    *  @param startPos The position in the text passed into the SpellPanel of this word
    *  @param endPos The position in the text passed into the SpellPanel of the end of this word
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public abstract void spellCheckWord ( String word, int startPos, int endPos ) ;





   /*------------------------------------------------------------*/
   /* replaceWord
    */
   /**
    *    This method will be called when the user has
    *  chosen to replace a word in the text that was
    *  passed to the SpellPanel
    *
    *  @param oldWord The old, incorrect word
    *  @param newWord The new, corrected word
    *  @param None
    *
    *  @return Nothing
    *//*---------------------------------------------------------*/
   public abstract void replaceWord ( String oldWord, String newWord, int startPos ) ;
} /* SpellPanelListener */
