package com.ibm.nzna.shared.spell ;
public class TextInfo {
   StringBuffer sbText;
   int curPos;
   private char curChar;
   private String wordResult;
   private boolean ignoreUpper;        // ignore words in all upper case
   private boolean wordComplete;
   private boolean wordsToCheck;
   private boolean done;
   private boolean hasLetters;            // does word have letters
   private boolean hasLower;           // does it have lowercase letters
   private boolean hasDigits;          // does it have numbers
   private WordBundle result;
   private int startPos;
   private int textLength;

   public TextInfo()
   {
   }

   public TextInfo(String textToCheck)
   {
      if ( ( textToCheck != null ) && ( textToCheck.length() > 0 ) ) {
         sbText=new StringBuffer(textToCheck);
         curPos=0;
         textLength=textToCheck.length();
         wordsToCheck=textLength>0;          // words to check is false if no text sent in constructor
      }
   }

   public final void setIgnore(boolean ignoreValue)
   {
      ignoreUpper=ignoreValue;
   }

   public final boolean isWordsToCheck()
   {
      return wordsToCheck;
   }

   public final void setWordsToCheck(boolean checkValue)
   {
      wordsToCheck=checkValue;
   }

   public final int getCurPos()
   {
      return curPos;
   }

   public final int getTextLength()
   {
      return textLength;
   }

   public StringBuffer getText()
   {
      return sbText;
   }

   public final void setText(StringBuffer sb)
   {
      sbText=sb;
      textLength=sbText.length();
   }

   public String getTextString()
   {
      return sbText.toString();
   }

   public final WordBundle getNextWord()
   {
      // initialize getNextWord variables to defaults
      wordResult="";
      wordComplete=false;
      done=false;
      hasLetters=false;
      hasLower=false;
      hasDigits=false;

      while (!done) {
         startPos=curPos;
         while (!wordComplete) {
            if (curPos<textLength) {
               curChar=sbText.charAt(curPos);
               if ((curChar>='a' && curChar<='z')) {
                  wordResult+=curChar;
                  hasLetters=true;
                  hasLower=true;
               } else
                  if ((curChar>='A' && curChar<='Z')) {
                  wordResult+=curChar;
                  hasLetters=true;
               } else
                  if (curChar>='0' && curChar<='9') {
                  wordResult+=curChar;
                  hasDigits=true;
               } else {
                  // reached non alphanumeric character
                  wordComplete=true;
               }
               curPos++;
            } else {
               // reached end of text
               wordComplete=true;
               wordsToCheck=false;
               done=true;
            }
         }
         // check that we have a valid word to check
         // if so then done=true
         if (hasLetters && !hasDigits && !(ignoreUpper && !hasLower)) { // don't check words containing numbers (could be smarter about this)
            result=new WordBundle(wordResult,startPos);
            done=true;
         } else {
            wordResult="";
            result=new WordBundle(wordResult,startPos);
            wordComplete=false;
         }
         hasLetters=false;
         hasDigits=false;
         hasLower=false;
      }
      return result;
   }
}

