package com.ibm.nzna.shared.spell ;
import java.awt.*;

public class j_util
{
	public static byte i;
	public static byte curchar;
	public static byte decompChar;
	public static byte accumulator;
	public static byte aCurbit;
	public static byte wCurbit;
	public static int inLen;
	public static String out;

	public static void centerDialog(Dialog d, Frame f)
	{
		int xPos;
		int yPos;

		int dWidth;
		int dHeight;

		Dimension screen;

		screen=f.getToolkit().getScreenSize();

		dWidth=d.bounds().width;
		dHeight=d.bounds().height;
		
		xPos=f.location().x+f.bounds().width/2-dWidth/2;
		yPos=f.location().y+f.bounds().height/2-dHeight/2;


		if(xPos<0)
		{
			xPos=10;
		}
		if(yPos<0)
		{
			yPos=10;
		}
		if(xPos+dWidth>screen.width)
		{
			xPos=screen.width-dWidth-10;
		}
		if(yPos+dHeight>screen.height)
		{
			yPos=screen.height-dHeight-10;
		}
		d.reshape(xPos,yPos,dWidth,dHeight);
	}
	
	public static String compWord(String in)
	{
		// simple word compress routine (ignores case, numbers)
		out="";
		accumulator=0;
		aCurbit=7;
		in=in.toUpperCase();
		inLen=in.length();
		
		for(i=0;i<inLen;i++)
		{	// iterate through each character
			// pack character into 5 bits each
			curchar=(byte)(in.charAt(i));
			if (curchar<'A' || curchar>'Z')
				return "";
			curchar-=(byte)64;	// 0-25 for alphabet  '@' is 65-1, this way letter A equals a not all zero code
			for(wCurbit=4;wCurbit>=0;wCurbit--)
			{
				if (aCurbit<0)			// accumulator full
				{
					out+=(char)accumulator;
					accumulator=0;
					aCurbit=7;
				}
				accumulator+=(((int)Math.pow(2,aCurbit) * (((int)Math.pow(2,wCurbit)) & curchar)>>>wCurbit));   
				aCurbit--;
			}
		}
		if(accumulator!=0)
		{
			out+=(char)accumulator;
		}
		return out;
	}

	public static String decompWord(String in)
	{
		out="";
		accumulator=0;
		aCurbit=4;
		inLen=in.length();
		for(i=0;i<inLen;i++)
		{
			decompChar=(byte)in.charAt(i);
			for(wCurbit=7;wCurbit>=0;wCurbit--)		// iterate through bits of compressed character
			{
				if (aCurbit<0)
				{	// convert accumulator to a character
					if(accumulator!=0)		// padding
					{
						out+=(char)(accumulator+'@');
						accumulator=0;
						aCurbit=4;
					}
				}
				accumulator+=(((int)Math.pow(2,aCurbit)*(((int)Math.pow(2,wCurbit)) & decompChar)>>>wCurbit));                          
				aCurbit--;
			}
		}
		if(accumulator!=0)
		{
			out+=(char)(accumulator+'@');
		}
		return out;
	}
	
	
	// soundexsim implementation - equivalency rating using soundex of two strings
	public static double soundexsim(String x, String y)
	{
		return eqscore(soundex(x,false),soundex(y,false));
	}

	// eqscore implementation - equivalency rating between two strings

	public static double eqscore(String x, String y)
	{
		// Default to equal term weighting
		return eqscore(x,y,'E');
	}
	
	public static double eqscore(String x, String y, char weightmode)
	{
		double score=0;

		x=x.toUpperCase().trim();
		y=y.toUpperCase().trim();
		
		if (x.equals(y))
			score=1;
		else if (x.equals("") || y.equals(""))
			score=0;
		else
		{
			double tweight=0, weight=0;
			int i, xlen, ylen, matches=0, inserts=0, transposes=0;

			// Swap so that x contains shortest string
			if (x.length()>y.length())
			{	String temp=new String(x);
				x=y;
				y=temp;
				temp=null;
			}

			// Allocate string buffers for easier handling of string contents
			StringBuffer xbuf=new StringBuffer(x);
			StringBuffer ybuf=new StringBuffer(y);
			
			xlen=xbuf.length();
			ylen=ybuf.length();

			tweight=addseries(ylen);

			for(i=0;i<xlen;i++)
			{

				if (weightmode=='F')
					weight=(ylen-i)/tweight; 				// Weighted towards front
				else
					if (weightmode=='E')
						weight=1/(double)ylen;				// Weighted equally

				if(xbuf.charAt(i)==ybuf.charAt(i))	// Current character matches
				{	matches++;
					score+=weight;
					continue;
				} else
					
					if(xlen-1>i && xlen!=ylen && xbuf.charAt(i)==ybuf.charAt(i+1) && xbuf.charAt(i+1)!=ybuf.charAt(i+1))
					{	// insert character into x of the next character in Y
						inserts++;
						xbuf.insert(i,ybuf.charAt(i+1));
						xlen++;
						continue;
					}

					if(xlen-1>i)	// Enough characters remain to attempt transpose
					{
						if(xbuf.charAt(i+1)==ybuf.charAt(i) || ybuf.charAt(i+1)==xbuf.charAt(i))
						{	// Transpose successful, update StringBuffer contents
							// Partial transpositions are acceptable.
							if(xbuf.charAt(i+1)==ybuf.charAt(i) && ybuf.charAt(i+1)==xbuf.charAt(i))
								score+=(weight/2);
							transposes++;
							char temp=xbuf.charAt(i);
							xbuf.setCharAt(i,xbuf.charAt(i+1));
							xbuf.setCharAt(i+1,temp);
							// For a perfect transposition, give 'credit', otherwise, nothing
							continue;
						}
					}

			}
//			System.out.println(matches+" matches, "+transposes+" transposes, "+inserts+" inserts");			
		}

		return score;
		
	}

	public static double factorial(int n)
	{
		// Recursive function to calculate a factorial
		return n>1?n*factorial(n-1):1.0;
	}

	public static double addseries(int n)
	{
		// Recursive function to add all the integers greater than zero and less than a given number
		// e.g. addseries(6) = 6+5+4+3+2+1=21
		return n>1?n+addseries(n-1):1.0;
	}
	
// soundex implementation - phonetic coding algorithm

	public static final String alphabet="ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	//             A   B   C   D   E   F   G   H   I   J   K   L   M   N   O   P   Q   R   S   T   U   V   W   X   Y   Z
	public static final char SoundexTable[]={'0','1','2','3','0','1','2','0','0','2','2','4','5','5','0','1','2','6','2','3','0','1','0','2','0','2'};

	public static String soundex(String in)
	{
		//padcoding is performed by default
		return soundex(in,true);
	}

	public static String soundex(String in, boolean padcode)
	{
		/*
		 Implemented based on the Soundex algorithm as published in
		'Practical Algorithms for Programmers', Binstock and Rex, 1995.
		
		Algorithm modified by Clifford Helsel to handle non alphabetic
		characters and 'short' words the same way that Sybase does.
		*/
		int	count=0;		// Valid code letters completed
		char	curchar;
		char	thiscode, prevcode=' ';
		StringBuffer code=new StringBuffer("    ");
		String toconvert=in.toUpperCase();
		int i;
		
		for (i=0;i<toconvert.length() && count<4;i++)
		{	curchar=toconvert.charAt(i);
			if(Character.isLetter(curchar))
				thiscode=SoundexTable[alphabet.indexOf(curchar)];
			else
				break; // When encounter non numeric set remainder of code to 0's
		
			if(count==0)
			{	code.setCharAt(count,curchar);
				count++;	// Definitely set next letter in sequence
				prevcode=' '; // Ignore first character when comparing current against previous
			} else
			{	if(thiscode!=prevcode && thiscode!='0')
				{	// This character is significant, insert into soundex code
					code.setCharAt(count,thiscode);
					count++;
				}
			prevcode=thiscode;
			}
		}

		// Pad incomplete code with zeroes
		if(padcode)
			for (;count<4;count++)
				code.setCharAt(count,'0');

		return code.toString();
	
					

	}

	public static void main(String args[])
	{
/*		System.out.println("  Compressing: "+args[0]+" yields: "+compWord(args[0]));
		System.out.println("Decompressing: "+compWord(args[0])+" yields: "+decompWord(compWord(args[0])));
		
		if (!decompWord(compWord(args[0])).equals(args[0].toUpperCase()))
		{
			System.out.println("Error");
		}
		else
		{
			System.out.println("Success!");
		}
*/
//	SOUNDEX / EQSCORE TEST CODE
		int similarity=(int)(eqscore(args[0],args[1])*100);
		int soundexsim=(int)(soundexsim(args[0],args[1])*100);
		int avgsim=(similarity+soundexsim)/2;
		System.out.println("   Plain Similarity: "+similarity);
		System.out.println("Phonetic Similarity: "+soundexsim);
		System.out.println(" Average Similarity: "+avgsim);

	}
}
