package com.ibm.nzna.shared.util ;
import com.oroinc.text.regex.*;

   /*********************************************************
   * <b><font color="maroon">Description:</b></font>
   * This is a helper class for the regular expression package:
   * com.oroinc.text.regex.
   *
   * <p><b><font color="olive">Legal:</b></font> Copyright (c) 1998 IBM. All Rights Reserved.
   * <p><b><font color="teal">Created:</b></font> 8/10/1999  10:44am
   * @author Chad Meadows
   * @version
   *********************************************************/
public class RegularExpression {

   /*********************************************************
   * <b><font color="maroon">Description:</b></font>
   * substitute uses Perl Regular expression to perform substitutions.
   * This is a helper method for this class.
   *
   * <p><b><font color="teal">Author:</b></font> <i>Chad Meadows</i>
   * <p><b><font color="teal">Created:</b></font> 6/8/1999  6:09am
   * @param
   * @return
   *********************************************************/
   public static String substitute ( String regularExpression, String substitution , String input) {
      int limit, interps, i;
      PatternMatcher    matcher           = new Perl5Matcher();
      Pattern           pattern           = null;
      PatternCompiler   compiler          = new Perl5Compiler();

      limit    = Util.SUBSTITUTE_ALL;
      interps  = Util.INTERPOLATE_ALL;

      try {
        pattern = compiler.compile(regularExpression);
      } catch(MalformedPatternException e){
        System.err.println("Bad pattern.");
        System.err.println(e.getMessage());
      }
      
      // Perform substitution 
      return Util.substitute(matcher, pattern, new Perl5Substitution(substitution, interps), input, limit);
   }
}
