package com.ibm.nzna.shared.util ;

import java.util.* ;

   /*********************************************************

   * This class provides a generic timing mechanism using 

   * notifications by listener.

   * 

   *

   * Legal: Copyright (c) 2000 IBM. All Rights Reserved.

   * Created: 6/9/100  5:43pm

   * @author 

   * @version

   *********************************************************/

public class Timer extends Thread {

   /* The time in milli seconds between each clock tick */

   private int interval = 0 ;

   /* flag used to stop the thread */

   private boolean exit = false ;

   /* The number of clock ticks since starting the timer */

   private int clockTickCount = 0 ;

   /* The list of listeners who want notification */

   Vector listeners = new Vector() ;

   /*********************************************************

   * Constructor for timer.

   * 

   *

   * Author:  

   * Created: 6/9/100  8:30pm

   * @param

   * @return

   *********************************************************/

   public Timer ( int interval ) {

      this.interval = interval ;

      this.setDaemon( true ) ;

   }

   /*********************************************************

   * Constructor

   * 

   *

   * Author:  

   * Created: 6/9/100  8:31pm

   * @param

   * @return

   *********************************************************/

   public Timer ( int interval , TimerListener timerListener ) {

      this( interval ) ;

      addListener ( timerListener ) ;

   }

   /*********************************************************

   * Stops the thread properly.

   * 

   *

   * Author:  

   * Created: 6/9/100  8:34pm

   * @param

   * @return

   *********************************************************/

   public void stopTimer() {

      exit = true ;

   }

   /*********************************************************

   * 

   * 

   *

   * Author:  

   * Created: 6/9/100  5:45pm

   * @param

   * @return

   *********************************************************/

   public void run() {

      while ( !exit ) {

         try {

            Thread.sleep( interval ) ;

         }

         catch ( Exception e ) {

         }

         clockTickCount++ ;

         sendEvent() ;

      }

   }

   /*********************************************************

   * Add a listener to the timer.

   * 

   *

   * Author:  

   * Created: 6/9/100  5:46pm

   * @param

   * @return

   *********************************************************/

   public void addListener( TimerListener timerListener ) {

      listeners.addElement( timerListener ) ;

   }

   /*********************************************************

   * Send the timer event notification

   * 

   *

   * Author:  

   * Created: 6/9/100  5:48pm

   * @param

   * @return

   *********************************************************/

   private void sendEvent () {

      int listenerCount = listeners.size() ;

      for ( int i = 0; i < listenerCount; i++) {

         ((TimerListener)listeners.elementAt( i )).clockTick( this ) ;

      }

   }

   /*********************************************************

   * Get the number of events delivered since the start of 

   * the timer.

   * 

   *

   * Author:  

   * Created: 6/9/100  5:53pm

   * @param

   * @return

   *********************************************************/

   public int getClockTickCount () {

      return ( clockTickCount ) ;

   }

}



