package com.ibm.nzna.shared.util;
/*-----------------------------------------------------------*/
/*   UVector                                                 */
/*                                                           */
/*   Description:                                            */
/*      Source code for: UVector                             */
/*                                                           */
/*                                                           */
/*         @Copyright  1999 IBM                              */
/*                                                           */
/*-----------------------------------------------------------*/
import java.util.*;

final class UVectorEnumerator implements Enumeration {
   UVector vector;
   int count;

   UVectorEnumerator(UVector v) {
	  vector = v;
	  count = 0;
   }   

   public boolean hasMoreElements() {
	  return count < vector.elementCount;
   }   

   public Object nextElement() {
	  synchronized (vector) {
		 if (count < vector.elementCount) {
			return vector.elementData[count++];
		 }
	  }
	  throw new NoSuchElementException("UVectorEnumerator");
   }   

}